/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the ARM target                             *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 85;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(ARMInstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(ARMInstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static ARMInstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static ARMInstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testMOPredicate_MO(unsigned PredicateID, const MachineOperand &MO, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(0),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_s16,
  GILLT_s32,
  GILLT_s64,
  GILLT_v2s1,
  GILLT_v2s32,
  GILLT_v2s64,
  GILLT_v4s1,
  GILLT_v4s16,
  GILLT_v4s32,
  GILLT_v4s64,
  GILLT_v8s1,
  GILLT_v8s8,
  GILLT_v8s16,
  GILLT_v8s64,
  GILLT_v16s1,
  GILLT_v16s8,
};
const static size_t NumTypeObjects = 16;
const static LLT TypeObjects[] = {
  LLT::scalar(16),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::vector(ElementCount::getFixed(2), 1),
  LLT::vector(ElementCount::getFixed(2), 32),
  LLT::vector(ElementCount::getFixed(2), 64),
  LLT::vector(ElementCount::getFixed(4), 1),
  LLT::vector(ElementCount::getFixed(4), 16),
  LLT::vector(ElementCount::getFixed(4), 32),
  LLT::vector(ElementCount::getFixed(4), 64),
  LLT::vector(ElementCount::getFixed(8), 1),
  LLT::vector(ElementCount::getFixed(8), 8),
  LLT::vector(ElementCount::getFixed(8), 16),
  LLT::vector(ElementCount::getFixed(8), 64),
  LLT::vector(ElementCount::getFixed(16), 1),
  LLT::vector(ElementCount::getFixed(16), 8),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_NoHonorSignDependentRoundingBit = 75,
  Feature_HasV4TBit = 6,
  Feature_NoV4TBit = 7,
  Feature_HasV5TBit = 13,
  Feature_NoV5TBit = 65,
  Feature_HasV5TEBit = 11,
  Feature_HasV6Bit = 0,
  Feature_NoV6Bit = 9,
  Feature_HasV6MBit = 28,
  Feature_HasV8MBaselineBit = 35,
  Feature_HasV8_1MMainlineBit = 41,
  Feature_HasMVEIntBit = 63,
  Feature_HasMVEFloatBit = 64,
  Feature_HasCDEBit = 84,
  Feature_HasFPRegsBit = 42,
  Feature_HasFPRegs16Bit = 43,
  Feature_HasFPRegs64Bit = 76,
  Feature_HasV6T2Bit = 8,
  Feature_HasV6KBit = 18,
  Feature_HasV7Bit = 3,
  Feature_HasV8Bit = 55,
  Feature_PreV8Bit = 19,
  Feature_HasV8_1aBit = 78,
  Feature_HasV8_3aBit = 79,
  Feature_NoVFPBit = 22,
  Feature_HasVFP2Bit = 21,
  Feature_HasVFP3Bit = 52,
  Feature_HasVFP4Bit = 50,
  Feature_HasDPVFPBit = 44,
  Feature_HasFPARMv8Bit = 47,
  Feature_HasNEONBit = 53,
  Feature_HasSHA2Bit = 62,
  Feature_HasAESBit = 54,
  Feature_HasDotProdBit = 56,
  Feature_HasCRCBit = 14,
  Feature_HasLOBBit = 40,
  Feature_HasFP16Bit = 61,
  Feature_HasFullFP16Bit = 46,
  Feature_HasMatMulInt8Bit = 57,
  Feature_HasDivideInThumbBit = 37,
  Feature_HasDivideInARMBit = 12,
  Feature_HasDSPBit = 36,
  Feature_HasDBBit = 15,
  Feature_HasV7ClrexBit = 17,
  Feature_HasAcquireReleaseBit = 16,
  Feature_HasMPBit = 2,
  Feature_Has8MSecExtBit = 29,
  Feature_HasZCZBit = 58,
  Feature_UseNEONForFPBit = 82,
  Feature_DontUseNEONForFPBit = 45,
  Feature_IsThumbBit = 26,
  Feature_IsThumb1OnlyBit = 27,
  Feature_IsThumb2Bit = 34,
  Feature_IsNotMClassBit = 38,
  Feature_IsARMBit = 1,
  Feature_IsWindowsBit = 30,
  Feature_IsNotWindowsBit = 31,
  Feature_IsReadTPTPIDRURWBit = 68,
  Feature_IsReadTPTPIDRUROBit = 69,
  Feature_IsReadTPTPIDRPRWBit = 70,
  Feature_IsReadTPSoftBit = 20,
  Feature_UseNaClTrapBit = 4,
  Feature_DontUseNaClTrapBit = 5,
  Feature_UseMovtBit = 39,
  Feature_DontUseMovtBit = 23,
  Feature_UseMovtInPicBit = 24,
  Feature_DontUseMovtInPicBit = 25,
  Feature_UseFPVMLxBit = 49,
  Feature_SLSBLRMitigationBit = 67,
  Feature_NoSLSBLRMitigationBit = 66,
  Feature_UseMulOpsBit = 10,
  Feature_UseFusedMACBit = 51,
  Feature_HasFastVGETLNi32Bit = 59,
  Feature_HasSlowVGETLNi32Bit = 80,
  Feature_HasFastVDUP32Bit = 60,
  Feature_HasSlowVDUP32Bit = 81,
  Feature_UseVMOVSRBit = 48,
  Feature_DontUseVMOVSRBit = 83,
  Feature_IsLEBit = 74,
  Feature_IsBEBit = 77,
  Feature_GenExecuteOnlyBit = 33,
  Feature_DontGenExecuteOnlyBit = 32,
  Feature_GenT1ExecuteOnlyBit = 73,
  Feature_SignRetAddrBit = 72,
  Feature_NoSignRetAddrBit = 71,
};

PredicateBitset ARMInstructionSelector::
computeAvailableModuleFeatures(const ARMSubtarget *Subtarget) const {
  PredicateBitset Features{};
  if (!TM.Options.HonorSignDependentRoundingFPMath())
    Features.set(Feature_NoHonorSignDependentRoundingBit);
  if (Subtarget->hasV4TOps())
    Features.set(Feature_HasV4TBit);
  if (!Subtarget->hasV4TOps())
    Features.set(Feature_NoV4TBit);
  if (Subtarget->hasV5TOps())
    Features.set(Feature_HasV5TBit);
  if (!Subtarget->hasV5TOps())
    Features.set(Feature_NoV5TBit);
  if (Subtarget->hasV5TEOps())
    Features.set(Feature_HasV5TEBit);
  if (Subtarget->hasV6Ops())
    Features.set(Feature_HasV6Bit);
  if (!Subtarget->hasV6Ops())
    Features.set(Feature_NoV6Bit);
  if (Subtarget->hasV6MOps())
    Features.set(Feature_HasV6MBit);
  if (Subtarget->hasV8MBaselineOps())
    Features.set(Feature_HasV8MBaselineBit);
  if (Subtarget->hasV8_1MMainlineOps())
    Features.set(Feature_HasV8_1MMainlineBit);
  if (Subtarget->hasMVEIntegerOps())
    Features.set(Feature_HasMVEIntBit);
  if (Subtarget->hasMVEFloatOps())
    Features.set(Feature_HasMVEFloatBit);
  if (Subtarget->hasCDEOps())
    Features.set(Feature_HasCDEBit);
  if (Subtarget->hasFPRegs())
    Features.set(Feature_HasFPRegsBit);
  if (Subtarget->hasFPRegs16())
    Features.set(Feature_HasFPRegs16Bit);
  if (Subtarget->hasFPRegs64())
    Features.set(Feature_HasFPRegs64Bit);
  if (Subtarget->hasV6T2Ops())
    Features.set(Feature_HasV6T2Bit);
  if (Subtarget->hasV6KOps())
    Features.set(Feature_HasV6KBit);
  if (Subtarget->hasV7Ops())
    Features.set(Feature_HasV7Bit);
  if (Subtarget->hasV8Ops())
    Features.set(Feature_HasV8Bit);
  if (!Subtarget->hasV8Ops())
    Features.set(Feature_PreV8Bit);
  if (Subtarget->hasV8_1aOps())
    Features.set(Feature_HasV8_1aBit);
  if (Subtarget->hasV8_3aOps())
    Features.set(Feature_HasV8_3aBit);
  if (!Subtarget->hasVFP2Base())
    Features.set(Feature_NoVFPBit);
  if (Subtarget->hasVFP2Base())
    Features.set(Feature_HasVFP2Bit);
  if (Subtarget->hasVFP3Base())
    Features.set(Feature_HasVFP3Bit);
  if (Subtarget->hasVFP4Base())
    Features.set(Feature_HasVFP4Bit);
  if (Subtarget->hasFP64())
    Features.set(Feature_HasDPVFPBit);
  if (Subtarget->hasFPARMv8Base())
    Features.set(Feature_HasFPARMv8Bit);
  if (Subtarget->hasNEON())
    Features.set(Feature_HasNEONBit);
  if (Subtarget->hasSHA2())
    Features.set(Feature_HasSHA2Bit);
  if (Subtarget->hasAES())
    Features.set(Feature_HasAESBit);
  if (Subtarget->hasDotProd())
    Features.set(Feature_HasDotProdBit);
  if (Subtarget->hasCRC())
    Features.set(Feature_HasCRCBit);
  if (Subtarget->hasLOB())
    Features.set(Feature_HasLOBBit);
  if (Subtarget->hasFP16())
    Features.set(Feature_HasFP16Bit);
  if (Subtarget->hasFullFP16())
    Features.set(Feature_HasFullFP16Bit);
  if (Subtarget->hasMatMulInt8())
    Features.set(Feature_HasMatMulInt8Bit);
  if (Subtarget->hasDivideInThumbMode())
    Features.set(Feature_HasDivideInThumbBit);
  if (Subtarget->hasDivideInARMMode())
    Features.set(Feature_HasDivideInARMBit);
  if (Subtarget->hasDSP())
    Features.set(Feature_HasDSPBit);
  if (Subtarget->hasDataBarrier())
    Features.set(Feature_HasDBBit);
  if (Subtarget->hasV7Clrex())
    Features.set(Feature_HasV7ClrexBit);
  if (Subtarget->hasAcquireRelease())
    Features.set(Feature_HasAcquireReleaseBit);
  if (Subtarget->hasMPExtension())
    Features.set(Feature_HasMPBit);
  if (Subtarget->has8MSecExt())
    Features.set(Feature_Has8MSecExtBit);
  if (Subtarget->hasZeroCycleZeroing())
    Features.set(Feature_HasZCZBit);
  if (Subtarget->useNEONForSinglePrecisionFP())
    Features.set(Feature_UseNEONForFPBit);
  if (!Subtarget->useNEONForSinglePrecisionFP())
    Features.set(Feature_DontUseNEONForFPBit);
  if (Subtarget->isThumb())
    Features.set(Feature_IsThumbBit);
  if (Subtarget->isThumb1Only())
    Features.set(Feature_IsThumb1OnlyBit);
  if (Subtarget->isThumb2())
    Features.set(Feature_IsThumb2Bit);
  if (!Subtarget->isMClass())
    Features.set(Feature_IsNotMClassBit);
  if (!Subtarget->isThumb())
    Features.set(Feature_IsARMBit);
  if (Subtarget->isTargetWindows())
    Features.set(Feature_IsWindowsBit);
  if (!Subtarget->isTargetWindows())
    Features.set(Feature_IsNotWindowsBit);
  if (Subtarget->isReadTPTPIDRURW())
    Features.set(Feature_IsReadTPTPIDRURWBit);
  if (Subtarget->isReadTPTPIDRURO())
    Features.set(Feature_IsReadTPTPIDRUROBit);
  if (Subtarget->isReadTPTPIDRPRW())
    Features.set(Feature_IsReadTPTPIDRPRWBit);
  if (Subtarget->isReadTPSoft())
    Features.set(Feature_IsReadTPSoftBit);
  if (Subtarget->useNaClTrap())
    Features.set(Feature_UseNaClTrapBit);
  if (!Subtarget->useNaClTrap())
    Features.set(Feature_DontUseNaClTrapBit);
  if (Subtarget->useMulOps())
    Features.set(Feature_UseMulOpsBit);
  if (TM.Options.AllowFPOpFusion ==  FPOpFusion::Fast && Subtarget->useFPVFMx())
    Features.set(Feature_UseFusedMACBit);
  if (!Subtarget->hasSlowVGETLNi32())
    Features.set(Feature_HasFastVGETLNi32Bit);
  if (Subtarget->hasSlowVGETLNi32())
    Features.set(Feature_HasSlowVGETLNi32Bit);
  if (!Subtarget->hasSlowVDUP32())
    Features.set(Feature_HasFastVDUP32Bit);
  if (Subtarget->hasSlowVDUP32())
    Features.set(Feature_HasSlowVDUP32Bit);
  if (Subtarget->preferVMOVSR() ||!Subtarget->useNEONForSinglePrecisionFP())
    Features.set(Feature_UseVMOVSRBit);
  if (!Subtarget->preferVMOVSR() &&Subtarget->useNEONForSinglePrecisionFP())
    Features.set(Feature_DontUseVMOVSRBit);
  if (Subtarget->genExecuteOnly())
    Features.set(Feature_GenExecuteOnlyBit);
  if (!Subtarget->genExecuteOnly())
    Features.set(Feature_DontGenExecuteOnlyBit);
  if (Subtarget->genExecuteOnly() && Subtarget->isThumb1Only() && !Subtarget->hasV8MBaselineOps())
    Features.set(Feature_GenT1ExecuteOnlyBit);
  return Features;
}

void ARMInstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const ARMSubtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset ARMInstructionSelector::
computeAvailableFunctionFeatures(const ARMSubtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  if (Subtarget->useMovt())
    Features.set(Feature_UseMovtBit);
  if (!Subtarget->useMovt())
    Features.set(Feature_DontUseMovtBit);
  if (Subtarget->useMovt() && Subtarget->allowPositionIndependentMovt())
    Features.set(Feature_UseMovtInPicBit);
  if (!Subtarget->useMovt() || !Subtarget->allowPositionIndependentMovt())
    Features.set(Feature_DontUseMovtInPicBit);
  if (((Subtarget->useFPVMLx() &&  TM.Options.AllowFPOpFusion != FPOpFusion::Fast) ||Subtarget->hasMinSize()))
    Features.set(Feature_UseFPVMLxBit);
  if ( MF->getSubtarget<ARMSubtarget>().hardenSlsBlr() )
    Features.set(Feature_SLSBLRMitigationBit);
  if ( !MF->getSubtarget<ARMSubtarget>().hardenSlsBlr() )
    Features.set(Feature_NoSLSBLRMitigationBit);
  if (MF->getDataLayout().isLittleEndian())
    Features.set(Feature_IsLEBit);
  if (MF->getDataLayout().isBigEndian())
    Features.set(Feature_IsBEBit);
  if ( MF->getInfo<ARMFunctionInfo>()->shouldSignReturnAddress(true) )
    Features.set(Feature_SignRetAddrBit);
  if ( !MF->getInfo<ARMFunctionInfo>()->shouldSignReturnAddress(true) )
    Features.set(Feature_NoSignRetAddrBit);
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_HasDotProd,
  GIFBS_HasFP16,
  GIFBS_HasFPARMv8,
  GIFBS_HasFPRegs,
  GIFBS_HasFullFP16,
  GIFBS_HasMVEFloat,
  GIFBS_HasMVEInt,
  GIFBS_HasMatMulInt8,
  GIFBS_HasNEON,
  GIFBS_HasVFP2,
  GIFBS_HasVFP3,
  GIFBS_HasVFP4,
  GIFBS_IsARM,
  GIFBS_IsThumb,
  GIFBS_IsThumb2,
  GIFBS_NoHonorSignDependentRounding,
  GIFBS_DontUseNEONForFP_HasVFP2,
  GIFBS_DontUseNaClTrap_IsARM,
  GIFBS_DontUseVMOVSR_HasNEON,
  GIFBS_Has8MSecExt_IsThumb,
  GIFBS_HasAES_HasV8,
  GIFBS_HasCRC_IsARM,
  GIFBS_HasCRC_IsThumb2,
  GIFBS_HasDB_IsARM,
  GIFBS_HasDB_IsThumb,
  GIFBS_HasDPVFP_HasFPARMv8,
  GIFBS_HasDPVFP_HasVFP2,
  GIFBS_HasDPVFP_HasVFP3,
  GIFBS_HasDPVFP_HasVFP4,
  GIFBS_HasDPVFP_NoHonorSignDependentRounding,
  GIFBS_HasDSP_IsThumb2,
  GIFBS_HasDivideInARM_IsARM,
  GIFBS_HasFP16_HasNEON,
  GIFBS_HasFPARMv8_HasNEON,
  GIFBS_HasFPRegs_HasFastVGETLNi32,
  GIFBS_HasFPRegs_UseVMOVSR,
  GIFBS_HasFullFP16_HasNEON,
  GIFBS_HasMVEInt_HasV8_1MMainline,
  GIFBS_HasMVEInt_IsBE,
  GIFBS_HasMVEInt_IsLE,
  GIFBS_HasNEON_HasV8,
  GIFBS_HasNEON_HasV8_1a,
  GIFBS_HasNEON_HasV8_3a,
  GIFBS_HasNEON_HasVFP4,
  GIFBS_HasNEON_IsBE,
  GIFBS_HasNEON_IsLE,
  GIFBS_HasNEON_UseNEONForFP,
  GIFBS_HasSHA2_HasV8,
  GIFBS_HasV5T_IsARM,
  GIFBS_HasV5T_IsThumb,
  GIFBS_HasV5TE_IsARM,
  GIFBS_HasV6_IsARM,
  GIFBS_HasV6K_IsARM,
  GIFBS_HasV6M_IsThumb,
  GIFBS_HasV6T2_IsARM,
  GIFBS_HasV7_IsARM,
  GIFBS_HasV7Clrex_IsThumb,
  GIFBS_HasV8MBaseline_IsThumb,
  GIFBS_IsARM_NoV5T,
  GIFBS_IsARM_NoV6,
  GIFBS_IsARM_PreV8,
  GIFBS_IsARM_UseNaClTrap,
  GIFBS_IsThumb_IsThumb1Only,
  GIFBS_IsThumb_IsWindows,
  GIFBS_IsThumb_NoV5T,
  GIFBS_IsThumb_UseMovt,
  GIFBS_IsThumb2_PreV8,
  GIFBS_IsThumb2_UseMulOps,
  GIFBS_DontUseMovt_GenExecuteOnly_IsThumb1Only,
  GIFBS_HasDSP_IsThumb2_UseMulOps,
  GIFBS_HasDivideInThumb_HasV8MBaseline_IsThumb,
  GIFBS_HasFPARMv8_HasFullFP16_HasNEON,
  GIFBS_HasFullFP16_HasNEON_HasV8,
  GIFBS_HasFullFP16_HasNEON_HasV8_3a,
  GIFBS_HasFullFP16_HasNEON_UseFPVMLx,
  GIFBS_HasFullFP16_HasNEON_UseFusedMAC,
  GIFBS_HasLOB_HasV8_1MMainline_IsThumb2,
  GIFBS_HasNEON_UseFPVMLx_UseNEONForFP,
  GIFBS_HasV5TE_IsARM_UseMulOps,
  GIFBS_HasV6_IsARM_UseMulOps,
  GIFBS_HasV6_IsThumb_IsThumb1Only,
  GIFBS_HasV6T2_IsARM_UseMulOps,
  GIFBS_HasVFP4_UseFusedMAC_UseNEONForFP,
  GIFBS_IsARM_NoV6_UseMulOps,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_HasDotProdBit, },
  {Feature_HasFP16Bit, },
  {Feature_HasFPARMv8Bit, },
  {Feature_HasFPRegsBit, },
  {Feature_HasFullFP16Bit, },
  {Feature_HasMVEFloatBit, },
  {Feature_HasMVEIntBit, },
  {Feature_HasMatMulInt8Bit, },
  {Feature_HasNEONBit, },
  {Feature_HasVFP2Bit, },
  {Feature_HasVFP3Bit, },
  {Feature_HasVFP4Bit, },
  {Feature_IsARMBit, },
  {Feature_IsThumbBit, },
  {Feature_IsThumb2Bit, },
  {Feature_NoHonorSignDependentRoundingBit, },
  {Feature_DontUseNEONForFPBit, Feature_HasVFP2Bit, },
  {Feature_DontUseNaClTrapBit, Feature_IsARMBit, },
  {Feature_DontUseVMOVSRBit, Feature_HasNEONBit, },
  {Feature_Has8MSecExtBit, Feature_IsThumbBit, },
  {Feature_HasAESBit, Feature_HasV8Bit, },
  {Feature_HasCRCBit, Feature_IsARMBit, },
  {Feature_HasCRCBit, Feature_IsThumb2Bit, },
  {Feature_HasDBBit, Feature_IsARMBit, },
  {Feature_HasDBBit, Feature_IsThumbBit, },
  {Feature_HasDPVFPBit, Feature_HasFPARMv8Bit, },
  {Feature_HasDPVFPBit, Feature_HasVFP2Bit, },
  {Feature_HasDPVFPBit, Feature_HasVFP3Bit, },
  {Feature_HasDPVFPBit, Feature_HasVFP4Bit, },
  {Feature_HasDPVFPBit, Feature_NoHonorSignDependentRoundingBit, },
  {Feature_HasDSPBit, Feature_IsThumb2Bit, },
  {Feature_HasDivideInARMBit, Feature_IsARMBit, },
  {Feature_HasFP16Bit, Feature_HasNEONBit, },
  {Feature_HasFPARMv8Bit, Feature_HasNEONBit, },
  {Feature_HasFPRegsBit, Feature_HasFastVGETLNi32Bit, },
  {Feature_HasFPRegsBit, Feature_UseVMOVSRBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasMVEIntBit, Feature_HasV8_1MMainlineBit, },
  {Feature_HasMVEIntBit, Feature_IsBEBit, },
  {Feature_HasMVEIntBit, Feature_IsLEBit, },
  {Feature_HasNEONBit, Feature_HasV8Bit, },
  {Feature_HasNEONBit, Feature_HasV8_1aBit, },
  {Feature_HasNEONBit, Feature_HasV8_3aBit, },
  {Feature_HasNEONBit, Feature_HasVFP4Bit, },
  {Feature_HasNEONBit, Feature_IsBEBit, },
  {Feature_HasNEONBit, Feature_IsLEBit, },
  {Feature_HasNEONBit, Feature_UseNEONForFPBit, },
  {Feature_HasSHA2Bit, Feature_HasV8Bit, },
  {Feature_HasV5TBit, Feature_IsARMBit, },
  {Feature_HasV5TBit, Feature_IsThumbBit, },
  {Feature_HasV5TEBit, Feature_IsARMBit, },
  {Feature_HasV6Bit, Feature_IsARMBit, },
  {Feature_HasV6KBit, Feature_IsARMBit, },
  {Feature_HasV6MBit, Feature_IsThumbBit, },
  {Feature_HasV6T2Bit, Feature_IsARMBit, },
  {Feature_HasV7Bit, Feature_IsARMBit, },
  {Feature_HasV7ClrexBit, Feature_IsThumbBit, },
  {Feature_HasV8MBaselineBit, Feature_IsThumbBit, },
  {Feature_IsARMBit, Feature_NoV5TBit, },
  {Feature_IsARMBit, Feature_NoV6Bit, },
  {Feature_IsARMBit, Feature_PreV8Bit, },
  {Feature_IsARMBit, Feature_UseNaClTrapBit, },
  {Feature_IsThumbBit, Feature_IsThumb1OnlyBit, },
  {Feature_IsThumbBit, Feature_IsWindowsBit, },
  {Feature_IsThumbBit, Feature_NoV5TBit, },
  {Feature_IsThumbBit, Feature_UseMovtBit, },
  {Feature_IsThumb2Bit, Feature_PreV8Bit, },
  {Feature_IsThumb2Bit, Feature_UseMulOpsBit, },
  {Feature_DontUseMovtBit, Feature_GenExecuteOnlyBit, Feature_IsThumb1OnlyBit, },
  {Feature_HasDSPBit, Feature_IsThumb2Bit, Feature_UseMulOpsBit, },
  {Feature_HasDivideInThumbBit, Feature_HasV8MBaselineBit, Feature_IsThumbBit, },
  {Feature_HasFPARMv8Bit, Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, Feature_HasV8Bit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, Feature_HasV8_3aBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, Feature_UseFPVMLxBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, Feature_UseFusedMACBit, },
  {Feature_HasLOBBit, Feature_HasV8_1MMainlineBit, Feature_IsThumb2Bit, },
  {Feature_HasNEONBit, Feature_UseFPVMLxBit, Feature_UseNEONForFPBit, },
  {Feature_HasV5TEBit, Feature_IsARMBit, Feature_UseMulOpsBit, },
  {Feature_HasV6Bit, Feature_IsARMBit, Feature_UseMulOpsBit, },
  {Feature_HasV6Bit, Feature_IsThumbBit, Feature_IsThumb1OnlyBit, },
  {Feature_HasV6T2Bit, Feature_IsARMBit, Feature_UseMulOpsBit, },
  {Feature_HasVFP4Bit, Feature_UseFusedMACBit, Feature_UseNEONForFPBit, },
  {Feature_IsARMBit, Feature_NoV6Bit, Feature_UseMulOpsBit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
};
// See constructor for table contents

ARMInstructionSelector::ComplexMatcherMemFn
ARMInstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
};

// PatFrag predicates.
enum {
  GICXXPred_MI_Predicate_bf_inv_mask_imm = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_vfp_f32imm,
  GICXXPred_MI_Predicate_vfp_f64imm,
};
bool ARMInstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_bf_inv_mask_imm: {
    
        // There's better methods of implementing this check. IntImmLeaf<> would be
        // equivalent and have less boilerplate but we need a test for C++
        // predicates and this one causes new rules to be imported into GlobalISel
        // without requiring additional features first.
        const auto &MO = MI.getOperand(1);
        if (!MO.isCImm())
          return false;
        return ARM::isBitFieldInvertedMask(MO.getCImm()->getZExtValue());
      
    llvm_unreachable("bf_inv_mask_imm should have returned");
  }
  case GICXXPred_MI_Predicate_vfp_f32imm: {
    
          const auto &MO = MI.getOperand(1);
          if (!MO.isFPImm())
            return false;
          return ARM_AM::getFP32Imm(MO.getFPImm()->getValueAPF()) != -1;
        
    llvm_unreachable("vfp_f32imm should have returned");
  }
  case GICXXPred_MI_Predicate_vfp_f64imm: {
    
          const auto &MO = MI.getOperand(1);
          if (!MO.isFPImm())
            return false;
          return ARM_AM::getFP64Imm(MO.getFPImm()->getValueAPF()) != -1;
        
    llvm_unreachable("vfp_f64imm should have returned");
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool ARMInstructionSelector::testMOPredicate_MO(unsigned PredicateID, const MachineOperand & MO, const MatcherState &State) const {
  const auto &Operands = State.RecordedOperands;
  Register Reg = MO.getReg();
  (void)Operands;
  (void)Reg;
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_VectorIndex8 = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_VectorIndex16,
  GICXXPred_I64_Predicate_VectorIndex32,
  GICXXPred_I64_Predicate_VectorIndex64,
  GICXXPred_I64_Predicate_asr_imm,
  GICXXPred_I64_Predicate_imm0_7,
  GICXXPred_I64_Predicate_imm0_15,
  GICXXPred_I64_Predicate_imm0_31,
  GICXXPred_I64_Predicate_imm0_32,
  GICXXPred_I64_Predicate_imm0_63,
  GICXXPred_I64_Predicate_imm0_239,
  GICXXPred_I64_Predicate_imm0_255,
  GICXXPred_I64_Predicate_imm0_255_expr,
  GICXXPred_I64_Predicate_imm0_4095,
  GICXXPred_I64_Predicate_imm0_65535,
  GICXXPred_I64_Predicate_imm0_65535_expr,
  GICXXPred_I64_Predicate_imm0_65535_neg,
  GICXXPred_I64_Predicate_imm1_7,
  GICXXPred_I64_Predicate_imm1_15,
  GICXXPred_I64_Predicate_imm1_16,
  GICXXPred_I64_Predicate_imm1_31,
  GICXXPred_I64_Predicate_imm8,
  GICXXPred_I64_Predicate_imm8_255,
  GICXXPred_I64_Predicate_imm8_or_16,
  GICXXPred_I64_Predicate_imm16,
  GICXXPred_I64_Predicate_imm16_31,
  GICXXPred_I64_Predicate_imm24b,
  GICXXPred_I64_Predicate_imm32,
  GICXXPred_I64_Predicate_imm256_510,
  GICXXPred_I64_Predicate_imm_3b,
  GICXXPred_I64_Predicate_imm_4b,
  GICXXPred_I64_Predicate_imm_6b,
  GICXXPred_I64_Predicate_imm_7b,
  GICXXPred_I64_Predicate_imm_9b,
  GICXXPred_I64_Predicate_imm_11b,
  GICXXPred_I64_Predicate_imm_12b,
  GICXXPred_I64_Predicate_imm_13b,
  GICXXPred_I64_Predicate_imm_even,
  GICXXPred_I64_Predicate_imm_odd,
  GICXXPred_I64_Predicate_imm_sr,
  GICXXPred_I64_Predicate_long_shift,
  GICXXPred_I64_Predicate_mod_imm,
  GICXXPred_I64_Predicate_mod_imm_not,
  GICXXPred_I64_Predicate_pkh_asr_amt,
  GICXXPred_I64_Predicate_pkh_lsl_amt,
  GICXXPred_I64_Predicate_shr_imm8,
  GICXXPred_I64_Predicate_shr_imm16,
  GICXXPred_I64_Predicate_shr_imm32,
  GICXXPred_I64_Predicate_shr_imm64,
  GICXXPred_I64_Predicate_t2_so_imm,
  GICXXPred_I64_Predicate_t2_so_imm_neg,
};
bool ARMInstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_VectorIndex8: {
    
      return ((uint64_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_VectorIndex16: {
    
      return ((uint64_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_VectorIndex32: {
    
      return ((uint64_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_VectorIndex64: {
    
      return ((uint64_t)Imm) < 1;
    
  }
  case GICXXPred_I64_Predicate_asr_imm: {
     return Imm > 0 && Imm <= 32; 
  }
  case GICXXPred_I64_Predicate_imm0_7: {
    
      return Imm >= 0 && Imm < 8;
    
  }
  case GICXXPred_I64_Predicate_imm0_15: {
    
      return Imm >= 0 && Imm < 16;
    
  }
  case GICXXPred_I64_Predicate_imm0_31: {
    
      return Imm >= 0 && Imm < 32;
    
  }
  case GICXXPred_I64_Predicate_imm0_32: {
    
      return Imm >= 0 && Imm < 33;
    
  }
  case GICXXPred_I64_Predicate_imm0_63: {
    
      return Imm >= 0 && Imm < 64;
    
  }
  case GICXXPred_I64_Predicate_imm0_239: {
     return Imm >= 0 && Imm < 240; 
  }
  case GICXXPred_I64_Predicate_imm0_255: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_imm0_255_expr: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_imm0_4095: {
    
      return Imm >= 0 && Imm < 4096;
    
  }
  case GICXXPred_I64_Predicate_imm0_65535: {
    
      return Imm >= 0 && Imm < 65536;
    
  }
  case GICXXPred_I64_Predicate_imm0_65535_expr: {
    
      return Imm >= 0 && Imm < 65536;
    
  }
  case GICXXPred_I64_Predicate_imm0_65535_neg: {
    
      return -Imm >= 0 && -Imm < 65536;
    
  }
  case GICXXPred_I64_Predicate_imm1_7: {
     return Imm > 0 && Imm < 8; 
  }
  case GICXXPred_I64_Predicate_imm1_15: {
     return Imm > 0 && Imm < 16; 
  }
  case GICXXPred_I64_Predicate_imm1_16: {
    
        return Imm > 0 && Imm <= 16;
      
  }
  case GICXXPred_I64_Predicate_imm1_31: {
     return Imm > 0 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_imm8: {
     return Imm == 8; 
  }
  case GICXXPred_I64_Predicate_imm8_255: {
    
      return Imm >= 8 && Imm < 256;
    
  }
  case GICXXPred_I64_Predicate_imm8_or_16: {
     return Imm == 8 || Imm == 16;
  }
  case GICXXPred_I64_Predicate_imm16: {
     return Imm == 16; 
  }
  case GICXXPred_I64_Predicate_imm16_31: {
    
      return (int32_t)Imm >= 16 && (int32_t)Imm < 32;
    
  }
  case GICXXPred_I64_Predicate_imm24b: {
    
      return Imm >= 0 && Imm <= 0xffffff;
    
  }
  case GICXXPred_I64_Predicate_imm32: {
     return Imm == 32; 
  }
  case GICXXPred_I64_Predicate_imm256_510: {
    
      return Imm >= 256 && Imm < 511;
    
  }
  case GICXXPred_I64_Predicate_imm_3b: {
    { return Imm >= 0 && Imm < (1 << 3); }
    llvm_unreachable("imm_3b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_4b: {
    { return Imm >= 0 && Imm < (1 << 4); }
    llvm_unreachable("imm_4b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_6b: {
    { return Imm >= 0 && Imm < (1 << 6); }
    llvm_unreachable("imm_6b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_7b: {
    { return Imm >= 0 && Imm < (1 << 7); }
    llvm_unreachable("imm_7b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_9b: {
    { return Imm >= 0 && Imm < (1 << 9); }
    llvm_unreachable("imm_9b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_11b: {
    { return Imm >= 0 && Imm < (1 << 11); }
    llvm_unreachable("imm_11b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_12b: {
    { return Imm >= 0 && Imm < (1 << 12); }
    llvm_unreachable("imm_12b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_13b: {
    { return Imm >= 0 && Imm < (1 << 13); }
    llvm_unreachable("imm_13b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_even: {
     return (Imm & 1) == 0; 
  }
  case GICXXPred_I64_Predicate_imm_odd: {
     return (Imm & 1) == 1; 
  }
  case GICXXPred_I64_Predicate_imm_sr: {
    
      return Imm > 0 && Imm <= 32;
    
  }
  case GICXXPred_I64_Predicate_long_shift: {
     return Imm > 0 && Imm <= 32; 
  }
  case GICXXPred_I64_Predicate_mod_imm: {
    
        return ARM_AM::getSOImmVal(Imm) != -1;
      
  }
  case GICXXPred_I64_Predicate_mod_imm_not: {
    
        return ARM_AM::getSOImmVal(~(uint32_t)Imm) != -1;
      
  }
  case GICXXPred_I64_Predicate_pkh_asr_amt: {
     return Imm > 0 && Imm <= 32; 
  }
  case GICXXPred_I64_Predicate_pkh_lsl_amt: {
     return Imm >= 0 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_shr_imm8: {
     return Imm > 0 && Imm <= 8; 
  }
  case GICXXPred_I64_Predicate_shr_imm16: {
     return Imm > 0 && Imm <= 16; 
  }
  case GICXXPred_I64_Predicate_shr_imm32: {
     return Imm > 0 && Imm <= 32; 
  }
  case GICXXPred_I64_Predicate_shr_imm64: {
     return Imm > 0 && Imm <= 64; 
  }
  case GICXXPred_I64_Predicate_t2_so_imm: {
    
        return ARM_AM::getT2SOImmVal(Imm) != -1;
      
  }
  case GICXXPred_I64_Predicate_t2_so_imm_neg: {
    
      return Imm && ARM_AM::getT2SOImmVal(-(uint32_t)Imm) != -1;
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool ARMInstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APInt_Predicate_arm_i32imm = GICXXPred_Invalid + 1,
};
bool ARMInstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APInt_Predicate_arm_i32imm: {
    
      if (Subtarget->useMovt())
        return true;
      if (ARM_AM::isSOImmTwoPartVal(Imm.getZExtValue()))
        return true;
      return ARM_AM::isSOImmTwoPartValNeg(Imm.getZExtValue());
    
    llvm_unreachable("arm_i32imm should have returned");
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool ARMInstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("ARMInstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
  GICR_renderInvertedImm,
  GICR_renderVFPF32Imm,
  GICR_renderVFPF64Imm,
};
ARMInstructionSelector::CustomRendererFn
ARMInstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
  &ARMInstructionSelector::renderInvertedImm,
  &ARMInstructionSelector::renderVFPF32Imm,
  &ARMInstructionSelector::renderVFPF64Imm,
};

bool ARMInstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool ARMInstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("ARMInstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *ARMInstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*      0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(308), /*)*//*default:*//*Label 79*/ GIMT_Encode4(130989),
     /*     10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(1030),
     /*     14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(10357),
     /*     18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(13601),
     /*     22 */ /*TargetOpcode::G_SDIV*//*Label 3*/ GIMT_Encode4(15305),
     /*     26 */ /*TargetOpcode::G_UDIV*//*Label 4*/ GIMT_Encode4(15401), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     46 */ /*TargetOpcode::G_AND*//*Label 5*/ GIMT_Encode4(15497),
     /*     50 */ /*TargetOpcode::G_OR*//*Label 6*/ GIMT_Encode4(18677),
     /*     54 */ /*TargetOpcode::G_XOR*//*Label 7*/ GIMT_Encode4(24486), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    114 */ /*TargetOpcode::G_CONCAT_VECTORS*//*Label 8*/ GIMT_Encode4(26181), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    126 */ /*TargetOpcode::G_BITCAST*//*Label 9*/ GIMT_Encode4(26568), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    142 */ /*TargetOpcode::G_INTRINSIC_TRUNC*//*Label 10*/ GIMT_Encode4(35580),
     /*    146 */ /*TargetOpcode::G_INTRINSIC_ROUND*//*Label 11*/ GIMT_Encode4(35876), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    158 */ /*TargetOpcode::G_INTRINSIC_ROUNDEVEN*//*Label 12*/ GIMT_Encode4(36251), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    174 */ /*TargetOpcode::G_SEXTLOAD*//*Label 13*/ GIMT_Encode4(36514), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    294 */ /*TargetOpcode::G_FENCE*//*Label 14*/ GIMT_Encode4(36677), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    314 */ /*TargetOpcode::G_INTRINSIC*//*Label 15*/ GIMT_Encode4(36698),
     /*    318 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 16*/ GIMT_Encode4(91450), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    330 */ /*TargetOpcode::G_ANYEXT*//*Label 17*/ GIMT_Encode4(99112),
     /*    334 */ /*TargetOpcode::G_TRUNC*//*Label 18*/ GIMT_Encode4(99270),
     /*    338 */ /*TargetOpcode::G_CONSTANT*//*Label 19*/ GIMT_Encode4(99428),
     /*    342 */ /*TargetOpcode::G_FCONSTANT*//*Label 20*/ GIMT_Encode4(99749), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    354 */ /*TargetOpcode::G_SEXT*//*Label 21*/ GIMT_Encode4(99845),
     /*    358 */ /*TargetOpcode::G_SEXT_INREG*//*Label 22*/ GIMT_Encode4(100003),
     /*    362 */ /*TargetOpcode::G_ZEXT*//*Label 23*/ GIMT_Encode4(100608),
     /*    366 */ /*TargetOpcode::G_SHL*//*Label 24*/ GIMT_Encode4(100766),
     /*    370 */ /*TargetOpcode::G_LSHR*//*Label 25*/ GIMT_Encode4(100982),
     /*    374 */ /*TargetOpcode::G_ASHR*//*Label 26*/ GIMT_Encode4(101090), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    386 */ /*TargetOpcode::G_ROTR*//*Label 27*/ GIMT_Encode4(101363), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    454 */ /*TargetOpcode::G_UMULH*//*Label 28*/ GIMT_Encode4(101695),
     /*    458 */ /*TargetOpcode::G_SMULH*//*Label 29*/ GIMT_Encode4(101943),
     /*    462 */ /*TargetOpcode::G_UADDSAT*//*Label 30*/ GIMT_Encode4(102312),
     /*    466 */ /*TargetOpcode::G_SADDSAT*//*Label 31*/ GIMT_Encode4(102957),
     /*    470 */ /*TargetOpcode::G_USUBSAT*//*Label 32*/ GIMT_Encode4(104257),
     /*    474 */ /*TargetOpcode::G_SSUBSAT*//*Label 33*/ GIMT_Encode4(104902), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    518 */ /*TargetOpcode::G_FADD*//*Label 34*/ GIMT_Encode4(105922),
     /*    522 */ /*TargetOpcode::G_FSUB*//*Label 35*/ GIMT_Encode4(108275),
     /*    526 */ /*TargetOpcode::G_FMUL*//*Label 36*/ GIMT_Encode4(109952),
     /*    530 */ /*TargetOpcode::G_FMA*//*Label 37*/ GIMT_Encode4(110933), GIMT_Encode4(0),
     /*    538 */ /*TargetOpcode::G_FDIV*//*Label 38*/ GIMT_Encode4(113024), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    586 */ /*TargetOpcode::G_FNEG*//*Label 39*/ GIMT_Encode4(113189),
     /*    590 */ /*TargetOpcode::G_FPEXT*//*Label 40*/ GIMT_Encode4(114720),
     /*    594 */ /*TargetOpcode::G_FPTRUNC*//*Label 41*/ GIMT_Encode4(114956),
     /*    598 */ /*TargetOpcode::G_FPTOSI*//*Label 42*/ GIMT_Encode4(115228),
     /*    602 */ /*TargetOpcode::G_FPTOUI*//*Label 43*/ GIMT_Encode4(116562),
     /*    606 */ /*TargetOpcode::G_SITOFP*//*Label 44*/ GIMT_Encode4(117896),
     /*    610 */ /*TargetOpcode::G_UITOFP*//*Label 45*/ GIMT_Encode4(118548), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    622 */ /*TargetOpcode::G_FABS*//*Label 46*/ GIMT_Encode4(119200), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    638 */ /*TargetOpcode::G_FMINNUM*//*Label 47*/ GIMT_Encode4(119976),
     /*    642 */ /*TargetOpcode::G_FMAXNUM*//*Label 48*/ GIMT_Encode4(120568), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    654 */ /*TargetOpcode::G_FMINIMUM*//*Label 49*/ GIMT_Encode4(121160),
     /*    658 */ /*TargetOpcode::G_FMAXIMUM*//*Label 50*/ GIMT_Encode4(121894), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    670 */ /*TargetOpcode::G_GET_FPENV*//*Label 51*/ GIMT_Encode4(122628),
     /*    674 */ /*TargetOpcode::G_SET_FPENV*//*Label 52*/ GIMT_Encode4(122661),
     /*    678 */ /*TargetOpcode::G_RESET_FPENV*//*Label 53*/ GIMT_Encode4(122697),
     /*    682 */ /*TargetOpcode::G_GET_FPMODE*//*Label 54*/ GIMT_Encode4(122826), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    702 */ /*TargetOpcode::G_SMIN*//*Label 55*/ GIMT_Encode4(122859),
     /*    706 */ /*TargetOpcode::G_SMAX*//*Label 56*/ GIMT_Encode4(123402),
     /*    710 */ /*TargetOpcode::G_UMIN*//*Label 57*/ GIMT_Encode4(123945),
     /*    714 */ /*TargetOpcode::G_UMAX*//*Label 58*/ GIMT_Encode4(124866),
     /*    718 */ /*TargetOpcode::G_ABS*//*Label 59*/ GIMT_Encode4(125787), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    730 */ /*TargetOpcode::G_BR*//*Label 60*/ GIMT_Encode4(126258), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    750 */ /*TargetOpcode::G_INSERT_VECTOR_ELT*//*Label 61*/ GIMT_Encode4(126331),
     /*    754 */ /*TargetOpcode::G_EXTRACT_VECTOR_ELT*//*Label 62*/ GIMT_Encode4(126631), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    782 */ /*TargetOpcode::G_CTLZ*//*Label 63*/ GIMT_Encode4(126688), GIMT_Encode4(0),
     /*    790 */ /*TargetOpcode::G_CTPOP*//*Label 64*/ GIMT_Encode4(127249),
     /*    794 */ /*TargetOpcode::G_BSWAP*//*Label 65*/ GIMT_Encode4(127357),
     /*    798 */ /*TargetOpcode::G_BITREVERSE*//*Label 66*/ GIMT_Encode4(127647),
     /*    802 */ /*TargetOpcode::G_FCEIL*//*Label 67*/ GIMT_Encode4(128079), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    850 */ /*TargetOpcode::G_FSQRT*//*Label 68*/ GIMT_Encode4(128342),
     /*    854 */ /*TargetOpcode::G_FFLOOR*//*Label 69*/ GIMT_Encode4(128480),
     /*    858 */ /*TargetOpcode::G_FRINT*//*Label 70*/ GIMT_Encode4(128855),
     /*    862 */ /*TargetOpcode::G_FNEARBYINT*//*Label 71*/ GIMT_Encode4(129151), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    950 */ /*TargetOpcode::G_TRAP*//*Label 72*/ GIMT_Encode4(129289),
     /*    954 */ /*TargetOpcode::G_DEBUGTRAP*//*Label 73*/ GIMT_Encode4(129335), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    994 */ /*TargetOpcode::G_VECREDUCE_ADD*//*Label 74*/ GIMT_Encode4(129422), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   1014 */ /*TargetOpcode::G_VECREDUCE_SMAX*//*Label 75*/ GIMT_Encode4(129843),
     /*   1018 */ /*TargetOpcode::G_VECREDUCE_SMIN*//*Label 76*/ GIMT_Encode4(130123),
     /*   1022 */ /*TargetOpcode::G_VECREDUCE_UMAX*//*Label 77*/ GIMT_Encode4(130412),
     /*   1026 */ /*TargetOpcode::G_VECREDUCE_UMIN*//*Label 78*/ GIMT_Encode4(130693),
     /*   1030 */ // Label 0: @1030
     /*   1030 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 89*/ GIMT_Encode4(10356),
     /*   1041 */ /*GILLT_s32*//*Label 80*/ GIMT_Encode4(1101),
     /*   1045 */ /*GILLT_s64*//*Label 81*/ GIMT_Encode4(6877), GIMT_Encode4(0),
     /*   1053 */ /*GILLT_v2s32*//*Label 82*/ GIMT_Encode4(6924),
     /*   1057 */ /*GILLT_v2s64*//*Label 83*/ GIMT_Encode4(7109), GIMT_Encode4(0),
     /*   1065 */ /*GILLT_v4s16*//*Label 84*/ GIMT_Encode4(7820),
     /*   1069 */ /*GILLT_v4s32*//*Label 85*/ GIMT_Encode4(8005), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   1081 */ /*GILLT_v8s8*//*Label 86*/ GIMT_Encode4(8961),
     /*   1085 */ /*GILLT_v8s16*//*Label 87*/ GIMT_Encode4(9146), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   1097 */ /*GILLT_v16s8*//*Label 88*/ GIMT_Encode4(10102),
     /*   1101 */ // Label 80: @1101
     /*   1101 */ GIM_Try, /*On fail goto*//*Label 90*/ GIMT_Encode4(6876),
     /*   1106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   1109 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   1112 */   GIM_Try, /*On fail goto*//*Label 91*/ GIMT_Encode4(1187), // Rule ID 5670 //
     /*   1117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   1120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   1124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1136 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1140 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1145 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*   1156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1162 */     // (add:{ *:[i32] } (and:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 255:{ *:[i32] }), GPR:{ *:[i32] }:$Rn)  =>  (UXTAB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTAB),
     /*   1165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1179 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1185 */     GIR_RootConstrainSelectedInstOperands,
     /*   1186 */     // GIR_Coverage, 5670,
     /*   1186 */     GIR_EraseRootFromParent_Done,
     /*   1187 */   // Label 91: @1187
     /*   1187 */   GIM_Try, /*On fail goto*//*Label 92*/ GIMT_Encode4(1262), // Rule ID 5671 //
     /*   1192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   1195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   1199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1215 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1220 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*   1231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1237 */     // (add:{ *:[i32] } (and:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] }), GPR:{ *:[i32] }:$Rn)  =>  (UXTAH:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTAH),
     /*   1240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1254 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1260 */     GIR_RootConstrainSelectedInstOperands,
     /*   1261 */     // GIR_Coverage, 5671,
     /*   1261 */     GIR_EraseRootFromParent_Done,
     /*   1262 */   // Label 92: @1262
     /*   1262 */   GIM_Try, /*On fail goto*//*Label 93*/ GIMT_Encode4(1337), // Rule ID 5705 //
     /*   1267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1286 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1290 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1295 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*   1306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1310 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1312 */     // (add:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 255:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2UXTAB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTAB),
     /*   1315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1329 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1335 */     GIR_RootConstrainSelectedInstOperands,
     /*   1336 */     // GIR_Coverage, 5705,
     /*   1336 */     GIR_EraseRootFromParent_Done,
     /*   1337 */   // Label 93: @1337
     /*   1337 */   GIM_Try, /*On fail goto*//*Label 94*/ GIMT_Encode4(1412), // Rule ID 5706 //
     /*   1342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1361 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1365 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1370 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*   1381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1387 */     // (add:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2UXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTAH),
     /*   1390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1404 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1410 */     GIR_RootConstrainSelectedInstOperands,
     /*   1411 */     // GIR_Coverage, 5706,
     /*   1411 */     GIR_EraseRootFromParent_Done,
     /*   1412 */   // Label 94: @1412
     /*   1412 */   GIM_Try, /*On fail goto*//*Label 95*/ GIMT_Encode4(1487), // Rule ID 2000 //
     /*   1417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   1420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   1424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1440 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1444 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1449 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*   1460 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1462 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (and:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 255:{ *:[i32] }))  =>  (UXTAB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTAB),
     /*   1465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1467 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   1469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1479 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1485 */     GIR_RootConstrainSelectedInstOperands,
     /*   1486 */     // GIR_Coverage, 2000,
     /*   1486 */     GIR_EraseRootFromParent_Done,
     /*   1487 */   // Label 95: @1487
     /*   1487 */   GIM_Try, /*On fail goto*//*Label 96*/ GIMT_Encode4(1562), // Rule ID 2001 //
     /*   1492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   1495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   1499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1515 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1519 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1524 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*   1535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1537 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (and:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] }))  =>  (UXTAH:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTAH),
     /*   1540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1542 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   1544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1554 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1560 */     GIR_RootConstrainSelectedInstOperands,
     /*   1561 */     // GIR_Coverage, 2001,
     /*   1561 */     GIR_EraseRootFromParent_Done,
     /*   1562 */   // Label 96: @1562
     /*   1562 */   GIM_Try, /*On fail goto*//*Label 97*/ GIMT_Encode4(1637), // Rule ID 2239 //
     /*   1567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1590 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1594 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1599 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*   1610 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1612 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 255:{ *:[i32] }))  =>  (t2UXTAB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTAB),
     /*   1615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1617 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   1619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1629 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1635 */     GIR_RootConstrainSelectedInstOperands,
     /*   1636 */     // GIR_Coverage, 2239,
     /*   1636 */     GIR_EraseRootFromParent_Done,
     /*   1637 */   // Label 97: @1637
     /*   1637 */   GIM_Try, /*On fail goto*//*Label 98*/ GIMT_Encode4(1712), // Rule ID 2240 //
     /*   1642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1665 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1669 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1674 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*   1685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1687 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] }))  =>  (t2UXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTAH),
     /*   1690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1692 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   1694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1704 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1710 */     GIR_RootConstrainSelectedInstOperands,
     /*   1711 */     // GIR_Coverage, 2240,
     /*   1711 */     GIR_EraseRootFromParent_Done,
     /*   1712 */   // Label 98: @1712
     /*   1712 */   GIM_Try, /*On fail goto*//*Label 99*/ GIMT_Encode4(1840), // Rule ID 5681 //
     /*   1717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   1732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   1740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   1744 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   1748 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   1752 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*   1756 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*   1760 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   1764 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   1768 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1773 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*   1777 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*   1781 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   1785 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*   1789 */     // MIs[4] Rm
     /*   1789 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*   1794 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*   1798 */     // MIs[1] Operand 2
     /*   1798 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   1809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1813 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   1815 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } (or:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] })), i16:{ *:[Other] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   1815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   1818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   1826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   1829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1832 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1838 */     GIR_RootConstrainSelectedInstOperands,
     /*   1839 */     // GIR_Coverage, 5681,
     /*   1839 */     GIR_EraseRootFromParent_Done,
     /*   1840 */   // Label 99: @1840
     /*   1840 */   GIM_Try, /*On fail goto*//*Label 100*/ GIMT_Encode4(1968), // Rule ID 5682 //
     /*   1845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   1860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   1868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   1872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   1876 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   1880 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*   1884 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   1888 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   1892 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   1896 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1901 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 8,
     /*   1905 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*   1909 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*   1913 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*   1917 */     // MIs[4] Rm
     /*   1917 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*   1922 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*   1926 */     // MIs[1] Operand 2
     /*   1926 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   1937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1941 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   1943 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] })), i16:{ *:[Other] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   1943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   1946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   1954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   1957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1960 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1966 */     GIR_RootConstrainSelectedInstOperands,
     /*   1967 */     // GIR_Coverage, 5682,
     /*   1967 */     GIR_EraseRootFromParent_Done,
     /*   1968 */   // Label 100: @1968
     /*   1968 */   GIM_Try, /*On fail goto*//*Label 101*/ GIMT_Encode4(2096), // Rule ID 2106 //
     /*   1973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   1992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1996 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2000 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   2004 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2008 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2012 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*   2016 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*   2020 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2024 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2028 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2033 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*   2037 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*   2041 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   2045 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*   2049 */     // MIs[4] Rm
     /*   2049 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*   2054 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*   2058 */     // MIs[1] Operand 2
     /*   2058 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   2069 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   2071 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } (or:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] })), i16:{ *:[Other] }))  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   2071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   2074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2076 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   2078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   2085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2088 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2094 */     GIR_RootConstrainSelectedInstOperands,
     /*   2095 */     // GIR_Coverage, 2106,
     /*   2095 */     GIR_EraseRootFromParent_Done,
     /*   2096 */   // Label 101: @2096
     /*   2096 */   GIM_Try, /*On fail goto*//*Label 102*/ GIMT_Encode4(2224), // Rule ID 5680 //
     /*   2101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   2104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   2120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2128 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   2132 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2136 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2140 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*   2144 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   2148 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2152 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2156 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2161 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 8,
     /*   2165 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*   2169 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*   2173 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*   2177 */     // MIs[4] Rm
     /*   2177 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*   2182 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*   2186 */     // MIs[1] Operand 2
     /*   2186 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   2197 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   2199 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] })), i16:{ *:[Other] }))  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   2199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   2202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2204 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   2206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   2213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2216 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2222 */     GIR_RootConstrainSelectedInstOperands,
     /*   2223 */     // GIR_Coverage, 5680,
     /*   2223 */     GIR_EraseRootFromParent_Done,
     /*   2224 */   // Label 102: @2224
     /*   2224 */   GIM_Try, /*On fail goto*//*Label 103*/ GIMT_Encode4(2334), // Rule ID 5449 //
     /*   2229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   2232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2248 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2252 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2256 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2260 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2264 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2268 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2273 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2277 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2281 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2285 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2289 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2293 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2298 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   2302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   2306 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2308 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 16:{ *:[i32] })), GPR:{ *:[i32] }:$Ra)  =>  (SMLATT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   2308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLATT),
     /*   2311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   2317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   2323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2326 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2332 */     GIR_RootConstrainSelectedInstOperands,
     /*   2333 */     // GIR_Coverage, 5449,
     /*   2333 */     GIR_EraseRootFromParent_Done,
     /*   2334 */   // Label 103: @2334
     /*   2334 */   GIM_Try, /*On fail goto*//*Label 104*/ GIMT_Encode4(2444), // Rule ID 5486 //
     /*   2339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   2342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2354 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2358 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2366 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2370 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2374 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2378 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2383 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2387 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2391 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2395 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2399 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2403 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2408 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   2412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2416 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2418 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] })), rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLATT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   2418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLATT),
     /*   2421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   2427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   2433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2436 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2442 */     GIR_RootConstrainSelectedInstOperands,
     /*   2443 */     // GIR_Coverage, 5486,
     /*   2443 */     GIR_EraseRootFromParent_Done,
     /*   2444 */   // Label 104: @2444
     /*   2444 */   GIM_Try, /*On fail goto*//*Label 105*/ GIMT_Encode4(2554), // Rule ID 192 //
     /*   2449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   2452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2456 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   2460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2472 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2476 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2480 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2484 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2488 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2492 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2497 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2501 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2505 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2509 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2513 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2517 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2522 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   2526 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2528 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 16:{ *:[i32] })))  =>  (SMLATT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   2528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLATT),
     /*   2531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   2537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2541 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   2543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2546 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2552 */     GIR_RootConstrainSelectedInstOperands,
     /*   2553 */     // GIR_Coverage, 192,
     /*   2553 */     GIR_EraseRootFromParent_Done,
     /*   2554 */   // Label 105: @2554
     /*   2554 */   GIM_Try, /*On fail goto*//*Label 106*/ GIMT_Encode4(2664), // Rule ID 521 //
     /*   2559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   2562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2578 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2582 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2586 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2590 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2594 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2598 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2602 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2607 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2611 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2615 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2619 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2623 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2627 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2632 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   2636 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2638 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] })))  =>  (t2SMLATT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   2638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLATT),
     /*   2641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   2647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2651 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   2653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2656 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2662 */     GIR_RootConstrainSelectedInstOperands,
     /*   2663 */     // GIR_Coverage, 521,
     /*   2663 */     GIR_EraseRootFromParent_Done,
     /*   2664 */   // Label 106: @2664
     /*   2664 */   GIM_Try, /*On fail goto*//*Label 107*/ GIMT_Encode4(2777), // Rule ID 5448 //
     /*   2669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   2672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2688 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2692 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2696 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2700 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2704 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2708 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2713 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2717 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2721 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   2725 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2729 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2734 */     // MIs[3] Operand 2
     /*   2734 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   2745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   2749 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2751 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, i16:{ *:[Other] })), GPR:{ *:[i32] }:$Ra)  =>  (SMLABT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   2751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABT),
     /*   2754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*   2760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   2764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   2766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2769 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2775 */     GIR_RootConstrainSelectedInstOperands,
     /*   2776 */     // GIR_Coverage, 5448,
     /*   2776 */     GIR_EraseRootFromParent_Done,
     /*   2777 */   // Label 107: @2777
     /*   2777 */   GIM_Try, /*On fail goto*//*Label 108*/ GIMT_Encode4(2890), // Rule ID 5485 //
     /*   2782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   2785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2813 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2817 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2821 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2826 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2830 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2834 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   2838 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2842 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2847 */     // MIs[3] Operand 2
     /*   2847 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   2858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2862 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2864 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] })), rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLABT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   2864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABT),
     /*   2867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*   2873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   2877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   2879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2882 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2888 */     GIR_RootConstrainSelectedInstOperands,
     /*   2889 */     // GIR_Coverage, 5485,
     /*   2889 */     GIR_EraseRootFromParent_Done,
     /*   2890 */   // Label 108: @2890
     /*   2890 */   GIM_Try, /*On fail goto*//*Label 109*/ GIMT_Encode4(3003), // Rule ID 5447 //
     /*   2895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   2898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2910 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2914 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2918 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2922 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   2926 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2930 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2935 */     // MIs[2] Operand 2
     /*   2935 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   2946 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2950 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2954 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2958 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2962 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2967 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   2971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   2975 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2977 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 16:{ *:[i32] })), GPR:{ *:[i32] }:$Ra)  =>  (SMLABT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   2977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABT),
     /*   2980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   2986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   2992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2995 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3001 */     GIR_RootConstrainSelectedInstOperands,
     /*   3002 */     // GIR_Coverage, 5447,
     /*   3002 */     GIR_EraseRootFromParent_Done,
     /*   3003 */   // Label 109: @3003
     /*   3003 */   GIM_Try, /*On fail goto*//*Label 110*/ GIMT_Encode4(3116), // Rule ID 5484 //
     /*   3008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   3011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3027 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3031 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3035 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3039 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3043 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3048 */     // MIs[2] Operand 2
     /*   3048 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   3059 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3063 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   3067 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3071 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   3075 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3080 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   3084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3088 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3090 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] })), rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLABT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   3090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABT),
     /*   3093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   3105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3108 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3114 */     GIR_RootConstrainSelectedInstOperands,
     /*   3115 */     // GIR_Coverage, 5484,
     /*   3115 */     GIR_EraseRootFromParent_Done,
     /*   3116 */   // Label 110: @3116
     /*   3116 */   GIM_Try, /*On fail goto*//*Label 111*/ GIMT_Encode4(3229), // Rule ID 191 //
     /*   3121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   3124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3128 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   3132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3144 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3148 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3152 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   3156 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3160 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   3164 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3169 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   3173 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3177 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3181 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3185 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3190 */     // MIs[3] Operand 2
     /*   3190 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   3201 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3203 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i16:{ *:[Other] })))  =>  (SMLATB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   3203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLATB),
     /*   3206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3216 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   3218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3221 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3227 */     GIR_RootConstrainSelectedInstOperands,
     /*   3228 */     // GIR_Coverage, 191,
     /*   3228 */     GIR_EraseRootFromParent_Done,
     /*   3229 */   // Label 111: @3229
     /*   3229 */   GIM_Try, /*On fail goto*//*Label 112*/ GIMT_Encode4(3342), // Rule ID 520 //
     /*   3234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   3237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3257 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3265 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   3269 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3273 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   3277 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3282 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   3286 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3290 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3294 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3298 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3303 */     // MIs[3] Operand 2
     /*   3303 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   3314 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3316 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] })))  =>  (t2SMLATB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   3316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLATB),
     /*   3319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3329 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   3331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3334 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3340 */     GIR_RootConstrainSelectedInstOperands,
     /*   3341 */     // GIR_Coverage, 520,
     /*   3341 */     GIR_EraseRootFromParent_Done,
     /*   3342 */   // Label 112: @3342
     /*   3342 */   GIM_Try, /*On fail goto*//*Label 113*/ GIMT_Encode4(3455), // Rule ID 190 //
     /*   3347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   3350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   3358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3370 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3382 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3386 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3391 */     // MIs[2] Operand 2
     /*   3391 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   3402 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3406 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   3410 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3414 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   3418 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3423 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   3427 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3429 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 16:{ *:[i32] })))  =>  (SMLABT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   3429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABT),
     /*   3432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3442 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   3444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3447 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3453 */     GIR_RootConstrainSelectedInstOperands,
     /*   3454 */     // GIR_Coverage, 190,
     /*   3454 */     GIR_EraseRootFromParent_Done,
     /*   3455 */   // Label 113: @3455
     /*   3455 */   GIM_Try, /*On fail goto*//*Label 114*/ GIMT_Encode4(3568), // Rule ID 519 //
     /*   3460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   3463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3479 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3483 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3487 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3491 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3495 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3499 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3504 */     // MIs[2] Operand 2
     /*   3504 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   3515 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3519 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   3523 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3527 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   3531 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3536 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   3540 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3542 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] })))  =>  (t2SMLABT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   3542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABT),
     /*   3545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3547 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3555 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   3557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3560 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3566 */     GIR_RootConstrainSelectedInstOperands,
     /*   3567 */     // GIR_Coverage, 519,
     /*   3567 */     GIR_EraseRootFromParent_Done,
     /*   3568 */   // Label 114: @3568
     /*   3568 */   GIM_Try, /*On fail goto*//*Label 115*/ GIMT_Encode4(3659), // Rule ID 5679 //
     /*   3573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   3576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*   3600 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3604 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   3608 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3613 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*   3617 */     // MIs[1] Operand 2
     /*   3617 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   3628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3632 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3634 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } (rotr:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), i16:{ *:[Other] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   3634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   3637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   3641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   3645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   3648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3651 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3657 */     GIR_RootConstrainSelectedInstOperands,
     /*   3658 */     // GIR_Coverage, 5679,
     /*   3658 */     GIR_EraseRootFromParent_Done,
     /*   3659 */   // Label 115: @3659
     /*   3659 */   GIM_Try, /*On fail goto*//*Label 116*/ GIMT_Encode4(3750), // Rule ID 2105 //
     /*   3664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   3667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3671 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*   3695 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3699 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   3703 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3708 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*   3712 */     // MIs[1] Operand 2
     /*   3712 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   3723 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3725 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } (rotr:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), i16:{ *:[Other] }))  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   3725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   3728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3730 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   3732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   3736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   3739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3742 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3748 */     GIR_RootConstrainSelectedInstOperands,
     /*   3749 */     // GIR_Coverage, 2105,
     /*   3749 */     GIR_EraseRootFromParent_Done,
     /*   3750 */   // Label 116: @3750
     /*   3750 */   GIM_Try, /*On fail goto*//*Label 117*/ GIMT_Encode4(3866), // Rule ID 5446 //
     /*   3755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   3758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3774 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3782 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3786 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3790 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3795 */     // MIs[2] Operand 2
     /*   3795 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   3806 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3810 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3814 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3818 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3823 */     // MIs[3] Operand 2
     /*   3823 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   3834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   3838 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3840 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i16:{ *:[Other] })), GPR:{ *:[i32] }:$Ra)  =>  (SMLABB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   3840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABB),
     /*   3843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   3855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3858 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3864 */     GIR_RootConstrainSelectedInstOperands,
     /*   3865 */     // GIR_Coverage, 5446,
     /*   3865 */     GIR_EraseRootFromParent_Done,
     /*   3866 */   // Label 117: @3866
     /*   3866 */   GIM_Try, /*On fail goto*//*Label 118*/ GIMT_Encode4(3982), // Rule ID 5483 //
     /*   3871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   3874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3890 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3902 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3906 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3911 */     // MIs[2] Operand 2
     /*   3911 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   3922 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3926 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3930 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3934 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3939 */     // MIs[3] Operand 2
     /*   3939 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   3950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3954 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3956 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] })), rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLABB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   3956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABB),
     /*   3959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3965 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   3971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3974 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3980 */     GIR_RootConstrainSelectedInstOperands,
     /*   3981 */     // GIR_Coverage, 5483,
     /*   3981 */     GIR_EraseRootFromParent_Done,
     /*   3982 */   // Label 118: @3982
     /*   3982 */   GIM_Try, /*On fail goto*//*Label 119*/ GIMT_Encode4(4098), // Rule ID 189 //
     /*   3987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   3990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   3998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   4010 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   4014 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4018 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   4022 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   4026 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   4031 */     // MIs[2] Operand 2
     /*   4031 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   4042 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   4046 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   4050 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   4054 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   4059 */     // MIs[3] Operand 2
     /*   4059 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   4070 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4072 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i16:{ *:[Other] })))  =>  (SMLABB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   4072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABB),
     /*   4075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   4081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   4085 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   4087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4090 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4096 */     GIR_RootConstrainSelectedInstOperands,
     /*   4097 */     // GIR_Coverage, 189,
     /*   4097 */     GIR_EraseRootFromParent_Done,
     /*   4098 */   // Label 119: @4098
     /*   4098 */   GIM_Try, /*On fail goto*//*Label 120*/ GIMT_Encode4(4214), // Rule ID 518 //
     /*   4103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   4106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4110 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   4126 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   4130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4134 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   4138 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   4142 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4147 */     // MIs[2] Operand 2
     /*   4147 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   4158 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   4162 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   4166 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   4170 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4175 */     // MIs[3] Operand 2
     /*   4175 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   4186 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4188 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] })))  =>  (t2SMLABB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   4188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABB),
     /*   4191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   4197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   4201 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   4203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4206 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4212 */     GIR_RootConstrainSelectedInstOperands,
     /*   4213 */     // GIR_Coverage, 518,
     /*   4213 */     GIR_EraseRootFromParent_Done,
     /*   4214 */   // Label 120: @4214
     /*   4214 */   GIM_Try, /*On fail goto*//*Label 121*/ GIMT_Encode4(4302), // Rule ID 3248 //
     /*   4219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4246 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4250 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4254 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4259 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4268 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4270 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } (mul:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src1, MQPR:{ *:[v4i32] }:$src2)), tGPREven:{ *:[i32] }:$src3)  =>  (MVE_VMLADAVau32:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v4i32] }:$src1, ?:{ *:[v4i32] }:$src2)
     /*   4270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau32),
     /*   4273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4275 */     GIR_RootToRootCopy, /*OpIdx*/2, // src3
     /*   4277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4288 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4294 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4300 */     GIR_RootConstrainSelectedInstOperands,
     /*   4301 */     // GIR_Coverage, 3248,
     /*   4301 */     GIR_EraseRootFromParent_Done,
     /*   4302 */   // Label 121: @4302
     /*   4302 */   GIM_Try, /*On fail goto*//*Label 122*/ GIMT_Encode4(4390), // Rule ID 3249 //
     /*   4307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   4326 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4330 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4334 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   4338 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   4342 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4347 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4356 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4358 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } (mul:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, MQPR:{ *:[v8i16] }:$src2)), tGPREven:{ *:[i32] }:$src3)  =>  (MVE_VMLADAVau16:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v8i16] }:$src1, ?:{ *:[v8i16] }:$src2)
     /*   4358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau16),
     /*   4361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4363 */     GIR_RootToRootCopy, /*OpIdx*/2, // src3
     /*   4365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4376 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4382 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4388 */     GIR_RootConstrainSelectedInstOperands,
     /*   4389 */     // GIR_Coverage, 3249,
     /*   4389 */     GIR_EraseRootFromParent_Done,
     /*   4390 */   // Label 122: @4390
     /*   4390 */   GIM_Try, /*On fail goto*//*Label 123*/ GIMT_Encode4(4478), // Rule ID 3252 //
     /*   4395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   4414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4422 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   4426 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*   4430 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4435 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4444 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4446 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } (mul:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src1, MQPR:{ *:[v16i8] }:$src2)), tGPREven:{ *:[i32] }:$src3)  =>  (MVE_VMLADAVau8:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v16i8] }:$src1, ?:{ *:[v16i8] }:$src2)
     /*   4446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau8),
     /*   4449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4451 */     GIR_RootToRootCopy, /*OpIdx*/2, // src3
     /*   4453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4464 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4470 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4476 */     GIR_RootConstrainSelectedInstOperands,
     /*   4477 */     // GIR_Coverage, 3252,
     /*   4477 */     GIR_EraseRootFromParent_Done,
     /*   4478 */   // Label 123: @4478
     /*   4478 */   GIM_Try, /*On fail goto*//*Label 124*/ GIMT_Encode4(4566), // Rule ID 5950 //
     /*   4483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4506 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4510 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4514 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4518 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4522 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4527 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4532 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4534 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$src3, (vecreduce_add:{ *:[i32] } (mul:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src1, MQPR:{ *:[v4i32] }:$src2)))  =>  (MVE_VMLADAVau32:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v4i32] }:$src1, ?:{ *:[v4i32] }:$src2)
     /*   4534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau32),
     /*   4537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4539 */     GIR_RootToRootCopy, /*OpIdx*/1, // src3
     /*   4541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4552 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4558 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4564 */     GIR_RootConstrainSelectedInstOperands,
     /*   4565 */     // GIR_Coverage, 5950,
     /*   4565 */     GIR_EraseRootFromParent_Done,
     /*   4566 */   // Label 124: @4566
     /*   4566 */   GIM_Try, /*On fail goto*//*Label 125*/ GIMT_Encode4(4654), // Rule ID 5951 //
     /*   4571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4590 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   4594 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4598 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4602 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   4606 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   4610 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4615 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4620 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4622 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$src3, (vecreduce_add:{ *:[i32] } (mul:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, MQPR:{ *:[v8i16] }:$src2)))  =>  (MVE_VMLADAVau16:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v8i16] }:$src1, ?:{ *:[v8i16] }:$src2)
     /*   4622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau16),
     /*   4625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4627 */     GIR_RootToRootCopy, /*OpIdx*/1, // src3
     /*   4629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4640 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4646 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4652 */     GIR_RootConstrainSelectedInstOperands,
     /*   4653 */     // GIR_Coverage, 5951,
     /*   4653 */     GIR_EraseRootFromParent_Done,
     /*   4654 */   // Label 125: @4654
     /*   4654 */   GIM_Try, /*On fail goto*//*Label 126*/ GIMT_Encode4(4742), // Rule ID 5954 //
     /*   4659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   4682 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4686 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4690 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   4694 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*   4698 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4703 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4708 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4710 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$src3, (vecreduce_add:{ *:[i32] } (mul:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src1, MQPR:{ *:[v16i8] }:$src2)))  =>  (MVE_VMLADAVau8:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v16i8] }:$src1, ?:{ *:[v16i8] }:$src2)
     /*   4710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau8),
     /*   4713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4715 */     GIR_RootToRootCopy, /*OpIdx*/1, // src3
     /*   4717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4728 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4734 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4740 */     GIR_RootConstrainSelectedInstOperands,
     /*   4741 */     // GIR_Coverage, 5954,
     /*   4741 */     GIR_EraseRootFromParent_Done,
     /*   4742 */   // Label 126: @4742
     /*   4742 */   GIM_Try, /*On fail goto*//*Label 127*/ GIMT_Encode4(4799), // Rule ID 72 //
     /*   4747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*   4750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   4754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   4758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   4766 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*   4770 */     // MIs[1] Operand 1
     /*   4770 */     // No operand predicates
     /*   4770 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4772 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm)  =>  (ADDri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*   4772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ADDri),
     /*   4775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4777 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4779 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*   4782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4785 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4791 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4797 */     GIR_RootConstrainSelectedInstOperands,
     /*   4798 */     // GIR_Coverage, 72,
     /*   4798 */     GIR_EraseRootFromParent_Done,
     /*   4799 */   // Label 127: @4799
     /*   4799 */   GIM_Try, /*On fail goto*//*Label 128*/ GIMT_Encode4(4856), // Rule ID 303 //
     /*   4804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*   4807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   4811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   4815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   4823 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /*   4827 */     // MIs[1] Operand 1
     /*   4827 */     // No operand predicates
     /*   4827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4829 */     // (add:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm3)  =>  (tADDi3:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$imm3)
     /*   4829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tADDi3),
     /*   4832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4834 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*   4840 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*   4842 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm3
     /*   4845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4848 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4854 */     GIR_RootConstrainSelectedInstOperands,
     /*   4855 */     // GIR_Coverage, 303,
     /*   4855 */     GIR_EraseRootFromParent_Done,
     /*   4856 */   // Label 128: @4856
     /*   4856 */   GIM_Try, /*On fail goto*//*Label 129*/ GIMT_Encode4(4913), // Rule ID 304 //
     /*   4861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*   4864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   4868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   4872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   4880 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_255_expr),
     /*   4884 */     // MIs[1] Operand 1
     /*   4884 */     // No operand predicates
     /*   4884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4886 */     // (add:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_imm0_255_expr>>:$imm8)  =>  (tADDi8:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm8)
     /*   4886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tADDi8),
     /*   4889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   4891 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*   4897 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm8
     /*   4902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4905 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4911 */     GIR_RootConstrainSelectedInstOperands,
     /*   4912 */     // GIR_Coverage, 304,
     /*   4912 */     GIR_EraseRootFromParent_Done,
     /*   4913 */   // Label 129: @4913
     /*   4913 */   GIM_Try, /*On fail goto*//*Label 130*/ GIMT_Encode4(4970), // Rule ID 407 //
     /*   4918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*   4921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   4929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   4937 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*   4941 */     // MIs[1] Operand 1
     /*   4941 */     // No operand predicates
     /*   4941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4943 */     // (add:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2ADDri:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*   4943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ADDri),
     /*   4946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4948 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4950 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*   4953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4956 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4962 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4968 */     GIR_RootConstrainSelectedInstOperands,
     /*   4969 */     // GIR_Coverage, 407,
     /*   4969 */     GIR_EraseRootFromParent_Done,
     /*   4970 */   // Label 130: @4970
     /*   4970 */   GIM_Try, /*On fail goto*//*Label 131*/ GIMT_Encode4(5021), // Rule ID 408 //
     /*   4975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*   4978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   4986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   4994 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_4095),
     /*   4998 */     // MIs[1] Operand 1
     /*   4998 */     // No operand predicates
     /*   4998 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5000 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_imm0_4095>>:$imm)  =>  (t2ADDri12:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*   5000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ADDri12),
     /*   5003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5005 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   5007 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*   5010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5013 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5019 */     GIR_RootConstrainSelectedInstOperands,
     /*   5020 */     // GIR_Coverage, 408,
     /*   5020 */     GIR_EraseRootFromParent_Done,
     /*   5021 */   // Label 131: @5021
     /*   5021 */   GIM_Try, /*On fail goto*//*Label 132*/ GIMT_Encode4(5097), // Rule ID 171 //
     /*   5026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM_UseMulOps),
     /*   5029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5041 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5045 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5049 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5054 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5065 */     // (add:{ *:[i32] } (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm), GPRnopc:{ *:[i32] }:$Ra)  =>  (MLA:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*   5065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MLA),
     /*   5068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5083 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5089 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5095 */     GIR_RootConstrainSelectedInstOperands,
     /*   5096 */     // GIR_Coverage, 171,
     /*   5096 */     GIR_EraseRootFromParent_Done,
     /*   5097 */   // Label 132: @5097
     /*   5097 */   GIM_Try, /*On fail goto*//*Label 133*/ GIMT_Encode4(5173), // Rule ID 172 //
     /*   5102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_NoV6),
     /*   5105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5121 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5125 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5130 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5141 */     // (add:{ *:[i32] } (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm), GPRnopc:{ *:[i32] }:$Ra)  =>  (MLAv5:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*   5141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MLAv5),
     /*   5144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5154 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5159 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5165 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5171 */     GIR_RootConstrainSelectedInstOperands,
     /*   5172 */     // GIR_Coverage, 172,
     /*   5172 */     GIR_EraseRootFromParent_Done,
     /*   5173 */   // Label 133: @5173
     /*   5173 */   GIM_Try, /*On fail goto*//*Label 134*/ GIMT_Encode4(5243), // Rule ID 503 //
     /*   5178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_UseMulOps),
     /*   5181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5197 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5201 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5217 */     // (add:{ *:[i32] } (mul:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm), rGPR:{ *:[i32] }:$Ra)  =>  (t2MLA:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   5217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MLA),
     /*   5220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5230 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5235 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5241 */     GIR_RootConstrainSelectedInstOperands,
     /*   5242 */     // GIR_Coverage, 503,
     /*   5242 */     GIR_EraseRootFromParent_Done,
     /*   5243 */   // Label 134: @5243
     /*   5243 */   GIM_Try, /*On fail goto*//*Label 135*/ GIMT_Encode4(5314), // Rule ID 5672 //
     /*   5248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   5251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   5263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5267 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5272 */     // MIs[1] Operand 2
     /*   5272 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /*   5283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5289 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i8:{ *:[Other] }), GPR:{ *:[i32] }:$Rn)  =>  (SXTAB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   5289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTAB),
     /*   5292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   5296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   5300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5306 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5312 */     GIR_RootConstrainSelectedInstOperands,
     /*   5313 */     // GIR_Coverage, 5672,
     /*   5313 */     GIR_EraseRootFromParent_Done,
     /*   5314 */   // Label 135: @5314
     /*   5314 */   GIM_Try, /*On fail goto*//*Label 136*/ GIMT_Encode4(5385), // Rule ID 5673 //
     /*   5319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   5322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   5334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5338 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5343 */     // MIs[1] Operand 2
     /*   5343 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   5354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5360 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i16:{ *:[Other] }), GPR:{ *:[i32] }:$Rn)  =>  (SXTAH:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   5360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTAH),
     /*   5363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   5367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   5371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5377 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5383 */     GIR_RootConstrainSelectedInstOperands,
     /*   5384 */     // GIR_Coverage, 5673,
     /*   5384 */     GIR_EraseRootFromParent_Done,
     /*   5385 */   // Label 136: @5385
     /*   5385 */   GIM_Try, /*On fail goto*//*Label 137*/ GIMT_Encode4(5456), // Rule ID 5707 //
     /*   5390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   5393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   5405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5409 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5414 */     // MIs[1] Operand 2
     /*   5414 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /*   5425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5431 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i8:{ *:[Other] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTAB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   5431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAB),
     /*   5434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   5438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   5442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5448 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5454 */     GIR_RootConstrainSelectedInstOperands,
     /*   5455 */     // GIR_Coverage, 5707,
     /*   5455 */     GIR_EraseRootFromParent_Done,
     /*   5456 */   // Label 137: @5456
     /*   5456 */   GIM_Try, /*On fail goto*//*Label 138*/ GIMT_Encode4(5527), // Rule ID 5708 //
     /*   5461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   5464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   5476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5480 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5485 */     // MIs[1] Operand 2
     /*   5485 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   5496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5502 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   5502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   5505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   5509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   5513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5519 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5525 */     GIR_RootConstrainSelectedInstOperands,
     /*   5526 */     // GIR_Coverage, 5708,
     /*   5526 */     GIR_EraseRootFromParent_Done,
     /*   5527 */   // Label 138: @5527
     /*   5527 */   GIM_Try, /*On fail goto*//*Label 139*/ GIMT_Encode4(5597), // Rule ID 180 //
     /*   5532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM_UseMulOps),
     /*   5535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMULH),
     /*   5547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5551 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5555 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5560 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5569 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5571 */     // (add:{ *:[i32] } (mulhs:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm), GPR:{ *:[i32] }:$Ra)  =>  (SMMLA:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   5571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMMLA),
     /*   5574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5589 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5595 */     GIR_RootConstrainSelectedInstOperands,
     /*   5596 */     // GIR_Coverage, 180,
     /*   5596 */     GIR_EraseRootFromParent_Done,
     /*   5597 */   // Label 139: @5597
     /*   5597 */   GIM_Try, /*On fail goto*//*Label 140*/ GIMT_Encode4(5667), // Rule ID 509 //
     /*   5602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   5605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMULH),
     /*   5617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5621 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5625 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5630 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5641 */     // (add:{ *:[i32] } (mulhs:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn), rGPR:{ *:[i32] }:$Ra)  =>  (t2SMMLA:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   5641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMMLA),
     /*   5644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*   5650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   5654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5659 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5665 */     GIR_RootConstrainSelectedInstOperands,
     /*   5666 */     // GIR_Coverage, 509,
     /*   5666 */     GIR_EraseRootFromParent_Done,
     /*   5667 */   // Label 140: @5667
     /*   5667 */   GIM_Try, /*On fail goto*//*Label 141*/ GIMT_Encode4(5730), // Rule ID 3053 //
     /*   5672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   5675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   5687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   5691 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   5696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5700 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5702 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } MQPR:{ *:[v16i8] }:$vec), tGPREven:{ *:[i32] }:$acc)  =>  (MVE_VADDVu8acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v16i8] }:$vec)
     /*   5702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu8acc),
     /*   5705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   5707 */     GIR_RootToRootCopy, /*OpIdx*/2, // acc
     /*   5709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   5713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5716 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5722 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5728 */     GIR_RootConstrainSelectedInstOperands,
     /*   5729 */     // GIR_Coverage, 3053,
     /*   5729 */     GIR_EraseRootFromParent_Done,
     /*   5730 */   // Label 141: @5730
     /*   5730 */   GIM_Try, /*On fail goto*//*Label 142*/ GIMT_Encode4(5793), // Rule ID 3081 //
     /*   5735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   5738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   5750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   5754 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   5759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5765 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } MQPR:{ *:[v8i16] }:$vec), tGPREven:{ *:[i32] }:$acc)  =>  (MVE_VADDVu16acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v8i16] }:$vec)
     /*   5765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu16acc),
     /*   5768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   5770 */     GIR_RootToRootCopy, /*OpIdx*/2, // acc
     /*   5772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   5776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5779 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5785 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5791 */     GIR_RootConstrainSelectedInstOperands,
     /*   5792 */     // GIR_Coverage, 3081,
     /*   5792 */     GIR_EraseRootFromParent_Done,
     /*   5793 */   // Label 142: @5793
     /*   5793 */   GIM_Try, /*On fail goto*//*Label 143*/ GIMT_Encode4(5856), // Rule ID 3091 //
     /*   5798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   5801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   5813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5817 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   5822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5826 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5828 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } MQPR:{ *:[v4i32] }:$vec), tGPREven:{ *:[i32] }:$acc)  =>  (MVE_VADDVu32acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v4i32] }:$vec)
     /*   5828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu32acc),
     /*   5831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   5833 */     GIR_RootToRootCopy, /*OpIdx*/2, // acc
     /*   5835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   5839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5842 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5848 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5854 */     GIR_RootConstrainSelectedInstOperands,
     /*   5855 */     // GIR_Coverage, 3091,
     /*   5855 */     GIR_EraseRootFromParent_Done,
     /*   5856 */   // Label 143: @5856
     /*   5856 */   GIM_Try, /*On fail goto*//*Label 144*/ GIMT_Encode4(5932), // Rule ID 5443 //
     /*   5861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM_UseMulOps),
     /*   5864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5884 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5888 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5893 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5898 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5900 */     // (add:{ *:[i32] } GPRnopc:{ *:[i32] }:$Ra, (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm))  =>  (MLA:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*   5900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MLA),
     /*   5903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5913 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   5915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5918 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5924 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5930 */     GIR_RootConstrainSelectedInstOperands,
     /*   5931 */     // GIR_Coverage, 5443,
     /*   5931 */     GIR_EraseRootFromParent_Done,
     /*   5932 */   // Label 144: @5932
     /*   5932 */   GIM_Try, /*On fail goto*//*Label 145*/ GIMT_Encode4(6008), // Rule ID 5444 //
     /*   5937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_NoV6),
     /*   5940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5960 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5964 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5969 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5976 */     // (add:{ *:[i32] } GPRnopc:{ *:[i32] }:$Ra, (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm))  =>  (MLAv5:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*   5976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MLAv5),
     /*   5979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5989 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   5991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5994 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6000 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6006 */     GIR_RootConstrainSelectedInstOperands,
     /*   6007 */     // GIR_Coverage, 5444,
     /*   6007 */     GIR_EraseRootFromParent_Done,
     /*   6008 */   // Label 145: @6008
     /*   6008 */   GIM_Try, /*On fail goto*//*Label 146*/ GIMT_Encode4(6078), // Rule ID 5481 //
     /*   6013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_UseMulOps),
     /*   6016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   6032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6036 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   6040 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6045 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6052 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm))  =>  (t2MLA:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   6052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MLA),
     /*   6055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   6061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   6065 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   6067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6070 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6076 */     GIR_RootConstrainSelectedInstOperands,
     /*   6077 */     // GIR_Coverage, 5481,
     /*   6077 */     GIR_EraseRootFromParent_Done,
     /*   6078 */   // Label 146: @6078
     /*   6078 */   GIM_Try, /*On fail goto*//*Label 147*/ GIMT_Encode4(6149), // Rule ID 2004 //
     /*   6083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   6086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   6102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6106 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6111 */     // MIs[1] Operand 2
     /*   6111 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /*   6122 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6124 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i8:{ *:[Other] }))  =>  (SXTAB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   6124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTAB),
     /*   6127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6129 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   6135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6141 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6147 */     GIR_RootConstrainSelectedInstOperands,
     /*   6148 */     // GIR_Coverage, 2004,
     /*   6148 */     GIR_EraseRootFromParent_Done,
     /*   6149 */   // Label 147: @6149
     /*   6149 */   GIM_Try, /*On fail goto*//*Label 148*/ GIMT_Encode4(6220), // Rule ID 2005 //
     /*   6154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   6157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6161 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   6173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6177 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6182 */     // MIs[1] Operand 2
     /*   6182 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   6193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6195 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (SXTAH:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   6195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTAH),
     /*   6198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6200 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   6206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6212 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6218 */     GIR_RootConstrainSelectedInstOperands,
     /*   6219 */     // GIR_Coverage, 2005,
     /*   6219 */     GIR_EraseRootFromParent_Done,
     /*   6220 */   // Label 148: @6220
     /*   6220 */   GIM_Try, /*On fail goto*//*Label 149*/ GIMT_Encode4(6291), // Rule ID 2243 //
     /*   6225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   6228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   6244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6248 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6253 */     // MIs[1] Operand 2
     /*   6253 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /*   6264 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6266 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i8:{ *:[Other] }))  =>  (t2SXTAB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   6266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAB),
     /*   6269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6271 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   6277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6283 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6289 */     GIR_RootConstrainSelectedInstOperands,
     /*   6290 */     // GIR_Coverage, 2243,
     /*   6290 */     GIR_EraseRootFromParent_Done,
     /*   6291 */   // Label 149: @6291
     /*   6291 */   GIM_Try, /*On fail goto*//*Label 150*/ GIMT_Encode4(6362), // Rule ID 2244 //
     /*   6296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   6299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6303 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   6315 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6319 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6324 */     // MIs[1] Operand 2
     /*   6324 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   6335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6337 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   6337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   6340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6342 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   6348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6354 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6360 */     GIR_RootConstrainSelectedInstOperands,
     /*   6361 */     // GIR_Coverage, 2244,
     /*   6361 */     GIR_EraseRootFromParent_Done,
     /*   6362 */   // Label 150: @6362
     /*   6362 */   GIM_Try, /*On fail goto*//*Label 151*/ GIMT_Encode4(6432), // Rule ID 5445 //
     /*   6367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM_UseMulOps),
     /*   6370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMULH),
     /*   6386 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6390 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   6394 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6399 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6406 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mulhs:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm))  =>  (SMMLA:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   6406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMMLA),
     /*   6409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   6415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   6419 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   6421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6424 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6430 */     GIR_RootConstrainSelectedInstOperands,
     /*   6431 */     // GIR_Coverage, 5445,
     /*   6431 */     GIR_EraseRootFromParent_Done,
     /*   6432 */   // Label 151: @6432
     /*   6432 */   GIM_Try, /*On fail goto*//*Label 152*/ GIMT_Encode4(6502), // Rule ID 5482 //
     /*   6437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   6440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMULH),
     /*   6456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6460 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   6464 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6469 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6474 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6476 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mulhs:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn))  =>  (t2SMMLA:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   6476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMMLA),
     /*   6479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*   6485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   6489 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   6491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6494 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6500 */     GIR_RootConstrainSelectedInstOperands,
     /*   6501 */     // GIR_Coverage, 5482,
     /*   6501 */     GIR_EraseRootFromParent_Done,
     /*   6502 */   // Label 152: @6502
     /*   6502 */   GIM_Try, /*On fail goto*//*Label 153*/ GIMT_Encode4(6565), // Rule ID 5926 //
     /*   6507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   6510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   6526 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   6530 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   6535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6537 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$acc, (vecreduce_add:{ *:[i32] } MQPR:{ *:[v16i8] }:$vec))  =>  (MVE_VADDVu8acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v16i8] }:$vec)
     /*   6537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu8acc),
     /*   6540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   6542 */     GIR_RootToRootCopy, /*OpIdx*/1, // acc
     /*   6544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   6548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6551 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6557 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6563 */     GIR_RootConstrainSelectedInstOperands,
     /*   6564 */     // GIR_Coverage, 5926,
     /*   6564 */     GIR_EraseRootFromParent_Done,
     /*   6565 */   // Label 153: @6565
     /*   6565 */   GIM_Try, /*On fail goto*//*Label 154*/ GIMT_Encode4(6628), // Rule ID 5940 //
     /*   6570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   6573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   6589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   6593 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   6598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6600 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$acc, (vecreduce_add:{ *:[i32] } MQPR:{ *:[v8i16] }:$vec))  =>  (MVE_VADDVu16acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v8i16] }:$vec)
     /*   6600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu16acc),
     /*   6603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   6605 */     GIR_RootToRootCopy, /*OpIdx*/1, // acc
     /*   6607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   6611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6614 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6620 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6626 */     GIR_RootConstrainSelectedInstOperands,
     /*   6627 */     // GIR_Coverage, 5940,
     /*   6627 */     GIR_EraseRootFromParent_Done,
     /*   6628 */   // Label 154: @6628
     /*   6628 */   GIM_Try, /*On fail goto*//*Label 155*/ GIMT_Encode4(6691), // Rule ID 5945 //
     /*   6633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   6636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   6652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6656 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   6661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6663 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$acc, (vecreduce_add:{ *:[i32] } MQPR:{ *:[v4i32] }:$vec))  =>  (MVE_VADDVu32acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v4i32] }:$vec)
     /*   6663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu32acc),
     /*   6666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   6668 */     GIR_RootToRootCopy, /*OpIdx*/1, // acc
     /*   6670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   6674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6677 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6683 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6689 */     GIR_RootConstrainSelectedInstOperands,
     /*   6690 */     // GIR_Coverage, 5945,
     /*   6690 */     GIR_EraseRootFromParent_Done,
     /*   6691 */   // Label 155: @6691
     /*   6691 */   GIM_Try, /*On fail goto*//*Label 156*/ GIMT_Encode4(6737), // Rule ID 73 //
     /*   6696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*   6699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6711 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (ADDrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*   6711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ADDrr),
     /*   6714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6716 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*   6720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6723 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6729 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6735 */     GIR_RootConstrainSelectedInstOperands,
     /*   6736 */     // GIR_Coverage, 73,
     /*   6736 */     GIR_EraseRootFromParent_Done,
     /*   6737 */   // Label 156: @6737
     /*   6737 */   GIM_Try, /*On fail goto*//*Label 157*/ GIMT_Encode4(6783), // Rule ID 305 //
     /*   6742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*   6745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   6749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   6753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   6757 */     // (add:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tADDrr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*   6757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tADDrr),
     /*   6760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6762 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*   6768 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*   6772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6775 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6781 */     GIR_RootConstrainSelectedInstOperands,
     /*   6782 */     // GIR_Coverage, 305,
     /*   6782 */     GIR_EraseRootFromParent_Done,
     /*   6783 */   // Label 157: @6783
     /*   6783 */   GIM_Try, /*On fail goto*//*Label 158*/ GIMT_Encode4(6829), // Rule ID 409 //
     /*   6788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*   6791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6803 */     // (add:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2ADDrr:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*   6803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ADDrr),
     /*   6806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6808 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*   6812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6815 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6821 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6827 */     GIR_RootConstrainSelectedInstOperands,
     /*   6828 */     // GIR_Coverage, 409,
     /*   6828 */     GIR_EraseRootFromParent_Done,
     /*   6829 */   // Label 158: @6829
     /*   6829 */   GIM_Try, /*On fail goto*//*Label 159*/ GIMT_Encode4(6875), // Rule ID 5463 //
     /*   6834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*   6837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6849 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)  =>  (t2ADDrr:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*   6849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ADDrr),
     /*   6852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   6856 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*   6858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6861 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6867 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6873 */     GIR_RootConstrainSelectedInstOperands,
     /*   6874 */     // GIR_Coverage, 5463,
     /*   6874 */     GIR_EraseRootFromParent_Done,
     /*   6875 */   // Label 159: @6875
     /*   6875 */   GIM_Reject,
     /*   6876 */ // Label 90: @6876
     /*   6876 */ GIM_Reject,
     /*   6877 */ // Label 81: @6877
     /*   6877 */ GIM_Try, /*On fail goto*//*Label 160*/ GIMT_Encode4(6923), // Rule ID 762 //
     /*   6882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   6885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   6888 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   6891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6895 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6899 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6903 */   // (add:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VADDv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /*   6903 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv1i64),
     /*   6906 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   6908 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   6910 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   6912 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6915 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6921 */   GIR_RootConstrainSelectedInstOperands,
     /*   6922 */   // GIR_Coverage, 762,
     /*   6922 */   GIR_EraseRootFromParent_Done,
     /*   6923 */ // Label 160: @6923
     /*   6923 */ GIM_Reject,
     /*   6924 */ // Label 82: @6924
     /*   6924 */ GIM_Try, /*On fail goto*//*Label 161*/ GIMT_Encode4(7108),
     /*   6929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6932 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   6935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6939 */   GIM_Try, /*On fail goto*//*Label 162*/ GIMT_Encode4(7005), // Rule ID 5532 //
     /*   6944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   6947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   6955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6959 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   6963 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6968 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6977 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6979 */     // (add:{ *:[v2i32] } (mul:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm), DPR:{ *:[v2i32] }:$src1)  =>  (VMLAv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   6979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv2i32),
     /*   6982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   6984 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   6986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   6990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   6994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6997 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7003 */     GIR_RootConstrainSelectedInstOperands,
     /*   7004 */     // GIR_Coverage, 5532,
     /*   7004 */     GIR_EraseRootFromParent_Done,
     /*   7005 */   // Label 162: @7005
     /*   7005 */   GIM_Try, /*On fail goto*//*Label 163*/ GIMT_Encode4(7071), // Rule ID 889 //
     /*   7010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7029 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   7033 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7038 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7045 */     // (add:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, (mul:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm))  =>  (VMLAv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv2i32),
     /*   7048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7050 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   7060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7063 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7069 */     GIR_RootConstrainSelectedInstOperands,
     /*   7070 */     // GIR_Coverage, 889,
     /*   7070 */     GIR_EraseRootFromParent_Done,
     /*   7071 */   // Label 163: @7071
     /*   7071 */   GIM_Try, /*On fail goto*//*Label 164*/ GIMT_Encode4(7107), // Rule ID 758 //
     /*   7076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7087 */     // (add:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VADDv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv2i32),
     /*   7090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7092 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   7096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7099 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7105 */     GIR_RootConstrainSelectedInstOperands,
     /*   7106 */     // GIR_Coverage, 758,
     /*   7106 */     GIR_EraseRootFromParent_Done,
     /*   7107 */   // Label 164: @7107
     /*   7107 */   GIM_Reject,
     /*   7108 */ // Label 161: @7108
     /*   7108 */ GIM_Reject,
     /*   7109 */ // Label 83: @7109
     /*   7109 */ GIM_Try, /*On fail goto*//*Label 165*/ GIMT_Encode4(7819),
     /*   7114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   7117 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*   7120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7124 */   GIM_Try, /*On fail goto*//*Label 166*/ GIMT_Encode4(7192), // Rule ID 782 //
     /*   7129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7144 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7149 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7153 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7157 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7161 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7166 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7168 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv2i64),
     /*   7171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   7181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7184 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7190 */     GIR_RootConstrainSelectedInstOperands,
     /*   7191 */     // GIR_Coverage, 782,
     /*   7191 */     GIR_EraseRootFromParent_Done,
     /*   7192 */   // Label 166: @7192
     /*   7192 */   GIM_Try, /*On fail goto*//*Label 167*/ GIMT_Encode4(7260), // Rule ID 781 //
     /*   7197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7208 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7212 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7225 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7229 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7234 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7236 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv2i64),
     /*   7239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   7249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7252 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7258 */     GIR_RootConstrainSelectedInstOperands,
     /*   7259 */     // GIR_Coverage, 781,
     /*   7259 */     GIR_EraseRootFromParent_Done,
     /*   7260 */   // Label 167: @7260
     /*   7260 */   GIM_Try, /*On fail goto*//*Label 168*/ GIMT_Encode4(7328), // Rule ID 770 //
     /*   7265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7280 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7285 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7289 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7293 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7297 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7302 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7304 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDLsv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLsv2i64),
     /*   7307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   7317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7320 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7326 */     GIR_RootConstrainSelectedInstOperands,
     /*   7327 */     // GIR_Coverage, 770,
     /*   7327 */     GIR_EraseRootFromParent_Done,
     /*   7328 */   // Label 168: @7328
     /*   7328 */   GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(7396), // Rule ID 780 //
     /*   7333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7348 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7353 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7357 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7361 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7365 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7370 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7372 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv2i64),
     /*   7375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   7385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7388 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7394 */     GIR_RootConstrainSelectedInstOperands,
     /*   7395 */     // GIR_Coverage, 780,
     /*   7395 */     GIR_EraseRootFromParent_Done,
     /*   7396 */   // Label 169: @7396
     /*   7396 */   GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(7464), // Rule ID 779 //
     /*   7401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7412 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7416 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7421 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7425 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7429 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7433 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7438 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7440 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv2i64),
     /*   7443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   7453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7456 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7462 */     GIR_RootConstrainSelectedInstOperands,
     /*   7463 */     // GIR_Coverage, 779,
     /*   7463 */     GIR_EraseRootFromParent_Done,
     /*   7464 */   // Label 170: @7464
     /*   7464 */   GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(7517), // Rule ID 5511 //
     /*   7469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7484 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7495 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm), QPR:{ *:[v2i64] }:$Vn)  =>  (VADDWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv2i64),
     /*   7498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   7502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7509 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7515 */     GIR_RootConstrainSelectedInstOperands,
     /*   7516 */     // GIR_Coverage, 5511,
     /*   7516 */     GIR_EraseRootFromParent_Done,
     /*   7517 */   // Label 171: @7517
     /*   7517 */   GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(7570), // Rule ID 5505 //
     /*   7522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7537 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7546 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7548 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm), QPR:{ *:[v2i64] }:$Vn)  =>  (VADDWsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv2i64),
     /*   7551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   7555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7562 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7568 */     GIR_RootConstrainSelectedInstOperands,
     /*   7569 */     // GIR_Coverage, 5505,
     /*   7569 */     GIR_EraseRootFromParent_Done,
     /*   7570 */   // Label 172: @7570
     /*   7570 */   GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(7623), // Rule ID 5510 //
     /*   7575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7590 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7601 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm), QPR:{ *:[v2i64] }:$Vn)  =>  (VADDWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv2i64),
     /*   7604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   7608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7615 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7621 */     GIR_RootConstrainSelectedInstOperands,
     /*   7622 */     // GIR_Coverage, 5510,
     /*   7622 */     GIR_EraseRootFromParent_Done,
     /*   7623 */   // Label 173: @7623
     /*   7623 */   GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(7676), // Rule ID 791 //
     /*   7628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7647 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7652 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7654 */     // (add:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv2i64),
     /*   7657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7659 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7668 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7674 */     GIR_RootConstrainSelectedInstOperands,
     /*   7675 */     // GIR_Coverage, 791,
     /*   7675 */     GIR_EraseRootFromParent_Done,
     /*   7676 */   // Label 174: @7676
     /*   7676 */   GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(7729), // Rule ID 785 //
     /*   7681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7700 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7707 */     // (add:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDWsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv2i64),
     /*   7710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7712 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7721 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7727 */     GIR_RootConstrainSelectedInstOperands,
     /*   7728 */     // GIR_Coverage, 785,
     /*   7728 */     GIR_EraseRootFromParent_Done,
     /*   7729 */   // Label 175: @7729
     /*   7729 */   GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(7782), // Rule ID 790 //
     /*   7734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7753 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7758 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7760 */     // (add:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv2i64),
     /*   7763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7765 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7774 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7780 */     GIR_RootConstrainSelectedInstOperands,
     /*   7781 */     // GIR_Coverage, 790,
     /*   7781 */     GIR_EraseRootFromParent_Done,
     /*   7782 */   // Label 176: @7782
     /*   7782 */   GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(7818), // Rule ID 763 //
     /*   7787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7798 */     // (add:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VADDv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /*   7798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv2i64),
     /*   7801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7803 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   7807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7810 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7816 */     GIR_RootConstrainSelectedInstOperands,
     /*   7817 */     // GIR_Coverage, 763,
     /*   7817 */     GIR_EraseRootFromParent_Done,
     /*   7818 */   // Label 177: @7818
     /*   7818 */   GIM_Reject,
     /*   7819 */ // Label 165: @7819
     /*   7819 */ GIM_Reject,
     /*   7820 */ // Label 84: @7820
     /*   7820 */ GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(8004),
     /*   7825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   7828 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*   7831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7835 */   GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(7901), // Rule ID 5531 //
     /*   7840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   7855 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*   7859 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7864 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7875 */     // (add:{ *:[v4i16] } (mul:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm), DPR:{ *:[v4i16] }:$src1)  =>  (VMLAv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   7875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv4i16),
     /*   7878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7880 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   7882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   7890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7893 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7899 */     GIR_RootConstrainSelectedInstOperands,
     /*   7900 */     // GIR_Coverage, 5531,
     /*   7900 */     GIR_EraseRootFromParent_Done,
     /*   7901 */   // Label 179: @7901
     /*   7901 */   GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(7967), // Rule ID 888 //
     /*   7906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   7925 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*   7929 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7934 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7941 */     // (add:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, (mul:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm))  =>  (VMLAv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   7941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv4i16),
     /*   7944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7946 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   7956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7959 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7965 */     GIR_RootConstrainSelectedInstOperands,
     /*   7966 */     // GIR_Coverage, 888,
     /*   7966 */     GIR_EraseRootFromParent_Done,
     /*   7967 */   // Label 180: @7967
     /*   7967 */   GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(8003), // Rule ID 757 //
     /*   7972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7983 */     // (add:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VADDv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   7983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv4i16),
     /*   7986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7988 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   7992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7995 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8001 */     GIR_RootConstrainSelectedInstOperands,
     /*   8002 */     // GIR_Coverage, 757,
     /*   8002 */     GIR_EraseRootFromParent_Done,
     /*   8003 */   // Label 181: @8003
     /*   8003 */   GIM_Reject,
     /*   8004 */ // Label 178: @8004
     /*   8004 */ GIM_Reject,
     /*   8005 */ // Label 85: @8005
     /*   8005 */ GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(8960),
     /*   8010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8013 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8016 */   GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(8088), // Rule ID 778 //
     /*   8021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8040 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8045 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   8049 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8053 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8057 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8062 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8064 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv4i32),
     /*   8067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   8077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8080 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8086 */     GIR_RootConstrainSelectedInstOperands,
     /*   8087 */     // GIR_Coverage, 778,
     /*   8087 */     GIR_EraseRootFromParent_Done,
     /*   8088 */   // Label 183: @8088
     /*   8088 */   GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(8160), // Rule ID 777 //
     /*   8093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8112 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   8121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8125 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8129 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8134 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8136 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv4i32),
     /*   8139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   8149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8152 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8158 */     GIR_RootConstrainSelectedInstOperands,
     /*   8159 */     // GIR_Coverage, 777,
     /*   8159 */     GIR_EraseRootFromParent_Done,
     /*   8160 */   // Label 184: @8160
     /*   8160 */   GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(8232), // Rule ID 769 //
     /*   8165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8184 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8189 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   8193 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8197 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8201 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8206 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8208 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDLsv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLsv4i32),
     /*   8211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   8221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8224 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8230 */     GIR_RootConstrainSelectedInstOperands,
     /*   8231 */     // GIR_Coverage, 769,
     /*   8231 */     GIR_EraseRootFromParent_Done,
     /*   8232 */   // Label 185: @8232
     /*   8232 */   GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(8304), // Rule ID 776 //
     /*   8237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8256 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   8265 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8269 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8273 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8278 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8280 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv4i32),
     /*   8283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   8293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8296 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8302 */     GIR_RootConstrainSelectedInstOperands,
     /*   8303 */     // GIR_Coverage, 776,
     /*   8303 */     GIR_EraseRootFromParent_Done,
     /*   8304 */   // Label 186: @8304
     /*   8304 */   GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(8376), // Rule ID 775 //
     /*   8309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8328 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8333 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   8337 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8341 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8345 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8350 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8352 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv4i32),
     /*   8355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   8365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8368 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8374 */     GIR_RootConstrainSelectedInstOperands,
     /*   8375 */     // GIR_Coverage, 775,
     /*   8375 */     GIR_EraseRootFromParent_Done,
     /*   8376 */   // Label 187: @8376
     /*   8376 */   GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(8446), // Rule ID 5535 //
     /*   8381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8400 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8404 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8409 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8418 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8420 */     // (add:{ *:[v4i32] } (mul:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm), QPR:{ *:[v4i32] }:$src1)  =>  (VMLAv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*   8420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv4i32),
     /*   8423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8425 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   8427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   8435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8438 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8444 */     GIR_RootConstrainSelectedInstOperands,
     /*   8445 */     // GIR_Coverage, 5535,
     /*   8445 */     GIR_EraseRootFromParent_Done,
     /*   8446 */   // Label 188: @8446
     /*   8446 */   GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(8503), // Rule ID 5509 //
     /*   8451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8470 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8481 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm), QPR:{ *:[v4i32] }:$Vn)  =>  (VADDWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv4i32),
     /*   8484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   8488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8495 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8501 */     GIR_RootConstrainSelectedInstOperands,
     /*   8502 */     // GIR_Coverage, 5509,
     /*   8502 */     GIR_EraseRootFromParent_Done,
     /*   8503 */   // Label 189: @8503
     /*   8503 */   GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(8560), // Rule ID 5504 //
     /*   8508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8527 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8536 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8538 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm), QPR:{ *:[v4i32] }:$Vn)  =>  (VADDWsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv4i32),
     /*   8541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   8545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8552 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8558 */     GIR_RootConstrainSelectedInstOperands,
     /*   8559 */     // GIR_Coverage, 5504,
     /*   8559 */     GIR_EraseRootFromParent_Done,
     /*   8560 */   // Label 190: @8560
     /*   8560 */   GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(8617), // Rule ID 5508 //
     /*   8565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8584 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8595 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm), QPR:{ *:[v4i32] }:$Vn)  =>  (VADDWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv4i32),
     /*   8598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8600 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   8602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8609 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8615 */     GIR_RootConstrainSelectedInstOperands,
     /*   8616 */     // GIR_Coverage, 5508,
     /*   8616 */     GIR_EraseRootFromParent_Done,
     /*   8617 */   // Label 191: @8617
     /*   8617 */   GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(8687), // Rule ID 892 //
     /*   8622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8629 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8645 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8649 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8654 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8661 */     // (add:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, (mul:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm))  =>  (VMLAv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*   8661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv4i32),
     /*   8664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8666 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   8676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8679 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8685 */     GIR_RootConstrainSelectedInstOperands,
     /*   8686 */     // GIR_Coverage, 892,
     /*   8686 */     GIR_EraseRootFromParent_Done,
     /*   8687 */   // Label 192: @8687
     /*   8687 */   GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(8744), // Rule ID 789 //
     /*   8692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8699 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8711 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8715 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8722 */     // (add:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv4i32),
     /*   8725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8727 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   8729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8736 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8742 */     GIR_RootConstrainSelectedInstOperands,
     /*   8743 */     // GIR_Coverage, 789,
     /*   8743 */     GIR_EraseRootFromParent_Done,
     /*   8744 */   // Label 193: @8744
     /*   8744 */   GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(8801), // Rule ID 784 //
     /*   8749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8772 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8779 */     // (add:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDWsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv4i32),
     /*   8782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8784 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   8786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8793 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8799 */     GIR_RootConstrainSelectedInstOperands,
     /*   8800 */     // GIR_Coverage, 784,
     /*   8800 */     GIR_EraseRootFromParent_Done,
     /*   8801 */   // Label 194: @8801
     /*   8801 */   GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(8858), // Rule ID 788 //
     /*   8806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8829 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8834 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8836 */     // (add:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv4i32),
     /*   8839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8841 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   8843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8850 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8856 */     GIR_RootConstrainSelectedInstOperands,
     /*   8857 */     // GIR_Coverage, 788,
     /*   8857 */     GIR_EraseRootFromParent_Done,
     /*   8858 */   // Label 195: @8858
     /*   8858 */   GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(8898), // Rule ID 761 //
     /*   8863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8870 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8878 */     // (add:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VADDv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*   8878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv4i32),
     /*   8881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8883 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   8885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   8887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8890 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8896 */     GIR_RootConstrainSelectedInstOperands,
     /*   8897 */     // GIR_Coverage, 761,
     /*   8897 */     GIR_EraseRootFromParent_Done,
     /*   8898 */   // Label 196: @8898
     /*   8898 */   GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(8959), // Rule ID 3496 //
     /*   8903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   8906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   8910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   8914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   8918 */     // (add:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VADDi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*   8918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*   8921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   8925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDi32),
     /*   8933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*   8935 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*   8937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*   8939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   8942 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8948 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8954 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   8957 */     GIR_RootConstrainSelectedInstOperands,
     /*   8958 */     // GIR_Coverage, 3496,
     /*   8958 */     GIR_EraseRootFromParent_Done,
     /*   8959 */   // Label 197: @8959
     /*   8959 */   GIM_Reject,
     /*   8960 */ // Label 182: @8960
     /*   8960 */ GIM_Reject,
     /*   8961 */ // Label 86: @8961
     /*   8961 */ GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(9145),
     /*   8966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   8969 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*   8972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8976 */   GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(9042), // Rule ID 5530 //
     /*   8981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   8996 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*   9000 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9005 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9016 */     // (add:{ *:[v8i8] } (mul:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm), DPR:{ *:[v8i8] }:$src1)  =>  (VMLAv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv8i8),
     /*   9019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9021 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   9023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   9031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9034 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9040 */     GIR_RootConstrainSelectedInstOperands,
     /*   9041 */     // GIR_Coverage, 5530,
     /*   9041 */     GIR_EraseRootFromParent_Done,
     /*   9042 */   // Label 199: @9042
     /*   9042 */   GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(9108), // Rule ID 887 //
     /*   9047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   9062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9066 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*   9070 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9082 */     // (add:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, (mul:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm))  =>  (VMLAv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv8i8),
     /*   9085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9087 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   9097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9100 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9106 */     GIR_RootConstrainSelectedInstOperands,
     /*   9107 */     // GIR_Coverage, 887,
     /*   9107 */     GIR_EraseRootFromParent_Done,
     /*   9108 */   // Label 200: @9108
     /*   9108 */   GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(9144), // Rule ID 756 //
     /*   9113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9124 */     // (add:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VADDv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv8i8),
     /*   9127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9129 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   9131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   9133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9136 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9142 */     GIR_RootConstrainSelectedInstOperands,
     /*   9143 */     // GIR_Coverage, 756,
     /*   9143 */     GIR_EraseRootFromParent_Done,
     /*   9144 */   // Label 201: @9144
     /*   9144 */   GIM_Reject,
     /*   9145 */ // Label 198: @9145
     /*   9145 */ GIM_Reject,
     /*   9146 */ // Label 87: @9146
     /*   9146 */ GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(10101),
     /*   9151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   9154 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   9157 */   GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(9229), // Rule ID 774 //
     /*   9162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9181 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9186 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   9190 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9194 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9198 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9203 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9205 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv8i16),
     /*   9208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   9218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9221 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9227 */     GIR_RootConstrainSelectedInstOperands,
     /*   9228 */     // GIR_Coverage, 774,
     /*   9228 */     GIR_EraseRootFromParent_Done,
     /*   9229 */   // Label 203: @9229
     /*   9229 */   GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(9301), // Rule ID 773 //
     /*   9234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9253 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   9262 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9266 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9270 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9275 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9277 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv8i16),
     /*   9280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   9290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9293 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9299 */     GIR_RootConstrainSelectedInstOperands,
     /*   9300 */     // GIR_Coverage, 773,
     /*   9300 */     GIR_EraseRootFromParent_Done,
     /*   9301 */   // Label 204: @9301
     /*   9301 */   GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(9373), // Rule ID 768 //
     /*   9306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9325 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   9334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9338 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9342 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9347 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9349 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDLsv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLsv8i16),
     /*   9352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   9362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9365 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9371 */     GIR_RootConstrainSelectedInstOperands,
     /*   9372 */     // GIR_Coverage, 768,
     /*   9372 */     GIR_EraseRootFromParent_Done,
     /*   9373 */   // Label 205: @9373
     /*   9373 */   GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(9445), // Rule ID 772 //
     /*   9378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9397 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   9406 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9410 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9414 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9419 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9421 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv8i16),
     /*   9424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   9434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9437 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9443 */     GIR_RootConstrainSelectedInstOperands,
     /*   9444 */     // GIR_Coverage, 772,
     /*   9444 */     GIR_EraseRootFromParent_Done,
     /*   9445 */   // Label 206: @9445
     /*   9445 */   GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(9517), // Rule ID 771 //
     /*   9450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9469 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9474 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   9478 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9482 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9486 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9491 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9493 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv8i16),
     /*   9496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   9506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9509 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9515 */     GIR_RootConstrainSelectedInstOperands,
     /*   9516 */     // GIR_Coverage, 771,
     /*   9516 */     GIR_EraseRootFromParent_Done,
     /*   9517 */   // Label 207: @9517
     /*   9517 */   GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(9587), // Rule ID 5534 //
     /*   9522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   9537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   9541 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   9545 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9550 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9561 */     // (add:{ *:[v8i16] } (mul:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm), QPR:{ *:[v8i16] }:$src1)  =>  (VMLAv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*   9561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv8i16),
     /*   9564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9566 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   9568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   9576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9579 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9585 */     GIR_RootConstrainSelectedInstOperands,
     /*   9586 */     // GIR_Coverage, 5534,
     /*   9586 */     GIR_EraseRootFromParent_Done,
     /*   9587 */   // Label 208: @9587
     /*   9587 */   GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(9644), // Rule ID 5507 //
     /*   9592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9620 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9622 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm), QPR:{ *:[v8i16] }:$Vn)  =>  (VADDWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv8i16),
     /*   9625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   9629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9636 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9642 */     GIR_RootConstrainSelectedInstOperands,
     /*   9643 */     // GIR_Coverage, 5507,
     /*   9643 */     GIR_EraseRootFromParent_Done,
     /*   9644 */   // Label 209: @9644
     /*   9644 */   GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(9701), // Rule ID 5503 //
     /*   9649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9668 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9679 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm), QPR:{ *:[v8i16] }:$Vn)  =>  (VADDWsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv8i16),
     /*   9682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   9686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9693 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9699 */     GIR_RootConstrainSelectedInstOperands,
     /*   9700 */     // GIR_Coverage, 5503,
     /*   9700 */     GIR_EraseRootFromParent_Done,
     /*   9701 */   // Label 210: @9701
     /*   9701 */   GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(9758), // Rule ID 5506 //
     /*   9706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9721 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9725 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9736 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm), QPR:{ *:[v8i16] }:$Vn)  =>  (VADDWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv8i16),
     /*   9739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   9743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9750 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9756 */     GIR_RootConstrainSelectedInstOperands,
     /*   9757 */     // GIR_Coverage, 5506,
     /*   9757 */     GIR_EraseRootFromParent_Done,
     /*   9758 */   // Label 211: @9758
     /*   9758 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(9828), // Rule ID 891 //
     /*   9763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   9782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   9786 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   9790 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9795 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9800 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9802 */     // (add:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, (mul:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm))  =>  (VMLAv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*   9802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv8i16),
     /*   9805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9807 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   9817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9820 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9826 */     GIR_RootConstrainSelectedInstOperands,
     /*   9827 */     // GIR_Coverage, 891,
     /*   9827 */     GIR_EraseRootFromParent_Done,
     /*   9828 */   // Label 212: @9828
     /*   9828 */   GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(9885), // Rule ID 787 //
     /*   9833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9856 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9863 */     // (add:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv8i16),
     /*   9866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9868 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   9870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9877 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9883 */     GIR_RootConstrainSelectedInstOperands,
     /*   9884 */     // GIR_Coverage, 787,
     /*   9884 */     GIR_EraseRootFromParent_Done,
     /*   9885 */   // Label 213: @9885
     /*   9885 */   GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(9942), // Rule ID 783 //
     /*   9890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9913 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9918 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9920 */     // (add:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDWsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv8i16),
     /*   9923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9925 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   9927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9934 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9940 */     GIR_RootConstrainSelectedInstOperands,
     /*   9941 */     // GIR_Coverage, 783,
     /*   9941 */     GIR_EraseRootFromParent_Done,
     /*   9942 */   // Label 214: @9942
     /*   9942 */   GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(9999), // Rule ID 786 //
     /*   9947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9954 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9966 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9970 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9977 */     // (add:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv8i16),
     /*   9980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9982 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   9984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9991 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9997 */     GIR_RootConstrainSelectedInstOperands,
     /*   9998 */     // GIR_Coverage, 786,
     /*   9998 */     GIR_EraseRootFromParent_Done,
     /*   9999 */   // Label 215: @9999
     /*   9999 */   GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(10039), // Rule ID 760 //
     /*  10004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10019 */     // (add:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VADDv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  10019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv8i16),
     /*  10022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  10024 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  10026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  10028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10031 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10037 */     GIR_RootConstrainSelectedInstOperands,
     /*  10038 */     // GIR_Coverage, 760,
     /*  10038 */     GIR_EraseRootFromParent_Done,
     /*  10039 */   // Label 216: @10039
     /*  10039 */   GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(10100), // Rule ID 3492 //
     /*  10044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  10047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10059 */     // (add:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VADDi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  10059 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  10062 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  10066 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDi16),
     /*  10074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  10076 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  10078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  10080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  10083 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10089 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10095 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  10098 */     GIR_RootConstrainSelectedInstOperands,
     /*  10099 */     // GIR_Coverage, 3492,
     /*  10099 */     GIR_EraseRootFromParent_Done,
     /*  10100 */   // Label 217: @10100
     /*  10100 */   GIM_Reject,
     /*  10101 */ // Label 202: @10101
     /*  10101 */ GIM_Reject,
     /*  10102 */ // Label 88: @10102
     /*  10102 */ GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(10355),
     /*  10107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  10110 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  10113 */   GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(10183), // Rule ID 5533 //
     /*  10118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  10133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  10137 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  10141 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10146 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10157 */     // (add:{ *:[v16i8] } (mul:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm), QPR:{ *:[v16i8] }:$src1)  =>  (VMLAv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src1, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  10157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv16i8),
     /*  10160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  10162 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  10164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  10168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  10172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10175 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10181 */     GIR_RootConstrainSelectedInstOperands,
     /*  10182 */     // GIR_Coverage, 5533,
     /*  10182 */     GIR_EraseRootFromParent_Done,
     /*  10183 */   // Label 219: @10183
     /*  10183 */   GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(10253), // Rule ID 890 //
     /*  10188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  10207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  10211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  10215 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10220 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10227 */     // (add:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src1, (mul:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm))  =>  (VMLAv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src1, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  10227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv16i8),
     /*  10230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  10232 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  10238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  10242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10245 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10251 */     GIR_RootConstrainSelectedInstOperands,
     /*  10252 */     // GIR_Coverage, 890,
     /*  10252 */     GIR_EraseRootFromParent_Done,
     /*  10253 */   // Label 220: @10253
     /*  10253 */   GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(10293), // Rule ID 759 //
     /*  10258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10273 */     // (add:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VADDv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  10273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv16i8),
     /*  10276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  10278 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  10280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  10282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10285 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10291 */     GIR_RootConstrainSelectedInstOperands,
     /*  10292 */     // GIR_Coverage, 759,
     /*  10292 */     GIR_EraseRootFromParent_Done,
     /*  10293 */   // Label 221: @10293
     /*  10293 */   GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(10354), // Rule ID 3488 //
     /*  10298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  10301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10313 */     // (add:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VADDi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  10313 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  10316 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  10320 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDi8),
     /*  10328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  10330 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  10332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  10334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  10337 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10343 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10349 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  10352 */     GIR_RootConstrainSelectedInstOperands,
     /*  10353 */     // GIR_Coverage, 3488,
     /*  10353 */     GIR_EraseRootFromParent_Done,
     /*  10354 */   // Label 222: @10354
     /*  10354 */   GIM_Reject,
     /*  10355 */ // Label 218: @10355
     /*  10355 */ GIM_Reject,
     /*  10356 */ // Label 89: @10356
     /*  10356 */ GIM_Reject,
     /*  10357 */ // Label 1: @10357
     /*  10357 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 232*/ GIMT_Encode4(13600),
     /*  10368 */ /*GILLT_s32*//*Label 223*/ GIMT_Encode4(10428),
     /*  10372 */ /*GILLT_s64*//*Label 224*/ GIMT_Encode4(11042), GIMT_Encode4(0),
     /*  10380 */ /*GILLT_v2s32*//*Label 225*/ GIMT_Encode4(11089),
     /*  10384 */ /*GILLT_v2s64*//*Label 226*/ GIMT_Encode4(11204), GIMT_Encode4(0),
     /*  10392 */ /*GILLT_v4s16*//*Label 227*/ GIMT_Encode4(11756),
     /*  10396 */ /*GILLT_v4s32*//*Label 228*/ GIMT_Encode4(11871), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  10408 */ /*GILLT_v8s8*//*Label 229*/ GIMT_Encode4(12586),
     /*  10412 */ /*GILLT_v8s16*//*Label 230*/ GIMT_Encode4(12701), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  10424 */ /*GILLT_v16s8*//*Label 231*/ GIMT_Encode4(13416),
     /*  10428 */ // Label 223: @10428
     /*  10428 */ GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(11041),
     /*  10433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  10436 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  10439 */   GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(10483), // Rule ID 330 //
     /*  10444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  10447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  10451 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  10455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  10459 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, tGPR:{ *:[i32] }:$Rn)  =>  (tRSB:{ *:[i32] } tGPR:{ *:[i32] }:$Rn)
     /*  10459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tRSB),
     /*  10462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10464 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  10470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10475 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10481 */     GIR_RootConstrainSelectedInstOperands,
     /*  10482 */     // GIR_Coverage, 330,
     /*  10482 */     GIR_EraseRootFromParent_Done,
     /*  10483 */   // Label 234: @10483
     /*  10483 */   GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(10540), // Rule ID 96 //
     /*  10488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  10491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  10503 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  10507 */     // MIs[1] Operand 1
     /*  10507 */     // No operand predicates
     /*  10507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10513 */     // (sub:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm, GPR:{ *:[i32] }:$Rn)  =>  (RSBri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  10513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::RSBri),
     /*  10516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10520 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  10523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10526 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10532 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10538 */     GIR_RootConstrainSelectedInstOperands,
     /*  10539 */     // GIR_Coverage, 96,
     /*  10539 */     GIR_EraseRootFromParent_Done,
     /*  10540 */   // Label 235: @10540
     /*  10540 */   GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(10597), // Rule ID 427 //
     /*  10545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  10548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  10560 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  10564 */     // MIs[1] Operand 1
     /*  10564 */     // No operand predicates
     /*  10564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10570 */     // (sub:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, rGPR:{ *:[i32] }:$Rn)  =>  (t2RSBri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  10570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2RSBri),
     /*  10573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10577 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  10580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10583 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10589 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10595 */     GIR_RootConstrainSelectedInstOperands,
     /*  10596 */     // GIR_Coverage, 427,
     /*  10596 */     GIR_EraseRootFromParent_Done,
     /*  10597 */   // Label 236: @10597
     /*  10597 */   GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(10654), // Rule ID 76 //
     /*  10602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  10605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10609 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  10621 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  10625 */     // MIs[1] Operand 1
     /*  10625 */     // No operand predicates
     /*  10625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10627 */     // (sub:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm)  =>  (SUBri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  10627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SUBri),
     /*  10630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10632 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10634 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  10637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10640 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10646 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10652 */     GIR_RootConstrainSelectedInstOperands,
     /*  10653 */     // GIR_Coverage, 76,
     /*  10653 */     GIR_EraseRootFromParent_Done,
     /*  10654 */   // Label 237: @10654
     /*  10654 */   GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(10711), // Rule ID 411 //
     /*  10659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  10662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  10670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  10678 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  10682 */     // MIs[1] Operand 1
     /*  10682 */     // No operand predicates
     /*  10682 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10684 */     // (sub:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2SUBri:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  10684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SUBri),
     /*  10687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10689 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  10694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10697 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10703 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10709 */     GIR_RootConstrainSelectedInstOperands,
     /*  10710 */     // GIR_Coverage, 411,
     /*  10710 */     GIR_EraseRootFromParent_Done,
     /*  10711 */   // Label 238: @10711
     /*  10711 */   GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(10762), // Rule ID 412 //
     /*  10716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  10719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  10735 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_4095),
     /*  10739 */     // MIs[1] Operand 1
     /*  10739 */     // No operand predicates
     /*  10739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10741 */     // (sub:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_imm0_4095>>:$imm)  =>  (t2SUBri12:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  10741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SUBri12),
     /*  10744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10746 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10748 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  10751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10754 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10760 */     GIR_RootConstrainSelectedInstOperands,
     /*  10761 */     // GIR_Coverage, 412,
     /*  10761 */     GIR_EraseRootFromParent_Done,
     /*  10762 */   // Label 239: @10762
     /*  10762 */   GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(10832), // Rule ID 173 //
     /*  10767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6T2_IsARM_UseMulOps),
     /*  10770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  10786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  10790 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  10794 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10804 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10806 */     // (sub:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm))  =>  (MLS:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*  10806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MLS),
     /*  10809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  10815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  10819 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  10821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10824 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10830 */     GIR_RootConstrainSelectedInstOperands,
     /*  10831 */     // GIR_Coverage, 173,
     /*  10831 */     GIR_EraseRootFromParent_Done,
     /*  10832 */   // Label 240: @10832
     /*  10832 */   GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(10902), // Rule ID 504 //
     /*  10837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_UseMulOps),
     /*  10840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  10856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  10860 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  10864 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10876 */     // (sub:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm))  =>  (t2MLS:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  10876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MLS),
     /*  10879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  10885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  10889 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  10891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10894 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10900 */     GIR_RootConstrainSelectedInstOperands,
     /*  10901 */     // GIR_Coverage, 504,
     /*  10901 */     GIR_EraseRootFromParent_Done,
     /*  10902 */   // Label 241: @10902
     /*  10902 */   GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(10948), // Rule ID 77 //
     /*  10907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  10910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10922 */     // (sub:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (SUBrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  10922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SUBrr),
     /*  10925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10927 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  10931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10934 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10940 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10946 */     GIR_RootConstrainSelectedInstOperands,
     /*  10947 */     // GIR_Coverage, 77,
     /*  10947 */     GIR_EraseRootFromParent_Done,
     /*  10948 */   // Label 242: @10948
     /*  10948 */   GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(10994), // Rule ID 333 //
     /*  10953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  10956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  10960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  10964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  10968 */     // (sub:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tSUBrr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  10968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tSUBrr),
     /*  10971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10973 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  10979 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  10983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10986 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10992 */     GIR_RootConstrainSelectedInstOperands,
     /*  10993 */     // GIR_Coverage, 333,
     /*  10993 */     GIR_EraseRootFromParent_Done,
     /*  10994 */   // Label 243: @10994
     /*  10994 */   GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(11040), // Rule ID 413 //
     /*  10999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  11002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  11006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  11010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  11014 */     // (sub:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SUBrr:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  11014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SUBrr),
     /*  11017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  11019 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  11021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  11023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11026 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11032 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11038 */     GIR_RootConstrainSelectedInstOperands,
     /*  11039 */     // GIR_Coverage, 413,
     /*  11039 */     GIR_EraseRootFromParent_Done,
     /*  11040 */   // Label 244: @11040
     /*  11040 */   GIM_Reject,
     /*  11041 */ // Label 233: @11041
     /*  11041 */ GIM_Reject,
     /*  11042 */ // Label 224: @11042
     /*  11042 */ GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(11088), // Rule ID 966 //
     /*  11047 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11050 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  11053 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  11056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11060 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11064 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11068 */   // (sub:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VSUBv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /*  11068 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv1i64),
     /*  11071 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11073 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11075 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  11077 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11080 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11086 */   GIR_RootConstrainSelectedInstOperands,
     /*  11087 */   // GIR_Coverage, 966,
     /*  11087 */   GIR_EraseRootFromParent_Done,
     /*  11088 */ // Label 245: @11088
     /*  11088 */ GIM_Reject,
     /*  11089 */ // Label 225: @11089
     /*  11089 */ GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(11203),
     /*  11094 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11097 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11104 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11108 */   GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(11170), // Rule ID 917 //
     /*  11113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  11124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11128 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11132 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11137 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11144 */     // (sub:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, (mul:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm))  =>  (VMLSv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv2i32),
     /*  11147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11149 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  11159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11162 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11168 */     GIR_RootConstrainSelectedInstOperands,
     /*  11169 */     // GIR_Coverage, 917,
     /*  11169 */     GIR_EraseRootFromParent_Done,
     /*  11170 */   // Label 247: @11170
     /*  11170 */   GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(11202), // Rule ID 962 //
     /*  11175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11182 */     // (sub:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VSUBv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv2i32),
     /*  11185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11187 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  11191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11194 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11200 */     GIR_RootConstrainSelectedInstOperands,
     /*  11201 */     // GIR_Coverage, 962,
     /*  11201 */     GIR_EraseRootFromParent_Done,
     /*  11202 */   // Label 248: @11202
     /*  11202 */   GIM_Reject,
     /*  11203 */ // Label 246: @11203
     /*  11203 */ GIM_Reject,
     /*  11204 */ // Label 226: @11204
     /*  11204 */ GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(11755),
     /*  11209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  11212 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  11215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11219 */   GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(11287), // Rule ID 986 //
     /*  11224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11235 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11239 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11244 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11248 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11252 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11256 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11261 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11263 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv2i64),
     /*  11266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11279 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11285 */     GIR_RootConstrainSelectedInstOperands,
     /*  11286 */     // GIR_Coverage, 986,
     /*  11286 */     GIR_EraseRootFromParent_Done,
     /*  11287 */   // Label 250: @11287
     /*  11287 */   GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(11355), // Rule ID 985 //
     /*  11292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11307 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11312 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11316 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11320 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11324 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11329 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11331 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv2i64),
     /*  11334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11347 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11353 */     GIR_RootConstrainSelectedInstOperands,
     /*  11354 */     // GIR_Coverage, 985,
     /*  11354 */     GIR_EraseRootFromParent_Done,
     /*  11355 */   // Label 251: @11355
     /*  11355 */   GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(11423), // Rule ID 974 //
     /*  11360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  11371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11375 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  11388 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11392 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11397 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11399 */     // (sub:{ *:[v2i64] } (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBLsv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLsv2i64),
     /*  11402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11415 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11421 */     GIR_RootConstrainSelectedInstOperands,
     /*  11422 */     // GIR_Coverage, 974,
     /*  11422 */     GIR_EraseRootFromParent_Done,
     /*  11423 */   // Label 252: @11423
     /*  11423 */   GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(11491), // Rule ID 984 //
     /*  11428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11443 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11448 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11452 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11456 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11460 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11465 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11467 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv2i64),
     /*  11470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11483 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11489 */     GIR_RootConstrainSelectedInstOperands,
     /*  11490 */     // GIR_Coverage, 984,
     /*  11490 */     GIR_EraseRootFromParent_Done,
     /*  11491 */   // Label 253: @11491
     /*  11491 */   GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(11559), // Rule ID 983 //
     /*  11496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11511 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11524 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11528 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11533 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11535 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv2i64),
     /*  11538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11551 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11557 */     GIR_RootConstrainSelectedInstOperands,
     /*  11558 */     // GIR_Coverage, 983,
     /*  11558 */     GIR_EraseRootFromParent_Done,
     /*  11559 */   // Label 254: @11559
     /*  11559 */   GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(11612), // Rule ID 995 //
     /*  11564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11583 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11590 */     // (sub:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv2i64),
     /*  11593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11595 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  11601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11604 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11610 */     GIR_RootConstrainSelectedInstOperands,
     /*  11611 */     // GIR_Coverage, 995,
     /*  11611 */     GIR_EraseRootFromParent_Done,
     /*  11612 */   // Label 255: @11612
     /*  11612 */   GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(11665), // Rule ID 989 //
     /*  11617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  11632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11636 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11643 */     // (sub:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBWsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWsv2i64),
     /*  11646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11648 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  11654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11657 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11663 */     GIR_RootConstrainSelectedInstOperands,
     /*  11664 */     // GIR_Coverage, 989,
     /*  11664 */     GIR_EraseRootFromParent_Done,
     /*  11665 */   // Label 256: @11665
     /*  11665 */   GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(11718), // Rule ID 994 //
     /*  11670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11694 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11696 */     // (sub:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv2i64),
     /*  11699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11701 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  11707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11710 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11716 */     GIR_RootConstrainSelectedInstOperands,
     /*  11717 */     // GIR_Coverage, 994,
     /*  11717 */     GIR_EraseRootFromParent_Done,
     /*  11718 */   // Label 257: @11718
     /*  11718 */   GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(11754), // Rule ID 967 //
     /*  11723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11726 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11734 */     // (sub:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VSUBv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /*  11734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv2i64),
     /*  11737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11739 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  11743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11746 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11752 */     GIR_RootConstrainSelectedInstOperands,
     /*  11753 */     // GIR_Coverage, 967,
     /*  11753 */     GIR_EraseRootFromParent_Done,
     /*  11754 */   // Label 258: @11754
     /*  11754 */   GIM_Reject,
     /*  11755 */ // Label 249: @11755
     /*  11755 */ GIM_Reject,
     /*  11756 */ // Label 227: @11756
     /*  11756 */ GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(11870),
     /*  11761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11764 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  11767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11771 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11775 */   GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(11837), // Rule ID 916 //
     /*  11780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  11791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  11799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11804 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11811 */     // (sub:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, (mul:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm))  =>  (VMLSv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  11811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv4i16),
     /*  11814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11816 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  11826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11829 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11835 */     GIR_RootConstrainSelectedInstOperands,
     /*  11836 */     // GIR_Coverage, 916,
     /*  11836 */     GIR_EraseRootFromParent_Done,
     /*  11837 */   // Label 260: @11837
     /*  11837 */   GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(11869), // Rule ID 961 //
     /*  11842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11849 */     // (sub:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VSUBv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  11849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv4i16),
     /*  11852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11854 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  11858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11861 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11867 */     GIR_RootConstrainSelectedInstOperands,
     /*  11868 */     // GIR_Coverage, 961,
     /*  11868 */     GIR_EraseRootFromParent_Done,
     /*  11869 */   // Label 261: @11869
     /*  11869 */   GIM_Reject,
     /*  11870 */ // Label 259: @11870
     /*  11870 */ GIM_Reject,
     /*  11871 */ // Label 228: @11871
     /*  11871 */ GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(12585),
     /*  11876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11879 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11882 */   GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(11954), // Rule ID 982 //
     /*  11887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11906 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11915 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11919 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11923 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11928 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11930 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  11930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv4i32),
     /*  11933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11946 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11952 */     GIR_RootConstrainSelectedInstOperands,
     /*  11953 */     // GIR_Coverage, 982,
     /*  11953 */     GIR_EraseRootFromParent_Done,
     /*  11954 */   // Label 263: @11954
     /*  11954 */   GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(12026), // Rule ID 981 //
     /*  11959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11991 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11995 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12000 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12002 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv4i32),
     /*  12005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12018 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12024 */     GIR_RootConstrainSelectedInstOperands,
     /*  12025 */     // GIR_Coverage, 981,
     /*  12025 */     GIR_EraseRootFromParent_Done,
     /*  12026 */   // Label 264: @12026
     /*  12026 */   GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(12098), // Rule ID 973 //
     /*  12031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12046 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12050 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12055 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12059 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12063 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12067 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12072 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12074 */     // (sub:{ *:[v4i32] } (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBLsv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLsv4i32),
     /*  12077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12090 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12096 */     GIR_RootConstrainSelectedInstOperands,
     /*  12097 */     // GIR_Coverage, 973,
     /*  12097 */     GIR_EraseRootFromParent_Done,
     /*  12098 */   // Label 265: @12098
     /*  12098 */   GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(12170), // Rule ID 980 //
     /*  12103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12135 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12139 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12144 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12146 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv4i32),
     /*  12149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12162 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12168 */     GIR_RootConstrainSelectedInstOperands,
     /*  12169 */     // GIR_Coverage, 980,
     /*  12169 */     GIR_EraseRootFromParent_Done,
     /*  12170 */   // Label 266: @12170
     /*  12170 */   GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(12242), // Rule ID 979 //
     /*  12175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12194 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12199 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12203 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12207 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12211 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12216 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12218 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv4i32),
     /*  12221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12234 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12240 */     GIR_RootConstrainSelectedInstOperands,
     /*  12241 */     // GIR_Coverage, 979,
     /*  12241 */     GIR_EraseRootFromParent_Done,
     /*  12242 */   // Label 267: @12242
     /*  12242 */   GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(12312), // Rule ID 920 //
     /*  12247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12254 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  12266 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12270 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12274 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12279 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12284 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12286 */     // (sub:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, (mul:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm))  =>  (VMLSv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  12286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv4i32),
     /*  12289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12291 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  12293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  12301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12304 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12310 */     GIR_RootConstrainSelectedInstOperands,
     /*  12311 */     // GIR_Coverage, 920,
     /*  12311 */     GIR_EraseRootFromParent_Done,
     /*  12312 */   // Label 268: @12312
     /*  12312 */   GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(12369), // Rule ID 993 //
     /*  12317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12340 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12347 */     // (sub:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv4i32),
     /*  12350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12352 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  12354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  12358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12361 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12367 */     GIR_RootConstrainSelectedInstOperands,
     /*  12368 */     // GIR_Coverage, 993,
     /*  12368 */     GIR_EraseRootFromParent_Done,
     /*  12369 */   // Label 269: @12369
     /*  12369 */   GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(12426), // Rule ID 988 //
     /*  12374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12397 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12402 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12404 */     // (sub:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBWsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWsv4i32),
     /*  12407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12409 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  12411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  12415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12418 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12424 */     GIR_RootConstrainSelectedInstOperands,
     /*  12425 */     // GIR_Coverage, 988,
     /*  12425 */     GIR_EraseRootFromParent_Done,
     /*  12426 */   // Label 270: @12426
     /*  12426 */   GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(12483), // Rule ID 992 //
     /*  12431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12454 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12461 */     // (sub:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv4i32),
     /*  12464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12466 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  12468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  12472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12475 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12481 */     GIR_RootConstrainSelectedInstOperands,
     /*  12482 */     // GIR_Coverage, 992,
     /*  12482 */     GIR_EraseRootFromParent_Done,
     /*  12483 */   // Label 271: @12483
     /*  12483 */   GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(12523), // Rule ID 965 //
     /*  12488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12503 */     // (sub:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VSUBv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  12503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv4i32),
     /*  12506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12508 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  12510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  12512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12515 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12521 */     GIR_RootConstrainSelectedInstOperands,
     /*  12522 */     // GIR_Coverage, 965,
     /*  12522 */     GIR_EraseRootFromParent_Done,
     /*  12523 */   // Label 272: @12523
     /*  12523 */   GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(12584), // Rule ID 3508 //
     /*  12528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  12531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  12535 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  12539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  12543 */     // (sub:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VSUBi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  12543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSUBi32),
     /*  12558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  12560 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  12562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  12564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  12567 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12573 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12579 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  12582 */     GIR_RootConstrainSelectedInstOperands,
     /*  12583 */     // GIR_Coverage, 3508,
     /*  12583 */     GIR_EraseRootFromParent_Done,
     /*  12584 */   // Label 273: @12584
     /*  12584 */   GIM_Reject,
     /*  12585 */ // Label 262: @12585
     /*  12585 */ GIM_Reject,
     /*  12586 */ // Label 229: @12586
     /*  12586 */ GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(12700),
     /*  12591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12594 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  12597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12601 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12605 */   GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(12667), // Rule ID 915 //
     /*  12610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  12621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12625 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  12629 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12634 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12641 */     // (sub:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, (mul:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm))  =>  (VMLSv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv8i8),
     /*  12644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12646 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  12648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  12656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12659 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12665 */     GIR_RootConstrainSelectedInstOperands,
     /*  12666 */     // GIR_Coverage, 915,
     /*  12666 */     GIR_EraseRootFromParent_Done,
     /*  12667 */   // Label 275: @12667
     /*  12667 */   GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(12699), // Rule ID 960 //
     /*  12672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12679 */     // (sub:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VSUBv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv8i8),
     /*  12682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12684 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  12686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  12688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12691 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12697 */     GIR_RootConstrainSelectedInstOperands,
     /*  12698 */     // GIR_Coverage, 960,
     /*  12698 */     GIR_EraseRootFromParent_Done,
     /*  12699 */   // Label 276: @12699
     /*  12699 */   GIM_Reject,
     /*  12700 */ // Label 274: @12700
     /*  12700 */ GIM_Reject,
     /*  12701 */ // Label 230: @12701
     /*  12701 */ GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(13415),
     /*  12706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  12709 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  12712 */   GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(12784), // Rule ID 978 //
     /*  12717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12736 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12741 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12745 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12749 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12753 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12758 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12760 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv8i16),
     /*  12763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12776 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12782 */     GIR_RootConstrainSelectedInstOperands,
     /*  12783 */     // GIR_Coverage, 978,
     /*  12783 */     GIR_EraseRootFromParent_Done,
     /*  12784 */   // Label 278: @12784
     /*  12784 */   GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(12856), // Rule ID 977 //
     /*  12789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12808 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12813 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12817 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12821 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12825 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12830 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12832 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv8i16),
     /*  12835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12848 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12854 */     GIR_RootConstrainSelectedInstOperands,
     /*  12855 */     // GIR_Coverage, 977,
     /*  12855 */     GIR_EraseRootFromParent_Done,
     /*  12856 */   // Label 279: @12856
     /*  12856 */   GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(12928), // Rule ID 972 //
     /*  12861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12880 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12885 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12889 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12893 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12897 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12902 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12904 */     // (sub:{ *:[v8i16] } (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBLsv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLsv8i16),
     /*  12907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12920 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12926 */     GIR_RootConstrainSelectedInstOperands,
     /*  12927 */     // GIR_Coverage, 972,
     /*  12927 */     GIR_EraseRootFromParent_Done,
     /*  12928 */   // Label 280: @12928
     /*  12928 */   GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(13000), // Rule ID 976 //
     /*  12933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12952 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12957 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12961 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12965 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12969 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12974 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12976 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv8i16),
     /*  12979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12992 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12998 */     GIR_RootConstrainSelectedInstOperands,
     /*  12999 */     // GIR_Coverage, 976,
     /*  12999 */     GIR_EraseRootFromParent_Done,
     /*  13000 */   // Label 281: @13000
     /*  13000 */   GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(13072), // Rule ID 975 //
     /*  13005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  13020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  13024 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  13029 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  13033 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  13037 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  13041 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  13046 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13048 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  13048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv8i16),
     /*  13051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  13057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  13061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13064 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13070 */     GIR_RootConstrainSelectedInstOperands,
     /*  13071 */     // GIR_Coverage, 975,
     /*  13071 */     GIR_EraseRootFromParent_Done,
     /*  13072 */   // Label 282: @13072
     /*  13072 */   GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(13142), // Rule ID 919 //
     /*  13077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13084 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  13096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  13100 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  13104 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13114 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13116 */     // (sub:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, (mul:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm))  =>  (VMLSv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  13116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv8i16),
     /*  13119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13121 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  13123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  13127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  13131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13134 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13140 */     GIR_RootConstrainSelectedInstOperands,
     /*  13141 */     // GIR_Coverage, 919,
     /*  13141 */     GIR_EraseRootFromParent_Done,
     /*  13142 */   // Label 283: @13142
     /*  13142 */   GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(13199), // Rule ID 991 //
     /*  13147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  13166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  13170 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  13175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13177 */     // (sub:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  13177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv8i16),
     /*  13180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13182 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  13184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  13188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13191 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13197 */     GIR_RootConstrainSelectedInstOperands,
     /*  13198 */     // GIR_Coverage, 991,
     /*  13198 */     GIR_EraseRootFromParent_Done,
     /*  13199 */   // Label 284: @13199
     /*  13199 */   GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(13256), // Rule ID 987 //
     /*  13204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  13223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  13227 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  13232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13234 */     // (sub:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBWsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  13234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWsv8i16),
     /*  13237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13239 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  13241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  13245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13248 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13254 */     GIR_RootConstrainSelectedInstOperands,
     /*  13255 */     // GIR_Coverage, 987,
     /*  13255 */     GIR_EraseRootFromParent_Done,
     /*  13256 */   // Label 285: @13256
     /*  13256 */   GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(13313), // Rule ID 990 //
     /*  13261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13268 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  13280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  13284 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  13289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13291 */     // (sub:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  13291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv8i16),
     /*  13294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13296 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  13298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  13302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13305 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13311 */     GIR_RootConstrainSelectedInstOperands,
     /*  13312 */     // GIR_Coverage, 990,
     /*  13312 */     GIR_EraseRootFromParent_Done,
     /*  13313 */   // Label 286: @13313
     /*  13313 */   GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(13353), // Rule ID 964 //
     /*  13318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13333 */     // (sub:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VSUBv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  13333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv8i16),
     /*  13336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13338 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  13340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  13342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13345 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13351 */     GIR_RootConstrainSelectedInstOperands,
     /*  13352 */     // GIR_Coverage, 964,
     /*  13352 */     GIR_EraseRootFromParent_Done,
     /*  13353 */   // Label 287: @13353
     /*  13353 */   GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(13414), // Rule ID 3504 //
     /*  13358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  13361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13373 */     // (sub:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VSUBi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  13373 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13376 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13380 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSUBi16),
     /*  13388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  13390 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  13392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  13394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  13397 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13403 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13409 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  13412 */     GIR_RootConstrainSelectedInstOperands,
     /*  13413 */     // GIR_Coverage, 3504,
     /*  13413 */     GIR_EraseRootFromParent_Done,
     /*  13414 */   // Label 288: @13414
     /*  13414 */   GIM_Reject,
     /*  13415 */ // Label 277: @13415
     /*  13415 */ GIM_Reject,
     /*  13416 */ // Label 231: @13416
     /*  13416 */ GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(13599),
     /*  13421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  13424 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  13427 */   GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(13497), // Rule ID 918 //
     /*  13432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13439 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  13451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  13455 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  13459 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13464 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13471 */     // (sub:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src1, (mul:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm))  =>  (VMLSv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src1, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  13471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv16i8),
     /*  13474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13476 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  13478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  13482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  13486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13489 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13495 */     GIR_RootConstrainSelectedInstOperands,
     /*  13496 */     // GIR_Coverage, 918,
     /*  13496 */     GIR_EraseRootFromParent_Done,
     /*  13497 */   // Label 290: @13497
     /*  13497 */   GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(13537), // Rule ID 963 //
     /*  13502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13517 */     // (sub:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VSUBv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  13517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv16i8),
     /*  13520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13522 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  13524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  13526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13529 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13535 */     GIR_RootConstrainSelectedInstOperands,
     /*  13536 */     // GIR_Coverage, 963,
     /*  13536 */     GIR_EraseRootFromParent_Done,
     /*  13537 */   // Label 291: @13537
     /*  13537 */   GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(13598), // Rule ID 3500 //
     /*  13542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  13545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13557 */     // (sub:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VSUBi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  13557 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13560 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13564 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSUBi8),
     /*  13572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  13574 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  13576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  13578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  13581 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13587 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  13596 */     GIR_RootConstrainSelectedInstOperands,
     /*  13597 */     // GIR_Coverage, 3500,
     /*  13597 */     GIR_EraseRootFromParent_Done,
     /*  13598 */   // Label 292: @13598
     /*  13598 */   GIM_Reject,
     /*  13599 */ // Label 289: @13599
     /*  13599 */ GIM_Reject,
     /*  13600 */ // Label 232: @13600
     /*  13600 */ GIM_Reject,
     /*  13601 */ // Label 2: @13601
     /*  13601 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 300*/ GIMT_Encode4(15304),
     /*  13612 */ /*GILLT_s32*//*Label 293*/ GIMT_Encode4(13672), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  13624 */ /*GILLT_v2s32*//*Label 294*/ GIMT_Encode4(14591), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  13636 */ /*GILLT_v4s16*//*Label 295*/ GIMT_Encode4(14638),
     /*  13640 */ /*GILLT_v4s32*//*Label 296*/ GIMT_Encode4(14685), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  13652 */ /*GILLT_v8s8*//*Label 297*/ GIMT_Encode4(14914),
     /*  13656 */ /*GILLT_v8s16*//*Label 298*/ GIMT_Encode4(14961), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  13668 */ /*GILLT_v16s8*//*Label 299*/ GIMT_Encode4(15190),
     /*  13672 */ // Label 293: @13672
     /*  13672 */ GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(14590),
     /*  13677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  13680 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  13683 */   GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(13771), // Rule ID 186 //
     /*  13688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  13691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  13707 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  13711 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13716 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  13720 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  13724 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13728 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  13732 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  13736 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13741 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  13745 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13747 */     // (mul:{ *:[i32] } (sra:{ *:[i32] } GPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 16:{ *:[i32] }))  =>  (SMULTT:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  13747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULTT),
     /*  13750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  13752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  13756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13763 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13769 */     GIR_RootConstrainSelectedInstOperands,
     /*  13770 */     // GIR_Coverage, 186,
     /*  13770 */     GIR_EraseRootFromParent_Done,
     /*  13771 */   // Label 302: @13771
     /*  13771 */   GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(13859), // Rule ID 515 //
     /*  13776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  13779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  13783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  13795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  13799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  13804 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  13808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  13812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13816 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  13820 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  13824 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  13829 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  13833 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13835 */     // (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] }))  =>  (t2SMULTT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  13835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULTT),
     /*  13838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  13840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  13844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13851 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13857 */     GIR_RootConstrainSelectedInstOperands,
     /*  13858 */     // GIR_Coverage, 515,
     /*  13858 */     GIR_EraseRootFromParent_Done,
     /*  13859 */   // Label 303: @13859
     /*  13859 */   GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(13950), // Rule ID 185 //
     /*  13864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  13867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  13883 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  13887 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13892 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  13896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  13900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  13904 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  13908 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13913 */     // MIs[2] Operand 2
     /*  13913 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  13924 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13926 */     // (mul:{ *:[i32] } (sra:{ *:[i32] } GPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (SMULTB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  13926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULTB),
     /*  13929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  13931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  13935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13942 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13948 */     GIR_RootConstrainSelectedInstOperands,
     /*  13949 */     // GIR_Coverage, 185,
     /*  13949 */     GIR_EraseRootFromParent_Done,
     /*  13950 */   // Label 304: @13950
     /*  13950 */   GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(14041), // Rule ID 514 //
     /*  13955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  13958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  13962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  13974 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  13978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  13983 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  13987 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  13991 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  13995 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  13999 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14004 */     // MIs[2] Operand 2
     /*  14004 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  14015 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14017 */     // (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (t2SMULTB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  14017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULTB),
     /*  14020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14033 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14039 */     GIR_RootConstrainSelectedInstOperands,
     /*  14040 */     // GIR_Coverage, 514,
     /*  14040 */     GIR_EraseRootFromParent_Done,
     /*  14041 */   // Label 305: @14041
     /*  14041 */   GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(14132), // Rule ID 184 //
     /*  14046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  14049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  14065 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14070 */     // MIs[1] Operand 2
     /*  14070 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*  14081 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  14085 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  14089 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  14093 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  14097 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14102 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  14106 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14108 */     // (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 16:{ *:[i32] }))  =>  (SMULBT:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  14108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULBT),
     /*  14111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14124 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14130 */     GIR_RootConstrainSelectedInstOperands,
     /*  14131 */     // GIR_Coverage, 184,
     /*  14131 */     GIR_EraseRootFromParent_Done,
     /*  14132 */   // Label 306: @14132
     /*  14132 */   GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(14223), // Rule ID 513 //
     /*  14137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  14140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  14156 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14161 */     // MIs[1] Operand 2
     /*  14161 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*  14172 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  14176 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  14180 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  14184 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  14188 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14193 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  14197 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14199 */     // (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] }))  =>  (t2SMULBT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  14199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULBT),
     /*  14202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14215 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14221 */     GIR_RootConstrainSelectedInstOperands,
     /*  14222 */     // GIR_Coverage, 513,
     /*  14222 */     GIR_EraseRootFromParent_Done,
     /*  14223 */   // Label 307: @14223
     /*  14223 */   GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(14317), // Rule ID 183 //
     /*  14228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  14231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14243 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  14247 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14252 */     // MIs[1] Operand 2
     /*  14252 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*  14263 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  14267 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14271 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  14275 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14280 */     // MIs[2] Operand 2
     /*  14280 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  14291 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14293 */     // (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (SMULBB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  14293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULBB),
     /*  14296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14309 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14315 */     GIR_RootConstrainSelectedInstOperands,
     /*  14316 */     // GIR_Coverage, 183,
     /*  14316 */     GIR_EraseRootFromParent_Done,
     /*  14317 */   // Label 308: @14317
     /*  14317 */   GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(14411), // Rule ID 512 //
     /*  14322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  14325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  14341 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14346 */     // MIs[1] Operand 2
     /*  14346 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*  14357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  14361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14365 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  14369 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14374 */     // MIs[2] Operand 2
     /*  14374 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  14385 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14387 */     // (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (t2SMULBB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  14387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULBB),
     /*  14390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14403 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14409 */     GIR_RootConstrainSelectedInstOperands,
     /*  14410 */     // GIR_Coverage, 512,
     /*  14410 */     GIR_EraseRootFromParent_Done,
     /*  14411 */   // Label 309: @14411
     /*  14411 */   GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(14457), // Rule ID 169 //
     /*  14416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  14419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14431 */     // (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (MUL:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  14431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MUL),
     /*  14434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14436 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  14438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  14440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14443 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14449 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14455 */     GIR_RootConstrainSelectedInstOperands,
     /*  14456 */     // GIR_Coverage, 169,
     /*  14456 */     GIR_EraseRootFromParent_Done,
     /*  14457 */   // Label 310: @14457
     /*  14457 */   GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(14503), // Rule ID 170 //
     /*  14462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_NoV6_UseMulOps),
     /*  14465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14477 */     // (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (MULv5:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  14477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MULv5),
     /*  14480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14482 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  14484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  14486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14489 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14495 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14501 */     GIR_RootConstrainSelectedInstOperands,
     /*  14502 */     // GIR_Coverage, 170,
     /*  14502 */     GIR_EraseRootFromParent_Done,
     /*  14503 */   // Label 311: @14503
     /*  14503 */   GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(14549), // Rule ID 323 //
     /*  14508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  14511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  14515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  14519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  14523 */     // (mul:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tMUL:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  14523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tMUL),
     /*  14526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14528 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  14534 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  14536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  14538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14541 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14547 */     GIR_RootConstrainSelectedInstOperands,
     /*  14548 */     // GIR_Coverage, 323,
     /*  14548 */     GIR_EraseRootFromParent_Done,
     /*  14549 */   // Label 312: @14549
     /*  14549 */   GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(14589), // Rule ID 502 //
     /*  14554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  14557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14569 */     // (mul:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2MUL:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  14569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MUL),
     /*  14572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14574 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  14576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  14578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14581 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14587 */     GIR_RootConstrainSelectedInstOperands,
     /*  14588 */     // GIR_Coverage, 502,
     /*  14588 */     GIR_EraseRootFromParent_Done,
     /*  14589 */   // Label 313: @14589
     /*  14589 */   GIM_Reject,
     /*  14590 */ // Label 301: @14590
     /*  14590 */ GIM_Reject,
     /*  14591 */ // Label 294: @14591
     /*  14591 */ GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(14637), // Rule ID 837 //
     /*  14596 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14602 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14609 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14613 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14617 */   // (mul:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VMULv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  14617 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv2i32),
     /*  14620 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  14622 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  14624 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  14626 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14629 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14635 */   GIR_RootConstrainSelectedInstOperands,
     /*  14636 */   // GIR_Coverage, 837,
     /*  14636 */   GIR_EraseRootFromParent_Done,
     /*  14637 */ // Label 314: @14637
     /*  14637 */ GIM_Reject,
     /*  14638 */ // Label 295: @14638
     /*  14638 */ GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(14684), // Rule ID 836 //
     /*  14643 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  14649 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14656 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14660 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14664 */   // (mul:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VMULv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  14664 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv4i16),
     /*  14667 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  14669 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  14671 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  14673 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14676 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14682 */   GIR_RootConstrainSelectedInstOperands,
     /*  14683 */   // GIR_Coverage, 836,
     /*  14683 */   GIR_EraseRootFromParent_Done,
     /*  14684 */ // Label 315: @14684
     /*  14684 */ GIM_Reject,
     /*  14685 */ // Label 296: @14685
     /*  14685 */ GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(14913),
     /*  14690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14693 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14696 */   GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(14811), // Rule ID 4421 //
     /*  14701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  14704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14725 */     // MIs[1] Operand 2
     /*  14725 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*  14736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  14740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14744 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14748 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14753 */     // MIs[2] Operand 2
     /*  14753 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  14764 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14766 */     // (mul:{ *:[v4i32] } (sext_inreg:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src1, v4i16:{ *:[Other] }), (sext_inreg:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src2, v4i16:{ *:[Other] }))  =>  (MVE_VMULLBs16:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src1, MQPR:{ *:[v4i32] }:$src2)
     /*  14766 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14769 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  14773 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBs16),
     /*  14781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  14783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  14787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  14791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  14794 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14800 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  14809 */     GIR_RootConstrainSelectedInstOperands,
     /*  14810 */     // GIR_Coverage, 4421,
     /*  14810 */     GIR_EraseRootFromParent_Done,
     /*  14811 */   // Label 317: @14811
     /*  14811 */   GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(14851), // Rule ID 840 //
     /*  14816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  14823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  14827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  14831 */     // (mul:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VMULv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  14831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv4i32),
     /*  14834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  14836 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  14838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  14840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14843 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14849 */     GIR_RootConstrainSelectedInstOperands,
     /*  14850 */     // GIR_Coverage, 840,
     /*  14850 */     GIR_EraseRootFromParent_Done,
     /*  14851 */   // Label 318: @14851
     /*  14851 */   GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(14912), // Rule ID 3466 //
     /*  14856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  14859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14863 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14871 */     // (mul:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMULi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  14871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  14878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULi32),
     /*  14886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  14888 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  14890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  14892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  14895 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14901 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14907 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  14910 */     GIR_RootConstrainSelectedInstOperands,
     /*  14911 */     // GIR_Coverage, 3466,
     /*  14911 */     GIR_EraseRootFromParent_Done,
     /*  14912 */   // Label 319: @14912
     /*  14912 */   GIM_Reject,
     /*  14913 */ // Label 316: @14913
     /*  14913 */ GIM_Reject,
     /*  14914 */ // Label 297: @14914
     /*  14914 */ GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(14960), // Rule ID 835 //
     /*  14919 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  14925 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  14928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14932 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14936 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14940 */   // (mul:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMULv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  14940 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv8i8),
     /*  14943 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  14945 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  14947 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  14949 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14952 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14958 */   GIR_RootConstrainSelectedInstOperands,
     /*  14959 */   // GIR_Coverage, 835,
     /*  14959 */   GIR_EraseRootFromParent_Done,
     /*  14960 */ // Label 320: @14960
     /*  14960 */ GIM_Reject,
     /*  14961 */ // Label 298: @14961
     /*  14961 */ GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(15189),
     /*  14966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  14969 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  14972 */   GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(15087), // Rule ID 4426 //
     /*  14977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  14980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  14996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15001 */     // MIs[1] Operand 2
     /*  15001 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /*  15012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  15016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  15020 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  15024 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15029 */     // MIs[2] Operand 2
     /*  15029 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /*  15040 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  15042 */     // (mul:{ *:[v8i16] } (sext_inreg:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, v8i8:{ *:[Other] }), (sext_inreg:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src2, v8i8:{ *:[Other] }))  =>  (MVE_VMULLBs8:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, MQPR:{ *:[v8i16] }:$src2)
     /*  15042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  15045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  15049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBs8),
     /*  15057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  15059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  15063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  15067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15070 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15076 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15082 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  15085 */     GIR_RootConstrainSelectedInstOperands,
     /*  15086 */     // GIR_Coverage, 4426,
     /*  15086 */     GIR_EraseRootFromParent_Done,
     /*  15087 */   // Label 322: @15087
     /*  15087 */   GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(15127), // Rule ID 839 //
     /*  15092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15107 */     // (mul:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VMULv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  15107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv8i16),
     /*  15110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  15112 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  15114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  15116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15119 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15125 */     GIR_RootConstrainSelectedInstOperands,
     /*  15126 */     // GIR_Coverage, 839,
     /*  15126 */     GIR_EraseRootFromParent_Done,
     /*  15127 */   // Label 323: @15127
     /*  15127 */   GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(15188), // Rule ID 3462 //
     /*  15132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  15135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15147 */     // (mul:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMULi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  15147 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  15150 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  15154 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULi16),
     /*  15162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  15164 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  15166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  15168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15171 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15177 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15183 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  15186 */     GIR_RootConstrainSelectedInstOperands,
     /*  15187 */     // GIR_Coverage, 3462,
     /*  15187 */     GIR_EraseRootFromParent_Done,
     /*  15188 */   // Label 324: @15188
     /*  15188 */   GIM_Reject,
     /*  15189 */ // Label 321: @15189
     /*  15189 */ GIM_Reject,
     /*  15190 */ // Label 299: @15190
     /*  15190 */ GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(15303),
     /*  15195 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  15198 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  15201 */   GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(15241), // Rule ID 838 //
     /*  15206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15221 */     // (mul:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMULv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  15221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv16i8),
     /*  15224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  15226 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  15228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  15230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15233 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15239 */     GIR_RootConstrainSelectedInstOperands,
     /*  15240 */     // GIR_Coverage, 838,
     /*  15240 */     GIR_EraseRootFromParent_Done,
     /*  15241 */   // Label 326: @15241
     /*  15241 */   GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(15302), // Rule ID 3458 //
     /*  15246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  15249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15261 */     // (mul:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMULi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  15261 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  15264 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  15268 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULi8),
     /*  15276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  15278 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  15280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  15282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15285 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15291 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15297 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  15300 */     GIR_RootConstrainSelectedInstOperands,
     /*  15301 */     // GIR_Coverage, 3458,
     /*  15301 */     GIR_EraseRootFromParent_Done,
     /*  15302 */   // Label 327: @15302
     /*  15302 */   GIM_Reject,
     /*  15303 */ // Label 325: @15303
     /*  15303 */ GIM_Reject,
     /*  15304 */ // Label 300: @15304
     /*  15304 */ GIM_Reject,
     /*  15305 */ // Label 3: @15305
     /*  15305 */ GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(15400),
     /*  15310 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  15313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  15316 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  15319 */   GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(15359), // Rule ID 195 //
     /*  15324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDivideInARM_IsARM),
     /*  15327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15339 */     // (sdiv:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (SDIV:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  15339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SDIV),
     /*  15342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15344 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  15346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  15348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15351 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15357 */     GIR_RootConstrainSelectedInstOperands,
     /*  15358 */     // GIR_Coverage, 195,
     /*  15358 */     GIR_EraseRootFromParent_Done,
     /*  15359 */   // Label 329: @15359
     /*  15359 */   GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(15399), // Rule ID 532 //
     /*  15364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDivideInThumb_HasV8MBaseline_IsThumb),
     /*  15367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15379 */     // (sdiv:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SDIV:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  15379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SDIV),
     /*  15382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15384 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  15386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  15388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15391 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15397 */     GIR_RootConstrainSelectedInstOperands,
     /*  15398 */     // GIR_Coverage, 532,
     /*  15398 */     GIR_EraseRootFromParent_Done,
     /*  15399 */   // Label 330: @15399
     /*  15399 */   GIM_Reject,
     /*  15400 */ // Label 328: @15400
     /*  15400 */ GIM_Reject,
     /*  15401 */ // Label 4: @15401
     /*  15401 */ GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(15496),
     /*  15406 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  15409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  15412 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  15415 */   GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(15455), // Rule ID 196 //
     /*  15420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDivideInARM_IsARM),
     /*  15423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15427 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15435 */     // (udiv:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (UDIV:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  15435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UDIV),
     /*  15438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15440 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  15442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  15444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15447 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15453 */     GIR_RootConstrainSelectedInstOperands,
     /*  15454 */     // GIR_Coverage, 196,
     /*  15454 */     GIR_EraseRootFromParent_Done,
     /*  15455 */   // Label 332: @15455
     /*  15455 */   GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(15495), // Rule ID 533 //
     /*  15460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDivideInThumb_HasV8MBaseline_IsThumb),
     /*  15463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15475 */     // (udiv:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UDIV:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  15475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UDIV),
     /*  15478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15480 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  15482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  15484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15487 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15493 */     GIR_RootConstrainSelectedInstOperands,
     /*  15494 */     // GIR_Coverage, 533,
     /*  15494 */     GIR_EraseRootFromParent_Done,
     /*  15495 */   // Label 333: @15495
     /*  15495 */   GIM_Reject,
     /*  15496 */ // Label 331: @15496
     /*  15496 */ GIM_Reject,
     /*  15497 */ // Label 5: @15497
     /*  15497 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 347*/ GIMT_Encode4(18676),
     /*  15508 */ /*GILLT_s32*//*Label 334*/ GIMT_Encode4(15568),
     /*  15512 */ /*GILLT_s64*//*Label 335*/ GIMT_Encode4(17560),
     /*  15516 */ /*GILLT_v2s1*//*Label 336*/ GIMT_Encode4(17607),
     /*  15520 */ /*GILLT_v2s32*//*Label 337*/ GIMT_Encode4(17725),
     /*  15524 */ /*GILLT_v2s64*//*Label 338*/ GIMT_Encode4(17772),
     /*  15528 */ /*GILLT_v4s1*//*Label 339*/ GIMT_Encode4(17886),
     /*  15532 */ /*GILLT_v4s16*//*Label 340*/ GIMT_Encode4(18004),
     /*  15536 */ /*GILLT_v4s32*//*Label 341*/ GIMT_Encode4(18051), GIMT_Encode4(0),
     /*  15544 */ /*GILLT_v8s1*//*Label 342*/ GIMT_Encode4(18165),
     /*  15548 */ /*GILLT_v8s8*//*Label 343*/ GIMT_Encode4(18283),
     /*  15552 */ /*GILLT_v8s16*//*Label 344*/ GIMT_Encode4(18330), GIMT_Encode4(0),
     /*  15560 */ /*GILLT_v16s1*//*Label 345*/ GIMT_Encode4(18444),
     /*  15564 */ /*GILLT_v16s8*//*Label 346*/ GIMT_Encode4(18562),
     /*  15568 */ // Label 334: @15568
     /*  15568 */ GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(17559),
     /*  15573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  15576 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  15579 */   GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(15652), // Rule ID 1855 //
     /*  15584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  15587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  15591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  15599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  15603 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  15607 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15612 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  15616 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16711935),
     /*  15627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15629 */     // (and:{ *:[i32] } (srl:{ *:[i32] } GPR:{ *:[i32] }:$Src, 8:{ *:[i32] }), 16711935:{ *:[i32] })  =>  (UXTB16:{ *:[i32] } GPR:{ *:[i32] }:$Src, 1:{ *:[i32] })
     /*  15629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTB16),
     /*  15632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Src
     /*  15638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  15641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15644 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15650 */     GIR_RootConstrainSelectedInstOperands,
     /*  15651 */     // GIR_Coverage, 1855,
     /*  15651 */     GIR_EraseRootFromParent_Done,
     /*  15652 */   // Label 349: @15652
     /*  15652 */   GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(15725), // Rule ID 2112 //
     /*  15657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  15660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  15672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  15676 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  15680 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15685 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  15689 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16711935),
     /*  15700 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15702 */     // (and:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Src, 8:{ *:[i32] }), 16711935:{ *:[i32] })  =>  (t2UXTB16:{ *:[i32] } rGPR:{ *:[i32] }:$Src, 1:{ *:[i32] })
     /*  15702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTB16),
     /*  15705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Src
     /*  15711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  15714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15717 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15723 */     GIR_RootConstrainSelectedInstOperands,
     /*  15724 */     // GIR_Coverage, 2112,
     /*  15724 */     GIR_EraseRootFromParent_Done,
     /*  15725 */   // Label 350: @15725
     /*  15725 */   GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(15773), // Rule ID 1997 //
     /*  15730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  15733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  15737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15741 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  15752 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Src, 255:{ *:[i32] })  =>  (UXTB:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  15752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTB),
     /*  15755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15757 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /*  15759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15765 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15771 */     GIR_RootConstrainSelectedInstOperands,
     /*  15772 */     // GIR_Coverage, 1997,
     /*  15772 */     GIR_EraseRootFromParent_Done,
     /*  15773 */   // Label 351: @15773
     /*  15773 */   GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(15821), // Rule ID 1998 //
     /*  15778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  15781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  15785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15789 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  15800 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Src, 65535:{ *:[i32] })  =>  (UXTH:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  15800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTH),
     /*  15803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15805 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /*  15807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15813 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15819 */     GIR_RootConstrainSelectedInstOperands,
     /*  15820 */     // GIR_Coverage, 1998,
     /*  15820 */     GIR_EraseRootFromParent_Done,
     /*  15821 */   // Label 352: @15821
     /*  15821 */   GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(15869), // Rule ID 1999 //
     /*  15826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  15829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  15833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15837 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16711935),
     /*  15848 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Src, 16711935:{ *:[i32] })  =>  (UXTB16:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  15848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTB16),
     /*  15851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15853 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /*  15855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15861 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15867 */     GIR_RootConstrainSelectedInstOperands,
     /*  15868 */     // GIR_Coverage, 1999,
     /*  15868 */     GIR_EraseRootFromParent_Done,
     /*  15869 */   // Label 353: @15869
     /*  15869 */   GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(15917), // Rule ID 2236 //
     /*  15874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  15877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15885 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  15896 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 255:{ *:[i32] })  =>  (t2UXTB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  15896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTB),
     /*  15899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15901 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  15903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15909 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15915 */     GIR_RootConstrainSelectedInstOperands,
     /*  15916 */     // GIR_Coverage, 2236,
     /*  15916 */     GIR_EraseRootFromParent_Done,
     /*  15917 */   // Label 354: @15917
     /*  15917 */   GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(15965), // Rule ID 2237 //
     /*  15922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  15925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15933 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  15944 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] })  =>  (t2UXTH:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  15944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTH),
     /*  15947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15949 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  15951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15957 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15963 */     GIR_RootConstrainSelectedInstOperands,
     /*  15964 */     // GIR_Coverage, 2237,
     /*  15964 */     GIR_EraseRootFromParent_Done,
     /*  15965 */   // Label 355: @15965
     /*  15965 */   GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(16013), // Rule ID 2238 //
     /*  15970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  15973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15977 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15981 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16711935),
     /*  15992 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16711935:{ *:[i32] })  =>  (t2UXTB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  15992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTB16),
     /*  15995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15997 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  15999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  16002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16005 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16011 */     GIR_RootConstrainSelectedInstOperands,
     /*  16012 */     // GIR_Coverage, 2238,
     /*  16012 */     GIR_EraseRootFromParent_Done,
     /*  16013 */   // Label 356: @16013
     /*  16013 */   GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(16090), // Rule ID 5439 //
     /*  16018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16041 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  16045 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16049 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16053 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  16057 */     // MIs[2] Operand 1
     /*  16057 */     // No operand predicates
     /*  16057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16061 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16063 */     // (and:{ *:[i32] } (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm), GPR:{ *:[i32] }:$Rn)  =>  (BICri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICri),
     /*  16066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16070 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16076 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16082 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16088 */     GIR_RootConstrainSelectedInstOperands,
     /*  16089 */     // GIR_Coverage, 5439,
     /*  16089 */     GIR_EraseRootFromParent_Done,
     /*  16090 */   // Label 357: @16090
     /*  16090 */   GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(16167), // Rule ID 5472 //
     /*  16095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16110 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16114 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16118 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  16122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16130 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  16134 */     // MIs[2] Operand 1
     /*  16134 */     // No operand predicates
     /*  16134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16138 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16140 */     // (and:{ *:[i32] } (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm), rGPR:{ *:[i32] }:$Rn)  =>  (t2BICri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICri),
     /*  16143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16153 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16159 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16165 */     GIR_RootConstrainSelectedInstOperands,
     /*  16166 */     // GIR_Coverage, 5472,
     /*  16166 */     GIR_EraseRootFromParent_Done,
     /*  16167 */   // Label 358: @16167
     /*  16167 */   GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(16244), // Rule ID 5438 //
     /*  16172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16191 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16203 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  16207 */     // MIs[2] Operand 1
     /*  16207 */     // No operand predicates
     /*  16207 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16215 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16217 */     // (and:{ *:[i32] } (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm, -1:{ *:[i32] }), GPR:{ *:[i32] }:$Rn)  =>  (BICri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICri),
     /*  16220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16224 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16230 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16236 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16242 */     GIR_RootConstrainSelectedInstOperands,
     /*  16243 */     // GIR_Coverage, 5438,
     /*  16243 */     GIR_EraseRootFromParent_Done,
     /*  16244 */   // Label 359: @16244
     /*  16244 */   GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(16321), // Rule ID 5471 //
     /*  16249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16268 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16272 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16276 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16280 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  16284 */     // MIs[2] Operand 1
     /*  16284 */     // No operand predicates
     /*  16284 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16292 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16294 */     // (and:{ *:[i32] } (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, -1:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2BICri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICri),
     /*  16297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16307 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16313 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16319 */     GIR_RootConstrainSelectedInstOperands,
     /*  16320 */     // GIR_Coverage, 5471,
     /*  16320 */     GIR_EraseRootFromParent_Done,
     /*  16321 */   // Label 360: @16321
     /*  16321 */   GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(16398), // Rule ID 5437 //
     /*  16326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16349 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16353 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  16357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16365 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  16369 */     // MIs[2] Operand 1
     /*  16369 */     // No operand predicates
     /*  16369 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16371 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm))  =>  (BICri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICri),
     /*  16374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16376 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16378 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16384 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16390 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16396 */     GIR_RootConstrainSelectedInstOperands,
     /*  16397 */     // GIR_Coverage, 5437,
     /*  16397 */     GIR_EraseRootFromParent_Done,
     /*  16398 */   // Label 361: @16398
     /*  16398 */   GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(16475), // Rule ID 5470 //
     /*  16403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16426 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16430 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  16434 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16438 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16442 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  16446 */     // MIs[2] Operand 1
     /*  16446 */     // No operand predicates
     /*  16446 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16448 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm))  =>  (t2BICri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICri),
     /*  16451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16453 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16455 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16461 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16467 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16473 */     GIR_RootConstrainSelectedInstOperands,
     /*  16474 */     // GIR_Coverage, 5470,
     /*  16474 */     GIR_EraseRootFromParent_Done,
     /*  16475 */   // Label 362: @16475
     /*  16475 */   GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(16552), // Rule ID 159 //
     /*  16480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16503 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16507 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16511 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16515 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  16519 */     // MIs[2] Operand 1
     /*  16519 */     // No operand predicates
     /*  16519 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16523 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16525 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm, -1:{ *:[i32] }))  =>  (BICri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICri),
     /*  16528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16530 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16532 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16538 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16544 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16550 */     GIR_RootConstrainSelectedInstOperands,
     /*  16551 */     // GIR_Coverage, 159,
     /*  16551 */     GIR_EraseRootFromParent_Done,
     /*  16552 */   // Label 363: @16552
     /*  16552 */   GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(16629), // Rule ID 490 //
     /*  16557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16564 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16580 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16592 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  16596 */     // MIs[2] Operand 1
     /*  16596 */     // No operand predicates
     /*  16596 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16600 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16602 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, -1:{ *:[i32] }))  =>  (t2BICri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICri),
     /*  16605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16607 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16609 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16615 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16621 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16627 */     GIR_RootConstrainSelectedInstOperands,
     /*  16628 */     // GIR_Coverage, 490,
     /*  16628 */     GIR_EraseRootFromParent_Done,
     /*  16629 */   // Label 364: @16629
     /*  16629 */   GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(16700), // Rule ID 5440 //
     /*  16634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16649 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16653 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16657 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16662 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16670 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16672 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }), GPR:{ *:[i32] }:$Rn)  =>  (BICrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  16672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICrr),
     /*  16675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  16683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16686 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16692 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16698 */     GIR_RootConstrainSelectedInstOperands,
     /*  16699 */     // GIR_Coverage, 5440,
     /*  16699 */     GIR_EraseRootFromParent_Done,
     /*  16700 */   // Label 365: @16700
     /*  16700 */   GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(16771), // Rule ID 5461 //
     /*  16705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  16708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16720 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16724 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16728 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16733 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16743 */     // (and:{ *:[i32] } (xor:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }), tGPR:{ *:[i32] }:$Rn)  =>  (tBIC:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  16743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tBIC),
     /*  16746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  16748 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  16754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  16760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16763 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16769 */     GIR_RootConstrainSelectedInstOperands,
     /*  16770 */     // GIR_Coverage, 5461,
     /*  16770 */     GIR_EraseRootFromParent_Done,
     /*  16771 */   // Label 366: @16771
     /*  16771 */   GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(16842), // Rule ID 5473 //
     /*  16776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16804 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16812 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16814 */     // (and:{ *:[i32] } (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2BICrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  16814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICrr),
     /*  16817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  16825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16828 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16834 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16840 */     GIR_RootConstrainSelectedInstOperands,
     /*  16841 */     // GIR_Coverage, 5473,
     /*  16841 */     GIR_EraseRootFromParent_Done,
     /*  16842 */   // Label 367: @16842
     /*  16842 */   GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(16913), // Rule ID 160 //
     /*  16847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16866 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16870 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16874 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16879 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16885 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } GPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (BICrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  16885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICrr),
     /*  16888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16890 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  16896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16899 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16905 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16911 */     GIR_RootConstrainSelectedInstOperands,
     /*  16912 */     // GIR_Coverage, 160,
     /*  16912 */     GIR_EraseRootFromParent_Done,
     /*  16913 */   // Label 368: @16913
     /*  16913 */   GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(16984), // Rule ID 313 //
     /*  16918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  16921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16941 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16945 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16950 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16954 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16956 */     // (and:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (tBIC:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  16956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tBIC),
     /*  16959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  16961 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  16967 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  16973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16976 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16982 */     GIR_RootConstrainSelectedInstOperands,
     /*  16983 */     // GIR_Coverage, 313,
     /*  16983 */     GIR_EraseRootFromParent_Done,
     /*  16984 */   // Label 369: @16984
     /*  16984 */   GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(17055), // Rule ID 491 //
     /*  16989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  17012 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17016 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17021 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  17025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17027 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (t2BICrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  17027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICrr),
     /*  17030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17032 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  17038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17041 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17047 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17053 */     GIR_RootConstrainSelectedInstOperands,
     /*  17054 */     // GIR_Coverage, 491,
     /*  17054 */     GIR_EraseRootFromParent_Done,
     /*  17055 */   // Label 370: @17055
     /*  17055 */   GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(17100), // Rule ID 345 //
     /*  17060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /*  17063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17071 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  17082 */     // (and:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, 255:{ *:[i32] })  =>  (tUXTB:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /*  17082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tUXTB),
     /*  17085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17087 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  17089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17092 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17098 */     GIR_RootConstrainSelectedInstOperands,
     /*  17099 */     // GIR_Coverage, 345,
     /*  17099 */     GIR_EraseRootFromParent_Done,
     /*  17100 */   // Label 371: @17100
     /*  17100 */   GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(17145), // Rule ID 346 //
     /*  17105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /*  17108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17112 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17116 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  17127 */     // (and:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] })  =>  (tUXTH:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /*  17127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tUXTH),
     /*  17130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17132 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  17134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17137 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17143 */     GIR_RootConstrainSelectedInstOperands,
     /*  17144 */     // GIR_Coverage, 346,
     /*  17144 */     GIR_EraseRootFromParent_Done,
     /*  17145 */   // Label 372: @17145
     /*  17145 */   GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(17204), // Rule ID 1894 //
     /*  17150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  17153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17169 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm_not),
     /*  17173 */     // MIs[1] Operand 1
     /*  17173 */     // No operand predicates
     /*  17173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17175 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_mod_imm_not>><<X:imm_not_XFORM>>:$imm)  =>  (BICri:{ *:[i32] } GPR:{ *:[i32] }:$src, (imm_not_XFORM:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_mod_imm_not>>:$imm))
     /*  17175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICri),
     /*  17178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17180 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  17182 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderInvertedImm), // imm
     /*  17187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17190 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17196 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17202 */     GIR_RootConstrainSelectedInstOperands,
     /*  17203 */     // GIR_Coverage, 1894,
     /*  17203 */     GIR_EraseRootFromParent_Done,
     /*  17204 */   // Label 373: @17204
     /*  17204 */   GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(17261), // Rule ID 147 //
     /*  17209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  17212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17228 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  17232 */     // MIs[1] Operand 1
     /*  17232 */     // No operand predicates
     /*  17232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17234 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm)  =>  (ANDri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  17234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ANDri),
     /*  17237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17239 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17241 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  17244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17247 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17253 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17259 */     GIR_RootConstrainSelectedInstOperands,
     /*  17260 */     // GIR_Coverage, 147,
     /*  17260 */     GIR_EraseRootFromParent_Done,
     /*  17261 */   // Label 374: @17261
     /*  17261 */   GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(17318), // Rule ID 481 //
     /*  17266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  17269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17285 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  17289 */     // MIs[1] Operand 1
     /*  17289 */     // No operand predicates
     /*  17289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17291 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2ANDri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  17291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ANDri),
     /*  17294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17296 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17298 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  17301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17304 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17310 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17316 */     GIR_RootConstrainSelectedInstOperands,
     /*  17317 */     // GIR_Coverage, 481,
     /*  17317 */     GIR_EraseRootFromParent_Done,
     /*  17318 */   // Label 375: @17318
     /*  17318 */   GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(17369), // Rule ID 163 //
     /*  17323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6T2_IsARM),
     /*  17326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17342 */     // MIs[1] Operand 1
     /*  17342 */     // No operand predicates
     /*  17342 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_bf_inv_mask_imm),
     /*  17346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17348 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_bf_inv_mask_imm>>:$imm)  =>  (BFC:{ *:[i32] } GPR:{ *:[i32] }:$src, (imm:{ *:[i32] }):$imm)
     /*  17348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BFC),
     /*  17351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17353 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  17355 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  17358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17361 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17367 */     GIR_RootConstrainSelectedInstOperands,
     /*  17368 */     // GIR_Coverage, 163,
     /*  17368 */     GIR_EraseRootFromParent_Done,
     /*  17369 */   // Label 376: @17369
     /*  17369 */   GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(17420), // Rule ID 493 //
     /*  17374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  17377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17393 */     // MIs[1] Operand 1
     /*  17393 */     // No operand predicates
     /*  17393 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_bf_inv_mask_imm),
     /*  17397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17399 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_bf_inv_mask_imm>>:$imm)  =>  (t2BFC:{ *:[i32] } rGPR:{ *:[i32] }:$src, (imm:{ *:[i32] }):$imm)
     /*  17399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BFC),
     /*  17402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17404 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  17406 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  17409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17412 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17418 */     GIR_RootConstrainSelectedInstOperands,
     /*  17419 */     // GIR_Coverage, 493,
     /*  17419 */     GIR_EraseRootFromParent_Done,
     /*  17420 */   // Label 377: @17420
     /*  17420 */   GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(17466), // Rule ID 148 //
     /*  17425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  17428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17440 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (ANDrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  17440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ANDrr),
     /*  17443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17445 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  17449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17452 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17458 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17464 */     GIR_RootConstrainSelectedInstOperands,
     /*  17465 */     // GIR_Coverage, 148,
     /*  17465 */     GIR_EraseRootFromParent_Done,
     /*  17466 */   // Label 378: @17466
     /*  17466 */   GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(17512), // Rule ID 310 //
     /*  17471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  17474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17486 */     // (and:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tAND:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  17486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tAND),
     /*  17489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  17491 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  17497 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  17501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17504 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17510 */     GIR_RootConstrainSelectedInstOperands,
     /*  17511 */     // GIR_Coverage, 310,
     /*  17511 */     GIR_EraseRootFromParent_Done,
     /*  17512 */   // Label 379: @17512
     /*  17512 */   GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(17558), // Rule ID 482 //
     /*  17517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  17520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17532 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2ANDrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  17532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ANDrr),
     /*  17535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17537 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  17541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17544 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17550 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17556 */     GIR_RootConstrainSelectedInstOperands,
     /*  17557 */     // GIR_Coverage, 482,
     /*  17557 */     GIR_EraseRootFromParent_Done,
     /*  17558 */   // Label 380: @17558
     /*  17558 */   GIM_Reject,
     /*  17559 */ // Label 348: @17559
     /*  17559 */ GIM_Reject,
     /*  17560 */ // Label 335: @17560
     /*  17560 */ GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(17606), // Rule ID 2526 //
     /*  17565 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  17571 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  17574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17578 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17582 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17586 */   // (and:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)  =>  (VANDd:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)
     /*  17586 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDd),
     /*  17589 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  17591 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  17593 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  17595 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17598 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17604 */   GIR_RootConstrainSelectedInstOperands,
     /*  17605 */   // GIR_Coverage, 2526,
     /*  17605 */   GIR_EraseRootFromParent_Done,
     /*  17606 */ // Label 381: @17606
     /*  17606 */ GIM_Reject,
     /*  17607 */ // Label 336: @17607
     /*  17607 */ GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(17724), // Rule ID 1826 //
     /*  17612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  17615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  17618 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  17621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17625 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17629 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17633 */   // (and:{ *:[v2i1] } VCCR:{ *:[v2i1] }:$p1, VCCR:{ *:[v2i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (t2ANDrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  17633 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  17636 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17640 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17645 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  17649 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17654 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  17657 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17661 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17666 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  17670 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17675 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  17678 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ANDrr),
     /*  17682 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17687 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  17690 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  17693 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  17696 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17702 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17708 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  17710 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17713 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17715 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  17718 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17723 */   // GIR_Coverage, 1826,
     /*  17723 */   GIR_EraseRootFromParent_Done,
     /*  17724 */ // Label 382: @17724
     /*  17724 */ GIM_Reject,
     /*  17725 */ // Label 337: @17725
     /*  17725 */ GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(17771), // Rule ID 1133 //
     /*  17730 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17736 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17743 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17747 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17751 */   // (and:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VANDd:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  17751 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDd),
     /*  17754 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  17756 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  17758 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  17760 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17763 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17769 */   GIR_RootConstrainSelectedInstOperands,
     /*  17770 */   // GIR_Coverage, 1133,
     /*  17770 */   GIR_EraseRootFromParent_Done,
     /*  17771 */ // Label 383: @17771
     /*  17771 */ GIM_Reject,
     /*  17772 */ // Label 338: @17772
     /*  17772 */ GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(17885),
     /*  17777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  17780 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  17783 */   GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(17823), // Rule ID 2529 //
     /*  17788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  17795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  17799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  17803 */     // (and:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)  =>  (VANDq:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)
     /*  17803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDq),
     /*  17806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  17808 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  17810 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  17812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17815 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17821 */     GIR_RootConstrainSelectedInstOperands,
     /*  17822 */     // GIR_Coverage, 2529,
     /*  17822 */     GIR_EraseRootFromParent_Done,
     /*  17823 */   // Label 385: @17823
     /*  17823 */   GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(17884), // Rule ID 3370 //
     /*  17828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  17831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  17835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  17839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  17843 */     // (and:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)  =>  (MVE_VAND:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)
     /*  17843 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  17846 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  17850 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VAND),
     /*  17858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  17860 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  17862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  17864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  17867 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17873 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  17882 */     GIR_RootConstrainSelectedInstOperands,
     /*  17883 */     // GIR_Coverage, 3370,
     /*  17883 */     GIR_EraseRootFromParent_Done,
     /*  17884 */   // Label 386: @17884
     /*  17884 */   GIM_Reject,
     /*  17885 */ // Label 384: @17885
     /*  17885 */ GIM_Reject,
     /*  17886 */ // Label 339: @17886
     /*  17886 */ GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(18003), // Rule ID 1827 //
     /*  17891 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  17894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  17897 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  17900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17904 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17908 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17912 */   // (and:{ *:[v4i1] } VCCR:{ *:[v4i1] }:$p1, VCCR:{ *:[v4i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (t2ANDrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  17912 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  17915 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17919 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17924 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  17928 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17933 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  17936 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17940 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17945 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  17949 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17954 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  17957 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ANDrr),
     /*  17961 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17966 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  17969 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  17972 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  17975 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17981 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17987 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  17989 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17992 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17994 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  17997 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18002 */   // GIR_Coverage, 1827,
     /*  18002 */   GIR_EraseRootFromParent_Done,
     /*  18003 */ // Label 387: @18003
     /*  18003 */ GIM_Reject,
     /*  18004 */ // Label 340: @18004
     /*  18004 */ GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(18050), // Rule ID 2525 //
     /*  18009 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  18015 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  18018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18022 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18026 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18030 */   // (and:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)  =>  (VANDd:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)
     /*  18030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDd),
     /*  18033 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  18035 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  18037 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  18039 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18042 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18048 */   GIR_RootConstrainSelectedInstOperands,
     /*  18049 */   // GIR_Coverage, 2525,
     /*  18049 */   GIR_EraseRootFromParent_Done,
     /*  18050 */ // Label 388: @18050
     /*  18050 */ GIM_Reject,
     /*  18051 */ // Label 341: @18051
     /*  18051 */ GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(18164),
     /*  18056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18059 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18062 */   GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(18102), // Rule ID 1134 //
     /*  18067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18074 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18082 */     // (and:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VANDq:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  18082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDq),
     /*  18085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  18087 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  18089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  18091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18094 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18100 */     GIR_RootConstrainSelectedInstOperands,
     /*  18101 */     // GIR_Coverage, 1134,
     /*  18101 */     GIR_EraseRootFromParent_Done,
     /*  18102 */   // Label 390: @18102
     /*  18102 */   GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(18163), // Rule ID 3366 //
     /*  18107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  18110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18122 */     // (and:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VAND:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  18122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  18125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  18129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VAND),
     /*  18137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  18139 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  18141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  18143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  18146 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18152 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18158 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  18161 */     GIR_RootConstrainSelectedInstOperands,
     /*  18162 */     // GIR_Coverage, 3366,
     /*  18162 */     GIR_EraseRootFromParent_Done,
     /*  18163 */   // Label 391: @18163
     /*  18163 */   GIM_Reject,
     /*  18164 */ // Label 389: @18164
     /*  18164 */ GIM_Reject,
     /*  18165 */ // Label 342: @18165
     /*  18165 */ GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(18282), // Rule ID 1828 //
     /*  18170 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  18173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  18176 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  18179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18183 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18187 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18191 */   // (and:{ *:[v8i1] } VCCR:{ *:[v8i1] }:$p1, VCCR:{ *:[v8i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (t2ANDrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  18191 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  18194 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18198 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18203 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  18207 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18212 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  18215 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18219 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18224 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  18228 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18233 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  18236 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ANDrr),
     /*  18240 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18245 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  18248 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  18251 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  18254 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18260 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18266 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  18268 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18271 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18273 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  18276 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18281 */   // GIR_Coverage, 1828,
     /*  18281 */   GIR_EraseRootFromParent_Done,
     /*  18282 */ // Label 392: @18282
     /*  18282 */ GIM_Reject,
     /*  18283 */ // Label 343: @18283
     /*  18283 */ GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(18329), // Rule ID 2524 //
     /*  18288 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  18294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  18297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18301 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18305 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18309 */   // (and:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)  =>  (VANDd:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)
     /*  18309 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDd),
     /*  18312 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  18314 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  18316 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  18318 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18321 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18327 */   GIR_RootConstrainSelectedInstOperands,
     /*  18328 */   // GIR_Coverage, 2524,
     /*  18328 */   GIR_EraseRootFromParent_Done,
     /*  18329 */ // Label 393: @18329
     /*  18329 */ GIM_Reject,
     /*  18330 */ // Label 344: @18330
     /*  18330 */ GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(18443),
     /*  18335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  18338 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  18341 */   GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(18381), // Rule ID 2528 //
     /*  18346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18361 */     // (and:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)  =>  (VANDq:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)
     /*  18361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDq),
     /*  18364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  18366 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  18368 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  18370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18373 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18379 */     GIR_RootConstrainSelectedInstOperands,
     /*  18380 */     // GIR_Coverage, 2528,
     /*  18380 */     GIR_EraseRootFromParent_Done,
     /*  18381 */   // Label 395: @18381
     /*  18381 */   GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(18442), // Rule ID 3362 //
     /*  18386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  18389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18401 */     // (and:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VAND:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  18401 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  18404 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  18408 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VAND),
     /*  18416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  18418 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  18420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  18422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  18425 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18431 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18437 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  18440 */     GIR_RootConstrainSelectedInstOperands,
     /*  18441 */     // GIR_Coverage, 3362,
     /*  18441 */     GIR_EraseRootFromParent_Done,
     /*  18442 */   // Label 396: @18442
     /*  18442 */   GIM_Reject,
     /*  18443 */ // Label 394: @18443
     /*  18443 */ GIM_Reject,
     /*  18444 */ // Label 345: @18444
     /*  18444 */ GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(18561), // Rule ID 1829 //
     /*  18449 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  18452 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  18455 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  18458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18462 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18466 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18470 */   // (and:{ *:[v16i1] } VCCR:{ *:[v16i1] }:$p1, VCCR:{ *:[v16i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } (t2ANDrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  18470 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  18473 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18477 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18482 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  18486 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18491 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  18494 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18498 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18503 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  18507 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18512 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  18515 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ANDrr),
     /*  18519 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18524 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  18527 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  18530 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  18533 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18539 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18545 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  18547 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18550 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18552 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  18555 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18560 */   // GIR_Coverage, 1829,
     /*  18560 */   GIR_EraseRootFromParent_Done,
     /*  18561 */ // Label 397: @18561
     /*  18561 */ GIM_Reject,
     /*  18562 */ // Label 346: @18562
     /*  18562 */ GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(18675),
     /*  18567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  18570 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  18573 */   GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(18613), // Rule ID 2527 //
     /*  18578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18593 */     // (and:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)  =>  (VANDq:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)
     /*  18593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDq),
     /*  18596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  18598 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  18600 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  18602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18605 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18611 */     GIR_RootConstrainSelectedInstOperands,
     /*  18612 */     // GIR_Coverage, 2527,
     /*  18612 */     GIR_EraseRootFromParent_Done,
     /*  18613 */   // Label 399: @18613
     /*  18613 */   GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(18674), // Rule ID 3358 //
     /*  18618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  18621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18633 */     // (and:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VAND:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  18633 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  18636 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  18640 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VAND),
     /*  18648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  18650 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  18652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  18654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  18657 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18663 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18669 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  18672 */     GIR_RootConstrainSelectedInstOperands,
     /*  18673 */     // GIR_Coverage, 3358,
     /*  18673 */     GIR_EraseRootFromParent_Done,
     /*  18674 */   // Label 400: @18674
     /*  18674 */   GIM_Reject,
     /*  18675 */ // Label 398: @18675
     /*  18675 */ GIM_Reject,
     /*  18676 */ // Label 347: @18676
     /*  18676 */ GIM_Reject,
     /*  18677 */ // Label 6: @18677
     /*  18677 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 414*/ GIMT_Encode4(24485),
     /*  18688 */ /*GILLT_s32*//*Label 401*/ GIMT_Encode4(18748),
     /*  18692 */ /*GILLT_s64*//*Label 402*/ GIMT_Encode4(23369),
     /*  18696 */ /*GILLT_v2s1*//*Label 403*/ GIMT_Encode4(23416),
     /*  18700 */ /*GILLT_v2s32*//*Label 404*/ GIMT_Encode4(23534),
     /*  18704 */ /*GILLT_v2s64*//*Label 405*/ GIMT_Encode4(23581),
     /*  18708 */ /*GILLT_v4s1*//*Label 406*/ GIMT_Encode4(23695),
     /*  18712 */ /*GILLT_v4s16*//*Label 407*/ GIMT_Encode4(23813),
     /*  18716 */ /*GILLT_v4s32*//*Label 408*/ GIMT_Encode4(23860), GIMT_Encode4(0),
     /*  18724 */ /*GILLT_v8s1*//*Label 409*/ GIMT_Encode4(23974),
     /*  18728 */ /*GILLT_v8s8*//*Label 410*/ GIMT_Encode4(24092),
     /*  18732 */ /*GILLT_v8s16*//*Label 411*/ GIMT_Encode4(24139), GIMT_Encode4(0),
     /*  18740 */ /*GILLT_v16s1*//*Label 412*/ GIMT_Encode4(24253),
     /*  18744 */ /*GILLT_v16s8*//*Label 413*/ GIMT_Encode4(24371),
     /*  18748 */ // Label 401: @18748
     /*  18748 */ GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(23368),
     /*  18753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  18756 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  18759 */   GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(18886), // Rule ID 5655 //
     /*  18764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  18767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  18771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18779 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  18783 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  18787 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18791 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  18795 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  18799 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  18803 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  18808 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  18812 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*  18823 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  18827 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  18831 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  18835 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  18839 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  18843 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  18847 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  18851 */     // MIs[4] Rm
     /*  18851 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18856 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*  18860 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  18864 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  18866 */     // (or:{ *:[i32] } (and:{ *:[i32] } (srl:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), 255:{ *:[i32] }), (sra:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), 16:{ *:[i32] }))  =>  (REVSH:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /*  18866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::REVSH),
     /*  18869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  18871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18878 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18884 */     GIR_RootConstrainSelectedInstOperands,
     /*  18885 */     // GIR_Coverage, 5655,
     /*  18885 */     GIR_EraseRootFromParent_Done,
     /*  18886 */   // Label 416: @18886
     /*  18886 */   GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(19013), // Rule ID 5697 //
     /*  18891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  18894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  18910 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  18914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18918 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  18922 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  18926 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  18930 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18935 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  18939 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*  18950 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  18954 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  18958 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  18962 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  18966 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  18970 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  18974 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  18978 */     // MIs[4] Rm
     /*  18978 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18983 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*  18987 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  18991 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  18993 */     // (or:{ *:[i32] } (and:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), 255:{ *:[i32] }), (sra:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), 16:{ *:[i32] }))  =>  (t2REVSH:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /*  18993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2REVSH),
     /*  18996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  18998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19005 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19011 */     GIR_RootConstrainSelectedInstOperands,
     /*  19012 */     // GIR_Coverage, 5697,
     /*  19012 */     GIR_EraseRootFromParent_Done,
     /*  19013 */   // Label 417: @19013
     /*  19013 */   GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(19140), // Rule ID 1914 //
     /*  19018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  19021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  19025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  19033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  19049 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19053 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19057 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  19062 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  19066 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  19070 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19074 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19078 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  19082 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  19086 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19090 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19094 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19098 */     // MIs[4] Rm
     /*  19098 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19103 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  19107 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(255),
     /*  19118 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19120 */     // (or:{ *:[i32] } (sra:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), 16:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), 255:{ *:[i32] }))  =>  (REVSH:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /*  19120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::REVSH),
     /*  19123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19132 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19138 */     GIR_RootConstrainSelectedInstOperands,
     /*  19139 */     // GIR_Coverage, 1914,
     /*  19139 */     GIR_EraseRootFromParent_Done,
     /*  19140 */   // Label 418: @19140
     /*  19140 */   GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(19267), // Rule ID 2196 //
     /*  19145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  19148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  19160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19164 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19168 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19172 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  19176 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19180 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19184 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19189 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  19193 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  19197 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19201 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19205 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  19209 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  19213 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19217 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19221 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19225 */     // MIs[4] Rm
     /*  19225 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19230 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  19234 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(255),
     /*  19245 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19247 */     // (or:{ *:[i32] } (sra:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), 16:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), 255:{ *:[i32] }))  =>  (t2REVSH:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /*  19247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2REVSH),
     /*  19250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19259 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19265 */     GIR_RootConstrainSelectedInstOperands,
     /*  19266 */     // GIR_Coverage, 2196,
     /*  19266 */     GIR_EraseRootFromParent_Done,
     /*  19267 */   // Label 419: @19267
     /*  19267 */   GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(19400), // Rule ID 5453 //
     /*  19272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  19275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19291 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19295 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19299 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  19303 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19307 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19311 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19316 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19320 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19324 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_asr_amt),
     /*  19328 */     // MIs[3] Operand 1
     /*  19328 */     // No operand predicates
     /*  19328 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  19339 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  19343 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19347 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  19351 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19355 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19360 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(4294901760),
     /*  19371 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19373 */     // (or:{ *:[i32] } (and:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_asr_amt>>:$sh), 65535:{ *:[i32] }), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 4294901760:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  19373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  19376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  19382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19386 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  19389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19392 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19398 */     GIR_RootConstrainSelectedInstOperands,
     /*  19399 */     // GIR_Coverage, 5453,
     /*  19399 */     GIR_EraseRootFromParent_Done,
     /*  19400 */   // Label 420: @19400
     /*  19400 */   GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(19533), // Rule ID 5490 //
     /*  19405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  19408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19424 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  19436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19440 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19444 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19449 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19453 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19457 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_asr_amt),
     /*  19461 */     // MIs[3] Operand 1
     /*  19461 */     // No operand predicates
     /*  19461 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  19472 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  19476 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19480 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  19484 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19488 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19493 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(4294901760),
     /*  19504 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19506 */     // (or:{ *:[i32] } (and:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_asr_amt>>:$sh), 65535:{ *:[i32] }), (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 4294901760:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  19506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  19509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  19515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19519 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  19522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19525 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19531 */     GIR_RootConstrainSelectedInstOperands,
     /*  19532 */     // GIR_Coverage, 5490,
     /*  19532 */     GIR_EraseRootFromParent_Done,
     /*  19533 */   // Label 421: @19533
     /*  19533 */   GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(19666), // Rule ID 5660 //
     /*  19538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  19541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19553 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19557 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19561 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19565 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19569 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19573 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19577 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19582 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19586 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19590 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_15),
     /*  19594 */     // MIs[3] Operand 1
     /*  19594 */     // No operand predicates
     /*  19594 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  19605 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  19609 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19613 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  19617 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19621 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19626 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(4294901760),
     /*  19637 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19639 */     // (or:{ *:[i32] } (and:{ *:[i32] } (srl:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh), 65535:{ *:[i32] }), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh)
     /*  19639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  19642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src1
     /*  19648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  19652 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  19655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19658 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19664 */     GIR_RootConstrainSelectedInstOperands,
     /*  19665 */     // GIR_Coverage, 5660,
     /*  19665 */     GIR_EraseRootFromParent_Done,
     /*  19666 */   // Label 422: @19666
     /*  19666 */   GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(19799), // Rule ID 5702 //
     /*  19671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  19674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19690 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19694 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19698 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19702 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19706 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19710 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19715 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19719 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19723 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_15),
     /*  19727 */     // MIs[3] Operand 1
     /*  19727 */     // No operand predicates
     /*  19727 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  19738 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  19742 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19746 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  19750 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19754 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19759 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(4294901760),
     /*  19770 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19772 */     // (or:{ *:[i32] } (and:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh), 65535:{ *:[i32] }), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh)
     /*  19772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  19775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19777 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src1
     /*  19781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  19785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  19788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19791 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19797 */     GIR_RootConstrainSelectedInstOperands,
     /*  19798 */     // GIR_Coverage, 5702,
     /*  19798 */     GIR_EraseRootFromParent_Done,
     /*  19799 */   // Label 423: @19799
     /*  19799 */   GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(19932), // Rule ID 5452 //
     /*  19804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  19807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19819 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19823 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19827 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19831 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  19835 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19839 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19843 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19848 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19852 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19856 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_lsl_amt),
     /*  19860 */     // MIs[3] Operand 1
     /*  19860 */     // No operand predicates
     /*  19860 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  19871 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  19875 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19879 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  19883 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19887 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19892 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(65535),
     /*  19903 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19905 */     // (or:{ *:[i32] } (and:{ *:[i32] } (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_lsl_amt>>:$sh), 4294901760:{ *:[i32] }), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  19905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  19908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  19914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19918 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  19921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19924 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19930 */     GIR_RootConstrainSelectedInstOperands,
     /*  19931 */     // GIR_Coverage, 5452,
     /*  19931 */     GIR_EraseRootFromParent_Done,
     /*  19932 */   // Label 424: @19932
     /*  19932 */   GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(20065), // Rule ID 5489 //
     /*  19937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  19940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19956 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  19968 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19972 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19976 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19981 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19985 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19989 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_lsl_amt),
     /*  19993 */     // MIs[3] Operand 1
     /*  19993 */     // No operand predicates
     /*  19993 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20004 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  20008 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20012 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  20016 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  20020 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20025 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(65535),
     /*  20036 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20038 */     // (or:{ *:[i32] } (and:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_lsl_amt>>:$sh), 4294901760:{ *:[i32] }), (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 65535:{ *:[i32] }))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  20038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  20041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  20047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20051 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  20054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20057 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20063 */     GIR_RootConstrainSelectedInstOperands,
     /*  20064 */     // GIR_Coverage, 5489,
     /*  20064 */     GIR_EraseRootFromParent_Done,
     /*  20065 */   // Label 425: @20065
     /*  20065 */   GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(20198), // Rule ID 203 //
     /*  20070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  20073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20089 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20098 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20109 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20113 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20117 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20121 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20125 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20129 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  20133 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20137 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20141 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20146 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20150 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20154 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_asr_amt),
     /*  20158 */     // MIs[4] Operand 1
     /*  20158 */     // No operand predicates
     /*  20158 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  20169 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20171 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 4294901760:{ *:[i32] }), (and:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_asr_amt>>:$sh), 65535:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  20171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  20174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  20184 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20190 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20196 */     GIR_RootConstrainSelectedInstOperands,
     /*  20197 */     // GIR_Coverage, 203,
     /*  20197 */     GIR_EraseRootFromParent_Done,
     /*  20198 */   // Label 426: @20198
     /*  20198 */   GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(20331), // Rule ID 540 //
     /*  20203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  20206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20222 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20226 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20231 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20250 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20254 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20258 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20262 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  20266 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20270 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20274 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20279 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20283 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20287 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_asr_amt),
     /*  20291 */     // MIs[4] Operand 1
     /*  20291 */     // No operand predicates
     /*  20291 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  20302 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20304 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 4294901760:{ *:[i32] }), (and:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_asr_amt>>:$sh), 65535:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  20304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  20307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  20317 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20323 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20329 */     GIR_RootConstrainSelectedInstOperands,
     /*  20330 */     // GIR_Coverage, 540,
     /*  20330 */     GIR_EraseRootFromParent_Done,
     /*  20331 */   // Label 427: @20331
     /*  20331 */   GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(20464), // Rule ID 1919 //
     /*  20336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  20339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20355 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20359 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20364 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20383 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20387 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20391 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20395 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  20399 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20403 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20407 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20412 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20416 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20420 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_15),
     /*  20424 */     // MIs[4] Operand 1
     /*  20424 */     // No operand predicates
     /*  20424 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  20435 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20437 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh), 65535:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh)
     /*  20437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  20440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  20446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src2
     /*  20450 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20456 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20462 */     GIR_RootConstrainSelectedInstOperands,
     /*  20463 */     // GIR_Coverage, 1919,
     /*  20463 */     GIR_EraseRootFromParent_Done,
     /*  20464 */   // Label 428: @20464
     /*  20464 */   GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(20597), // Rule ID 2201 //
     /*  20469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  20472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20488 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20492 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20497 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20508 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20512 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20516 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20520 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20524 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20528 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  20532 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20536 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20540 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20545 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20549 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20553 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_15),
     /*  20557 */     // MIs[4] Operand 1
     /*  20557 */     // No operand predicates
     /*  20557 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  20568 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20570 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh), 65535:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh)
     /*  20570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  20573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  20579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src2
     /*  20583 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20589 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20595 */     GIR_RootConstrainSelectedInstOperands,
     /*  20596 */     // GIR_Coverage, 2201,
     /*  20596 */     GIR_EraseRootFromParent_Done,
     /*  20597 */   // Label 429: @20597
     /*  20597 */   GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(20730), // Rule ID 202 //
     /*  20602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  20605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20621 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20625 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20630 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  20641 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20645 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20649 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20653 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20657 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20661 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  20665 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20669 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20673 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20678 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20682 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20686 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_lsl_amt),
     /*  20690 */     // MIs[4] Operand 1
     /*  20690 */     // No operand predicates
     /*  20690 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20701 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20703 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (and:{ *:[i32] } (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_lsl_amt>>:$sh), 4294901760:{ *:[i32] }))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  20703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  20706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  20716 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20722 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20728 */     GIR_RootConstrainSelectedInstOperands,
     /*  20729 */     // GIR_Coverage, 202,
     /*  20729 */     GIR_EraseRootFromParent_Done,
     /*  20730 */   // Label 430: @20730
     /*  20730 */   GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(20863), // Rule ID 539 //
     /*  20735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  20738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20754 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20758 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20763 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  20774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20786 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20790 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20794 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  20798 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20802 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20806 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20811 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20815 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20819 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_lsl_amt),
     /*  20823 */     // MIs[4] Operand 1
     /*  20823 */     // No operand predicates
     /*  20823 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20834 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20836 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (and:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_lsl_amt>>:$sh), 4294901760:{ *:[i32] }))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  20836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  20839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  20849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20855 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20861 */     GIR_RootConstrainSelectedInstOperands,
     /*  20862 */     // GIR_Coverage, 539,
     /*  20862 */     GIR_EraseRootFromParent_Done,
     /*  20863 */   // Label 431: @20863
     /*  20863 */   GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(20968), // Rule ID 1915 //
     /*  20868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  20871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20887 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20896 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  20907 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20911 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20915 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20919 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20923 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20928 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20939 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20941 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 4294901760:{ *:[i32] }))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  20941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  20944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  20957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20960 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20966 */     GIR_RootConstrainSelectedInstOperands,
     /*  20967 */     // GIR_Coverage, 1915,
     /*  20967 */     GIR_EraseRootFromParent_Done,
     /*  20968 */   // Label 432: @20968
     /*  20968 */   GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(21073), // Rule ID 2197 //
     /*  20973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  20976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20992 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21001 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  21012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21020 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21024 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21028 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21033 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21044 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21046 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 65535:{ *:[i32] }), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src2, 4294901760:{ *:[i32] }))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, 0:{ *:[i32] })
     /*  21046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  21049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  21062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21065 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21071 */     GIR_RootConstrainSelectedInstOperands,
     /*  21072 */     // GIR_Coverage, 2197,
     /*  21072 */     GIR_EraseRootFromParent_Done,
     /*  21073 */   // Label 433: @21073
     /*  21073 */   GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(21178), // Rule ID 5656 //
     /*  21078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  21081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21097 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21106 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21125 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21129 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21133 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21138 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  21149 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21151 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 4294901760:{ *:[i32] }), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  21151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  21154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  21164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  21167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21170 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21176 */     GIR_RootConstrainSelectedInstOperands,
     /*  21177 */     // GIR_Coverage, 5656,
     /*  21177 */     GIR_EraseRootFromParent_Done,
     /*  21178 */   // Label 434: @21178
     /*  21178 */   GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(21283), // Rule ID 5698 //
     /*  21183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  21186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21202 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21211 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21230 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21234 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21238 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21243 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  21254 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21256 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src2, 4294901760:{ *:[i32] }), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 65535:{ *:[i32] }))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, 0:{ *:[i32] })
     /*  21256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  21259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  21265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  21269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  21272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21275 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21281 */     GIR_RootConstrainSelectedInstOperands,
     /*  21282 */     // GIR_Coverage, 5698,
     /*  21282 */     GIR_EraseRootFromParent_Done,
     /*  21283 */   // Label 435: @21283
     /*  21283 */   GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(21389), // Rule ID 1918 //
     /*  21288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  21291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21307 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21311 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21316 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21327 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21331 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  21335 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21339 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21343 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21348 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21352 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21356 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  21360 */     // MIs[3] Operand 1
     /*  21360 */     // No operand predicates
     /*  21360 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21362 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  21362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  21365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21375 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21381 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21387 */     GIR_RootConstrainSelectedInstOperands,
     /*  21388 */     // GIR_Coverage, 1918,
     /*  21388 */     GIR_EraseRootFromParent_Done,
     /*  21389 */   // Label 436: @21389
     /*  21389 */   GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(21495), // Rule ID 2200 //
     /*  21394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  21397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21413 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21417 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21422 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  21441 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21445 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21449 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21454 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21458 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21462 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  21466 */     // MIs[3] Operand 1
     /*  21466 */     // No operand predicates
     /*  21466 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21468 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  21468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  21471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21481 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21487 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21493 */     GIR_RootConstrainSelectedInstOperands,
     /*  21494 */     // GIR_Coverage, 2200,
     /*  21494 */     GIR_EraseRootFromParent_Done,
     /*  21495 */   // Label 437: @21495
     /*  21495 */   GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(21601), // Rule ID 1917 //
     /*  21500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  21503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21519 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21523 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21528 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21539 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21543 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  21547 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21551 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21555 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21560 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21564 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21568 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16),
     /*  21572 */     // MIs[3] Operand 1
     /*  21572 */     // No operand predicates
     /*  21572 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21574 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (srl:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh)
     /*  21574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  21577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21587 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21593 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21599 */     GIR_RootConstrainSelectedInstOperands,
     /*  21600 */     // GIR_Coverage, 1917,
     /*  21600 */     GIR_EraseRootFromParent_Done,
     /*  21601 */   // Label 438: @21601
     /*  21601 */   GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(21707), // Rule ID 2199 //
     /*  21606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  21609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21625 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21629 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21634 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21645 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21649 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  21653 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21657 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21661 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21666 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21670 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21674 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16),
     /*  21678 */     // MIs[3] Operand 1
     /*  21678 */     // No operand predicates
     /*  21678 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21680 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (srl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh)
     /*  21680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  21683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21699 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21705 */     GIR_RootConstrainSelectedInstOperands,
     /*  21706 */     // GIR_Coverage, 2199,
     /*  21706 */     GIR_EraseRootFromParent_Done,
     /*  21707 */   // Label 439: @21707
     /*  21707 */   GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(21813), // Rule ID 1916 //
     /*  21712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  21715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21731 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21735 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21740 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  21751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  21759 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21763 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21767 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21772 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21776 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21780 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  21784 */     // MIs[3] Operand 1
     /*  21784 */     // No operand predicates
     /*  21784 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21786 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  21786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  21789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  21795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  21799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21805 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21811 */     GIR_RootConstrainSelectedInstOperands,
     /*  21812 */     // GIR_Coverage, 1916,
     /*  21812 */     GIR_EraseRootFromParent_Done,
     /*  21813 */   // Label 440: @21813
     /*  21813 */   GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(21919), // Rule ID 2198 //
     /*  21818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  21821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21837 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21841 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21846 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  21857 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21861 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  21865 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21869 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21873 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21878 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21882 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21886 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  21890 */     // MIs[3] Operand 1
     /*  21890 */     // No operand predicates
     /*  21890 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21892 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 65535:{ *:[i32] }), (shl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  21892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  21895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21905 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21911 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21917 */     GIR_RootConstrainSelectedInstOperands,
     /*  21918 */     // GIR_Coverage, 2198,
     /*  21918 */     GIR_EraseRootFromParent_Done,
     /*  21919 */   // Label 441: @21919
     /*  21919 */   GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(22025), // Rule ID 5659 //
     /*  21924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  21927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  21939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21943 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21947 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21960 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  21964 */     // MIs[2] Operand 1
     /*  21964 */     // No operand predicates
     /*  21964 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21968 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21972 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  21976 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  21980 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21985 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21996 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21998 */     // (or:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  21998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  22001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  22007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  22011 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22017 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22023 */     GIR_RootConstrainSelectedInstOperands,
     /*  22024 */     // GIR_Coverage, 5659,
     /*  22024 */     GIR_EraseRootFromParent_Done,
     /*  22025 */   // Label 442: @22025
     /*  22025 */   GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(22131), // Rule ID 5701 //
     /*  22030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  22033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  22045 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22049 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22053 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22058 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22062 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22066 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  22070 */     // MIs[2] Operand 1
     /*  22070 */     // No operand predicates
     /*  22070 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22074 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22078 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  22082 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  22086 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22091 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(4294901760),
     /*  22102 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  22104 */     // (or:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  22104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  22107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  22113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  22117 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22123 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22129 */     GIR_RootConstrainSelectedInstOperands,
     /*  22130 */     // GIR_Coverage, 5701,
     /*  22130 */     GIR_EraseRootFromParent_Done,
     /*  22131 */   // Label 443: @22131
     /*  22131 */   GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(22237), // Rule ID 5658 //
     /*  22136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  22139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  22151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22155 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22159 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22172 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16),
     /*  22176 */     // MIs[2] Operand 1
     /*  22176 */     // No operand predicates
     /*  22176 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22180 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22184 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  22188 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  22192 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22197 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(4294901760),
     /*  22208 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  22210 */     // (or:{ *:[i32] } (srl:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh)
     /*  22210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  22213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  22219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  22223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22229 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22235 */     GIR_RootConstrainSelectedInstOperands,
     /*  22236 */     // GIR_Coverage, 5658,
     /*  22236 */     GIR_EraseRootFromParent_Done,
     /*  22237 */   // Label 444: @22237
     /*  22237 */   GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(22343), // Rule ID 5700 //
     /*  22242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  22245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  22257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22261 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22265 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22270 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22274 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22278 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16),
     /*  22282 */     // MIs[2] Operand 1
     /*  22282 */     // No operand predicates
     /*  22282 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22286 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22290 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  22294 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  22298 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22303 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(4294901760),
     /*  22314 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  22316 */     // (or:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh)
     /*  22316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  22319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  22325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  22329 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22335 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22341 */     GIR_RootConstrainSelectedInstOperands,
     /*  22342 */     // GIR_Coverage, 5700,
     /*  22342 */     GIR_EraseRootFromParent_Done,
     /*  22343 */   // Label 445: @22343
     /*  22343 */   GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(22449), // Rule ID 5657 //
     /*  22348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  22351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  22363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22367 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22371 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22376 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22380 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22384 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  22388 */     // MIs[2] Operand 1
     /*  22388 */     // No operand predicates
     /*  22388 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22392 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22396 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  22400 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  22404 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22409 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(65535),
     /*  22420 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  22422 */     // (or:{ *:[i32] } (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  22422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  22425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  22431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  22435 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22441 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22447 */     GIR_RootConstrainSelectedInstOperands,
     /*  22448 */     // GIR_Coverage, 5657,
     /*  22448 */     GIR_EraseRootFromParent_Done,
     /*  22449 */   // Label 446: @22449
     /*  22449 */   GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(22555), // Rule ID 5699 //
     /*  22454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  22457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  22469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22473 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22477 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22490 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  22494 */     // MIs[2] Operand 1
     /*  22494 */     // No operand predicates
     /*  22494 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22498 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22502 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  22506 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  22510 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22515 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(65535),
     /*  22526 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  22528 */     // (or:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 65535:{ *:[i32] }))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  22528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  22531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  22537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  22541 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22547 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22553 */     GIR_RootConstrainSelectedInstOperands,
     /*  22554 */     // GIR_Coverage, 5699,
     /*  22554 */     GIR_EraseRootFromParent_Done,
     /*  22555 */   // Label 447: @22555
     /*  22555 */   GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(22632), // Rule ID 5477 //
     /*  22560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22579 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22583 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  22587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22595 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  22599 */     // MIs[2] Operand 1
     /*  22599 */     // No operand predicates
     /*  22599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22603 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22605 */     // (or:{ *:[i32] } (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm), rGPR:{ *:[i32] }:$Rn)  =>  (t2ORNri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  22605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNri),
     /*  22608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  22612 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  22615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22618 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22624 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22630 */     GIR_RootConstrainSelectedInstOperands,
     /*  22631 */     // GIR_Coverage, 5477,
     /*  22631 */     GIR_EraseRootFromParent_Done,
     /*  22632 */   // Label 448: @22632
     /*  22632 */   GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(22709), // Rule ID 5476 //
     /*  22637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22656 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22660 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22664 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22668 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  22672 */     // MIs[2] Operand 1
     /*  22672 */     // No operand predicates
     /*  22672 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  22676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22680 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22682 */     // (or:{ *:[i32] } (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, -1:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2ORNri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  22682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNri),
     /*  22685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  22689 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  22692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22695 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22701 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22707 */     GIR_RootConstrainSelectedInstOperands,
     /*  22708 */     // GIR_Coverage, 5476,
     /*  22708 */     GIR_EraseRootFromParent_Done,
     /*  22709 */   // Label 449: @22709
     /*  22709 */   GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(22786), // Rule ID 5475 //
     /*  22714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22737 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22741 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  22745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22753 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  22757 */     // MIs[2] Operand 1
     /*  22757 */     // No operand predicates
     /*  22757 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22759 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm))  =>  (t2ORNri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  22759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNri),
     /*  22762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22764 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  22766 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  22769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22772 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22778 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22784 */     GIR_RootConstrainSelectedInstOperands,
     /*  22785 */     // GIR_Coverage, 5475,
     /*  22785 */     GIR_EraseRootFromParent_Done,
     /*  22786 */   // Label 450: @22786
     /*  22786 */   GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(22863), // Rule ID 496 //
     /*  22791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22810 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22814 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22822 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22826 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  22830 */     // MIs[2] Operand 1
     /*  22830 */     // No operand predicates
     /*  22830 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  22834 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22836 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, -1:{ *:[i32] }))  =>  (t2ORNri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  22836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNri),
     /*  22839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22841 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  22843 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  22846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22849 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22855 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22861 */     GIR_RootConstrainSelectedInstOperands,
     /*  22862 */     // GIR_Coverage, 496,
     /*  22862 */     GIR_EraseRootFromParent_Done,
     /*  22863 */   // Label 451: @22863
     /*  22863 */   GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(22934), // Rule ID 5478 //
     /*  22868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22887 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22896 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  22900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22904 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22906 */     // (or:{ *:[i32] } (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2ORNrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  22906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNrr),
     /*  22909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  22913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  22917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22920 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22926 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22932 */     GIR_RootConstrainSelectedInstOperands,
     /*  22933 */     // GIR_Coverage, 5478,
     /*  22933 */     GIR_EraseRootFromParent_Done,
     /*  22934 */   // Label 452: @22934
     /*  22934 */   GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(23005), // Rule ID 497 //
     /*  22939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22962 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22966 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22971 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  22975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22977 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (t2ORNrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  22977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNrr),
     /*  22980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22982 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  22984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  22988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22991 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22997 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23003 */     GIR_RootConstrainSelectedInstOperands,
     /*  23004 */     // GIR_Coverage, 497,
     /*  23004 */     GIR_EraseRootFromParent_Done,
     /*  23005 */   // Label 453: @23005
     /*  23005 */   GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(23060), // Rule ID 1848 //
     /*  23010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6T2_IsARM),
     /*  23013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  23017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23021 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294901760),
     /*  23032 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$src, 4294901760:{ *:[i32] })  =>  (MOVTi16:{ *:[i32] } GPR:{ *:[i32] }:$src, 65535:{ *:[i32] })
     /*  23032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MOVTi16),
     /*  23035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23037 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  23039 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(65535),
     /*  23049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23052 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23058 */     GIR_RootConstrainSelectedInstOperands,
     /*  23059 */     // GIR_Coverage, 1848,
     /*  23059 */     GIR_EraseRootFromParent_Done,
     /*  23060 */   // Label 454: @23060
     /*  23060 */   GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(23115), // Rule ID 2094 //
     /*  23065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  23068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23076 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294901760),
     /*  23087 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$src, 4294901760:{ *:[i32] })  =>  (t2MOVTi16:{ *:[i32] } rGPR:{ *:[i32] }:$src, 65535:{ *:[i32] })
     /*  23087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MOVTi16),
     /*  23090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23092 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  23094 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(65535),
     /*  23104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23107 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23113 */     GIR_RootConstrainSelectedInstOperands,
     /*  23114 */     // GIR_Coverage, 2094,
     /*  23114 */     GIR_EraseRootFromParent_Done,
     /*  23115 */   // Label 455: @23115
     /*  23115 */   GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(23172), // Rule ID 151 //
     /*  23120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  23123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23127 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23139 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  23143 */     // MIs[1] Operand 1
     /*  23143 */     // No operand predicates
     /*  23143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23145 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm)  =>  (ORRri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  23145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ORRri),
     /*  23148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23150 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  23152 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  23155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23158 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23164 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23170 */     GIR_RootConstrainSelectedInstOperands,
     /*  23171 */     // GIR_Coverage, 151,
     /*  23171 */     GIR_EraseRootFromParent_Done,
     /*  23172 */   // Label 456: @23172
     /*  23172 */   GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(23229), // Rule ID 484 //
     /*  23177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  23180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23196 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  23200 */     // MIs[1] Operand 1
     /*  23200 */     // No operand predicates
     /*  23200 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23202 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2ORRri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  23202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORRri),
     /*  23205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23207 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  23209 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  23212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23215 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23221 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23227 */     GIR_RootConstrainSelectedInstOperands,
     /*  23228 */     // GIR_Coverage, 484,
     /*  23228 */     GIR_EraseRootFromParent_Done,
     /*  23229 */   // Label 457: @23229
     /*  23229 */   GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(23275), // Rule ID 152 //
     /*  23234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  23237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23249 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (ORRrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  23249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ORRrr),
     /*  23252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23254 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  23256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  23258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23261 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23267 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23273 */     GIR_RootConstrainSelectedInstOperands,
     /*  23274 */     // GIR_Coverage, 152,
     /*  23274 */     GIR_EraseRootFromParent_Done,
     /*  23275 */   // Label 458: @23275
     /*  23275 */   GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(23321), // Rule ID 325 //
     /*  23280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  23283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  23287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  23291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  23295 */     // (or:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tORR:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  23295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tORR),
     /*  23298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  23300 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  23306 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  23308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  23310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23313 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23319 */     GIR_RootConstrainSelectedInstOperands,
     /*  23320 */     // GIR_Coverage, 325,
     /*  23320 */     GIR_EraseRootFromParent_Done,
     /*  23321 */   // Label 459: @23321
     /*  23321 */   GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(23367), // Rule ID 485 //
     /*  23326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  23329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23341 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2ORRrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  23341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORRrr),
     /*  23344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23346 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  23348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  23350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23353 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23359 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23365 */     GIR_RootConstrainSelectedInstOperands,
     /*  23366 */     // GIR_Coverage, 485,
     /*  23366 */     GIR_EraseRootFromParent_Done,
     /*  23367 */   // Label 460: @23367
     /*  23367 */   GIM_Reject,
     /*  23368 */ // Label 415: @23368
     /*  23368 */ GIM_Reject,
     /*  23369 */ // Label 402: @23369
     /*  23369 */ GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(23415), // Rule ID 2532 //
     /*  23374 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  23380 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  23383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23387 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23391 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23395 */   // (or:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)  =>  (VORRd:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)
     /*  23395 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRd),
     /*  23398 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  23400 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  23402 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  23404 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23407 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23413 */   GIR_RootConstrainSelectedInstOperands,
     /*  23414 */   // GIR_Coverage, 2532,
     /*  23414 */   GIR_EraseRootFromParent_Done,
     /*  23415 */ // Label 461: @23415
     /*  23415 */ GIM_Reject,
     /*  23416 */ // Label 403: @23416
     /*  23416 */ GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(23533), // Rule ID 1834 //
     /*  23421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  23424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  23427 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  23430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23434 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23438 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23442 */   // (or:{ *:[v2i1] } VCCR:{ *:[v2i1] }:$p1, VCCR:{ *:[v2i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (t2ORRrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  23442 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  23445 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23449 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23454 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  23458 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23463 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  23466 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23470 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23475 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  23479 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23484 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  23487 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ORRrr),
     /*  23491 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23496 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23499 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  23502 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  23505 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23511 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23517 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23519 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23522 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23524 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  23527 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23532 */   // GIR_Coverage, 1834,
     /*  23532 */   GIR_EraseRootFromParent_Done,
     /*  23533 */ // Label 462: @23533
     /*  23533 */ GIM_Reject,
     /*  23534 */ // Label 404: @23534
     /*  23534 */ GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(23580), // Rule ID 1137 //
     /*  23539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  23545 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  23548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23552 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23556 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23560 */   // (or:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VORRd:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  23560 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRd),
     /*  23563 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  23565 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  23567 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  23569 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23572 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23578 */   GIR_RootConstrainSelectedInstOperands,
     /*  23579 */   // GIR_Coverage, 1137,
     /*  23579 */   GIR_EraseRootFromParent_Done,
     /*  23580 */ // Label 463: @23580
     /*  23580 */ GIM_Reject,
     /*  23581 */ // Label 405: @23581
     /*  23581 */ GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(23694),
     /*  23586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  23589 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  23592 */   GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(23632), // Rule ID 2535 //
     /*  23597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23612 */     // (or:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)  =>  (VORRq:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)
     /*  23612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRq),
     /*  23615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  23617 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  23619 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  23621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23624 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23630 */     GIR_RootConstrainSelectedInstOperands,
     /*  23631 */     // GIR_Coverage, 2535,
     /*  23631 */     GIR_EraseRootFromParent_Done,
     /*  23632 */   // Label 465: @23632
     /*  23632 */   GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(23693), // Rule ID 3384 //
     /*  23637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  23640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23644 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23652 */     // (or:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)  =>  (MVE_VORR:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)
     /*  23652 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  23655 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23659 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VORR),
     /*  23667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  23669 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  23671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  23673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  23676 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23682 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23688 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  23691 */     GIR_RootConstrainSelectedInstOperands,
     /*  23692 */     // GIR_Coverage, 3384,
     /*  23692 */     GIR_EraseRootFromParent_Done,
     /*  23693 */   // Label 466: @23693
     /*  23693 */   GIM_Reject,
     /*  23694 */ // Label 464: @23694
     /*  23694 */ GIM_Reject,
     /*  23695 */ // Label 406: @23695
     /*  23695 */ GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(23812), // Rule ID 1835 //
     /*  23700 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  23703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  23706 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  23709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23713 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23717 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23721 */   // (or:{ *:[v4i1] } VCCR:{ *:[v4i1] }:$p1, VCCR:{ *:[v4i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (t2ORRrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  23721 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  23724 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23728 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23733 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  23737 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23742 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  23745 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23749 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23754 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  23758 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23763 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  23766 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ORRrr),
     /*  23770 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23775 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23778 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  23781 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  23784 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23790 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23796 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23798 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23801 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23803 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  23806 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23811 */   // GIR_Coverage, 1835,
     /*  23811 */   GIR_EraseRootFromParent_Done,
     /*  23812 */ // Label 467: @23812
     /*  23812 */ GIM_Reject,
     /*  23813 */ // Label 407: @23813
     /*  23813 */ GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(23859), // Rule ID 2531 //
     /*  23818 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23824 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23831 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23835 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23839 */   // (or:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)  =>  (VORRd:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)
     /*  23839 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRd),
     /*  23842 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  23844 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  23846 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  23848 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23851 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23857 */   GIR_RootConstrainSelectedInstOperands,
     /*  23858 */   // GIR_Coverage, 2531,
     /*  23858 */   GIR_EraseRootFromParent_Done,
     /*  23859 */ // Label 468: @23859
     /*  23859 */ GIM_Reject,
     /*  23860 */ // Label 408: @23860
     /*  23860 */ GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(23973),
     /*  23865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23868 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23871 */   GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(23911), // Rule ID 1138 //
     /*  23876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23883 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23891 */     // (or:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VORRq:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  23891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRq),
     /*  23894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  23896 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  23898 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  23900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23903 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23909 */     GIR_RootConstrainSelectedInstOperands,
     /*  23910 */     // GIR_Coverage, 1138,
     /*  23910 */     GIR_EraseRootFromParent_Done,
     /*  23911 */   // Label 470: @23911
     /*  23911 */   GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(23972), // Rule ID 3380 //
     /*  23916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  23919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23923 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23931 */     // (or:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VORR:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  23931 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  23934 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23938 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VORR),
     /*  23946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  23948 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  23950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  23952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  23955 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23961 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23967 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  23970 */     GIR_RootConstrainSelectedInstOperands,
     /*  23971 */     // GIR_Coverage, 3380,
     /*  23971 */     GIR_EraseRootFromParent_Done,
     /*  23972 */   // Label 471: @23972
     /*  23972 */   GIM_Reject,
     /*  23973 */ // Label 469: @23973
     /*  23973 */ GIM_Reject,
     /*  23974 */ // Label 409: @23974
     /*  23974 */ GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(24091), // Rule ID 1836 //
     /*  23979 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  23982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  23985 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  23988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23992 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23996 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24000 */   // (or:{ *:[v8i1] } VCCR:{ *:[v8i1] }:$p1, VCCR:{ *:[v8i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (t2ORRrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  24000 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  24003 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24007 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24012 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  24016 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24021 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  24024 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24028 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24033 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  24037 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24042 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  24045 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ORRrr),
     /*  24049 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24054 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  24057 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  24060 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  24063 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24069 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24075 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  24077 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24080 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24082 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  24085 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24090 */   // GIR_Coverage, 1836,
     /*  24090 */   GIR_EraseRootFromParent_Done,
     /*  24091 */ // Label 472: @24091
     /*  24091 */ GIM_Reject,
     /*  24092 */ // Label 410: @24092
     /*  24092 */ GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(24138), // Rule ID 2530 //
     /*  24097 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24103 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  24106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  24110 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  24114 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  24118 */   // (or:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)  =>  (VORRd:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)
     /*  24118 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRd),
     /*  24121 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  24123 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  24125 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  24127 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24130 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24136 */   GIR_RootConstrainSelectedInstOperands,
     /*  24137 */   // GIR_Coverage, 2530,
     /*  24137 */   GIR_EraseRootFromParent_Done,
     /*  24138 */ // Label 473: @24138
     /*  24138 */ GIM_Reject,
     /*  24139 */ // Label 411: @24139
     /*  24139 */ GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(24252),
     /*  24144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24147 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  24150 */   GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(24190), // Rule ID 2534 //
     /*  24155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24162 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24170 */     // (or:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)  =>  (VORRq:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)
     /*  24170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRq),
     /*  24173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  24175 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  24177 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  24179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24182 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24188 */     GIR_RootConstrainSelectedInstOperands,
     /*  24189 */     // GIR_Coverage, 2534,
     /*  24189 */     GIR_EraseRootFromParent_Done,
     /*  24190 */   // Label 475: @24190
     /*  24190 */   GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(24251), // Rule ID 3376 //
     /*  24195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  24198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24202 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24210 */     // (or:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VORR:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  24210 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  24213 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  24217 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VORR),
     /*  24225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  24227 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  24229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  24231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  24234 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24240 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24246 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  24249 */     GIR_RootConstrainSelectedInstOperands,
     /*  24250 */     // GIR_Coverage, 3376,
     /*  24250 */     GIR_EraseRootFromParent_Done,
     /*  24251 */   // Label 476: @24251
     /*  24251 */   GIM_Reject,
     /*  24252 */ // Label 474: @24252
     /*  24252 */ GIM_Reject,
     /*  24253 */ // Label 412: @24253
     /*  24253 */ GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(24370), // Rule ID 1837 //
     /*  24258 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  24261 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  24264 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  24267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24271 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24275 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24279 */   // (or:{ *:[v16i1] } VCCR:{ *:[v16i1] }:$p1, VCCR:{ *:[v16i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } (t2ORRrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  24279 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  24282 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24286 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24291 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  24295 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24300 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  24303 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24307 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24312 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  24316 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24321 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  24324 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ORRrr),
     /*  24328 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24333 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  24336 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  24339 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  24342 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24348 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24354 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  24356 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24359 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24361 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  24364 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24369 */   // GIR_Coverage, 1837,
     /*  24369 */   GIR_EraseRootFromParent_Done,
     /*  24370 */ // Label 477: @24370
     /*  24370 */ GIM_Reject,
     /*  24371 */ // Label 413: @24371
     /*  24371 */ GIM_Try, /*On fail goto*//*Label 478*/ GIMT_Encode4(24484),
     /*  24376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  24379 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  24382 */   GIM_Try, /*On fail goto*//*Label 479*/ GIMT_Encode4(24422), // Rule ID 2533 //
     /*  24387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24402 */     // (or:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)  =>  (VORRq:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)
     /*  24402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRq),
     /*  24405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  24407 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  24409 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  24411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24414 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24420 */     GIR_RootConstrainSelectedInstOperands,
     /*  24421 */     // GIR_Coverage, 2533,
     /*  24421 */     GIR_EraseRootFromParent_Done,
     /*  24422 */   // Label 479: @24422
     /*  24422 */   GIM_Try, /*On fail goto*//*Label 480*/ GIMT_Encode4(24483), // Rule ID 3372 //
     /*  24427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  24430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24442 */     // (or:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VORR:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  24442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  24445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  24449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VORR),
     /*  24457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  24459 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  24461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  24463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  24466 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24472 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  24481 */     GIR_RootConstrainSelectedInstOperands,
     /*  24482 */     // GIR_Coverage, 3372,
     /*  24482 */     GIR_EraseRootFromParent_Done,
     /*  24483 */   // Label 480: @24483
     /*  24483 */   GIM_Reject,
     /*  24484 */ // Label 478: @24484
     /*  24484 */ GIM_Reject,
     /*  24485 */ // Label 414: @24485
     /*  24485 */ GIM_Reject,
     /*  24486 */ // Label 7: @24486
     /*  24486 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 494*/ GIMT_Encode4(26180),
     /*  24497 */ /*GILLT_s32*//*Label 481*/ GIMT_Encode4(24557),
     /*  24501 */ /*GILLT_s64*//*Label 482*/ GIMT_Encode4(25064),
     /*  24505 */ /*GILLT_v2s1*//*Label 483*/ GIMT_Encode4(25111),
     /*  24509 */ /*GILLT_v2s32*//*Label 484*/ GIMT_Encode4(25229),
     /*  24513 */ /*GILLT_v2s64*//*Label 485*/ GIMT_Encode4(25276),
     /*  24517 */ /*GILLT_v4s1*//*Label 486*/ GIMT_Encode4(25390),
     /*  24521 */ /*GILLT_v4s16*//*Label 487*/ GIMT_Encode4(25508),
     /*  24525 */ /*GILLT_v4s32*//*Label 488*/ GIMT_Encode4(25555), GIMT_Encode4(0),
     /*  24533 */ /*GILLT_v8s1*//*Label 489*/ GIMT_Encode4(25669),
     /*  24537 */ /*GILLT_v8s8*//*Label 490*/ GIMT_Encode4(25787),
     /*  24541 */ /*GILLT_v8s16*//*Label 491*/ GIMT_Encode4(25834), GIMT_Encode4(0),
     /*  24549 */ /*GILLT_v16s1*//*Label 492*/ GIMT_Encode4(25948),
     /*  24553 */ /*GILLT_v16s8*//*Label 493*/ GIMT_Encode4(26066),
     /*  24557 */ // Label 481: @24557
     /*  24557 */ GIM_Try, /*On fail goto*//*Label 495*/ GIMT_Encode4(25063),
     /*  24562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  24565 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  24568 */   GIM_Try, /*On fail goto*//*Label 496*/ GIMT_Encode4(24623), // Rule ID 5480 //
     /*  24573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  24576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24580 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, uint8_t(-1),
     /*  24584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24592 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  24596 */     // MIs[1] Operand 1
     /*  24596 */     // No operand predicates
     /*  24596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24598 */     // (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2MVNi:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  24598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MVNi),
     /*  24601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24603 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  24606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24609 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24615 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24621 */     GIR_RootConstrainSelectedInstOperands,
     /*  24622 */     // GIR_Coverage, 5480,
     /*  24622 */     GIR_EraseRootFromParent_Done,
     /*  24623 */   // Label 496: @24623
     /*  24623 */   GIM_Try, /*On fail goto*//*Label 497*/ GIMT_Encode4(24678), // Rule ID 499 //
     /*  24628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  24631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24643 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  24647 */     // MIs[1] Operand 1
     /*  24647 */     // No operand predicates
     /*  24647 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  24651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24653 */     // (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, -1:{ *:[i32] })  =>  (t2MVNi:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  24653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MVNi),
     /*  24656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24658 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  24661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24664 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24670 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24676 */     GIR_RootConstrainSelectedInstOperands,
     /*  24677 */     // GIR_Coverage, 499,
     /*  24677 */     GIR_EraseRootFromParent_Done,
     /*  24678 */   // Label 497: @24678
     /*  24678 */   GIM_Try, /*On fail goto*//*Label 498*/ GIMT_Encode4(24722), // Rule ID 500 //
     /*  24683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  24686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24694 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  24698 */     // (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] })  =>  (t2MVNr:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /*  24698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MVNr),
     /*  24701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24703 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  24705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24708 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24714 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24720 */     GIR_RootConstrainSelectedInstOperands,
     /*  24721 */     // GIR_Coverage, 500,
     /*  24721 */     GIR_EraseRootFromParent_Done,
     /*  24722 */   // Label 498: @24722
     /*  24722 */   GIM_Try, /*On fail goto*//*Label 499*/ GIMT_Encode4(24766), // Rule ID 165 //
     /*  24727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  24730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24734 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24738 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  24742 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$Rm, -1:{ *:[i32] })  =>  (MVNr:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /*  24742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVNr),
     /*  24745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24747 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  24749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24752 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24758 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24764 */     GIR_RootConstrainSelectedInstOperands,
     /*  24765 */     // GIR_Coverage, 165,
     /*  24765 */     GIR_EraseRootFromParent_Done,
     /*  24766 */   // Label 499: @24766
     /*  24766 */   GIM_Try, /*On fail goto*//*Label 500*/ GIMT_Encode4(24810), // Rule ID 324 //
     /*  24771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  24774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  24778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  24782 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  24786 */     // (xor:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, -1:{ *:[i32] })  =>  (tMVN:{ *:[i32] } tGPR:{ *:[i32] }:$Rn)
     /*  24786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tMVN),
     /*  24789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24791 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  24797 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  24799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24802 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24808 */     GIR_RootConstrainSelectedInstOperands,
     /*  24809 */     // GIR_Coverage, 324,
     /*  24809 */     GIR_EraseRootFromParent_Done,
     /*  24810 */   // Label 500: @24810
     /*  24810 */   GIM_Try, /*On fail goto*//*Label 501*/ GIMT_Encode4(24867), // Rule ID 155 //
     /*  24815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  24818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24822 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24834 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  24838 */     // MIs[1] Operand 1
     /*  24838 */     // No operand predicates
     /*  24838 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24840 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm)  =>  (EORri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::EORri),
     /*  24843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24845 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  24847 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  24850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24853 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24859 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24865 */     GIR_RootConstrainSelectedInstOperands,
     /*  24866 */     // GIR_Coverage, 155,
     /*  24866 */     GIR_EraseRootFromParent_Done,
     /*  24867 */   // Label 501: @24867
     /*  24867 */   GIM_Try, /*On fail goto*//*Label 502*/ GIMT_Encode4(24924), // Rule ID 487 //
     /*  24872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  24875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24891 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  24895 */     // MIs[1] Operand 1
     /*  24895 */     // No operand predicates
     /*  24895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24897 */     // (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2EORri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2EORri),
     /*  24900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24902 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  24904 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  24907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24910 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24916 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24922 */     GIR_RootConstrainSelectedInstOperands,
     /*  24923 */     // GIR_Coverage, 487,
     /*  24923 */     GIR_EraseRootFromParent_Done,
     /*  24924 */   // Label 502: @24924
     /*  24924 */   GIM_Try, /*On fail goto*//*Label 503*/ GIMT_Encode4(24970), // Rule ID 156 //
     /*  24929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  24932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24944 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (EORrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  24944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::EORrr),
     /*  24947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24949 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  24951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  24953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24956 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24962 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24968 */     GIR_RootConstrainSelectedInstOperands,
     /*  24969 */     // GIR_Coverage, 156,
     /*  24969 */     GIR_EraseRootFromParent_Done,
     /*  24970 */   // Label 503: @24970
     /*  24970 */   GIM_Try, /*On fail goto*//*Label 504*/ GIMT_Encode4(25016), // Rule ID 317 //
     /*  24975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  24978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  24982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  24986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  24990 */     // (xor:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tEOR:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  24990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tEOR),
     /*  24993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  24995 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  25001 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  25003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  25005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25008 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25014 */     GIR_RootConstrainSelectedInstOperands,
     /*  25015 */     // GIR_Coverage, 317,
     /*  25015 */     GIR_EraseRootFromParent_Done,
     /*  25016 */   // Label 504: @25016
     /*  25016 */   GIM_Try, /*On fail goto*//*Label 505*/ GIMT_Encode4(25062), // Rule ID 488 //
     /*  25021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  25024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25036 */     // (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2EORrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  25036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2EORrr),
     /*  25039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  25041 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  25043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  25045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25048 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25054 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25060 */     GIR_RootConstrainSelectedInstOperands,
     /*  25061 */     // GIR_Coverage, 488,
     /*  25061 */     GIR_EraseRootFromParent_Done,
     /*  25062 */   // Label 505: @25062
     /*  25062 */   GIM_Reject,
     /*  25063 */ // Label 495: @25063
     /*  25063 */ GIM_Reject,
     /*  25064 */ // Label 482: @25064
     /*  25064 */ GIM_Try, /*On fail goto*//*Label 506*/ GIMT_Encode4(25110), // Rule ID 2538 //
     /*  25069 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25072 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  25075 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  25078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25082 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25086 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25090 */   // (xor:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)  =>  (VEORd:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)
     /*  25090 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORd),
     /*  25093 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25095 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  25097 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  25099 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25102 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25108 */   GIR_RootConstrainSelectedInstOperands,
     /*  25109 */   // GIR_Coverage, 2538,
     /*  25109 */   GIR_EraseRootFromParent_Done,
     /*  25110 */ // Label 506: @25110
     /*  25110 */ GIM_Reject,
     /*  25111 */ // Label 483: @25111
     /*  25111 */ GIM_Try, /*On fail goto*//*Label 507*/ GIMT_Encode4(25228), // Rule ID 1830 //
     /*  25116 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  25122 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  25125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25129 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25133 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25137 */   // (xor:{ *:[v2i1] } VCCR:{ *:[v2i1] }:$p1, VCCR:{ *:[v2i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (t2EORrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  25137 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  25140 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25144 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25149 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  25153 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25158 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  25161 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25165 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25170 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  25174 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25179 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  25182 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2EORrr),
     /*  25186 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25191 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  25194 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  25197 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  25200 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25206 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25212 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  25214 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25217 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25219 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25222 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25227 */   // GIR_Coverage, 1830,
     /*  25227 */   GIR_EraseRootFromParent_Done,
     /*  25228 */ // Label 507: @25228
     /*  25228 */ GIM_Reject,
     /*  25229 */ // Label 484: @25229
     /*  25229 */ GIM_Try, /*On fail goto*//*Label 508*/ GIMT_Encode4(25275), // Rule ID 1135 //
     /*  25234 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  25240 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  25243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25247 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25251 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25255 */   // (xor:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VEORd:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  25255 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORd),
     /*  25258 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25260 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  25262 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  25264 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25267 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25273 */   GIR_RootConstrainSelectedInstOperands,
     /*  25274 */   // GIR_Coverage, 1135,
     /*  25274 */   GIR_EraseRootFromParent_Done,
     /*  25275 */ // Label 508: @25275
     /*  25275 */ GIM_Reject,
     /*  25276 */ // Label 485: @25276
     /*  25276 */ GIM_Try, /*On fail goto*//*Label 509*/ GIMT_Encode4(25389),
     /*  25281 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  25284 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  25287 */   GIM_Try, /*On fail goto*//*Label 510*/ GIMT_Encode4(25327), // Rule ID 2541 //
     /*  25292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25307 */     // (xor:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)  =>  (VEORq:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)
     /*  25307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORq),
     /*  25310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25312 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  25314 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  25316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25319 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25325 */     GIR_RootConstrainSelectedInstOperands,
     /*  25326 */     // GIR_Coverage, 2541,
     /*  25326 */     GIR_EraseRootFromParent_Done,
     /*  25327 */   // Label 510: @25327
     /*  25327 */   GIM_Try, /*On fail goto*//*Label 511*/ GIMT_Encode4(25388), // Rule ID 3398 //
     /*  25332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25347 */     // (xor:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)  =>  (MVE_VEOR:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)
     /*  25347 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  25350 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  25354 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VEOR),
     /*  25362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  25364 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  25366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  25368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  25371 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25377 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25383 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25386 */     GIR_RootConstrainSelectedInstOperands,
     /*  25387 */     // GIR_Coverage, 3398,
     /*  25387 */     GIR_EraseRootFromParent_Done,
     /*  25388 */   // Label 511: @25388
     /*  25388 */   GIM_Reject,
     /*  25389 */ // Label 509: @25389
     /*  25389 */ GIM_Reject,
     /*  25390 */ // Label 486: @25390
     /*  25390 */ GIM_Try, /*On fail goto*//*Label 512*/ GIMT_Encode4(25507), // Rule ID 1831 //
     /*  25395 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  25401 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  25404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25412 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25416 */   // (xor:{ *:[v4i1] } VCCR:{ *:[v4i1] }:$p1, VCCR:{ *:[v4i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (t2EORrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  25416 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  25419 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25423 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25428 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  25432 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25437 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  25440 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25444 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25449 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  25453 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25458 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  25461 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2EORrr),
     /*  25465 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25470 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  25473 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  25476 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  25479 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25485 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25491 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  25493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25496 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25498 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25501 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25506 */   // GIR_Coverage, 1831,
     /*  25506 */   GIR_EraseRootFromParent_Done,
     /*  25507 */ // Label 512: @25507
     /*  25507 */ GIM_Reject,
     /*  25508 */ // Label 487: @25508
     /*  25508 */ GIM_Try, /*On fail goto*//*Label 513*/ GIMT_Encode4(25554), // Rule ID 2537 //
     /*  25513 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25519 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25530 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25534 */   // (xor:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)  =>  (VEORd:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)
     /*  25534 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORd),
     /*  25537 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25539 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  25541 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  25543 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25546 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25552 */   GIR_RootConstrainSelectedInstOperands,
     /*  25553 */   // GIR_Coverage, 2537,
     /*  25553 */   GIR_EraseRootFromParent_Done,
     /*  25554 */ // Label 513: @25554
     /*  25554 */ GIM_Reject,
     /*  25555 */ // Label 488: @25555
     /*  25555 */ GIM_Try, /*On fail goto*//*Label 514*/ GIMT_Encode4(25668),
     /*  25560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25563 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25566 */   GIM_Try, /*On fail goto*//*Label 515*/ GIMT_Encode4(25606), // Rule ID 1136 //
     /*  25571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25586 */     // (xor:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VEORq:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  25586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORq),
     /*  25589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25591 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  25593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  25595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25598 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25604 */     GIR_RootConstrainSelectedInstOperands,
     /*  25605 */     // GIR_Coverage, 1136,
     /*  25605 */     GIR_EraseRootFromParent_Done,
     /*  25606 */   // Label 515: @25606
     /*  25606 */   GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(25667), // Rule ID 3394 //
     /*  25611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25626 */     // (xor:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VEOR:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  25626 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  25629 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  25633 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VEOR),
     /*  25641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  25643 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  25645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  25647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  25650 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25656 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25662 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25665 */     GIR_RootConstrainSelectedInstOperands,
     /*  25666 */     // GIR_Coverage, 3394,
     /*  25666 */     GIR_EraseRootFromParent_Done,
     /*  25667 */   // Label 516: @25667
     /*  25667 */   GIM_Reject,
     /*  25668 */ // Label 514: @25668
     /*  25668 */ GIM_Reject,
     /*  25669 */ // Label 489: @25669
     /*  25669 */ GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(25786), // Rule ID 1832 //
     /*  25674 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  25680 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  25683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25687 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25691 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25695 */   // (xor:{ *:[v8i1] } VCCR:{ *:[v8i1] }:$p1, VCCR:{ *:[v8i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (t2EORrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  25695 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  25698 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25702 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25707 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  25711 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25716 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  25719 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25723 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25728 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  25732 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25737 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  25740 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2EORrr),
     /*  25744 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25749 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  25752 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  25755 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  25758 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25764 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25770 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  25772 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25775 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25777 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25780 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25785 */   // GIR_Coverage, 1832,
     /*  25785 */   GIR_EraseRootFromParent_Done,
     /*  25786 */ // Label 517: @25786
     /*  25786 */ GIM_Reject,
     /*  25787 */ // Label 490: @25787
     /*  25787 */ GIM_Try, /*On fail goto*//*Label 518*/ GIMT_Encode4(25833), // Rule ID 2536 //
     /*  25792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  25798 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  25801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25805 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25809 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25813 */   // (xor:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)  =>  (VEORd:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)
     /*  25813 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORd),
     /*  25816 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25818 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  25820 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  25822 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25825 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25831 */   GIR_RootConstrainSelectedInstOperands,
     /*  25832 */   // GIR_Coverage, 2536,
     /*  25832 */   GIR_EraseRootFromParent_Done,
     /*  25833 */ // Label 518: @25833
     /*  25833 */ GIM_Reject,
     /*  25834 */ // Label 491: @25834
     /*  25834 */ GIM_Try, /*On fail goto*//*Label 519*/ GIMT_Encode4(25947),
     /*  25839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25842 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  25845 */   GIM_Try, /*On fail goto*//*Label 520*/ GIMT_Encode4(25885), // Rule ID 2540 //
     /*  25850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25865 */     // (xor:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)  =>  (VEORq:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)
     /*  25865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORq),
     /*  25868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25870 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  25872 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  25874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25877 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25883 */     GIR_RootConstrainSelectedInstOperands,
     /*  25884 */     // GIR_Coverage, 2540,
     /*  25884 */     GIR_EraseRootFromParent_Done,
     /*  25885 */   // Label 520: @25885
     /*  25885 */   GIM_Try, /*On fail goto*//*Label 521*/ GIMT_Encode4(25946), // Rule ID 3390 //
     /*  25890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25905 */     // (xor:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VEOR:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  25905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  25908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  25912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VEOR),
     /*  25920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  25922 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  25924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  25926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  25929 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25935 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25941 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25944 */     GIR_RootConstrainSelectedInstOperands,
     /*  25945 */     // GIR_Coverage, 3390,
     /*  25945 */     GIR_EraseRootFromParent_Done,
     /*  25946 */   // Label 521: @25946
     /*  25946 */   GIM_Reject,
     /*  25947 */ // Label 519: @25947
     /*  25947 */ GIM_Reject,
     /*  25948 */ // Label 492: @25948
     /*  25948 */ GIM_Try, /*On fail goto*//*Label 522*/ GIMT_Encode4(26065), // Rule ID 1833 //
     /*  25953 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  25959 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  25962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25966 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25970 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25974 */   // (xor:{ *:[v16i1] } VCCR:{ *:[v16i1] }:$p1, VCCR:{ *:[v16i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } (t2EORrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  25974 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  25977 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25981 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25986 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  25990 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25995 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  25998 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26002 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26007 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  26011 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  26016 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  26019 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2EORrr),
     /*  26023 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26028 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  26031 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  26034 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  26037 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26043 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26049 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  26051 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26054 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26056 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  26059 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  26064 */   // GIR_Coverage, 1833,
     /*  26064 */   GIR_EraseRootFromParent_Done,
     /*  26065 */ // Label 522: @26065
     /*  26065 */ GIM_Reject,
     /*  26066 */ // Label 493: @26066
     /*  26066 */ GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(26179),
     /*  26071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  26074 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  26077 */   GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(26117), // Rule ID 2539 //
     /*  26082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26097 */     // (xor:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)  =>  (VEORq:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)
     /*  26097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORq),
     /*  26100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  26102 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  26104 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  26106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  26109 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26115 */     GIR_RootConstrainSelectedInstOperands,
     /*  26116 */     // GIR_Coverage, 2539,
     /*  26116 */     GIR_EraseRootFromParent_Done,
     /*  26117 */   // Label 524: @26117
     /*  26117 */   GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(26178), // Rule ID 3386 //
     /*  26122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  26125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  26129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  26133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  26137 */     // (xor:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VEOR:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  26137 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  26140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  26144 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VEOR),
     /*  26152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  26154 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  26156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  26158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  26161 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26167 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  26176 */     GIR_RootConstrainSelectedInstOperands,
     /*  26177 */     // GIR_Coverage, 3386,
     /*  26177 */     GIR_EraseRootFromParent_Done,
     /*  26178 */   // Label 525: @26178
     /*  26178 */   GIM_Reject,
     /*  26179 */ // Label 523: @26179
     /*  26179 */ GIM_Reject,
     /*  26180 */ // Label 494: @26180
     /*  26180 */ GIM_Reject,
     /*  26181 */ // Label 8: @26181
     /*  26181 */ GIM_Try, /*On fail goto*//*Label 526*/ GIMT_Encode4(26567),
     /*  26186 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  26189 */   GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(16), /*)*//*default:*//*Label 531*/ GIMT_Encode4(26566),
     /*  26200 */   /*GILLT_v2s64*//*Label 527*/ GIMT_Encode4(26244), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  26212 */   /*GILLT_v4s32*//*Label 528*/ GIMT_Encode4(26302), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  26228 */   /*GILLT_v8s16*//*Label 529*/ GIMT_Encode4(26405), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  26240 */   /*GILLT_v16s8*//*Label 530*/ GIMT_Encode4(26508),
     /*  26244 */   // Label 527: @26244
     /*  26244 */   GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(26301), // Rule ID 3024 //
     /*  26249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26252 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  26255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  26258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26262 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26270 */     // (concat_vectors:{ *:[v2i64] } DPR:{ *:[v1i64] }:$Dn, DPR:{ *:[v1i64] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v2i64] } QPR:{ *:[i32] }, DPR:{ *:[v1i64] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v1i64] }:$Dm, dsub_1:{ *:[i32] })
     /*  26270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26275 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26277 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26282 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26285 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26290 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26295 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26300 */     // GIR_Coverage, 3024,
     /*  26300 */     GIR_EraseRootFromParent_Done,
     /*  26301 */   // Label 532: @26301
     /*  26301 */   GIM_Reject,
     /*  26302 */   // Label 528: @26302
     /*  26302 */   GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(26404),
     /*  26307 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  26310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  26313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26325 */     GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(26364), // Rule ID 3025 //
     /*  26330 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26333 */       // (concat_vectors:{ *:[v4i32] } DPR:{ *:[v2i32] }:$Dn, DPR:{ *:[v2i32] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v4i32] } QPR:{ *:[i32] }, DPR:{ *:[v2i32] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v2i32] }:$Dm, dsub_1:{ *:[i32] })
     /*  26333 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26336 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26338 */       GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26340 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26343 */       GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26345 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26348 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26353 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26358 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26363 */       // GIR_Coverage, 3025,
     /*  26363 */       GIR_EraseRootFromParent_Done,
     /*  26364 */     // Label 534: @26364
     /*  26364 */     GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(26403), // Rule ID 3028 //
     /*  26369 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26372 */       // (concat_vectors:{ *:[v4f32] } DPR:{ *:[v2f32] }:$Dn, DPR:{ *:[v2f32] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v4f32] } QPR:{ *:[i32] }, DPR:{ *:[v2f32] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v2f32] }:$Dm, dsub_1:{ *:[i32] })
     /*  26372 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26375 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26377 */       GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26379 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26382 */       GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26384 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26387 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26392 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26397 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26402 */       // GIR_Coverage, 3028,
     /*  26402 */       GIR_EraseRootFromParent_Done,
     /*  26403 */     // Label 535: @26403
     /*  26403 */     GIM_Reject,
     /*  26404 */   // Label 533: @26404
     /*  26404 */   GIM_Reject,
     /*  26405 */   // Label 529: @26405
     /*  26405 */   GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(26507),
     /*  26410 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26428 */     GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(26467), // Rule ID 3026 //
     /*  26433 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26436 */       // (concat_vectors:{ *:[v8i16] } DPR:{ *:[v4i16] }:$Dn, DPR:{ *:[v4i16] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v8i16] } QPR:{ *:[i32] }, DPR:{ *:[v4i16] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v4i16] }:$Dm, dsub_1:{ *:[i32] })
     /*  26436 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26439 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26441 */       GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26443 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26446 */       GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26448 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26451 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26456 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26461 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26466 */       // GIR_Coverage, 3026,
     /*  26466 */       GIR_EraseRootFromParent_Done,
     /*  26467 */     // Label 537: @26467
     /*  26467 */     GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(26506), // Rule ID 3029 //
     /*  26472 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26475 */       // (concat_vectors:{ *:[v8f16] } DPR:{ *:[v4f16] }:$Dn, DPR:{ *:[v4f16] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v8f16] } QPR:{ *:[i32] }, DPR:{ *:[v4f16] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v4f16] }:$Dm, dsub_1:{ *:[i32] })
     /*  26475 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26478 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26480 */       GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26482 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26485 */       GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26487 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26490 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26495 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26500 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26505 */       // GIR_Coverage, 3029,
     /*  26505 */       GIR_EraseRootFromParent_Done,
     /*  26506 */     // Label 538: @26506
     /*  26506 */     GIM_Reject,
     /*  26507 */   // Label 536: @26507
     /*  26507 */   GIM_Reject,
     /*  26508 */   // Label 530: @26508
     /*  26508 */   GIM_Try, /*On fail goto*//*Label 539*/ GIMT_Encode4(26565), // Rule ID 3027 //
     /*  26513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26516 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  26519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  26522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26526 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26534 */     // (concat_vectors:{ *:[v16i8] } DPR:{ *:[v8i8] }:$Dn, DPR:{ *:[v8i8] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v16i8] } QPR:{ *:[i32] }, DPR:{ *:[v8i8] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v8i8] }:$Dm, dsub_1:{ *:[i32] })
     /*  26534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26539 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26541 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26546 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26549 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26554 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26559 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26564 */     // GIR_Coverage, 3027,
     /*  26564 */     GIR_EraseRootFromParent_Done,
     /*  26565 */   // Label 539: @26565
     /*  26565 */   GIM_Reject,
     /*  26566 */   // Label 531: @26566
     /*  26566 */   GIM_Reject,
     /*  26567 */ // Label 526: @26567
     /*  26567 */ GIM_Reject,
     /*  26568 */ // Label 9: @26568
     /*  26568 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 549*/ GIMT_Encode4(35579),
     /*  26579 */ /*GILLT_s32*//*Label 540*/ GIMT_Encode4(26639),
     /*  26583 */ /*GILLT_s64*//*Label 541*/ GIMT_Encode4(26787), GIMT_Encode4(0),
     /*  26591 */ /*GILLT_v2s32*//*Label 542*/ GIMT_Encode4(27542),
     /*  26595 */ /*GILLT_v2s64*//*Label 543*/ GIMT_Encode4(28297), GIMT_Encode4(0),
     /*  26603 */ /*GILLT_v4s16*//*Label 544*/ GIMT_Encode4(30016),
     /*  26607 */ /*GILLT_v4s32*//*Label 545*/ GIMT_Encode4(30771), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  26619 */ /*GILLT_v8s8*//*Label 546*/ GIMT_Encode4(32490),
     /*  26623 */ /*GILLT_v8s16*//*Label 547*/ GIMT_Encode4(32905), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  26635 */ /*GILLT_v16s8*//*Label 548*/ GIMT_Encode4(34624),
     /*  26639 */ // Label 540: @26639
     /*  26639 */ GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(26786),
     /*  26644 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  26647 */   GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(26681), // Rule ID 692 //
     /*  26652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRegs),
     /*  26655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  26659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  26663 */     // (bitconvert:{ *:[i32] } SPR:{ *:[f32] }:$Sn)  =>  (VMOVRS:{ *:[i32] } SPR:{ *:[f32] }:$Sn)
     /*  26663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVRS),
     /*  26666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  26668 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /*  26670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  26673 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26679 */     GIR_RootConstrainSelectedInstOperands,
     /*  26680 */     // GIR_Coverage, 692,
     /*  26680 */     GIR_EraseRootFromParent_Done,
     /*  26681 */   // Label 551: @26681
     /*  26681 */   GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(26715), // Rule ID 693 //
     /*  26686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRegs_UseVMOVSR),
     /*  26689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  26693 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  26697 */     // (bitconvert:{ *:[f32] } GPR:{ *:[i32] }:$Rt)  =>  (VMOVSR:{ *:[f32] } GPR:{ *:[i32] }:$Rt)
     /*  26697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVSR),
     /*  26700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sn]
     /*  26702 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rt
     /*  26704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  26707 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26713 */     GIR_RootConstrainSelectedInstOperands,
     /*  26714 */     // GIR_Coverage, 693,
     /*  26714 */     GIR_EraseRootFromParent_Done,
     /*  26715 */   // Label 552: @26715
     /*  26715 */   GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(26785), // Rule ID 2718 //
     /*  26720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseVMOVSR_HasNEON),
     /*  26723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  26727 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  26731 */     // (bitconvert:{ *:[f32] } GPR:{ *:[i32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[f32] } (VMOVDRR:{ *:[f64] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$a), ssub_0:{ *:[i32] })
     /*  26731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  26734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VMOVDRR),
     /*  26738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26743 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /*  26747 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /*  26751 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  26754 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26760 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  26762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26767 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /*  26774 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  26779 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /*  26784 */     // GIR_Coverage, 2718,
     /*  26784 */     GIR_EraseRootFromParent_Done,
     /*  26785 */   // Label 553: @26785
     /*  26785 */   GIM_Reject,
     /*  26786 */ // Label 550: @26786
     /*  26786 */ GIM_Reject,
     /*  26787 */ // Label 541: @26787
     /*  26787 */ GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(26819), // Rule ID 2720 //
     /*  26792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  26798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26802 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26806 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26806 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26809 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26811 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26813 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26818 */   // GIR_Coverage, 2720,
     /*  26818 */   GIR_EraseRootFromParent_Done,
     /*  26819 */ // Label 554: @26819
     /*  26819 */ GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(26851), // Rule ID 2721 //
     /*  26824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  26830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26834 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26838 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  26838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26841 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26843 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26845 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26850 */   // GIR_Coverage, 2721,
     /*  26850 */   GIR_EraseRootFromParent_Done,
     /*  26851 */ // Label 555: @26851
     /*  26851 */ GIM_Try, /*On fail goto*//*Label 556*/ GIMT_Encode4(26883), // Rule ID 2732 //
     /*  26856 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  26859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  26862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26866 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26870 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26873 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26875 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26877 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26882 */   // GIR_Coverage, 2732,
     /*  26882 */   GIR_EraseRootFromParent_Done,
     /*  26883 */ // Label 556: @26883
     /*  26883 */ GIM_Try, /*On fail goto*//*Label 557*/ GIMT_Encode4(26915), // Rule ID 2733 //
     /*  26888 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  26891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  26894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26902 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26905 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26907 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26909 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26914 */   // GIR_Coverage, 2733,
     /*  26914 */   GIR_EraseRootFromParent_Done,
     /*  26915 */ // Label 557: @26915
     /*  26915 */ GIM_Try, /*On fail goto*//*Label 558*/ GIMT_Encode4(26947), // Rule ID 2734 //
     /*  26920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  26923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26930 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26934 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26937 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26939 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26941 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26946 */   // GIR_Coverage, 2734,
     /*  26946 */   GIR_EraseRootFromParent_Done,
     /*  26947 */ // Label 558: @26947
     /*  26947 */ GIM_Try, /*On fail goto*//*Label 559*/ GIMT_Encode4(26979), // Rule ID 2735 //
     /*  26952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  26955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26962 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26966 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26969 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26971 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26973 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26978 */   // GIR_Coverage, 2735,
     /*  26978 */   GIR_EraseRootFromParent_Done,
     /*  26979 */ // Label 559: @26979
     /*  26979 */ GIM_Try, /*On fail goto*//*Label 560*/ GIMT_Encode4(27011), // Rule ID 2736 //
     /*  26984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  26987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  26990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26998 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27001 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27003 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27005 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27010 */   // GIR_Coverage, 2736,
     /*  27010 */   GIR_EraseRootFromParent_Done,
     /*  27011 */ // Label 560: @27011
     /*  27011 */ GIM_Try, /*On fail goto*//*Label 561*/ GIMT_Encode4(27043), // Rule ID 2737 //
     /*  27016 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27026 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27030 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  27030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27033 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27035 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27037 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27042 */   // GIR_Coverage, 2737,
     /*  27042 */   GIR_EraseRootFromParent_Done,
     /*  27043 */ // Label 561: @27043
     /*  27043 */ GIM_Try, /*On fail goto*//*Label 562*/ GIMT_Encode4(27075), // Rule ID 2738 //
     /*  27048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27058 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27062 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  27062 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27065 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27067 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27069 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27074 */   // GIR_Coverage, 2738,
     /*  27074 */   GIR_EraseRootFromParent_Done,
     /*  27075 */ // Label 562: @27075
     /*  27075 */ GIM_Try, /*On fail goto*//*Label 563*/ GIMT_Encode4(27107), // Rule ID 2739 //
     /*  27080 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27090 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27094 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  27094 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27097 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27099 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27101 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27106 */   // GIR_Coverage, 2739,
     /*  27106 */   GIR_EraseRootFromParent_Done,
     /*  27107 */ // Label 563: @27107
     /*  27107 */ GIM_Try, /*On fail goto*//*Label 564*/ GIMT_Encode4(27139), // Rule ID 2740 //
     /*  27112 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27122 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27126 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  27126 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27129 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27131 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27133 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27138 */   // GIR_Coverage, 2740,
     /*  27138 */   GIR_EraseRootFromParent_Done,
     /*  27139 */ // Label 564: @27139
     /*  27139 */ GIM_Try, /*On fail goto*//*Label 565*/ GIMT_Encode4(27171), // Rule ID 2741 //
     /*  27144 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  27150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27154 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27158 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  27158 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27161 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27163 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27165 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27170 */   // GIR_Coverage, 2741,
     /*  27170 */   GIR_EraseRootFromParent_Done,
     /*  27171 */ // Label 565: @27171
     /*  27171 */ GIM_Try, /*On fail goto*//*Label 566*/ GIMT_Encode4(27208), // Rule ID 2804 //
     /*  27176 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27186 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27190 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v2f32] }:$src)  =>  (VREV64d32:{ *:[f64] } DPR:{ *:[v2f32] }:$src)
     /*  27190 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27193 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27195 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27197 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27200 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27206 */   GIR_RootConstrainSelectedInstOperands,
     /*  27207 */   // GIR_Coverage, 2804,
     /*  27207 */   GIR_EraseRootFromParent_Done,
     /*  27208 */ // Label 566: @27208
     /*  27208 */ GIM_Try, /*On fail goto*//*Label 567*/ GIMT_Encode4(27245), // Rule ID 2805 //
     /*  27213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27223 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27227 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v2i32] }:$src)  =>  (VREV64d32:{ *:[f64] } DPR:{ *:[v2i32] }:$src)
     /*  27227 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27230 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27232 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27234 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27237 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27243 */   GIR_RootConstrainSelectedInstOperands,
     /*  27244 */   // GIR_Coverage, 2805,
     /*  27244 */   GIR_EraseRootFromParent_Done,
     /*  27245 */ // Label 567: @27245
     /*  27245 */ GIM_Try, /*On fail goto*//*Label 568*/ GIMT_Encode4(27282), // Rule ID 2806 //
     /*  27250 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27260 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27264 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v4f16] }:$src)  =>  (VREV64d16:{ *:[f64] } DPR:{ *:[v4f16] }:$src)
     /*  27264 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  27267 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27269 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27271 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27274 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27280 */   GIR_RootConstrainSelectedInstOperands,
     /*  27281 */   // GIR_Coverage, 2806,
     /*  27281 */   GIR_EraseRootFromParent_Done,
     /*  27282 */ // Label 568: @27282
     /*  27282 */ GIM_Try, /*On fail goto*//*Label 569*/ GIMT_Encode4(27319), // Rule ID 2807 //
     /*  27287 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27297 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27301 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v4i16] }:$src)  =>  (VREV64d16:{ *:[f64] } DPR:{ *:[v4i16] }:$src)
     /*  27301 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  27304 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27306 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27308 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27311 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27317 */   GIR_RootConstrainSelectedInstOperands,
     /*  27318 */   // GIR_Coverage, 2807,
     /*  27318 */   GIR_EraseRootFromParent_Done,
     /*  27319 */ // Label 569: @27319
     /*  27319 */ GIM_Try, /*On fail goto*//*Label 570*/ GIMT_Encode4(27356), // Rule ID 2808 //
     /*  27324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  27330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27334 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27338 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v8i8] }:$src)  =>  (VREV64d8:{ *:[f64] } DPR:{ *:[v8i8] }:$src)
     /*  27338 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d8),
     /*  27341 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27343 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27345 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27348 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27354 */   GIR_RootConstrainSelectedInstOperands,
     /*  27355 */   // GIR_Coverage, 2808,
     /*  27355 */   GIR_EraseRootFromParent_Done,
     /*  27356 */ // Label 570: @27356
     /*  27356 */ GIM_Try, /*On fail goto*//*Label 571*/ GIMT_Encode4(27393), // Rule ID 2809 //
     /*  27361 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27371 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27375 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v2f32] }:$src)  =>  (VREV64d32:{ *:[v1i64] } DPR:{ *:[v2f32] }:$src)
     /*  27375 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27378 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27380 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27382 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27385 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27391 */   GIR_RootConstrainSelectedInstOperands,
     /*  27392 */   // GIR_Coverage, 2809,
     /*  27392 */   GIR_EraseRootFromParent_Done,
     /*  27393 */ // Label 571: @27393
     /*  27393 */ GIM_Try, /*On fail goto*//*Label 572*/ GIMT_Encode4(27430), // Rule ID 2810 //
     /*  27398 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27412 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v2i32] }:$src)  =>  (VREV64d32:{ *:[v1i64] } DPR:{ *:[v2i32] }:$src)
     /*  27412 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27415 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27417 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27419 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27422 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27428 */   GIR_RootConstrainSelectedInstOperands,
     /*  27429 */   // GIR_Coverage, 2810,
     /*  27429 */   GIR_EraseRootFromParent_Done,
     /*  27430 */ // Label 572: @27430
     /*  27430 */ GIM_Try, /*On fail goto*//*Label 573*/ GIMT_Encode4(27467), // Rule ID 2811 //
     /*  27435 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27445 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27449 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v4f16] }:$src)  =>  (VREV64d16:{ *:[v1i64] } DPR:{ *:[v4f16] }:$src)
     /*  27449 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  27452 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27454 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27456 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27459 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27465 */   GIR_RootConstrainSelectedInstOperands,
     /*  27466 */   // GIR_Coverage, 2811,
     /*  27466 */   GIR_EraseRootFromParent_Done,
     /*  27467 */ // Label 573: @27467
     /*  27467 */ GIM_Try, /*On fail goto*//*Label 574*/ GIMT_Encode4(27504), // Rule ID 2812 //
     /*  27472 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27482 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27486 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v4i16] }:$src)  =>  (VREV64d16:{ *:[v1i64] } DPR:{ *:[v4i16] }:$src)
     /*  27486 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  27489 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27491 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27493 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27496 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27502 */   GIR_RootConstrainSelectedInstOperands,
     /*  27503 */   // GIR_Coverage, 2812,
     /*  27503 */   GIR_EraseRootFromParent_Done,
     /*  27504 */ // Label 574: @27504
     /*  27504 */ GIM_Try, /*On fail goto*//*Label 575*/ GIMT_Encode4(27541), // Rule ID 2813 //
     /*  27509 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  27515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27519 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27523 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v8i8] }:$src)  =>  (VREV64d8:{ *:[v1i64] } DPR:{ *:[v8i8] }:$src)
     /*  27523 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d8),
     /*  27526 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27528 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27530 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27533 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27539 */   GIR_RootConstrainSelectedInstOperands,
     /*  27540 */   // GIR_Coverage, 2813,
     /*  27540 */   GIR_EraseRootFromParent_Done,
     /*  27541 */ // Label 575: @27541
     /*  27541 */ GIM_Reject,
     /*  27542 */ // Label 542: @27542
     /*  27542 */ GIM_Try, /*On fail goto*//*Label 576*/ GIMT_Encode4(27574), // Rule ID 2722 //
     /*  27547 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27557 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27561 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27561 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27564 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27566 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27568 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27573 */   // GIR_Coverage, 2722,
     /*  27573 */   GIR_EraseRootFromParent_Done,
     /*  27574 */ // Label 576: @27574
     /*  27574 */ GIM_Try, /*On fail goto*//*Label 577*/ GIMT_Encode4(27606), // Rule ID 2723 //
     /*  27579 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27582 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27589 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27593 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27593 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27596 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27598 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27600 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27605 */   // GIR_Coverage, 2723,
     /*  27605 */   GIR_EraseRootFromParent_Done,
     /*  27606 */ // Label 577: @27606
     /*  27606 */ GIM_Try, /*On fail goto*//*Label 578*/ GIMT_Encode4(27638), // Rule ID 2742 //
     /*  27611 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27621 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27625 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27625 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27628 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27630 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27632 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27637 */   // GIR_Coverage, 2742,
     /*  27637 */   GIR_EraseRootFromParent_Done,
     /*  27638 */ // Label 578: @27638
     /*  27638 */ GIM_Try, /*On fail goto*//*Label 579*/ GIMT_Encode4(27670), // Rule ID 2743 //
     /*  27643 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27653 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27657 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27657 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27660 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27662 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27664 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27669 */   // GIR_Coverage, 2743,
     /*  27669 */   GIR_EraseRootFromParent_Done,
     /*  27670 */ // Label 579: @27670
     /*  27670 */ GIM_Try, /*On fail goto*//*Label 580*/ GIMT_Encode4(27702), // Rule ID 2744 //
     /*  27675 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27678 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27685 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27689 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27689 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27692 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27694 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27696 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27701 */   // GIR_Coverage, 2744,
     /*  27701 */   GIR_EraseRootFromParent_Done,
     /*  27702 */ // Label 580: @27702
     /*  27702 */ GIM_Try, /*On fail goto*//*Label 581*/ GIMT_Encode4(27734), // Rule ID 2745 //
     /*  27707 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27717 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27721 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27721 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27724 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27726 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27728 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27733 */   // GIR_Coverage, 2745,
     /*  27733 */   GIR_EraseRootFromParent_Done,
     /*  27734 */ // Label 581: @27734
     /*  27734 */ GIM_Try, /*On fail goto*//*Label 582*/ GIMT_Encode4(27766), // Rule ID 2746 //
     /*  27739 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  27745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27749 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27753 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27753 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27756 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27758 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27760 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27765 */   // GIR_Coverage, 2746,
     /*  27765 */   GIR_EraseRootFromParent_Done,
     /*  27766 */ // Label 582: @27766
     /*  27766 */ GIM_Try, /*On fail goto*//*Label 583*/ GIMT_Encode4(27798), // Rule ID 2747 //
     /*  27771 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27781 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27785 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27785 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27788 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27790 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27792 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27797 */   // GIR_Coverage, 2747,
     /*  27797 */   GIR_EraseRootFromParent_Done,
     /*  27798 */ // Label 583: @27798
     /*  27798 */ GIM_Try, /*On fail goto*//*Label 584*/ GIMT_Encode4(27830), // Rule ID 2748 //
     /*  27803 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27813 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27817 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27817 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27820 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27822 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27824 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27829 */   // GIR_Coverage, 2748,
     /*  27829 */   GIR_EraseRootFromParent_Done,
     /*  27830 */ // Label 584: @27830
     /*  27830 */ GIM_Try, /*On fail goto*//*Label 585*/ GIMT_Encode4(27862), // Rule ID 2749 //
     /*  27835 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27845 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27849 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27849 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27852 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27854 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27856 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27861 */   // GIR_Coverage, 2749,
     /*  27861 */   GIR_EraseRootFromParent_Done,
     /*  27862 */ // Label 585: @27862
     /*  27862 */ GIM_Try, /*On fail goto*//*Label 586*/ GIMT_Encode4(27894), // Rule ID 2750 //
     /*  27867 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27870 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27877 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27881 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27881 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27884 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27886 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27888 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27893 */   // GIR_Coverage, 2750,
     /*  27893 */   GIR_EraseRootFromParent_Done,
     /*  27894 */ // Label 586: @27894
     /*  27894 */ GIM_Try, /*On fail goto*//*Label 587*/ GIMT_Encode4(27926), // Rule ID 2751 //
     /*  27899 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  27905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27909 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27913 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27913 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27916 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27918 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27920 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27925 */   // GIR_Coverage, 2751,
     /*  27925 */   GIR_EraseRootFromParent_Done,
     /*  27926 */ // Label 587: @27926
     /*  27926 */ GIM_Try, /*On fail goto*//*Label 588*/ GIMT_Encode4(27963), // Rule ID 2814 //
     /*  27931 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27941 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27945 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[f64] }:$src)  =>  (VREV64d32:{ *:[v2f32] } DPR:{ *:[f64] }:$src)
     /*  27945 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27948 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27950 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27952 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27955 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27961 */   GIR_RootConstrainSelectedInstOperands,
     /*  27962 */   // GIR_Coverage, 2814,
     /*  27962 */   GIR_EraseRootFromParent_Done,
     /*  27963 */ // Label 588: @27963
     /*  27963 */ GIM_Try, /*On fail goto*//*Label 589*/ GIMT_Encode4(28000), // Rule ID 2815 //
     /*  27968 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27982 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v1i64] }:$src)  =>  (VREV64d32:{ *:[v2f32] } DPR:{ *:[v1i64] }:$src)
     /*  27982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27985 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27987 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27989 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27992 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27998 */   GIR_RootConstrainSelectedInstOperands,
     /*  27999 */   // GIR_Coverage, 2815,
     /*  27999 */   GIR_EraseRootFromParent_Done,
     /*  28000 */ // Label 589: @28000
     /*  28000 */ GIM_Try, /*On fail goto*//*Label 590*/ GIMT_Encode4(28037), // Rule ID 2816 //
     /*  28005 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28015 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28019 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v4f16] }:$src)  =>  (VREV32d16:{ *:[v2f32] } DPR:{ *:[v4f16] }:$src)
     /*  28019 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  28022 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28024 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28026 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28029 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28035 */   GIR_RootConstrainSelectedInstOperands,
     /*  28036 */   // GIR_Coverage, 2816,
     /*  28036 */   GIR_EraseRootFromParent_Done,
     /*  28037 */ // Label 590: @28037
     /*  28037 */ GIM_Try, /*On fail goto*//*Label 591*/ GIMT_Encode4(28074), // Rule ID 2817 //
     /*  28042 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28045 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28052 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28056 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v4i16] }:$src)  =>  (VREV32d16:{ *:[v2f32] } DPR:{ *:[v4i16] }:$src)
     /*  28056 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  28059 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28061 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28063 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28066 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28072 */   GIR_RootConstrainSelectedInstOperands,
     /*  28073 */   // GIR_Coverage, 2817,
     /*  28073 */   GIR_EraseRootFromParent_Done,
     /*  28074 */ // Label 591: @28074
     /*  28074 */ GIM_Try, /*On fail goto*//*Label 592*/ GIMT_Encode4(28111), // Rule ID 2818 //
     /*  28079 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  28085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28089 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28093 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v8i8] }:$src)  =>  (VREV32d8:{ *:[v2f32] } DPR:{ *:[v8i8] }:$src)
     /*  28093 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d8),
     /*  28096 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28098 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28100 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28103 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28109 */   GIR_RootConstrainSelectedInstOperands,
     /*  28110 */   // GIR_Coverage, 2818,
     /*  28110 */   GIR_EraseRootFromParent_Done,
     /*  28111 */ // Label 592: @28111
     /*  28111 */ GIM_Try, /*On fail goto*//*Label 593*/ GIMT_Encode4(28148), // Rule ID 2819 //
     /*  28116 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  28122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28126 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28130 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[f64] }:$src)  =>  (VREV64d32:{ *:[v2i32] } DPR:{ *:[f64] }:$src)
     /*  28130 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  28133 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28135 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28137 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28140 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28146 */   GIR_RootConstrainSelectedInstOperands,
     /*  28147 */   // GIR_Coverage, 2819,
     /*  28147 */   GIR_EraseRootFromParent_Done,
     /*  28148 */ // Label 593: @28148
     /*  28148 */ GIM_Try, /*On fail goto*//*Label 594*/ GIMT_Encode4(28185), // Rule ID 2820 //
     /*  28153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  28159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28163 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28167 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v1i64] }:$src)  =>  (VREV64d32:{ *:[v2i32] } DPR:{ *:[v1i64] }:$src)
     /*  28167 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  28170 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28172 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28174 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28177 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28183 */   GIR_RootConstrainSelectedInstOperands,
     /*  28184 */   // GIR_Coverage, 2820,
     /*  28184 */   GIR_EraseRootFromParent_Done,
     /*  28185 */ // Label 594: @28185
     /*  28185 */ GIM_Try, /*On fail goto*//*Label 595*/ GIMT_Encode4(28222), // Rule ID 2821 //
     /*  28190 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28193 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28200 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28204 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v4f16] }:$src)  =>  (VREV32d16:{ *:[v2i32] } DPR:{ *:[v4f16] }:$src)
     /*  28204 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  28207 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28209 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28211 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28214 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28220 */   GIR_RootConstrainSelectedInstOperands,
     /*  28221 */   // GIR_Coverage, 2821,
     /*  28221 */   GIR_EraseRootFromParent_Done,
     /*  28222 */ // Label 595: @28222
     /*  28222 */ GIM_Try, /*On fail goto*//*Label 596*/ GIMT_Encode4(28259), // Rule ID 2822 //
     /*  28227 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28230 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28237 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28241 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v4i16] }:$src)  =>  (VREV32d16:{ *:[v2i32] } DPR:{ *:[v4i16] }:$src)
     /*  28241 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  28244 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28246 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28248 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28251 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28257 */   GIR_RootConstrainSelectedInstOperands,
     /*  28258 */   // GIR_Coverage, 2822,
     /*  28258 */   GIR_EraseRootFromParent_Done,
     /*  28259 */ // Label 596: @28259
     /*  28259 */ GIM_Try, /*On fail goto*//*Label 597*/ GIMT_Encode4(28296), // Rule ID 2823 //
     /*  28264 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  28270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28274 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28278 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v8i8] }:$src)  =>  (VREV32d8:{ *:[v2i32] } DPR:{ *:[v8i8] }:$src)
     /*  28278 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d8),
     /*  28281 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28283 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28285 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28288 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28294 */   GIR_RootConstrainSelectedInstOperands,
     /*  28295 */   // GIR_Coverage, 2823,
     /*  28295 */   GIR_EraseRootFromParent_Done,
     /*  28296 */ // Label 597: @28296
     /*  28296 */ GIM_Reject,
     /*  28297 */ // Label 543: @28297
     /*  28297 */ GIM_Try, /*On fail goto*//*Label 598*/ GIMT_Encode4(28329), // Rule ID 2726 //
     /*  28302 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  28308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28312 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28316 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28316 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28319 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28321 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28323 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28328 */   // GIR_Coverage, 2726,
     /*  28328 */   GIR_EraseRootFromParent_Done,
     /*  28329 */ // Label 598: @28329
     /*  28329 */ GIM_Try, /*On fail goto*//*Label 599*/ GIMT_Encode4(28361), // Rule ID 2727 //
     /*  28334 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  28340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28344 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28348 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28348 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28351 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28353 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28355 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28360 */   // GIR_Coverage, 2727,
     /*  28360 */   GIR_EraseRootFromParent_Done,
     /*  28361 */ // Label 599: @28361
     /*  28361 */ GIM_Try, /*On fail goto*//*Label 600*/ GIMT_Encode4(28393), // Rule ID 2768 //
     /*  28366 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28376 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28380 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28380 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28383 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28385 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28387 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28392 */   // GIR_Coverage, 2768,
     /*  28392 */   GIR_EraseRootFromParent_Done,
     /*  28393 */ // Label 600: @28393
     /*  28393 */ GIM_Try, /*On fail goto*//*Label 601*/ GIMT_Encode4(28425), // Rule ID 2769 //
     /*  28398 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28412 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28412 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28415 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28417 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28419 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28424 */   // GIR_Coverage, 2769,
     /*  28424 */   GIR_EraseRootFromParent_Done,
     /*  28425 */ // Label 601: @28425
     /*  28425 */ GIM_Try, /*On fail goto*//*Label 602*/ GIMT_Encode4(28457), // Rule ID 2770 //
     /*  28430 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28440 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28444 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28444 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28447 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28449 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28451 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28456 */   // GIR_Coverage, 2770,
     /*  28456 */   GIR_EraseRootFromParent_Done,
     /*  28457 */ // Label 602: @28457
     /*  28457 */ GIM_Try, /*On fail goto*//*Label 603*/ GIMT_Encode4(28489), // Rule ID 2771 //
     /*  28462 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28472 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28476 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28476 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28479 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28481 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28483 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28488 */   // GIR_Coverage, 2771,
     /*  28488 */   GIR_EraseRootFromParent_Done,
     /*  28489 */ // Label 603: @28489
     /*  28489 */ GIM_Try, /*On fail goto*//*Label 604*/ GIMT_Encode4(28521), // Rule ID 2772 //
     /*  28494 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  28500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28504 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28508 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28508 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28511 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28513 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28515 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28520 */   // GIR_Coverage, 2772,
     /*  28520 */   GIR_EraseRootFromParent_Done,
     /*  28521 */ // Label 604: @28521
     /*  28521 */ GIM_Try, /*On fail goto*//*Label 605*/ GIMT_Encode4(28553), // Rule ID 2773 //
     /*  28526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28536 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28540 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28540 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28543 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28545 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28547 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28552 */   // GIR_Coverage, 2773,
     /*  28552 */   GIR_EraseRootFromParent_Done,
     /*  28553 */ // Label 605: @28553
     /*  28553 */ GIM_Try, /*On fail goto*//*Label 606*/ GIMT_Encode4(28585), // Rule ID 2774 //
     /*  28558 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28568 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28572 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28572 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28575 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28577 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28579 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28584 */   // GIR_Coverage, 2774,
     /*  28584 */   GIR_EraseRootFromParent_Done,
     /*  28585 */ // Label 606: @28585
     /*  28585 */ GIM_Try, /*On fail goto*//*Label 607*/ GIMT_Encode4(28617), // Rule ID 2775 //
     /*  28590 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28600 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28604 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28604 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28607 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28609 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28611 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28616 */   // GIR_Coverage, 2775,
     /*  28616 */   GIR_EraseRootFromParent_Done,
     /*  28617 */ // Label 607: @28617
     /*  28617 */ GIM_Try, /*On fail goto*//*Label 608*/ GIMT_Encode4(28649), // Rule ID 2776 //
     /*  28622 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28632 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28636 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28636 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28639 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28641 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28643 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28648 */   // GIR_Coverage, 2776,
     /*  28648 */   GIR_EraseRootFromParent_Done,
     /*  28649 */ // Label 608: @28649
     /*  28649 */ GIM_Try, /*On fail goto*//*Label 609*/ GIMT_Encode4(28681), // Rule ID 2777 //
     /*  28654 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  28660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28664 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28668 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28668 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28671 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28673 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28675 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28680 */   // GIR_Coverage, 2777,
     /*  28680 */   GIR_EraseRootFromParent_Done,
     /*  28681 */ // Label 609: @28681
     /*  28681 */ GIM_Try, /*On fail goto*//*Label 610*/ GIMT_Encode4(28718), // Rule ID 2840 //
     /*  28686 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28700 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v4f32] }:$src)  =>  (VREV64q32:{ *:[v2f64] } QPR:{ *:[v4f32] }:$src)
     /*  28700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  28703 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28705 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28707 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28710 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28716 */   GIR_RootConstrainSelectedInstOperands,
     /*  28717 */   // GIR_Coverage, 2840,
     /*  28717 */   GIR_EraseRootFromParent_Done,
     /*  28718 */ // Label 610: @28718
     /*  28718 */ GIM_Try, /*On fail goto*//*Label 611*/ GIMT_Encode4(28755), // Rule ID 2841 //
     /*  28723 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28726 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28733 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28737 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v4i32] }:$src)  =>  (VREV64q32:{ *:[v2f64] } QPR:{ *:[v4i32] }:$src)
     /*  28737 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  28740 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28742 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28744 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28747 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28753 */   GIR_RootConstrainSelectedInstOperands,
     /*  28754 */   // GIR_Coverage, 2841,
     /*  28754 */   GIR_EraseRootFromParent_Done,
     /*  28755 */ // Label 611: @28755
     /*  28755 */ GIM_Try, /*On fail goto*//*Label 612*/ GIMT_Encode4(28792), // Rule ID 2842 //
     /*  28760 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28770 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28774 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v8f16] }:$src)  =>  (VREV64q16:{ *:[v2f64] } QPR:{ *:[v8f16] }:$src)
     /*  28774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  28777 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28779 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28781 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28784 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28790 */   GIR_RootConstrainSelectedInstOperands,
     /*  28791 */   // GIR_Coverage, 2842,
     /*  28791 */   GIR_EraseRootFromParent_Done,
     /*  28792 */ // Label 612: @28792
     /*  28792 */ GIM_Try, /*On fail goto*//*Label 613*/ GIMT_Encode4(28829), // Rule ID 2843 //
     /*  28797 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28807 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28811 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v8i16] }:$src)  =>  (VREV64q16:{ *:[v2f64] } QPR:{ *:[v8i16] }:$src)
     /*  28811 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  28814 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28816 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28818 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28821 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28827 */   GIR_RootConstrainSelectedInstOperands,
     /*  28828 */   // GIR_Coverage, 2843,
     /*  28828 */   GIR_EraseRootFromParent_Done,
     /*  28829 */ // Label 613: @28829
     /*  28829 */ GIM_Try, /*On fail goto*//*Label 614*/ GIMT_Encode4(28866), // Rule ID 2844 //
     /*  28834 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  28840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28844 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28848 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v16i8] }:$src)  =>  (VREV64q8:{ *:[v2f64] } QPR:{ *:[v16i8] }:$src)
     /*  28848 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q8),
     /*  28851 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28853 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28855 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28858 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28864 */   GIR_RootConstrainSelectedInstOperands,
     /*  28865 */   // GIR_Coverage, 2844,
     /*  28865 */   GIR_EraseRootFromParent_Done,
     /*  28866 */ // Label 614: @28866
     /*  28866 */ GIM_Try, /*On fail goto*//*Label 615*/ GIMT_Encode4(28903), // Rule ID 2845 //
     /*  28871 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28881 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28885 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v4f32] }:$src)  =>  (VREV64q32:{ *:[v2i64] } QPR:{ *:[v4f32] }:$src)
     /*  28885 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  28888 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28890 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28892 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28895 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28901 */   GIR_RootConstrainSelectedInstOperands,
     /*  28902 */   // GIR_Coverage, 2845,
     /*  28902 */   GIR_EraseRootFromParent_Done,
     /*  28903 */ // Label 615: @28903
     /*  28903 */ GIM_Try, /*On fail goto*//*Label 616*/ GIMT_Encode4(28940), // Rule ID 2846 //
     /*  28908 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28918 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28922 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v4i32] }:$src)  =>  (VREV64q32:{ *:[v2i64] } QPR:{ *:[v4i32] }:$src)
     /*  28922 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  28925 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28927 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28929 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28932 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28938 */   GIR_RootConstrainSelectedInstOperands,
     /*  28939 */   // GIR_Coverage, 2846,
     /*  28939 */   GIR_EraseRootFromParent_Done,
     /*  28940 */ // Label 616: @28940
     /*  28940 */ GIM_Try, /*On fail goto*//*Label 617*/ GIMT_Encode4(28977), // Rule ID 2847 //
     /*  28945 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28955 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28959 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v8f16] }:$src)  =>  (VREV64q16:{ *:[v2i64] } QPR:{ *:[v8f16] }:$src)
     /*  28959 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  28962 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28964 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28966 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28969 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28975 */   GIR_RootConstrainSelectedInstOperands,
     /*  28976 */   // GIR_Coverage, 2847,
     /*  28976 */   GIR_EraseRootFromParent_Done,
     /*  28977 */ // Label 617: @28977
     /*  28977 */ GIM_Try, /*On fail goto*//*Label 618*/ GIMT_Encode4(29014), // Rule ID 2848 //
     /*  28982 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28992 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28996 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v8i16] }:$src)  =>  (VREV64q16:{ *:[v2i64] } QPR:{ *:[v8i16] }:$src)
     /*  28996 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  28999 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  29001 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29003 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  29006 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29012 */   GIR_RootConstrainSelectedInstOperands,
     /*  29013 */   // GIR_Coverage, 2848,
     /*  29013 */   GIR_EraseRootFromParent_Done,
     /*  29014 */ // Label 618: @29014
     /*  29014 */ GIM_Try, /*On fail goto*//*Label 619*/ GIMT_Encode4(29051), // Rule ID 2849 //
     /*  29019 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  29022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  29029 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  29033 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v16i8] }:$src)  =>  (VREV64q8:{ *:[v2i64] } QPR:{ *:[v16i8] }:$src)
     /*  29033 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q8),
     /*  29036 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  29038 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29040 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  29043 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29049 */   GIR_RootConstrainSelectedInstOperands,
     /*  29050 */   // GIR_Coverage, 2849,
     /*  29050 */   GIR_EraseRootFromParent_Done,
     /*  29051 */ // Label 619: @29051
     /*  29051 */ GIM_Try, /*On fail goto*//*Label 620*/ GIMT_Encode4(29083), // Rule ID 5283 //
     /*  29056 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  29059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  29062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29066 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29070 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29070 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29073 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29075 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29077 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29082 */   // GIR_Coverage, 5283,
     /*  29082 */   GIR_EraseRootFromParent_Done,
     /*  29083 */ // Label 620: @29083
     /*  29083 */ GIM_Try, /*On fail goto*//*Label 621*/ GIMT_Encode4(29115), // Rule ID 5284 //
     /*  29088 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  29091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  29094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29098 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29102 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29105 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29107 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29109 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29114 */   // GIR_Coverage, 5284,
     /*  29114 */   GIR_EraseRootFromParent_Done,
     /*  29115 */ // Label 621: @29115
     /*  29115 */ GIM_Try, /*On fail goto*//*Label 622*/ GIMT_Encode4(29147), // Rule ID 5289 //
     /*  29120 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29123 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29130 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29134 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29134 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29137 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29139 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29141 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29146 */   // GIR_Coverage, 5289,
     /*  29146 */   GIR_EraseRootFromParent_Done,
     /*  29147 */ // Label 622: @29147
     /*  29147 */ GIM_Try, /*On fail goto*//*Label 623*/ GIMT_Encode4(29179), // Rule ID 5290 //
     /*  29152 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29162 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29166 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29166 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29169 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29171 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29173 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29178 */   // GIR_Coverage, 5290,
     /*  29178 */   GIR_EraseRootFromParent_Done,
     /*  29179 */ // Label 623: @29179
     /*  29179 */ GIM_Try, /*On fail goto*//*Label 624*/ GIMT_Encode4(29211), // Rule ID 5291 //
     /*  29184 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29187 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29194 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29198 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29198 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29201 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29203 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29205 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29210 */   // GIR_Coverage, 5291,
     /*  29210 */   GIR_EraseRootFromParent_Done,
     /*  29211 */ // Label 624: @29211
     /*  29211 */ GIM_Try, /*On fail goto*//*Label 625*/ GIMT_Encode4(29243), // Rule ID 5292 //
     /*  29216 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29226 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29230 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29230 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29233 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29235 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29237 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29242 */   // GIR_Coverage, 5292,
     /*  29242 */   GIR_EraseRootFromParent_Done,
     /*  29243 */ // Label 625: @29243
     /*  29243 */ GIM_Try, /*On fail goto*//*Label 626*/ GIMT_Encode4(29275), // Rule ID 5293 //
     /*  29248 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29258 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29262 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29262 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29265 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29267 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29269 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29274 */   // GIR_Coverage, 5293,
     /*  29274 */   GIR_EraseRootFromParent_Done,
     /*  29275 */ // Label 626: @29275
     /*  29275 */ GIM_Try, /*On fail goto*//*Label 627*/ GIMT_Encode4(29307), // Rule ID 5294 //
     /*  29280 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29290 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29294 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29294 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29297 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29299 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29301 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29306 */   // GIR_Coverage, 5294,
     /*  29306 */   GIR_EraseRootFromParent_Done,
     /*  29307 */ // Label 627: @29307
     /*  29307 */ GIM_Try, /*On fail goto*//*Label 628*/ GIMT_Encode4(29339), // Rule ID 5295 //
     /*  29312 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29322 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29326 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29326 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29329 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29331 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29333 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29338 */   // GIR_Coverage, 5295,
     /*  29338 */   GIR_EraseRootFromParent_Done,
     /*  29339 */ // Label 628: @29339
     /*  29339 */ GIM_Try, /*On fail goto*//*Label 629*/ GIMT_Encode4(29371), // Rule ID 5296 //
     /*  29344 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29354 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29358 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29361 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29363 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29365 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29370 */   // GIR_Coverage, 5296,
     /*  29370 */   GIR_EraseRootFromParent_Done,
     /*  29371 */ // Label 629: @29371
     /*  29371 */ GIM_Try, /*On fail goto*//*Label 630*/ GIMT_Encode4(29403), // Rule ID 5297 //
     /*  29376 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29386 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29390 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29390 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29393 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29395 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29397 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29402 */   // GIR_Coverage, 5297,
     /*  29402 */   GIR_EraseRootFromParent_Done,
     /*  29403 */ // Label 630: @29403
     /*  29403 */ GIM_Try, /*On fail goto*//*Label 631*/ GIMT_Encode4(29435), // Rule ID 5298 //
     /*  29408 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29418 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29422 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29422 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29425 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29427 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29429 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29434 */   // GIR_Coverage, 5298,
     /*  29434 */   GIR_EraseRootFromParent_Done,
     /*  29435 */ // Label 631: @29435
     /*  29435 */ GIM_Try, /*On fail goto*//*Label 632*/ GIMT_Encode4(29493), // Rule ID 5325 //
     /*  29440 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29450 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29454 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VREV64_32:{ *:[v2f64] } MQPR:{ *:[v4f32] }:$src)
     /*  29454 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29457 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29461 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29466 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  29469 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29471 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29473 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29476 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29482 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29488 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29491 */   GIR_RootConstrainSelectedInstOperands,
     /*  29492 */   // GIR_Coverage, 5325,
     /*  29492 */   GIR_EraseRootFromParent_Done,
     /*  29493 */ // Label 632: @29493
     /*  29493 */ GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(29551), // Rule ID 5326 //
     /*  29498 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29508 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29512 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV64_32:{ *:[v2f64] } MQPR:{ *:[v4i32] }:$src)
     /*  29512 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29515 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29519 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29524 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  29527 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29529 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29531 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29534 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29540 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29546 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29549 */   GIR_RootConstrainSelectedInstOperands,
     /*  29550 */   // GIR_Coverage, 5326,
     /*  29550 */   GIR_EraseRootFromParent_Done,
     /*  29551 */ // Label 633: @29551
     /*  29551 */ GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(29609), // Rule ID 5327 //
     /*  29556 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29566 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29570 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VREV64_16:{ *:[v2f64] } MQPR:{ *:[v8f16] }:$src)
     /*  29570 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29573 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29577 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29582 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  29585 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29587 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29589 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29592 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29598 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29604 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29607 */   GIR_RootConstrainSelectedInstOperands,
     /*  29608 */   // GIR_Coverage, 5327,
     /*  29608 */   GIR_EraseRootFromParent_Done,
     /*  29609 */ // Label 634: @29609
     /*  29609 */ GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(29667), // Rule ID 5328 //
     /*  29614 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29624 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29628 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV64_16:{ *:[v2f64] } MQPR:{ *:[v8i16] }:$src)
     /*  29628 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29631 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29635 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29640 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  29643 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29645 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29647 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29650 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29656 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29662 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29665 */   GIR_RootConstrainSelectedInstOperands,
     /*  29666 */   // GIR_Coverage, 5328,
     /*  29666 */   GIR_EraseRootFromParent_Done,
     /*  29667 */ // Label 635: @29667
     /*  29667 */ GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(29725), // Rule ID 5329 //
     /*  29672 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29682 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29686 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV64_8:{ *:[v2f64] } MQPR:{ *:[v16i8] }:$src)
     /*  29686 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29689 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29693 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29698 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_8),
     /*  29701 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29703 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29705 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29708 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29714 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29720 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29723 */   GIR_RootConstrainSelectedInstOperands,
     /*  29724 */   // GIR_Coverage, 5329,
     /*  29724 */   GIR_EraseRootFromParent_Done,
     /*  29725 */ // Label 636: @29725
     /*  29725 */ GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(29783), // Rule ID 5330 //
     /*  29730 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29740 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29744 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VREV64_32:{ *:[v2i64] } MQPR:{ *:[v4f32] }:$src)
     /*  29744 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29747 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29751 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29756 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  29759 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29761 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29763 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29766 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29772 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29778 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29781 */   GIR_RootConstrainSelectedInstOperands,
     /*  29782 */   // GIR_Coverage, 5330,
     /*  29782 */   GIR_EraseRootFromParent_Done,
     /*  29783 */ // Label 637: @29783
     /*  29783 */ GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(29841), // Rule ID 5331 //
     /*  29788 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29798 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29802 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV64_32:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$src)
     /*  29802 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29805 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29809 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29814 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  29817 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29819 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29821 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29824 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29830 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29836 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29839 */   GIR_RootConstrainSelectedInstOperands,
     /*  29840 */   // GIR_Coverage, 5331,
     /*  29840 */   GIR_EraseRootFromParent_Done,
     /*  29841 */ // Label 638: @29841
     /*  29841 */ GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(29899), // Rule ID 5332 //
     /*  29846 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29856 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29860 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VREV64_16:{ *:[v2i64] } MQPR:{ *:[v8f16] }:$src)
     /*  29860 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29863 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29867 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29872 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  29875 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29877 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29879 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29882 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29888 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29894 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29897 */   GIR_RootConstrainSelectedInstOperands,
     /*  29898 */   // GIR_Coverage, 5332,
     /*  29898 */   GIR_EraseRootFromParent_Done,
     /*  29899 */ // Label 639: @29899
     /*  29899 */ GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(29957), // Rule ID 5333 //
     /*  29904 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29918 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV64_16:{ *:[v2i64] } MQPR:{ *:[v8i16] }:$src)
     /*  29918 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29921 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29925 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29930 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  29933 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29935 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29937 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29940 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29946 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29952 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29955 */   GIR_RootConstrainSelectedInstOperands,
     /*  29956 */   // GIR_Coverage, 5333,
     /*  29956 */   GIR_EraseRootFromParent_Done,
     /*  29957 */ // Label 640: @29957
     /*  29957 */ GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(30015), // Rule ID 5334 //
     /*  29962 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29972 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29976 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV64_8:{ *:[v2i64] } MQPR:{ *:[v16i8] }:$src)
     /*  29976 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29979 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29983 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_8),
     /*  29991 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29993 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29995 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29998 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30004 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30010 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  30013 */   GIR_RootConstrainSelectedInstOperands,
     /*  30014 */   // GIR_Coverage, 5334,
     /*  30014 */   GIR_EraseRootFromParent_Done,
     /*  30015 */ // Label 641: @30015
     /*  30015 */ GIM_Reject,
     /*  30016 */ // Label 544: @30016
     /*  30016 */ GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(30048), // Rule ID 2724 //
     /*  30021 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30024 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30031 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30035 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30035 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30038 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30040 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30042 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30047 */   // GIR_Coverage, 2724,
     /*  30047 */   GIR_EraseRootFromParent_Done,
     /*  30048 */ // Label 642: @30048
     /*  30048 */ GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(30080), // Rule ID 2725 //
     /*  30053 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30059 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30063 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30067 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30067 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30070 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30072 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30074 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30079 */   // GIR_Coverage, 2725,
     /*  30079 */   GIR_EraseRootFromParent_Done,
     /*  30080 */ // Label 643: @30080
     /*  30080 */ GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(30112), // Rule ID 2752 //
     /*  30085 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30095 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30099 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30099 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30102 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30104 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30106 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30111 */   // GIR_Coverage, 2752,
     /*  30111 */   GIR_EraseRootFromParent_Done,
     /*  30112 */ // Label 644: @30112
     /*  30112 */ GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(30144), // Rule ID 2753 //
     /*  30117 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30120 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30127 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30131 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30131 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30134 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30136 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30138 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30143 */   // GIR_Coverage, 2753,
     /*  30143 */   GIR_EraseRootFromParent_Done,
     /*  30144 */ // Label 645: @30144
     /*  30144 */ GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(30176), // Rule ID 2754 //
     /*  30149 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30159 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30163 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30163 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30166 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30168 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30170 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30175 */   // GIR_Coverage, 2754,
     /*  30175 */   GIR_EraseRootFromParent_Done,
     /*  30176 */ // Label 646: @30176
     /*  30176 */ GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(30208), // Rule ID 2755 //
     /*  30181 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30184 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30191 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30195 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30195 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30198 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30200 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30202 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30207 */   // GIR_Coverage, 2755,
     /*  30207 */   GIR_EraseRootFromParent_Done,
     /*  30208 */ // Label 647: @30208
     /*  30208 */ GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(30240), // Rule ID 2756 //
     /*  30213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30223 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30227 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30227 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30230 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30232 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30234 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30239 */   // GIR_Coverage, 2756,
     /*  30239 */   GIR_EraseRootFromParent_Done,
     /*  30240 */ // Label 648: @30240
     /*  30240 */ GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(30272), // Rule ID 2757 //
     /*  30245 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30248 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30255 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30259 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30259 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30262 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30264 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30266 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30271 */   // GIR_Coverage, 2757,
     /*  30271 */   GIR_EraseRootFromParent_Done,
     /*  30272 */ // Label 649: @30272
     /*  30272 */ GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(30304), // Rule ID 2758 //
     /*  30277 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30287 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30291 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30291 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30294 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30296 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30298 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30303 */   // GIR_Coverage, 2758,
     /*  30303 */   GIR_EraseRootFromParent_Done,
     /*  30304 */ // Label 650: @30304
     /*  30304 */ GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(30336), // Rule ID 2759 //
     /*  30309 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30319 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30323 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30326 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30328 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30330 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30335 */   // GIR_Coverage, 2759,
     /*  30335 */   GIR_EraseRootFromParent_Done,
     /*  30336 */ // Label 651: @30336
     /*  30336 */ GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(30368), // Rule ID 2760 //
     /*  30341 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30351 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30355 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30355 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30358 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30360 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30362 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30367 */   // GIR_Coverage, 2760,
     /*  30367 */   GIR_EraseRootFromParent_Done,
     /*  30368 */ // Label 652: @30368
     /*  30368 */ GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(30400), // Rule ID 2761 //
     /*  30373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30387 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30387 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30390 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30392 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30394 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30399 */   // GIR_Coverage, 2761,
     /*  30399 */   GIR_EraseRootFromParent_Done,
     /*  30400 */ // Label 653: @30400
     /*  30400 */ GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(30437), // Rule ID 2824 //
     /*  30405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30415 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30419 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[f64] }:$src)  =>  (VREV64d16:{ *:[v4f16] } DPR:{ *:[f64] }:$src)
     /*  30419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  30422 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30424 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30426 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30429 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30435 */   GIR_RootConstrainSelectedInstOperands,
     /*  30436 */   // GIR_Coverage, 2824,
     /*  30436 */   GIR_EraseRootFromParent_Done,
     /*  30437 */ // Label 654: @30437
     /*  30437 */ GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(30474), // Rule ID 2825 //
     /*  30442 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30456 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v1i64] }:$src)  =>  (VREV64d16:{ *:[v4f16] } DPR:{ *:[v1i64] }:$src)
     /*  30456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  30459 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30461 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30463 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30466 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30472 */   GIR_RootConstrainSelectedInstOperands,
     /*  30473 */   // GIR_Coverage, 2825,
     /*  30473 */   GIR_EraseRootFromParent_Done,
     /*  30474 */ // Label 655: @30474
     /*  30474 */ GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(30511), // Rule ID 2826 //
     /*  30479 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30489 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30493 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v2f32] }:$src)  =>  (VREV32d16:{ *:[v4f16] } DPR:{ *:[v2f32] }:$src)
     /*  30493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  30496 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30498 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30500 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30503 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30509 */   GIR_RootConstrainSelectedInstOperands,
     /*  30510 */   // GIR_Coverage, 2826,
     /*  30510 */   GIR_EraseRootFromParent_Done,
     /*  30511 */ // Label 656: @30511
     /*  30511 */ GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(30548), // Rule ID 2827 //
     /*  30516 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30530 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v2i32] }:$src)  =>  (VREV32d16:{ *:[v4f16] } DPR:{ *:[v2i32] }:$src)
     /*  30530 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  30533 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30535 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30537 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30540 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30546 */   GIR_RootConstrainSelectedInstOperands,
     /*  30547 */   // GIR_Coverage, 2827,
     /*  30547 */   GIR_EraseRootFromParent_Done,
     /*  30548 */ // Label 657: @30548
     /*  30548 */ GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(30585), // Rule ID 2828 //
     /*  30553 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30556 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30563 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30567 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v8i8] }:$src)  =>  (VREV16d8:{ *:[v4f16] } DPR:{ *:[v8i8] }:$src)
     /*  30567 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16d8),
     /*  30570 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30572 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30574 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30577 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30583 */   GIR_RootConstrainSelectedInstOperands,
     /*  30584 */   // GIR_Coverage, 2828,
     /*  30584 */   GIR_EraseRootFromParent_Done,
     /*  30585 */ // Label 658: @30585
     /*  30585 */ GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(30622), // Rule ID 2829 //
     /*  30590 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30600 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30604 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[f64] }:$src)  =>  (VREV64d16:{ *:[v4i16] } DPR:{ *:[f64] }:$src)
     /*  30604 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  30607 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30609 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30611 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30614 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30620 */   GIR_RootConstrainSelectedInstOperands,
     /*  30621 */   // GIR_Coverage, 2829,
     /*  30621 */   GIR_EraseRootFromParent_Done,
     /*  30622 */ // Label 659: @30622
     /*  30622 */ GIM_Try, /*On fail goto*//*Label 660*/ GIMT_Encode4(30659), // Rule ID 2830 //
     /*  30627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30637 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30641 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v1i64] }:$src)  =>  (VREV64d16:{ *:[v4i16] } DPR:{ *:[v1i64] }:$src)
     /*  30641 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  30644 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30646 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30648 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30651 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30657 */   GIR_RootConstrainSelectedInstOperands,
     /*  30658 */   // GIR_Coverage, 2830,
     /*  30658 */   GIR_EraseRootFromParent_Done,
     /*  30659 */ // Label 660: @30659
     /*  30659 */ GIM_Try, /*On fail goto*//*Label 661*/ GIMT_Encode4(30696), // Rule ID 2831 //
     /*  30664 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30674 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30678 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v2f32] }:$src)  =>  (VREV32d16:{ *:[v4i16] } DPR:{ *:[v2f32] }:$src)
     /*  30678 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  30681 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30683 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30685 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30688 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30694 */   GIR_RootConstrainSelectedInstOperands,
     /*  30695 */   // GIR_Coverage, 2831,
     /*  30695 */   GIR_EraseRootFromParent_Done,
     /*  30696 */ // Label 661: @30696
     /*  30696 */ GIM_Try, /*On fail goto*//*Label 662*/ GIMT_Encode4(30733), // Rule ID 2832 //
     /*  30701 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30711 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30715 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v2i32] }:$src)  =>  (VREV32d16:{ *:[v4i16] } DPR:{ *:[v2i32] }:$src)
     /*  30715 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  30718 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30720 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30722 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30725 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30731 */   GIR_RootConstrainSelectedInstOperands,
     /*  30732 */   // GIR_Coverage, 2832,
     /*  30732 */   GIR_EraseRootFromParent_Done,
     /*  30733 */ // Label 662: @30733
     /*  30733 */ GIM_Try, /*On fail goto*//*Label 663*/ GIMT_Encode4(30770), // Rule ID 2833 //
     /*  30738 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30748 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30752 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v8i8] }:$src)  =>  (VREV16d8:{ *:[v4i16] } DPR:{ *:[v8i8] }:$src)
     /*  30752 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16d8),
     /*  30755 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30757 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30759 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30762 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30768 */   GIR_RootConstrainSelectedInstOperands,
     /*  30769 */   // GIR_Coverage, 2833,
     /*  30769 */   GIR_EraseRootFromParent_Done,
     /*  30770 */ // Label 663: @30770
     /*  30770 */ GIM_Reject,
     /*  30771 */ // Label 545: @30771
     /*  30771 */ GIM_Try, /*On fail goto*//*Label 664*/ GIMT_Encode4(30803), // Rule ID 2728 //
     /*  30776 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30786 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30790 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  30790 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30793 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30795 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30797 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30802 */   // GIR_Coverage, 2728,
     /*  30802 */   GIR_EraseRootFromParent_Done,
     /*  30803 */ // Label 664: @30803
     /*  30803 */ GIM_Try, /*On fail goto*//*Label 665*/ GIMT_Encode4(30835), // Rule ID 2729 //
     /*  30808 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30818 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30822 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30822 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30825 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30827 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30829 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30834 */   // GIR_Coverage, 2729,
     /*  30834 */   GIR_EraseRootFromParent_Done,
     /*  30835 */ // Label 665: @30835
     /*  30835 */ GIM_Try, /*On fail goto*//*Label 666*/ GIMT_Encode4(30867), // Rule ID 2778 //
     /*  30840 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  30846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30850 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30854 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30854 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30857 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30859 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30861 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30866 */   // GIR_Coverage, 2778,
     /*  30866 */   GIR_EraseRootFromParent_Done,
     /*  30867 */ // Label 666: @30867
     /*  30867 */ GIM_Try, /*On fail goto*//*Label 667*/ GIMT_Encode4(30899), // Rule ID 2779 //
     /*  30872 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  30878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30882 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30886 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30886 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30889 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30891 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30893 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30898 */   // GIR_Coverage, 2779,
     /*  30898 */   GIR_EraseRootFromParent_Done,
     /*  30899 */ // Label 667: @30899
     /*  30899 */ GIM_Try, /*On fail goto*//*Label 668*/ GIMT_Encode4(30931), // Rule ID 2780 //
     /*  30904 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30918 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30918 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30921 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30923 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30925 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30930 */   // GIR_Coverage, 2780,
     /*  30930 */   GIR_EraseRootFromParent_Done,
     /*  30931 */ // Label 668: @30931
     /*  30931 */ GIM_Try, /*On fail goto*//*Label 669*/ GIMT_Encode4(30963), // Rule ID 2781 //
     /*  30936 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30946 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30950 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30950 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30953 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30955 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30957 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30962 */   // GIR_Coverage, 2781,
     /*  30962 */   GIR_EraseRootFromParent_Done,
     /*  30963 */ // Label 669: @30963
     /*  30963 */ GIM_Try, /*On fail goto*//*Label 670*/ GIMT_Encode4(30995), // Rule ID 2782 //
     /*  30968 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  30974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30982 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30985 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30987 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30989 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30994 */   // GIR_Coverage, 2782,
     /*  30994 */   GIR_EraseRootFromParent_Done,
     /*  30995 */ // Label 670: @30995
     /*  30995 */ GIM_Try, /*On fail goto*//*Label 671*/ GIMT_Encode4(31027), // Rule ID 2783 //
     /*  31000 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  31003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31010 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31014 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  31014 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31017 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31019 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31021 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  31026 */   // GIR_Coverage, 2783,
     /*  31026 */   GIR_EraseRootFromParent_Done,
     /*  31027 */ // Label 671: @31027
     /*  31027 */ GIM_Try, /*On fail goto*//*Label 672*/ GIMT_Encode4(31059), // Rule ID 2784 //
     /*  31032 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  31035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31042 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31046 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  31046 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31049 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31051 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31053 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  31058 */   // GIR_Coverage, 2784,
     /*  31058 */   GIR_EraseRootFromParent_Done,
     /*  31059 */ // Label 672: @31059
     /*  31059 */ GIM_Try, /*On fail goto*//*Label 673*/ GIMT_Encode4(31091), // Rule ID 2785 //
     /*  31064 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  31067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31074 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31078 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  31078 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31081 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31083 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31085 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  31090 */   // GIR_Coverage, 2785,
     /*  31090 */   GIR_EraseRootFromParent_Done,
     /*  31091 */ // Label 673: @31091
     /*  31091 */ GIM_Try, /*On fail goto*//*Label 674*/ GIMT_Encode4(31123), // Rule ID 2786 //
     /*  31096 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  31099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31106 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31110 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  31110 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31113 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31115 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31117 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  31122 */   // GIR_Coverage, 2786,
     /*  31122 */   GIR_EraseRootFromParent_Done,
     /*  31123 */ // Label 674: @31123
     /*  31123 */ GIM_Try, /*On fail goto*//*Label 675*/ GIMT_Encode4(31155), // Rule ID 2787 //
     /*  31128 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  31131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31138 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31142 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  31142 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31145 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31147 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31149 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  31154 */   // GIR_Coverage, 2787,
     /*  31154 */   GIR_EraseRootFromParent_Done,
     /*  31155 */ // Label 675: @31155
     /*  31155 */ GIM_Try, /*On fail goto*//*Label 676*/ GIMT_Encode4(31192), // Rule ID 2850 //
     /*  31160 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31170 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31174 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v2f64] }:$src)  =>  (VREV64q32:{ *:[v4f32] } QPR:{ *:[v2f64] }:$src)
     /*  31174 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  31177 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31179 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31181 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31184 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31190 */   GIR_RootConstrainSelectedInstOperands,
     /*  31191 */   // GIR_Coverage, 2850,
     /*  31191 */   GIR_EraseRootFromParent_Done,
     /*  31192 */ // Label 676: @31192
     /*  31192 */ GIM_Try, /*On fail goto*//*Label 677*/ GIMT_Encode4(31229), // Rule ID 2851 //
     /*  31197 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31207 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31211 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v2i64] }:$src)  =>  (VREV64q32:{ *:[v4f32] } QPR:{ *:[v2i64] }:$src)
     /*  31211 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  31214 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31216 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31218 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31221 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31227 */   GIR_RootConstrainSelectedInstOperands,
     /*  31228 */   // GIR_Coverage, 2851,
     /*  31228 */   GIR_EraseRootFromParent_Done,
     /*  31229 */ // Label 677: @31229
     /*  31229 */ GIM_Try, /*On fail goto*//*Label 678*/ GIMT_Encode4(31266), // Rule ID 2852 //
     /*  31234 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31244 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31248 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v8f16] }:$src)  =>  (VREV32q16:{ *:[v4f32] } QPR:{ *:[v8f16] }:$src)
     /*  31248 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  31251 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31253 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31255 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31258 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31264 */   GIR_RootConstrainSelectedInstOperands,
     /*  31265 */   // GIR_Coverage, 2852,
     /*  31265 */   GIR_EraseRootFromParent_Done,
     /*  31266 */ // Label 678: @31266
     /*  31266 */ GIM_Try, /*On fail goto*//*Label 679*/ GIMT_Encode4(31303), // Rule ID 2853 //
     /*  31271 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31281 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31285 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v8i16] }:$src)  =>  (VREV32q16:{ *:[v4f32] } QPR:{ *:[v8i16] }:$src)
     /*  31285 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  31288 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31290 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31292 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31295 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31301 */   GIR_RootConstrainSelectedInstOperands,
     /*  31302 */   // GIR_Coverage, 2853,
     /*  31302 */   GIR_EraseRootFromParent_Done,
     /*  31303 */ // Label 679: @31303
     /*  31303 */ GIM_Try, /*On fail goto*//*Label 680*/ GIMT_Encode4(31340), // Rule ID 2854 //
     /*  31308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31318 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31322 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v16i8] }:$src)  =>  (VREV32q8:{ *:[v4f32] } QPR:{ *:[v16i8] }:$src)
     /*  31322 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q8),
     /*  31325 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31327 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31329 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31332 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31338 */   GIR_RootConstrainSelectedInstOperands,
     /*  31339 */   // GIR_Coverage, 2854,
     /*  31339 */   GIR_EraseRootFromParent_Done,
     /*  31340 */ // Label 680: @31340
     /*  31340 */ GIM_Try, /*On fail goto*//*Label 681*/ GIMT_Encode4(31377), // Rule ID 2855 //
     /*  31345 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31355 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31359 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v2f64] }:$src)  =>  (VREV64q32:{ *:[v4i32] } QPR:{ *:[v2f64] }:$src)
     /*  31359 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  31362 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31364 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31366 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31369 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31375 */   GIR_RootConstrainSelectedInstOperands,
     /*  31376 */   // GIR_Coverage, 2855,
     /*  31376 */   GIR_EraseRootFromParent_Done,
     /*  31377 */ // Label 681: @31377
     /*  31377 */ GIM_Try, /*On fail goto*//*Label 682*/ GIMT_Encode4(31414), // Rule ID 2856 //
     /*  31382 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31392 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31396 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v2i64] }:$src)  =>  (VREV64q32:{ *:[v4i32] } QPR:{ *:[v2i64] }:$src)
     /*  31396 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  31399 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31401 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31403 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31406 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31412 */   GIR_RootConstrainSelectedInstOperands,
     /*  31413 */   // GIR_Coverage, 2856,
     /*  31413 */   GIR_EraseRootFromParent_Done,
     /*  31414 */ // Label 682: @31414
     /*  31414 */ GIM_Try, /*On fail goto*//*Label 683*/ GIMT_Encode4(31451), // Rule ID 2857 //
     /*  31419 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31425 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31429 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31433 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v8f16] }:$src)  =>  (VREV32q16:{ *:[v4i32] } QPR:{ *:[v8f16] }:$src)
     /*  31433 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  31436 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31438 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31440 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31443 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31449 */   GIR_RootConstrainSelectedInstOperands,
     /*  31450 */   // GIR_Coverage, 2857,
     /*  31450 */   GIR_EraseRootFromParent_Done,
     /*  31451 */ // Label 683: @31451
     /*  31451 */ GIM_Try, /*On fail goto*//*Label 684*/ GIMT_Encode4(31488), // Rule ID 2858 //
     /*  31456 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31466 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31470 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v8i16] }:$src)  =>  (VREV32q16:{ *:[v4i32] } QPR:{ *:[v8i16] }:$src)
     /*  31470 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  31473 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31475 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31477 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31480 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31486 */   GIR_RootConstrainSelectedInstOperands,
     /*  31487 */   // GIR_Coverage, 2858,
     /*  31487 */   GIR_EraseRootFromParent_Done,
     /*  31488 */ // Label 684: @31488
     /*  31488 */ GIM_Try, /*On fail goto*//*Label 685*/ GIMT_Encode4(31525), // Rule ID 2859 //
     /*  31493 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31503 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31507 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v16i8] }:$src)  =>  (VREV32q8:{ *:[v4i32] } QPR:{ *:[v16i8] }:$src)
     /*  31507 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q8),
     /*  31510 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31512 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31514 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31517 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31523 */   GIR_RootConstrainSelectedInstOperands,
     /*  31524 */   // GIR_Coverage, 2859,
     /*  31524 */   GIR_EraseRootFromParent_Done,
     /*  31525 */ // Label 685: @31525
     /*  31525 */ GIM_Try, /*On fail goto*//*Label 686*/ GIMT_Encode4(31557), // Rule ID 5285 //
     /*  31530 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  31533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31540 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31544 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31544 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31547 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31549 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31551 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31556 */   // GIR_Coverage, 5285,
     /*  31556 */   GIR_EraseRootFromParent_Done,
     /*  31557 */ // Label 686: @31557
     /*  31557 */ GIM_Try, /*On fail goto*//*Label 687*/ GIMT_Encode4(31589), // Rule ID 5286 //
     /*  31562 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  31565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31572 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31576 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31576 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31579 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31581 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31583 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31588 */   // GIR_Coverage, 5286,
     /*  31588 */   GIR_EraseRootFromParent_Done,
     /*  31589 */ // Label 687: @31589
     /*  31589 */ GIM_Try, /*On fail goto*//*Label 688*/ GIMT_Encode4(31621), // Rule ID 5299 //
     /*  31594 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31597 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31604 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31608 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31611 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31613 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31615 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31620 */   // GIR_Coverage, 5299,
     /*  31620 */   GIR_EraseRootFromParent_Done,
     /*  31621 */ // Label 688: @31621
     /*  31621 */ GIM_Try, /*On fail goto*//*Label 689*/ GIMT_Encode4(31653), // Rule ID 5300 //
     /*  31626 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31636 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31640 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31640 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31643 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31645 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31647 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31652 */   // GIR_Coverage, 5300,
     /*  31652 */   GIR_EraseRootFromParent_Done,
     /*  31653 */ // Label 689: @31653
     /*  31653 */ GIM_Try, /*On fail goto*//*Label 690*/ GIMT_Encode4(31685), // Rule ID 5301 //
     /*  31658 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31661 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31668 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31672 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31672 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31675 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31677 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31679 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31684 */   // GIR_Coverage, 5301,
     /*  31684 */   GIR_EraseRootFromParent_Done,
     /*  31685 */ // Label 690: @31685
     /*  31685 */ GIM_Try, /*On fail goto*//*Label 691*/ GIMT_Encode4(31717), // Rule ID 5302 //
     /*  31690 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31700 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31704 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31704 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31707 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31709 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31711 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31716 */   // GIR_Coverage, 5302,
     /*  31716 */   GIR_EraseRootFromParent_Done,
     /*  31717 */ // Label 691: @31717
     /*  31717 */ GIM_Try, /*On fail goto*//*Label 692*/ GIMT_Encode4(31749), // Rule ID 5303 //
     /*  31722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31736 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31736 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31739 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31741 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31743 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31748 */   // GIR_Coverage, 5303,
     /*  31748 */   GIR_EraseRootFromParent_Done,
     /*  31749 */ // Label 692: @31749
     /*  31749 */ GIM_Try, /*On fail goto*//*Label 693*/ GIMT_Encode4(31781), // Rule ID 5304 //
     /*  31754 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31764 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31768 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31768 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31771 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31773 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31775 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31780 */   // GIR_Coverage, 5304,
     /*  31780 */   GIR_EraseRootFromParent_Done,
     /*  31781 */ // Label 693: @31781
     /*  31781 */ GIM_Try, /*On fail goto*//*Label 694*/ GIMT_Encode4(31813), // Rule ID 5305 //
     /*  31786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31796 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31800 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31800 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31803 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31805 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31807 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31812 */   // GIR_Coverage, 5305,
     /*  31812 */   GIR_EraseRootFromParent_Done,
     /*  31813 */ // Label 694: @31813
     /*  31813 */ GIM_Try, /*On fail goto*//*Label 695*/ GIMT_Encode4(31845), // Rule ID 5306 //
     /*  31818 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31828 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31832 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31832 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31835 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31837 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31839 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31844 */   // GIR_Coverage, 5306,
     /*  31844 */   GIR_EraseRootFromParent_Done,
     /*  31845 */ // Label 695: @31845
     /*  31845 */ GIM_Try, /*On fail goto*//*Label 696*/ GIMT_Encode4(31877), // Rule ID 5307 //
     /*  31850 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31860 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31864 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31864 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31867 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31869 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31871 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31876 */   // GIR_Coverage, 5307,
     /*  31876 */   GIR_EraseRootFromParent_Done,
     /*  31877 */ // Label 696: @31877
     /*  31877 */ GIM_Try, /*On fail goto*//*Label 697*/ GIMT_Encode4(31909), // Rule ID 5308 //
     /*  31882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31892 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31896 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31896 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31899 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31901 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31903 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31908 */   // GIR_Coverage, 5308,
     /*  31908 */   GIR_EraseRootFromParent_Done,
     /*  31909 */ // Label 697: @31909
     /*  31909 */ GIM_Try, /*On fail goto*//*Label 698*/ GIMT_Encode4(31967), // Rule ID 5335 //
     /*  31914 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  31917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31924 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31928 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v2f64] }:$src)  =>  (MVE_VREV64_32:{ *:[v4f32] } MQPR:{ *:[v2f64] }:$src)
     /*  31928 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  31931 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  31935 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  31940 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  31943 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  31945 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31947 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31950 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31956 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31962 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  31965 */   GIR_RootConstrainSelectedInstOperands,
     /*  31966 */   // GIR_Coverage, 5335,
     /*  31966 */   GIR_EraseRootFromParent_Done,
     /*  31967 */ // Label 698: @31967
     /*  31967 */ GIM_Try, /*On fail goto*//*Label 699*/ GIMT_Encode4(32025), // Rule ID 5336 //
     /*  31972 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  31975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31982 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31986 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v2i64] }:$src)  =>  (MVE_VREV64_32:{ *:[v4f32] } MQPR:{ *:[v2i64] }:$src)
     /*  31986 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  31989 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  31993 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  31998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  32001 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32003 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32005 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32008 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32014 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32020 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32023 */   GIR_RootConstrainSelectedInstOperands,
     /*  32024 */   // GIR_Coverage, 5336,
     /*  32024 */   GIR_EraseRootFromParent_Done,
     /*  32025 */ // Label 699: @32025
     /*  32025 */ GIM_Try, /*On fail goto*//*Label 700*/ GIMT_Encode4(32083), // Rule ID 5337 //
     /*  32030 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32040 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32044 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VREV32_16:{ *:[v4f32] } MQPR:{ *:[v8f16] }:$src)
     /*  32044 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32047 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32051 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32056 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  32059 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32061 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32063 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32066 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32072 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32078 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32081 */   GIR_RootConstrainSelectedInstOperands,
     /*  32082 */   // GIR_Coverage, 5337,
     /*  32082 */   GIR_EraseRootFromParent_Done,
     /*  32083 */ // Label 700: @32083
     /*  32083 */ GIM_Try, /*On fail goto*//*Label 701*/ GIMT_Encode4(32141), // Rule ID 5338 //
     /*  32088 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32098 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32102 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV32_16:{ *:[v4f32] } MQPR:{ *:[v8i16] }:$src)
     /*  32102 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32105 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32109 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32114 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  32117 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32119 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32121 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32124 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32130 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32136 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32139 */   GIR_RootConstrainSelectedInstOperands,
     /*  32140 */   // GIR_Coverage, 5338,
     /*  32140 */   GIR_EraseRootFromParent_Done,
     /*  32141 */ // Label 701: @32141
     /*  32141 */ GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(32199), // Rule ID 5339 //
     /*  32146 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  32152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32156 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32160 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV32_8:{ *:[v4f32] } MQPR:{ *:[v16i8] }:$src)
     /*  32160 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32163 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32167 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32172 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_8),
     /*  32175 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32177 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32179 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32182 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32188 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32194 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32197 */   GIR_RootConstrainSelectedInstOperands,
     /*  32198 */   // GIR_Coverage, 5339,
     /*  32198 */   GIR_EraseRootFromParent_Done,
     /*  32199 */ // Label 702: @32199
     /*  32199 */ GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(32257), // Rule ID 5340 //
     /*  32204 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  32210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32214 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32218 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v2f64] }:$src)  =>  (MVE_VREV64_32:{ *:[v4i32] } MQPR:{ *:[v2f64] }:$src)
     /*  32218 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32221 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32225 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32230 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  32233 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32235 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32237 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32240 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32246 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32252 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32255 */   GIR_RootConstrainSelectedInstOperands,
     /*  32256 */   // GIR_Coverage, 5340,
     /*  32256 */   GIR_EraseRootFromParent_Done,
     /*  32257 */ // Label 703: @32257
     /*  32257 */ GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(32315), // Rule ID 5341 //
     /*  32262 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  32268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32276 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v2i64] }:$src)  =>  (MVE_VREV64_32:{ *:[v4i32] } MQPR:{ *:[v2i64] }:$src)
     /*  32276 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32279 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32283 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32288 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  32291 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32293 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32295 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32298 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32304 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32310 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32313 */   GIR_RootConstrainSelectedInstOperands,
     /*  32314 */   // GIR_Coverage, 5341,
     /*  32314 */   GIR_EraseRootFromParent_Done,
     /*  32315 */ // Label 704: @32315
     /*  32315 */ GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(32373), // Rule ID 5342 //
     /*  32320 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32330 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32334 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VREV32_16:{ *:[v4i32] } MQPR:{ *:[v8f16] }:$src)
     /*  32334 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32337 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32341 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32346 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  32349 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32351 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32353 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32356 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32362 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32368 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32371 */   GIR_RootConstrainSelectedInstOperands,
     /*  32372 */   // GIR_Coverage, 5342,
     /*  32372 */   GIR_EraseRootFromParent_Done,
     /*  32373 */ // Label 705: @32373
     /*  32373 */ GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(32431), // Rule ID 5343 //
     /*  32378 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32388 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32392 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV32_16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)
     /*  32392 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32395 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32399 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32404 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  32407 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32409 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32411 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32414 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32420 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32426 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32429 */   GIR_RootConstrainSelectedInstOperands,
     /*  32430 */   // GIR_Coverage, 5343,
     /*  32430 */   GIR_EraseRootFromParent_Done,
     /*  32431 */ // Label 706: @32431
     /*  32431 */ GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(32489), // Rule ID 5344 //
     /*  32436 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  32442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32446 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32450 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV32_8:{ *:[v4i32] } MQPR:{ *:[v16i8] }:$src)
     /*  32450 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32453 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32457 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32462 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_8),
     /*  32465 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32467 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32469 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32472 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32478 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32484 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32487 */   GIR_RootConstrainSelectedInstOperands,
     /*  32488 */   // GIR_Coverage, 5344,
     /*  32488 */   GIR_EraseRootFromParent_Done,
     /*  32489 */ // Label 707: @32489
     /*  32489 */ GIM_Reject,
     /*  32490 */ // Label 546: @32490
     /*  32490 */ GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(32522), // Rule ID 2762 //
     /*  32495 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  32501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32505 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32509 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32509 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32512 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32514 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32516 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32521 */   // GIR_Coverage, 2762,
     /*  32521 */   GIR_EraseRootFromParent_Done,
     /*  32522 */ // Label 708: @32522
     /*  32522 */ GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(32554), // Rule ID 2763 //
     /*  32527 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  32533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32537 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32541 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32541 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32544 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32546 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32548 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32553 */   // GIR_Coverage, 2763,
     /*  32553 */   GIR_EraseRootFromParent_Done,
     /*  32554 */ // Label 709: @32554
     /*  32554 */ GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(32586), // Rule ID 2764 //
     /*  32559 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  32565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32569 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32573 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32573 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32576 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32578 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32580 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32585 */   // GIR_Coverage, 2764,
     /*  32585 */   GIR_EraseRootFromParent_Done,
     /*  32586 */ // Label 710: @32586
     /*  32586 */ GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(32618), // Rule ID 2765 //
     /*  32591 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  32597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32601 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32605 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32605 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32608 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32610 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32612 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32617 */   // GIR_Coverage, 2765,
     /*  32617 */   GIR_EraseRootFromParent_Done,
     /*  32618 */ // Label 711: @32618
     /*  32618 */ GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(32650), // Rule ID 2766 //
     /*  32623 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  32629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32633 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32637 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32637 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32640 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32642 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32644 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32649 */   // GIR_Coverage, 2766,
     /*  32649 */   GIR_EraseRootFromParent_Done,
     /*  32650 */ // Label 712: @32650
     /*  32650 */ GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(32682), // Rule ID 2767 //
     /*  32655 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32658 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  32661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32665 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32669 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32669 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32672 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32674 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32676 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32681 */   // GIR_Coverage, 2767,
     /*  32681 */   GIR_EraseRootFromParent_Done,
     /*  32682 */ // Label 713: @32682
     /*  32682 */ GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(32719), // Rule ID 2834 //
     /*  32687 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  32693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32697 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32701 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[f64] }:$src)  =>  (VREV64d8:{ *:[v8i8] } DPR:{ *:[f64] }:$src)
     /*  32701 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d8),
     /*  32704 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32706 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32708 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32711 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32717 */   GIR_RootConstrainSelectedInstOperands,
     /*  32718 */   // GIR_Coverage, 2834,
     /*  32718 */   GIR_EraseRootFromParent_Done,
     /*  32719 */ // Label 714: @32719
     /*  32719 */ GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(32756), // Rule ID 2835 //
     /*  32724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  32730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32734 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32738 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v1i64] }:$src)  =>  (VREV64d8:{ *:[v8i8] } DPR:{ *:[v1i64] }:$src)
     /*  32738 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d8),
     /*  32741 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32743 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32745 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32748 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32754 */   GIR_RootConstrainSelectedInstOperands,
     /*  32755 */   // GIR_Coverage, 2835,
     /*  32755 */   GIR_EraseRootFromParent_Done,
     /*  32756 */ // Label 715: @32756
     /*  32756 */ GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(32793), // Rule ID 2836 //
     /*  32761 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32764 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  32767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32771 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32775 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v2f32] }:$src)  =>  (VREV32d8:{ *:[v8i8] } DPR:{ *:[v2f32] }:$src)
     /*  32775 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d8),
     /*  32778 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32780 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32782 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32785 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32791 */   GIR_RootConstrainSelectedInstOperands,
     /*  32792 */   // GIR_Coverage, 2836,
     /*  32792 */   GIR_EraseRootFromParent_Done,
     /*  32793 */ // Label 716: @32793
     /*  32793 */ GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(32830), // Rule ID 2837 //
     /*  32798 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  32804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32808 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32812 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v2i32] }:$src)  =>  (VREV32d8:{ *:[v8i8] } DPR:{ *:[v2i32] }:$src)
     /*  32812 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d8),
     /*  32815 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32817 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32819 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32822 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32828 */   GIR_RootConstrainSelectedInstOperands,
     /*  32829 */   // GIR_Coverage, 2837,
     /*  32829 */   GIR_EraseRootFromParent_Done,
     /*  32830 */ // Label 717: @32830
     /*  32830 */ GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(32867), // Rule ID 2838 //
     /*  32835 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  32841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32845 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32849 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v4f16] }:$src)  =>  (VREV16d8:{ *:[v8i8] } DPR:{ *:[v4f16] }:$src)
     /*  32849 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16d8),
     /*  32852 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32854 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32856 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32859 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32865 */   GIR_RootConstrainSelectedInstOperands,
     /*  32866 */   // GIR_Coverage, 2838,
     /*  32866 */   GIR_EraseRootFromParent_Done,
     /*  32867 */ // Label 718: @32867
     /*  32867 */ GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(32904), // Rule ID 2839 //
     /*  32872 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  32878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32882 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32886 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v4i16] }:$src)  =>  (VREV16d8:{ *:[v8i8] } DPR:{ *:[v4i16] }:$src)
     /*  32886 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16d8),
     /*  32889 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32891 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32893 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32896 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32902 */   GIR_RootConstrainSelectedInstOperands,
     /*  32903 */   // GIR_Coverage, 2839,
     /*  32903 */   GIR_EraseRootFromParent_Done,
     /*  32904 */ // Label 719: @32904
     /*  32904 */ GIM_Reject,
     /*  32905 */ // Label 547: @32905
     /*  32905 */ GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(32937), // Rule ID 2730 //
     /*  32910 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32920 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32924 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  32924 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32927 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32929 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32931 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  32936 */   // GIR_Coverage, 2730,
     /*  32936 */   GIR_EraseRootFromParent_Done,
     /*  32937 */ // Label 720: @32937
     /*  32937 */ GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(32969), // Rule ID 2731 //
     /*  32942 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32952 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32956 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  32956 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32959 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32961 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32963 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  32968 */   // GIR_Coverage, 2731,
     /*  32968 */   GIR_EraseRootFromParent_Done,
     /*  32969 */ // Label 721: @32969
     /*  32969 */ GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(33001), // Rule ID 2788 //
     /*  32974 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  32980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32984 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32988 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  32988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32991 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32993 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32995 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33000 */   // GIR_Coverage, 2788,
     /*  33000 */   GIR_EraseRootFromParent_Done,
     /*  33001 */ // Label 722: @33001
     /*  33001 */ GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(33033), // Rule ID 2789 //
     /*  33006 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33016 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33020 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  33020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33023 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33025 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33027 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33032 */   // GIR_Coverage, 2789,
     /*  33032 */   GIR_EraseRootFromParent_Done,
     /*  33033 */ // Label 723: @33033
     /*  33033 */ GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(33065), // Rule ID 2790 //
     /*  33038 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33048 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33052 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  33052 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33055 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33057 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33059 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33064 */   // GIR_Coverage, 2790,
     /*  33064 */   GIR_EraseRootFromParent_Done,
     /*  33065 */ // Label 724: @33065
     /*  33065 */ GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(33097), // Rule ID 2791 //
     /*  33070 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33080 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33084 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  33084 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33087 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33089 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33091 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33096 */   // GIR_Coverage, 2791,
     /*  33096 */   GIR_EraseRootFromParent_Done,
     /*  33097 */ // Label 725: @33097
     /*  33097 */ GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(33129), // Rule ID 2792 //
     /*  33102 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33112 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33116 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  33116 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33119 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33121 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33123 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33128 */   // GIR_Coverage, 2792,
     /*  33128 */   GIR_EraseRootFromParent_Done,
     /*  33129 */ // Label 726: @33129
     /*  33129 */ GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(33161), // Rule ID 2793 //
     /*  33134 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33144 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33148 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  33148 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33151 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33153 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33155 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33160 */   // GIR_Coverage, 2793,
     /*  33160 */   GIR_EraseRootFromParent_Done,
     /*  33161 */ // Label 727: @33161
     /*  33161 */ GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(33193), // Rule ID 2794 //
     /*  33166 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33176 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33180 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  33180 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33183 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33185 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33187 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33192 */   // GIR_Coverage, 2794,
     /*  33192 */   GIR_EraseRootFromParent_Done,
     /*  33193 */ // Label 728: @33193
     /*  33193 */ GIM_Try, /*On fail goto*//*Label 729*/ GIMT_Encode4(33225), // Rule ID 2795 //
     /*  33198 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33201 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33208 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33212 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  33212 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33215 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33217 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33219 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33224 */   // GIR_Coverage, 2795,
     /*  33224 */   GIR_EraseRootFromParent_Done,
     /*  33225 */ // Label 729: @33225
     /*  33225 */ GIM_Try, /*On fail goto*//*Label 730*/ GIMT_Encode4(33257), // Rule ID 2796 //
     /*  33230 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33240 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33244 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  33244 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33247 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33249 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33251 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33256 */   // GIR_Coverage, 2796,
     /*  33256 */   GIR_EraseRootFromParent_Done,
     /*  33257 */ // Label 730: @33257
     /*  33257 */ GIM_Try, /*On fail goto*//*Label 731*/ GIMT_Encode4(33289), // Rule ID 2797 //
     /*  33262 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33276 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  33276 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33279 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33281 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33283 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33288 */   // GIR_Coverage, 2797,
     /*  33288 */   GIR_EraseRootFromParent_Done,
     /*  33289 */ // Label 731: @33289
     /*  33289 */ GIM_Try, /*On fail goto*//*Label 732*/ GIMT_Encode4(33326), // Rule ID 2860 //
     /*  33294 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33304 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33308 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v2f64] }:$src)  =>  (VREV64q16:{ *:[v8f16] } QPR:{ *:[v2f64] }:$src)
     /*  33308 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  33311 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33313 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33315 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33318 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33324 */   GIR_RootConstrainSelectedInstOperands,
     /*  33325 */   // GIR_Coverage, 2860,
     /*  33325 */   GIR_EraseRootFromParent_Done,
     /*  33326 */ // Label 732: @33326
     /*  33326 */ GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(33363), // Rule ID 2861 //
     /*  33331 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33341 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33345 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v2i64] }:$src)  =>  (VREV64q16:{ *:[v8f16] } QPR:{ *:[v2i64] }:$src)
     /*  33345 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  33348 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33350 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33352 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33355 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33361 */   GIR_RootConstrainSelectedInstOperands,
     /*  33362 */   // GIR_Coverage, 2861,
     /*  33362 */   GIR_EraseRootFromParent_Done,
     /*  33363 */ // Label 733: @33363
     /*  33363 */ GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(33400), // Rule ID 2862 //
     /*  33368 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33378 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33382 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v4f32] }:$src)  =>  (VREV32q16:{ *:[v8f16] } QPR:{ *:[v4f32] }:$src)
     /*  33382 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  33385 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33387 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33389 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33392 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33398 */   GIR_RootConstrainSelectedInstOperands,
     /*  33399 */   // GIR_Coverage, 2862,
     /*  33399 */   GIR_EraseRootFromParent_Done,
     /*  33400 */ // Label 734: @33400
     /*  33400 */ GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(33437), // Rule ID 2863 //
     /*  33405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33415 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33419 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v4i32] }:$src)  =>  (VREV32q16:{ *:[v8f16] } QPR:{ *:[v4i32] }:$src)
     /*  33419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  33422 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33424 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33426 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33429 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33435 */   GIR_RootConstrainSelectedInstOperands,
     /*  33436 */   // GIR_Coverage, 2863,
     /*  33436 */   GIR_EraseRootFromParent_Done,
     /*  33437 */ // Label 735: @33437
     /*  33437 */ GIM_Try, /*On fail goto*//*Label 736*/ GIMT_Encode4(33474), // Rule ID 2864 //
     /*  33442 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33456 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v16i8] }:$src)  =>  (VREV16q8:{ *:[v8f16] } QPR:{ *:[v16i8] }:$src)
     /*  33456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16q8),
     /*  33459 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33461 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33463 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33466 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33472 */   GIR_RootConstrainSelectedInstOperands,
     /*  33473 */   // GIR_Coverage, 2864,
     /*  33473 */   GIR_EraseRootFromParent_Done,
     /*  33474 */ // Label 736: @33474
     /*  33474 */ GIM_Try, /*On fail goto*//*Label 737*/ GIMT_Encode4(33511), // Rule ID 2865 //
     /*  33479 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33489 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33493 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v2f64] }:$src)  =>  (VREV64q16:{ *:[v8i16] } QPR:{ *:[v2f64] }:$src)
     /*  33493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  33496 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33498 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33500 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33503 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33509 */   GIR_RootConstrainSelectedInstOperands,
     /*  33510 */   // GIR_Coverage, 2865,
     /*  33510 */   GIR_EraseRootFromParent_Done,
     /*  33511 */ // Label 737: @33511
     /*  33511 */ GIM_Try, /*On fail goto*//*Label 738*/ GIMT_Encode4(33548), // Rule ID 2866 //
     /*  33516 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33530 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v2i64] }:$src)  =>  (VREV64q16:{ *:[v8i16] } QPR:{ *:[v2i64] }:$src)
     /*  33530 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  33533 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33535 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33537 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33540 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33546 */   GIR_RootConstrainSelectedInstOperands,
     /*  33547 */   // GIR_Coverage, 2866,
     /*  33547 */   GIR_EraseRootFromParent_Done,
     /*  33548 */ // Label 738: @33548
     /*  33548 */ GIM_Try, /*On fail goto*//*Label 739*/ GIMT_Encode4(33585), // Rule ID 2867 //
     /*  33553 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33556 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33563 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33567 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v4f32] }:$src)  =>  (VREV32q16:{ *:[v8i16] } QPR:{ *:[v4f32] }:$src)
     /*  33567 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  33570 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33572 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33574 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33577 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33583 */   GIR_RootConstrainSelectedInstOperands,
     /*  33584 */   // GIR_Coverage, 2867,
     /*  33584 */   GIR_EraseRootFromParent_Done,
     /*  33585 */ // Label 739: @33585
     /*  33585 */ GIM_Try, /*On fail goto*//*Label 740*/ GIMT_Encode4(33622), // Rule ID 2868 //
     /*  33590 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33600 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33604 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v4i32] }:$src)  =>  (VREV32q16:{ *:[v8i16] } QPR:{ *:[v4i32] }:$src)
     /*  33604 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  33607 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33609 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33611 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33614 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33620 */   GIR_RootConstrainSelectedInstOperands,
     /*  33621 */   // GIR_Coverage, 2868,
     /*  33621 */   GIR_EraseRootFromParent_Done,
     /*  33622 */ // Label 740: @33622
     /*  33622 */ GIM_Try, /*On fail goto*//*Label 741*/ GIMT_Encode4(33659), // Rule ID 2869 //
     /*  33627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33637 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33641 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v16i8] }:$src)  =>  (VREV16q8:{ *:[v8i16] } QPR:{ *:[v16i8] }:$src)
     /*  33641 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16q8),
     /*  33644 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33646 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33648 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33651 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33657 */   GIR_RootConstrainSelectedInstOperands,
     /*  33658 */   // GIR_Coverage, 2869,
     /*  33658 */   GIR_EraseRootFromParent_Done,
     /*  33659 */ // Label 741: @33659
     /*  33659 */ GIM_Try, /*On fail goto*//*Label 742*/ GIMT_Encode4(33691), // Rule ID 5287 //
     /*  33664 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  33667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33674 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33678 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  33678 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33681 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33683 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33685 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33690 */   // GIR_Coverage, 5287,
     /*  33690 */   GIR_EraseRootFromParent_Done,
     /*  33691 */ // Label 742: @33691
     /*  33691 */ GIM_Try, /*On fail goto*//*Label 743*/ GIMT_Encode4(33723), // Rule ID 5288 //
     /*  33696 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  33699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33706 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33710 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33710 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33713 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33715 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33717 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33722 */   // GIR_Coverage, 5288,
     /*  33722 */   GIR_EraseRootFromParent_Done,
     /*  33723 */ // Label 743: @33723
     /*  33723 */ GIM_Try, /*On fail goto*//*Label 744*/ GIMT_Encode4(33755), // Rule ID 5309 //
     /*  33728 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33738 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33742 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33742 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33745 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33747 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33749 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33754 */   // GIR_Coverage, 5309,
     /*  33754 */   GIR_EraseRootFromParent_Done,
     /*  33755 */ // Label 744: @33755
     /*  33755 */ GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(33787), // Rule ID 5310 //
     /*  33760 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33770 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33774 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33777 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33779 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33781 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33786 */   // GIR_Coverage, 5310,
     /*  33786 */   GIR_EraseRootFromParent_Done,
     /*  33787 */ // Label 745: @33787
     /*  33787 */ GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(33819), // Rule ID 5311 //
     /*  33792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33802 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33806 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33806 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33809 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33811 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33813 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33818 */   // GIR_Coverage, 5311,
     /*  33818 */   GIR_EraseRootFromParent_Done,
     /*  33819 */ // Label 746: @33819
     /*  33819 */ GIM_Try, /*On fail goto*//*Label 747*/ GIMT_Encode4(33851), // Rule ID 5312 //
     /*  33824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33834 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33838 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33841 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33843 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33845 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33850 */   // GIR_Coverage, 5312,
     /*  33850 */   GIR_EraseRootFromParent_Done,
     /*  33851 */ // Label 747: @33851
     /*  33851 */ GIM_Try, /*On fail goto*//*Label 748*/ GIMT_Encode4(33883), // Rule ID 5313 //
     /*  33856 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33866 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33870 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33873 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33875 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33877 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33882 */   // GIR_Coverage, 5313,
     /*  33882 */   GIR_EraseRootFromParent_Done,
     /*  33883 */ // Label 748: @33883
     /*  33883 */ GIM_Try, /*On fail goto*//*Label 749*/ GIMT_Encode4(33915), // Rule ID 5314 //
     /*  33888 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33902 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  33902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33905 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33907 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33909 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33914 */   // GIR_Coverage, 5314,
     /*  33914 */   GIR_EraseRootFromParent_Done,
     /*  33915 */ // Label 749: @33915
     /*  33915 */ GIM_Try, /*On fail goto*//*Label 750*/ GIMT_Encode4(33947), // Rule ID 5315 //
     /*  33920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33930 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33934 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  33934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33937 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33939 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33941 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33946 */   // GIR_Coverage, 5315,
     /*  33946 */   GIR_EraseRootFromParent_Done,
     /*  33947 */ // Label 750: @33947
     /*  33947 */ GIM_Try, /*On fail goto*//*Label 751*/ GIMT_Encode4(33979), // Rule ID 5316 //
     /*  33952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33962 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33966 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  33966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33969 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33971 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33973 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33978 */   // GIR_Coverage, 5316,
     /*  33978 */   GIR_EraseRootFromParent_Done,
     /*  33979 */ // Label 751: @33979
     /*  33979 */ GIM_Try, /*On fail goto*//*Label 752*/ GIMT_Encode4(34011), // Rule ID 5317 //
     /*  33984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33998 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  33998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34001 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34003 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34005 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34010 */   // GIR_Coverage, 5317,
     /*  34010 */   GIR_EraseRootFromParent_Done,
     /*  34011 */ // Label 752: @34011
     /*  34011 */ GIM_Try, /*On fail goto*//*Label 753*/ GIMT_Encode4(34043), // Rule ID 5318 //
     /*  34016 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  34019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34026 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34030 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  34030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34033 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34035 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34037 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34042 */   // GIR_Coverage, 5318,
     /*  34042 */   GIR_EraseRootFromParent_Done,
     /*  34043 */ // Label 753: @34043
     /*  34043 */ GIM_Try, /*On fail goto*//*Label 754*/ GIMT_Encode4(34101), // Rule ID 5345 //
     /*  34048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34058 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34062 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v2f64] }:$src)  =>  (MVE_VREV64_16:{ *:[v8f16] } MQPR:{ *:[v2f64] }:$src)
     /*  34062 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34065 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34069 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34074 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  34077 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34079 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34081 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34084 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34090 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34096 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34099 */   GIR_RootConstrainSelectedInstOperands,
     /*  34100 */   // GIR_Coverage, 5345,
     /*  34100 */   GIR_EraseRootFromParent_Done,
     /*  34101 */ // Label 754: @34101
     /*  34101 */ GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(34159), // Rule ID 5346 //
     /*  34106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34116 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34120 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v2i64] }:$src)  =>  (MVE_VREV64_16:{ *:[v8f16] } MQPR:{ *:[v2i64] }:$src)
     /*  34120 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34123 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34127 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34132 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  34135 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34137 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34139 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34142 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34148 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34154 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34157 */   GIR_RootConstrainSelectedInstOperands,
     /*  34158 */   // GIR_Coverage, 5346,
     /*  34158 */   GIR_EraseRootFromParent_Done,
     /*  34159 */ // Label 755: @34159
     /*  34159 */ GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(34217), // Rule ID 5347 //
     /*  34164 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34174 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34178 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VREV32_16:{ *:[v8f16] } MQPR:{ *:[v4f32] }:$src)
     /*  34178 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34181 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34185 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34190 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  34193 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34195 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34197 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34200 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34206 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34212 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34215 */   GIR_RootConstrainSelectedInstOperands,
     /*  34216 */   // GIR_Coverage, 5347,
     /*  34216 */   GIR_EraseRootFromParent_Done,
     /*  34217 */ // Label 756: @34217
     /*  34217 */ GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(34275), // Rule ID 5348 //
     /*  34222 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34232 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34236 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV32_16:{ *:[v8f16] } MQPR:{ *:[v4i32] }:$src)
     /*  34236 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34239 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34243 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34248 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  34251 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34253 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34255 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34258 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34264 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34270 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34273 */   GIR_RootConstrainSelectedInstOperands,
     /*  34274 */   // GIR_Coverage, 5348,
     /*  34274 */   GIR_EraseRootFromParent_Done,
     /*  34275 */ // Label 757: @34275
     /*  34275 */ GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(34333), // Rule ID 5349 //
     /*  34280 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34290 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34294 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV16_8:{ *:[v8f16] } MQPR:{ *:[v16i8] }:$src)
     /*  34294 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34297 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34301 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34306 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV16_8),
     /*  34309 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34311 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34313 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34316 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34322 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34328 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34331 */   GIR_RootConstrainSelectedInstOperands,
     /*  34332 */   // GIR_Coverage, 5349,
     /*  34332 */   GIR_EraseRootFromParent_Done,
     /*  34333 */ // Label 758: @34333
     /*  34333 */ GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(34391), // Rule ID 5350 //
     /*  34338 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34348 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34352 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v2f64] }:$src)  =>  (MVE_VREV64_16:{ *:[v8i16] } MQPR:{ *:[v2f64] }:$src)
     /*  34352 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34355 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34359 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34364 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  34367 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34369 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34371 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34374 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34380 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34386 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34389 */   GIR_RootConstrainSelectedInstOperands,
     /*  34390 */   // GIR_Coverage, 5350,
     /*  34390 */   GIR_EraseRootFromParent_Done,
     /*  34391 */ // Label 759: @34391
     /*  34391 */ GIM_Try, /*On fail goto*//*Label 760*/ GIMT_Encode4(34449), // Rule ID 5351 //
     /*  34396 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34406 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34410 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v2i64] }:$src)  =>  (MVE_VREV64_16:{ *:[v8i16] } MQPR:{ *:[v2i64] }:$src)
     /*  34410 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34413 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34417 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34422 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  34425 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34427 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34429 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34432 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34438 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34444 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34447 */   GIR_RootConstrainSelectedInstOperands,
     /*  34448 */   // GIR_Coverage, 5351,
     /*  34448 */   GIR_EraseRootFromParent_Done,
     /*  34449 */ // Label 760: @34449
     /*  34449 */ GIM_Try, /*On fail goto*//*Label 761*/ GIMT_Encode4(34507), // Rule ID 5352 //
     /*  34454 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34464 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34468 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VREV32_16:{ *:[v8i16] } MQPR:{ *:[v4f32] }:$src)
     /*  34468 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34471 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34475 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34480 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  34483 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34485 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34487 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34490 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34496 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34502 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34505 */   GIR_RootConstrainSelectedInstOperands,
     /*  34506 */   // GIR_Coverage, 5352,
     /*  34506 */   GIR_EraseRootFromParent_Done,
     /*  34507 */ // Label 761: @34507
     /*  34507 */ GIM_Try, /*On fail goto*//*Label 762*/ GIMT_Encode4(34565), // Rule ID 5353 //
     /*  34512 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34522 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34526 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV32_16:{ *:[v8i16] } MQPR:{ *:[v4i32] }:$src)
     /*  34526 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34529 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34533 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34538 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  34541 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34543 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34545 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34548 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34554 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34560 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34563 */   GIR_RootConstrainSelectedInstOperands,
     /*  34564 */   // GIR_Coverage, 5353,
     /*  34564 */   GIR_EraseRootFromParent_Done,
     /*  34565 */ // Label 762: @34565
     /*  34565 */ GIM_Try, /*On fail goto*//*Label 763*/ GIMT_Encode4(34623), // Rule ID 5354 //
     /*  34570 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34580 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34584 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV16_8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)
     /*  34584 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34587 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34591 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34596 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV16_8),
     /*  34599 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34601 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34603 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34606 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34612 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34618 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34621 */   GIR_RootConstrainSelectedInstOperands,
     /*  34622 */   // GIR_Coverage, 5354,
     /*  34622 */   GIR_EraseRootFromParent_Done,
     /*  34623 */ // Label 763: @34623
     /*  34623 */ GIM_Reject,
     /*  34624 */ // Label 548: @34624
     /*  34624 */ GIM_Try, /*On fail goto*//*Label 764*/ GIMT_Encode4(34656), // Rule ID 2798 //
     /*  34629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34639 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34643 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34643 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34646 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34648 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34650 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34655 */   // GIR_Coverage, 2798,
     /*  34655 */   GIR_EraseRootFromParent_Done,
     /*  34656 */ // Label 764: @34656
     /*  34656 */ GIM_Try, /*On fail goto*//*Label 765*/ GIMT_Encode4(34688), // Rule ID 2799 //
     /*  34661 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34664 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34671 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34675 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34675 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34678 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34680 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34682 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34687 */   // GIR_Coverage, 2799,
     /*  34687 */   GIR_EraseRootFromParent_Done,
     /*  34688 */ // Label 765: @34688
     /*  34688 */ GIM_Try, /*On fail goto*//*Label 766*/ GIMT_Encode4(34720), // Rule ID 2800 //
     /*  34693 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34703 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34707 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34707 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34710 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34712 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34714 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34719 */   // GIR_Coverage, 2800,
     /*  34719 */   GIR_EraseRootFromParent_Done,
     /*  34720 */ // Label 766: @34720
     /*  34720 */ GIM_Try, /*On fail goto*//*Label 767*/ GIMT_Encode4(34752), // Rule ID 2801 //
     /*  34725 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34735 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34739 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34739 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34742 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34744 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34746 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34751 */   // GIR_Coverage, 2801,
     /*  34751 */   GIR_EraseRootFromParent_Done,
     /*  34752 */ // Label 767: @34752
     /*  34752 */ GIM_Try, /*On fail goto*//*Label 768*/ GIMT_Encode4(34784), // Rule ID 2802 //
     /*  34757 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34767 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34771 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34771 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34774 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34776 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34778 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34783 */   // GIR_Coverage, 2802,
     /*  34783 */   GIR_EraseRootFromParent_Done,
     /*  34784 */ // Label 768: @34784
     /*  34784 */ GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(34816), // Rule ID 2803 //
     /*  34789 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34799 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34803 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34803 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34806 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34808 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34810 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34815 */   // GIR_Coverage, 2803,
     /*  34815 */   GIR_EraseRootFromParent_Done,
     /*  34816 */ // Label 769: @34816
     /*  34816 */ GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(34853), // Rule ID 2870 //
     /*  34821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  34824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34831 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34835 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v2f64] }:$src)  =>  (VREV64q8:{ *:[v16i8] } QPR:{ *:[v2f64] }:$src)
     /*  34835 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q8),
     /*  34838 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  34840 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34842 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  34845 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34851 */   GIR_RootConstrainSelectedInstOperands,
     /*  34852 */   // GIR_Coverage, 2870,
     /*  34852 */   GIR_EraseRootFromParent_Done,
     /*  34853 */ // Label 770: @34853
     /*  34853 */ GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(34890), // Rule ID 2871 //
     /*  34858 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  34861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34868 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34872 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v2i64] }:$src)  =>  (VREV64q8:{ *:[v16i8] } QPR:{ *:[v2i64] }:$src)
     /*  34872 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q8),
     /*  34875 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  34877 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34879 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  34882 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34888 */   GIR_RootConstrainSelectedInstOperands,
     /*  34889 */   // GIR_Coverage, 2871,
     /*  34889 */   GIR_EraseRootFromParent_Done,
     /*  34890 */ // Label 771: @34890
     /*  34890 */ GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(34927), // Rule ID 2872 //
     /*  34895 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  34898 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34905 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34909 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v4f32] }:$src)  =>  (VREV32q8:{ *:[v16i8] } QPR:{ *:[v4f32] }:$src)
     /*  34909 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q8),
     /*  34912 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  34914 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34916 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  34919 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34925 */   GIR_RootConstrainSelectedInstOperands,
     /*  34926 */   // GIR_Coverage, 2872,
     /*  34926 */   GIR_EraseRootFromParent_Done,
     /*  34927 */ // Label 772: @34927
     /*  34927 */ GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(34964), // Rule ID 2873 //
     /*  34932 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  34935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34942 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34946 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v4i32] }:$src)  =>  (VREV32q8:{ *:[v16i8] } QPR:{ *:[v4i32] }:$src)
     /*  34946 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q8),
     /*  34949 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  34951 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34953 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  34956 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34962 */   GIR_RootConstrainSelectedInstOperands,
     /*  34963 */   // GIR_Coverage, 2873,
     /*  34963 */   GIR_EraseRootFromParent_Done,
     /*  34964 */ // Label 773: @34964
     /*  34964 */ GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(35001), // Rule ID 2874 //
     /*  34969 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  34972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34979 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34983 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v8f16] }:$src)  =>  (VREV16q8:{ *:[v16i8] } QPR:{ *:[v8f16] }:$src)
     /*  34983 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16q8),
     /*  34986 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  34988 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34990 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  34993 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34999 */   GIR_RootConstrainSelectedInstOperands,
     /*  35000 */   // GIR_Coverage, 2874,
     /*  35000 */   GIR_EraseRootFromParent_Done,
     /*  35001 */ // Label 774: @35001
     /*  35001 */ GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(35038), // Rule ID 2875 //
     /*  35006 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  35009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  35016 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  35020 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v8i16] }:$src)  =>  (VREV16q8:{ *:[v16i8] } QPR:{ *:[v8i16] }:$src)
     /*  35020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16q8),
     /*  35023 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  35025 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35027 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  35030 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35036 */   GIR_RootConstrainSelectedInstOperands,
     /*  35037 */   // GIR_Coverage, 2875,
     /*  35037 */   GIR_EraseRootFromParent_Done,
     /*  35038 */ // Label 775: @35038
     /*  35038 */ GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(35070), // Rule ID 5319 //
     /*  35043 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35053 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35057 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35057 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35060 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35062 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35064 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35069 */   // GIR_Coverage, 5319,
     /*  35069 */   GIR_EraseRootFromParent_Done,
     /*  35070 */ // Label 776: @35070
     /*  35070 */ GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(35102), // Rule ID 5320 //
     /*  35075 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35081 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35085 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35089 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35089 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35092 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35094 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35096 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35101 */   // GIR_Coverage, 5320,
     /*  35101 */   GIR_EraseRootFromParent_Done,
     /*  35102 */ // Label 777: @35102
     /*  35102 */ GIM_Try, /*On fail goto*//*Label 778*/ GIMT_Encode4(35134), // Rule ID 5321 //
     /*  35107 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35117 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35121 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35121 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35124 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35126 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35128 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35133 */   // GIR_Coverage, 5321,
     /*  35133 */   GIR_EraseRootFromParent_Done,
     /*  35134 */ // Label 778: @35134
     /*  35134 */ GIM_Try, /*On fail goto*//*Label 779*/ GIMT_Encode4(35166), // Rule ID 5322 //
     /*  35139 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35149 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35153 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35153 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35156 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35158 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35160 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35165 */   // GIR_Coverage, 5322,
     /*  35165 */   GIR_EraseRootFromParent_Done,
     /*  35166 */ // Label 779: @35166
     /*  35166 */ GIM_Try, /*On fail goto*//*Label 780*/ GIMT_Encode4(35198), // Rule ID 5323 //
     /*  35171 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35181 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35185 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35185 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35188 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35190 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35192 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35197 */   // GIR_Coverage, 5323,
     /*  35197 */   GIR_EraseRootFromParent_Done,
     /*  35198 */ // Label 780: @35198
     /*  35198 */ GIM_Try, /*On fail goto*//*Label 781*/ GIMT_Encode4(35230), // Rule ID 5324 //
     /*  35203 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35206 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35213 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35217 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35217 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35220 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35222 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35224 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35229 */   // GIR_Coverage, 5324,
     /*  35229 */   GIR_EraseRootFromParent_Done,
     /*  35230 */ // Label 781: @35230
     /*  35230 */ GIM_Try, /*On fail goto*//*Label 782*/ GIMT_Encode4(35288), // Rule ID 5355 //
     /*  35235 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35245 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35249 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v2f64] }:$src)  =>  (MVE_VREV64_8:{ *:[v16i8] } MQPR:{ *:[v2f64] }:$src)
     /*  35249 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35252 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35256 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35261 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_8),
     /*  35264 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35266 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35268 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35271 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35277 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35283 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35286 */   GIR_RootConstrainSelectedInstOperands,
     /*  35287 */   // GIR_Coverage, 5355,
     /*  35287 */   GIR_EraseRootFromParent_Done,
     /*  35288 */ // Label 782: @35288
     /*  35288 */ GIM_Try, /*On fail goto*//*Label 783*/ GIMT_Encode4(35346), // Rule ID 5356 //
     /*  35293 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35303 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35307 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v2i64] }:$src)  =>  (MVE_VREV64_8:{ *:[v16i8] } MQPR:{ *:[v2i64] }:$src)
     /*  35307 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35310 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35314 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35319 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_8),
     /*  35322 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35324 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35326 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35329 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35335 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35341 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35344 */   GIR_RootConstrainSelectedInstOperands,
     /*  35345 */   // GIR_Coverage, 5356,
     /*  35345 */   GIR_EraseRootFromParent_Done,
     /*  35346 */ // Label 783: @35346
     /*  35346 */ GIM_Try, /*On fail goto*//*Label 784*/ GIMT_Encode4(35404), // Rule ID 5357 //
     /*  35351 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35354 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35357 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35361 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35365 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VREV32_8:{ *:[v16i8] } MQPR:{ *:[v4f32] }:$src)
     /*  35365 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35368 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35372 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35377 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_8),
     /*  35380 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35382 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35384 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35387 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35393 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35399 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35402 */   GIR_RootConstrainSelectedInstOperands,
     /*  35403 */   // GIR_Coverage, 5357,
     /*  35403 */   GIR_EraseRootFromParent_Done,
     /*  35404 */ // Label 784: @35404
     /*  35404 */ GIM_Try, /*On fail goto*//*Label 785*/ GIMT_Encode4(35462), // Rule ID 5358 //
     /*  35409 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35415 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35419 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35423 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV32_8:{ *:[v16i8] } MQPR:{ *:[v4i32] }:$src)
     /*  35423 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35426 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35430 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35435 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_8),
     /*  35438 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35440 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35442 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35445 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35451 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35457 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35460 */   GIR_RootConstrainSelectedInstOperands,
     /*  35461 */   // GIR_Coverage, 5358,
     /*  35461 */   GIR_EraseRootFromParent_Done,
     /*  35462 */ // Label 785: @35462
     /*  35462 */ GIM_Try, /*On fail goto*//*Label 786*/ GIMT_Encode4(35520), // Rule ID 5359 //
     /*  35467 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35477 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35481 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VREV16_8:{ *:[v16i8] } MQPR:{ *:[v8f16] }:$src)
     /*  35481 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35484 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35488 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV16_8),
     /*  35496 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35498 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35500 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35503 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35509 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35515 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35518 */   GIR_RootConstrainSelectedInstOperands,
     /*  35519 */   // GIR_Coverage, 5359,
     /*  35519 */   GIR_EraseRootFromParent_Done,
     /*  35520 */ // Label 786: @35520
     /*  35520 */ GIM_Try, /*On fail goto*//*Label 787*/ GIMT_Encode4(35578), // Rule ID 5360 //
     /*  35525 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35528 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35535 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35539 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV16_8:{ *:[v16i8] } MQPR:{ *:[v8i16] }:$src)
     /*  35539 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35542 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35546 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35551 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV16_8),
     /*  35554 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35556 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35558 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35561 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35567 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35573 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35576 */   GIR_RootConstrainSelectedInstOperands,
     /*  35577 */   // GIR_Coverage, 5360,
     /*  35577 */   GIR_EraseRootFromParent_Done,
     /*  35578 */ // Label 787: @35578
     /*  35578 */ GIM_Reject,
     /*  35579 */ // Label 549: @35579
     /*  35579 */ GIM_Reject,
     /*  35580 */ // Label 10: @35580
     /*  35580 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 793*/ GIMT_Encode4(35875),
     /*  35591 */ /*GILLT_s16*//*Label 788*/ GIMT_Encode4(35643),
     /*  35595 */ /*GILLT_s32*//*Label 789*/ GIMT_Encode4(35681),
     /*  35599 */ /*GILLT_s64*//*Label 790*/ GIMT_Encode4(35719), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  35623 */ /*GILLT_v4s32*//*Label 791*/ GIMT_Encode4(35757), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  35639 */ /*GILLT_v8s16*//*Label 792*/ GIMT_Encode4(35816),
     /*  35643 */ // Label 788: @35643
     /*  35643 */ GIM_Try, /*On fail goto*//*Label 794*/ GIMT_Encode4(35680), // Rule ID 665 //
     /*  35648 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  35651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  35654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  35658 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  35662 */   // (ftrunc:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTZH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /*  35662 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZH),
     /*  35665 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  35667 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /*  35669 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  35672 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35678 */   GIR_RootConstrainSelectedInstOperands,
     /*  35679 */   // GIR_Coverage, 665,
     /*  35679 */   GIR_EraseRootFromParent_Done,
     /*  35680 */ // Label 794: @35680
     /*  35680 */ GIM_Reject,
     /*  35681 */ // Label 789: @35681
     /*  35681 */ GIM_Try, /*On fail goto*//*Label 795*/ GIMT_Encode4(35718), // Rule ID 666 //
     /*  35686 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  35689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  35692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  35696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  35700 */   // (ftrunc:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTZS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /*  35700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZS),
     /*  35703 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  35705 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /*  35707 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  35710 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35716 */   GIR_RootConstrainSelectedInstOperands,
     /*  35717 */   // GIR_Coverage, 666,
     /*  35717 */   GIR_EraseRootFromParent_Done,
     /*  35718 */ // Label 795: @35718
     /*  35718 */ GIM_Reject,
     /*  35719 */ // Label 790: @35719
     /*  35719 */ GIM_Try, /*On fail goto*//*Label 796*/ GIMT_Encode4(35756), // Rule ID 667 //
     /*  35724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /*  35727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  35730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  35734 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  35738 */   // (ftrunc:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTZD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /*  35738 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZD),
     /*  35741 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /*  35743 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /*  35745 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  35748 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35754 */   GIR_RootConstrainSelectedInstOperands,
     /*  35755 */   // GIR_Coverage, 667,
     /*  35755 */   GIR_EraseRootFromParent_Done,
     /*  35756 */ // Label 796: @35756
     /*  35756 */ GIM_Reject,
     /*  35757 */ // Label 791: @35757
     /*  35757 */ GIM_Try, /*On fail goto*//*Label 797*/ GIMT_Encode4(35815), // Rule ID 3982 //
     /*  35762 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  35765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35772 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35776 */   // (ftrunc:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32Z:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /*  35776 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35779 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35783 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35788 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32Z),
     /*  35791 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35793 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  35795 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35798 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35804 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35810 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35813 */   GIR_RootConstrainSelectedInstOperands,
     /*  35814 */   // GIR_Coverage, 3982,
     /*  35814 */   GIR_EraseRootFromParent_Done,
     /*  35815 */ // Label 797: @35815
     /*  35815 */ GIM_Reject,
     /*  35816 */ // Label 792: @35816
     /*  35816 */ GIM_Try, /*On fail goto*//*Label 798*/ GIMT_Encode4(35874), // Rule ID 3970 //
     /*  35821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  35824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35831 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35835 */   // (ftrunc:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16Z:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /*  35835 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35838 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35842 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35847 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16Z),
     /*  35850 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35852 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  35854 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35857 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35863 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35869 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35872 */   GIR_RootConstrainSelectedInstOperands,
     /*  35873 */   // GIR_Coverage, 3970,
     /*  35873 */   GIR_EraseRootFromParent_Done,
     /*  35874 */ // Label 798: @35874
     /*  35874 */ GIM_Reject,
     /*  35875 */ // Label 793: @35875
     /*  35875 */ GIM_Reject,
     /*  35876 */ // Label 11: @35876
     /*  35876 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 806*/ GIMT_Encode4(36250),
     /*  35887 */ /*GILLT_s16*//*Label 799*/ GIMT_Encode4(35939),
     /*  35891 */ /*GILLT_s32*//*Label 800*/ GIMT_Encode4(35966),
     /*  35895 */ /*GILLT_s64*//*Label 801*/ GIMT_Encode4(35993), GIMT_Encode4(0),
     /*  35903 */ /*GILLT_v2s32*//*Label 802*/ GIMT_Encode4(36020), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  35915 */ /*GILLT_v4s16*//*Label 803*/ GIMT_Encode4(36047),
     /*  35919 */ /*GILLT_v4s32*//*Label 804*/ GIMT_Encode4(36074), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  35935 */ /*GILLT_v8s16*//*Label 805*/ GIMT_Encode4(36162),
     /*  35939 */ // Label 799: @35939
     /*  35939 */ GIM_Try, /*On fail goto*//*Label 807*/ GIMT_Encode4(35965), // Rule ID 674 //
     /*  35944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  35947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  35950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  35954 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  35958 */   // (fround:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTAH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /*  35958 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTAH),
     /*  35963 */   GIR_RootConstrainSelectedInstOperands,
     /*  35964 */   // GIR_Coverage, 674,
     /*  35964 */   GIR_Done,
     /*  35965 */ // Label 807: @35965
     /*  35965 */ GIM_Reject,
     /*  35966 */ // Label 800: @35966
     /*  35966 */ GIM_Try, /*On fail goto*//*Label 808*/ GIMT_Encode4(35992), // Rule ID 675 //
     /*  35971 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  35974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  35977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  35981 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  35985 */   // (fround:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTAS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /*  35985 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTAS),
     /*  35990 */   GIR_RootConstrainSelectedInstOperands,
     /*  35991 */   // GIR_Coverage, 675,
     /*  35991 */   GIR_Done,
     /*  35992 */ // Label 808: @35992
     /*  35992 */ GIM_Reject,
     /*  35993 */ // Label 801: @35993
     /*  35993 */ GIM_Try, /*On fail goto*//*Label 809*/ GIMT_Encode4(36019), // Rule ID 676 //
     /*  35998 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /*  36001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  36004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36008 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36012 */   // (fround:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTAD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /*  36012 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTAD),
     /*  36017 */   GIR_RootConstrainSelectedInstOperands,
     /*  36018 */   // GIR_Coverage, 676,
     /*  36018 */   GIR_Done,
     /*  36019 */ // Label 809: @36019
     /*  36019 */ GIM_Reject,
     /*  36020 */ // Label 802: @36020
     /*  36020 */ GIM_Try, /*On fail goto*//*Label 810*/ GIMT_Encode4(36046), // Rule ID 1699 //
     /*  36025 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  36028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  36031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36035 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36039 */   // (fround:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTANDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  36039 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTANDf),
     /*  36044 */   GIR_RootConstrainSelectedInstOperands,
     /*  36045 */   // GIR_Coverage, 1699,
     /*  36045 */   GIR_Done,
     /*  36046 */ // Label 810: @36046
     /*  36046 */ GIM_Reject,
     /*  36047 */ // Label 803: @36047
     /*  36047 */ GIM_Try, /*On fail goto*//*Label 811*/ GIMT_Encode4(36073), // Rule ID 1701 //
     /*  36052 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  36055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  36058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36062 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36066 */   // (fround:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTANDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  36066 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTANDh),
     /*  36071 */   GIR_RootConstrainSelectedInstOperands,
     /*  36072 */   // GIR_Coverage, 1701,
     /*  36072 */   GIR_Done,
     /*  36073 */ // Label 811: @36073
     /*  36073 */ GIM_Reject,
     /*  36074 */ // Label 804: @36074
     /*  36074 */ GIM_Try, /*On fail goto*//*Label 812*/ GIMT_Encode4(36161),
     /*  36079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36082 */   GIM_Try, /*On fail goto*//*Label 813*/ GIMT_Encode4(36105), // Rule ID 1700 //
     /*  36087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  36090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  36094 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  36098 */     // (fround:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTANQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  36098 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTANQf),
     /*  36103 */     GIR_RootConstrainSelectedInstOperands,
     /*  36104 */     // GIR_Coverage, 1700,
     /*  36104 */     GIR_Done,
     /*  36105 */   // Label 813: @36105
     /*  36105 */   GIM_Try, /*On fail goto*//*Label 814*/ GIMT_Encode4(36160), // Rule ID 3980 //
     /*  36110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  36113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36121 */     // (fround:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32A:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /*  36121 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  36124 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36128 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32A),
     /*  36136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  36138 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  36140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  36143 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36149 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36155 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36158 */     GIR_RootConstrainSelectedInstOperands,
     /*  36159 */     // GIR_Coverage, 3980,
     /*  36159 */     GIR_EraseRootFromParent_Done,
     /*  36160 */   // Label 814: @36160
     /*  36160 */   GIM_Reject,
     /*  36161 */ // Label 812: @36161
     /*  36161 */ GIM_Reject,
     /*  36162 */ // Label 805: @36162
     /*  36162 */ GIM_Try, /*On fail goto*//*Label 815*/ GIMT_Encode4(36249),
     /*  36167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  36170 */   GIM_Try, /*On fail goto*//*Label 816*/ GIMT_Encode4(36193), // Rule ID 1702 //
     /*  36175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  36178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  36182 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  36186 */     // (fround:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTANQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  36186 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTANQh),
     /*  36191 */     GIR_RootConstrainSelectedInstOperands,
     /*  36192 */     // GIR_Coverage, 1702,
     /*  36192 */     GIR_Done,
     /*  36193 */   // Label 816: @36193
     /*  36193 */   GIM_Try, /*On fail goto*//*Label 817*/ GIMT_Encode4(36248), // Rule ID 3968 //
     /*  36198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  36201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36209 */     // (fround:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16A:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /*  36209 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  36212 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36216 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16A),
     /*  36224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  36226 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  36228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  36231 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36237 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36243 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36246 */     GIR_RootConstrainSelectedInstOperands,
     /*  36247 */     // GIR_Coverage, 3968,
     /*  36247 */     GIR_EraseRootFromParent_Done,
     /*  36248 */   // Label 817: @36248
     /*  36248 */   GIM_Reject,
     /*  36249 */ // Label 815: @36249
     /*  36249 */ GIM_Reject,
     /*  36250 */ // Label 806: @36250
     /*  36250 */ GIM_Reject,
     /*  36251 */ // Label 12: @36251
     /*  36251 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 823*/ GIMT_Encode4(36513),
     /*  36262 */ /*GILLT_s16*//*Label 818*/ GIMT_Encode4(36314),
     /*  36266 */ /*GILLT_s32*//*Label 819*/ GIMT_Encode4(36341),
     /*  36270 */ /*GILLT_s64*//*Label 820*/ GIMT_Encode4(36368), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  36294 */ /*GILLT_v4s32*//*Label 821*/ GIMT_Encode4(36395), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  36310 */ /*GILLT_v8s16*//*Label 822*/ GIMT_Encode4(36454),
     /*  36314 */ // Label 818: @36314
     /*  36314 */ GIM_Try, /*On fail goto*//*Label 824*/ GIMT_Encode4(36340), // Rule ID 678 //
     /*  36319 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  36322 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  36325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  36329 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  36333 */   // (froundeven:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTNH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /*  36333 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTNH),
     /*  36338 */   GIR_RootConstrainSelectedInstOperands,
     /*  36339 */   // GIR_Coverage, 678,
     /*  36339 */   GIR_Done,
     /*  36340 */ // Label 824: @36340
     /*  36340 */ GIM_Reject,
     /*  36341 */ // Label 819: @36341
     /*  36341 */ GIM_Try, /*On fail goto*//*Label 825*/ GIMT_Encode4(36367), // Rule ID 680 //
     /*  36346 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  36349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  36352 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36356 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36360 */   // (froundeven:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTNS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /*  36360 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTNS),
     /*  36365 */   GIR_RootConstrainSelectedInstOperands,
     /*  36366 */   // GIR_Coverage, 680,
     /*  36366 */   GIR_Done,
     /*  36367 */ // Label 825: @36367
     /*  36367 */ GIM_Reject,
     /*  36368 */ // Label 820: @36368
     /*  36368 */ GIM_Try, /*On fail goto*//*Label 826*/ GIMT_Encode4(36394), // Rule ID 682 //
     /*  36373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /*  36376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  36379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36387 */   // (froundeven:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTND:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /*  36387 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTND),
     /*  36392 */   GIR_RootConstrainSelectedInstOperands,
     /*  36393 */   // GIR_Coverage, 682,
     /*  36393 */   GIR_Done,
     /*  36394 */ // Label 826: @36394
     /*  36394 */ GIM_Reject,
     /*  36395 */ // Label 821: @36395
     /*  36395 */ GIM_Try, /*On fail goto*//*Label 827*/ GIMT_Encode4(36453), // Rule ID 3976 //
     /*  36400 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  36403 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36410 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36414 */   // (froundeven:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32N:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /*  36414 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  36417 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36421 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36426 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32N),
     /*  36429 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  36431 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  36433 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  36436 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36442 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36448 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36451 */   GIR_RootConstrainSelectedInstOperands,
     /*  36452 */   // GIR_Coverage, 3976,
     /*  36452 */   GIR_EraseRootFromParent_Done,
     /*  36453 */ // Label 827: @36453
     /*  36453 */ GIM_Reject,
     /*  36454 */ // Label 822: @36454
     /*  36454 */ GIM_Try, /*On fail goto*//*Label 828*/ GIMT_Encode4(36512), // Rule ID 3964 //
     /*  36459 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  36462 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  36465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36469 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36473 */   // (froundeven:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16N:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /*  36473 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  36476 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36480 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36485 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16N),
     /*  36488 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  36490 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  36492 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  36495 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36501 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36507 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36510 */   GIR_RootConstrainSelectedInstOperands,
     /*  36511 */   // GIR_Coverage, 3964,
     /*  36511 */   GIR_EraseRootFromParent_Done,
     /*  36512 */ // Label 828: @36512
     /*  36512 */ GIM_Reject,
     /*  36513 */ // Label 823: @36513
     /*  36513 */ GIM_Reject,
     /*  36514 */ // Label 13: @36514
     /*  36514 */ GIM_Try, /*On fail goto*//*Label 829*/ GIMT_Encode4(36676),
     /*  36519 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36522 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  36525 */   GIM_Try, /*On fail goto*//*Label 830*/ GIMT_Encode4(36600), // Rule ID 2053 //
     /*  36530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /*  36533 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  36540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  36544 */     // MIs[0] Rn
     /*  36544 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  36548 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  36552 */     // (ld:{ *:[i32] } tGPR:{ *:[i32] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (tLDRSB:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, (tMOVi8:{ *:[i32] } 0:{ *:[i32] }))
     /*  36552 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  36555 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::tMOVi8),
     /*  36559 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36564 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  36570 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  36573 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  36576 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tLDRSB),
     /*  36587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  36589 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  36591 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36594 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  36598 */     GIR_RootConstrainSelectedInstOperands,
     /*  36599 */     // GIR_Coverage, 2053,
     /*  36599 */     GIR_EraseRootFromParent_Done,
     /*  36600 */   // Label 830: @36600
     /*  36600 */   GIM_Try, /*On fail goto*//*Label 831*/ GIMT_Encode4(36675), // Rule ID 2054 //
     /*  36605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /*  36608 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  36615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  36619 */     // MIs[0] Rn
     /*  36619 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  36623 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  36627 */     // (ld:{ *:[i32] } tGPR:{ *:[i32] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (tLDRSH:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, (tMOVi8:{ *:[i32] } 0:{ *:[i32] }))
     /*  36627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  36630 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::tMOVi8),
     /*  36634 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36639 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  36645 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  36648 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  36651 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36657 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tLDRSH),
     /*  36662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  36664 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  36666 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36669 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  36673 */     GIR_RootConstrainSelectedInstOperands,
     /*  36674 */     // GIR_Coverage, 2054,
     /*  36674 */     GIR_EraseRootFromParent_Done,
     /*  36675 */   // Label 831: @36675
     /*  36675 */   GIM_Reject,
     /*  36676 */ // Label 829: @36676
     /*  36676 */ GIM_Reject,
     /*  36677 */ // Label 14: @36677
     /*  36677 */ GIM_Try, /*On fail goto*//*Label 832*/ GIMT_Encode4(36697), // Rule ID 5421 //
     /*  36682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  36685 */   // MIs[0] Operand 0
     /*  36685 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /*  36688 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  36692 */   // (atomic_fence (timm:{ *:[i32] }), 0:{ *:[i32] })  =>  (MEMBARRIER)
     /*  36692 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::MEMBARRIER),
     /*  36695 */   GIR_RootConstrainSelectedInstOperands,
     /*  36696 */   // GIR_Coverage, 5421,
     /*  36696 */   GIR_EraseRootFromParent_Done,
     /*  36697 */ // Label 832: @36697
     /*  36697 */ GIM_Reject,
     /*  36698 */ // Label 15: @36698
     /*  36698 */ GIM_Try, /*On fail goto*//*Label 833*/ GIMT_Encode4(42093),
     /*  36703 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  36706 */   GIM_Try, /*On fail goto*//*Label 834*/ GIMT_Encode4(36754), // Rule ID 1856 //
     /*  36711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  36714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uxtb16),
     /*  36719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  36729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  36733 */     // (intrinsic_wo_chain:{ *:[i32] } 3945:{ *:[iPTR] }, GPR:{ *:[i32] }:$Src)  =>  (UXTB16:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  36733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTB16),
     /*  36736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  36738 */     GIR_RootToRootCopy, /*OpIdx*/2, // Src
     /*  36740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  36743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36746 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36752 */     GIR_RootConstrainSelectedInstOperands,
     /*  36753 */     // GIR_Coverage, 1856,
     /*  36753 */     GIR_EraseRootFromParent_Done,
     /*  36754 */   // Label 834: @36754
     /*  36754 */   GIM_Try, /*On fail goto*//*Label 835*/ GIMT_Encode4(36802), // Rule ID 2110 //
     /*  36759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  36762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uxtb16),
     /*  36767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  36777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  36781 */     // (intrinsic_wo_chain:{ *:[i32] } 3945:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rm)  =>  (t2UXTB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  36781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTB16),
     /*  36784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  36786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  36788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  36791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36794 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36800 */     GIR_RootConstrainSelectedInstOperands,
     /*  36801 */     // GIR_Coverage, 2110,
     /*  36801 */     GIR_EraseRootFromParent_Done,
     /*  36802 */   // Label 835: @36802
     /*  36802 */   GIM_Try, /*On fail goto*//*Label 836*/ GIMT_Encode4(36838), // Rule ID 677 //
     /*  36807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  36810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  36815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /*  36818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  36821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  36825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  36829 */     // (intrinsic_wo_chain:{ *:[f16] } 3831:{ *:[iPTR] }, HPR:{ *:[f16] }:$Sm)  =>  (VRINTNH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /*  36829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTNH),
     /*  36832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  36834 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /*  36836 */     GIR_RootConstrainSelectedInstOperands,
     /*  36837 */     // GIR_Coverage, 677,
     /*  36837 */     GIR_EraseRootFromParent_Done,
     /*  36838 */   // Label 836: @36838
     /*  36838 */   GIM_Try, /*On fail goto*//*Label 837*/ GIMT_Encode4(36874), // Rule ID 679 //
     /*  36843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  36846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  36851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36865 */     // (intrinsic_wo_chain:{ *:[f32] } 3831:{ *:[iPTR] }, SPR:{ *:[f32] }:$Sm)  =>  (VRINTNS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /*  36865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTNS),
     /*  36868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  36870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /*  36872 */     GIR_RootConstrainSelectedInstOperands,
     /*  36873 */     // GIR_Coverage, 679,
     /*  36873 */     GIR_EraseRootFromParent_Done,
     /*  36874 */   // Label 837: @36874
     /*  36874 */   GIM_Try, /*On fail goto*//*Label 838*/ GIMT_Encode4(36910), // Rule ID 681 //
     /*  36879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /*  36882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  36887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  36890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  36893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36901 */     // (intrinsic_wo_chain:{ *:[f64] } 3831:{ *:[iPTR] }, DPR:{ *:[f64] }:$Dm)  =>  (VRINTND:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /*  36901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTND),
     /*  36904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /*  36906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  36908 */     GIR_RootConstrainSelectedInstOperands,
     /*  36909 */     // GIR_Coverage, 681,
     /*  36909 */     GIR_EraseRootFromParent_Done,
     /*  36910 */   // Label 838: @36910
     /*  36910 */   GIM_Try, /*On fail goto*//*Label 839*/ GIMT_Encode4(36955), // Rule ID 696 //
     /*  36915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /*  36918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_vcvtr),
     /*  36923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  36929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36937 */     // (intrinsic_wo_chain:{ *:[f32] } 3946:{ *:[iPTR] }, DPR:{ *:[f64] }:$Dm)  =>  (VTOSIRD:{ *:[f32] } DPR:{ *:[f64] }:$Dm)
     /*  36937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTOSIRD),
     /*  36940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  36942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  36944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36947 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36953 */     GIR_RootConstrainSelectedInstOperands,
     /*  36954 */     // GIR_Coverage, 696,
     /*  36954 */     GIR_EraseRootFromParent_Done,
     /*  36955 */   // Label 839: @36955
     /*  36955 */   GIM_Try, /*On fail goto*//*Label 840*/ GIMT_Encode4(37000), // Rule ID 697 //
     /*  36960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /*  36963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_vcvtr),
     /*  36968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36982 */     // (intrinsic_wo_chain:{ *:[f32] } 3946:{ *:[iPTR] }, SPR:{ *:[f32] }:$Sm)  =>  (VTOSIRS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /*  36982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTOSIRS),
     /*  36985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  36987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /*  36989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36992 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36998 */     GIR_RootConstrainSelectedInstOperands,
     /*  36999 */     // GIR_Coverage, 697,
     /*  36999 */     GIR_EraseRootFromParent_Done,
     /*  37000 */   // Label 840: @37000
     /*  37000 */   GIM_Try, /*On fail goto*//*Label 841*/ GIMT_Encode4(37045), // Rule ID 698 //
     /*  37005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /*  37008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_vcvtru),
     /*  37013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  37016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  37023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37027 */     // (intrinsic_wo_chain:{ *:[f32] } 3947:{ *:[iPTR] }, DPR:{ *:[f64] }:$Dm)  =>  (VTOUIRD:{ *:[f32] } DPR:{ *:[f64] }:$Dm)
     /*  37027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTOUIRD),
     /*  37030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  37032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  37034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37037 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37043 */     GIR_RootConstrainSelectedInstOperands,
     /*  37044 */     // GIR_Coverage, 698,
     /*  37044 */     GIR_EraseRootFromParent_Done,
     /*  37045 */   // Label 841: @37045
     /*  37045 */   GIM_Try, /*On fail goto*//*Label 842*/ GIMT_Encode4(37090), // Rule ID 699 //
     /*  37050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /*  37053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_vcvtru),
     /*  37058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  37061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  37064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  37068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  37072 */     // (intrinsic_wo_chain:{ *:[f32] } 3947:{ *:[iPTR] }, SPR:{ *:[f32] }:$Sm)  =>  (VTOUIRS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /*  37072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTOUIRS),
     /*  37075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  37077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /*  37079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37082 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37088 */     GIR_RootConstrainSelectedInstOperands,
     /*  37089 */     // GIR_Coverage, 699,
     /*  37089 */     GIR_EraseRootFromParent_Done,
     /*  37090 */   // Label 842: @37090
     /*  37090 */   GIM_Try, /*On fail goto*//*Label 843*/ GIMT_Encode4(37135), // Rule ID 1242 //
     /*  37095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  37103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  37106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  37109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37117 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3799:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm)  =>  (VPADDLsv8i8:{ *:[v4i16] } DPR:{ *:[v8i8] }:$Vm)
     /*  37117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv8i8),
     /*  37120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37127 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37133 */     GIR_RootConstrainSelectedInstOperands,
     /*  37134 */     // GIR_Coverage, 1242,
     /*  37134 */     GIR_EraseRootFromParent_Done,
     /*  37135 */   // Label 843: @37135
     /*  37135 */   GIM_Try, /*On fail goto*//*Label 844*/ GIMT_Encode4(37180), // Rule ID 1243 //
     /*  37140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  37148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  37151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  37154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37162 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3799:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VPADDLsv4i16:{ *:[v2i32] } DPR:{ *:[v4i16] }:$Vm)
     /*  37162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv4i16),
     /*  37165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37172 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37178 */     GIR_RootConstrainSelectedInstOperands,
     /*  37179 */     // GIR_Coverage, 1243,
     /*  37179 */     GIR_EraseRootFromParent_Done,
     /*  37180 */   // Label 844: @37180
     /*  37180 */   GIM_Try, /*On fail goto*//*Label 845*/ GIMT_Encode4(37225), // Rule ID 1244 //
     /*  37185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  37193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  37196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37207 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3799:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VPADDLsv2i32:{ *:[v1i64] } DPR:{ *:[v2i32] }:$Vm)
     /*  37207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv2i32),
     /*  37210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37217 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37223 */     GIR_RootConstrainSelectedInstOperands,
     /*  37224 */     // GIR_Coverage, 1244,
     /*  37224 */     GIR_EraseRootFromParent_Done,
     /*  37225 */   // Label 845: @37225
     /*  37225 */   GIM_Try, /*On fail goto*//*Label 846*/ GIMT_Encode4(37270), // Rule ID 1245 //
     /*  37230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  37238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  37241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  37244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37252 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3799:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (VPADDLsv16i8:{ *:[v8i16] } QPR:{ *:[v16i8] }:$Vm)
     /*  37252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv16i8),
     /*  37255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37262 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37268 */     GIR_RootConstrainSelectedInstOperands,
     /*  37269 */     // GIR_Coverage, 1245,
     /*  37269 */     GIR_EraseRootFromParent_Done,
     /*  37270 */   // Label 846: @37270
     /*  37270 */   GIM_Try, /*On fail goto*//*Label 847*/ GIMT_Encode4(37315), // Rule ID 1246 //
     /*  37275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  37283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  37286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  37289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37297 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3799:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VPADDLsv8i16:{ *:[v4i32] } QPR:{ *:[v8i16] }:$Vm)
     /*  37297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv8i16),
     /*  37300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37307 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37313 */     GIR_RootConstrainSelectedInstOperands,
     /*  37314 */     // GIR_Coverage, 1246,
     /*  37314 */     GIR_EraseRootFromParent_Done,
     /*  37315 */   // Label 847: @37315
     /*  37315 */   GIM_Try, /*On fail goto*//*Label 848*/ GIMT_Encode4(37360), // Rule ID 1247 //
     /*  37320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  37328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  37331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37342 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3799:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VPADDLsv4i32:{ *:[v2i64] } QPR:{ *:[v4i32] }:$Vm)
     /*  37342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv4i32),
     /*  37345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37352 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37358 */     GIR_RootConstrainSelectedInstOperands,
     /*  37359 */     // GIR_Coverage, 1247,
     /*  37359 */     GIR_EraseRootFromParent_Done,
     /*  37360 */   // Label 848: @37360
     /*  37360 */   GIM_Try, /*On fail goto*//*Label 849*/ GIMT_Encode4(37405), // Rule ID 1248 //
     /*  37365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  37376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  37379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37387 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3800:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm)  =>  (VPADDLuv8i8:{ *:[v4i16] } DPR:{ *:[v8i8] }:$Vm)
     /*  37387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv8i8),
     /*  37390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37397 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37403 */     GIR_RootConstrainSelectedInstOperands,
     /*  37404 */     // GIR_Coverage, 1248,
     /*  37404 */     GIR_EraseRootFromParent_Done,
     /*  37405 */   // Label 849: @37405
     /*  37405 */   GIM_Try, /*On fail goto*//*Label 850*/ GIMT_Encode4(37450), // Rule ID 1249 //
     /*  37410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  37421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  37424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37432 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3800:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VPADDLuv4i16:{ *:[v2i32] } DPR:{ *:[v4i16] }:$Vm)
     /*  37432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv4i16),
     /*  37435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37442 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37448 */     GIR_RootConstrainSelectedInstOperands,
     /*  37449 */     // GIR_Coverage, 1249,
     /*  37449 */     GIR_EraseRootFromParent_Done,
     /*  37450 */   // Label 850: @37450
     /*  37450 */   GIM_Try, /*On fail goto*//*Label 851*/ GIMT_Encode4(37495), // Rule ID 1250 //
     /*  37455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  37466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37477 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3800:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VPADDLuv2i32:{ *:[v1i64] } DPR:{ *:[v2i32] }:$Vm)
     /*  37477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv2i32),
     /*  37480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37487 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37493 */     GIR_RootConstrainSelectedInstOperands,
     /*  37494 */     // GIR_Coverage, 1250,
     /*  37494 */     GIR_EraseRootFromParent_Done,
     /*  37495 */   // Label 851: @37495
     /*  37495 */   GIM_Try, /*On fail goto*//*Label 852*/ GIMT_Encode4(37540), // Rule ID 1251 //
     /*  37500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  37511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  37514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37522 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3800:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (VPADDLuv16i8:{ *:[v8i16] } QPR:{ *:[v16i8] }:$Vm)
     /*  37522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv16i8),
     /*  37525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37532 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37538 */     GIR_RootConstrainSelectedInstOperands,
     /*  37539 */     // GIR_Coverage, 1251,
     /*  37539 */     GIR_EraseRootFromParent_Done,
     /*  37540 */   // Label 852: @37540
     /*  37540 */   GIM_Try, /*On fail goto*//*Label 853*/ GIMT_Encode4(37585), // Rule ID 1252 //
     /*  37545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  37556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  37559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37567 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3800:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VPADDLuv8i16:{ *:[v4i32] } QPR:{ *:[v8i16] }:$Vm)
     /*  37567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv8i16),
     /*  37570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37577 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37583 */     GIR_RootConstrainSelectedInstOperands,
     /*  37584 */     // GIR_Coverage, 1252,
     /*  37584 */     GIR_EraseRootFromParent_Done,
     /*  37585 */   // Label 853: @37585
     /*  37585 */   GIM_Try, /*On fail goto*//*Label 854*/ GIMT_Encode4(37630), // Rule ID 1253 //
     /*  37590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  37601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37612 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3800:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VPADDLuv4i32:{ *:[v2i64] } QPR:{ *:[v4i32] }:$Vm)
     /*  37612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv4i32),
     /*  37615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37622 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37628 */     GIR_RootConstrainSelectedInstOperands,
     /*  37629 */     // GIR_Coverage, 1253,
     /*  37629 */     GIR_EraseRootFromParent_Done,
     /*  37630 */   // Label 854: @37630
     /*  37630 */   GIM_Try, /*On fail goto*//*Label 855*/ GIMT_Encode4(37675), // Rule ID 1282 //
     /*  37635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  37646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37657 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3827:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VRECPEd:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /*  37657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEd),
     /*  37660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37667 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37673 */     GIR_RootConstrainSelectedInstOperands,
     /*  37674 */     // GIR_Coverage, 1282,
     /*  37674 */     GIR_EraseRootFromParent_Done,
     /*  37675 */   // Label 855: @37675
     /*  37675 */   GIM_Try, /*On fail goto*//*Label 856*/ GIMT_Encode4(37720), // Rule ID 1283 //
     /*  37680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  37691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37702 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3827:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VRECPEq:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /*  37702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEq),
     /*  37705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37712 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37718 */     GIR_RootConstrainSelectedInstOperands,
     /*  37719 */     // GIR_Coverage, 1283,
     /*  37719 */     GIR_EraseRootFromParent_Done,
     /*  37720 */   // Label 856: @37720
     /*  37720 */   GIM_Try, /*On fail goto*//*Label 857*/ GIMT_Encode4(37765), // Rule ID 1284 //
     /*  37725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  37736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37747 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3827:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRECPEfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  37747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEfd),
     /*  37750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37757 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37763 */     GIR_RootConstrainSelectedInstOperands,
     /*  37764 */     // GIR_Coverage, 1284,
     /*  37764 */     GIR_EraseRootFromParent_Done,
     /*  37765 */   // Label 857: @37765
     /*  37765 */   GIM_Try, /*On fail goto*//*Label 858*/ GIMT_Encode4(37810), // Rule ID 1285 //
     /*  37770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  37781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37792 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3827:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRECPEfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  37792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEfq),
     /*  37795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37802 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37808 */     GIR_RootConstrainSelectedInstOperands,
     /*  37809 */     // GIR_Coverage, 1285,
     /*  37809 */     GIR_EraseRootFromParent_Done,
     /*  37810 */   // Label 858: @37810
     /*  37810 */   GIM_Try, /*On fail goto*//*Label 859*/ GIMT_Encode4(37855), // Rule ID 1286 //
     /*  37815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  37818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  37826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  37829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37837 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3827:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRECPEhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  37837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEhd),
     /*  37840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37842 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37847 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37853 */     GIR_RootConstrainSelectedInstOperands,
     /*  37854 */     // GIR_Coverage, 1286,
     /*  37854 */     GIR_EraseRootFromParent_Done,
     /*  37855 */   // Label 859: @37855
     /*  37855 */   GIM_Try, /*On fail goto*//*Label 860*/ GIMT_Encode4(37900), // Rule ID 1287 //
     /*  37860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  37863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  37871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  37874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37882 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3827:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRECPEhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  37882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEhq),
     /*  37885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37892 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37898 */     GIR_RootConstrainSelectedInstOperands,
     /*  37899 */     // GIR_Coverage, 1287,
     /*  37899 */     GIR_EraseRootFromParent_Done,
     /*  37900 */   // Label 860: @37900
     /*  37900 */   GIM_Try, /*On fail goto*//*Label 861*/ GIMT_Encode4(37945), // Rule ID 1292 //
     /*  37905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  37913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  37916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37927 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3838:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VRSQRTEd:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /*  37927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEd),
     /*  37930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37937 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37943 */     GIR_RootConstrainSelectedInstOperands,
     /*  37944 */     // GIR_Coverage, 1292,
     /*  37944 */     GIR_EraseRootFromParent_Done,
     /*  37945 */   // Label 861: @37945
     /*  37945 */   GIM_Try, /*On fail goto*//*Label 862*/ GIMT_Encode4(37990), // Rule ID 1293 //
     /*  37950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  37958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  37961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37972 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3838:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VRSQRTEq:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /*  37972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEq),
     /*  37975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37982 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37988 */     GIR_RootConstrainSelectedInstOperands,
     /*  37989 */     // GIR_Coverage, 1293,
     /*  37989 */     GIR_EraseRootFromParent_Done,
     /*  37990 */   // Label 862: @37990
     /*  37990 */   GIM_Try, /*On fail goto*//*Label 863*/ GIMT_Encode4(38035), // Rule ID 1294 //
     /*  37995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  38003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  38006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  38009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38017 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3838:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRSQRTEfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  38017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEfd),
     /*  38020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38027 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38033 */     GIR_RootConstrainSelectedInstOperands,
     /*  38034 */     // GIR_Coverage, 1294,
     /*  38034 */     GIR_EraseRootFromParent_Done,
     /*  38035 */   // Label 863: @38035
     /*  38035 */   GIM_Try, /*On fail goto*//*Label 864*/ GIMT_Encode4(38080), // Rule ID 1295 //
     /*  38040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  38048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  38051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38062 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3838:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRSQRTEfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  38062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEfq),
     /*  38065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38072 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38078 */     GIR_RootConstrainSelectedInstOperands,
     /*  38079 */     // GIR_Coverage, 1295,
     /*  38079 */     GIR_EraseRootFromParent_Done,
     /*  38080 */   // Label 864: @38080
     /*  38080 */   GIM_Try, /*On fail goto*//*Label 865*/ GIMT_Encode4(38125), // Rule ID 1296 //
     /*  38085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  38088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  38093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  38096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  38099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38107 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3838:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRSQRTEhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  38107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEhd),
     /*  38110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38117 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38123 */     GIR_RootConstrainSelectedInstOperands,
     /*  38124 */     // GIR_Coverage, 1296,
     /*  38124 */     GIR_EraseRootFromParent_Done,
     /*  38125 */   // Label 865: @38125
     /*  38125 */   GIM_Try, /*On fail goto*//*Label 866*/ GIMT_Encode4(38170), // Rule ID 1297 //
     /*  38130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  38133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  38138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  38141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  38144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38152 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3838:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRSQRTEhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  38152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEhq),
     /*  38155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38162 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38168 */     GIR_RootConstrainSelectedInstOperands,
     /*  38169 */     // GIR_Coverage, 1297,
     /*  38169 */     GIR_EraseRootFromParent_Done,
     /*  38170 */   // Label 866: @38170
     /*  38170 */   GIM_Try, /*On fail goto*//*Label 867*/ GIMT_Encode4(38215), // Rule ID 1518 //
     /*  38175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  38183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  38186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  38189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38197 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3805:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm)  =>  (VQABSv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /*  38197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv8i8),
     /*  38200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38207 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38213 */     GIR_RootConstrainSelectedInstOperands,
     /*  38214 */     // GIR_Coverage, 1518,
     /*  38214 */     GIR_EraseRootFromParent_Done,
     /*  38215 */   // Label 867: @38215
     /*  38215 */   GIM_Try, /*On fail goto*//*Label 868*/ GIMT_Encode4(38260), // Rule ID 1519 //
     /*  38220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  38228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  38231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  38234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38242 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3805:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VQABSv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)
     /*  38242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv4i16),
     /*  38245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38252 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38258 */     GIR_RootConstrainSelectedInstOperands,
     /*  38259 */     // GIR_Coverage, 1519,
     /*  38259 */     GIR_EraseRootFromParent_Done,
     /*  38260 */   // Label 868: @38260
     /*  38260 */   GIM_Try, /*On fail goto*//*Label 869*/ GIMT_Encode4(38305), // Rule ID 1520 //
     /*  38265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  38273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  38276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  38279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38287 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3805:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VQABSv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /*  38287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv2i32),
     /*  38290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38297 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38303 */     GIR_RootConstrainSelectedInstOperands,
     /*  38304 */     // GIR_Coverage, 1520,
     /*  38304 */     GIR_EraseRootFromParent_Done,
     /*  38305 */   // Label 869: @38305
     /*  38305 */   GIM_Try, /*On fail goto*//*Label 870*/ GIMT_Encode4(38350), // Rule ID 1521 //
     /*  38310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  38318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  38321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  38324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38332 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3805:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (VQABSv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /*  38332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv16i8),
     /*  38335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38342 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38348 */     GIR_RootConstrainSelectedInstOperands,
     /*  38349 */     // GIR_Coverage, 1521,
     /*  38349 */     GIR_EraseRootFromParent_Done,
     /*  38350 */   // Label 870: @38350
     /*  38350 */   GIM_Try, /*On fail goto*//*Label 871*/ GIMT_Encode4(38395), // Rule ID 1522 //
     /*  38355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  38363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  38366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  38369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38377 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3805:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VQABSv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)
     /*  38377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv8i16),
     /*  38380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38387 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38393 */     GIR_RootConstrainSelectedInstOperands,
     /*  38394 */     // GIR_Coverage, 1522,
     /*  38394 */     GIR_EraseRootFromParent_Done,
     /*  38395 */   // Label 871: @38395
     /*  38395 */   GIM_Try, /*On fail goto*//*Label 872*/ GIMT_Encode4(38440), // Rule ID 1523 //
     /*  38400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  38408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  38411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38422 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3805:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VQABSv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /*  38422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv4i32),
     /*  38425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38432 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38438 */     GIR_RootConstrainSelectedInstOperands,
     /*  38439 */     // GIR_Coverage, 1523,
     /*  38439 */     GIR_EraseRootFromParent_Done,
     /*  38440 */   // Label 872: @38440
     /*  38440 */   GIM_Try, /*On fail goto*//*Label 873*/ GIMT_Encode4(38485), // Rule ID 1534 //
     /*  38445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  38456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  38459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38467 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3811:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm)  =>  (VQNEGv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /*  38467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv8i8),
     /*  38470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38477 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38483 */     GIR_RootConstrainSelectedInstOperands,
     /*  38484 */     // GIR_Coverage, 1534,
     /*  38484 */     GIR_EraseRootFromParent_Done,
     /*  38485 */   // Label 873: @38485
     /*  38485 */   GIM_Try, /*On fail goto*//*Label 874*/ GIMT_Encode4(38530), // Rule ID 1535 //
     /*  38490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  38501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  38504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38512 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3811:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VQNEGv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)
     /*  38512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv4i16),
     /*  38515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38522 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38528 */     GIR_RootConstrainSelectedInstOperands,
     /*  38529 */     // GIR_Coverage, 1535,
     /*  38529 */     GIR_EraseRootFromParent_Done,
     /*  38530 */   // Label 874: @38530
     /*  38530 */   GIM_Try, /*On fail goto*//*Label 875*/ GIMT_Encode4(38575), // Rule ID 1536 //
     /*  38535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  38546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  38549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38557 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3811:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VQNEGv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /*  38557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv2i32),
     /*  38560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38567 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38573 */     GIR_RootConstrainSelectedInstOperands,
     /*  38574 */     // GIR_Coverage, 1536,
     /*  38574 */     GIR_EraseRootFromParent_Done,
     /*  38575 */   // Label 875: @38575
     /*  38575 */   GIM_Try, /*On fail goto*//*Label 876*/ GIMT_Encode4(38620), // Rule ID 1537 //
     /*  38580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  38591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  38594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38602 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3811:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (VQNEGv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /*  38602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv16i8),
     /*  38605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38607 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38612 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38618 */     GIR_RootConstrainSelectedInstOperands,
     /*  38619 */     // GIR_Coverage, 1537,
     /*  38619 */     GIR_EraseRootFromParent_Done,
     /*  38620 */   // Label 876: @38620
     /*  38620 */   GIM_Try, /*On fail goto*//*Label 877*/ GIMT_Encode4(38665), // Rule ID 1538 //
     /*  38625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  38636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  38639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38647 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3811:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VQNEGv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)
     /*  38647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv8i16),
     /*  38650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38657 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38663 */     GIR_RootConstrainSelectedInstOperands,
     /*  38664 */     // GIR_Coverage, 1538,
     /*  38664 */     GIR_EraseRootFromParent_Done,
     /*  38665 */   // Label 877: @38665
     /*  38665 */   GIM_Try, /*On fail goto*//*Label 878*/ GIMT_Encode4(38710), // Rule ID 1539 //
     /*  38670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  38681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38692 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3811:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VQNEGv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /*  38692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv4i32),
     /*  38695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38702 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38708 */     GIR_RootConstrainSelectedInstOperands,
     /*  38709 */     // GIR_Coverage, 1539,
     /*  38709 */     GIR_EraseRootFromParent_Done,
     /*  38710 */   // Label 878: @38710
     /*  38710 */   GIM_Try, /*On fail goto*//*Label 879*/ GIMT_Encode4(38755), // Rule ID 1540 //
     /*  38715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  38723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  38726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  38729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38737 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3752:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm)  =>  (VCLSv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /*  38737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv8i8),
     /*  38740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38747 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38753 */     GIR_RootConstrainSelectedInstOperands,
     /*  38754 */     // GIR_Coverage, 1540,
     /*  38754 */     GIR_EraseRootFromParent_Done,
     /*  38755 */   // Label 879: @38755
     /*  38755 */   GIM_Try, /*On fail goto*//*Label 880*/ GIMT_Encode4(38800), // Rule ID 1541 //
     /*  38760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  38768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  38771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  38774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38782 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3752:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VCLSv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)
     /*  38782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv4i16),
     /*  38785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38792 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38798 */     GIR_RootConstrainSelectedInstOperands,
     /*  38799 */     // GIR_Coverage, 1541,
     /*  38799 */     GIR_EraseRootFromParent_Done,
     /*  38800 */   // Label 880: @38800
     /*  38800 */   GIM_Try, /*On fail goto*//*Label 881*/ GIMT_Encode4(38845), // Rule ID 1542 //
     /*  38805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  38813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  38816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  38819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38827 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3752:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VCLSv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /*  38827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv2i32),
     /*  38830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38837 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38843 */     GIR_RootConstrainSelectedInstOperands,
     /*  38844 */     // GIR_Coverage, 1542,
     /*  38844 */     GIR_EraseRootFromParent_Done,
     /*  38845 */   // Label 881: @38845
     /*  38845 */   GIM_Try, /*On fail goto*//*Label 882*/ GIMT_Encode4(38890), // Rule ID 1543 //
     /*  38850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  38858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  38861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  38864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38872 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3752:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (VCLSv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /*  38872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv16i8),
     /*  38875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38882 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38888 */     GIR_RootConstrainSelectedInstOperands,
     /*  38889 */     // GIR_Coverage, 1543,
     /*  38889 */     GIR_EraseRootFromParent_Done,
     /*  38890 */   // Label 882: @38890
     /*  38890 */   GIM_Try, /*On fail goto*//*Label 883*/ GIMT_Encode4(38935), // Rule ID 1544 //
     /*  38895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  38903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  38906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  38909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38917 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3752:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VCLSv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)
     /*  38917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv8i16),
     /*  38920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38927 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38933 */     GIR_RootConstrainSelectedInstOperands,
     /*  38934 */     // GIR_Coverage, 1544,
     /*  38934 */     GIR_EraseRootFromParent_Done,
     /*  38935 */   // Label 883: @38935
     /*  38935 */   GIM_Try, /*On fail goto*//*Label 884*/ GIMT_Encode4(38980), // Rule ID 1545 //
     /*  38940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  38948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  38951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38962 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3752:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VCLSv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /*  38962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv4i32),
     /*  38965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38972 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38978 */     GIR_RootConstrainSelectedInstOperands,
     /*  38979 */     // GIR_Coverage, 1545,
     /*  38979 */     GIR_EraseRootFromParent_Done,
     /*  38980 */   // Label 884: @38980
     /*  38980 */   GIM_Try, /*On fail goto*//*Label 885*/ GIMT_Encode4(39025), // Rule ID 1589 //
     /*  38985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovns),
     /*  38993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  38996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  38999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39007 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3808:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VQMOVNsv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vm)
     /*  39007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsv8i8),
     /*  39010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39017 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39023 */     GIR_RootConstrainSelectedInstOperands,
     /*  39024 */     // GIR_Coverage, 1589,
     /*  39024 */     GIR_EraseRootFromParent_Done,
     /*  39025 */   // Label 885: @39025
     /*  39025 */   GIM_Try, /*On fail goto*//*Label 886*/ GIMT_Encode4(39070), // Rule ID 1590 //
     /*  39030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovns),
     /*  39038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39052 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3808:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VQMOVNsv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vm)
     /*  39052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsv4i16),
     /*  39055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39062 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39068 */     GIR_RootConstrainSelectedInstOperands,
     /*  39069 */     // GIR_Coverage, 1590,
     /*  39069 */     GIR_EraseRootFromParent_Done,
     /*  39070 */   // Label 886: @39070
     /*  39070 */   GIM_Try, /*On fail goto*//*Label 887*/ GIMT_Encode4(39115), // Rule ID 1591 //
     /*  39075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovns),
     /*  39083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  39089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39097 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3808:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm)  =>  (VQMOVNsv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vm)
     /*  39097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsv2i32),
     /*  39100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39102 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39107 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39113 */     GIR_RootConstrainSelectedInstOperands,
     /*  39114 */     // GIR_Coverage, 1591,
     /*  39114 */     GIR_EraseRootFromParent_Done,
     /*  39115 */   // Label 887: @39115
     /*  39115 */   GIM_Try, /*On fail goto*//*Label 888*/ GIMT_Encode4(39160), // Rule ID 1592 //
     /*  39120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnu),
     /*  39128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  39131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39142 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3810:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VQMOVNuv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vm)
     /*  39142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNuv8i8),
     /*  39145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39152 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39158 */     GIR_RootConstrainSelectedInstOperands,
     /*  39159 */     // GIR_Coverage, 1592,
     /*  39159 */     GIR_EraseRootFromParent_Done,
     /*  39160 */   // Label 888: @39160
     /*  39160 */   GIM_Try, /*On fail goto*//*Label 889*/ GIMT_Encode4(39205), // Rule ID 1593 //
     /*  39165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnu),
     /*  39173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39187 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3810:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VQMOVNuv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vm)
     /*  39187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNuv4i16),
     /*  39190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39197 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39203 */     GIR_RootConstrainSelectedInstOperands,
     /*  39204 */     // GIR_Coverage, 1593,
     /*  39204 */     GIR_EraseRootFromParent_Done,
     /*  39205 */   // Label 889: @39205
     /*  39205 */   GIM_Try, /*On fail goto*//*Label 890*/ GIMT_Encode4(39250), // Rule ID 1594 //
     /*  39210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnu),
     /*  39218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  39224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39232 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3810:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm)  =>  (VQMOVNuv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vm)
     /*  39232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNuv2i32),
     /*  39235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39242 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39248 */     GIR_RootConstrainSelectedInstOperands,
     /*  39249 */     // GIR_Coverage, 1594,
     /*  39249 */     GIR_EraseRootFromParent_Done,
     /*  39250 */   // Label 890: @39250
     /*  39250 */   GIM_Try, /*On fail goto*//*Label 891*/ GIMT_Encode4(39295), // Rule ID 1595 //
     /*  39255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnsu),
     /*  39263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  39266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39277 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3809:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VQMOVNsuv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vm)
     /*  39277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsuv8i8),
     /*  39280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39287 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39293 */     GIR_RootConstrainSelectedInstOperands,
     /*  39294 */     // GIR_Coverage, 1595,
     /*  39294 */     GIR_EraseRootFromParent_Done,
     /*  39295 */   // Label 891: @39295
     /*  39295 */   GIM_Try, /*On fail goto*//*Label 892*/ GIMT_Encode4(39340), // Rule ID 1596 //
     /*  39300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnsu),
     /*  39308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39322 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3809:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VQMOVNsuv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vm)
     /*  39322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsuv4i16),
     /*  39325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39332 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39338 */     GIR_RootConstrainSelectedInstOperands,
     /*  39339 */     // GIR_Coverage, 1596,
     /*  39339 */     GIR_EraseRootFromParent_Done,
     /*  39340 */   // Label 892: @39340
     /*  39340 */   GIM_Try, /*On fail goto*//*Label 893*/ GIMT_Encode4(39385), // Rule ID 1597 //
     /*  39345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnsu),
     /*  39353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  39359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39367 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3809:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm)  =>  (VQMOVNsuv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vm)
     /*  39367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsuv2i32),
     /*  39370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39377 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39383 */     GIR_RootConstrainSelectedInstOperands,
     /*  39384 */     // GIR_Coverage, 1597,
     /*  39384 */     GIR_EraseRootFromParent_Done,
     /*  39385 */   // Label 893: @39385
     /*  39385 */   GIM_Try, /*On fail goto*//*Label 894*/ GIMT_Encode4(39421), // Rule ID 1620 //
     /*  39390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtas),
     /*  39398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39412 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3753:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTANSDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANSDf),
     /*  39415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39419 */     GIR_RootConstrainSelectedInstOperands,
     /*  39420 */     // GIR_Coverage, 1620,
     /*  39420 */     GIR_EraseRootFromParent_Done,
     /*  39421 */   // Label 894: @39421
     /*  39421 */   GIM_Try, /*On fail goto*//*Label 895*/ GIMT_Encode4(39457), // Rule ID 1621 //
     /*  39426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtas),
     /*  39434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39448 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3753:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTANSQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  39448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANSQf),
     /*  39451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39455 */     GIR_RootConstrainSelectedInstOperands,
     /*  39456 */     // GIR_Coverage, 1621,
     /*  39456 */     GIR_EraseRootFromParent_Done,
     /*  39457 */   // Label 895: @39457
     /*  39457 */   GIM_Try, /*On fail goto*//*Label 896*/ GIMT_Encode4(39493), // Rule ID 1622 //
     /*  39462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtau),
     /*  39470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39484 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3754:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTANUDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANUDf),
     /*  39487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39491 */     GIR_RootConstrainSelectedInstOperands,
     /*  39492 */     // GIR_Coverage, 1622,
     /*  39492 */     GIR_EraseRootFromParent_Done,
     /*  39493 */   // Label 896: @39493
     /*  39493 */   GIM_Try, /*On fail goto*//*Label 897*/ GIMT_Encode4(39529), // Rule ID 1623 //
     /*  39498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtau),
     /*  39506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39520 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3754:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTANUQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  39520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANUQf),
     /*  39523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39525 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39527 */     GIR_RootConstrainSelectedInstOperands,
     /*  39528 */     // GIR_Coverage, 1623,
     /*  39528 */     GIR_EraseRootFromParent_Done,
     /*  39529 */   // Label 897: @39529
     /*  39529 */   GIM_Try, /*On fail goto*//*Label 898*/ GIMT_Encode4(39565), // Rule ID 1624 //
     /*  39534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtas),
     /*  39542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  39548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39556 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3753:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTANSDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  39556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANSDh),
     /*  39559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39563 */     GIR_RootConstrainSelectedInstOperands,
     /*  39564 */     // GIR_Coverage, 1624,
     /*  39564 */     GIR_EraseRootFromParent_Done,
     /*  39565 */   // Label 898: @39565
     /*  39565 */   GIM_Try, /*On fail goto*//*Label 899*/ GIMT_Encode4(39601), // Rule ID 1625 //
     /*  39570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtas),
     /*  39578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  39581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39592 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3753:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTANSQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  39592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANSQh),
     /*  39595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39599 */     GIR_RootConstrainSelectedInstOperands,
     /*  39600 */     // GIR_Coverage, 1625,
     /*  39600 */     GIR_EraseRootFromParent_Done,
     /*  39601 */   // Label 899: @39601
     /*  39601 */   GIM_Try, /*On fail goto*//*Label 900*/ GIMT_Encode4(39637), // Rule ID 1626 //
     /*  39606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtau),
     /*  39614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  39620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39628 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3754:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTANUDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  39628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANUDh),
     /*  39631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39635 */     GIR_RootConstrainSelectedInstOperands,
     /*  39636 */     // GIR_Coverage, 1626,
     /*  39636 */     GIR_EraseRootFromParent_Done,
     /*  39637 */   // Label 900: @39637
     /*  39637 */   GIM_Try, /*On fail goto*//*Label 901*/ GIMT_Encode4(39673), // Rule ID 1627 //
     /*  39642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtau),
     /*  39650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  39653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39664 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3754:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTANUQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  39664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANUQh),
     /*  39667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39671 */     GIR_RootConstrainSelectedInstOperands,
     /*  39672 */     // GIR_Coverage, 1627,
     /*  39672 */     GIR_EraseRootFromParent_Done,
     /*  39673 */   // Label 901: @39673
     /*  39673 */   GIM_Try, /*On fail goto*//*Label 902*/ GIMT_Encode4(39709), // Rule ID 1628 //
     /*  39678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtns),
     /*  39686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39700 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3765:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTNNSDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNSDf),
     /*  39703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39707 */     GIR_RootConstrainSelectedInstOperands,
     /*  39708 */     // GIR_Coverage, 1628,
     /*  39708 */     GIR_EraseRootFromParent_Done,
     /*  39709 */   // Label 902: @39709
     /*  39709 */   GIM_Try, /*On fail goto*//*Label 903*/ GIMT_Encode4(39745), // Rule ID 1629 //
     /*  39714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtns),
     /*  39722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39736 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3765:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTNNSQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  39736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNSQf),
     /*  39739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39743 */     GIR_RootConstrainSelectedInstOperands,
     /*  39744 */     // GIR_Coverage, 1629,
     /*  39744 */     GIR_EraseRootFromParent_Done,
     /*  39745 */   // Label 903: @39745
     /*  39745 */   GIM_Try, /*On fail goto*//*Label 904*/ GIMT_Encode4(39781), // Rule ID 1630 //
     /*  39750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtnu),
     /*  39758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39772 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3766:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTNNUDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNUDf),
     /*  39775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39779 */     GIR_RootConstrainSelectedInstOperands,
     /*  39780 */     // GIR_Coverage, 1630,
     /*  39780 */     GIR_EraseRootFromParent_Done,
     /*  39781 */   // Label 904: @39781
     /*  39781 */   GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(39817), // Rule ID 1631 //
     /*  39786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtnu),
     /*  39794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39808 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3766:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTNNUQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  39808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNUQf),
     /*  39811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39815 */     GIR_RootConstrainSelectedInstOperands,
     /*  39816 */     // GIR_Coverage, 1631,
     /*  39816 */     GIR_EraseRootFromParent_Done,
     /*  39817 */   // Label 905: @39817
     /*  39817 */   GIM_Try, /*On fail goto*//*Label 906*/ GIMT_Encode4(39853), // Rule ID 1632 //
     /*  39822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtns),
     /*  39830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  39836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39844 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3765:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTNNSDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  39844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNSDh),
     /*  39847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39851 */     GIR_RootConstrainSelectedInstOperands,
     /*  39852 */     // GIR_Coverage, 1632,
     /*  39852 */     GIR_EraseRootFromParent_Done,
     /*  39853 */   // Label 906: @39853
     /*  39853 */   GIM_Try, /*On fail goto*//*Label 907*/ GIMT_Encode4(39889), // Rule ID 1633 //
     /*  39858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtns),
     /*  39866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  39869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39880 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3765:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTNNSQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  39880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNSQh),
     /*  39883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39887 */     GIR_RootConstrainSelectedInstOperands,
     /*  39888 */     // GIR_Coverage, 1633,
     /*  39888 */     GIR_EraseRootFromParent_Done,
     /*  39889 */   // Label 907: @39889
     /*  39889 */   GIM_Try, /*On fail goto*//*Label 908*/ GIMT_Encode4(39925), // Rule ID 1634 //
     /*  39894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtnu),
     /*  39902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  39908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39916 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3766:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTNNUDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  39916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNUDh),
     /*  39919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39923 */     GIR_RootConstrainSelectedInstOperands,
     /*  39924 */     // GIR_Coverage, 1634,
     /*  39924 */     GIR_EraseRootFromParent_Done,
     /*  39925 */   // Label 908: @39925
     /*  39925 */   GIM_Try, /*On fail goto*//*Label 909*/ GIMT_Encode4(39961), // Rule ID 1635 //
     /*  39930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtnu),
     /*  39938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  39941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39952 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3766:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTNNUQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  39952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNUQh),
     /*  39955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39959 */     GIR_RootConstrainSelectedInstOperands,
     /*  39960 */     // GIR_Coverage, 1635,
     /*  39960 */     GIR_EraseRootFromParent_Done,
     /*  39961 */   // Label 909: @39961
     /*  39961 */   GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(39997), // Rule ID 1636 //
     /*  39966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtps),
     /*  39974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39988 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3767:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTPNSDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNSDf),
     /*  39991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39995 */     GIR_RootConstrainSelectedInstOperands,
     /*  39996 */     // GIR_Coverage, 1636,
     /*  39996 */     GIR_EraseRootFromParent_Done,
     /*  39997 */   // Label 910: @39997
     /*  39997 */   GIM_Try, /*On fail goto*//*Label 911*/ GIMT_Encode4(40033), // Rule ID 1637 //
     /*  40002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtps),
     /*  40010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40024 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3767:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTPNSQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNSQf),
     /*  40027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40031 */     GIR_RootConstrainSelectedInstOperands,
     /*  40032 */     // GIR_Coverage, 1637,
     /*  40032 */     GIR_EraseRootFromParent_Done,
     /*  40033 */   // Label 911: @40033
     /*  40033 */   GIM_Try, /*On fail goto*//*Label 912*/ GIMT_Encode4(40069), // Rule ID 1638 //
     /*  40038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtpu),
     /*  40046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40060 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3768:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTPNUDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNUDf),
     /*  40063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40067 */     GIR_RootConstrainSelectedInstOperands,
     /*  40068 */     // GIR_Coverage, 1638,
     /*  40068 */     GIR_EraseRootFromParent_Done,
     /*  40069 */   // Label 912: @40069
     /*  40069 */   GIM_Try, /*On fail goto*//*Label 913*/ GIMT_Encode4(40105), // Rule ID 1639 //
     /*  40074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtpu),
     /*  40082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40096 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3768:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTPNUQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNUQf),
     /*  40099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40103 */     GIR_RootConstrainSelectedInstOperands,
     /*  40104 */     // GIR_Coverage, 1639,
     /*  40104 */     GIR_EraseRootFromParent_Done,
     /*  40105 */   // Label 913: @40105
     /*  40105 */   GIM_Try, /*On fail goto*//*Label 914*/ GIMT_Encode4(40141), // Rule ID 1640 //
     /*  40110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtps),
     /*  40118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40132 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3767:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTPNSDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNSDh),
     /*  40135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40139 */     GIR_RootConstrainSelectedInstOperands,
     /*  40140 */     // GIR_Coverage, 1640,
     /*  40140 */     GIR_EraseRootFromParent_Done,
     /*  40141 */   // Label 914: @40141
     /*  40141 */   GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(40177), // Rule ID 1641 //
     /*  40146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtps),
     /*  40154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40168 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3767:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTPNSQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNSQh),
     /*  40171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40175 */     GIR_RootConstrainSelectedInstOperands,
     /*  40176 */     // GIR_Coverage, 1641,
     /*  40176 */     GIR_EraseRootFromParent_Done,
     /*  40177 */   // Label 915: @40177
     /*  40177 */   GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(40213), // Rule ID 1642 //
     /*  40182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtpu),
     /*  40190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40204 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3768:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTPNUDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNUDh),
     /*  40207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40211 */     GIR_RootConstrainSelectedInstOperands,
     /*  40212 */     // GIR_Coverage, 1642,
     /*  40212 */     GIR_EraseRootFromParent_Done,
     /*  40213 */   // Label 916: @40213
     /*  40213 */   GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(40249), // Rule ID 1643 //
     /*  40218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtpu),
     /*  40226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40240 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3768:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTPNUQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNUQh),
     /*  40243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40247 */     GIR_RootConstrainSelectedInstOperands,
     /*  40248 */     // GIR_Coverage, 1643,
     /*  40248 */     GIR_EraseRootFromParent_Done,
     /*  40249 */   // Label 917: @40249
     /*  40249 */   GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(40285), // Rule ID 1644 //
     /*  40254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtms),
     /*  40262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40276 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3763:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTMNSDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNSDf),
     /*  40279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40283 */     GIR_RootConstrainSelectedInstOperands,
     /*  40284 */     // GIR_Coverage, 1644,
     /*  40284 */     GIR_EraseRootFromParent_Done,
     /*  40285 */   // Label 918: @40285
     /*  40285 */   GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(40321), // Rule ID 1645 //
     /*  40290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtms),
     /*  40298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40312 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3763:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTMNSQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNSQf),
     /*  40315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40319 */     GIR_RootConstrainSelectedInstOperands,
     /*  40320 */     // GIR_Coverage, 1645,
     /*  40320 */     GIR_EraseRootFromParent_Done,
     /*  40321 */   // Label 919: @40321
     /*  40321 */   GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(40357), // Rule ID 1646 //
     /*  40326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtmu),
     /*  40334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40348 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3764:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTMNUDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNUDf),
     /*  40351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40355 */     GIR_RootConstrainSelectedInstOperands,
     /*  40356 */     // GIR_Coverage, 1646,
     /*  40356 */     GIR_EraseRootFromParent_Done,
     /*  40357 */   // Label 920: @40357
     /*  40357 */   GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(40393), // Rule ID 1647 //
     /*  40362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtmu),
     /*  40370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40384 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3764:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTMNUQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNUQf),
     /*  40387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40391 */     GIR_RootConstrainSelectedInstOperands,
     /*  40392 */     // GIR_Coverage, 1647,
     /*  40392 */     GIR_EraseRootFromParent_Done,
     /*  40393 */   // Label 921: @40393
     /*  40393 */   GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(40429), // Rule ID 1648 //
     /*  40398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtms),
     /*  40406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40420 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3763:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTMNSDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNSDh),
     /*  40423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40427 */     GIR_RootConstrainSelectedInstOperands,
     /*  40428 */     // GIR_Coverage, 1648,
     /*  40428 */     GIR_EraseRootFromParent_Done,
     /*  40429 */   // Label 922: @40429
     /*  40429 */   GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(40465), // Rule ID 1649 //
     /*  40434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtms),
     /*  40442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40456 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3763:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTMNSQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNSQh),
     /*  40459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40463 */     GIR_RootConstrainSelectedInstOperands,
     /*  40464 */     // GIR_Coverage, 1649,
     /*  40464 */     GIR_EraseRootFromParent_Done,
     /*  40465 */   // Label 923: @40465
     /*  40465 */   GIM_Try, /*On fail goto*//*Label 924*/ GIMT_Encode4(40501), // Rule ID 1650 //
     /*  40470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtmu),
     /*  40478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40492 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3764:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTMNUDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNUDh),
     /*  40495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40499 */     GIR_RootConstrainSelectedInstOperands,
     /*  40500 */     // GIR_Coverage, 1650,
     /*  40500 */     GIR_EraseRootFromParent_Done,
     /*  40501 */   // Label 924: @40501
     /*  40501 */   GIM_Try, /*On fail goto*//*Label 925*/ GIMT_Encode4(40537), // Rule ID 1651 //
     /*  40506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtmu),
     /*  40514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40528 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3764:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTMNUQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNUQh),
     /*  40531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40535 */     GIR_RootConstrainSelectedInstOperands,
     /*  40536 */     // GIR_Coverage, 1651,
     /*  40536 */     GIR_EraseRootFromParent_Done,
     /*  40537 */   // Label 925: @40537
     /*  40537 */   GIM_Try, /*On fail goto*//*Label 926*/ GIMT_Encode4(40582), // Rule ID 1668 //
     /*  40542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasNEON),
     /*  40545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2hf),
     /*  40550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40564 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3759:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTf2h:{ *:[v4i16] } QPR:{ *:[v4f32] }:$Vm)
     /*  40564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2h),
     /*  40567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40569 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  40574 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  40580 */     GIR_RootConstrainSelectedInstOperands,
     /*  40581 */     // GIR_Coverage, 1668,
     /*  40581 */     GIR_EraseRootFromParent_Done,
     /*  40582 */   // Label 926: @40582
     /*  40582 */   GIM_Try, /*On fail goto*//*Label 927*/ GIMT_Encode4(40627), // Rule ID 1669 //
     /*  40587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasNEON),
     /*  40590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvthf2fp),
     /*  40595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40609 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3762:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VCVTh2f:{ *:[v4f32] } DPR:{ *:[v4i16] }:$Vm)
     /*  40609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2f),
     /*  40612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40614 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  40619 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  40625 */     GIR_RootConstrainSelectedInstOperands,
     /*  40626 */     // GIR_Coverage, 1669,
     /*  40626 */     GIR_EraseRootFromParent_Done,
     /*  40627 */   // Label 927: @40627
     /*  40627 */   GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(40663), // Rule ID 1691 //
     /*  40632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  40640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40654 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3831:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTNNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTNNDf),
     /*  40657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40659 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40661 */     GIR_RootConstrainSelectedInstOperands,
     /*  40662 */     // GIR_Coverage, 1691,
     /*  40662 */     GIR_EraseRootFromParent_Done,
     /*  40663 */   // Label 928: @40663
     /*  40663 */   GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(40699), // Rule ID 1692 //
     /*  40668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  40676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40690 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3831:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTNNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTNNQf),
     /*  40693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40697 */     GIR_RootConstrainSelectedInstOperands,
     /*  40698 */     // GIR_Coverage, 1692,
     /*  40698 */     GIR_EraseRootFromParent_Done,
     /*  40699 */   // Label 929: @40699
     /*  40699 */   GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(40735), // Rule ID 1693 //
     /*  40704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  40712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40726 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3831:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTNNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTNNDh),
     /*  40729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40733 */     GIR_RootConstrainSelectedInstOperands,
     /*  40734 */     // GIR_Coverage, 1693,
     /*  40734 */     GIR_EraseRootFromParent_Done,
     /*  40735 */   // Label 930: @40735
     /*  40735 */   GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(40771), // Rule ID 1694 //
     /*  40740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  40748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40762 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3831:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTNNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTNNQh),
     /*  40765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40769 */     GIR_RootConstrainSelectedInstOperands,
     /*  40770 */     // GIR_Coverage, 1694,
     /*  40770 */     GIR_EraseRootFromParent_Done,
     /*  40771 */   // Label 931: @40771
     /*  40771 */   GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(40807), // Rule ID 1695 //
     /*  40776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintx),
     /*  40784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40798 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3833:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTXNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXNDf),
     /*  40801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40805 */     GIR_RootConstrainSelectedInstOperands,
     /*  40806 */     // GIR_Coverage, 1695,
     /*  40806 */     GIR_EraseRootFromParent_Done,
     /*  40807 */   // Label 932: @40807
     /*  40807 */   GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(40843), // Rule ID 1696 //
     /*  40812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintx),
     /*  40820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40834 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3833:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTXNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXNQf),
     /*  40837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40839 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40841 */     GIR_RootConstrainSelectedInstOperands,
     /*  40842 */     // GIR_Coverage, 1696,
     /*  40842 */     GIR_EraseRootFromParent_Done,
     /*  40843 */   // Label 933: @40843
     /*  40843 */   GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(40879), // Rule ID 1697 //
     /*  40848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintx),
     /*  40856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40870 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3833:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTXNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXNDh),
     /*  40873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40877 */     GIR_RootConstrainSelectedInstOperands,
     /*  40878 */     // GIR_Coverage, 1697,
     /*  40878 */     GIR_EraseRootFromParent_Done,
     /*  40879 */   // Label 934: @40879
     /*  40879 */   GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(40915), // Rule ID 1698 //
     /*  40884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintx),
     /*  40892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40906 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3833:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTXNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXNQh),
     /*  40909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40913 */     GIR_RootConstrainSelectedInstOperands,
     /*  40914 */     // GIR_Coverage, 1698,
     /*  40914 */     GIR_EraseRootFromParent_Done,
     /*  40915 */   // Label 935: @40915
     /*  40915 */   GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(40951), // Rule ID 1703 //
     /*  40920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintz),
     /*  40928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40942 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3834:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTZNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZNDf),
     /*  40945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40949 */     GIR_RootConstrainSelectedInstOperands,
     /*  40950 */     // GIR_Coverage, 1703,
     /*  40950 */     GIR_EraseRootFromParent_Done,
     /*  40951 */   // Label 936: @40951
     /*  40951 */   GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(40987), // Rule ID 1704 //
     /*  40956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintz),
     /*  40964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40978 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3834:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTZNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZNQf),
     /*  40981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40985 */     GIR_RootConstrainSelectedInstOperands,
     /*  40986 */     // GIR_Coverage, 1704,
     /*  40986 */     GIR_EraseRootFromParent_Done,
     /*  40987 */   // Label 937: @40987
     /*  40987 */   GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(41023), // Rule ID 1705 //
     /*  40992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintz),
     /*  41000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  41003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  41006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  41010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  41014 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3834:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTZNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  41014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZNDh),
     /*  41017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41021 */     GIR_RootConstrainSelectedInstOperands,
     /*  41022 */     // GIR_Coverage, 1705,
     /*  41022 */     GIR_EraseRootFromParent_Done,
     /*  41023 */   // Label 938: @41023
     /*  41023 */   GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(41059), // Rule ID 1706 //
     /*  41028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  41031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintz),
     /*  41036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  41039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  41042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41050 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3834:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTZNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  41050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZNQh),
     /*  41053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41057 */     GIR_RootConstrainSelectedInstOperands,
     /*  41058 */     // GIR_Coverage, 1706,
     /*  41058 */     GIR_EraseRootFromParent_Done,
     /*  41059 */   // Label 939: @41059
     /*  41059 */   GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(41095), // Rule ID 1711 //
     /*  41064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  41067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintp),
     /*  41072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  41075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  41078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  41082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  41086 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3832:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTPNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  41086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTPNDf),
     /*  41089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41093 */     GIR_RootConstrainSelectedInstOperands,
     /*  41094 */     // GIR_Coverage, 1711,
     /*  41094 */     GIR_EraseRootFromParent_Done,
     /*  41095 */   // Label 940: @41095
     /*  41095 */   GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(41131), // Rule ID 1712 //
     /*  41100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  41103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintp),
     /*  41108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  41111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41122 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3832:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTPNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  41122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTPNQf),
     /*  41125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41127 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41129 */     GIR_RootConstrainSelectedInstOperands,
     /*  41130 */     // GIR_Coverage, 1712,
     /*  41130 */     GIR_EraseRootFromParent_Done,
     /*  41131 */   // Label 941: @41131
     /*  41131 */   GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(41167), // Rule ID 1713 //
     /*  41136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  41139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintp),
     /*  41144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  41147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  41150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  41154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  41158 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3832:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTPNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  41158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTPNDh),
     /*  41161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41163 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41165 */     GIR_RootConstrainSelectedInstOperands,
     /*  41166 */     // GIR_Coverage, 1713,
     /*  41166 */     GIR_EraseRootFromParent_Done,
     /*  41167 */   // Label 942: @41167
     /*  41167 */   GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(41203), // Rule ID 1714 //
     /*  41172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  41175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintp),
     /*  41180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  41183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  41186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41194 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3832:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTPNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  41194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTPNQh),
     /*  41197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41201 */     GIR_RootConstrainSelectedInstOperands,
     /*  41202 */     // GIR_Coverage, 1714,
     /*  41202 */     GIR_EraseRootFromParent_Done,
     /*  41203 */   // Label 943: @41203
     /*  41203 */   GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(41239), // Rule ID 1717 //
     /*  41208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasV8),
     /*  41211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_aesimc),
     /*  41216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  41219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  41222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41230 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3722:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (AESIMC:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /*  41230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::AESIMC),
     /*  41233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41237 */     GIR_RootConstrainSelectedInstOperands,
     /*  41238 */     // GIR_Coverage, 1717,
     /*  41238 */     GIR_EraseRootFromParent_Done,
     /*  41239 */   // Label 944: @41239
     /*  41239 */   GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(41275), // Rule ID 1718 //
     /*  41244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasV8),
     /*  41247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_aesmc),
     /*  41252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  41255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  41258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41266 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3723:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (AESMC:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /*  41266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::AESMC),
     /*  41269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41271 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41273 */     GIR_RootConstrainSelectedInstOperands,
     /*  41274 */     // GIR_Coverage, 1718,
     /*  41274 */     GIR_EraseRootFromParent_Done,
     /*  41275 */   // Label 945: @41275
     /*  41275 */   GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(41323), // Rule ID 1851 //
     /*  41280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  41283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sxtb16),
     /*  41288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  41298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  41302 */     // (intrinsic_wo_chain:{ *:[i32] } 3920:{ *:[iPTR] }, GPR:{ *:[i32] }:$Src)  =>  (SXTB16:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  41302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTB16),
     /*  41305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Src
     /*  41309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41315 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41321 */     GIR_RootConstrainSelectedInstOperands,
     /*  41322 */     // GIR_Coverage, 1851,
     /*  41322 */     GIR_EraseRootFromParent_Done,
     /*  41323 */   // Label 946: @41323
     /*  41323 */   GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(41371), // Rule ID 2099 //
     /*  41328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  41331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sxtb16),
     /*  41336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41350 */     // (intrinsic_wo_chain:{ *:[i32] } 3920:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 0:{ *:[i32] })
     /*  41350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTB16),
     /*  41353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41363 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41369 */     GIR_RootConstrainSelectedInstOperands,
     /*  41370 */     // GIR_Coverage, 2099,
     /*  41370 */     GIR_EraseRootFromParent_Done,
     /*  41371 */   // Label 947: @41371
     /*  41371 */   GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(41437), // Rule ID 3648 //
     /*  41376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcls),
     /*  41384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  41387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  41390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41398 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3605:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$val)  =>  (MVE_VCLSs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$val)
     /*  41398 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41401 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41405 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLSs8),
     /*  41413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  41415 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  41417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41420 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41426 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41432 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41435 */     GIR_RootConstrainSelectedInstOperands,
     /*  41436 */     // GIR_Coverage, 3648,
     /*  41436 */     GIR_EraseRootFromParent_Done,
     /*  41437 */   // Label 948: @41437
     /*  41437 */   GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(41503), // Rule ID 3650 //
     /*  41442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcls),
     /*  41450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  41453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  41456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41464 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3605:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$val)  =>  (MVE_VCLSs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$val)
     /*  41464 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41467 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41471 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLSs16),
     /*  41479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  41481 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  41483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41486 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41492 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41498 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41501 */     GIR_RootConstrainSelectedInstOperands,
     /*  41502 */     // GIR_Coverage, 3650,
     /*  41502 */     GIR_EraseRootFromParent_Done,
     /*  41503 */   // Label 949: @41503
     /*  41503 */   GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(41569), // Rule ID 3652 //
     /*  41508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcls),
     /*  41516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  41519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41530 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3605:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$val)  =>  (MVE_VCLSs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$val)
     /*  41530 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41533 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41537 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLSs32),
     /*  41545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  41547 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  41549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41552 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41558 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41564 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41567 */     GIR_RootConstrainSelectedInstOperands,
     /*  41568 */     // GIR_Coverage, 3652,
     /*  41568 */     GIR_EraseRootFromParent_Done,
     /*  41569 */   // Label 950: @41569
     /*  41569 */   GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(41620), // Rule ID 4864 //
     /*  41574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vctp8),
     /*  41582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s1,
     /*  41585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  41592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41596 */     // (intrinsic_wo_chain:{ *:[v16i1] } 3613:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn)  =>  (MVE_VCTP8:{ *:[v16i1] } rGPR:{ *:[i32] }:$Rn)
     /*  41596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCTP8),
     /*  41599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /*  41601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41606 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41612 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41618 */     GIR_RootConstrainSelectedInstOperands,
     /*  41619 */     // GIR_Coverage, 4864,
     /*  41619 */     GIR_EraseRootFromParent_Done,
     /*  41620 */   // Label 951: @41620
     /*  41620 */   GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(41671), // Rule ID 4866 //
     /*  41625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vctp16),
     /*  41633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s1,
     /*  41636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  41643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41647 */     // (intrinsic_wo_chain:{ *:[v8i1] } 3610:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn)  =>  (MVE_VCTP16:{ *:[v8i1] } rGPR:{ *:[i32] }:$Rn)
     /*  41647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCTP16),
     /*  41650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /*  41652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41657 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41663 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41669 */     GIR_RootConstrainSelectedInstOperands,
     /*  41670 */     // GIR_Coverage, 4866,
     /*  41670 */     GIR_EraseRootFromParent_Done,
     /*  41671 */   // Label 952: @41671
     /*  41671 */   GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(41722), // Rule ID 4868 //
     /*  41676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vctp32),
     /*  41684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s1,
     /*  41687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  41694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41698 */     // (intrinsic_wo_chain:{ *:[v4i1] } 3611:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn)  =>  (MVE_VCTP32:{ *:[v4i1] } rGPR:{ *:[i32] }:$Rn)
     /*  41698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCTP32),
     /*  41701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /*  41703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41708 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41714 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41720 */     GIR_RootConstrainSelectedInstOperands,
     /*  41721 */     // GIR_Coverage, 4868,
     /*  41721 */     GIR_EraseRootFromParent_Done,
     /*  41722 */   // Label 953: @41722
     /*  41722 */   GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(41773), // Rule ID 4870 //
     /*  41727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vctp64),
     /*  41735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s1,
     /*  41738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  41745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41749 */     // (intrinsic_wo_chain:{ *:[v2i1] } 3612:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn)  =>  (MVE_VCTP64:{ *:[v2i1] } rGPR:{ *:[i32] }:$Rn)
     /*  41749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCTP64),
     /*  41752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /*  41754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41759 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41765 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41771 */     GIR_RootConstrainSelectedInstOperands,
     /*  41772 */     // GIR_Coverage, 4870,
     /*  41772 */     GIR_EraseRootFromParent_Done,
     /*  41773 */   // Label 954: @41773
     /*  41773 */   GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(41819), // Rule ID 600 //
     /*  41778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has8MSecExt_IsThumb),
     /*  41781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_cmse_tt),
     /*  41786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41793 */     // MIs[0] Rn
     /*  41793 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  41797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  41801 */     // (intrinsic_wo_chain:{ *:[i32] } 3495:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn)  =>  (t2TT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn)
     /*  41801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2TT),
     /*  41804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  41806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41811 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41817 */     GIR_RootConstrainSelectedInstOperands,
     /*  41818 */     // GIR_Coverage, 600,
     /*  41818 */     GIR_EraseRootFromParent_Done,
     /*  41819 */   // Label 955: @41819
     /*  41819 */   GIM_Try, /*On fail goto*//*Label 956*/ GIMT_Encode4(41865), // Rule ID 601 //
     /*  41824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has8MSecExt_IsThumb),
     /*  41827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_cmse_ttt),
     /*  41832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41839 */     // MIs[0] Rn
     /*  41839 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  41843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  41847 */     // (intrinsic_wo_chain:{ *:[i32] } 3498:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn)  =>  (t2TTT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn)
     /*  41847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2TTT),
     /*  41850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  41852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41857 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41863 */     GIR_RootConstrainSelectedInstOperands,
     /*  41864 */     // GIR_Coverage, 601,
     /*  41864 */     GIR_EraseRootFromParent_Done,
     /*  41865 */   // Label 956: @41865
     /*  41865 */   GIM_Try, /*On fail goto*//*Label 957*/ GIMT_Encode4(41911), // Rule ID 602 //
     /*  41870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has8MSecExt_IsThumb),
     /*  41873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_cmse_tta),
     /*  41878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41885 */     // MIs[0] Rn
     /*  41885 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  41889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  41893 */     // (intrinsic_wo_chain:{ *:[i32] } 3496:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn)  =>  (t2TTA:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn)
     /*  41893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2TTA),
     /*  41896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  41898 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41903 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41909 */     GIR_RootConstrainSelectedInstOperands,
     /*  41910 */     // GIR_Coverage, 602,
     /*  41910 */     GIR_EraseRootFromParent_Done,
     /*  41911 */   // Label 957: @41911
     /*  41911 */   GIM_Try, /*On fail goto*//*Label 958*/ GIMT_Encode4(41957), // Rule ID 603 //
     /*  41916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has8MSecExt_IsThumb),
     /*  41919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_cmse_ttat),
     /*  41924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41931 */     // MIs[0] Rn
     /*  41931 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  41935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  41939 */     // (intrinsic_wo_chain:{ *:[i32] } 3497:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn)  =>  (t2TTAT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn)
     /*  41939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2TTAT),
     /*  41942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  41944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41949 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41955 */     GIR_RootConstrainSelectedInstOperands,
     /*  41956 */     // GIR_Coverage, 603,
     /*  41956 */     GIR_EraseRootFromParent_Done,
     /*  41957 */   // Label 958: @41957
     /*  41957 */   GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(42092), // Rule ID 2693 //
     /*  41962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1h),
     /*  41970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  41980 */     // (intrinsic_wo_chain:{ *:[i32] } 3730:{ *:[iPTR] }, i32:{ *:[i32] }:$Rn)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[f32] } (SHA1H:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (COPY_TO_REGCLASS:{ *:[f32] } i32:{ *:[i32] }:$Rn, SPR:{ *:[i32] }), ssub_0:{ *:[i32] })), ssub_0:{ *:[i32] }), GPR:{ *:[i32] })
     /*  41980 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  41983 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41987 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41992 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  41996 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  42001 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /*  42004 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  42008 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42013 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  42016 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  42019 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /*  42022 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPair_with_ssub_0RegClassID),
     /*  42027 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /*  42032 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /*  42035 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::SHA1H),
     /*  42039 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42044 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42047 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  42049 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  42052 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42056 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42061 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /*  42068 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  42073 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42083 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  42086 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /*  42091 */     // GIR_Coverage, 2693,
     /*  42091 */     GIR_EraseRootFromParent_Done,
     /*  42092 */   // Label 959: @42092
     /*  42092 */   GIM_Reject,
     /*  42093 */ // Label 833: @42093
     /*  42093 */ GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(62647),
     /*  42098 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /*  42101 */   GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(42158), // Rule ID 2117 //
     /*  42106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  42109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uxtab16),
     /*  42114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42135 */     // (intrinsic_wo_chain:{ *:[i32] } 3944:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UXTAB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  42135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTAB16),
     /*  42138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  42142 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  42144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  42147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42150 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42156 */     GIR_RootConstrainSelectedInstOperands,
     /*  42157 */     // GIR_Coverage, 2117,
     /*  42157 */     GIR_EraseRootFromParent_Done,
     /*  42158 */   // Label 961: @42158
     /*  42158 */   GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(42257), // Rule ID 1888 //
     /*  42163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  42166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat),
     /*  42171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  42192 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  42196 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42200 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42205 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  42209 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42213 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  42217 */     // MIs[2] Operand 1
     /*  42217 */     // No operand predicates
     /*  42217 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /*  42221 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42225 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  42229 */     // MIs[3] Operand 1
     /*  42229 */     // No operand predicates
     /*  42229 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  42231 */     // (intrinsic_wo_chain:{ *:[i32] } 3939:{ *:[iPTR] }, (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$shft), (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos)  =>  (USAT:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos, GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$shft)
     /*  42231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USAT),
     /*  42234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42236 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // pos
     /*  42239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /*  42243 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shft
     /*  42246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42249 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42255 */     GIR_RootConstrainSelectedInstOperands,
     /*  42256 */     // GIR_Coverage, 1888,
     /*  42256 */     GIR_EraseRootFromParent_Done,
     /*  42257 */   // Label 962: @42257
     /*  42257 */   GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(42356), // Rule ID 2154 //
     /*  42262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  42265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat),
     /*  42270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  42291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  42295 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42299 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42304 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  42308 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42312 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  42316 */     // MIs[2] Operand 1
     /*  42316 */     // No operand predicates
     /*  42316 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /*  42320 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42324 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  42328 */     // MIs[3] Operand 1
     /*  42328 */     // No operand predicates
     /*  42328 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  42330 */     // (intrinsic_wo_chain:{ *:[i32] } 3939:{ *:[iPTR] }, (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$shft), (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos)  =>  (t2USAT:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos, GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$shft)
     /*  42330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USAT),
     /*  42333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42335 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // pos
     /*  42338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /*  42342 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shft
     /*  42345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42348 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42354 */     GIR_RootConstrainSelectedInstOperands,
     /*  42355 */     // GIR_Coverage, 2154,
     /*  42355 */     GIR_EraseRootFromParent_Done,
     /*  42356 */   // Label 963: @42356
     /*  42356 */   GIM_Try, /*On fail goto*//*Label 964*/ GIMT_Encode4(42440), // Rule ID 5430 //
     /*  42361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  42364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42390 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42393 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42398 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42402 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42407 */     // MIs[1] Rn
     /*  42407 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42416 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42418 */     // (intrinsic_wo_chain:{ *:[i32] } 3862:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[i32] } 3862:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rn), GPRnopc:{ *:[i32] }:$Rm)  =>  (QDADD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)
     /*  42418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDADD),
     /*  42421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42423 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  42425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42432 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42438 */     GIR_RootConstrainSelectedInstOperands,
     /*  42439 */     // GIR_Coverage, 5430,
     /*  42439 */     GIR_EraseRootFromParent_Done,
     /*  42440 */   // Label 964: @42440
     /*  42440 */   GIM_Try, /*On fail goto*//*Label 965*/ GIMT_Encode4(42524), // Rule ID 5687 //
     /*  42445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  42448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42474 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42477 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42482 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42486 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42491 */     // MIs[1] Rn
     /*  42491 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42502 */     // (intrinsic_wo_chain:{ *:[i32] } 3862:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[i32] } 3862:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn), rGPR:{ *:[i32] }:$Rm)  =>  (t2QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /*  42502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDADD),
     /*  42505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42507 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  42509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42516 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42522 */     GIR_RootConstrainSelectedInstOperands,
     /*  42523 */     // GIR_Coverage, 5687,
     /*  42523 */     GIR_EraseRootFromParent_Done,
     /*  42524 */   // Label 965: @42524
     /*  42524 */   GIM_Try, /*On fail goto*//*Label 966*/ GIMT_Encode4(42608), // Rule ID 109 //
     /*  42529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  42532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  42558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42562 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42565 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42570 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42574 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42579 */     // MIs[1] Rn
     /*  42579 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42586 */     // (intrinsic_wo_chain:{ *:[i32] } 3862:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rm, (intrinsic_wo_chain:{ *:[i32] } 3862:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rn))  =>  (QDADD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)
     /*  42586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDADD),
     /*  42589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  42593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42600 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42606 */     GIR_RootConstrainSelectedInstOperands,
     /*  42607 */     // GIR_Coverage, 109,
     /*  42607 */     GIR_EraseRootFromParent_Done,
     /*  42608 */   // Label 966: @42608
     /*  42608 */   GIM_Try, /*On fail goto*//*Label 967*/ GIMT_Encode4(42692), // Rule ID 110 //
     /*  42613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  42616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub),
     /*  42621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  42642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42646 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42649 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42654 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42658 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42663 */     // MIs[1] Rn
     /*  42663 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42668 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42670 */     // (intrinsic_wo_chain:{ *:[i32] } 3867:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rm, (intrinsic_wo_chain:{ *:[i32] } 3862:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rn))  =>  (QDSUB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)
     /*  42670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDSUB),
     /*  42673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  42677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42684 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42690 */     GIR_RootConstrainSelectedInstOperands,
     /*  42691 */     // GIR_Coverage, 110,
     /*  42691 */     GIR_EraseRootFromParent_Done,
     /*  42692 */   // Label 967: @42692
     /*  42692 */   GIM_Try, /*On fail goto*//*Label 968*/ GIMT_Encode4(42776), // Rule ID 2132 //
     /*  42697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  42700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  42726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42730 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42733 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42738 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42742 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42747 */     // MIs[1] Rn
     /*  42747 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42752 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42754 */     // (intrinsic_wo_chain:{ *:[i32] } 3862:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rm, (intrinsic_wo_chain:{ *:[i32] } 3862:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (t2QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /*  42754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDADD),
     /*  42757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  42761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42768 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42774 */     GIR_RootConstrainSelectedInstOperands,
     /*  42775 */     // GIR_Coverage, 2132,
     /*  42775 */     GIR_EraseRootFromParent_Done,
     /*  42776 */   // Label 968: @42776
     /*  42776 */   GIM_Try, /*On fail goto*//*Label 969*/ GIMT_Encode4(42860), // Rule ID 2133 //
     /*  42781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  42784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub),
     /*  42789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  42810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42814 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42817 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42822 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42826 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42831 */     // MIs[1] Rn
     /*  42831 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42836 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42838 */     // (intrinsic_wo_chain:{ *:[i32] } 3867:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rm, (intrinsic_wo_chain:{ *:[i32] } 3862:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (t2QDSUB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /*  42838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDSUB),
     /*  42841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  42845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42852 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42858 */     GIR_RootConstrainSelectedInstOperands,
     /*  42859 */     // GIR_Coverage, 2133,
     /*  42859 */     GIR_EraseRootFromParent_Done,
     /*  42860 */   // Label 969: @42860
     /*  42860 */   GIM_Try, /*On fail goto*//*Label 970*/ GIMT_Encode4(42933), // Rule ID 4058 //
     /*  42865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  42868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvta),
     /*  42873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  42876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  42882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42886 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  42890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42894 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3621:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTs16f16a:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  42894 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42897 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42901 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16a),
     /*  42909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  42911 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  42913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  42916 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42922 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42928 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  42931 */     GIR_RootConstrainSelectedInstOperands,
     /*  42932 */     // GIR_Coverage, 4058,
     /*  42932 */     GIR_EraseRootFromParent_Done,
     /*  42933 */   // Label 970: @42933
     /*  42933 */   GIM_Try, /*On fail goto*//*Label 971*/ GIMT_Encode4(43006), // Rule ID 4060 //
     /*  42938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  42941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtn),
     /*  42946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  42949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  42955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42959 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  42963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42967 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3625:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTs16f16n:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  42967 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42970 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42974 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16n),
     /*  42982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  42984 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  42986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  42989 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42995 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43001 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43004 */     GIR_RootConstrainSelectedInstOperands,
     /*  43005 */     // GIR_Coverage, 4060,
     /*  43005 */     GIR_EraseRootFromParent_Done,
     /*  43006 */   // Label 971: @43006
     /*  43006 */   GIM_Try, /*On fail goto*//*Label 972*/ GIMT_Encode4(43079), // Rule ID 4062 //
     /*  43011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtp),
     /*  43019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  43022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  43028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43032 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43040 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3627:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTs16f16p:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  43040 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43043 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43047 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16p),
     /*  43055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43057 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43062 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43068 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43074 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43077 */     GIR_RootConstrainSelectedInstOperands,
     /*  43078 */     // GIR_Coverage, 4062,
     /*  43078 */     GIR_EraseRootFromParent_Done,
     /*  43079 */   // Label 972: @43079
     /*  43079 */   GIM_Try, /*On fail goto*//*Label 973*/ GIMT_Encode4(43152), // Rule ID 4064 //
     /*  43084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtm),
     /*  43092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  43095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  43101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43105 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43113 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3623:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTs16f16m:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  43113 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43116 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43120 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16m),
     /*  43128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43130 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43135 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43141 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43147 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43150 */     GIR_RootConstrainSelectedInstOperands,
     /*  43151 */     // GIR_Coverage, 4064,
     /*  43151 */     GIR_EraseRootFromParent_Done,
     /*  43152 */   // Label 973: @43152
     /*  43152 */   GIM_Try, /*On fail goto*//*Label 974*/ GIMT_Encode4(43225), // Rule ID 4066 //
     /*  43157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvta),
     /*  43165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  43168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  43174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43178 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43186 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3621:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTu16f16a:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  43186 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43189 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43193 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16a),
     /*  43201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43203 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43208 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43214 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43220 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43223 */     GIR_RootConstrainSelectedInstOperands,
     /*  43224 */     // GIR_Coverage, 4066,
     /*  43224 */     GIR_EraseRootFromParent_Done,
     /*  43225 */   // Label 974: @43225
     /*  43225 */   GIM_Try, /*On fail goto*//*Label 975*/ GIMT_Encode4(43298), // Rule ID 4068 //
     /*  43230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtn),
     /*  43238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  43241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  43247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43251 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43259 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3625:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTu16f16n:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  43259 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43262 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43266 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16n),
     /*  43274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43276 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43281 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43287 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43293 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43296 */     GIR_RootConstrainSelectedInstOperands,
     /*  43297 */     // GIR_Coverage, 4068,
     /*  43297 */     GIR_EraseRootFromParent_Done,
     /*  43298 */   // Label 975: @43298
     /*  43298 */   GIM_Try, /*On fail goto*//*Label 976*/ GIMT_Encode4(43371), // Rule ID 4070 //
     /*  43303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtp),
     /*  43311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  43314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  43320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43324 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43332 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3627:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTu16f16p:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  43332 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43335 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43339 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16p),
     /*  43347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43349 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43354 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43360 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43366 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43369 */     GIR_RootConstrainSelectedInstOperands,
     /*  43370 */     // GIR_Coverage, 4070,
     /*  43370 */     GIR_EraseRootFromParent_Done,
     /*  43371 */   // Label 976: @43371
     /*  43371 */   GIM_Try, /*On fail goto*//*Label 977*/ GIMT_Encode4(43444), // Rule ID 4072 //
     /*  43376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtm),
     /*  43384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  43387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  43393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43397 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43405 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3623:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTu16f16m:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  43405 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43408 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43412 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16m),
     /*  43420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43422 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43427 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43433 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43439 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43442 */     GIR_RootConstrainSelectedInstOperands,
     /*  43443 */     // GIR_Coverage, 4072,
     /*  43443 */     GIR_EraseRootFromParent_Done,
     /*  43444 */   // Label 977: @43444
     /*  43444 */   GIM_Try, /*On fail goto*//*Label 978*/ GIMT_Encode4(43517), // Rule ID 4074 //
     /*  43449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvta),
     /*  43457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43470 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43478 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3621:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTs32f32a:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43478 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43485 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32a),
     /*  43493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43495 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43500 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43506 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43512 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43515 */     GIR_RootConstrainSelectedInstOperands,
     /*  43516 */     // GIR_Coverage, 4074,
     /*  43516 */     GIR_EraseRootFromParent_Done,
     /*  43517 */   // Label 978: @43517
     /*  43517 */   GIM_Try, /*On fail goto*//*Label 979*/ GIMT_Encode4(43590), // Rule ID 4076 //
     /*  43522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtn),
     /*  43530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43543 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43551 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3625:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTs32f32n:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43551 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43554 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43558 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32n),
     /*  43566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43568 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43573 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43579 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43585 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43588 */     GIR_RootConstrainSelectedInstOperands,
     /*  43589 */     // GIR_Coverage, 4076,
     /*  43589 */     GIR_EraseRootFromParent_Done,
     /*  43590 */   // Label 979: @43590
     /*  43590 */   GIM_Try, /*On fail goto*//*Label 980*/ GIMT_Encode4(43663), // Rule ID 4078 //
     /*  43595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtp),
     /*  43603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43616 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43624 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3627:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTs32f32p:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43624 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43627 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43631 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32p),
     /*  43639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43641 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43646 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43652 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43658 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43661 */     GIR_RootConstrainSelectedInstOperands,
     /*  43662 */     // GIR_Coverage, 4078,
     /*  43662 */     GIR_EraseRootFromParent_Done,
     /*  43663 */   // Label 980: @43663
     /*  43663 */   GIM_Try, /*On fail goto*//*Label 981*/ GIMT_Encode4(43736), // Rule ID 4080 //
     /*  43668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtm),
     /*  43676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43689 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43697 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3623:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTs32f32m:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43697 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43700 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43704 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32m),
     /*  43712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43714 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43719 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43725 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43731 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43734 */     GIR_RootConstrainSelectedInstOperands,
     /*  43735 */     // GIR_Coverage, 4080,
     /*  43735 */     GIR_EraseRootFromParent_Done,
     /*  43736 */   // Label 981: @43736
     /*  43736 */   GIM_Try, /*On fail goto*//*Label 982*/ GIMT_Encode4(43809), // Rule ID 4082 //
     /*  43741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvta),
     /*  43749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43762 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43770 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3621:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTu32f32a:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32a),
     /*  43785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43787 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43792 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43798 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43804 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43807 */     GIR_RootConstrainSelectedInstOperands,
     /*  43808 */     // GIR_Coverage, 4082,
     /*  43808 */     GIR_EraseRootFromParent_Done,
     /*  43809 */   // Label 982: @43809
     /*  43809 */   GIM_Try, /*On fail goto*//*Label 983*/ GIMT_Encode4(43882), // Rule ID 4084 //
     /*  43814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtn),
     /*  43822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43835 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43843 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3625:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTu32f32n:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43843 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43846 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43850 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32n),
     /*  43858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43860 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43865 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43871 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43877 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43880 */     GIR_RootConstrainSelectedInstOperands,
     /*  43881 */     // GIR_Coverage, 4084,
     /*  43881 */     GIR_EraseRootFromParent_Done,
     /*  43882 */   // Label 983: @43882
     /*  43882 */   GIM_Try, /*On fail goto*//*Label 984*/ GIMT_Encode4(43955), // Rule ID 4086 //
     /*  43887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtp),
     /*  43895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43908 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43916 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3627:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTu32f32p:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43916 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43919 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43923 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32p),
     /*  43931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43933 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43938 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43944 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43950 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43953 */     GIR_RootConstrainSelectedInstOperands,
     /*  43954 */     // GIR_Coverage, 4086,
     /*  43954 */     GIR_EraseRootFromParent_Done,
     /*  43955 */   // Label 984: @43955
     /*  43955 */   GIM_Try, /*On fail goto*//*Label 985*/ GIMT_Encode4(44028), // Rule ID 4088 //
     /*  43960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtm),
     /*  43968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43981 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43989 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3623:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTu32f32m:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43989 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43992 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43996 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32m),
     /*  44004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  44006 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  44008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44011 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44017 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44026 */     GIR_RootConstrainSelectedInstOperands,
     /*  44027 */     // GIR_Coverage, 4088,
     /*  44027 */     GIR_EraseRootFromParent_Done,
     /*  44028 */   // Label 985: @44028
     /*  44028 */   GIM_Try, /*On fail goto*//*Label 986*/ GIMT_Encode4(44101), // Rule ID 4532 //
     /*  44033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  44036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_widen),
     /*  44041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  44044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  44047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44058 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  44062 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3619:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qm, 0:{ *:[i32] })  =>  (MVE_VCVTf32f16bh:{ *:[v4f32] } MQPR:{ *:[v8f16] }:$Qm)
     /*  44062 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  44065 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44069 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32f16bh),
     /*  44077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  44079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  44081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44084 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44090 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44096 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44099 */     GIR_RootConstrainSelectedInstOperands,
     /*  44100 */     // GIR_Coverage, 4532,
     /*  44100 */     GIR_EraseRootFromParent_Done,
     /*  44101 */   // Label 986: @44101
     /*  44101 */   GIM_Try, /*On fail goto*//*Label 987*/ GIMT_Encode4(44174), // Rule ID 4538 //
     /*  44106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  44109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_widen),
     /*  44114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  44117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  44120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44131 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  44135 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3619:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qm, 1:{ *:[i32] })  =>  (MVE_VCVTf32f16th:{ *:[v4f32] } MQPR:{ *:[v8f16] }:$Qm)
     /*  44135 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  44138 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44142 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32f16th),
     /*  44150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  44152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  44154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44157 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44163 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44169 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44172 */     GIR_RootConstrainSelectedInstOperands,
     /*  44173 */     // GIR_Coverage, 4538,
     /*  44173 */     GIR_EraseRootFromParent_Done,
     /*  44174 */   // Label 987: @44174
     /*  44174 */   GIM_Try, /*On fail goto*//*Label 988*/ GIMT_Encode4(44242), // Rule ID 1881 //
     /*  44179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  44182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat),
     /*  44187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  44190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  44193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  44200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  44204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44212 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  44216 */     // MIs[1] Operand 1
     /*  44216 */     // No operand predicates
     /*  44216 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44218 */     // (intrinsic_wo_chain:{ *:[i32] } 3939:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos)  =>  (USAT:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos, GPRnopc:{ *:[i32] }:$a, 0:{ *:[i32] })
     /*  44218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USAT),
     /*  44221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // pos
     /*  44226 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  44228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44234 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44240 */     GIR_RootConstrainSelectedInstOperands,
     /*  44241 */     // GIR_Coverage, 1881,
     /*  44241 */     GIR_EraseRootFromParent_Done,
     /*  44242 */   // Label 988: @44242
     /*  44242 */   GIM_Try, /*On fail goto*//*Label 989*/ GIMT_Encode4(44307), // Rule ID 1885 //
     /*  44247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  44250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat16),
     /*  44255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  44258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  44261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  44268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  44272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44280 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  44284 */     // MIs[1] Operand 1
     /*  44284 */     // No operand predicates
     /*  44284 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44286 */     // (intrinsic_wo_chain:{ *:[i32] } 3940:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$pos)  =>  (USAT16:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$pos, GPRnopc:{ *:[i32] }:$a)
     /*  44286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USAT16),
     /*  44289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // pos
     /*  44294 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  44296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44299 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44305 */     GIR_RootConstrainSelectedInstOperands,
     /*  44306 */     // GIR_Coverage, 1885,
     /*  44306 */     GIR_EraseRootFromParent_Done,
     /*  44307 */   // Label 989: @44307
     /*  44307 */   GIM_Try, /*On fail goto*//*Label 990*/ GIMT_Encode4(44375), // Rule ID 2149 //
     /*  44312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  44315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat),
     /*  44320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  44323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  44326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  44333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  44337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44345 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  44349 */     // MIs[1] Operand 1
     /*  44349 */     // No operand predicates
     /*  44349 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44351 */     // (intrinsic_wo_chain:{ *:[i32] } 3939:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos)  =>  (t2USAT:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos, GPR:{ *:[i32] }:$a, 0:{ *:[i32] })
     /*  44351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USAT),
     /*  44354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44356 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // pos
     /*  44359 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  44361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44367 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44373 */     GIR_RootConstrainSelectedInstOperands,
     /*  44374 */     // GIR_Coverage, 2149,
     /*  44374 */     GIR_EraseRootFromParent_Done,
     /*  44375 */   // Label 990: @44375
     /*  44375 */   GIM_Try, /*On fail goto*//*Label 991*/ GIMT_Encode4(44440), // Rule ID 2151 //
     /*  44380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  44383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat16),
     /*  44388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  44391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  44394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  44401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  44405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44413 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  44417 */     // MIs[1] Operand 1
     /*  44417 */     // No operand predicates
     /*  44417 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44419 */     // (intrinsic_wo_chain:{ *:[i32] } 3940:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$pos)  =>  (t2USAT16:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$pos, GPR:{ *:[i32] }:$a)
     /*  44419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USAT16),
     /*  44422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44424 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // pos
     /*  44427 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  44429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44432 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44438 */     GIR_RootConstrainSelectedInstOperands,
     /*  44439 */     // GIR_Coverage, 2151,
     /*  44439 */     GIR_EraseRootFromParent_Done,
     /*  44440 */   // Label 991: @44440
     /*  44440 */   GIM_Try, /*On fail goto*//*Label 992*/ GIMT_Encode4(44523), // Rule ID 3928 //
     /*  44445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshlu_imm),
     /*  44450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  44453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  44456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44475 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /*  44479 */     // MIs[1] Operand 1
     /*  44479 */     // No operand predicates
     /*  44479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44481 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3680:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)  =>  (MVE_VQSHLU_imms8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)
     /*  44481 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  44484 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44488 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLU_imms8),
     /*  44496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  44498 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  44500 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  44503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44506 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44512 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44518 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44521 */     GIR_RootConstrainSelectedInstOperands,
     /*  44522 */     // GIR_Coverage, 3928,
     /*  44522 */     GIR_EraseRootFromParent_Done,
     /*  44523 */   // Label 992: @44523
     /*  44523 */   GIM_Try, /*On fail goto*//*Label 993*/ GIMT_Encode4(44606), // Rule ID 3930 //
     /*  44528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshlu_imm),
     /*  44533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  44536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  44539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44558 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  44562 */     // MIs[1] Operand 1
     /*  44562 */     // No operand predicates
     /*  44562 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44564 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3680:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)  =>  (MVE_VQSHLU_imms16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)
     /*  44564 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  44567 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44571 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLU_imms16),
     /*  44579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  44581 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  44583 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  44586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44589 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44595 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44601 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44604 */     GIR_RootConstrainSelectedInstOperands,
     /*  44605 */     // GIR_Coverage, 3930,
     /*  44605 */     GIR_EraseRootFromParent_Done,
     /*  44606 */   // Label 993: @44606
     /*  44606 */   GIM_Try, /*On fail goto*//*Label 994*/ GIMT_Encode4(44689), // Rule ID 3932 //
     /*  44611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshlu_imm),
     /*  44616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  44619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44641 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  44645 */     // MIs[1] Operand 1
     /*  44645 */     // No operand predicates
     /*  44645 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44647 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3680:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)  =>  (MVE_VQSHLU_imms32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)
     /*  44647 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  44650 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44654 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLU_imms32),
     /*  44662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  44664 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  44666 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  44669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44672 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44678 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44684 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44687 */     GIR_RootConstrainSelectedInstOperands,
     /*  44688 */     // GIR_Coverage, 3932,
     /*  44688 */     GIR_EraseRootFromParent_Done,
     /*  44689 */   // Label 994: @44689
     /*  44689 */   GIM_Try, /*On fail goto*//*Label 995*/ GIMT_Encode4(44750), // Rule ID 1652 //
     /*  44694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxs),
     /*  44702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  44705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44727 */     // MIs[1] Operand 1
     /*  44727 */     // No operand predicates
     /*  44727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44729 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3757:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTf2xsd:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2xsd),
     /*  44732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44734 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44736 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44742 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44748 */     GIR_RootConstrainSelectedInstOperands,
     /*  44749 */     // GIR_Coverage, 1652,
     /*  44749 */     GIR_EraseRootFromParent_Done,
     /*  44750 */   // Label 995: @44750
     /*  44750 */   GIM_Try, /*On fail goto*//*Label 996*/ GIMT_Encode4(44811), // Rule ID 1653 //
     /*  44755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxu),
     /*  44763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  44766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44788 */     // MIs[1] Operand 1
     /*  44788 */     // No operand predicates
     /*  44788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44790 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3758:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTf2xud:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2xud),
     /*  44793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44795 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44797 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44803 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44809 */     GIR_RootConstrainSelectedInstOperands,
     /*  44810 */     // GIR_Coverage, 1653,
     /*  44810 */     GIR_EraseRootFromParent_Done,
     /*  44811 */   // Label 996: @44811
     /*  44811 */   GIM_Try, /*On fail goto*//*Label 997*/ GIMT_Encode4(44872), // Rule ID 1654 //
     /*  44816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxs2fp),
     /*  44824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  44827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44849 */     // MIs[1] Operand 1
     /*  44849 */     // No operand predicates
     /*  44849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44851 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3760:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxs2fd:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxs2fd),
     /*  44854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44858 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44864 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44870 */     GIR_RootConstrainSelectedInstOperands,
     /*  44871 */     // GIR_Coverage, 1654,
     /*  44871 */     GIR_EraseRootFromParent_Done,
     /*  44872 */   // Label 997: @44872
     /*  44872 */   GIM_Try, /*On fail goto*//*Label 998*/ GIMT_Encode4(44933), // Rule ID 1655 //
     /*  44877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxu2fp),
     /*  44885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  44888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44910 */     // MIs[1] Operand 1
     /*  44910 */     // No operand predicates
     /*  44910 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44912 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3761:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxu2fd:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxu2fd),
     /*  44915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44919 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44925 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44931 */     GIR_RootConstrainSelectedInstOperands,
     /*  44932 */     // GIR_Coverage, 1655,
     /*  44932 */     GIR_EraseRootFromParent_Done,
     /*  44933 */   // Label 998: @44933
     /*  44933 */   GIM_Try, /*On fail goto*//*Label 999*/ GIMT_Encode4(44994), // Rule ID 1656 //
     /*  44938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  44941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxs),
     /*  44946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  44949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  44952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44971 */     // MIs[1] Operand 1
     /*  44971 */     // No operand predicates
     /*  44971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44973 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3757:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTh2xsd:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2xsd),
     /*  44976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44978 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44980 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44986 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44992 */     GIR_RootConstrainSelectedInstOperands,
     /*  44993 */     // GIR_Coverage, 1656,
     /*  44993 */     GIR_EraseRootFromParent_Done,
     /*  44994 */   // Label 999: @44994
     /*  44994 */   GIM_Try, /*On fail goto*//*Label 1000*/ GIMT_Encode4(45055), // Rule ID 1657 //
     /*  44999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxu),
     /*  45007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  45010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  45020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  45024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45032 */     // MIs[1] Operand 1
     /*  45032 */     // No operand predicates
     /*  45032 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45034 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3758:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTh2xud:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2xud),
     /*  45037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45039 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45041 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45047 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45053 */     GIR_RootConstrainSelectedInstOperands,
     /*  45054 */     // GIR_Coverage, 1657,
     /*  45054 */     GIR_EraseRootFromParent_Done,
     /*  45055 */   // Label 1000: @45055
     /*  45055 */   GIM_Try, /*On fail goto*//*Label 1001*/ GIMT_Encode4(45116), // Rule ID 1658 //
     /*  45060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxs2fp),
     /*  45068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  45071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  45081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  45085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45093 */     // MIs[1] Operand 1
     /*  45093 */     // No operand predicates
     /*  45093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45095 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3760:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxs2hd:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxs2hd),
     /*  45098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45100 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45102 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45108 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45114 */     GIR_RootConstrainSelectedInstOperands,
     /*  45115 */     // GIR_Coverage, 1658,
     /*  45115 */     GIR_EraseRootFromParent_Done,
     /*  45116 */   // Label 1001: @45116
     /*  45116 */   GIM_Try, /*On fail goto*//*Label 1002*/ GIMT_Encode4(45177), // Rule ID 1659 //
     /*  45121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxu2fp),
     /*  45129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  45132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  45142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  45146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45154 */     // MIs[1] Operand 1
     /*  45154 */     // No operand predicates
     /*  45154 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45156 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3761:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxu2hd:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxu2hd),
     /*  45159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45163 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45169 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45175 */     GIR_RootConstrainSelectedInstOperands,
     /*  45176 */     // GIR_Coverage, 1659,
     /*  45176 */     GIR_EraseRootFromParent_Done,
     /*  45177 */   // Label 1002: @45177
     /*  45177 */   GIM_Try, /*On fail goto*//*Label 1003*/ GIMT_Encode4(45238), // Rule ID 1660 //
     /*  45182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxs),
     /*  45190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  45193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45215 */     // MIs[1] Operand 1
     /*  45215 */     // No operand predicates
     /*  45215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45217 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3757:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTf2xsq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2xsq),
     /*  45220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45224 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45230 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45236 */     GIR_RootConstrainSelectedInstOperands,
     /*  45237 */     // GIR_Coverage, 1660,
     /*  45237 */     GIR_EraseRootFromParent_Done,
     /*  45238 */   // Label 1003: @45238
     /*  45238 */   GIM_Try, /*On fail goto*//*Label 1004*/ GIMT_Encode4(45299), // Rule ID 1661 //
     /*  45243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxu),
     /*  45251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  45254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45276 */     // MIs[1] Operand 1
     /*  45276 */     // No operand predicates
     /*  45276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45278 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3758:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTf2xuq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2xuq),
     /*  45281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45285 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45291 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45297 */     GIR_RootConstrainSelectedInstOperands,
     /*  45298 */     // GIR_Coverage, 1661,
     /*  45298 */     GIR_EraseRootFromParent_Done,
     /*  45299 */   // Label 1004: @45299
     /*  45299 */   GIM_Try, /*On fail goto*//*Label 1005*/ GIMT_Encode4(45360), // Rule ID 1662 //
     /*  45304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxs2fp),
     /*  45312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  45315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45337 */     // MIs[1] Operand 1
     /*  45337 */     // No operand predicates
     /*  45337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45339 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3760:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxs2fq:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxs2fq),
     /*  45342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45346 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45352 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45358 */     GIR_RootConstrainSelectedInstOperands,
     /*  45359 */     // GIR_Coverage, 1662,
     /*  45359 */     GIR_EraseRootFromParent_Done,
     /*  45360 */   // Label 1005: @45360
     /*  45360 */   GIM_Try, /*On fail goto*//*Label 1006*/ GIMT_Encode4(45421), // Rule ID 1663 //
     /*  45365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxu2fp),
     /*  45373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  45376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45398 */     // MIs[1] Operand 1
     /*  45398 */     // No operand predicates
     /*  45398 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45400 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3761:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxu2fq:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxu2fq),
     /*  45403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45407 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45413 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45419 */     GIR_RootConstrainSelectedInstOperands,
     /*  45420 */     // GIR_Coverage, 1663,
     /*  45420 */     GIR_EraseRootFromParent_Done,
     /*  45421 */   // Label 1006: @45421
     /*  45421 */   GIM_Try, /*On fail goto*//*Label 1007*/ GIMT_Encode4(45482), // Rule ID 1664 //
     /*  45426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxs),
     /*  45434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  45437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  45440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45459 */     // MIs[1] Operand 1
     /*  45459 */     // No operand predicates
     /*  45459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45461 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3757:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTh2xsq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2xsq),
     /*  45464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45466 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45468 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45474 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45480 */     GIR_RootConstrainSelectedInstOperands,
     /*  45481 */     // GIR_Coverage, 1664,
     /*  45481 */     GIR_EraseRootFromParent_Done,
     /*  45482 */   // Label 1007: @45482
     /*  45482 */   GIM_Try, /*On fail goto*//*Label 1008*/ GIMT_Encode4(45543), // Rule ID 1665 //
     /*  45487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxu),
     /*  45495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  45498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  45501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45520 */     // MIs[1] Operand 1
     /*  45520 */     // No operand predicates
     /*  45520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45522 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3758:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTh2xuq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2xuq),
     /*  45525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45529 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45535 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45541 */     GIR_RootConstrainSelectedInstOperands,
     /*  45542 */     // GIR_Coverage, 1665,
     /*  45542 */     GIR_EraseRootFromParent_Done,
     /*  45543 */   // Label 1008: @45543
     /*  45543 */   GIM_Try, /*On fail goto*//*Label 1009*/ GIMT_Encode4(45604), // Rule ID 1666 //
     /*  45548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxs2fp),
     /*  45556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  45559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  45562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45581 */     // MIs[1] Operand 1
     /*  45581 */     // No operand predicates
     /*  45581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45583 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3760:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxs2hq:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxs2hq),
     /*  45586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45590 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45596 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45602 */     GIR_RootConstrainSelectedInstOperands,
     /*  45603 */     // GIR_Coverage, 1666,
     /*  45603 */     GIR_EraseRootFromParent_Done,
     /*  45604 */   // Label 1009: @45604
     /*  45604 */   GIM_Try, /*On fail goto*//*Label 1010*/ GIMT_Encode4(45665), // Rule ID 1667 //
     /*  45609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxu2fp),
     /*  45617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  45620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  45623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45642 */     // MIs[1] Operand 1
     /*  45642 */     // No operand predicates
     /*  45642 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45644 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3761:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxu2hq:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxu2hq),
     /*  45647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45651 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45657 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45663 */     GIR_RootConstrainSelectedInstOperands,
     /*  45664 */     // GIR_Coverage, 1667,
     /*  45664 */     GIR_EraseRootFromParent_Done,
     /*  45665 */   // Label 1010: @45665
     /*  45665 */   GIM_Try, /*On fail goto*//*Label 1011*/ GIMT_Encode4(45726), // Rule ID 1725 //
     /*  45670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  45673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_sqshl),
     /*  45678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45703 */     // MIs[1] Operand 1
     /*  45703 */     // No operand predicates
     /*  45703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45705 */     // (intrinsic_wo_chain:{ *:[i32] } 3585:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)  =>  (MVE_SQSHL:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)
     /*  45705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_SQSHL),
     /*  45708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  45710 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  45712 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  45715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45718 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45724 */     GIR_RootConstrainSelectedInstOperands,
     /*  45725 */     // GIR_Coverage, 1725,
     /*  45725 */     GIR_EraseRootFromParent_Done,
     /*  45726 */   // Label 1011: @45726
     /*  45726 */   GIM_Try, /*On fail goto*//*Label 1012*/ GIMT_Encode4(45787), // Rule ID 1726 //
     /*  45731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  45734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_srshr),
     /*  45739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45764 */     // MIs[1] Operand 1
     /*  45764 */     // No operand predicates
     /*  45764 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45766 */     // (intrinsic_wo_chain:{ *:[i32] } 3587:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)  =>  (MVE_SRSHR:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)
     /*  45766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_SRSHR),
     /*  45769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  45771 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  45773 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  45776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45779 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45785 */     GIR_RootConstrainSelectedInstOperands,
     /*  45786 */     // GIR_Coverage, 1726,
     /*  45786 */     GIR_EraseRootFromParent_Done,
     /*  45787 */   // Label 1012: @45787
     /*  45787 */   GIM_Try, /*On fail goto*//*Label 1013*/ GIMT_Encode4(45848), // Rule ID 1727 //
     /*  45792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  45795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_uqshl),
     /*  45800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45825 */     // MIs[1] Operand 1
     /*  45825 */     // No operand predicates
     /*  45825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45827 */     // (intrinsic_wo_chain:{ *:[i32] } 3592:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)  =>  (MVE_UQSHL:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)
     /*  45827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_UQSHL),
     /*  45830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  45832 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  45834 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  45837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45840 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45846 */     GIR_RootConstrainSelectedInstOperands,
     /*  45847 */     // GIR_Coverage, 1727,
     /*  45847 */     GIR_EraseRootFromParent_Done,
     /*  45848 */   // Label 1013: @45848
     /*  45848 */   GIM_Try, /*On fail goto*//*Label 1014*/ GIMT_Encode4(45909), // Rule ID 1728 //
     /*  45853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  45856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_urshr),
     /*  45861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45886 */     // MIs[1] Operand 1
     /*  45886 */     // No operand predicates
     /*  45886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45888 */     // (intrinsic_wo_chain:{ *:[i32] } 3594:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)  =>  (MVE_URSHR:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)
     /*  45888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_URSHR),
     /*  45891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  45893 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  45895 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  45898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45901 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45907 */     GIR_RootConstrainSelectedInstOperands,
     /*  45908 */     // GIR_Coverage, 1728,
     /*  45908 */     GIR_EraseRootFromParent_Done,
     /*  45909 */   // Label 1014: @45909
     /*  45909 */   GIM_Try, /*On fail goto*//*Label 1015*/ GIMT_Encode4(45963), // Rule ID 105 //
     /*  45914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  45917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd8),
     /*  45922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45943 */     // (intrinsic_wo_chain:{ *:[i32] } 3864:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  45943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QADD8),
     /*  45946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  45950 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  45952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45955 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45961 */     GIR_RootConstrainSelectedInstOperands,
     /*  45962 */     // GIR_Coverage, 105,
     /*  45962 */     GIR_EraseRootFromParent_Done,
     /*  45963 */   // Label 1015: @45963
     /*  45963 */   GIM_Try, /*On fail goto*//*Label 1016*/ GIMT_Encode4(46017), // Rule ID 106 //
     /*  45968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  45971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd16),
     /*  45976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45997 */     // (intrinsic_wo_chain:{ *:[i32] } 3863:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  45997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QADD16),
     /*  46000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46004 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46009 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46015 */     GIR_RootConstrainSelectedInstOperands,
     /*  46016 */     // GIR_Coverage, 106,
     /*  46016 */     GIR_EraseRootFromParent_Done,
     /*  46017 */   // Label 1016: @46017
     /*  46017 */   GIM_Try, /*On fail goto*//*Label 1017*/ GIMT_Encode4(46071), // Rule ID 107 //
     /*  46022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub16),
     /*  46030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46051 */     // (intrinsic_wo_chain:{ *:[i32] } 3868:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QSUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QSUB16),
     /*  46054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46058 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46063 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46069 */     GIR_RootConstrainSelectedInstOperands,
     /*  46070 */     // GIR_Coverage, 107,
     /*  46070 */     GIR_EraseRootFromParent_Done,
     /*  46071 */   // Label 1017: @46071
     /*  46071 */   GIM_Try, /*On fail goto*//*Label 1018*/ GIMT_Encode4(46125), // Rule ID 108 //
     /*  46076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub8),
     /*  46084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46105 */     // (intrinsic_wo_chain:{ *:[i32] } 3869:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QSUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QSUB8),
     /*  46108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46110 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46112 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46117 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46123 */     GIR_RootConstrainSelectedInstOperands,
     /*  46124 */     // GIR_Coverage, 108,
     /*  46124 */     GIR_EraseRootFromParent_Done,
     /*  46125 */   // Label 1018: @46125
     /*  46125 */   GIM_Try, /*On fail goto*//*Label 1019*/ GIMT_Encode4(46179), // Rule ID 111 //
     /*  46130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub),
     /*  46138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46159 */     // (intrinsic_wo_chain:{ *:[i32] } 3867:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)  =>  (QSUB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)
     /*  46159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QSUB),
     /*  46162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46164 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  46166 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /*  46168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46171 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46177 */     GIR_RootConstrainSelectedInstOperands,
     /*  46178 */     // GIR_Coverage, 111,
     /*  46178 */     GIR_EraseRootFromParent_Done,
     /*  46179 */   // Label 1019: @46179
     /*  46179 */   GIM_Try, /*On fail goto*//*Label 1020*/ GIMT_Encode4(46233), // Rule ID 112 //
     /*  46184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  46192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46213 */     // (intrinsic_wo_chain:{ *:[i32] } 3862:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)  =>  (QADD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)
     /*  46213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QADD),
     /*  46216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  46220 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /*  46222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46225 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46231 */     GIR_RootConstrainSelectedInstOperands,
     /*  46232 */     // GIR_Coverage, 112,
     /*  46232 */     GIR_EraseRootFromParent_Done,
     /*  46233 */   // Label 1020: @46233
     /*  46233 */   GIM_Try, /*On fail goto*//*Label 1021*/ GIMT_Encode4(46287), // Rule ID 113 //
     /*  46238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqadd16),
     /*  46246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46267 */     // (intrinsic_wo_chain:{ *:[i32] } 3931:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQADD16),
     /*  46270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46274 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46279 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46285 */     GIR_RootConstrainSelectedInstOperands,
     /*  46286 */     // GIR_Coverage, 113,
     /*  46286 */     GIR_EraseRootFromParent_Done,
     /*  46287 */   // Label 1021: @46287
     /*  46287 */   GIM_Try, /*On fail goto*//*Label 1022*/ GIMT_Encode4(46341), // Rule ID 114 //
     /*  46292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqadd8),
     /*  46300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46321 */     // (intrinsic_wo_chain:{ *:[i32] } 3932:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQADD8),
     /*  46324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46326 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46328 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46333 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46339 */     GIR_RootConstrainSelectedInstOperands,
     /*  46340 */     // GIR_Coverage, 114,
     /*  46340 */     GIR_EraseRootFromParent_Done,
     /*  46341 */   // Label 1022: @46341
     /*  46341 */   GIM_Try, /*On fail goto*//*Label 1023*/ GIMT_Encode4(46395), // Rule ID 115 //
     /*  46346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsub16),
     /*  46354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46375 */     // (intrinsic_wo_chain:{ *:[i32] } 3935:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQSUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQSUB16),
     /*  46378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46380 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46382 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46387 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46393 */     GIR_RootConstrainSelectedInstOperands,
     /*  46394 */     // GIR_Coverage, 115,
     /*  46394 */     GIR_EraseRootFromParent_Done,
     /*  46395 */   // Label 1023: @46395
     /*  46395 */   GIM_Try, /*On fail goto*//*Label 1024*/ GIMT_Encode4(46449), // Rule ID 116 //
     /*  46400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsub8),
     /*  46408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46429 */     // (intrinsic_wo_chain:{ *:[i32] } 3936:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQSUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQSUB8),
     /*  46432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46436 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46441 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46447 */     GIR_RootConstrainSelectedInstOperands,
     /*  46448 */     // GIR_Coverage, 116,
     /*  46448 */     GIR_EraseRootFromParent_Done,
     /*  46449 */   // Label 1024: @46449
     /*  46449 */   GIM_Try, /*On fail goto*//*Label 1025*/ GIMT_Encode4(46503), // Rule ID 117 //
     /*  46454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qasx),
     /*  46462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46483 */     // (intrinsic_wo_chain:{ *:[i32] } 3865:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QASX),
     /*  46486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46490 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46495 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46501 */     GIR_RootConstrainSelectedInstOperands,
     /*  46502 */     // GIR_Coverage, 117,
     /*  46502 */     GIR_EraseRootFromParent_Done,
     /*  46503 */   // Label 1025: @46503
     /*  46503 */   GIM_Try, /*On fail goto*//*Label 1026*/ GIMT_Encode4(46557), // Rule ID 118 //
     /*  46508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsax),
     /*  46516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46537 */     // (intrinsic_wo_chain:{ *:[i32] } 3866:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QSAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QSAX),
     /*  46540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46544 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46549 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46555 */     GIR_RootConstrainSelectedInstOperands,
     /*  46556 */     // GIR_Coverage, 118,
     /*  46556 */     GIR_EraseRootFromParent_Done,
     /*  46557 */   // Label 1026: @46557
     /*  46557 */   GIM_Try, /*On fail goto*//*Label 1027*/ GIMT_Encode4(46611), // Rule ID 119 //
     /*  46562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqasx),
     /*  46570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46591 */     // (intrinsic_wo_chain:{ *:[i32] } 3933:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQASX),
     /*  46594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46603 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46609 */     GIR_RootConstrainSelectedInstOperands,
     /*  46610 */     // GIR_Coverage, 119,
     /*  46610 */     GIR_EraseRootFromParent_Done,
     /*  46611 */   // Label 1027: @46611
     /*  46611 */   GIM_Try, /*On fail goto*//*Label 1028*/ GIMT_Encode4(46665), // Rule ID 120 //
     /*  46616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsax),
     /*  46624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46645 */     // (intrinsic_wo_chain:{ *:[i32] } 3934:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQSAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQSAX),
     /*  46648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46650 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46652 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46657 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46663 */     GIR_RootConstrainSelectedInstOperands,
     /*  46664 */     // GIR_Coverage, 120,
     /*  46664 */     GIR_EraseRootFromParent_Done,
     /*  46665 */   // Label 1028: @46665
     /*  46665 */   GIM_Try, /*On fail goto*//*Label 1029*/ GIMT_Encode4(46719), // Rule ID 133 //
     /*  46670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shasx),
     /*  46678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46699 */     // (intrinsic_wo_chain:{ *:[i32] } 3877:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHASX),
     /*  46702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46706 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46711 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46717 */     GIR_RootConstrainSelectedInstOperands,
     /*  46718 */     // GIR_Coverage, 133,
     /*  46718 */     GIR_EraseRootFromParent_Done,
     /*  46719 */   // Label 1029: @46719
     /*  46719 */   GIM_Try, /*On fail goto*//*Label 1030*/ GIMT_Encode4(46773), // Rule ID 134 //
     /*  46724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shadd16),
     /*  46732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46753 */     // (intrinsic_wo_chain:{ *:[i32] } 3875:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHADD16),
     /*  46756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46760 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46765 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46771 */     GIR_RootConstrainSelectedInstOperands,
     /*  46772 */     // GIR_Coverage, 134,
     /*  46772 */     GIR_EraseRootFromParent_Done,
     /*  46773 */   // Label 1030: @46773
     /*  46773 */   GIM_Try, /*On fail goto*//*Label 1031*/ GIMT_Encode4(46827), // Rule ID 135 //
     /*  46778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shadd8),
     /*  46786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46807 */     // (intrinsic_wo_chain:{ *:[i32] } 3876:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHADD8),
     /*  46810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46819 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46825 */     GIR_RootConstrainSelectedInstOperands,
     /*  46826 */     // GIR_Coverage, 135,
     /*  46826 */     GIR_EraseRootFromParent_Done,
     /*  46827 */   // Label 1031: @46827
     /*  46827 */   GIM_Try, /*On fail goto*//*Label 1032*/ GIMT_Encode4(46881), // Rule ID 136 //
     /*  46832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsax),
     /*  46840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46861 */     // (intrinsic_wo_chain:{ *:[i32] } 3878:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHSAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHSAX),
     /*  46864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46873 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46879 */     GIR_RootConstrainSelectedInstOperands,
     /*  46880 */     // GIR_Coverage, 136,
     /*  46880 */     GIR_EraseRootFromParent_Done,
     /*  46881 */   // Label 1032: @46881
     /*  46881 */   GIM_Try, /*On fail goto*//*Label 1033*/ GIMT_Encode4(46935), // Rule ID 137 //
     /*  46886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsub16),
     /*  46894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46915 */     // (intrinsic_wo_chain:{ *:[i32] } 3879:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHSUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHSUB16),
     /*  46918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46922 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46927 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46933 */     GIR_RootConstrainSelectedInstOperands,
     /*  46934 */     // GIR_Coverage, 137,
     /*  46934 */     GIR_EraseRootFromParent_Done,
     /*  46935 */   // Label 1033: @46935
     /*  46935 */   GIM_Try, /*On fail goto*//*Label 1034*/ GIMT_Encode4(46989), // Rule ID 138 //
     /*  46940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsub8),
     /*  46948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46969 */     // (intrinsic_wo_chain:{ *:[i32] } 3880:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHSUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHSUB8),
     /*  46972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46974 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46976 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46981 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46987 */     GIR_RootConstrainSelectedInstOperands,
     /*  46988 */     // GIR_Coverage, 138,
     /*  46988 */     GIR_EraseRootFromParent_Done,
     /*  46989 */   // Label 1034: @46989
     /*  46989 */   GIM_Try, /*On fail goto*//*Label 1035*/ GIMT_Encode4(47043), // Rule ID 139 //
     /*  46994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhasx),
     /*  47002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47023 */     // (intrinsic_wo_chain:{ *:[i32] } 3926:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHASX),
     /*  47026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47030 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47035 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47041 */     GIR_RootConstrainSelectedInstOperands,
     /*  47042 */     // GIR_Coverage, 139,
     /*  47042 */     GIR_EraseRootFromParent_Done,
     /*  47043 */   // Label 1035: @47043
     /*  47043 */   GIM_Try, /*On fail goto*//*Label 1036*/ GIMT_Encode4(47097), // Rule ID 140 //
     /*  47048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  47051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhadd16),
     /*  47056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47077 */     // (intrinsic_wo_chain:{ *:[i32] } 3924:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHADD16),
     /*  47080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47084 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47089 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47095 */     GIR_RootConstrainSelectedInstOperands,
     /*  47096 */     // GIR_Coverage, 140,
     /*  47096 */     GIR_EraseRootFromParent_Done,
     /*  47097 */   // Label 1036: @47097
     /*  47097 */   GIM_Try, /*On fail goto*//*Label 1037*/ GIMT_Encode4(47151), // Rule ID 141 //
     /*  47102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  47105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhadd8),
     /*  47110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47131 */     // (intrinsic_wo_chain:{ *:[i32] } 3925:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHADD8),
     /*  47134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47138 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47143 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47149 */     GIR_RootConstrainSelectedInstOperands,
     /*  47150 */     // GIR_Coverage, 141,
     /*  47150 */     GIR_EraseRootFromParent_Done,
     /*  47151 */   // Label 1037: @47151
     /*  47151 */   GIM_Try, /*On fail goto*//*Label 1038*/ GIMT_Encode4(47205), // Rule ID 142 //
     /*  47156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  47159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsax),
     /*  47164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47185 */     // (intrinsic_wo_chain:{ *:[i32] } 3927:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHSAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHSAX),
     /*  47188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47197 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47203 */     GIR_RootConstrainSelectedInstOperands,
     /*  47204 */     // GIR_Coverage, 142,
     /*  47204 */     GIR_EraseRootFromParent_Done,
     /*  47205 */   // Label 1038: @47205
     /*  47205 */   GIM_Try, /*On fail goto*//*Label 1039*/ GIMT_Encode4(47259), // Rule ID 143 //
     /*  47210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  47213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsub16),
     /*  47218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47239 */     // (intrinsic_wo_chain:{ *:[i32] } 3928:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHSUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHSUB16),
     /*  47242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47246 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47251 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47257 */     GIR_RootConstrainSelectedInstOperands,
     /*  47258 */     // GIR_Coverage, 143,
     /*  47258 */     GIR_EraseRootFromParent_Done,
     /*  47259 */   // Label 1039: @47259
     /*  47259 */   GIM_Try, /*On fail goto*//*Label 1040*/ GIMT_Encode4(47313), // Rule ID 144 //
     /*  47264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  47267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsub8),
     /*  47272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47293 */     // (intrinsic_wo_chain:{ *:[i32] } 3929:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHSUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHSUB8),
     /*  47296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47298 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47300 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47305 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47311 */     GIR_RootConstrainSelectedInstOperands,
     /*  47312 */     // GIR_Coverage, 144,
     /*  47312 */     GIR_EraseRootFromParent_Done,
     /*  47313 */   // Label 1040: @47313
     /*  47313 */   GIM_Try, /*On fail goto*//*Label 1041*/ GIMT_Encode4(47367), // Rule ID 145 //
     /*  47318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  47321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usad8),
     /*  47326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  47339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  47343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  47347 */     // (intrinsic_wo_chain:{ *:[i32] } 3937:{ *:[iPTR] }, GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (USAD8:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  47347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USAD8),
     /*  47350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47354 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47359 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47365 */     GIR_RootConstrainSelectedInstOperands,
     /*  47366 */     // GIR_Coverage, 145,
     /*  47366 */     GIR_EraseRootFromParent_Done,
     /*  47367 */   // Label 1041: @47367
     /*  47367 */   GIM_Try, /*On fail goto*//*Label 1042*/ GIMT_Encode4(47412), // Rule ID 204 //
     /*  47372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32b),
     /*  47380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47401 */     // (intrinsic_wo_chain:{ *:[i32] } 3499:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32B:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32B),
     /*  47404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47410 */     GIR_RootConstrainSelectedInstOperands,
     /*  47411 */     // GIR_Coverage, 204,
     /*  47411 */     GIR_EraseRootFromParent_Done,
     /*  47412 */   // Label 1042: @47412
     /*  47412 */   GIM_Try, /*On fail goto*//*Label 1043*/ GIMT_Encode4(47457), // Rule ID 205 //
     /*  47417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32cb),
     /*  47425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47446 */     // (intrinsic_wo_chain:{ *:[i32] } 3500:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32CB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32CB),
     /*  47449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47453 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47455 */     GIR_RootConstrainSelectedInstOperands,
     /*  47456 */     // GIR_Coverage, 205,
     /*  47456 */     GIR_EraseRootFromParent_Done,
     /*  47457 */   // Label 1043: @47457
     /*  47457 */   GIM_Try, /*On fail goto*//*Label 1044*/ GIMT_Encode4(47502), // Rule ID 206 //
     /*  47462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32h),
     /*  47470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47491 */     // (intrinsic_wo_chain:{ *:[i32] } 3503:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32H:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32H),
     /*  47494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47500 */     GIR_RootConstrainSelectedInstOperands,
     /*  47501 */     // GIR_Coverage, 206,
     /*  47501 */     GIR_EraseRootFromParent_Done,
     /*  47502 */   // Label 1044: @47502
     /*  47502 */   GIM_Try, /*On fail goto*//*Label 1045*/ GIMT_Encode4(47547), // Rule ID 207 //
     /*  47507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32ch),
     /*  47515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47536 */     // (intrinsic_wo_chain:{ *:[i32] } 3501:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32CH:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32CH),
     /*  47539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47545 */     GIR_RootConstrainSelectedInstOperands,
     /*  47546 */     // GIR_Coverage, 207,
     /*  47546 */     GIR_EraseRootFromParent_Done,
     /*  47547 */   // Label 1045: @47547
     /*  47547 */   GIM_Try, /*On fail goto*//*Label 1046*/ GIMT_Encode4(47592), // Rule ID 208 //
     /*  47552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32w),
     /*  47560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47581 */     // (intrinsic_wo_chain:{ *:[i32] } 3504:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32W:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32W),
     /*  47584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47588 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47590 */     GIR_RootConstrainSelectedInstOperands,
     /*  47591 */     // GIR_Coverage, 208,
     /*  47591 */     GIR_EraseRootFromParent_Done,
     /*  47592 */   // Label 1046: @47592
     /*  47592 */   GIM_Try, /*On fail goto*//*Label 1047*/ GIMT_Encode4(47637), // Rule ID 209 //
     /*  47597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32cw),
     /*  47605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47626 */     // (intrinsic_wo_chain:{ *:[i32] } 3502:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32CW:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32CW),
     /*  47629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47633 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47635 */     GIR_RootConstrainSelectedInstOperands,
     /*  47636 */     // GIR_Coverage, 209,
     /*  47636 */     GIR_EraseRootFromParent_Done,
     /*  47637 */   // Label 1047: @47637
     /*  47637 */   GIM_Try, /*On fail goto*//*Label 1048*/ GIMT_Encode4(47691), // Rule ID 432 //
     /*  47642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd16),
     /*  47650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47671 */     // (intrinsic_wo_chain:{ *:[i32] } 3863:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QADD16),
     /*  47674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47678 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47683 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47689 */     GIR_RootConstrainSelectedInstOperands,
     /*  47690 */     // GIR_Coverage, 432,
     /*  47690 */     GIR_EraseRootFromParent_Done,
     /*  47691 */   // Label 1048: @47691
     /*  47691 */   GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(47745), // Rule ID 433 //
     /*  47696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd8),
     /*  47704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47725 */     // (intrinsic_wo_chain:{ *:[i32] } 3864:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QADD8),
     /*  47728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47732 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47737 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47743 */     GIR_RootConstrainSelectedInstOperands,
     /*  47744 */     // GIR_Coverage, 433,
     /*  47744 */     GIR_EraseRootFromParent_Done,
     /*  47745 */   // Label 1049: @47745
     /*  47745 */   GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(47799), // Rule ID 434 //
     /*  47750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qasx),
     /*  47758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47779 */     // (intrinsic_wo_chain:{ *:[i32] } 3865:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QASX),
     /*  47782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47784 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47786 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47791 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47797 */     GIR_RootConstrainSelectedInstOperands,
     /*  47798 */     // GIR_Coverage, 434,
     /*  47798 */     GIR_EraseRootFromParent_Done,
     /*  47799 */   // Label 1050: @47799
     /*  47799 */   GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(47853), // Rule ID 435 //
     /*  47804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsub8),
     /*  47812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47833 */     // (intrinsic_wo_chain:{ *:[i32] } 3936:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQSUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQSUB8),
     /*  47836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47845 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47851 */     GIR_RootConstrainSelectedInstOperands,
     /*  47852 */     // GIR_Coverage, 435,
     /*  47852 */     GIR_EraseRootFromParent_Done,
     /*  47853 */   // Label 1051: @47853
     /*  47853 */   GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(47907), // Rule ID 436 //
     /*  47858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsax),
     /*  47866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47887 */     // (intrinsic_wo_chain:{ *:[i32] } 3866:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QSAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QSAX),
     /*  47890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47899 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47905 */     GIR_RootConstrainSelectedInstOperands,
     /*  47906 */     // GIR_Coverage, 436,
     /*  47906 */     GIR_EraseRootFromParent_Done,
     /*  47907 */   // Label 1052: @47907
     /*  47907 */   GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(47961), // Rule ID 437 //
     /*  47912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub16),
     /*  47920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47941 */     // (intrinsic_wo_chain:{ *:[i32] } 3868:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QSUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QSUB16),
     /*  47944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47953 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47959 */     GIR_RootConstrainSelectedInstOperands,
     /*  47960 */     // GIR_Coverage, 437,
     /*  47960 */     GIR_EraseRootFromParent_Done,
     /*  47961 */   // Label 1053: @47961
     /*  47961 */   GIM_Try, /*On fail goto*//*Label 1054*/ GIMT_Encode4(48015), // Rule ID 438 //
     /*  47966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub8),
     /*  47974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47995 */     // (intrinsic_wo_chain:{ *:[i32] } 3869:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QSUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QSUB8),
     /*  47998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48002 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48007 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48013 */     GIR_RootConstrainSelectedInstOperands,
     /*  48014 */     // GIR_Coverage, 438,
     /*  48014 */     GIR_EraseRootFromParent_Done,
     /*  48015 */   // Label 1054: @48015
     /*  48015 */   GIM_Try, /*On fail goto*//*Label 1055*/ GIMT_Encode4(48069), // Rule ID 439 //
     /*  48020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqadd16),
     /*  48028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48049 */     // (intrinsic_wo_chain:{ *:[i32] } 3931:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQADD16),
     /*  48052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48054 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48056 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48061 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48067 */     GIR_RootConstrainSelectedInstOperands,
     /*  48068 */     // GIR_Coverage, 439,
     /*  48068 */     GIR_EraseRootFromParent_Done,
     /*  48069 */   // Label 1055: @48069
     /*  48069 */   GIM_Try, /*On fail goto*//*Label 1056*/ GIMT_Encode4(48123), // Rule ID 440 //
     /*  48074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqadd8),
     /*  48082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48103 */     // (intrinsic_wo_chain:{ *:[i32] } 3932:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQADD8),
     /*  48106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48110 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48115 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48121 */     GIR_RootConstrainSelectedInstOperands,
     /*  48122 */     // GIR_Coverage, 440,
     /*  48122 */     GIR_EraseRootFromParent_Done,
     /*  48123 */   // Label 1056: @48123
     /*  48123 */   GIM_Try, /*On fail goto*//*Label 1057*/ GIMT_Encode4(48177), // Rule ID 441 //
     /*  48128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqasx),
     /*  48136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48157 */     // (intrinsic_wo_chain:{ *:[i32] } 3933:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQASX),
     /*  48160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48162 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48164 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48169 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48175 */     GIR_RootConstrainSelectedInstOperands,
     /*  48176 */     // GIR_Coverage, 441,
     /*  48176 */     GIR_EraseRootFromParent_Done,
     /*  48177 */   // Label 1057: @48177
     /*  48177 */   GIM_Try, /*On fail goto*//*Label 1058*/ GIMT_Encode4(48231), // Rule ID 442 //
     /*  48182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsax),
     /*  48190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48211 */     // (intrinsic_wo_chain:{ *:[i32] } 3934:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQSAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQSAX),
     /*  48214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48223 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48229 */     GIR_RootConstrainSelectedInstOperands,
     /*  48230 */     // GIR_Coverage, 442,
     /*  48230 */     GIR_EraseRootFromParent_Done,
     /*  48231 */   // Label 1058: @48231
     /*  48231 */   GIM_Try, /*On fail goto*//*Label 1059*/ GIMT_Encode4(48285), // Rule ID 443 //
     /*  48236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsub16),
     /*  48244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48265 */     // (intrinsic_wo_chain:{ *:[i32] } 3935:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQSUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQSUB16),
     /*  48268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48270 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48272 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48277 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48283 */     GIR_RootConstrainSelectedInstOperands,
     /*  48284 */     // GIR_Coverage, 443,
     /*  48284 */     GIR_EraseRootFromParent_Done,
     /*  48285 */   // Label 1059: @48285
     /*  48285 */   GIM_Try, /*On fail goto*//*Label 1060*/ GIMT_Encode4(48339), // Rule ID 456 //
     /*  48290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shasx),
     /*  48298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48319 */     // (intrinsic_wo_chain:{ *:[i32] } 3877:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHASX),
     /*  48322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48331 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48337 */     GIR_RootConstrainSelectedInstOperands,
     /*  48338 */     // GIR_Coverage, 456,
     /*  48338 */     GIR_EraseRootFromParent_Done,
     /*  48339 */   // Label 1060: @48339
     /*  48339 */   GIM_Try, /*On fail goto*//*Label 1061*/ GIMT_Encode4(48393), // Rule ID 457 //
     /*  48344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shadd16),
     /*  48352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48373 */     // (intrinsic_wo_chain:{ *:[i32] } 3875:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHADD16),
     /*  48376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48380 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48385 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48391 */     GIR_RootConstrainSelectedInstOperands,
     /*  48392 */     // GIR_Coverage, 457,
     /*  48392 */     GIR_EraseRootFromParent_Done,
     /*  48393 */   // Label 1061: @48393
     /*  48393 */   GIM_Try, /*On fail goto*//*Label 1062*/ GIMT_Encode4(48447), // Rule ID 458 //
     /*  48398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shadd8),
     /*  48406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48427 */     // (intrinsic_wo_chain:{ *:[i32] } 3876:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHADD8),
     /*  48430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48432 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48434 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48439 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48445 */     GIR_RootConstrainSelectedInstOperands,
     /*  48446 */     // GIR_Coverage, 458,
     /*  48446 */     GIR_EraseRootFromParent_Done,
     /*  48447 */   // Label 1062: @48447
     /*  48447 */   GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(48501), // Rule ID 459 //
     /*  48452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsax),
     /*  48460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48481 */     // (intrinsic_wo_chain:{ *:[i32] } 3878:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHSAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHSAX),
     /*  48484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48493 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48499 */     GIR_RootConstrainSelectedInstOperands,
     /*  48500 */     // GIR_Coverage, 459,
     /*  48500 */     GIR_EraseRootFromParent_Done,
     /*  48501 */   // Label 1063: @48501
     /*  48501 */   GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(48555), // Rule ID 460 //
     /*  48506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsub16),
     /*  48514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48535 */     // (intrinsic_wo_chain:{ *:[i32] } 3879:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHSUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHSUB16),
     /*  48538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48540 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48542 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48547 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48553 */     GIR_RootConstrainSelectedInstOperands,
     /*  48554 */     // GIR_Coverage, 460,
     /*  48554 */     GIR_EraseRootFromParent_Done,
     /*  48555 */   // Label 1064: @48555
     /*  48555 */   GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(48609), // Rule ID 461 //
     /*  48560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsub8),
     /*  48568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48589 */     // (intrinsic_wo_chain:{ *:[i32] } 3880:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHSUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHSUB8),
     /*  48592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48594 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48596 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48601 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48607 */     GIR_RootConstrainSelectedInstOperands,
     /*  48608 */     // GIR_Coverage, 461,
     /*  48608 */     GIR_EraseRootFromParent_Done,
     /*  48609 */   // Label 1065: @48609
     /*  48609 */   GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(48663), // Rule ID 462 //
     /*  48614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhasx),
     /*  48622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48643 */     // (intrinsic_wo_chain:{ *:[i32] } 3926:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHASX),
     /*  48646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48650 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48655 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48661 */     GIR_RootConstrainSelectedInstOperands,
     /*  48662 */     // GIR_Coverage, 462,
     /*  48662 */     GIR_EraseRootFromParent_Done,
     /*  48663 */   // Label 1066: @48663
     /*  48663 */   GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(48717), // Rule ID 463 //
     /*  48668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhadd16),
     /*  48676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48697 */     // (intrinsic_wo_chain:{ *:[i32] } 3924:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHADD16),
     /*  48700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48704 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48709 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48715 */     GIR_RootConstrainSelectedInstOperands,
     /*  48716 */     // GIR_Coverage, 463,
     /*  48716 */     GIR_EraseRootFromParent_Done,
     /*  48717 */   // Label 1067: @48717
     /*  48717 */   GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(48771), // Rule ID 464 //
     /*  48722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhadd8),
     /*  48730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48751 */     // (intrinsic_wo_chain:{ *:[i32] } 3925:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHADD8),
     /*  48754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48758 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48763 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48769 */     GIR_RootConstrainSelectedInstOperands,
     /*  48770 */     // GIR_Coverage, 464,
     /*  48770 */     GIR_EraseRootFromParent_Done,
     /*  48771 */   // Label 1068: @48771
     /*  48771 */   GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(48825), // Rule ID 465 //
     /*  48776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsax),
     /*  48784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48805 */     // (intrinsic_wo_chain:{ *:[i32] } 3927:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHSAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHSAX),
     /*  48808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48812 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48817 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48823 */     GIR_RootConstrainSelectedInstOperands,
     /*  48824 */     // GIR_Coverage, 465,
     /*  48824 */     GIR_EraseRootFromParent_Done,
     /*  48825 */   // Label 1069: @48825
     /*  48825 */   GIM_Try, /*On fail goto*//*Label 1070*/ GIMT_Encode4(48879), // Rule ID 466 //
     /*  48830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsub16),
     /*  48838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48859 */     // (intrinsic_wo_chain:{ *:[i32] } 3928:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHSUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHSUB16),
     /*  48862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48866 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48871 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48877 */     GIR_RootConstrainSelectedInstOperands,
     /*  48878 */     // GIR_Coverage, 466,
     /*  48878 */     GIR_EraseRootFromParent_Done,
     /*  48879 */   // Label 1070: @48879
     /*  48879 */   GIM_Try, /*On fail goto*//*Label 1071*/ GIMT_Encode4(48933), // Rule ID 467 //
     /*  48884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsub8),
     /*  48892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48913 */     // (intrinsic_wo_chain:{ *:[i32] } 3929:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHSUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHSUB8),
     /*  48916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48925 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48931 */     GIR_RootConstrainSelectedInstOperands,
     /*  48932 */     // GIR_Coverage, 467,
     /*  48932 */     GIR_EraseRootFromParent_Done,
     /*  48933 */   // Label 1071: @48933
     /*  48933 */   GIM_Try, /*On fail goto*//*Label 1072*/ GIMT_Encode4(48987), // Rule ID 468 //
     /*  48938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usad8),
     /*  48946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48967 */     // (intrinsic_wo_chain:{ *:[i32] } 3937:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2USAD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USAD8),
     /*  48970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48974 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48979 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48985 */     GIR_RootConstrainSelectedInstOperands,
     /*  48986 */     // GIR_Coverage, 468,
     /*  48986 */     GIR_EraseRootFromParent_Done,
     /*  48987 */   // Label 1072: @48987
     /*  48987 */   GIM_Try, /*On fail goto*//*Label 1073*/ GIMT_Encode4(49041), // Rule ID 524 //
     /*  48992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smuad),
     /*  49000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49021 */     // (intrinsic_wo_chain:{ *:[i32] } 3895:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMUAD:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMUAD),
     /*  49024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49028 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49033 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49039 */     GIR_RootConstrainSelectedInstOperands,
     /*  49040 */     // GIR_Coverage, 524,
     /*  49040 */     GIR_EraseRootFromParent_Done,
     /*  49041 */   // Label 1073: @49041
     /*  49041 */   GIM_Try, /*On fail goto*//*Label 1074*/ GIMT_Encode4(49095), // Rule ID 525 //
     /*  49046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  49049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smuadx),
     /*  49054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49075 */     // (intrinsic_wo_chain:{ *:[i32] } 3896:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMUADX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMUADX),
     /*  49078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49082 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49087 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49093 */     GIR_RootConstrainSelectedInstOperands,
     /*  49094 */     // GIR_Coverage, 525,
     /*  49094 */     GIR_EraseRootFromParent_Done,
     /*  49095 */   // Label 1074: @49095
     /*  49095 */   GIM_Try, /*On fail goto*//*Label 1075*/ GIMT_Encode4(49149), // Rule ID 526 //
     /*  49100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  49103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smusd),
     /*  49108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49129 */     // (intrinsic_wo_chain:{ *:[i32] } 3903:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMUSD:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMUSD),
     /*  49132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49136 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49141 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49147 */     GIR_RootConstrainSelectedInstOperands,
     /*  49148 */     // GIR_Coverage, 526,
     /*  49148 */     GIR_EraseRootFromParent_Done,
     /*  49149 */   // Label 1075: @49149
     /*  49149 */   GIM_Try, /*On fail goto*//*Label 1076*/ GIMT_Encode4(49203), // Rule ID 527 //
     /*  49154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  49157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smusdx),
     /*  49162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49183 */     // (intrinsic_wo_chain:{ *:[i32] } 3904:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMUSDX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMUSDX),
     /*  49186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49190 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49195 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49201 */     GIR_RootConstrainSelectedInstOperands,
     /*  49202 */     // GIR_Coverage, 527,
     /*  49202 */     GIR_EraseRootFromParent_Done,
     /*  49203 */   // Label 1076: @49203
     /*  49203 */   GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(49248), // Rule ID 541 //
     /*  49208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  49211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32b),
     /*  49216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49237 */     // (intrinsic_wo_chain:{ *:[i32] } 3499:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32B:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32B),
     /*  49240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49244 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49246 */     GIR_RootConstrainSelectedInstOperands,
     /*  49247 */     // GIR_Coverage, 541,
     /*  49247 */     GIR_EraseRootFromParent_Done,
     /*  49248 */   // Label 1077: @49248
     /*  49248 */   GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(49293), // Rule ID 542 //
     /*  49253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  49256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32cb),
     /*  49261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49282 */     // (intrinsic_wo_chain:{ *:[i32] } 3500:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32CB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32CB),
     /*  49285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49289 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49291 */     GIR_RootConstrainSelectedInstOperands,
     /*  49292 */     // GIR_Coverage, 542,
     /*  49292 */     GIR_EraseRootFromParent_Done,
     /*  49293 */   // Label 1078: @49293
     /*  49293 */   GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(49338), // Rule ID 543 //
     /*  49298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  49301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32h),
     /*  49306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49327 */     // (intrinsic_wo_chain:{ *:[i32] } 3503:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32H:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32H),
     /*  49330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49336 */     GIR_RootConstrainSelectedInstOperands,
     /*  49337 */     // GIR_Coverage, 543,
     /*  49337 */     GIR_EraseRootFromParent_Done,
     /*  49338 */   // Label 1079: @49338
     /*  49338 */   GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(49383), // Rule ID 544 //
     /*  49343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  49346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32ch),
     /*  49351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49372 */     // (intrinsic_wo_chain:{ *:[i32] } 3501:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32CH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32CH),
     /*  49375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49379 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49381 */     GIR_RootConstrainSelectedInstOperands,
     /*  49382 */     // GIR_Coverage, 544,
     /*  49382 */     GIR_EraseRootFromParent_Done,
     /*  49383 */   // Label 1080: @49383
     /*  49383 */   GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(49428), // Rule ID 545 //
     /*  49388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  49391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32w),
     /*  49396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49417 */     // (intrinsic_wo_chain:{ *:[i32] } 3504:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32W:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32W),
     /*  49420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49424 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49426 */     GIR_RootConstrainSelectedInstOperands,
     /*  49427 */     // GIR_Coverage, 545,
     /*  49427 */     GIR_EraseRootFromParent_Done,
     /*  49428 */   // Label 1081: @49428
     /*  49428 */   GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(49473), // Rule ID 546 //
     /*  49433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  49436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32cw),
     /*  49441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49462 */     // (intrinsic_wo_chain:{ *:[i32] } 3502:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32CW:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32CW),
     /*  49465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49469 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49471 */     GIR_RootConstrainSelectedInstOperands,
     /*  49472 */     // GIR_Coverage, 546,
     /*  49472 */     GIR_EraseRootFromParent_Done,
     /*  49473 */   // Label 1082: @49473
     /*  49473 */   GIM_Try, /*On fail goto*//*Label 1083*/ GIMT_Encode4(49527), // Rule ID 792 //
     /*  49478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  49489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  49495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49507 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3769:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VHADDsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  49507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv4i16),
     /*  49510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49512 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49514 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49519 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49525 */     GIR_RootConstrainSelectedInstOperands,
     /*  49526 */     // GIR_Coverage, 792,
     /*  49526 */     GIR_EraseRootFromParent_Done,
     /*  49527 */   // Label 1083: @49527
     /*  49527 */   GIM_Try, /*On fail goto*//*Label 1084*/ GIMT_Encode4(49581), // Rule ID 793 //
     /*  49532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  49543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  49546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  49549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49561 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3769:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VHADDsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  49561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv2i32),
     /*  49564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49566 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49568 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49573 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49579 */     GIR_RootConstrainSelectedInstOperands,
     /*  49580 */     // GIR_Coverage, 793,
     /*  49580 */     GIR_EraseRootFromParent_Done,
     /*  49581 */   // Label 1084: @49581
     /*  49581 */   GIM_Try, /*On fail goto*//*Label 1085*/ GIMT_Encode4(49635), // Rule ID 794 //
     /*  49586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  49597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  49600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  49603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49615 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3769:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VHADDsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  49615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv8i16),
     /*  49618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49620 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49622 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49627 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49633 */     GIR_RootConstrainSelectedInstOperands,
     /*  49634 */     // GIR_Coverage, 794,
     /*  49634 */     GIR_EraseRootFromParent_Done,
     /*  49635 */   // Label 1085: @49635
     /*  49635 */   GIM_Try, /*On fail goto*//*Label 1086*/ GIMT_Encode4(49689), // Rule ID 795 //
     /*  49640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  49651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  49654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  49657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49669 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3769:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VHADDsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  49669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv4i32),
     /*  49672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49676 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49681 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49687 */     GIR_RootConstrainSelectedInstOperands,
     /*  49688 */     // GIR_Coverage, 795,
     /*  49688 */     GIR_EraseRootFromParent_Done,
     /*  49689 */   // Label 1086: @49689
     /*  49689 */   GIM_Try, /*On fail goto*//*Label 1087*/ GIMT_Encode4(49743), // Rule ID 796 //
     /*  49694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  49705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  49708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  49711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49723 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3769:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VHADDsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  49723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv8i8),
     /*  49726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49735 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49741 */     GIR_RootConstrainSelectedInstOperands,
     /*  49742 */     // GIR_Coverage, 796,
     /*  49742 */     GIR_EraseRootFromParent_Done,
     /*  49743 */   // Label 1087: @49743
     /*  49743 */   GIM_Try, /*On fail goto*//*Label 1088*/ GIMT_Encode4(49797), // Rule ID 797 //
     /*  49748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  49759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  49762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  49765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49777 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3769:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VHADDsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  49777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv16i8),
     /*  49780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49789 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49795 */     GIR_RootConstrainSelectedInstOperands,
     /*  49796 */     // GIR_Coverage, 797,
     /*  49796 */     GIR_EraseRootFromParent_Done,
     /*  49797 */   // Label 1088: @49797
     /*  49797 */   GIM_Try, /*On fail goto*//*Label 1089*/ GIMT_Encode4(49851), // Rule ID 798 //
     /*  49802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  49810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  49813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  49819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49831 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3770:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VHADDuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  49831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv4i16),
     /*  49834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49838 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49843 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49849 */     GIR_RootConstrainSelectedInstOperands,
     /*  49850 */     // GIR_Coverage, 798,
     /*  49850 */     GIR_EraseRootFromParent_Done,
     /*  49851 */   // Label 1089: @49851
     /*  49851 */   GIM_Try, /*On fail goto*//*Label 1090*/ GIMT_Encode4(49905), // Rule ID 799 //
     /*  49856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  49864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  49867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  49870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  49873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49885 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3770:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VHADDuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  49885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv2i32),
     /*  49888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49892 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49897 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49903 */     GIR_RootConstrainSelectedInstOperands,
     /*  49904 */     // GIR_Coverage, 799,
     /*  49904 */     GIR_EraseRootFromParent_Done,
     /*  49905 */   // Label 1090: @49905
     /*  49905 */   GIM_Try, /*On fail goto*//*Label 1091*/ GIMT_Encode4(49959), // Rule ID 800 //
     /*  49910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  49918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  49921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  49924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  49927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49939 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3770:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VHADDuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  49939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv8i16),
     /*  49942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49946 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49951 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49957 */     GIR_RootConstrainSelectedInstOperands,
     /*  49958 */     // GIR_Coverage, 800,
     /*  49958 */     GIR_EraseRootFromParent_Done,
     /*  49959 */   // Label 1091: @49959
     /*  49959 */   GIM_Try, /*On fail goto*//*Label 1092*/ GIMT_Encode4(50013), // Rule ID 801 //
     /*  49964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  49972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  49975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  49978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  49981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49993 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3770:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VHADDuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  49993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv4i32),
     /*  49996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50005 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50011 */     GIR_RootConstrainSelectedInstOperands,
     /*  50012 */     // GIR_Coverage, 801,
     /*  50012 */     GIR_EraseRootFromParent_Done,
     /*  50013 */   // Label 1092: @50013
     /*  50013 */   GIM_Try, /*On fail goto*//*Label 1093*/ GIMT_Encode4(50067), // Rule ID 802 //
     /*  50018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  50026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  50029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  50035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50047 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3770:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VHADDuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  50047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv8i8),
     /*  50050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50054 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50059 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50065 */     GIR_RootConstrainSelectedInstOperands,
     /*  50066 */     // GIR_Coverage, 802,
     /*  50066 */     GIR_EraseRootFromParent_Done,
     /*  50067 */   // Label 1093: @50067
     /*  50067 */   GIM_Try, /*On fail goto*//*Label 1094*/ GIMT_Encode4(50121), // Rule ID 803 //
     /*  50072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  50080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  50083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  50086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  50089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50101 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3770:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VHADDuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  50101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv16i8),
     /*  50104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50113 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50119 */     GIR_RootConstrainSelectedInstOperands,
     /*  50120 */     // GIR_Coverage, 803,
     /*  50120 */     GIR_EraseRootFromParent_Done,
     /*  50121 */   // Label 1094: @50121
     /*  50121 */   GIM_Try, /*On fail goto*//*Label 1095*/ GIMT_Encode4(50175), // Rule ID 804 //
     /*  50126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  50134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  50137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  50140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  50143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50155 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3829:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VRHADDsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  50155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv4i16),
     /*  50158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50162 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50167 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50173 */     GIR_RootConstrainSelectedInstOperands,
     /*  50174 */     // GIR_Coverage, 804,
     /*  50174 */     GIR_EraseRootFromParent_Done,
     /*  50175 */   // Label 1095: @50175
     /*  50175 */   GIM_Try, /*On fail goto*//*Label 1096*/ GIMT_Encode4(50229), // Rule ID 805 //
     /*  50180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  50188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  50191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  50194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  50197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50209 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3829:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VRHADDsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  50209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv2i32),
     /*  50212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50214 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50216 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50221 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50227 */     GIR_RootConstrainSelectedInstOperands,
     /*  50228 */     // GIR_Coverage, 805,
     /*  50228 */     GIR_EraseRootFromParent_Done,
     /*  50229 */   // Label 1096: @50229
     /*  50229 */   GIM_Try, /*On fail goto*//*Label 1097*/ GIMT_Encode4(50283), // Rule ID 806 //
     /*  50234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  50242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  50245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  50248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  50251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50263 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3829:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VRHADDsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  50263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv8i16),
     /*  50266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50270 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50275 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50281 */     GIR_RootConstrainSelectedInstOperands,
     /*  50282 */     // GIR_Coverage, 806,
     /*  50282 */     GIR_EraseRootFromParent_Done,
     /*  50283 */   // Label 1097: @50283
     /*  50283 */   GIM_Try, /*On fail goto*//*Label 1098*/ GIMT_Encode4(50337), // Rule ID 807 //
     /*  50288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  50296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  50299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  50302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  50305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50317 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3829:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VRHADDsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  50317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv4i32),
     /*  50320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50324 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50329 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50335 */     GIR_RootConstrainSelectedInstOperands,
     /*  50336 */     // GIR_Coverage, 807,
     /*  50336 */     GIR_EraseRootFromParent_Done,
     /*  50337 */   // Label 1098: @50337
     /*  50337 */   GIM_Try, /*On fail goto*//*Label 1099*/ GIMT_Encode4(50391), // Rule ID 808 //
     /*  50342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  50350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  50353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  50359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50371 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3829:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VRHADDsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  50371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv8i8),
     /*  50374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50378 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50383 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50389 */     GIR_RootConstrainSelectedInstOperands,
     /*  50390 */     // GIR_Coverage, 808,
     /*  50390 */     GIR_EraseRootFromParent_Done,
     /*  50391 */   // Label 1099: @50391
     /*  50391 */   GIM_Try, /*On fail goto*//*Label 1100*/ GIMT_Encode4(50445), // Rule ID 809 //
     /*  50396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  50404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  50407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  50410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  50413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50425 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3829:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VRHADDsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  50425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv16i8),
     /*  50428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50430 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50432 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50437 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50443 */     GIR_RootConstrainSelectedInstOperands,
     /*  50444 */     // GIR_Coverage, 809,
     /*  50444 */     GIR_EraseRootFromParent_Done,
     /*  50445 */   // Label 1100: @50445
     /*  50445 */   GIM_Try, /*On fail goto*//*Label 1101*/ GIMT_Encode4(50499), // Rule ID 810 //
     /*  50450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  50461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  50464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  50467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50479 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3830:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VRHADDuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  50479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv4i16),
     /*  50482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50486 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50491 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50497 */     GIR_RootConstrainSelectedInstOperands,
     /*  50498 */     // GIR_Coverage, 810,
     /*  50498 */     GIR_EraseRootFromParent_Done,
     /*  50499 */   // Label 1101: @50499
     /*  50499 */   GIM_Try, /*On fail goto*//*Label 1102*/ GIMT_Encode4(50553), // Rule ID 811 //
     /*  50504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  50515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  50518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  50521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50533 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3830:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VRHADDuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  50533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv2i32),
     /*  50536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50540 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50545 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50551 */     GIR_RootConstrainSelectedInstOperands,
     /*  50552 */     // GIR_Coverage, 811,
     /*  50552 */     GIR_EraseRootFromParent_Done,
     /*  50553 */   // Label 1102: @50553
     /*  50553 */   GIM_Try, /*On fail goto*//*Label 1103*/ GIMT_Encode4(50607), // Rule ID 812 //
     /*  50558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  50569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  50572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  50575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50587 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3830:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VRHADDuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  50587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv8i16),
     /*  50590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50594 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50599 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50605 */     GIR_RootConstrainSelectedInstOperands,
     /*  50606 */     // GIR_Coverage, 812,
     /*  50606 */     GIR_EraseRootFromParent_Done,
     /*  50607 */   // Label 1103: @50607
     /*  50607 */   GIM_Try, /*On fail goto*//*Label 1104*/ GIMT_Encode4(50661), // Rule ID 813 //
     /*  50612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  50623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  50626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  50629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50641 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3830:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VRHADDuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  50641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv4i32),
     /*  50644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50648 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50653 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50659 */     GIR_RootConstrainSelectedInstOperands,
     /*  50660 */     // GIR_Coverage, 813,
     /*  50660 */     GIR_EraseRootFromParent_Done,
     /*  50661 */   // Label 1104: @50661
     /*  50661 */   GIM_Try, /*On fail goto*//*Label 1105*/ GIMT_Encode4(50715), // Rule ID 814 //
     /*  50666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  50677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  50683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50695 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3830:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VRHADDuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  50695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv8i8),
     /*  50698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50702 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50707 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50713 */     GIR_RootConstrainSelectedInstOperands,
     /*  50714 */     // GIR_Coverage, 814,
     /*  50714 */     GIR_EraseRootFromParent_Done,
     /*  50715 */   // Label 1105: @50715
     /*  50715 */   GIM_Try, /*On fail goto*//*Label 1106*/ GIMT_Encode4(50769), // Rule ID 815 //
     /*  50720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  50731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  50734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  50737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50749 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3830:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VRHADDuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  50749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv16i8),
     /*  50752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50756 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50761 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50767 */     GIR_RootConstrainSelectedInstOperands,
     /*  50768 */     // GIR_Coverage, 815,
     /*  50768 */     GIR_EraseRootFromParent_Done,
     /*  50769 */   // Label 1106: @50769
     /*  50769 */   GIM_Try, /*On fail goto*//*Label 1107*/ GIMT_Encode4(50823), // Rule ID 832 //
     /*  50774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vraddhn),
     /*  50782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  50785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  50788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  50791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50803 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3826:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VRADDHNv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  50803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRADDHNv8i8),
     /*  50806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50810 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50815 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50821 */     GIR_RootConstrainSelectedInstOperands,
     /*  50822 */     // GIR_Coverage, 832,
     /*  50822 */     GIR_EraseRootFromParent_Done,
     /*  50823 */   // Label 1107: @50823
     /*  50823 */   GIM_Try, /*On fail goto*//*Label 1108*/ GIMT_Encode4(50877), // Rule ID 833 //
     /*  50828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vraddhn),
     /*  50836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  50839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  50842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  50845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50857 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3826:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VRADDHNv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  50857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRADDHNv4i16),
     /*  50860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50869 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50875 */     GIR_RootConstrainSelectedInstOperands,
     /*  50876 */     // GIR_Coverage, 833,
     /*  50876 */     GIR_EraseRootFromParent_Done,
     /*  50877 */   // Label 1108: @50877
     /*  50877 */   GIM_Try, /*On fail goto*//*Label 1109*/ GIMT_Encode4(50931), // Rule ID 834 //
     /*  50882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vraddhn),
     /*  50890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  50893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  50896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  50899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50911 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3826:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VRADDHNv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /*  50911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRADDHNv2i32),
     /*  50914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50918 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50923 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50929 */     GIR_RootConstrainSelectedInstOperands,
     /*  50930 */     // GIR_Coverage, 834,
     /*  50930 */     GIR_EraseRootFromParent_Done,
     /*  50931 */   // Label 1109: @50931
     /*  50931 */   GIM_Try, /*On fail goto*//*Label 1110*/ GIMT_Encode4(50985), // Rule ID 841 //
     /*  50936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vmulp),
     /*  50944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  50947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  50953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50965 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3795:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMULpd:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  50965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULpd),
     /*  50968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50972 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50977 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50983 */     GIR_RootConstrainSelectedInstOperands,
     /*  50984 */     // GIR_Coverage, 841,
     /*  50984 */     GIR_EraseRootFromParent_Done,
     /*  50985 */   // Label 1110: @50985
     /*  50985 */   GIM_Try, /*On fail goto*//*Label 1111*/ GIMT_Encode4(51039), // Rule ID 842 //
     /*  50990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vmulp),
     /*  50998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  51001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  51004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  51007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51019 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3795:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMULpq:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  51019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULpq),
     /*  51022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51026 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51031 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51037 */     GIR_RootConstrainSelectedInstOperands,
     /*  51038 */     // GIR_Coverage, 842,
     /*  51038 */     GIR_EraseRootFromParent_Done,
     /*  51039 */   // Label 1111: @51039
     /*  51039 */   GIM_Try, /*On fail goto*//*Label 1112*/ GIMT_Encode4(51093), // Rule ID 855 //
     /*  51044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmulh),
     /*  51052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  51055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  51058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  51061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51073 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3806:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQDMULHv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  51073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULHv4i16),
     /*  51076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51080 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51085 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51091 */     GIR_RootConstrainSelectedInstOperands,
     /*  51092 */     // GIR_Coverage, 855,
     /*  51092 */     GIR_EraseRootFromParent_Done,
     /*  51093 */   // Label 1112: @51093
     /*  51093 */   GIM_Try, /*On fail goto*//*Label 1113*/ GIMT_Encode4(51147), // Rule ID 856 //
     /*  51098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmulh),
     /*  51106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  51109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  51112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  51115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51127 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3806:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQDMULHv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  51127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULHv2i32),
     /*  51130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51139 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51145 */     GIR_RootConstrainSelectedInstOperands,
     /*  51146 */     // GIR_Coverage, 856,
     /*  51146 */     GIR_EraseRootFromParent_Done,
     /*  51147 */   // Label 1113: @51147
     /*  51147 */   GIM_Try, /*On fail goto*//*Label 1114*/ GIMT_Encode4(51201), // Rule ID 857 //
     /*  51152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmulh),
     /*  51160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  51163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  51166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  51169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51181 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3806:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQDMULHv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  51181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULHv8i16),
     /*  51184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51193 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51199 */     GIR_RootConstrainSelectedInstOperands,
     /*  51200 */     // GIR_Coverage, 857,
     /*  51200 */     GIR_EraseRootFromParent_Done,
     /*  51201 */   // Label 1114: @51201
     /*  51201 */   GIM_Try, /*On fail goto*//*Label 1115*/ GIMT_Encode4(51255), // Rule ID 858 //
     /*  51206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmulh),
     /*  51214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  51217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  51220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  51223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51235 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3806:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQDMULHv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  51235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULHv4i32),
     /*  51238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51247 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51253 */     GIR_RootConstrainSelectedInstOperands,
     /*  51254 */     // GIR_Coverage, 858,
     /*  51254 */     GIR_EraseRootFromParent_Done,
     /*  51255 */   // Label 1115: @51255
     /*  51255 */   GIM_Try, /*On fail goto*//*Label 1116*/ GIMT_Encode4(51309), // Rule ID 863 //
     /*  51260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmulh),
     /*  51268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  51271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  51274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  51277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51289 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3814:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQRDMULHv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  51289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMULHv4i16),
     /*  51292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51301 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51307 */     GIR_RootConstrainSelectedInstOperands,
     /*  51308 */     // GIR_Coverage, 863,
     /*  51308 */     GIR_EraseRootFromParent_Done,
     /*  51309 */   // Label 1116: @51309
     /*  51309 */   GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(51363), // Rule ID 864 //
     /*  51314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmulh),
     /*  51322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  51325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  51328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  51331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51343 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3814:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQRDMULHv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  51343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMULHv2i32),
     /*  51346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51350 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51355 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51361 */     GIR_RootConstrainSelectedInstOperands,
     /*  51362 */     // GIR_Coverage, 864,
     /*  51362 */     GIR_EraseRootFromParent_Done,
     /*  51363 */   // Label 1117: @51363
     /*  51363 */   GIM_Try, /*On fail goto*//*Label 1118*/ GIMT_Encode4(51417), // Rule ID 865 //
     /*  51368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmulh),
     /*  51376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  51379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  51382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  51385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51397 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3814:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQRDMULHv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  51397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMULHv8i16),
     /*  51400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51404 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51409 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51415 */     GIR_RootConstrainSelectedInstOperands,
     /*  51416 */     // GIR_Coverage, 865,
     /*  51416 */     GIR_EraseRootFromParent_Done,
     /*  51417 */   // Label 1118: @51417
     /*  51417 */   GIM_Try, /*On fail goto*//*Label 1119*/ GIMT_Encode4(51471), // Rule ID 866 //
     /*  51422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmulh),
     /*  51430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  51433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  51436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  51439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51451 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3814:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQRDMULHv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  51451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMULHv4i32),
     /*  51454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51458 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51463 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51469 */     GIR_RootConstrainSelectedInstOperands,
     /*  51470 */     // GIR_Coverage, 866,
     /*  51470 */     GIR_EraseRootFromParent_Done,
     /*  51471 */   // Label 1119: @51471
     /*  51471 */   GIM_Try, /*On fail goto*//*Label 1120*/ GIMT_Encode4(51525), // Rule ID 877 //
     /*  51476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vmullp),
     /*  51484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  51487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  51490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  51493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51505 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3792:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMULLp8:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  51505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULLp8),
     /*  51508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51512 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51517 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51523 */     GIR_RootConstrainSelectedInstOperands,
     /*  51524 */     // GIR_Coverage, 877,
     /*  51524 */     GIR_EraseRootFromParent_Done,
     /*  51525 */   // Label 1120: @51525
     /*  51525 */   GIM_Try, /*On fail goto*//*Label 1121*/ GIMT_Encode4(51570), // Rule ID 878 //
     /*  51530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasV8),
     /*  51533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vmullp),
     /*  51538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  51541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  51544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  51547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51559 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3792:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VMULLp64:{ *:[v2i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /*  51559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULLp64),
     /*  51562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51566 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51568 */     GIR_RootConstrainSelectedInstOperands,
     /*  51569 */     // GIR_Coverage, 878,
     /*  51569 */     GIR_EraseRootFromParent_Done,
     /*  51570 */   // Label 1121: @51570
     /*  51570 */   GIM_Try, /*On fail goto*//*Label 1122*/ GIMT_Encode4(51624), // Rule ID 883 //
     /*  51575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /*  51583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  51586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  51589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  51592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51604 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3807:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQDMULLv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  51604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULLv4i32),
     /*  51607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51611 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51616 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51622 */     GIR_RootConstrainSelectedInstOperands,
     /*  51623 */     // GIR_Coverage, 883,
     /*  51623 */     GIR_EraseRootFromParent_Done,
     /*  51624 */   // Label 1122: @51624
     /*  51624 */   GIM_Try, /*On fail goto*//*Label 1123*/ GIMT_Encode4(51678), // Rule ID 884 //
     /*  51629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /*  51637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  51640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  51643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  51646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51658 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3807:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQDMULLv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  51658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULLv2i64),
     /*  51661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51665 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51670 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51676 */     GIR_RootConstrainSelectedInstOperands,
     /*  51677 */     // GIR_Coverage, 884,
     /*  51677 */     GIR_EraseRootFromParent_Done,
     /*  51678 */   // Label 1123: @51678
     /*  51678 */   GIM_Try, /*On fail goto*//*Label 1124*/ GIMT_Encode4(51732), // Rule ID 996 //
     /*  51683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  51691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  51694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  51697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  51700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51712 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3771:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VHSUBsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  51712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv4i16),
     /*  51715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51719 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51724 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51730 */     GIR_RootConstrainSelectedInstOperands,
     /*  51731 */     // GIR_Coverage, 996,
     /*  51731 */     GIR_EraseRootFromParent_Done,
     /*  51732 */   // Label 1124: @51732
     /*  51732 */   GIM_Try, /*On fail goto*//*Label 1125*/ GIMT_Encode4(51786), // Rule ID 997 //
     /*  51737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  51745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  51748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  51751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  51754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51766 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3771:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VHSUBsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  51766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv2i32),
     /*  51769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51773 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51778 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51784 */     GIR_RootConstrainSelectedInstOperands,
     /*  51785 */     // GIR_Coverage, 997,
     /*  51785 */     GIR_EraseRootFromParent_Done,
     /*  51786 */   // Label 1125: @51786
     /*  51786 */   GIM_Try, /*On fail goto*//*Label 1126*/ GIMT_Encode4(51840), // Rule ID 998 //
     /*  51791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  51799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  51802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  51805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  51808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51820 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3771:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VHSUBsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  51820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv8i16),
     /*  51823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51827 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51832 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51838 */     GIR_RootConstrainSelectedInstOperands,
     /*  51839 */     // GIR_Coverage, 998,
     /*  51839 */     GIR_EraseRootFromParent_Done,
     /*  51840 */   // Label 1126: @51840
     /*  51840 */   GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(51894), // Rule ID 999 //
     /*  51845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  51853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  51856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  51859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  51862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51874 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3771:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VHSUBsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  51874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv4i32),
     /*  51877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51881 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51886 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51892 */     GIR_RootConstrainSelectedInstOperands,
     /*  51893 */     // GIR_Coverage, 999,
     /*  51893 */     GIR_EraseRootFromParent_Done,
     /*  51894 */   // Label 1127: @51894
     /*  51894 */   GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(51948), // Rule ID 1000 //
     /*  51899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  51907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  51910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  51913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  51916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51928 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3771:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VHSUBsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  51928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv8i8),
     /*  51931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51935 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51940 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51946 */     GIR_RootConstrainSelectedInstOperands,
     /*  51947 */     // GIR_Coverage, 1000,
     /*  51947 */     GIR_EraseRootFromParent_Done,
     /*  51948 */   // Label 1128: @51948
     /*  51948 */   GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(52002), // Rule ID 1001 //
     /*  51953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  51961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  51964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  51967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  51970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51982 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3771:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VHSUBsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  51982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv16i8),
     /*  51985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51989 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51994 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52000 */     GIR_RootConstrainSelectedInstOperands,
     /*  52001 */     // GIR_Coverage, 1001,
     /*  52001 */     GIR_EraseRootFromParent_Done,
     /*  52002 */   // Label 1129: @52002
     /*  52002 */   GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(52056), // Rule ID 1002 //
     /*  52007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  52015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  52018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  52021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  52024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52036 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3772:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VHSUBuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  52036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv4i16),
     /*  52039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52043 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52048 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52054 */     GIR_RootConstrainSelectedInstOperands,
     /*  52055 */     // GIR_Coverage, 1002,
     /*  52055 */     GIR_EraseRootFromParent_Done,
     /*  52056 */   // Label 1130: @52056
     /*  52056 */   GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(52110), // Rule ID 1003 //
     /*  52061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  52069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  52072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  52075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  52078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52090 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3772:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VHSUBuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  52090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv2i32),
     /*  52093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52097 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52102 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52108 */     GIR_RootConstrainSelectedInstOperands,
     /*  52109 */     // GIR_Coverage, 1003,
     /*  52109 */     GIR_EraseRootFromParent_Done,
     /*  52110 */   // Label 1131: @52110
     /*  52110 */   GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(52164), // Rule ID 1004 //
     /*  52115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  52123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  52126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  52132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52144 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3772:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VHSUBuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  52144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv8i16),
     /*  52147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52151 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52156 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52162 */     GIR_RootConstrainSelectedInstOperands,
     /*  52163 */     // GIR_Coverage, 1004,
     /*  52163 */     GIR_EraseRootFromParent_Done,
     /*  52164 */   // Label 1132: @52164
     /*  52164 */   GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(52218), // Rule ID 1005 //
     /*  52169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  52177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  52180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  52186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52198 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3772:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VHSUBuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  52198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv4i32),
     /*  52201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52205 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52210 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52216 */     GIR_RootConstrainSelectedInstOperands,
     /*  52217 */     // GIR_Coverage, 1005,
     /*  52217 */     GIR_EraseRootFromParent_Done,
     /*  52218 */   // Label 1133: @52218
     /*  52218 */   GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(52272), // Rule ID 1006 //
     /*  52223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  52231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  52234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  52237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  52240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52252 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3772:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VHSUBuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  52252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv8i8),
     /*  52255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52259 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52264 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52270 */     GIR_RootConstrainSelectedInstOperands,
     /*  52271 */     // GIR_Coverage, 1006,
     /*  52271 */     GIR_EraseRootFromParent_Done,
     /*  52272 */   // Label 1134: @52272
     /*  52272 */   GIM_Try, /*On fail goto*//*Label 1135*/ GIMT_Encode4(52326), // Rule ID 1007 //
     /*  52277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  52285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  52288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  52291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  52294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52306 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3772:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VHSUBuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  52306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv16i8),
     /*  52309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52313 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52318 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52324 */     GIR_RootConstrainSelectedInstOperands,
     /*  52325 */     // GIR_Coverage, 1007,
     /*  52325 */     GIR_EraseRootFromParent_Done,
     /*  52326 */   // Label 1135: @52326
     /*  52326 */   GIM_Try, /*On fail goto*//*Label 1136*/ GIMT_Encode4(52380), // Rule ID 1024 //
     /*  52331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsubhn),
     /*  52339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  52342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  52348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52360 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3840:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VRSUBHNv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  52360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSUBHNv8i8),
     /*  52363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52367 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52372 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52378 */     GIR_RootConstrainSelectedInstOperands,
     /*  52379 */     // GIR_Coverage, 1024,
     /*  52379 */     GIR_EraseRootFromParent_Done,
     /*  52380 */   // Label 1136: @52380
     /*  52380 */   GIM_Try, /*On fail goto*//*Label 1137*/ GIMT_Encode4(52434), // Rule ID 1025 //
     /*  52385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsubhn),
     /*  52393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  52396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  52402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52414 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3840:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VRSUBHNv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  52414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSUBHNv4i16),
     /*  52417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52421 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52426 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52432 */     GIR_RootConstrainSelectedInstOperands,
     /*  52433 */     // GIR_Coverage, 1025,
     /*  52433 */     GIR_EraseRootFromParent_Done,
     /*  52434 */   // Label 1137: @52434
     /*  52434 */   GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(52488), // Rule ID 1026 //
     /*  52439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsubhn),
     /*  52447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  52450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  52453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  52456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52468 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3840:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VRSUBHNv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /*  52468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSUBHNv2i32),
     /*  52471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52475 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52480 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52486 */     GIR_RootConstrainSelectedInstOperands,
     /*  52487 */     // GIR_Coverage, 1026,
     /*  52487 */     GIR_EraseRootFromParent_Done,
     /*  52488 */   // Label 1138: @52488
     /*  52488 */   GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(52542), // Rule ID 1119 //
     /*  52493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacge),
     /*  52501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  52504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  52507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  52510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52522 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3747:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VACGEfd:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  52522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGEfd),
     /*  52525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52529 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52534 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52540 */     GIR_RootConstrainSelectedInstOperands,
     /*  52541 */     // GIR_Coverage, 1119,
     /*  52541 */     GIR_EraseRootFromParent_Done,
     /*  52542 */   // Label 1139: @52542
     /*  52542 */   GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(52596), // Rule ID 1120 //
     /*  52547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacge),
     /*  52555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  52558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  52564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52576 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3747:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VACGEfq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /*  52576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGEfq),
     /*  52579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52583 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52588 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52594 */     GIR_RootConstrainSelectedInstOperands,
     /*  52595 */     // GIR_Coverage, 1120,
     /*  52595 */     GIR_EraseRootFromParent_Done,
     /*  52596 */   // Label 1140: @52596
     /*  52596 */   GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(52650), // Rule ID 1121 //
     /*  52601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  52604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacge),
     /*  52609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  52612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  52615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  52618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52630 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3747:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VACGEhd:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  52630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGEhd),
     /*  52633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52637 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52642 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52648 */     GIR_RootConstrainSelectedInstOperands,
     /*  52649 */     // GIR_Coverage, 1121,
     /*  52649 */     GIR_EraseRootFromParent_Done,
     /*  52650 */   // Label 1141: @52650
     /*  52650 */   GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(52704), // Rule ID 1122 //
     /*  52655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  52658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacge),
     /*  52663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  52666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  52672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52684 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3747:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VACGEhq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /*  52684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGEhq),
     /*  52687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52691 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52696 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52702 */     GIR_RootConstrainSelectedInstOperands,
     /*  52703 */     // GIR_Coverage, 1122,
     /*  52703 */     GIR_EraseRootFromParent_Done,
     /*  52704 */   // Label 1142: @52704
     /*  52704 */   GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(52758), // Rule ID 1123 //
     /*  52709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacgt),
     /*  52717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  52720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  52723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  52726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52738 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3748:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VACGTfd:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  52738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGTfd),
     /*  52741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52745 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52750 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52756 */     GIR_RootConstrainSelectedInstOperands,
     /*  52757 */     // GIR_Coverage, 1123,
     /*  52757 */     GIR_EraseRootFromParent_Done,
     /*  52758 */   // Label 1143: @52758
     /*  52758 */   GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(52812), // Rule ID 1124 //
     /*  52763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacgt),
     /*  52771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  52774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  52780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52792 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3748:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VACGTfq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /*  52792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGTfq),
     /*  52795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52799 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52804 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52810 */     GIR_RootConstrainSelectedInstOperands,
     /*  52811 */     // GIR_Coverage, 1124,
     /*  52811 */     GIR_EraseRootFromParent_Done,
     /*  52812 */   // Label 1144: @52812
     /*  52812 */   GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(52866), // Rule ID 1125 //
     /*  52817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  52820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacgt),
     /*  52825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  52828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  52831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  52834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52846 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3748:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VACGThd:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  52846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGThd),
     /*  52849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52853 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52858 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52864 */     GIR_RootConstrainSelectedInstOperands,
     /*  52865 */     // GIR_Coverage, 1125,
     /*  52865 */     GIR_EraseRootFromParent_Done,
     /*  52866 */   // Label 1145: @52866
     /*  52866 */   GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(52920), // Rule ID 1126 //
     /*  52871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  52874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacgt),
     /*  52879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  52882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  52888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52900 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3748:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VACGThq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /*  52900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGThq),
     /*  52903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52907 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52912 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52918 */     GIR_RootConstrainSelectedInstOperands,
     /*  52919 */     // GIR_Coverage, 1126,
     /*  52919 */     GIR_EraseRootFromParent_Done,
     /*  52920 */   // Label 1146: @52920
     /*  52920 */   GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(52974), // Rule ID 1169 //
     /*  52925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vabds),
     /*  52933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  52936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  52939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  52942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52954 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3744:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VABDfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  52954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABDfd),
     /*  52957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52959 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52961 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52966 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52972 */     GIR_RootConstrainSelectedInstOperands,
     /*  52973 */     // GIR_Coverage, 1169,
     /*  52973 */     GIR_EraseRootFromParent_Done,
     /*  52974 */   // Label 1147: @52974
     /*  52974 */   GIM_Try, /*On fail goto*//*Label 1148*/ GIMT_Encode4(53028), // Rule ID 1170 //
     /*  52979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vabds),
     /*  52987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  52990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  52996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53008 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3744:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VABDfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /*  53008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABDfq),
     /*  53011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53015 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53020 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53026 */     GIR_RootConstrainSelectedInstOperands,
     /*  53027 */     // GIR_Coverage, 1170,
     /*  53027 */     GIR_EraseRootFromParent_Done,
     /*  53028 */   // Label 1148: @53028
     /*  53028 */   GIM_Try, /*On fail goto*//*Label 1149*/ GIMT_Encode4(53082), // Rule ID 1171 //
     /*  53033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  53036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vabds),
     /*  53041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  53044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  53047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  53050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53062 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3744:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VABDhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  53062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABDhd),
     /*  53065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53069 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53074 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53080 */     GIR_RootConstrainSelectedInstOperands,
     /*  53081 */     // GIR_Coverage, 1171,
     /*  53081 */     GIR_EraseRootFromParent_Done,
     /*  53082 */   // Label 1149: @53082
     /*  53082 */   GIM_Try, /*On fail goto*//*Label 1150*/ GIMT_Encode4(53136), // Rule ID 1172 //
     /*  53087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  53090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vabds),
     /*  53095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  53098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  53101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  53104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53116 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3744:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VABDhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /*  53116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABDhq),
     /*  53119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53123 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53128 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53134 */     GIR_RootConstrainSelectedInstOperands,
     /*  53135 */     // GIR_Coverage, 1172,
     /*  53135 */     GIR_EraseRootFromParent_Done,
     /*  53136 */   // Label 1150: @53136
     /*  53136 */   GIM_Try, /*On fail goto*//*Label 1151*/ GIMT_Encode4(53190), // Rule ID 1237 //
     /*  53141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadd),
     /*  53149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  53152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  53155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  53158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53170 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3798:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VPADDi8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  53170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDi8),
     /*  53173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53175 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53177 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53182 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53188 */     GIR_RootConstrainSelectedInstOperands,
     /*  53189 */     // GIR_Coverage, 1237,
     /*  53189 */     GIR_EraseRootFromParent_Done,
     /*  53190 */   // Label 1151: @53190
     /*  53190 */   GIM_Try, /*On fail goto*//*Label 1152*/ GIMT_Encode4(53244), // Rule ID 1238 //
     /*  53195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadd),
     /*  53203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  53206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  53209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  53212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53224 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3798:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VPADDi16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  53224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDi16),
     /*  53227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53231 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53236 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53242 */     GIR_RootConstrainSelectedInstOperands,
     /*  53243 */     // GIR_Coverage, 1238,
     /*  53243 */     GIR_EraseRootFromParent_Done,
     /*  53244 */   // Label 1152: @53244
     /*  53244 */   GIM_Try, /*On fail goto*//*Label 1153*/ GIMT_Encode4(53298), // Rule ID 1239 //
     /*  53249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadd),
     /*  53257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  53260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  53263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  53266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53278 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3798:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VPADDi32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  53278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDi32),
     /*  53281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53285 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53290 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53296 */     GIR_RootConstrainSelectedInstOperands,
     /*  53297 */     // GIR_Coverage, 1239,
     /*  53297 */     GIR_EraseRootFromParent_Done,
     /*  53298 */   // Label 1153: @53298
     /*  53298 */   GIM_Try, /*On fail goto*//*Label 1154*/ GIMT_Encode4(53352), // Rule ID 1240 //
     /*  53303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadd),
     /*  53311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  53314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  53317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  53320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53332 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3798:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VPADDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  53332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDf),
     /*  53335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53339 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53344 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53350 */     GIR_RootConstrainSelectedInstOperands,
     /*  53351 */     // GIR_Coverage, 1240,
     /*  53351 */     GIR_EraseRootFromParent_Done,
     /*  53352 */   // Label 1154: @53352
     /*  53352 */   GIM_Try, /*On fail goto*//*Label 1155*/ GIMT_Encode4(53406), // Rule ID 1241 //
     /*  53357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  53360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadd),
     /*  53365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  53368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  53371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  53374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53386 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3798:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VPADDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  53386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDh),
     /*  53389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53393 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53398 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53404 */     GIR_RootConstrainSelectedInstOperands,
     /*  53405 */     // GIR_Coverage, 1241,
     /*  53405 */     GIR_EraseRootFromParent_Done,
     /*  53406 */   // Label 1155: @53406
     /*  53406 */   GIM_Try, /*On fail goto*//*Label 1156*/ GIMT_Encode4(53460), // Rule ID 1254 //
     /*  53411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  53422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  53425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  53428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53440 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3796:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v8i8] }:$Vm)  =>  (VPADALsv8i8:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v8i8] }:$Vm)
     /*  53440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv8i8),
     /*  53443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53445 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53447 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53452 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53458 */     GIR_RootConstrainSelectedInstOperands,
     /*  53459 */     // GIR_Coverage, 1254,
     /*  53459 */     GIR_EraseRootFromParent_Done,
     /*  53460 */   // Label 1156: @53460
     /*  53460 */   GIM_Try, /*On fail goto*//*Label 1157*/ GIMT_Encode4(53514), // Rule ID 1255 //
     /*  53465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  53476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  53479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  53482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53494 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3796:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v4i16] }:$Vm)  =>  (VPADALsv4i16:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v4i16] }:$Vm)
     /*  53494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv4i16),
     /*  53497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53499 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53501 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53506 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53512 */     GIR_RootConstrainSelectedInstOperands,
     /*  53513 */     // GIR_Coverage, 1255,
     /*  53513 */     GIR_EraseRootFromParent_Done,
     /*  53514 */   // Label 1157: @53514
     /*  53514 */   GIM_Try, /*On fail goto*//*Label 1158*/ GIMT_Encode4(53568), // Rule ID 1256 //
     /*  53519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  53530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  53533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  53536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53548 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3796:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$src1, DPR:{ *:[v2i32] }:$Vm)  =>  (VPADALsv2i32:{ *:[v1i64] } DPR:{ *:[v1i64] }:$src1, DPR:{ *:[v2i32] }:$Vm)
     /*  53548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv2i32),
     /*  53551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53553 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53555 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53560 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53566 */     GIR_RootConstrainSelectedInstOperands,
     /*  53567 */     // GIR_Coverage, 1256,
     /*  53567 */     GIR_EraseRootFromParent_Done,
     /*  53568 */   // Label 1158: @53568
     /*  53568 */   GIM_Try, /*On fail goto*//*Label 1159*/ GIMT_Encode4(53622), // Rule ID 1257 //
     /*  53573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  53584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  53587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  53590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53602 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3796:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v16i8] }:$Vm)  =>  (VPADALsv16i8:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v16i8] }:$Vm)
     /*  53602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv16i8),
     /*  53605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53607 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53609 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53614 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53620 */     GIR_RootConstrainSelectedInstOperands,
     /*  53621 */     // GIR_Coverage, 1257,
     /*  53621 */     GIR_EraseRootFromParent_Done,
     /*  53622 */   // Label 1159: @53622
     /*  53622 */   GIM_Try, /*On fail goto*//*Label 1160*/ GIMT_Encode4(53676), // Rule ID 1258 //
     /*  53627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  53638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  53641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  53644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53656 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3796:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v8i16] }:$Vm)  =>  (VPADALsv8i16:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v8i16] }:$Vm)
     /*  53656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv8i16),
     /*  53659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53661 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53663 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53668 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53674 */     GIR_RootConstrainSelectedInstOperands,
     /*  53675 */     // GIR_Coverage, 1258,
     /*  53675 */     GIR_EraseRootFromParent_Done,
     /*  53676 */   // Label 1160: @53676
     /*  53676 */   GIM_Try, /*On fail goto*//*Label 1161*/ GIMT_Encode4(53730), // Rule ID 1259 //
     /*  53681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  53692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  53695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  53698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53710 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3796:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$src1, QPR:{ *:[v4i32] }:$Vm)  =>  (VPADALsv4i32:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, QPR:{ *:[v4i32] }:$Vm)
     /*  53710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv4i32),
     /*  53713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53715 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53717 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53722 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53728 */     GIR_RootConstrainSelectedInstOperands,
     /*  53729 */     // GIR_Coverage, 1259,
     /*  53729 */     GIR_EraseRootFromParent_Done,
     /*  53730 */   // Label 1161: @53730
     /*  53730 */   GIM_Try, /*On fail goto*//*Label 1162*/ GIMT_Encode4(53784), // Rule ID 1260 //
     /*  53735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  53743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  53746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  53749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  53752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53764 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3797:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v8i8] }:$Vm)  =>  (VPADALuv8i8:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v8i8] }:$Vm)
     /*  53764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv8i8),
     /*  53767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53769 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53771 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53776 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53782 */     GIR_RootConstrainSelectedInstOperands,
     /*  53783 */     // GIR_Coverage, 1260,
     /*  53783 */     GIR_EraseRootFromParent_Done,
     /*  53784 */   // Label 1162: @53784
     /*  53784 */   GIM_Try, /*On fail goto*//*Label 1163*/ GIMT_Encode4(53838), // Rule ID 1261 //
     /*  53789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  53797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  53800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  53803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  53806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53818 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3797:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v4i16] }:$Vm)  =>  (VPADALuv4i16:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v4i16] }:$Vm)
     /*  53818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv4i16),
     /*  53821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53823 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53830 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53836 */     GIR_RootConstrainSelectedInstOperands,
     /*  53837 */     // GIR_Coverage, 1261,
     /*  53837 */     GIR_EraseRootFromParent_Done,
     /*  53838 */   // Label 1163: @53838
     /*  53838 */   GIM_Try, /*On fail goto*//*Label 1164*/ GIMT_Encode4(53892), // Rule ID 1262 //
     /*  53843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  53851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  53854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  53857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  53860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53872 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3797:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$src1, DPR:{ *:[v2i32] }:$Vm)  =>  (VPADALuv2i32:{ *:[v1i64] } DPR:{ *:[v1i64] }:$src1, DPR:{ *:[v2i32] }:$Vm)
     /*  53872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv2i32),
     /*  53875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53877 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53879 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53884 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53890 */     GIR_RootConstrainSelectedInstOperands,
     /*  53891 */     // GIR_Coverage, 1262,
     /*  53891 */     GIR_EraseRootFromParent_Done,
     /*  53892 */   // Label 1164: @53892
     /*  53892 */   GIM_Try, /*On fail goto*//*Label 1165*/ GIMT_Encode4(53946), // Rule ID 1263 //
     /*  53897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  53905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  53908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  53911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  53914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53926 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3797:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v16i8] }:$Vm)  =>  (VPADALuv16i8:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v16i8] }:$Vm)
     /*  53926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv16i8),
     /*  53929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53931 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53933 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53938 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53944 */     GIR_RootConstrainSelectedInstOperands,
     /*  53945 */     // GIR_Coverage, 1263,
     /*  53945 */     GIR_EraseRootFromParent_Done,
     /*  53946 */   // Label 1165: @53946
     /*  53946 */   GIM_Try, /*On fail goto*//*Label 1166*/ GIMT_Encode4(54000), // Rule ID 1264 //
     /*  53951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  53959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  53962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  53965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  53968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53980 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3797:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v8i16] }:$Vm)  =>  (VPADALuv8i16:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v8i16] }:$Vm)
     /*  53980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv8i16),
     /*  53983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53985 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53987 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53992 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53998 */     GIR_RootConstrainSelectedInstOperands,
     /*  53999 */     // GIR_Coverage, 1264,
     /*  53999 */     GIR_EraseRootFromParent_Done,
     /*  54000 */   // Label 1166: @54000
     /*  54000 */   GIM_Try, /*On fail goto*//*Label 1167*/ GIMT_Encode4(54054), // Rule ID 1265 //
     /*  54005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  54013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  54016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  54019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  54022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54034 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3797:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$src1, QPR:{ *:[v4i32] }:$Vm)  =>  (VPADALuv4i32:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, QPR:{ *:[v4i32] }:$Vm)
     /*  54034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv4i32),
     /*  54037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54039 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  54041 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54046 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54052 */     GIR_RootConstrainSelectedInstOperands,
     /*  54053 */     // GIR_Coverage, 1265,
     /*  54053 */     GIR_EraseRootFromParent_Done,
     /*  54054 */   // Label 1167: @54054
     /*  54054 */   GIM_Try, /*On fail goto*//*Label 1168*/ GIMT_Encode4(54108), // Rule ID 1266 //
     /*  54059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxs),
     /*  54067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  54070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  54073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  54076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54088 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3801:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VPMAXs8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  54088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXs8),
     /*  54091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54100 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54106 */     GIR_RootConstrainSelectedInstOperands,
     /*  54107 */     // GIR_Coverage, 1266,
     /*  54107 */     GIR_EraseRootFromParent_Done,
     /*  54108 */   // Label 1168: @54108
     /*  54108 */   GIM_Try, /*On fail goto*//*Label 1169*/ GIMT_Encode4(54162), // Rule ID 1267 //
     /*  54113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxs),
     /*  54121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54142 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3801:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VPMAXs16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  54142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXs16),
     /*  54145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54149 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54154 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54160 */     GIR_RootConstrainSelectedInstOperands,
     /*  54161 */     // GIR_Coverage, 1267,
     /*  54161 */     GIR_EraseRootFromParent_Done,
     /*  54162 */   // Label 1169: @54162
     /*  54162 */   GIM_Try, /*On fail goto*//*Label 1170*/ GIMT_Encode4(54216), // Rule ID 1268 //
     /*  54167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxs),
     /*  54175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54196 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3801:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VPMAXs32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  54196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXs32),
     /*  54199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54203 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54208 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54214 */     GIR_RootConstrainSelectedInstOperands,
     /*  54215 */     // GIR_Coverage, 1268,
     /*  54215 */     GIR_EraseRootFromParent_Done,
     /*  54216 */   // Label 1170: @54216
     /*  54216 */   GIM_Try, /*On fail goto*//*Label 1171*/ GIMT_Encode4(54270), // Rule ID 1269 //
     /*  54221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxu),
     /*  54229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  54232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  54235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  54238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54250 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3802:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VPMAXu8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  54250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXu8),
     /*  54253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54257 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54262 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54268 */     GIR_RootConstrainSelectedInstOperands,
     /*  54269 */     // GIR_Coverage, 1269,
     /*  54269 */     GIR_EraseRootFromParent_Done,
     /*  54270 */   // Label 1171: @54270
     /*  54270 */   GIM_Try, /*On fail goto*//*Label 1172*/ GIMT_Encode4(54324), // Rule ID 1270 //
     /*  54275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxu),
     /*  54283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54304 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3802:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VPMAXu16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  54304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXu16),
     /*  54307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54311 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54316 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54322 */     GIR_RootConstrainSelectedInstOperands,
     /*  54323 */     // GIR_Coverage, 1270,
     /*  54323 */     GIR_EraseRootFromParent_Done,
     /*  54324 */   // Label 1172: @54324
     /*  54324 */   GIM_Try, /*On fail goto*//*Label 1173*/ GIMT_Encode4(54378), // Rule ID 1271 //
     /*  54329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxu),
     /*  54337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54358 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3802:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VPMAXu32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  54358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXu32),
     /*  54361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54363 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54365 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54370 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54376 */     GIR_RootConstrainSelectedInstOperands,
     /*  54377 */     // GIR_Coverage, 1271,
     /*  54377 */     GIR_EraseRootFromParent_Done,
     /*  54378 */   // Label 1173: @54378
     /*  54378 */   GIM_Try, /*On fail goto*//*Label 1174*/ GIMT_Encode4(54432), // Rule ID 1272 //
     /*  54383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxs),
     /*  54391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54412 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3801:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VPMAXf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  54412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXf),
     /*  54415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54419 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54424 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54430 */     GIR_RootConstrainSelectedInstOperands,
     /*  54431 */     // GIR_Coverage, 1272,
     /*  54431 */     GIR_EraseRootFromParent_Done,
     /*  54432 */   // Label 1174: @54432
     /*  54432 */   GIM_Try, /*On fail goto*//*Label 1175*/ GIMT_Encode4(54486), // Rule ID 1273 //
     /*  54437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  54440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxs),
     /*  54445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54466 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3801:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VPMAXh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  54466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXh),
     /*  54469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54473 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54478 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54484 */     GIR_RootConstrainSelectedInstOperands,
     /*  54485 */     // GIR_Coverage, 1273,
     /*  54485 */     GIR_EraseRootFromParent_Done,
     /*  54486 */   // Label 1175: @54486
     /*  54486 */   GIM_Try, /*On fail goto*//*Label 1176*/ GIMT_Encode4(54540), // Rule ID 1274 //
     /*  54491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmins),
     /*  54499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  54502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  54505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  54508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54520 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3803:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VPMINs8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  54520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINs8),
     /*  54523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54525 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54527 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54532 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54538 */     GIR_RootConstrainSelectedInstOperands,
     /*  54539 */     // GIR_Coverage, 1274,
     /*  54539 */     GIR_EraseRootFromParent_Done,
     /*  54540 */   // Label 1176: @54540
     /*  54540 */   GIM_Try, /*On fail goto*//*Label 1177*/ GIMT_Encode4(54594), // Rule ID 1275 //
     /*  54545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmins),
     /*  54553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54574 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3803:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VPMINs16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  54574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINs16),
     /*  54577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54581 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54586 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54592 */     GIR_RootConstrainSelectedInstOperands,
     /*  54593 */     // GIR_Coverage, 1275,
     /*  54593 */     GIR_EraseRootFromParent_Done,
     /*  54594 */   // Label 1177: @54594
     /*  54594 */   GIM_Try, /*On fail goto*//*Label 1178*/ GIMT_Encode4(54648), // Rule ID 1276 //
     /*  54599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmins),
     /*  54607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54628 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3803:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VPMINs32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  54628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINs32),
     /*  54631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54635 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54640 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54646 */     GIR_RootConstrainSelectedInstOperands,
     /*  54647 */     // GIR_Coverage, 1276,
     /*  54647 */     GIR_EraseRootFromParent_Done,
     /*  54648 */   // Label 1178: @54648
     /*  54648 */   GIM_Try, /*On fail goto*//*Label 1179*/ GIMT_Encode4(54702), // Rule ID 1277 //
     /*  54653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpminu),
     /*  54661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  54664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  54667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  54670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54682 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3804:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VPMINu8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  54682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINu8),
     /*  54685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54689 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54694 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54700 */     GIR_RootConstrainSelectedInstOperands,
     /*  54701 */     // GIR_Coverage, 1277,
     /*  54701 */     GIR_EraseRootFromParent_Done,
     /*  54702 */   // Label 1179: @54702
     /*  54702 */   GIM_Try, /*On fail goto*//*Label 1180*/ GIMT_Encode4(54756), // Rule ID 1278 //
     /*  54707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpminu),
     /*  54715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54736 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3804:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VPMINu16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  54736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINu16),
     /*  54739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54743 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54748 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54754 */     GIR_RootConstrainSelectedInstOperands,
     /*  54755 */     // GIR_Coverage, 1278,
     /*  54755 */     GIR_EraseRootFromParent_Done,
     /*  54756 */   // Label 1180: @54756
     /*  54756 */   GIM_Try, /*On fail goto*//*Label 1181*/ GIMT_Encode4(54810), // Rule ID 1279 //
     /*  54761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpminu),
     /*  54769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54790 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3804:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VPMINu32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  54790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINu32),
     /*  54793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54795 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54797 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54802 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54808 */     GIR_RootConstrainSelectedInstOperands,
     /*  54809 */     // GIR_Coverage, 1279,
     /*  54809 */     GIR_EraseRootFromParent_Done,
     /*  54810 */   // Label 1181: @54810
     /*  54810 */   GIM_Try, /*On fail goto*//*Label 1182*/ GIMT_Encode4(54864), // Rule ID 1280 //
     /*  54815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmins),
     /*  54823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54844 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3803:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VPMINf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  54844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINf),
     /*  54847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54851 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54856 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54862 */     GIR_RootConstrainSelectedInstOperands,
     /*  54863 */     // GIR_Coverage, 1280,
     /*  54863 */     GIR_EraseRootFromParent_Done,
     /*  54864 */   // Label 1182: @54864
     /*  54864 */   GIM_Try, /*On fail goto*//*Label 1183*/ GIMT_Encode4(54918), // Rule ID 1281 //
     /*  54869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  54872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmins),
     /*  54877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54898 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3803:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VPMINh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  54898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINh),
     /*  54901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54905 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54910 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54916 */     GIR_RootConstrainSelectedInstOperands,
     /*  54917 */     // GIR_Coverage, 1281,
     /*  54917 */     GIR_EraseRootFromParent_Done,
     /*  54918 */   // Label 1183: @54918
     /*  54918 */   GIM_Try, /*On fail goto*//*Label 1184*/ GIMT_Encode4(54972), // Rule ID 1288 //
     /*  54923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecps),
     /*  54931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54952 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3828:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VRECPSfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  54952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPSfd),
     /*  54955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54959 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54964 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54970 */     GIR_RootConstrainSelectedInstOperands,
     /*  54971 */     // GIR_Coverage, 1288,
     /*  54971 */     GIR_EraseRootFromParent_Done,
     /*  54972 */   // Label 1184: @54972
     /*  54972 */   GIM_Try, /*On fail goto*//*Label 1185*/ GIMT_Encode4(55026), // Rule ID 1289 //
     /*  54977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecps),
     /*  54985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  54988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  54994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55006 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3828:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VRECPSfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /*  55006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPSfq),
     /*  55009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55013 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55018 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55024 */     GIR_RootConstrainSelectedInstOperands,
     /*  55025 */     // GIR_Coverage, 1289,
     /*  55025 */     GIR_EraseRootFromParent_Done,
     /*  55026 */   // Label 1185: @55026
     /*  55026 */   GIM_Try, /*On fail goto*//*Label 1186*/ GIMT_Encode4(55080), // Rule ID 1290 //
     /*  55031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  55034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecps),
     /*  55039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  55042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  55048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55060 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3828:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VRECPShd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  55060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPShd),
     /*  55063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55067 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55072 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55078 */     GIR_RootConstrainSelectedInstOperands,
     /*  55079 */     // GIR_Coverage, 1290,
     /*  55079 */     GIR_EraseRootFromParent_Done,
     /*  55080 */   // Label 1186: @55080
     /*  55080 */   GIM_Try, /*On fail goto*//*Label 1187*/ GIMT_Encode4(55134), // Rule ID 1291 //
     /*  55085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  55088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecps),
     /*  55093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  55096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  55099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  55102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55114 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3828:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VRECPShq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /*  55114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPShq),
     /*  55117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55121 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55126 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55132 */     GIR_RootConstrainSelectedInstOperands,
     /*  55133 */     // GIR_Coverage, 1291,
     /*  55133 */     GIR_EraseRootFromParent_Done,
     /*  55134 */   // Label 1187: @55134
     /*  55134 */   GIM_Try, /*On fail goto*//*Label 1188*/ GIMT_Encode4(55188), // Rule ID 1298 //
     /*  55139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrts),
     /*  55147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  55150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  55153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  55156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55168 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3839:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VRSQRTSfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  55168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTSfd),
     /*  55171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55180 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55186 */     GIR_RootConstrainSelectedInstOperands,
     /*  55187 */     // GIR_Coverage, 1298,
     /*  55187 */     GIR_EraseRootFromParent_Done,
     /*  55188 */   // Label 1188: @55188
     /*  55188 */   GIM_Try, /*On fail goto*//*Label 1189*/ GIMT_Encode4(55242), // Rule ID 1299 //
     /*  55193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrts),
     /*  55201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  55204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  55210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55222 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3839:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VRSQRTSfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /*  55222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTSfq),
     /*  55225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55234 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55240 */     GIR_RootConstrainSelectedInstOperands,
     /*  55241 */     // GIR_Coverage, 1299,
     /*  55241 */     GIR_EraseRootFromParent_Done,
     /*  55242 */   // Label 1189: @55242
     /*  55242 */   GIM_Try, /*On fail goto*//*Label 1190*/ GIMT_Encode4(55296), // Rule ID 1300 //
     /*  55247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  55250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrts),
     /*  55255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  55258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  55264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55276 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3839:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VRSQRTShd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  55276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTShd),
     /*  55279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55288 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55294 */     GIR_RootConstrainSelectedInstOperands,
     /*  55295 */     // GIR_Coverage, 1300,
     /*  55295 */     GIR_EraseRootFromParent_Done,
     /*  55296 */   // Label 1190: @55296
     /*  55296 */   GIM_Try, /*On fail goto*//*Label 1191*/ GIMT_Encode4(55350), // Rule ID 1301 //
     /*  55301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  55304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrts),
     /*  55309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  55312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  55315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  55318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55330 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3839:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VRSQRTShq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /*  55330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTShq),
     /*  55333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55335 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55337 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55342 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55348 */     GIR_RootConstrainSelectedInstOperands,
     /*  55349 */     // GIR_Coverage, 1301,
     /*  55349 */     GIR_EraseRootFromParent_Done,
     /*  55350 */   // Label 1191: @55350
     /*  55350 */   GIM_Try, /*On fail goto*//*Label 1192*/ GIMT_Encode4(55404), // Rule ID 1302 //
     /*  55355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  55366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  55372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55384 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3842:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VSHLsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  55384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv4i16),
     /*  55387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55391 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55396 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55402 */     GIR_RootConstrainSelectedInstOperands,
     /*  55403 */     // GIR_Coverage, 1302,
     /*  55403 */     GIR_EraseRootFromParent_Done,
     /*  55404 */   // Label 1192: @55404
     /*  55404 */   GIM_Try, /*On fail goto*//*Label 1193*/ GIMT_Encode4(55458), // Rule ID 1303 //
     /*  55409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  55420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  55423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  55426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55438 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3842:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VSHLsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  55438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv2i32),
     /*  55441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55445 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55450 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55456 */     GIR_RootConstrainSelectedInstOperands,
     /*  55457 */     // GIR_Coverage, 1303,
     /*  55457 */     GIR_EraseRootFromParent_Done,
     /*  55458 */   // Label 1193: @55458
     /*  55458 */   GIM_Try, /*On fail goto*//*Label 1194*/ GIMT_Encode4(55512), // Rule ID 1304 //
     /*  55463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  55474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  55477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  55480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55492 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3842:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VSHLsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  55492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv8i16),
     /*  55495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55499 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55504 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55510 */     GIR_RootConstrainSelectedInstOperands,
     /*  55511 */     // GIR_Coverage, 1304,
     /*  55511 */     GIR_EraseRootFromParent_Done,
     /*  55512 */   // Label 1194: @55512
     /*  55512 */   GIM_Try, /*On fail goto*//*Label 1195*/ GIMT_Encode4(55566), // Rule ID 1305 //
     /*  55517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  55528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  55534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55546 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3842:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VSHLsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  55546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv4i32),
     /*  55549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55553 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55558 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55564 */     GIR_RootConstrainSelectedInstOperands,
     /*  55565 */     // GIR_Coverage, 1305,
     /*  55565 */     GIR_EraseRootFromParent_Done,
     /*  55566 */   // Label 1195: @55566
     /*  55566 */   GIM_Try, /*On fail goto*//*Label 1196*/ GIMT_Encode4(55620), // Rule ID 1306 //
     /*  55571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  55582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  55585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  55588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55600 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3842:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VSHLsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  55600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv8i8),
     /*  55603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55607 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55612 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55618 */     GIR_RootConstrainSelectedInstOperands,
     /*  55619 */     // GIR_Coverage, 1306,
     /*  55619 */     GIR_EraseRootFromParent_Done,
     /*  55620 */   // Label 1196: @55620
     /*  55620 */   GIM_Try, /*On fail goto*//*Label 1197*/ GIMT_Encode4(55674), // Rule ID 1307 //
     /*  55625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  55636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  55639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  55642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55654 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3842:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VSHLsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  55654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv16i8),
     /*  55657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55659 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55661 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55666 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55672 */     GIR_RootConstrainSelectedInstOperands,
     /*  55673 */     // GIR_Coverage, 1307,
     /*  55673 */     GIR_EraseRootFromParent_Done,
     /*  55674 */   // Label 1197: @55674
     /*  55674 */   GIM_Try, /*On fail goto*//*Label 1198*/ GIMT_Encode4(55728), // Rule ID 1308 //
     /*  55679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  55690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  55693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  55696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55708 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3842:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VSHLsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  55708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv1i64),
     /*  55711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55715 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55720 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55726 */     GIR_RootConstrainSelectedInstOperands,
     /*  55727 */     // GIR_Coverage, 1308,
     /*  55727 */     GIR_EraseRootFromParent_Done,
     /*  55728 */   // Label 1198: @55728
     /*  55728 */   GIM_Try, /*On fail goto*//*Label 1199*/ GIMT_Encode4(55782), // Rule ID 1309 //
     /*  55733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  55744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  55747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  55750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55762 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3842:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VSHLsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  55762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv2i64),
     /*  55765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55774 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55780 */     GIR_RootConstrainSelectedInstOperands,
     /*  55781 */     // GIR_Coverage, 1309,
     /*  55781 */     GIR_EraseRootFromParent_Done,
     /*  55782 */   // Label 1199: @55782
     /*  55782 */   GIM_Try, /*On fail goto*//*Label 1200*/ GIMT_Encode4(55836), // Rule ID 1310 //
     /*  55787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  55795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  55798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  55804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55816 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3843:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VSHLuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  55816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv4i16),
     /*  55819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55823 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55828 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55834 */     GIR_RootConstrainSelectedInstOperands,
     /*  55835 */     // GIR_Coverage, 1310,
     /*  55835 */     GIR_EraseRootFromParent_Done,
     /*  55836 */   // Label 1200: @55836
     /*  55836 */   GIM_Try, /*On fail goto*//*Label 1201*/ GIMT_Encode4(55890), // Rule ID 1311 //
     /*  55841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  55849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  55852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  55855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  55858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55870 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3843:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VSHLuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  55870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv2i32),
     /*  55873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55877 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55882 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55888 */     GIR_RootConstrainSelectedInstOperands,
     /*  55889 */     // GIR_Coverage, 1311,
     /*  55889 */     GIR_EraseRootFromParent_Done,
     /*  55890 */   // Label 1201: @55890
     /*  55890 */   GIM_Try, /*On fail goto*//*Label 1202*/ GIMT_Encode4(55944), // Rule ID 1312 //
     /*  55895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  55903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  55906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  55909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  55912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55924 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3843:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VSHLuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  55924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv8i16),
     /*  55927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55931 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55936 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55942 */     GIR_RootConstrainSelectedInstOperands,
     /*  55943 */     // GIR_Coverage, 1312,
     /*  55943 */     GIR_EraseRootFromParent_Done,
     /*  55944 */   // Label 1202: @55944
     /*  55944 */   GIM_Try, /*On fail goto*//*Label 1203*/ GIMT_Encode4(55998), // Rule ID 1313 //
     /*  55949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  55957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  55960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  55966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55978 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3843:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VSHLuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  55978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv4i32),
     /*  55981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55985 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55990 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55996 */     GIR_RootConstrainSelectedInstOperands,
     /*  55997 */     // GIR_Coverage, 1313,
     /*  55997 */     GIR_EraseRootFromParent_Done,
     /*  55998 */   // Label 1203: @55998
     /*  55998 */   GIM_Try, /*On fail goto*//*Label 1204*/ GIMT_Encode4(56052), // Rule ID 1314 //
     /*  56003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  56011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  56014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  56017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  56020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56032 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3843:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VSHLuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  56032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv8i8),
     /*  56035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56039 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56044 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56050 */     GIR_RootConstrainSelectedInstOperands,
     /*  56051 */     // GIR_Coverage, 1314,
     /*  56051 */     GIR_EraseRootFromParent_Done,
     /*  56052 */   // Label 1204: @56052
     /*  56052 */   GIM_Try, /*On fail goto*//*Label 1205*/ GIMT_Encode4(56106), // Rule ID 1315 //
     /*  56057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  56065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  56068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  56071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  56074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56086 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3843:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VSHLuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  56086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv16i8),
     /*  56089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56093 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56098 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56104 */     GIR_RootConstrainSelectedInstOperands,
     /*  56105 */     // GIR_Coverage, 1315,
     /*  56105 */     GIR_EraseRootFromParent_Done,
     /*  56106 */   // Label 1205: @56106
     /*  56106 */   GIM_Try, /*On fail goto*//*Label 1206*/ GIMT_Encode4(56160), // Rule ID 1316 //
     /*  56111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  56119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  56122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  56125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  56128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56140 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3843:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VSHLuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  56140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv1i64),
     /*  56143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56147 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56152 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56158 */     GIR_RootConstrainSelectedInstOperands,
     /*  56159 */     // GIR_Coverage, 1316,
     /*  56159 */     GIR_EraseRootFromParent_Done,
     /*  56160 */   // Label 1206: @56160
     /*  56160 */   GIM_Try, /*On fail goto*//*Label 1207*/ GIMT_Encode4(56214), // Rule ID 1317 //
     /*  56165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  56173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  56176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  56179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  56182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56194 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3843:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VSHLuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  56194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv2i64),
     /*  56197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56201 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56206 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56212 */     GIR_RootConstrainSelectedInstOperands,
     /*  56213 */     // GIR_Coverage, 1317,
     /*  56213 */     GIR_EraseRootFromParent_Done,
     /*  56214 */   // Label 1207: @56214
     /*  56214 */   GIM_Try, /*On fail goto*//*Label 1208*/ GIMT_Encode4(56268), // Rule ID 1351 //
     /*  56219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  56230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  56233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  56236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56248 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3836:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VRSHLsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  56248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv4i16),
     /*  56251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56255 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56260 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56266 */     GIR_RootConstrainSelectedInstOperands,
     /*  56267 */     // GIR_Coverage, 1351,
     /*  56267 */     GIR_EraseRootFromParent_Done,
     /*  56268 */   // Label 1208: @56268
     /*  56268 */   GIM_Try, /*On fail goto*//*Label 1209*/ GIMT_Encode4(56322), // Rule ID 1352 //
     /*  56273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  56284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  56287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  56290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56302 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3836:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VRSHLsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  56302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv2i32),
     /*  56305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56309 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56314 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56320 */     GIR_RootConstrainSelectedInstOperands,
     /*  56321 */     // GIR_Coverage, 1352,
     /*  56321 */     GIR_EraseRootFromParent_Done,
     /*  56322 */   // Label 1209: @56322
     /*  56322 */   GIM_Try, /*On fail goto*//*Label 1210*/ GIMT_Encode4(56376), // Rule ID 1353 //
     /*  56327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  56338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  56341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  56344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56356 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3836:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VRSHLsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  56356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv8i16),
     /*  56359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56368 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56374 */     GIR_RootConstrainSelectedInstOperands,
     /*  56375 */     // GIR_Coverage, 1353,
     /*  56375 */     GIR_EraseRootFromParent_Done,
     /*  56376 */   // Label 1210: @56376
     /*  56376 */   GIM_Try, /*On fail goto*//*Label 1211*/ GIMT_Encode4(56430), // Rule ID 1354 //
     /*  56381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  56392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  56398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56410 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3836:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VRSHLsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  56410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv4i32),
     /*  56413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56417 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56422 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56428 */     GIR_RootConstrainSelectedInstOperands,
     /*  56429 */     // GIR_Coverage, 1354,
     /*  56429 */     GIR_EraseRootFromParent_Done,
     /*  56430 */   // Label 1211: @56430
     /*  56430 */   GIM_Try, /*On fail goto*//*Label 1212*/ GIMT_Encode4(56484), // Rule ID 1355 //
     /*  56435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  56446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  56449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  56452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56464 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3836:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VRSHLsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  56464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv8i8),
     /*  56467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56471 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56476 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56482 */     GIR_RootConstrainSelectedInstOperands,
     /*  56483 */     // GIR_Coverage, 1355,
     /*  56483 */     GIR_EraseRootFromParent_Done,
     /*  56484 */   // Label 1212: @56484
     /*  56484 */   GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(56538), // Rule ID 1356 //
     /*  56489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  56500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  56503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  56506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56518 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3836:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VRSHLsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  56518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv16i8),
     /*  56521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56523 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56525 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56530 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56536 */     GIR_RootConstrainSelectedInstOperands,
     /*  56537 */     // GIR_Coverage, 1356,
     /*  56537 */     GIR_EraseRootFromParent_Done,
     /*  56538 */   // Label 1213: @56538
     /*  56538 */   GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(56592), // Rule ID 1357 //
     /*  56543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  56554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  56557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  56560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56572 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3836:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VRSHLsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  56572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv1i64),
     /*  56575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56579 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56584 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56590 */     GIR_RootConstrainSelectedInstOperands,
     /*  56591 */     // GIR_Coverage, 1357,
     /*  56591 */     GIR_EraseRootFromParent_Done,
     /*  56592 */   // Label 1214: @56592
     /*  56592 */   GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(56646), // Rule ID 1358 //
     /*  56597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  56608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  56611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  56614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56626 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3836:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VRSHLsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  56626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv2i64),
     /*  56629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56633 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56638 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56644 */     GIR_RootConstrainSelectedInstOperands,
     /*  56645 */     // GIR_Coverage, 1358,
     /*  56645 */     GIR_EraseRootFromParent_Done,
     /*  56646 */   // Label 1215: @56646
     /*  56646 */   GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(56700), // Rule ID 1359 //
     /*  56651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  56662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  56665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  56668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56680 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3837:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VRSHLuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  56680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv4i16),
     /*  56683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56687 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56692 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56698 */     GIR_RootConstrainSelectedInstOperands,
     /*  56699 */     // GIR_Coverage, 1359,
     /*  56699 */     GIR_EraseRootFromParent_Done,
     /*  56700 */   // Label 1216: @56700
     /*  56700 */   GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(56754), // Rule ID 1360 //
     /*  56705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  56716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  56719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  56722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56734 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3837:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VRSHLuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  56734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv2i32),
     /*  56737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56741 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56746 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56752 */     GIR_RootConstrainSelectedInstOperands,
     /*  56753 */     // GIR_Coverage, 1360,
     /*  56753 */     GIR_EraseRootFromParent_Done,
     /*  56754 */   // Label 1217: @56754
     /*  56754 */   GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(56808), // Rule ID 1361 //
     /*  56759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  56770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  56773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  56776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56788 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3837:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VRSHLuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  56788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv8i16),
     /*  56791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56800 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56806 */     GIR_RootConstrainSelectedInstOperands,
     /*  56807 */     // GIR_Coverage, 1361,
     /*  56807 */     GIR_EraseRootFromParent_Done,
     /*  56808 */   // Label 1218: @56808
     /*  56808 */   GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(56862), // Rule ID 1362 //
     /*  56813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  56824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  56830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56842 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3837:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VRSHLuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  56842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv4i32),
     /*  56845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56849 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56854 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56860 */     GIR_RootConstrainSelectedInstOperands,
     /*  56861 */     // GIR_Coverage, 1362,
     /*  56861 */     GIR_EraseRootFromParent_Done,
     /*  56862 */   // Label 1219: @56862
     /*  56862 */   GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(56916), // Rule ID 1363 //
     /*  56867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  56878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  56881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  56884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56896 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3837:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VRSHLuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  56896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv8i8),
     /*  56899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56903 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56908 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56914 */     GIR_RootConstrainSelectedInstOperands,
     /*  56915 */     // GIR_Coverage, 1363,
     /*  56915 */     GIR_EraseRootFromParent_Done,
     /*  56916 */   // Label 1220: @56916
     /*  56916 */   GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(56970), // Rule ID 1364 //
     /*  56921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  56932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  56935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  56938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56950 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3837:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VRSHLuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  56950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv16i8),
     /*  56953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56957 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56962 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56968 */     GIR_RootConstrainSelectedInstOperands,
     /*  56969 */     // GIR_Coverage, 1364,
     /*  56969 */     GIR_EraseRootFromParent_Done,
     /*  56970 */   // Label 1221: @56970
     /*  56970 */   GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(57024), // Rule ID 1365 //
     /*  56975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  56986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  56989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  56992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57004 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3837:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VRSHLuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  57004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv1i64),
     /*  57007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57011 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57016 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57022 */     GIR_RootConstrainSelectedInstOperands,
     /*  57023 */     // GIR_Coverage, 1365,
     /*  57023 */     GIR_EraseRootFromParent_Done,
     /*  57024 */   // Label 1222: @57024
     /*  57024 */   GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(57078), // Rule ID 1366 //
     /*  57029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  57037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  57040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  57043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  57046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57058 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3837:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VRSHLuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  57058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv2i64),
     /*  57061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57065 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57070 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57076 */     GIR_RootConstrainSelectedInstOperands,
     /*  57077 */     // GIR_Coverage, 1366,
     /*  57077 */     GIR_EraseRootFromParent_Done,
     /*  57078 */   // Label 1223: @57078
     /*  57078 */   GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(57132), // Rule ID 1386 //
     /*  57083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  57094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  57097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  57100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57112 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3823:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VQSHLsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  57112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv4i16),
     /*  57115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57119 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57124 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57130 */     GIR_RootConstrainSelectedInstOperands,
     /*  57131 */     // GIR_Coverage, 1386,
     /*  57131 */     GIR_EraseRootFromParent_Done,
     /*  57132 */   // Label 1224: @57132
     /*  57132 */   GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(57186), // Rule ID 1387 //
     /*  57137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  57148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  57151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  57154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57166 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3823:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VQSHLsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  57166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv2i32),
     /*  57169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57173 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57178 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57184 */     GIR_RootConstrainSelectedInstOperands,
     /*  57185 */     // GIR_Coverage, 1387,
     /*  57185 */     GIR_EraseRootFromParent_Done,
     /*  57186 */   // Label 1225: @57186
     /*  57186 */   GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(57240), // Rule ID 1388 //
     /*  57191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  57202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  57205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  57208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57220 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3823:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VQSHLsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  57220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv8i16),
     /*  57223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57227 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57232 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57238 */     GIR_RootConstrainSelectedInstOperands,
     /*  57239 */     // GIR_Coverage, 1388,
     /*  57239 */     GIR_EraseRootFromParent_Done,
     /*  57240 */   // Label 1226: @57240
     /*  57240 */   GIM_Try, /*On fail goto*//*Label 1227*/ GIMT_Encode4(57294), // Rule ID 1389 //
     /*  57245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  57256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  57262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57274 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3823:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VQSHLsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  57274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv4i32),
     /*  57277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57281 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57286 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57292 */     GIR_RootConstrainSelectedInstOperands,
     /*  57293 */     // GIR_Coverage, 1389,
     /*  57293 */     GIR_EraseRootFromParent_Done,
     /*  57294 */   // Label 1227: @57294
     /*  57294 */   GIM_Try, /*On fail goto*//*Label 1228*/ GIMT_Encode4(57348), // Rule ID 1390 //
     /*  57299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  57310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  57313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  57316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57328 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3823:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VQSHLsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  57328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv8i8),
     /*  57331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57335 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57340 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57346 */     GIR_RootConstrainSelectedInstOperands,
     /*  57347 */     // GIR_Coverage, 1390,
     /*  57347 */     GIR_EraseRootFromParent_Done,
     /*  57348 */   // Label 1228: @57348
     /*  57348 */   GIM_Try, /*On fail goto*//*Label 1229*/ GIMT_Encode4(57402), // Rule ID 1391 //
     /*  57353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  57364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  57367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  57370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57382 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3823:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VQSHLsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  57382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv16i8),
     /*  57385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57394 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57400 */     GIR_RootConstrainSelectedInstOperands,
     /*  57401 */     // GIR_Coverage, 1391,
     /*  57401 */     GIR_EraseRootFromParent_Done,
     /*  57402 */   // Label 1229: @57402
     /*  57402 */   GIM_Try, /*On fail goto*//*Label 1230*/ GIMT_Encode4(57456), // Rule ID 1392 //
     /*  57407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  57418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  57421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  57424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57436 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3823:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VQSHLsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  57436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv1i64),
     /*  57439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57443 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57448 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57454 */     GIR_RootConstrainSelectedInstOperands,
     /*  57455 */     // GIR_Coverage, 1392,
     /*  57455 */     GIR_EraseRootFromParent_Done,
     /*  57456 */   // Label 1230: @57456
     /*  57456 */   GIM_Try, /*On fail goto*//*Label 1231*/ GIMT_Encode4(57510), // Rule ID 1393 //
     /*  57461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  57472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  57475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  57478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57490 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3823:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VQSHLsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  57490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv2i64),
     /*  57493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57495 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57497 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57502 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57508 */     GIR_RootConstrainSelectedInstOperands,
     /*  57509 */     // GIR_Coverage, 1393,
     /*  57509 */     GIR_EraseRootFromParent_Done,
     /*  57510 */   // Label 1231: @57510
     /*  57510 */   GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(57564), // Rule ID 1394 //
     /*  57515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  57526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  57529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  57532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57544 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3825:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VQSHLuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  57544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv4i16),
     /*  57547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57551 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57556 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57562 */     GIR_RootConstrainSelectedInstOperands,
     /*  57563 */     // GIR_Coverage, 1394,
     /*  57563 */     GIR_EraseRootFromParent_Done,
     /*  57564 */   // Label 1232: @57564
     /*  57564 */   GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(57618), // Rule ID 1395 //
     /*  57569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  57580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  57583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  57586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57598 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3825:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VQSHLuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  57598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv2i32),
     /*  57601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57603 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57605 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57610 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57616 */     GIR_RootConstrainSelectedInstOperands,
     /*  57617 */     // GIR_Coverage, 1395,
     /*  57617 */     GIR_EraseRootFromParent_Done,
     /*  57618 */   // Label 1233: @57618
     /*  57618 */   GIM_Try, /*On fail goto*//*Label 1234*/ GIMT_Encode4(57672), // Rule ID 1396 //
     /*  57623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  57634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  57637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  57640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57652 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3825:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VQSHLuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  57652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv8i16),
     /*  57655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57659 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57664 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57670 */     GIR_RootConstrainSelectedInstOperands,
     /*  57671 */     // GIR_Coverage, 1396,
     /*  57671 */     GIR_EraseRootFromParent_Done,
     /*  57672 */   // Label 1234: @57672
     /*  57672 */   GIM_Try, /*On fail goto*//*Label 1235*/ GIMT_Encode4(57726), // Rule ID 1397 //
     /*  57677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  57688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  57694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57706 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3825:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VQSHLuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  57706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv4i32),
     /*  57709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57713 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57718 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57724 */     GIR_RootConstrainSelectedInstOperands,
     /*  57725 */     // GIR_Coverage, 1397,
     /*  57725 */     GIR_EraseRootFromParent_Done,
     /*  57726 */   // Label 1235: @57726
     /*  57726 */   GIM_Try, /*On fail goto*//*Label 1236*/ GIMT_Encode4(57780), // Rule ID 1398 //
     /*  57731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  57742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  57745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  57748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57760 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3825:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VQSHLuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  57760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv8i8),
     /*  57763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57767 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57772 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57778 */     GIR_RootConstrainSelectedInstOperands,
     /*  57779 */     // GIR_Coverage, 1398,
     /*  57779 */     GIR_EraseRootFromParent_Done,
     /*  57780 */   // Label 1236: @57780
     /*  57780 */   GIM_Try, /*On fail goto*//*Label 1237*/ GIMT_Encode4(57834), // Rule ID 1399 //
     /*  57785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  57796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  57799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  57802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57814 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3825:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VQSHLuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  57814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv16i8),
     /*  57817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57821 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57826 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57832 */     GIR_RootConstrainSelectedInstOperands,
     /*  57833 */     // GIR_Coverage, 1399,
     /*  57833 */     GIR_EraseRootFromParent_Done,
     /*  57834 */   // Label 1237: @57834
     /*  57834 */   GIM_Try, /*On fail goto*//*Label 1238*/ GIMT_Encode4(57888), // Rule ID 1400 //
     /*  57839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  57850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  57853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  57856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57868 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3825:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VQSHLuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  57868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv1i64),
     /*  57871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57875 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57880 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57886 */     GIR_RootConstrainSelectedInstOperands,
     /*  57887 */     // GIR_Coverage, 1400,
     /*  57887 */     GIR_EraseRootFromParent_Done,
     /*  57888 */   // Label 1238: @57888
     /*  57888 */   GIM_Try, /*On fail goto*//*Label 1239*/ GIMT_Encode4(57942), // Rule ID 1401 //
     /*  57893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  57904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  57907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  57910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57922 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3825:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VQSHLuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  57922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv2i64),
     /*  57925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57929 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57934 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57940 */     GIR_RootConstrainSelectedInstOperands,
     /*  57941 */     // GIR_Coverage, 1401,
     /*  57941 */     GIR_EraseRootFromParent_Done,
     /*  57942 */   // Label 1239: @57942
     /*  57942 */   GIM_Try, /*On fail goto*//*Label 1240*/ GIMT_Encode4(57996), // Rule ID 1435 //
     /*  57947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  57955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  57958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  57961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  57964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57976 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3818:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VQRSHLsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  57976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv4i16),
     /*  57979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57988 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57994 */     GIR_RootConstrainSelectedInstOperands,
     /*  57995 */     // GIR_Coverage, 1435,
     /*  57995 */     GIR_EraseRootFromParent_Done,
     /*  57996 */   // Label 1240: @57996
     /*  57996 */   GIM_Try, /*On fail goto*//*Label 1241*/ GIMT_Encode4(58050), // Rule ID 1436 //
     /*  58001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  58009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  58012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  58015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  58018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58030 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3818:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VQRSHLsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  58030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv2i32),
     /*  58033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58037 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58042 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58048 */     GIR_RootConstrainSelectedInstOperands,
     /*  58049 */     // GIR_Coverage, 1436,
     /*  58049 */     GIR_EraseRootFromParent_Done,
     /*  58050 */   // Label 1241: @58050
     /*  58050 */   GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(58104), // Rule ID 1437 //
     /*  58055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  58063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  58066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  58069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  58072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58084 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3818:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VQRSHLsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  58084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv8i16),
     /*  58087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58091 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58096 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58102 */     GIR_RootConstrainSelectedInstOperands,
     /*  58103 */     // GIR_Coverage, 1437,
     /*  58103 */     GIR_EraseRootFromParent_Done,
     /*  58104 */   // Label 1242: @58104
     /*  58104 */   GIM_Try, /*On fail goto*//*Label 1243*/ GIMT_Encode4(58158), // Rule ID 1438 //
     /*  58109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  58117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  58120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  58123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  58126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58138 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3818:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VQRSHLsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  58138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv4i32),
     /*  58141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58150 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58156 */     GIR_RootConstrainSelectedInstOperands,
     /*  58157 */     // GIR_Coverage, 1438,
     /*  58157 */     GIR_EraseRootFromParent_Done,
     /*  58158 */   // Label 1243: @58158
     /*  58158 */   GIM_Try, /*On fail goto*//*Label 1244*/ GIMT_Encode4(58212), // Rule ID 1439 //
     /*  58163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  58171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  58174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  58177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  58180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58192 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3818:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VQRSHLsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  58192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv8i8),
     /*  58195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58199 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58204 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58210 */     GIR_RootConstrainSelectedInstOperands,
     /*  58211 */     // GIR_Coverage, 1439,
     /*  58211 */     GIR_EraseRootFromParent_Done,
     /*  58212 */   // Label 1244: @58212
     /*  58212 */   GIM_Try, /*On fail goto*//*Label 1245*/ GIMT_Encode4(58266), // Rule ID 1440 //
     /*  58217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  58225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  58228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  58231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  58234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58246 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3818:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VQRSHLsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  58246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv16i8),
     /*  58249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58253 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58258 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58264 */     GIR_RootConstrainSelectedInstOperands,
     /*  58265 */     // GIR_Coverage, 1440,
     /*  58265 */     GIR_EraseRootFromParent_Done,
     /*  58266 */   // Label 1245: @58266
     /*  58266 */   GIM_Try, /*On fail goto*//*Label 1246*/ GIMT_Encode4(58320), // Rule ID 1441 //
     /*  58271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  58279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  58282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  58285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  58288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58300 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3818:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VQRSHLsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  58300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv1i64),
     /*  58303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58307 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58312 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58318 */     GIR_RootConstrainSelectedInstOperands,
     /*  58319 */     // GIR_Coverage, 1441,
     /*  58319 */     GIR_EraseRootFromParent_Done,
     /*  58320 */   // Label 1246: @58320
     /*  58320 */   GIM_Try, /*On fail goto*//*Label 1247*/ GIMT_Encode4(58374), // Rule ID 1442 //
     /*  58325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  58333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  58336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  58339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  58342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58354 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3818:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VQRSHLsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  58354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv2i64),
     /*  58357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58361 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58366 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58372 */     GIR_RootConstrainSelectedInstOperands,
     /*  58373 */     // GIR_Coverage, 1442,
     /*  58373 */     GIR_EraseRootFromParent_Done,
     /*  58374 */   // Label 1247: @58374
     /*  58374 */   GIM_Try, /*On fail goto*//*Label 1248*/ GIMT_Encode4(58428), // Rule ID 1443 //
     /*  58379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  58390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  58393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  58396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58408 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3819:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VQRSHLuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  58408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv4i16),
     /*  58411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58415 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58420 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58426 */     GIR_RootConstrainSelectedInstOperands,
     /*  58427 */     // GIR_Coverage, 1443,
     /*  58427 */     GIR_EraseRootFromParent_Done,
     /*  58428 */   // Label 1248: @58428
     /*  58428 */   GIM_Try, /*On fail goto*//*Label 1249*/ GIMT_Encode4(58482), // Rule ID 1444 //
     /*  58433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  58444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  58447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  58450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58462 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3819:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VQRSHLuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  58462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv2i32),
     /*  58465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58469 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58474 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58480 */     GIR_RootConstrainSelectedInstOperands,
     /*  58481 */     // GIR_Coverage, 1444,
     /*  58481 */     GIR_EraseRootFromParent_Done,
     /*  58482 */   // Label 1249: @58482
     /*  58482 */   GIM_Try, /*On fail goto*//*Label 1250*/ GIMT_Encode4(58536), // Rule ID 1445 //
     /*  58487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  58498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  58501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  58504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58516 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3819:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VQRSHLuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  58516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv8i16),
     /*  58519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58528 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58534 */     GIR_RootConstrainSelectedInstOperands,
     /*  58535 */     // GIR_Coverage, 1445,
     /*  58535 */     GIR_EraseRootFromParent_Done,
     /*  58536 */   // Label 1250: @58536
     /*  58536 */   GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(58590), // Rule ID 1446 //
     /*  58541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  58552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  58555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  58558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58570 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3819:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VQRSHLuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  58570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv4i32),
     /*  58573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58577 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58582 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58588 */     GIR_RootConstrainSelectedInstOperands,
     /*  58589 */     // GIR_Coverage, 1446,
     /*  58589 */     GIR_EraseRootFromParent_Done,
     /*  58590 */   // Label 1251: @58590
     /*  58590 */   GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(58644), // Rule ID 1447 //
     /*  58595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  58606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  58609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  58612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58624 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3819:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VQRSHLuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  58624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv8i8),
     /*  58627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58631 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58636 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58642 */     GIR_RootConstrainSelectedInstOperands,
     /*  58643 */     // GIR_Coverage, 1447,
     /*  58643 */     GIR_EraseRootFromParent_Done,
     /*  58644 */   // Label 1252: @58644
     /*  58644 */   GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(58698), // Rule ID 1448 //
     /*  58649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  58660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  58663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  58666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58678 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3819:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VQRSHLuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  58678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv16i8),
     /*  58681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58685 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58690 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58696 */     GIR_RootConstrainSelectedInstOperands,
     /*  58697 */     // GIR_Coverage, 1448,
     /*  58697 */     GIR_EraseRootFromParent_Done,
     /*  58698 */   // Label 1253: @58698
     /*  58698 */   GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(58752), // Rule ID 1449 //
     /*  58703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  58714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  58717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  58720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58732 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3819:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VQRSHLuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  58732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv1i64),
     /*  58735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58739 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58744 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58750 */     GIR_RootConstrainSelectedInstOperands,
     /*  58751 */     // GIR_Coverage, 1449,
     /*  58751 */     GIR_EraseRootFromParent_Done,
     /*  58752 */   // Label 1254: @58752
     /*  58752 */   GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(58806), // Rule ID 1450 //
     /*  58757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  58768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  58771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  58774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58786 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3819:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VQRSHLuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  58786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv2i64),
     /*  58789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58793 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58798 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58804 */     GIR_RootConstrainSelectedInstOperands,
     /*  58805 */     // GIR_Coverage, 1450,
     /*  58805 */     GIR_EraseRootFromParent_Done,
     /*  58806 */   // Label 1255: @58806
     /*  58806 */   GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(58851), // Rule ID 1715 //
     /*  58811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasV8),
     /*  58814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_aesd),
     /*  58819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  58822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  58825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  58828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58840 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3720:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$src, QPR:{ *:[v16i8] }:$Vm)  =>  (AESD:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src, QPR:{ *:[v16i8] }:$Vm)
     /*  58840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::AESD),
     /*  58843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58845 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  58847 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  58849 */     GIR_RootConstrainSelectedInstOperands,
     /*  58850 */     // GIR_Coverage, 1715,
     /*  58850 */     GIR_EraseRootFromParent_Done,
     /*  58851 */   // Label 1256: @58851
     /*  58851 */   GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(58896), // Rule ID 1716 //
     /*  58856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasV8),
     /*  58859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_aese),
     /*  58864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  58867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  58870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  58873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58885 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3721:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$src, QPR:{ *:[v16i8] }:$Vm)  =>  (AESE:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src, QPR:{ *:[v16i8] }:$Vm)
     /*  58885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::AESE),
     /*  58888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58890 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  58892 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  58894 */     GIR_RootConstrainSelectedInstOperands,
     /*  58895 */     // GIR_Coverage, 1716,
     /*  58895 */     GIR_EraseRootFromParent_Done,
     /*  58896 */   // Label 1257: @58896
     /*  58896 */   GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(58941), // Rule ID 1719 //
     /*  58901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  58904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1su1),
     /*  58909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  58912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  58915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  58918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58930 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3734:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA1SU1:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vm)
     /*  58930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA1SU1),
     /*  58933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58935 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  58937 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  58939 */     GIR_RootConstrainSelectedInstOperands,
     /*  58940 */     // GIR_Coverage, 1719,
     /*  58940 */     GIR_EraseRootFromParent_Done,
     /*  58941 */   // Label 1258: @58941
     /*  58941 */   GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(58986), // Rule ID 1720 //
     /*  58946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  58949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha256su0),
     /*  58954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  58957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  58960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  58963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58975 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3737:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA256SU0:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vm)
     /*  58975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA256SU0),
     /*  58978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58980 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  58982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  58984 */     GIR_RootConstrainSelectedInstOperands,
     /*  58985 */     // GIR_Coverage, 1720,
     /*  58985 */     GIR_EraseRootFromParent_Done,
     /*  58986 */   // Label 1259: @58986
     /*  58986 */   GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(59040), // Rule ID 1729 //
     /*  58991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  58994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_sqrshr),
     /*  58999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59020 */     // (intrinsic_wo_chain:{ *:[i32] } 3583:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_SQRSHR:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, rGPR:{ *:[i32] }:$Rm)
     /*  59020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_SQRSHR),
     /*  59023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  59025 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  59027 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59032 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59038 */     GIR_RootConstrainSelectedInstOperands,
     /*  59039 */     // GIR_Coverage, 1729,
     /*  59039 */     GIR_EraseRootFromParent_Done,
     /*  59040 */   // Label 1260: @59040
     /*  59040 */   GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(59094), // Rule ID 1730 //
     /*  59045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  59048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_uqrshl),
     /*  59053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59074 */     // (intrinsic_wo_chain:{ *:[i32] } 3590:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_UQRSHL:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, rGPR:{ *:[i32] }:$Rm)
     /*  59074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_UQRSHL),
     /*  59077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  59079 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  59081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59086 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59092 */     GIR_RootConstrainSelectedInstOperands,
     /*  59093 */     // GIR_Coverage, 1730,
     /*  59093 */     GIR_EraseRootFromParent_Done,
     /*  59094 */   // Label 1261: @59094
     /*  59094 */   GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(59151), // Rule ID 1853 //
     /*  59099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  59102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sxtab16),
     /*  59107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59128 */     // (intrinsic_wo_chain:{ *:[i32] } 3919:{ *:[iPTR] }, GPR:{ *:[i32] }:$LHS, GPR:{ *:[i32] }:$RHS)  =>  (SXTAB16:{ *:[i32] } GPR:{ *:[i32] }:$LHS, GPR:{ *:[i32] }:$RHS, 0:{ *:[i32] })
     /*  59128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTAB16),
     /*  59131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59133 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  59135 */     GIR_RootToRootCopy, /*OpIdx*/3, // RHS
     /*  59137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  59140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59143 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59149 */     GIR_RootConstrainSelectedInstOperands,
     /*  59150 */     // GIR_Coverage, 1853,
     /*  59150 */     GIR_EraseRootFromParent_Done,
     /*  59151 */   // Label 1262: @59151
     /*  59151 */   GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(59208), // Rule ID 1860 //
     /*  59156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  59159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uxtab16),
     /*  59164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59185 */     // (intrinsic_wo_chain:{ *:[i32] } 3944:{ *:[iPTR] }, GPR:{ *:[i32] }:$LHS, GPR:{ *:[i32] }:$RHS)  =>  (UXTAB16:{ *:[i32] } GPR:{ *:[i32] }:$LHS, GPR:{ *:[i32] }:$RHS, 0:{ *:[i32] })
     /*  59185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTAB16),
     /*  59188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59190 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  59192 */     GIR_RootToRootCopy, /*OpIdx*/3, // RHS
     /*  59194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  59197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59200 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59206 */     GIR_RootConstrainSelectedInstOperands,
     /*  59207 */     // GIR_Coverage, 1860,
     /*  59207 */     GIR_EraseRootFromParent_Done,
     /*  59208 */   // Label 1263: @59208
     /*  59208 */   GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(59262), // Rule ID 1907 //
     /*  59213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  59216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smuad),
     /*  59221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59242 */     // (intrinsic_wo_chain:{ *:[i32] } 3895:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SMUAD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  59242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMUAD),
     /*  59245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59254 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59260 */     GIR_RootConstrainSelectedInstOperands,
     /*  59261 */     // GIR_Coverage, 1907,
     /*  59261 */     GIR_EraseRootFromParent_Done,
     /*  59262 */   // Label 1264: @59262
     /*  59262 */   GIM_Try, /*On fail goto*//*Label 1265*/ GIMT_Encode4(59316), // Rule ID 1908 //
     /*  59267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  59270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smuadx),
     /*  59275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59296 */     // (intrinsic_wo_chain:{ *:[i32] } 3896:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SMUADX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  59296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMUADX),
     /*  59299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59303 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59308 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59314 */     GIR_RootConstrainSelectedInstOperands,
     /*  59315 */     // GIR_Coverage, 1908,
     /*  59315 */     GIR_EraseRootFromParent_Done,
     /*  59316 */   // Label 1265: @59316
     /*  59316 */   GIM_Try, /*On fail goto*//*Label 1266*/ GIMT_Encode4(59370), // Rule ID 1909 //
     /*  59321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  59324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smusd),
     /*  59329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59350 */     // (intrinsic_wo_chain:{ *:[i32] } 3903:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SMUSD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  59350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMUSD),
     /*  59353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59357 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59362 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59368 */     GIR_RootConstrainSelectedInstOperands,
     /*  59369 */     // GIR_Coverage, 1909,
     /*  59369 */     GIR_EraseRootFromParent_Done,
     /*  59370 */   // Label 1266: @59370
     /*  59370 */   GIM_Try, /*On fail goto*//*Label 1267*/ GIMT_Encode4(59424), // Rule ID 1910 //
     /*  59375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  59378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smusdx),
     /*  59383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59404 */     // (intrinsic_wo_chain:{ *:[i32] } 3904:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SMUSDX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  59404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMUSDX),
     /*  59407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59411 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59416 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59422 */     GIR_RootConstrainSelectedInstOperands,
     /*  59423 */     // GIR_Coverage, 1910,
     /*  59423 */     GIR_EraseRootFromParent_Done,
     /*  59424 */   // Label 1267: @59424
     /*  59424 */   GIM_Try, /*On fail goto*//*Label 1268*/ GIMT_Encode4(59478), // Rule ID 1984 //
     /*  59429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulbb),
     /*  59437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59458 */     // (intrinsic_wo_chain:{ *:[i32] } 3897:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULBB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULBB),
     /*  59461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59463 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59465 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59470 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59476 */     GIR_RootConstrainSelectedInstOperands,
     /*  59477 */     // GIR_Coverage, 1984,
     /*  59477 */     GIR_EraseRootFromParent_Done,
     /*  59478 */   // Label 1268: @59478
     /*  59478 */   GIM_Try, /*On fail goto*//*Label 1269*/ GIMT_Encode4(59532), // Rule ID 1985 //
     /*  59483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulbt),
     /*  59491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59512 */     // (intrinsic_wo_chain:{ *:[i32] } 3898:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULBT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULBT),
     /*  59515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59517 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59519 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59524 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59530 */     GIR_RootConstrainSelectedInstOperands,
     /*  59531 */     // GIR_Coverage, 1985,
     /*  59531 */     GIR_EraseRootFromParent_Done,
     /*  59532 */   // Label 1269: @59532
     /*  59532 */   GIM_Try, /*On fail goto*//*Label 1270*/ GIMT_Encode4(59586), // Rule ID 1986 //
     /*  59537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smultb),
     /*  59545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59566 */     // (intrinsic_wo_chain:{ *:[i32] } 3899:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULTB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULTB),
     /*  59569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59571 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59573 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59578 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59584 */     GIR_RootConstrainSelectedInstOperands,
     /*  59585 */     // GIR_Coverage, 1986,
     /*  59585 */     GIR_EraseRootFromParent_Done,
     /*  59586 */   // Label 1270: @59586
     /*  59586 */   GIM_Try, /*On fail goto*//*Label 1271*/ GIMT_Encode4(59640), // Rule ID 1987 //
     /*  59591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smultt),
     /*  59599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59620 */     // (intrinsic_wo_chain:{ *:[i32] } 3900:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULTT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULTT),
     /*  59623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59625 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59627 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59632 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59638 */     GIR_RootConstrainSelectedInstOperands,
     /*  59639 */     // GIR_Coverage, 1987,
     /*  59639 */     GIR_EraseRootFromParent_Done,
     /*  59640 */   // Label 1271: @59640
     /*  59640 */   GIM_Try, /*On fail goto*//*Label 1272*/ GIMT_Encode4(59694), // Rule ID 1988 //
     /*  59645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulwb),
     /*  59653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59674 */     // (intrinsic_wo_chain:{ *:[i32] } 3901:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULWB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULWB),
     /*  59677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59679 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59681 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59686 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59692 */     GIR_RootConstrainSelectedInstOperands,
     /*  59693 */     // GIR_Coverage, 1988,
     /*  59693 */     GIR_EraseRootFromParent_Done,
     /*  59694 */   // Label 1272: @59694
     /*  59694 */   GIM_Try, /*On fail goto*//*Label 1273*/ GIMT_Encode4(59748), // Rule ID 1989 //
     /*  59699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulwt),
     /*  59707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59728 */     // (intrinsic_wo_chain:{ *:[i32] } 3902:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULWT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULWT),
     /*  59731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59733 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59735 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59740 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59746 */     GIR_RootConstrainSelectedInstOperands,
     /*  59747 */     // GIR_Coverage, 1989,
     /*  59747 */     GIR_EraseRootFromParent_Done,
     /*  59748 */   // Label 1273: @59748
     /*  59748 */   GIM_Try, /*On fail goto*//*Label 1274*/ GIMT_Encode4(59805), // Rule ID 2100 //
     /*  59753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  59756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sxtab16),
     /*  59761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59782 */     // (intrinsic_wo_chain:{ *:[i32] } 3919:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SXTAB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  59782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAB16),
     /*  59785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59789 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  59794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59797 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59803 */     GIR_RootConstrainSelectedInstOperands,
     /*  59804 */     // GIR_Coverage, 2100,
     /*  59804 */     GIR_EraseRootFromParent_Done,
     /*  59805 */   // Label 1274: @59805
     /*  59805 */   GIM_Try, /*On fail goto*//*Label 1275*/ GIMT_Encode4(59859), // Rule ID 2130 //
     /*  59810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  59813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  59818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59839 */     // (intrinsic_wo_chain:{ *:[i32] } 3862:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)  =>  (t2QADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /*  59839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QADD),
     /*  59842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59844 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  59846 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /*  59848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59851 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59857 */     GIR_RootConstrainSelectedInstOperands,
     /*  59858 */     // GIR_Coverage, 2130,
     /*  59858 */     GIR_EraseRootFromParent_Done,
     /*  59859 */   // Label 1275: @59859
     /*  59859 */   GIM_Try, /*On fail goto*//*Label 1276*/ GIMT_Encode4(59913), // Rule ID 2131 //
     /*  59864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  59867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub),
     /*  59872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59893 */     // (intrinsic_wo_chain:{ *:[i32] } 3867:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)  =>  (t2QSUB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /*  59893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QSUB),
     /*  59896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59898 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  59900 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /*  59902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59905 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59911 */     GIR_RootConstrainSelectedInstOperands,
     /*  59912 */     // GIR_Coverage, 2131,
     /*  59912 */     GIR_EraseRootFromParent_Done,
     /*  59913 */   // Label 1276: @59913
     /*  59913 */   GIM_Try, /*On fail goto*//*Label 1277*/ GIMT_Encode4(59967), // Rule ID 2171 //
     /*  59918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  59921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulbb),
     /*  59926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59947 */     // (intrinsic_wo_chain:{ *:[i32] } 3897:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULBB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  59947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULBB),
     /*  59950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59954 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59959 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59965 */     GIR_RootConstrainSelectedInstOperands,
     /*  59966 */     // GIR_Coverage, 2171,
     /*  59966 */     GIR_EraseRootFromParent_Done,
     /*  59967 */   // Label 1277: @59967
     /*  59967 */   GIM_Try, /*On fail goto*//*Label 1278*/ GIMT_Encode4(60021), // Rule ID 2172 //
     /*  59972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  59975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulbt),
     /*  59980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60001 */     // (intrinsic_wo_chain:{ *:[i32] } 3898:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULBT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  60001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULBT),
     /*  60004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60008 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  60013 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60019 */     GIR_RootConstrainSelectedInstOperands,
     /*  60020 */     // GIR_Coverage, 2172,
     /*  60020 */     GIR_EraseRootFromParent_Done,
     /*  60021 */   // Label 1278: @60021
     /*  60021 */   GIM_Try, /*On fail goto*//*Label 1279*/ GIMT_Encode4(60075), // Rule ID 2173 //
     /*  60026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  60029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smultb),
     /*  60034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  60043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60055 */     // (intrinsic_wo_chain:{ *:[i32] } 3899:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULTB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  60055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULTB),
     /*  60058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60062 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  60067 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60073 */     GIR_RootConstrainSelectedInstOperands,
     /*  60074 */     // GIR_Coverage, 2173,
     /*  60074 */     GIR_EraseRootFromParent_Done,
     /*  60075 */   // Label 1279: @60075
     /*  60075 */   GIM_Try, /*On fail goto*//*Label 1280*/ GIMT_Encode4(60129), // Rule ID 2174 //
     /*  60080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  60083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smultt),
     /*  60088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  60097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60109 */     // (intrinsic_wo_chain:{ *:[i32] } 3900:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULTT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  60109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULTT),
     /*  60112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  60121 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60127 */     GIR_RootConstrainSelectedInstOperands,
     /*  60128 */     // GIR_Coverage, 2174,
     /*  60128 */     GIR_EraseRootFromParent_Done,
     /*  60129 */   // Label 1280: @60129
     /*  60129 */   GIM_Try, /*On fail goto*//*Label 1281*/ GIMT_Encode4(60183), // Rule ID 2175 //
     /*  60134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  60137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulwb),
     /*  60142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  60151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60163 */     // (intrinsic_wo_chain:{ *:[i32] } 3901:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULWB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  60163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULWB),
     /*  60166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60170 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  60175 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60181 */     GIR_RootConstrainSelectedInstOperands,
     /*  60182 */     // GIR_Coverage, 2175,
     /*  60182 */     GIR_EraseRootFromParent_Done,
     /*  60183 */   // Label 1281: @60183
     /*  60183 */   GIM_Try, /*On fail goto*//*Label 1282*/ GIMT_Encode4(60237), // Rule ID 2176 //
     /*  60188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  60191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulwt),
     /*  60196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  60205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60217 */     // (intrinsic_wo_chain:{ *:[i32] } 3902:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULWT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  60217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULWT),
     /*  60220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60224 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  60229 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60235 */     GIR_RootConstrainSelectedInstOperands,
     /*  60236 */     // GIR_Coverage, 2176,
     /*  60236 */     GIR_EraseRootFromParent_Done,
     /*  60237 */   // Label 1282: @60237
     /*  60237 */   GIM_Try, /*On fail goto*//*Label 1283*/ GIMT_Encode4(60285), // Rule ID 2513 //
     /*  60242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8_3a),
     /*  60245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot90),
     /*  60250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  60253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  60256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  60259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60271 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3751:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Rn, DPR:{ *:[v4f16] }:$Rm)  =>  (VCADDv4f16:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Rn, DPR:{ *:[v4f16] }:$Rm, 0:{ *:[i32] })
     /*  60271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv4f16),
     /*  60274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60283 */     GIR_RootConstrainSelectedInstOperands,
     /*  60284 */     // GIR_Coverage, 2513,
     /*  60284 */     GIR_EraseRootFromParent_Done,
     /*  60285 */   // Label 1283: @60285
     /*  60285 */   GIM_Try, /*On fail goto*//*Label 1284*/ GIMT_Encode4(60333), // Rule ID 2514 //
     /*  60290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8_3a),
     /*  60293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot270),
     /*  60298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  60301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  60304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  60307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60319 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3750:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Rn, DPR:{ *:[v4f16] }:$Rm)  =>  (VCADDv4f16:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Rn, DPR:{ *:[v4f16] }:$Rm, 1:{ *:[i32] })
     /*  60319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv4f16),
     /*  60322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  60331 */     GIR_RootConstrainSelectedInstOperands,
     /*  60332 */     // GIR_Coverage, 2514,
     /*  60332 */     GIR_EraseRootFromParent_Done,
     /*  60333 */   // Label 1284: @60333
     /*  60333 */   GIM_Try, /*On fail goto*//*Label 1285*/ GIMT_Encode4(60381), // Rule ID 2515 //
     /*  60338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8_3a),
     /*  60341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot90),
     /*  60346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  60349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  60352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  60355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60367 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3751:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Rn, QPR:{ *:[v8f16] }:$Rm)  =>  (VCADDv8f16:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Rn, QPR:{ *:[v8f16] }:$Rm, 0:{ *:[i32] })
     /*  60367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv8f16),
     /*  60370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60374 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60379 */     GIR_RootConstrainSelectedInstOperands,
     /*  60380 */     // GIR_Coverage, 2515,
     /*  60380 */     GIR_EraseRootFromParent_Done,
     /*  60381 */   // Label 1285: @60381
     /*  60381 */   GIM_Try, /*On fail goto*//*Label 1286*/ GIMT_Encode4(60429), // Rule ID 2516 //
     /*  60386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8_3a),
     /*  60389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot270),
     /*  60394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  60397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  60400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  60403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60415 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3750:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Rn, QPR:{ *:[v8f16] }:$Rm)  =>  (VCADDv8f16:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Rn, QPR:{ *:[v8f16] }:$Rm, 1:{ *:[i32] })
     /*  60415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv8f16),
     /*  60418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60422 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  60427 */     GIR_RootConstrainSelectedInstOperands,
     /*  60428 */     // GIR_Coverage, 2516,
     /*  60428 */     GIR_EraseRootFromParent_Done,
     /*  60429 */   // Label 1286: @60429
     /*  60429 */   GIM_Try, /*On fail goto*//*Label 1287*/ GIMT_Encode4(60477), // Rule ID 2517 //
     /*  60434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_3a),
     /*  60437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot90),
     /*  60442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  60445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  60451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60463 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3751:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Rn, DPR:{ *:[v2f32] }:$Rm)  =>  (VCADDv2f32:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Rn, DPR:{ *:[v2f32] }:$Rm, 0:{ *:[i32] })
     /*  60463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv2f32),
     /*  60466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60470 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60475 */     GIR_RootConstrainSelectedInstOperands,
     /*  60476 */     // GIR_Coverage, 2517,
     /*  60476 */     GIR_EraseRootFromParent_Done,
     /*  60477 */   // Label 1287: @60477
     /*  60477 */   GIM_Try, /*On fail goto*//*Label 1288*/ GIMT_Encode4(60525), // Rule ID 2518 //
     /*  60482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_3a),
     /*  60485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot270),
     /*  60490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  60493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  60499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60511 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3750:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Rn, DPR:{ *:[v2f32] }:$Rm)  =>  (VCADDv2f32:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Rn, DPR:{ *:[v2f32] }:$Rm, 1:{ *:[i32] })
     /*  60511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv2f32),
     /*  60514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60518 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  60523 */     GIR_RootConstrainSelectedInstOperands,
     /*  60524 */     // GIR_Coverage, 2518,
     /*  60524 */     GIR_EraseRootFromParent_Done,
     /*  60525 */   // Label 1288: @60525
     /*  60525 */   GIM_Try, /*On fail goto*//*Label 1289*/ GIMT_Encode4(60573), // Rule ID 2519 //
     /*  60530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_3a),
     /*  60533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot90),
     /*  60538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  60541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  60544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  60547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60559 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3751:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Rn, QPR:{ *:[v4f32] }:$Rm)  =>  (VCADDv4f32:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Rn, QPR:{ *:[v4f32] }:$Rm, 0:{ *:[i32] })
     /*  60559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv4f32),
     /*  60562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60566 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60571 */     GIR_RootConstrainSelectedInstOperands,
     /*  60572 */     // GIR_Coverage, 2519,
     /*  60572 */     GIR_EraseRootFromParent_Done,
     /*  60573 */   // Label 1289: @60573
     /*  60573 */   GIM_Try, /*On fail goto*//*Label 1290*/ GIMT_Encode4(60621), // Rule ID 2520 //
     /*  60578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_3a),
     /*  60581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot270),
     /*  60586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  60589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  60592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  60595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60607 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3750:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Rn, QPR:{ *:[v4f32] }:$Rm)  =>  (VCADDv4f32:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Rn, QPR:{ *:[v4f32] }:$Rm, 1:{ *:[i32] })
     /*  60607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv4f32),
     /*  60610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60614 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  60619 */     GIR_RootConstrainSelectedInstOperands,
     /*  60620 */     // GIR_Coverage, 2520,
     /*  60620 */     GIR_EraseRootFromParent_Done,
     /*  60621 */   // Label 1290: @60621
     /*  60621 */   GIM_Try, /*On fail goto*//*Label 1291*/ GIMT_Encode4(60726), // Rule ID 3105 //
     /*  60626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  60629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minnmv),
     /*  60634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  60643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  60647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  60651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  60655 */     // (intrinsic_wo_chain:{ *:[f32] } 3559:{ *:[iPTR] }, SPR:{ *:[f32] }:$prev, MQPR:{ *:[v4f32] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (MVE_VMINNMVf32:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } SPR:{ *:[f32] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v4f32] }:$vec), SPR:{ *:[i32] })
     /*  60655 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  60658 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60662 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60667 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  60671 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60676 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60679 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMVf32),
     /*  60683 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60688 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  60691 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  60695 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  60698 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60704 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60710 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60717 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60720 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  60725 */     // GIR_Coverage, 3105,
     /*  60725 */     GIR_EraseRootFromParent_Done,
     /*  60726 */   // Label 1291: @60726
     /*  60726 */   GIM_Try, /*On fail goto*//*Label 1292*/ GIMT_Encode4(60831), // Rule ID 3107 //
     /*  60731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  60734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minnmv),
     /*  60739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /*  60742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  60745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  60748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  60752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  60756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  60760 */     // (intrinsic_wo_chain:{ *:[f16] } 3559:{ *:[iPTR] }, HPR:{ *:[f16] }:$prev, MQPR:{ *:[v8f16] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (MVE_VMINNMVf16:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } HPR:{ *:[f16] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v8f16] }:$vec), HPR:{ *:[i32] })
     /*  60760 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  60763 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60767 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60772 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  60776 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60781 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60784 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMVf16),
     /*  60788 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60793 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  60796 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  60800 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  60803 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60809 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60815 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60822 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60825 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /*  60830 */     // GIR_Coverage, 3107,
     /*  60830 */     GIR_EraseRootFromParent_Done,
     /*  60831 */   // Label 1292: @60831
     /*  60831 */   GIM_Try, /*On fail goto*//*Label 1293*/ GIMT_Encode4(60936), // Rule ID 3109 //
     /*  60836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  60839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxnmv),
     /*  60844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  60853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  60857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  60861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  60865 */     // (intrinsic_wo_chain:{ *:[f32] } 3550:{ *:[iPTR] }, SPR:{ *:[f32] }:$prev, MQPR:{ *:[v4f32] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (MVE_VMAXNMVf32:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } SPR:{ *:[f32] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v4f32] }:$vec), SPR:{ *:[i32] })
     /*  60865 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  60868 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60872 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60877 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  60881 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60886 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60889 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMVf32),
     /*  60893 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60898 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  60901 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  60905 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  60908 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60914 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60920 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60927 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60930 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  60935 */     // GIR_Coverage, 3109,
     /*  60935 */     GIR_EraseRootFromParent_Done,
     /*  60936 */   // Label 1293: @60936
     /*  60936 */   GIM_Try, /*On fail goto*//*Label 1294*/ GIMT_Encode4(61041), // Rule ID 3111 //
     /*  60941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  60944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxnmv),
     /*  60949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /*  60952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  60955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  60958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  60962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  60966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  60970 */     // (intrinsic_wo_chain:{ *:[f16] } 3550:{ *:[iPTR] }, HPR:{ *:[f16] }:$prev, MQPR:{ *:[v8f16] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (MVE_VMAXNMVf16:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } HPR:{ *:[f16] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v8f16] }:$vec), HPR:{ *:[i32] })
     /*  60970 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  60973 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60977 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60982 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  60986 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60991 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60994 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMVf16),
     /*  60998 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61003 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61006 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  61010 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  61013 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61019 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61025 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61032 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61035 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /*  61040 */     // GIR_Coverage, 3111,
     /*  61040 */     GIR_EraseRootFromParent_Done,
     /*  61041 */   // Label 1294: @61041
     /*  61041 */   GIM_Try, /*On fail goto*//*Label 1295*/ GIMT_Encode4(61146), // Rule ID 3113 //
     /*  61046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  61049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minnmav),
     /*  61054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  61063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  61067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  61071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61075 */     // (intrinsic_wo_chain:{ *:[f32] } 3557:{ *:[iPTR] }, SPR:{ *:[f32] }:$prev, MQPR:{ *:[v4f32] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (MVE_VMINNMAVf32:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } SPR:{ *:[f32] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v4f32] }:$vec), SPR:{ *:[i32] })
     /*  61075 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  61078 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61082 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61087 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  61091 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61096 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  61099 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMAVf32),
     /*  61103 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61108 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61111 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  61115 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  61118 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61124 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61130 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61137 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61140 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  61145 */     // GIR_Coverage, 3113,
     /*  61145 */     GIR_EraseRootFromParent_Done,
     /*  61146 */   // Label 1295: @61146
     /*  61146 */   GIM_Try, /*On fail goto*//*Label 1296*/ GIMT_Encode4(61251), // Rule ID 3115 //
     /*  61151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  61154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minnmav),
     /*  61159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /*  61162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  61165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  61168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  61172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  61176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61180 */     // (intrinsic_wo_chain:{ *:[f16] } 3557:{ *:[iPTR] }, HPR:{ *:[f16] }:$prev, MQPR:{ *:[v8f16] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (MVE_VMINNMAVf16:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } HPR:{ *:[f16] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v8f16] }:$vec), HPR:{ *:[i32] })
     /*  61180 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  61183 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61187 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61192 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  61196 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61201 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  61204 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMAVf16),
     /*  61208 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61213 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61216 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  61220 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  61223 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61229 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61235 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61242 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61245 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /*  61250 */     // GIR_Coverage, 3115,
     /*  61250 */     GIR_EraseRootFromParent_Done,
     /*  61251 */   // Label 1296: @61251
     /*  61251 */   GIM_Try, /*On fail goto*//*Label 1297*/ GIMT_Encode4(61356), // Rule ID 3117 //
     /*  61256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  61259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxnmav),
     /*  61264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  61273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  61277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  61281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61285 */     // (intrinsic_wo_chain:{ *:[f32] } 3548:{ *:[iPTR] }, SPR:{ *:[f32] }:$prev, MQPR:{ *:[v4f32] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (MVE_VMAXNMAVf32:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } SPR:{ *:[f32] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v4f32] }:$vec), SPR:{ *:[i32] })
     /*  61285 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  61288 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61292 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61297 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  61301 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61306 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  61309 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMAVf32),
     /*  61313 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61318 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61321 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  61325 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  61328 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61334 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61340 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61347 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61350 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  61355 */     // GIR_Coverage, 3117,
     /*  61355 */     GIR_EraseRootFromParent_Done,
     /*  61356 */   // Label 1297: @61356
     /*  61356 */   GIM_Try, /*On fail goto*//*Label 1298*/ GIMT_Encode4(61461), // Rule ID 3119 //
     /*  61361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  61364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxnmav),
     /*  61369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /*  61372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  61375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  61378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  61382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  61386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61390 */     // (intrinsic_wo_chain:{ *:[f16] } 3548:{ *:[iPTR] }, HPR:{ *:[f16] }:$prev, MQPR:{ *:[v8f16] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (MVE_VMAXNMAVf16:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } HPR:{ *:[f16] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v8f16] }:$vec), HPR:{ *:[i32] })
     /*  61390 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  61393 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61397 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61402 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  61406 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61411 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  61414 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMAVf16),
     /*  61418 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61423 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61426 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  61430 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  61433 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61439 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61445 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61452 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61455 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /*  61460 */     // GIR_Coverage, 3119,
     /*  61460 */     GIR_EraseRootFromParent_Done,
     /*  61461 */   // Label 1298: @61461
     /*  61461 */   GIM_Try, /*On fail goto*//*Label 1299*/ GIMT_Encode4(61521), // Rule ID 3169 //
     /*  61466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minav),
     /*  61474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  61483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61495 */     // (intrinsic_wo_chain:{ *:[i32] } 3555:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)  =>  (MVE_VMINAVs8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  61495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAVs8),
     /*  61498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61500 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61502 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61507 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61513 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61519 */     GIR_RootConstrainSelectedInstOperands,
     /*  61520 */     // GIR_Coverage, 3169,
     /*  61520 */     GIR_EraseRootFromParent_Done,
     /*  61521 */   // Label 1299: @61521
     /*  61521 */   GIM_Try, /*On fail goto*//*Label 1300*/ GIMT_Encode4(61581), // Rule ID 3171 //
     /*  61526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minav),
     /*  61534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  61543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61555 */     // (intrinsic_wo_chain:{ *:[i32] } 3555:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)  =>  (MVE_VMINAVs16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  61555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAVs16),
     /*  61558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61560 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61562 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61567 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61573 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61579 */     GIR_RootConstrainSelectedInstOperands,
     /*  61580 */     // GIR_Coverage, 3171,
     /*  61580 */     GIR_EraseRootFromParent_Done,
     /*  61581 */   // Label 1300: @61581
     /*  61581 */   GIM_Try, /*On fail goto*//*Label 1301*/ GIMT_Encode4(61641), // Rule ID 3173 //
     /*  61586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minav),
     /*  61594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  61603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61615 */     // (intrinsic_wo_chain:{ *:[i32] } 3555:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)  =>  (MVE_VMINAVs32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  61615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAVs32),
     /*  61618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61620 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61622 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61627 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61633 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61639 */     GIR_RootConstrainSelectedInstOperands,
     /*  61640 */     // GIR_Coverage, 3173,
     /*  61640 */     GIR_EraseRootFromParent_Done,
     /*  61641 */   // Label 1301: @61641
     /*  61641 */   GIM_Try, /*On fail goto*//*Label 1302*/ GIMT_Encode4(61701), // Rule ID 3175 //
     /*  61646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxav),
     /*  61654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  61663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61675 */     // (intrinsic_wo_chain:{ *:[i32] } 3546:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)  =>  (MVE_VMAXAVs8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  61675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAVs8),
     /*  61678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61680 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61682 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61687 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61693 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61699 */     GIR_RootConstrainSelectedInstOperands,
     /*  61700 */     // GIR_Coverage, 3175,
     /*  61700 */     GIR_EraseRootFromParent_Done,
     /*  61701 */   // Label 1302: @61701
     /*  61701 */   GIM_Try, /*On fail goto*//*Label 1303*/ GIMT_Encode4(61761), // Rule ID 3177 //
     /*  61706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxav),
     /*  61714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  61723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61735 */     // (intrinsic_wo_chain:{ *:[i32] } 3546:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)  =>  (MVE_VMAXAVs16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  61735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAVs16),
     /*  61738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61740 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61742 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61747 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61753 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61759 */     GIR_RootConstrainSelectedInstOperands,
     /*  61760 */     // GIR_Coverage, 3177,
     /*  61760 */     GIR_EraseRootFromParent_Done,
     /*  61761 */   // Label 1303: @61761
     /*  61761 */   GIM_Try, /*On fail goto*//*Label 1304*/ GIMT_Encode4(61821), // Rule ID 3179 //
     /*  61766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxav),
     /*  61774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  61783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61795 */     // (intrinsic_wo_chain:{ *:[i32] } 3546:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)  =>  (MVE_VMAXAVs32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  61795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAVs32),
     /*  61798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61800 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61802 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61807 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61813 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61819 */     GIR_RootConstrainSelectedInstOperands,
     /*  61820 */     // GIR_Coverage, 3179,
     /*  61820 */     GIR_EraseRootFromParent_Done,
     /*  61821 */   // Label 1304: @61821
     /*  61821 */   GIM_Try, /*On fail goto*//*Label 1305*/ GIMT_Encode4(61896), // Rule ID 3470 //
     /*  61826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmulh),
     /*  61834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  61837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  61840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  61843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61855 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3668:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQDMULHi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  61855 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  61858 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  61862 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULHi8),
     /*  61870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  61872 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  61874 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  61876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61879 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61885 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61894 */     GIR_RootConstrainSelectedInstOperands,
     /*  61895 */     // GIR_Coverage, 3470,
     /*  61895 */     GIR_EraseRootFromParent_Done,
     /*  61896 */   // Label 1305: @61896
     /*  61896 */   GIM_Try, /*On fail goto*//*Label 1306*/ GIMT_Encode4(61971), // Rule ID 3477 //
     /*  61901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmulh),
     /*  61909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  61912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  61915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  61918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61930 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3668:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQDMULHi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  61930 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  61933 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  61937 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULHi16),
     /*  61945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  61947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  61949 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  61951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61954 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61960 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61966 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61969 */     GIR_RootConstrainSelectedInstOperands,
     /*  61970 */     // GIR_Coverage, 3477,
     /*  61970 */     GIR_EraseRootFromParent_Done,
     /*  61971 */   // Label 1306: @61971
     /*  61971 */   GIM_Try, /*On fail goto*//*Label 1307*/ GIMT_Encode4(62046), // Rule ID 3481 //
     /*  61976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmulh),
     /*  61984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  61987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  61990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  61993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62005 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3668:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQDMULHi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  62005 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62008 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62012 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULHi32),
     /*  62020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  62024 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  62026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62029 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62035 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62041 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62044 */     GIR_RootConstrainSelectedInstOperands,
     /*  62045 */     // GIR_Coverage, 3481,
     /*  62045 */     GIR_EraseRootFromParent_Done,
     /*  62046 */   // Label 1307: @62046
     /*  62046 */   GIM_Try, /*On fail goto*//*Label 1308*/ GIMT_Encode4(62121), // Rule ID 3483 //
     /*  62051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  62054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmulh),
     /*  62059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  62062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  62065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  62068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62080 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3677:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQRDMULHi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  62080 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62083 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62087 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMULHi8),
     /*  62095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  62099 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  62101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62104 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62110 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62116 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62119 */     GIR_RootConstrainSelectedInstOperands,
     /*  62120 */     // GIR_Coverage, 3483,
     /*  62120 */     GIR_EraseRootFromParent_Done,
     /*  62121 */   // Label 1308: @62121
     /*  62121 */   GIM_Try, /*On fail goto*//*Label 1309*/ GIMT_Encode4(62196), // Rule ID 3485 //
     /*  62126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  62129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmulh),
     /*  62134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  62137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  62140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  62143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62155 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3677:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQRDMULHi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  62155 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62158 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62162 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMULHi16),
     /*  62170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  62174 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  62176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62179 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62185 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62191 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62194 */     GIR_RootConstrainSelectedInstOperands,
     /*  62195 */     // GIR_Coverage, 3485,
     /*  62195 */     GIR_EraseRootFromParent_Done,
     /*  62196 */   // Label 1309: @62196
     /*  62196 */   GIM_Try, /*On fail goto*//*Label 1310*/ GIMT_Encode4(62271), // Rule ID 3487 //
     /*  62201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  62204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmulh),
     /*  62209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  62218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62230 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3677:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQRDMULHi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  62230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMULHi32),
     /*  62245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  62249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  62251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62254 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62260 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62269 */     GIR_RootConstrainSelectedInstOperands,
     /*  62270 */     // GIR_Coverage, 3487,
     /*  62270 */     GIR_EraseRootFromParent_Done,
     /*  62271 */   // Label 1310: @62271
     /*  62271 */   GIM_Try, /*On fail goto*//*Label 1311*/ GIMT_Encode4(62346), // Rule ID 4755 //
     /*  62276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  62279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vbrsr),
     /*  62284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  62287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  62290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  62305 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3601:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qn, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_VBRSR8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qn, rGPR:{ *:[i32] }:$Rm)
     /*  62305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR8),
     /*  62320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  62324 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  62326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62329 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62335 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62341 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62344 */     GIR_RootConstrainSelectedInstOperands,
     /*  62345 */     // GIR_Coverage, 4755,
     /*  62345 */     GIR_EraseRootFromParent_Done,
     /*  62346 */   // Label 1311: @62346
     /*  62346 */   GIM_Try, /*On fail goto*//*Label 1312*/ GIMT_Encode4(62421), // Rule ID 4760 //
     /*  62351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  62354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vbrsr),
     /*  62359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  62362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  62365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  62380 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3601:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qn, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_VBRSR16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qn, rGPR:{ *:[i32] }:$Rm)
     /*  62380 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62383 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62387 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR16),
     /*  62395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  62399 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  62401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62404 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62410 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62416 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62419 */     GIR_RootConstrainSelectedInstOperands,
     /*  62420 */     // GIR_Coverage, 4760,
     /*  62420 */     GIR_EraseRootFromParent_Done,
     /*  62421 */   // Label 1312: @62421
     /*  62421 */   GIM_Try, /*On fail goto*//*Label 1313*/ GIMT_Encode4(62496), // Rule ID 4762 //
     /*  62426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  62429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vbrsr),
     /*  62434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  62455 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3601:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qn, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_VBRSR32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qn, rGPR:{ *:[i32] }:$Rm)
     /*  62455 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62458 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62462 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR32),
     /*  62470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  62474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  62476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62479 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62485 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62491 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62494 */     GIR_RootConstrainSelectedInstOperands,
     /*  62495 */     // GIR_Coverage, 4762,
     /*  62495 */     GIR_EraseRootFromParent_Done,
     /*  62496 */   // Label 1313: @62496
     /*  62496 */   GIM_Try, /*On fail goto*//*Label 1314*/ GIMT_Encode4(62571), // Rule ID 4764 //
     /*  62501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  62504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vbrsr),
     /*  62509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  62512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  62515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  62530 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3601:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qn, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_VBRSR16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qn, rGPR:{ *:[i32] }:$Rm)
     /*  62530 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62533 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62537 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR16),
     /*  62545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  62549 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  62551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62554 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62560 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62566 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62569 */     GIR_RootConstrainSelectedInstOperands,
     /*  62570 */     // GIR_Coverage, 4764,
     /*  62570 */     GIR_EraseRootFromParent_Done,
     /*  62571 */   // Label 1314: @62571
     /*  62571 */   GIM_Try, /*On fail goto*//*Label 1315*/ GIMT_Encode4(62646), // Rule ID 4766 //
     /*  62576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  62579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vbrsr),
     /*  62584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  62605 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3601:{ *:[iPTR] }, MQPR:{ *:[v4f32] }:$Qn, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_VBRSR32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qn, rGPR:{ *:[i32] }:$Rm)
     /*  62605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR32),
     /*  62620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62622 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  62624 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  62626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62629 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62635 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62641 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62644 */     GIR_RootConstrainSelectedInstOperands,
     /*  62645 */     // GIR_Coverage, 4766,
     /*  62645 */     GIR_EraseRootFromParent_Done,
     /*  62646 */   // Label 1315: @62646
     /*  62646 */   GIM_Reject,
     /*  62647 */ // Label 960: @62647
     /*  62647 */ GIM_Try, /*On fail goto*//*Label 1316*/ GIMT_Encode4(73570),
     /*  62652 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /*  62655 */   GIM_Try, /*On fail goto*//*Label 1317*/ GIMT_Encode4(62745), // Rule ID 3916 //
     /*  62660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  62665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  62668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  62671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  62677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  62689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62693 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /*  62697 */     // MIs[1] Operand 1
     /*  62697 */     // No operand predicates
     /*  62697 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  62701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62703 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3678:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm, 0:{ *:[i32] })  =>  (MVE_VQSHLimms8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)
     /*  62703 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62706 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62710 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimms8),
     /*  62718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62720 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  62722 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  62725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62728 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62734 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62740 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62743 */     GIR_RootConstrainSelectedInstOperands,
     /*  62744 */     // GIR_Coverage, 3916,
     /*  62744 */     GIR_EraseRootFromParent_Done,
     /*  62745 */   // Label 1317: @62745
     /*  62745 */   GIM_Try, /*On fail goto*//*Label 1318*/ GIMT_Encode4(62835), // Rule ID 3918 //
     /*  62750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  62755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  62758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  62761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  62767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  62779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62783 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /*  62787 */     // MIs[1] Operand 1
     /*  62787 */     // No operand predicates
     /*  62787 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  62791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62793 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3678:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm, 1:{ *:[i32] })  =>  (MVE_VQSHLimmu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)
     /*  62793 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62796 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62800 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimmu8),
     /*  62808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62810 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  62812 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  62815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62818 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62824 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62830 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62833 */     GIR_RootConstrainSelectedInstOperands,
     /*  62834 */     // GIR_Coverage, 3918,
     /*  62834 */     GIR_EraseRootFromParent_Done,
     /*  62835 */   // Label 1318: @62835
     /*  62835 */   GIM_Try, /*On fail goto*//*Label 1319*/ GIMT_Encode4(62925), // Rule ID 3920 //
     /*  62840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  62845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  62848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  62851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  62857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  62869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62873 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  62877 */     // MIs[1] Operand 1
     /*  62877 */     // No operand predicates
     /*  62877 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  62881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62883 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3678:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm, 0:{ *:[i32] })  =>  (MVE_VQSHLimms16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)
     /*  62883 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62886 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62890 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimms16),
     /*  62898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62900 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  62902 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  62905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62908 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62914 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62920 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62923 */     GIR_RootConstrainSelectedInstOperands,
     /*  62924 */     // GIR_Coverage, 3920,
     /*  62924 */     GIR_EraseRootFromParent_Done,
     /*  62925 */   // Label 1319: @62925
     /*  62925 */   GIM_Try, /*On fail goto*//*Label 1320*/ GIMT_Encode4(63015), // Rule ID 3922 //
     /*  62930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  62935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  62938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  62941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  62947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  62959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62963 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  62967 */     // MIs[1] Operand 1
     /*  62967 */     // No operand predicates
     /*  62967 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  62971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62973 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3678:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm, 1:{ *:[i32] })  =>  (MVE_VQSHLimmu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)
     /*  62973 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62976 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62980 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimmu16),
     /*  62988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62990 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  62992 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  62995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62998 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63004 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63010 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63013 */     GIR_RootConstrainSelectedInstOperands,
     /*  63014 */     // GIR_Coverage, 3922,
     /*  63014 */     GIR_EraseRootFromParent_Done,
     /*  63015 */   // Label 1320: @63015
     /*  63015 */   GIM_Try, /*On fail goto*//*Label 1321*/ GIMT_Encode4(63105), // Rule ID 3924 //
     /*  63020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  63025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63053 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  63057 */     // MIs[1] Operand 1
     /*  63057 */     // No operand predicates
     /*  63057 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  63061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63063 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3678:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm, 0:{ *:[i32] })  =>  (MVE_VQSHLimms32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)
     /*  63063 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63066 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63070 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimms32),
     /*  63078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63080 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63082 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63088 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63094 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63100 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63103 */     GIR_RootConstrainSelectedInstOperands,
     /*  63104 */     // GIR_Coverage, 3924,
     /*  63104 */     GIR_EraseRootFromParent_Done,
     /*  63105 */   // Label 1321: @63105
     /*  63105 */   GIM_Try, /*On fail goto*//*Label 1322*/ GIMT_Encode4(63195), // Rule ID 3926 //
     /*  63110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  63115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63143 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  63147 */     // MIs[1] Operand 1
     /*  63147 */     // No operand predicates
     /*  63147 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  63151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63153 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3678:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm, 1:{ *:[i32] })  =>  (MVE_VQSHLimmu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)
     /*  63153 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63156 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63160 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimmu32),
     /*  63168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63170 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63172 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63178 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63184 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63190 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63193 */     GIR_RootConstrainSelectedInstOperands,
     /*  63194 */     // GIR_Coverage, 3926,
     /*  63194 */     GIR_EraseRootFromParent_Done,
     /*  63195 */   // Label 1322: @63195
     /*  63195 */   GIM_Try, /*On fail goto*//*Label 1323*/ GIMT_Encode4(63285), // Rule ID 3934 //
     /*  63200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  63205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  63208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  63211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63233 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  63237 */     // MIs[1] Operand 1
     /*  63237 */     // No operand predicates
     /*  63237 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  63241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63243 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3694:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] })  =>  (MVE_VRSHR_imms8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm)
     /*  63243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_imms8),
     /*  63258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63260 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63262 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63268 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63274 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63283 */     GIR_RootConstrainSelectedInstOperands,
     /*  63284 */     // GIR_Coverage, 3934,
     /*  63284 */     GIR_EraseRootFromParent_Done,
     /*  63285 */   // Label 1323: @63285
     /*  63285 */   GIM_Try, /*On fail goto*//*Label 1324*/ GIMT_Encode4(63375), // Rule ID 3936 //
     /*  63290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  63295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  63298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  63301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63323 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  63327 */     // MIs[1] Operand 1
     /*  63327 */     // No operand predicates
     /*  63327 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  63331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63333 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3694:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] })  =>  (MVE_VRSHR_immu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm)
     /*  63333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_immu8),
     /*  63348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63350 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63352 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63358 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63364 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63370 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63373 */     GIR_RootConstrainSelectedInstOperands,
     /*  63374 */     // GIR_Coverage, 3936,
     /*  63374 */     GIR_EraseRootFromParent_Done,
     /*  63375 */   // Label 1324: @63375
     /*  63375 */   GIM_Try, /*On fail goto*//*Label 1325*/ GIMT_Encode4(63465), // Rule ID 3938 //
     /*  63380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  63385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  63391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63413 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  63417 */     // MIs[1] Operand 1
     /*  63417 */     // No operand predicates
     /*  63417 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  63421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63423 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3694:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] })  =>  (MVE_VRSHR_imms16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm)
     /*  63423 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63426 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63430 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_imms16),
     /*  63438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63440 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63442 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63448 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63454 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63463 */     GIR_RootConstrainSelectedInstOperands,
     /*  63464 */     // GIR_Coverage, 3938,
     /*  63464 */     GIR_EraseRootFromParent_Done,
     /*  63465 */   // Label 1325: @63465
     /*  63465 */   GIM_Try, /*On fail goto*//*Label 1326*/ GIMT_Encode4(63555), // Rule ID 3940 //
     /*  63470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  63475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  63481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63503 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  63507 */     // MIs[1] Operand 1
     /*  63507 */     // No operand predicates
     /*  63507 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  63511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63513 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3694:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] })  =>  (MVE_VRSHR_immu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm)
     /*  63513 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63516 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63520 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_immu16),
     /*  63528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63530 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63532 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63538 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63544 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63550 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63553 */     GIR_RootConstrainSelectedInstOperands,
     /*  63554 */     // GIR_Coverage, 3940,
     /*  63554 */     GIR_EraseRootFromParent_Done,
     /*  63555 */   // Label 1326: @63555
     /*  63555 */   GIM_Try, /*On fail goto*//*Label 1327*/ GIMT_Encode4(63645), // Rule ID 3942 //
     /*  63560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  63565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63593 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm32),
     /*  63597 */     // MIs[1] Operand 1
     /*  63597 */     // No operand predicates
     /*  63597 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  63601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63603 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3694:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm, 0:{ *:[i32] })  =>  (MVE_VRSHR_imms32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm)
     /*  63603 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63606 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63610 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_imms32),
     /*  63618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63620 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63622 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63628 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63634 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63640 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63643 */     GIR_RootConstrainSelectedInstOperands,
     /*  63644 */     // GIR_Coverage, 3942,
     /*  63644 */     GIR_EraseRootFromParent_Done,
     /*  63645 */   // Label 1327: @63645
     /*  63645 */   GIM_Try, /*On fail goto*//*Label 1328*/ GIMT_Encode4(63735), // Rule ID 3944 //
     /*  63650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  63655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63683 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm32),
     /*  63687 */     // MIs[1] Operand 1
     /*  63687 */     // No operand predicates
     /*  63687 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  63691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63693 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3694:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm, 1:{ *:[i32] })  =>  (MVE_VRSHR_immu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm)
     /*  63693 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63696 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63700 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_immu32),
     /*  63708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63710 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63712 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63718 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63724 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63730 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63733 */     GIR_RootConstrainSelectedInstOperands,
     /*  63734 */     // GIR_Coverage, 3944,
     /*  63734 */     GIR_EraseRootFromParent_Done,
     /*  63735 */   // Label 1328: @63735
     /*  63735 */   GIM_Try, /*On fail goto*//*Label 1329*/ GIMT_Encode4(63824), // Rule ID 4042 //
     /*  63740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  63743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  63748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  63757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63764 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  63768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  63776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63780 */     // MIs[1] Operand 1
     /*  63780 */     // No operand predicates
     /*  63780 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63782 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3614:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTf16s16_fix:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  63782 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63785 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63789 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16s16_fix),
     /*  63797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63799 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  63801 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  63804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63807 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63813 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63819 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63822 */     GIR_RootConstrainSelectedInstOperands,
     /*  63823 */     // GIR_Coverage, 4042,
     /*  63823 */     GIR_EraseRootFromParent_Done,
     /*  63824 */   // Label 1329: @63824
     /*  63824 */   GIM_Try, /*On fail goto*//*Label 1330*/ GIMT_Encode4(63913), // Rule ID 4044 //
     /*  63829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  63832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  63837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  63846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63853 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  63857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  63865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63869 */     // MIs[1] Operand 1
     /*  63869 */     // No operand predicates
     /*  63869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63871 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3614:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTs16f16_fix:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  63871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16_fix),
     /*  63886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63888 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  63890 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  63893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63896 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63902 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63908 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63911 */     GIR_RootConstrainSelectedInstOperands,
     /*  63912 */     // GIR_Coverage, 4044,
     /*  63912 */     GIR_EraseRootFromParent_Done,
     /*  63913 */   // Label 1330: @63913
     /*  63913 */   GIM_Try, /*On fail goto*//*Label 1331*/ GIMT_Encode4(64002), // Rule ID 4046 //
     /*  63918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  63921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  63926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  63935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63942 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  63946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  63954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63958 */     // MIs[1] Operand 1
     /*  63958 */     // No operand predicates
     /*  63958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63960 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3614:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTf16u16_fix:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  63960 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63963 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63967 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16u16_fix),
     /*  63975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63977 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  63979 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  63982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63985 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63991 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63997 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64000 */     GIR_RootConstrainSelectedInstOperands,
     /*  64001 */     // GIR_Coverage, 4046,
     /*  64001 */     GIR_EraseRootFromParent_Done,
     /*  64002 */   // Label 1331: @64002
     /*  64002 */   GIM_Try, /*On fail goto*//*Label 1332*/ GIMT_Encode4(64091), // Rule ID 4048 //
     /*  64007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  64010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  64015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  64018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  64024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64031 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  64035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  64043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64047 */     // MIs[1] Operand 1
     /*  64047 */     // No operand predicates
     /*  64047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64049 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3614:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTu16f16_fix:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  64049 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  64052 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  64056 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16_fix),
     /*  64064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  64066 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  64068 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  64071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64074 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64080 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64086 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64089 */     GIR_RootConstrainSelectedInstOperands,
     /*  64090 */     // GIR_Coverage, 4048,
     /*  64090 */     GIR_EraseRootFromParent_Done,
     /*  64091 */   // Label 1332: @64091
     /*  64091 */   GIM_Try, /*On fail goto*//*Label 1333*/ GIMT_Encode4(64180), // Rule ID 4050 //
     /*  64096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  64099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  64104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  64107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64120 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  64124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  64132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64136 */     // MIs[1] Operand 1
     /*  64136 */     // No operand predicates
     /*  64136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64138 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3614:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTf32s32_fix:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  64138 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  64141 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  64145 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32s32_fix),
     /*  64153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  64155 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  64157 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  64160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64163 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64169 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64175 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64178 */     GIR_RootConstrainSelectedInstOperands,
     /*  64179 */     // GIR_Coverage, 4050,
     /*  64179 */     GIR_EraseRootFromParent_Done,
     /*  64180 */   // Label 1333: @64180
     /*  64180 */   GIM_Try, /*On fail goto*//*Label 1334*/ GIMT_Encode4(64269), // Rule ID 4052 //
     /*  64185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  64188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  64193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  64196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64209 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  64213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  64221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64225 */     // MIs[1] Operand 1
     /*  64225 */     // No operand predicates
     /*  64225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64227 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3614:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTs32f32_fix:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  64227 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  64230 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  64234 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32_fix),
     /*  64242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  64244 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  64246 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  64249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64252 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64258 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64264 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64267 */     GIR_RootConstrainSelectedInstOperands,
     /*  64268 */     // GIR_Coverage, 4052,
     /*  64268 */     GIR_EraseRootFromParent_Done,
     /*  64269 */   // Label 1334: @64269
     /*  64269 */   GIM_Try, /*On fail goto*//*Label 1335*/ GIMT_Encode4(64358), // Rule ID 4054 //
     /*  64274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  64277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  64282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  64285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64298 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  64302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  64310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64314 */     // MIs[1] Operand 1
     /*  64314 */     // No operand predicates
     /*  64314 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64316 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3614:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTf32u32_fix:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  64316 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  64319 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  64323 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32u32_fix),
     /*  64331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  64333 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  64335 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  64338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64341 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64347 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64353 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64356 */     GIR_RootConstrainSelectedInstOperands,
     /*  64357 */     // GIR_Coverage, 4054,
     /*  64357 */     GIR_EraseRootFromParent_Done,
     /*  64358 */   // Label 1335: @64358
     /*  64358 */   GIM_Try, /*On fail goto*//*Label 1336*/ GIMT_Encode4(64447), // Rule ID 4056 //
     /*  64363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  64366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  64371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  64374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64387 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  64391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  64399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64403 */     // MIs[1] Operand 1
     /*  64403 */     // No operand predicates
     /*  64403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64405 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3614:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTu32f32_fix:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  64405 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  64408 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  64412 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32_fix),
     /*  64420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  64422 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  64424 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  64427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64430 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64436 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64442 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64445 */     GIR_RootConstrainSelectedInstOperands,
     /*  64446 */     // GIR_Coverage, 4056,
     /*  64446 */     GIR_EraseRootFromParent_Done,
     /*  64447 */   // Label 1336: @64447
     /*  64447 */   GIM_Try, /*On fail goto*//*Label 1337*/ GIMT_Encode4(64514), // Rule ID 3121 //
     /*  64452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  64469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64484 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  64488 */     // (intrinsic_wo_chain:{ *:[i32] } 3561:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMINVs8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  64488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs8),
     /*  64491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64493 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64495 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64500 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64506 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64512 */     GIR_RootConstrainSelectedInstOperands,
     /*  64513 */     // GIR_Coverage, 3121,
     /*  64513 */     GIR_EraseRootFromParent_Done,
     /*  64514 */   // Label 1337: @64514
     /*  64514 */   GIM_Try, /*On fail goto*//*Label 1338*/ GIMT_Encode4(64581), // Rule ID 3123 //
     /*  64519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  64536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64551 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  64555 */     // (intrinsic_wo_chain:{ *:[i32] } 3561:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMINVs16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  64555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs16),
     /*  64558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64560 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64562 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64567 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64573 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64579 */     GIR_RootConstrainSelectedInstOperands,
     /*  64580 */     // GIR_Coverage, 3123,
     /*  64580 */     GIR_EraseRootFromParent_Done,
     /*  64581 */   // Label 1338: @64581
     /*  64581 */   GIM_Try, /*On fail goto*//*Label 1339*/ GIMT_Encode4(64648), // Rule ID 3125 //
     /*  64586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64618 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  64622 */     // (intrinsic_wo_chain:{ *:[i32] } 3561:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMINVs32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  64622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs32),
     /*  64625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64627 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64629 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64634 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64640 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64646 */     GIR_RootConstrainSelectedInstOperands,
     /*  64647 */     // GIR_Coverage, 3125,
     /*  64647 */     GIR_EraseRootFromParent_Done,
     /*  64648 */   // Label 1339: @64648
     /*  64648 */   GIM_Try, /*On fail goto*//*Label 1340*/ GIMT_Encode4(64715), // Rule ID 3127 //
     /*  64653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  64670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64685 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  64689 */     // (intrinsic_wo_chain:{ *:[i32] } 3561:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMINVu8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  64689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu8),
     /*  64692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64694 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64696 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64701 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64707 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64713 */     GIR_RootConstrainSelectedInstOperands,
     /*  64714 */     // GIR_Coverage, 3127,
     /*  64714 */     GIR_EraseRootFromParent_Done,
     /*  64715 */   // Label 1340: @64715
     /*  64715 */   GIM_Try, /*On fail goto*//*Label 1341*/ GIMT_Encode4(64782), // Rule ID 3129 //
     /*  64720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  64737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64752 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  64756 */     // (intrinsic_wo_chain:{ *:[i32] } 3561:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMINVu16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  64756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu16),
     /*  64759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64761 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64763 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64768 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64774 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64780 */     GIR_RootConstrainSelectedInstOperands,
     /*  64781 */     // GIR_Coverage, 3129,
     /*  64781 */     GIR_EraseRootFromParent_Done,
     /*  64782 */   // Label 1341: @64782
     /*  64782 */   GIM_Try, /*On fail goto*//*Label 1342*/ GIMT_Encode4(64849), // Rule ID 3131 //
     /*  64787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64819 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  64823 */     // (intrinsic_wo_chain:{ *:[i32] } 3561:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMINVu32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  64823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu32),
     /*  64826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64828 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64830 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64835 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64841 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64847 */     GIR_RootConstrainSelectedInstOperands,
     /*  64848 */     // GIR_Coverage, 3131,
     /*  64848 */     GIR_EraseRootFromParent_Done,
     /*  64849 */   // Label 1342: @64849
     /*  64849 */   GIM_Try, /*On fail goto*//*Label 1343*/ GIMT_Encode4(64916), // Rule ID 3133 //
     /*  64854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  64862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  64871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64886 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  64890 */     // (intrinsic_wo_chain:{ *:[i32] } 3552:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMAXVs8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  64890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs8),
     /*  64893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64895 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64897 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64902 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64908 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64914 */     GIR_RootConstrainSelectedInstOperands,
     /*  64915 */     // GIR_Coverage, 3133,
     /*  64915 */     GIR_EraseRootFromParent_Done,
     /*  64916 */   // Label 1343: @64916
     /*  64916 */   GIM_Try, /*On fail goto*//*Label 1344*/ GIMT_Encode4(64983), // Rule ID 3135 //
     /*  64921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  64929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  64938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64953 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  64957 */     // (intrinsic_wo_chain:{ *:[i32] } 3552:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMAXVs16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  64957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs16),
     /*  64960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64962 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64964 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64969 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64975 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64981 */     GIR_RootConstrainSelectedInstOperands,
     /*  64982 */     // GIR_Coverage, 3135,
     /*  64982 */     GIR_EraseRootFromParent_Done,
     /*  64983 */   // Label 1344: @64983
     /*  64983 */   GIM_Try, /*On fail goto*//*Label 1345*/ GIMT_Encode4(65050), // Rule ID 3137 //
     /*  64988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  64996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  65002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  65005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65020 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65024 */     // (intrinsic_wo_chain:{ *:[i32] } 3552:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMAXVs32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  65024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs32),
     /*  65027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  65029 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  65031 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  65033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65036 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65042 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65048 */     GIR_RootConstrainSelectedInstOperands,
     /*  65049 */     // GIR_Coverage, 3137,
     /*  65049 */     GIR_EraseRootFromParent_Done,
     /*  65050 */   // Label 1345: @65050
     /*  65050 */   GIM_Try, /*On fail goto*//*Label 1346*/ GIMT_Encode4(65117), // Rule ID 3139 //
     /*  65055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  65063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  65066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  65069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  65072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65087 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65091 */     // (intrinsic_wo_chain:{ *:[i32] } 3552:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMAXVu8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  65091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu8),
     /*  65094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  65096 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  65098 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  65100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65103 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65109 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65115 */     GIR_RootConstrainSelectedInstOperands,
     /*  65116 */     // GIR_Coverage, 3139,
     /*  65116 */     GIR_EraseRootFromParent_Done,
     /*  65117 */   // Label 1346: @65117
     /*  65117 */   GIM_Try, /*On fail goto*//*Label 1347*/ GIMT_Encode4(65184), // Rule ID 3141 //
     /*  65122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  65130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  65133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  65136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  65139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65154 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65158 */     // (intrinsic_wo_chain:{ *:[i32] } 3552:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMAXVu16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  65158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu16),
     /*  65161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  65163 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  65165 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  65167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65170 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65176 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65182 */     GIR_RootConstrainSelectedInstOperands,
     /*  65183 */     // GIR_Coverage, 3141,
     /*  65183 */     GIR_EraseRootFromParent_Done,
     /*  65184 */   // Label 1347: @65184
     /*  65184 */   GIM_Try, /*On fail goto*//*Label 1348*/ GIMT_Encode4(65251), // Rule ID 3143 //
     /*  65189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  65197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  65200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  65203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  65206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65221 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65225 */     // (intrinsic_wo_chain:{ *:[i32] } 3552:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMAXVu32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  65225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu32),
     /*  65228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  65230 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  65232 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  65234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65237 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65243 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65249 */     GIR_RootConstrainSelectedInstOperands,
     /*  65250 */     // GIR_Coverage, 3143,
     /*  65250 */     GIR_EraseRootFromParent_Done,
     /*  65251 */   // Label 1348: @65251
     /*  65251 */   GIM_Try, /*On fail goto*//*Label 1349*/ GIMT_Encode4(65333), // Rule ID 3548 //
     /*  65256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  65264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  65267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  65270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  65273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65288 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65292 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3598:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VABDs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  65292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDs8),
     /*  65307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65311 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65316 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65322 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65328 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65331 */     GIR_RootConstrainSelectedInstOperands,
     /*  65332 */     // GIR_Coverage, 3548,
     /*  65332 */     GIR_EraseRootFromParent_Done,
     /*  65333 */   // Label 1349: @65333
     /*  65333 */   GIM_Try, /*On fail goto*//*Label 1350*/ GIMT_Encode4(65415), // Rule ID 3555 //
     /*  65338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  65346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  65349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  65352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  65355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65370 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65374 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3598:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VABDs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  65374 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65377 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65381 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDs16),
     /*  65389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65393 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65398 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65404 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65410 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65413 */     GIR_RootConstrainSelectedInstOperands,
     /*  65414 */     // GIR_Coverage, 3555,
     /*  65414 */     GIR_EraseRootFromParent_Done,
     /*  65415 */   // Label 1350: @65415
     /*  65415 */   GIM_Try, /*On fail goto*//*Label 1351*/ GIMT_Encode4(65497), // Rule ID 3559 //
     /*  65420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  65428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  65431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  65437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65452 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65456 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3598:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VABDs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  65456 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65459 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65463 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDs32),
     /*  65471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65475 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65480 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65486 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65492 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65495 */     GIR_RootConstrainSelectedInstOperands,
     /*  65496 */     // GIR_Coverage, 3559,
     /*  65496 */     GIR_EraseRootFromParent_Done,
     /*  65497 */   // Label 1351: @65497
     /*  65497 */   GIM_Try, /*On fail goto*//*Label 1352*/ GIMT_Encode4(65579), // Rule ID 3563 //
     /*  65502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  65510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  65513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  65516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  65519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65534 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65538 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3598:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VABDu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  65538 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65541 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65545 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDu8),
     /*  65553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65557 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65562 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65568 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65574 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65577 */     GIR_RootConstrainSelectedInstOperands,
     /*  65578 */     // GIR_Coverage, 3563,
     /*  65578 */     GIR_EraseRootFromParent_Done,
     /*  65579 */   // Label 1352: @65579
     /*  65579 */   GIM_Try, /*On fail goto*//*Label 1353*/ GIMT_Encode4(65661), // Rule ID 3567 //
     /*  65584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  65592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  65595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  65598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  65601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65616 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65620 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3598:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VABDu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  65620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDu16),
     /*  65635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65639 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65644 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65650 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65656 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65659 */     GIR_RootConstrainSelectedInstOperands,
     /*  65660 */     // GIR_Coverage, 3567,
     /*  65660 */     GIR_EraseRootFromParent_Done,
     /*  65661 */   // Label 1353: @65661
     /*  65661 */   GIM_Try, /*On fail goto*//*Label 1354*/ GIMT_Encode4(65743), // Rule ID 3571 //
     /*  65666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  65674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  65677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  65683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65698 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65702 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3598:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VABDu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  65702 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65705 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65709 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDu32),
     /*  65717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65721 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65726 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65732 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65738 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65741 */     GIR_RootConstrainSelectedInstOperands,
     /*  65742 */     // GIR_Coverage, 3571,
     /*  65742 */     GIR_EraseRootFromParent_Done,
     /*  65743 */   // Label 1354: @65743
     /*  65743 */   GIM_Try, /*On fail goto*//*Label 1355*/ GIMT_Encode4(65825), // Rule ID 3572 //
     /*  65748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  65756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  65759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  65762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  65765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65780 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65784 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3684:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRHADDs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  65784 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65787 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65791 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDs8),
     /*  65799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65803 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65808 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65814 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65820 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65823 */     GIR_RootConstrainSelectedInstOperands,
     /*  65824 */     // GIR_Coverage, 3572,
     /*  65824 */     GIR_EraseRootFromParent_Done,
     /*  65825 */   // Label 1355: @65825
     /*  65825 */   GIM_Try, /*On fail goto*//*Label 1356*/ GIMT_Encode4(65907), // Rule ID 3579 //
     /*  65830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  65838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  65841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  65844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  65847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65862 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65866 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3684:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRHADDs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  65866 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65869 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65873 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDs16),
     /*  65881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65885 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65890 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65896 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65902 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65905 */     GIR_RootConstrainSelectedInstOperands,
     /*  65906 */     // GIR_Coverage, 3579,
     /*  65906 */     GIR_EraseRootFromParent_Done,
     /*  65907 */   // Label 1356: @65907
     /*  65907 */   GIM_Try, /*On fail goto*//*Label 1357*/ GIMT_Encode4(65989), // Rule ID 3583 //
     /*  65912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  65920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  65923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  65929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65944 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65948 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3684:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRHADDs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  65948 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65951 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65955 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDs32),
     /*  65963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65967 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65972 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65978 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65984 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65987 */     GIR_RootConstrainSelectedInstOperands,
     /*  65988 */     // GIR_Coverage, 3583,
     /*  65988 */     GIR_EraseRootFromParent_Done,
     /*  65989 */   // Label 1357: @65989
     /*  65989 */   GIM_Try, /*On fail goto*//*Label 1358*/ GIMT_Encode4(66071), // Rule ID 3587 //
     /*  65994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  66002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  66005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  66008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  66011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66026 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66030 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3684:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRHADDu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  66030 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66033 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66037 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDu8),
     /*  66045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66049 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66054 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66060 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66066 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66069 */     GIR_RootConstrainSelectedInstOperands,
     /*  66070 */     // GIR_Coverage, 3587,
     /*  66070 */     GIR_EraseRootFromParent_Done,
     /*  66071 */   // Label 1358: @66071
     /*  66071 */   GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(66153), // Rule ID 3591 //
     /*  66076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  66084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  66087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  66090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  66093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66108 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66112 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3684:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRHADDu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  66112 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66115 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66119 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDu16),
     /*  66127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66136 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66142 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66148 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66151 */     GIR_RootConstrainSelectedInstOperands,
     /*  66152 */     // GIR_Coverage, 3591,
     /*  66152 */     GIR_EraseRootFromParent_Done,
     /*  66153 */   // Label 1359: @66153
     /*  66153 */   GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(66235), // Rule ID 3595 //
     /*  66158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  66166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66190 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66194 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3684:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRHADDu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  66194 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66197 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66201 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDu32),
     /*  66209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66213 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66218 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66224 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66230 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66233 */     GIR_RootConstrainSelectedInstOperands,
     /*  66234 */     // GIR_Coverage, 3595,
     /*  66234 */     GIR_EraseRootFromParent_Done,
     /*  66235 */   // Label 1360: @66235
     /*  66235 */   GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(66317), // Rule ID 3596 //
     /*  66240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  66248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  66251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  66254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  66257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66272 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66276 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3633:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHADDs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  66276 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66279 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66283 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDs8),
     /*  66291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66295 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66300 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66306 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66312 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66315 */     GIR_RootConstrainSelectedInstOperands,
     /*  66316 */     // GIR_Coverage, 3596,
     /*  66316 */     GIR_EraseRootFromParent_Done,
     /*  66317 */   // Label 1361: @66317
     /*  66317 */   GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(66399), // Rule ID 3603 //
     /*  66322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  66330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  66333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  66336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  66339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66354 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66358 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3633:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHADDs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  66358 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66361 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66365 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDs16),
     /*  66373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66375 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66377 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66382 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66388 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66394 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66397 */     GIR_RootConstrainSelectedInstOperands,
     /*  66398 */     // GIR_Coverage, 3603,
     /*  66398 */     GIR_EraseRootFromParent_Done,
     /*  66399 */   // Label 1362: @66399
     /*  66399 */   GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(66481), // Rule ID 3607 //
     /*  66404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  66412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66436 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66440 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3633:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHADDs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  66440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDs32),
     /*  66455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66464 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66470 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66476 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66479 */     GIR_RootConstrainSelectedInstOperands,
     /*  66480 */     // GIR_Coverage, 3607,
     /*  66480 */     GIR_EraseRootFromParent_Done,
     /*  66481 */   // Label 1363: @66481
     /*  66481 */   GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(66563), // Rule ID 3611 //
     /*  66486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  66494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  66497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  66500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  66503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66518 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66522 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3633:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHADDu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  66522 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66525 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66529 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDu8),
     /*  66537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66541 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66546 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66552 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66558 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66561 */     GIR_RootConstrainSelectedInstOperands,
     /*  66562 */     // GIR_Coverage, 3611,
     /*  66562 */     GIR_EraseRootFromParent_Done,
     /*  66563 */   // Label 1364: @66563
     /*  66563 */   GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(66645), // Rule ID 3615 //
     /*  66568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  66576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  66579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  66582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  66585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66600 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66604 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3633:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHADDu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  66604 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66607 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66611 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDu16),
     /*  66619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66623 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66628 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66634 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66640 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66643 */     GIR_RootConstrainSelectedInstOperands,
     /*  66644 */     // GIR_Coverage, 3615,
     /*  66644 */     GIR_EraseRootFromParent_Done,
     /*  66645 */   // Label 1365: @66645
     /*  66645 */   GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(66727), // Rule ID 3619 //
     /*  66650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  66658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66682 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66686 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3633:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHADDu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  66686 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66689 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66693 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDu32),
     /*  66701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66710 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66716 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66722 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66725 */     GIR_RootConstrainSelectedInstOperands,
     /*  66726 */     // GIR_Coverage, 3619,
     /*  66726 */     GIR_EraseRootFromParent_Done,
     /*  66727 */   // Label 1366: @66727
     /*  66727 */   GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(66809), // Rule ID 3620 //
     /*  66732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  66740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  66743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  66746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  66749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66764 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66768 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3634:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHSUBs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  66768 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66771 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66775 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBs8),
     /*  66783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66787 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66792 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66798 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66804 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66807 */     GIR_RootConstrainSelectedInstOperands,
     /*  66808 */     // GIR_Coverage, 3620,
     /*  66808 */     GIR_EraseRootFromParent_Done,
     /*  66809 */   // Label 1367: @66809
     /*  66809 */   GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(66891), // Rule ID 3623 //
     /*  66814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  66822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  66825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  66828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  66831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66846 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66850 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3634:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHSUBs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  66850 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66853 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66857 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBs16),
     /*  66865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66867 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66869 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66874 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66880 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66886 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66889 */     GIR_RootConstrainSelectedInstOperands,
     /*  66890 */     // GIR_Coverage, 3623,
     /*  66890 */     GIR_EraseRootFromParent_Done,
     /*  66891 */   // Label 1368: @66891
     /*  66891 */   GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(66973), // Rule ID 3626 //
     /*  66896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  66904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66928 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66932 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3634:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHSUBs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  66932 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66935 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66939 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBs32),
     /*  66947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66951 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66956 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66962 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66968 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66971 */     GIR_RootConstrainSelectedInstOperands,
     /*  66972 */     // GIR_Coverage, 3626,
     /*  66972 */     GIR_EraseRootFromParent_Done,
     /*  66973 */   // Label 1369: @66973
     /*  66973 */   GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(67055), // Rule ID 3629 //
     /*  66978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  66986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  66989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  66992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  66995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67010 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  67014 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3634:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHSUBu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  67014 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67017 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67021 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBu8),
     /*  67029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67033 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67038 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67044 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67050 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67053 */     GIR_RootConstrainSelectedInstOperands,
     /*  67054 */     // GIR_Coverage, 3629,
     /*  67054 */     GIR_EraseRootFromParent_Done,
     /*  67055 */   // Label 1370: @67055
     /*  67055 */   GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(67137), // Rule ID 3632 //
     /*  67060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  67068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  67071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  67077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67092 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  67096 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3634:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHSUBu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  67096 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67099 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67103 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBu16),
     /*  67111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67115 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67120 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67126 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67132 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67135 */     GIR_RootConstrainSelectedInstOperands,
     /*  67136 */     // GIR_Coverage, 3632,
     /*  67136 */     GIR_EraseRootFromParent_Done,
     /*  67137 */   // Label 1371: @67137
     /*  67137 */   GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(67219), // Rule ID 3635 //
     /*  67142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  67150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  67159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67174 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  67178 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3634:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHSUBu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  67178 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67181 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67185 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBu32),
     /*  67193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67195 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67197 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67202 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67208 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67214 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67217 */     GIR_RootConstrainSelectedInstOperands,
     /*  67218 */     // GIR_Coverage, 3635,
     /*  67218 */     GIR_EraseRootFromParent_Done,
     /*  67219 */   // Label 1372: @67219
     /*  67219 */   GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(67301), // Rule ID 4036 //
     /*  67224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  67227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  67232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  67241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67256 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67260 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3598:{ *:[iPTR] }, MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VABDf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /*  67260 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67263 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67267 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDf32),
     /*  67275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67279 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67284 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67290 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67296 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67299 */     GIR_RootConstrainSelectedInstOperands,
     /*  67300 */     // GIR_Coverage, 4036,
     /*  67300 */     GIR_EraseRootFromParent_Done,
     /*  67301 */   // Label 1373: @67301
     /*  67301 */   GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(67383), // Rule ID 4038 //
     /*  67306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  67309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  67314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  67317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  67323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67338 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67342 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3598:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VABDf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /*  67342 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67345 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67349 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDf16),
     /*  67357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67361 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67366 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67372 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67378 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67381 */     GIR_RootConstrainSelectedInstOperands,
     /*  67382 */     // GIR_Coverage, 4038,
     /*  67382 */     GIR_EraseRootFromParent_Done,
     /*  67383 */   // Label 1374: @67383
     /*  67383 */   GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(67465), // Rule ID 4411 //
     /*  67388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull_poly),
     /*  67396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  67399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  67402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  67405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67420 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67424 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3661:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VMULLBp8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  67424 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67427 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67431 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBp8),
     /*  67439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67443 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67448 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67454 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67463 */     GIR_RootConstrainSelectedInstOperands,
     /*  67464 */     // GIR_Coverage, 4411,
     /*  67464 */     GIR_EraseRootFromParent_Done,
     /*  67465 */   // Label 1375: @67465
     /*  67465 */   GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(67547), // Rule ID 4413 //
     /*  67470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull_poly),
     /*  67478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  67481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  67484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  67487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67502 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  67506 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3661:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VMULLTp8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  67506 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67509 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67513 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTp8),
     /*  67521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67523 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67525 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67530 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67536 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67542 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67545 */     GIR_RootConstrainSelectedInstOperands,
     /*  67546 */     // GIR_Coverage, 4413,
     /*  67546 */     GIR_EraseRootFromParent_Done,
     /*  67547 */   // Label 1376: @67547
     /*  67547 */   GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(67629), // Rule ID 4415 //
     /*  67552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull_poly),
     /*  67560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  67569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67584 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67588 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3661:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VMULLBp16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  67588 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67591 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67595 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBp16),
     /*  67603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67607 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67612 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67618 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67627 */     GIR_RootConstrainSelectedInstOperands,
     /*  67628 */     // GIR_Coverage, 4415,
     /*  67628 */     GIR_EraseRootFromParent_Done,
     /*  67629 */   // Label 1377: @67629
     /*  67629 */   GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(67711), // Rule ID 4417 //
     /*  67634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull_poly),
     /*  67642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  67651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67666 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  67670 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3661:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VMULLTp16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  67670 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67673 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67677 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTp16),
     /*  67685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67689 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67694 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67700 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67706 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67709 */     GIR_RootConstrainSelectedInstOperands,
     /*  67710 */     // GIR_Coverage, 4417,
     /*  67710 */     GIR_EraseRootFromParent_Done,
     /*  67711 */   // Label 1378: @67711
     /*  67711 */   GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(67793), // Rule ID 4444 //
     /*  67716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  67724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  67727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  67730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  67733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67748 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67752 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3659:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VMULHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  67752 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67755 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67759 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs8),
     /*  67767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67771 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67776 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67782 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67788 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67791 */     GIR_RootConstrainSelectedInstOperands,
     /*  67792 */     // GIR_Coverage, 4444,
     /*  67792 */     GIR_EraseRootFromParent_Done,
     /*  67793 */   // Label 1379: @67793
     /*  67793 */   GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(67875), // Rule ID 4451 //
     /*  67798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  67806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  67809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  67815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67830 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67834 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3659:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VMULHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  67834 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67837 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67841 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs16),
     /*  67849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67853 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67858 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67864 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67870 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67873 */     GIR_RootConstrainSelectedInstOperands,
     /*  67874 */     // GIR_Coverage, 4451,
     /*  67874 */     GIR_EraseRootFromParent_Done,
     /*  67875 */   // Label 1380: @67875
     /*  67875 */   GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(67957), // Rule ID 4455 //
     /*  67880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  67888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  67897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67912 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67916 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3659:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VMULHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  67916 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67919 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67923 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs32),
     /*  67931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67935 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67940 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67946 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67952 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67955 */     GIR_RootConstrainSelectedInstOperands,
     /*  67956 */     // GIR_Coverage, 4455,
     /*  67956 */     GIR_EraseRootFromParent_Done,
     /*  67957 */   // Label 1381: @67957
     /*  67957 */   GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(68039), // Rule ID 4459 //
     /*  67962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  67970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  67973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  67976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  67979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67994 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  67998 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3659:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VMULHu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  67998 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68001 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68005 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu8),
     /*  68013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68017 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68022 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68028 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68034 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68037 */     GIR_RootConstrainSelectedInstOperands,
     /*  68038 */     // GIR_Coverage, 4459,
     /*  68038 */     GIR_EraseRootFromParent_Done,
     /*  68039 */   // Label 1382: @68039
     /*  68039 */   GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(68121), // Rule ID 4463 //
     /*  68044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  68052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68076 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68080 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3659:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VMULHu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  68080 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68083 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68087 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu16),
     /*  68095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68099 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68104 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68110 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68116 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68119 */     GIR_RootConstrainSelectedInstOperands,
     /*  68120 */     // GIR_Coverage, 4463,
     /*  68120 */     GIR_EraseRootFromParent_Done,
     /*  68121 */   // Label 1383: @68121
     /*  68121 */   GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(68203), // Rule ID 4467 //
     /*  68126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  68134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68158 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68162 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3659:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VMULHu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  68162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68165 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68169 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu32),
     /*  68177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68181 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68186 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68192 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68198 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68201 */     GIR_RootConstrainSelectedInstOperands,
     /*  68202 */     // GIR_Coverage, 4467,
     /*  68202 */     GIR_EraseRootFromParent_Done,
     /*  68203 */   // Label 1384: @68203
     /*  68203 */   GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(68285), // Rule ID 4468 //
     /*  68208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  68216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  68219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  68225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68240 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  68244 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3693:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRMULHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  68244 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68247 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68251 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHs8),
     /*  68259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68263 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68268 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68274 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68283 */     GIR_RootConstrainSelectedInstOperands,
     /*  68284 */     // GIR_Coverage, 4468,
     /*  68284 */     GIR_EraseRootFromParent_Done,
     /*  68285 */   // Label 1385: @68285
     /*  68285 */   GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(68367), // Rule ID 4470 //
     /*  68290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  68298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68322 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  68326 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3693:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRMULHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  68326 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68329 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68333 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHs16),
     /*  68341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68345 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68350 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68356 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68362 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68365 */     GIR_RootConstrainSelectedInstOperands,
     /*  68366 */     // GIR_Coverage, 4470,
     /*  68366 */     GIR_EraseRootFromParent_Done,
     /*  68367 */   // Label 1386: @68367
     /*  68367 */   GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(68449), // Rule ID 4472 //
     /*  68372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  68380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68404 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  68408 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3693:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRMULHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  68408 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68411 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68415 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHs32),
     /*  68423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68427 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68432 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68438 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68444 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68447 */     GIR_RootConstrainSelectedInstOperands,
     /*  68448 */     // GIR_Coverage, 4472,
     /*  68448 */     GIR_EraseRootFromParent_Done,
     /*  68449 */   // Label 1387: @68449
     /*  68449 */   GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(68531), // Rule ID 4474 //
     /*  68454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  68462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  68465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  68471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68486 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68490 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3693:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRMULHu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  68490 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68493 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68497 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHu8),
     /*  68505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68514 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68520 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68526 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68529 */     GIR_RootConstrainSelectedInstOperands,
     /*  68530 */     // GIR_Coverage, 4474,
     /*  68530 */     GIR_EraseRootFromParent_Done,
     /*  68531 */   // Label 1388: @68531
     /*  68531 */   GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(68613), // Rule ID 4476 //
     /*  68536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  68544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68568 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68572 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3693:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRMULHu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  68572 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68575 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68579 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHu16),
     /*  68587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68591 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68596 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68602 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68608 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68611 */     GIR_RootConstrainSelectedInstOperands,
     /*  68612 */     // GIR_Coverage, 4476,
     /*  68612 */     GIR_EraseRootFromParent_Done,
     /*  68613 */   // Label 1389: @68613
     /*  68613 */   GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(68695), // Rule ID 4478 //
     /*  68618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  68626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68650 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68654 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3693:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRMULHu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  68654 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68657 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68661 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHu32),
     /*  68669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68673 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68678 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68684 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68690 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68693 */     GIR_RootConstrainSelectedInstOperands,
     /*  68694 */     // GIR_Coverage, 4478,
     /*  68694 */     GIR_EraseRootFromParent_Done,
     /*  68695 */   // Label 1390: @68695
     /*  68695 */   GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(68762), // Rule ID 4529 //
     /*  68700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  68703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_narrow),
     /*  68708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68732 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  68736 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3617:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qm, 0:{ *:[i32] })  =>  (MVE_VCVTf16f32bh:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qm)
     /*  68736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16f32bh),
     /*  68739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  68743 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  68745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68748 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68754 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68760 */     GIR_RootConstrainSelectedInstOperands,
     /*  68761 */     // GIR_Coverage, 4529,
     /*  68761 */     GIR_EraseRootFromParent_Done,
     /*  68762 */   // Label 1391: @68762
     /*  68762 */   GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(68829), // Rule ID 4535 //
     /*  68767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  68770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_narrow),
     /*  68775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68799 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68803 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3617:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qm, 1:{ *:[i32] })  =>  (MVE_VCVTf16f32th:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qm)
     /*  68803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16f32th),
     /*  68806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  68810 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  68812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68815 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68821 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68827 */     GIR_RootConstrainSelectedInstOperands,
     /*  68828 */     // GIR_Coverage, 4535,
     /*  68828 */     GIR_EraseRootFromParent_Done,
     /*  68829 */   // Label 1392: @68829
     /*  68829 */   GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(68911), // Rule ID 4553 //
     /*  68834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmull),
     /*  68842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68866 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  68870 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3669:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VQDMULLs16bh:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  68870 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68873 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68877 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULLs16bh),
     /*  68885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68889 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68894 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68900 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68909 */     GIR_RootConstrainSelectedInstOperands,
     /*  68910 */     // GIR_Coverage, 4553,
     /*  68910 */     GIR_EraseRootFromParent_Done,
     /*  68911 */   // Label 1393: @68911
     /*  68911 */   GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(68993), // Rule ID 4555 //
     /*  68916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmull),
     /*  68924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68948 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68952 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3669:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VQDMULLs16th:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  68952 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68955 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68959 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULLs16th),
     /*  68967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68976 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68982 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68988 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68991 */     GIR_RootConstrainSelectedInstOperands,
     /*  68992 */     // GIR_Coverage, 4555,
     /*  68992 */     GIR_EraseRootFromParent_Done,
     /*  68993 */   // Label 1394: @68993
     /*  68993 */   GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(69075), // Rule ID 4557 //
     /*  68998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  69001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmull),
     /*  69006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  69009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69030 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  69034 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3669:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VQDMULLs32bh:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  69034 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  69037 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  69041 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULLs32bh),
     /*  69049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69051 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  69053 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  69055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69058 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69064 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69070 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  69073 */     GIR_RootConstrainSelectedInstOperands,
     /*  69074 */     // GIR_Coverage, 4557,
     /*  69074 */     GIR_EraseRootFromParent_Done,
     /*  69075 */   // Label 1395: @69075
     /*  69075 */   GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(69157), // Rule ID 4559 //
     /*  69080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  69083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmull),
     /*  69088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  69091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69112 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  69116 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3669:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VQDMULLs32th:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  69116 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  69119 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  69123 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULLs32th),
     /*  69131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  69135 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  69137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69140 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69146 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69152 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  69155 */     GIR_RootConstrainSelectedInstOperands,
     /*  69156 */     // GIR_Coverage, 4559,
     /*  69156 */     GIR_EraseRootFromParent_Done,
     /*  69157 */   // Label 1396: @69157
     /*  69157 */   GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(69234), // Rule ID 3904 //
     /*  69162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsli),
     /*  69167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  69170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  69195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69199 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /*  69203 */     // MIs[1] Operand 1
     /*  69203 */     // No operand predicates
     /*  69203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69205 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3708:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)  =>  (MVE_VSLIimm8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)
     /*  69205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSLIimm8),
     /*  69208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69210 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  69212 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  69214 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  69217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69220 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69226 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69232 */     GIR_RootConstrainSelectedInstOperands,
     /*  69233 */     // GIR_Coverage, 3904,
     /*  69233 */     GIR_EraseRootFromParent_Done,
     /*  69234 */   // Label 1397: @69234
     /*  69234 */   GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(69311), // Rule ID 3906 //
     /*  69239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsli),
     /*  69244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  69272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69276 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  69280 */     // MIs[1] Operand 1
     /*  69280 */     // No operand predicates
     /*  69280 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69282 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3708:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)  =>  (MVE_VSLIimm16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)
     /*  69282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSLIimm16),
     /*  69285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69287 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  69289 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  69291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  69294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69297 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69303 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69309 */     GIR_RootConstrainSelectedInstOperands,
     /*  69310 */     // GIR_Coverage, 3906,
     /*  69310 */     GIR_EraseRootFromParent_Done,
     /*  69311 */   // Label 1398: @69311
     /*  69311 */   GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(69388), // Rule ID 3908 //
     /*  69316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsli),
     /*  69321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  69349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69353 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  69357 */     // MIs[1] Operand 1
     /*  69357 */     // No operand predicates
     /*  69357 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69359 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3708:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)  =>  (MVE_VSLIimm32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)
     /*  69359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSLIimm32),
     /*  69362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69364 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  69366 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  69368 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  69371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69374 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69380 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69386 */     GIR_RootConstrainSelectedInstOperands,
     /*  69387 */     // GIR_Coverage, 3908,
     /*  69387 */     GIR_EraseRootFromParent_Done,
     /*  69388 */   // Label 1399: @69388
     /*  69388 */   GIM_Try, /*On fail goto*//*Label 1400*/ GIMT_Encode4(69465), // Rule ID 3910 //
     /*  69393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsri),
     /*  69398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  69401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  69426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69430 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  69434 */     // MIs[1] Operand 1
     /*  69434 */     // No operand predicates
     /*  69434 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69436 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3710:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm)  =>  (MVE_VSRIimm8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm)
     /*  69436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSRIimm8),
     /*  69439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69441 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  69443 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  69445 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  69448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69451 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69457 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69463 */     GIR_RootConstrainSelectedInstOperands,
     /*  69464 */     // GIR_Coverage, 3910,
     /*  69464 */     GIR_EraseRootFromParent_Done,
     /*  69465 */   // Label 1400: @69465
     /*  69465 */   GIM_Try, /*On fail goto*//*Label 1401*/ GIMT_Encode4(69542), // Rule ID 3912 //
     /*  69470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsri),
     /*  69475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  69503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69507 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  69511 */     // MIs[1] Operand 1
     /*  69511 */     // No operand predicates
     /*  69511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69513 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3710:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm)  =>  (MVE_VSRIimm16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm)
     /*  69513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSRIimm16),
     /*  69516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69518 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  69520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  69522 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  69525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69528 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69534 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69540 */     GIR_RootConstrainSelectedInstOperands,
     /*  69541 */     // GIR_Coverage, 3912,
     /*  69541 */     GIR_EraseRootFromParent_Done,
     /*  69542 */   // Label 1401: @69542
     /*  69542 */   GIM_Try, /*On fail goto*//*Label 1402*/ GIMT_Encode4(69619), // Rule ID 3914 //
     /*  69547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsri),
     /*  69552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  69580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69584 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm32),
     /*  69588 */     // MIs[1] Operand 1
     /*  69588 */     // No operand predicates
     /*  69588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69590 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3710:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm)  =>  (MVE_VSRIimm32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm)
     /*  69590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSRIimm32),
     /*  69593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69595 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  69597 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  69599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  69602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69605 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69611 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69617 */     GIR_RootConstrainSelectedInstOperands,
     /*  69618 */     // GIR_Coverage, 3914,
     /*  69618 */     GIR_EraseRootFromParent_Done,
     /*  69619 */   // Label 1402: @69619
     /*  69619 */   GIM_Try, /*On fail goto*//*Label 1403*/ GIMT_Encode4(69710), // Rule ID 4383 //
     /*  69624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  69627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcmulq),
     /*  69632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  69644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69656 */     // MIs[1] Operand 1
     /*  69656 */     // No operand predicates
     /*  69656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69666 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3608:{ *:[iPTR] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm)  =>  (MVE_VCMULf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  69666 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  69669 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  69673 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMULf16),
     /*  69681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69683 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  69685 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qm
     /*  69687 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  69690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69693 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69699 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69705 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  69708 */     GIR_RootConstrainSelectedInstOperands,
     /*  69709 */     // GIR_Coverage, 4383,
     /*  69709 */     GIR_EraseRootFromParent_Done,
     /*  69710 */   // Label 1403: @69710
     /*  69710 */   GIM_Try, /*On fail goto*//*Label 1404*/ GIMT_Encode4(69801), // Rule ID 4385 //
     /*  69715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  69718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcmulq),
     /*  69723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  69735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69747 */     // MIs[1] Operand 1
     /*  69747 */     // No operand predicates
     /*  69747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69757 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3608:{ *:[iPTR] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm)  =>  (MVE_VCMULf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  69757 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  69760 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  69764 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMULf32),
     /*  69772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69774 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  69776 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qm
     /*  69778 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  69781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69784 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69790 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69796 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  69799 */     GIR_RootConstrainSelectedInstOperands,
     /*  69800 */     // GIR_Coverage, 4385,
     /*  69800 */     GIR_EraseRootFromParent_Done,
     /*  69801 */   // Label 1404: @69801
     /*  69801 */   GIM_Try, /*On fail goto*//*Label 1405*/ GIMT_Encode4(69864), // Rule ID 146 //
     /*  69806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  69809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usada8),
     /*  69814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  69817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  69823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  69830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  69834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  69838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  69842 */     // (intrinsic_wo_chain:{ *:[i32] } 3938:{ *:[iPTR] }, GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)  =>  (USADA8:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*  69842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USADA8),
     /*  69845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  69849 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  69851 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  69853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  69856 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69862 */     GIR_RootConstrainSelectedInstOperands,
     /*  69863 */     // GIR_Coverage, 146,
     /*  69863 */     GIR_EraseRootFromParent_Done,
     /*  69864 */   // Label 1405: @69864
     /*  69864 */   GIM_Try, /*On fail goto*//*Label 1406*/ GIMT_Encode4(69927), // Rule ID 469 //
     /*  69869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  69872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usada8),
     /*  69877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  69880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  69886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69905 */     // (intrinsic_wo_chain:{ *:[i32] } 3938:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)  =>  (t2USADA8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  69905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USADA8),
     /*  69908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69910 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  69912 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  69914 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  69916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  69919 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69925 */     GIR_RootConstrainSelectedInstOperands,
     /*  69926 */     // GIR_Coverage, 469,
     /*  69926 */     GIR_EraseRootFromParent_Done,
     /*  69927 */   // Label 1406: @69927
     /*  69927 */   GIM_Try, /*On fail goto*//*Label 1407*/ GIMT_Encode4(69990), // Rule ID 528 //
     /*  69932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  69935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlad),
     /*  69940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  69943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  69949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69968 */     // (intrinsic_wo_chain:{ *:[i32] } 3883:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLAD:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  69968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLAD),
     /*  69971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  69975 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  69977 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  69979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  69982 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69988 */     GIR_RootConstrainSelectedInstOperands,
     /*  69989 */     // GIR_Coverage, 528,
     /*  69989 */     GIR_EraseRootFromParent_Done,
     /*  69990 */   // Label 1407: @69990
     /*  69990 */   GIM_Try, /*On fail goto*//*Label 1408*/ GIMT_Encode4(70053), // Rule ID 529 //
     /*  69995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  69998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smladx),
     /*  70003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  70006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  70009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  70012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  70015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70031 */     // (intrinsic_wo_chain:{ *:[i32] } 3884:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLADX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  70031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLADX),
     /*  70034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70038 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  70040 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  70042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70045 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70051 */     GIR_RootConstrainSelectedInstOperands,
     /*  70052 */     // GIR_Coverage, 529,
     /*  70052 */     GIR_EraseRootFromParent_Done,
     /*  70053 */   // Label 1408: @70053
     /*  70053 */   GIM_Try, /*On fail goto*//*Label 1409*/ GIMT_Encode4(70116), // Rule ID 530 //
     /*  70058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  70061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlsd),
     /*  70066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  70069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  70072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  70075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  70078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70094 */     // (intrinsic_wo_chain:{ *:[i32] } 3891:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLSD:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  70094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLSD),
     /*  70097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70101 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  70103 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  70105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70108 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70114 */     GIR_RootConstrainSelectedInstOperands,
     /*  70115 */     // GIR_Coverage, 530,
     /*  70115 */     GIR_EraseRootFromParent_Done,
     /*  70116 */   // Label 1409: @70116
     /*  70116 */   GIM_Try, /*On fail goto*//*Label 1410*/ GIMT_Encode4(70179), // Rule ID 531 //
     /*  70121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  70124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlsdx),
     /*  70129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  70132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  70135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  70138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  70141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70157 */     // (intrinsic_wo_chain:{ *:[i32] } 3892:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLSDX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  70157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLSDX),
     /*  70160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70162 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70164 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  70166 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  70168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70171 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70177 */     GIR_RootConstrainSelectedInstOperands,
     /*  70178 */     // GIR_Coverage, 531,
     /*  70178 */     GIR_EraseRootFromParent_Done,
     /*  70179 */   // Label 1410: @70179
     /*  70179 */   GIM_Try, /*On fail goto*//*Label 1411*/ GIMT_Encode4(70233), // Rule ID 951 //
     /*  70184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /*  70187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_udot),
     /*  70192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  70195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  70198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  70201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  70204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70220 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3740:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VUDOTD:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  70220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUDOTD),
     /*  70223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70227 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70229 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70231 */     GIR_RootConstrainSelectedInstOperands,
     /*  70232 */     // GIR_Coverage, 951,
     /*  70232 */     GIR_EraseRootFromParent_Done,
     /*  70233 */   // Label 1411: @70233
     /*  70233 */   GIM_Try, /*On fail goto*//*Label 1412*/ GIMT_Encode4(70287), // Rule ID 952 //
     /*  70238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /*  70241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sdot),
     /*  70246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  70249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  70252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  70255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  70258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70274 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3728:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VSDOTD:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  70274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSDOTD),
     /*  70277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70281 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70283 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70285 */     GIR_RootConstrainSelectedInstOperands,
     /*  70286 */     // GIR_Coverage, 952,
     /*  70286 */     GIR_EraseRootFromParent_Done,
     /*  70287 */   // Label 1412: @70287
     /*  70287 */   GIM_Try, /*On fail goto*//*Label 1413*/ GIMT_Encode4(70341), // Rule ID 953 //
     /*  70292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /*  70295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_udot),
     /*  70300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  70312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70328 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3740:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VUDOTQ:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  70328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUDOTQ),
     /*  70331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70335 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70337 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70339 */     GIR_RootConstrainSelectedInstOperands,
     /*  70340 */     // GIR_Coverage, 953,
     /*  70340 */     GIR_EraseRootFromParent_Done,
     /*  70341 */   // Label 1413: @70341
     /*  70341 */   GIM_Try, /*On fail goto*//*Label 1414*/ GIMT_Encode4(70395), // Rule ID 954 //
     /*  70346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /*  70349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sdot),
     /*  70354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  70366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70382 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3728:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VSDOTQ:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  70382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSDOTQ),
     /*  70385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70391 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70393 */     GIR_RootConstrainSelectedInstOperands,
     /*  70394 */     // GIR_Coverage, 954,
     /*  70394 */     GIR_EraseRootFromParent_Done,
     /*  70395 */   // Label 1414: @70395
     /*  70395 */   GIM_Try, /*On fail goto*//*Label 1415*/ GIMT_Encode4(70449), // Rule ID 955 //
     /*  70400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /*  70403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_smmla),
     /*  70408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  70420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70436 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3739:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VSMMLA:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  70436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSMMLA),
     /*  70439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70443 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70445 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70447 */     GIR_RootConstrainSelectedInstOperands,
     /*  70448 */     // GIR_Coverage, 955,
     /*  70448 */     GIR_EraseRootFromParent_Done,
     /*  70449 */   // Label 1415: @70449
     /*  70449 */   GIM_Try, /*On fail goto*//*Label 1416*/ GIMT_Encode4(70503), // Rule ID 956 //
     /*  70454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /*  70457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_ummla),
     /*  70462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  70474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70490 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3741:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VUMMLA:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  70490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUMMLA),
     /*  70493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70495 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70497 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70499 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70501 */     GIR_RootConstrainSelectedInstOperands,
     /*  70502 */     // GIR_Coverage, 956,
     /*  70502 */     GIR_EraseRootFromParent_Done,
     /*  70503 */   // Label 1416: @70503
     /*  70503 */   GIM_Try, /*On fail goto*//*Label 1417*/ GIMT_Encode4(70557), // Rule ID 957 //
     /*  70508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /*  70511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_usmmla),
     /*  70516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  70528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70544 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3743:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VUSMMLA:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  70544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUSMMLA),
     /*  70547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70551 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70553 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70555 */     GIR_RootConstrainSelectedInstOperands,
     /*  70556 */     // GIR_Coverage, 957,
     /*  70556 */     GIR_EraseRootFromParent_Done,
     /*  70557 */   // Label 1417: @70557
     /*  70557 */   GIM_Try, /*On fail goto*//*Label 1418*/ GIMT_Encode4(70611), // Rule ID 958 //
     /*  70562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /*  70565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_usdot),
     /*  70570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  70573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  70576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  70579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  70582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70598 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3742:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VUSDOTD:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  70598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUSDOTD),
     /*  70601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70603 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70605 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70607 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70609 */     GIR_RootConstrainSelectedInstOperands,
     /*  70610 */     // GIR_Coverage, 958,
     /*  70610 */     GIR_EraseRootFromParent_Done,
     /*  70611 */   // Label 1418: @70611
     /*  70611 */   GIM_Try, /*On fail goto*//*Label 1419*/ GIMT_Encode4(70665), // Rule ID 959 //
     /*  70616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /*  70619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_usdot),
     /*  70624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  70636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70652 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3742:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VUSDOTQ:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  70652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUSDOTQ),
     /*  70655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70659 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70661 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70663 */     GIR_RootConstrainSelectedInstOperands,
     /*  70664 */     // GIR_Coverage, 959,
     /*  70664 */     GIR_EraseRootFromParent_Done,
     /*  70665 */   // Label 1419: @70665
     /*  70665 */   GIM_Try, /*On fail goto*//*Label 1420*/ GIMT_Encode4(70728), // Rule ID 1690 //
     /*  70670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbx1),
     /*  70678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  70681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  70687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  70690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70706 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3858:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$orig, VecListOneD:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VTBX1:{ *:[v8i8] } DPR:{ *:[v8i8] }:$orig, VecListOneD:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  70706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBX1),
     /*  70709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  70711 */     GIR_RootToRootCopy, /*OpIdx*/2, // orig
     /*  70713 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70715 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70720 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70726 */     GIR_RootConstrainSelectedInstOperands,
     /*  70727 */     // GIR_Coverage, 1690,
     /*  70727 */     GIR_EraseRootFromParent_Done,
     /*  70728 */   // Label 1420: @70728
     /*  70728 */   GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(70782), // Rule ID 1721 //
     /*  70733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  70736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1su0),
     /*  70741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  70753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70769 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3733:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA1SU0:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  70769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA1SU0),
     /*  70772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  70774 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  70776 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70778 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70780 */     GIR_RootConstrainSelectedInstOperands,
     /*  70781 */     // GIR_Coverage, 1721,
     /*  70781 */     GIR_EraseRootFromParent_Done,
     /*  70782 */   // Label 1421: @70782
     /*  70782 */   GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(70836), // Rule ID 1722 //
     /*  70787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  70790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha256h),
     /*  70795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  70807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70823 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3735:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA256H:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  70823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA256H),
     /*  70826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  70828 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  70830 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70832 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70834 */     GIR_RootConstrainSelectedInstOperands,
     /*  70835 */     // GIR_Coverage, 1722,
     /*  70835 */     GIR_EraseRootFromParent_Done,
     /*  70836 */   // Label 1422: @70836
     /*  70836 */   GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(70890), // Rule ID 1723 //
     /*  70841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  70844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha256h2),
     /*  70849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  70861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70877 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3736:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA256H2:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  70877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA256H2),
     /*  70880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  70882 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  70884 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70886 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70888 */     GIR_RootConstrainSelectedInstOperands,
     /*  70889 */     // GIR_Coverage, 1723,
     /*  70889 */     GIR_EraseRootFromParent_Done,
     /*  70890 */   // Label 1423: @70890
     /*  70890 */   GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(70944), // Rule ID 1724 //
     /*  70895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  70898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha256su1),
     /*  70903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  70915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70931 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3738:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA256SU1:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  70931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA256SU1),
     /*  70934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  70936 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  70938 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70940 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70942 */     GIR_RootConstrainSelectedInstOperands,
     /*  70943 */     // GIR_Coverage, 1724,
     /*  70943 */     GIR_EraseRootFromParent_Done,
     /*  70944 */   // Label 1424: @70944
     /*  70944 */   GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(71007), // Rule ID 1899 //
     /*  70949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  70952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlad),
     /*  70957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  70960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  70963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  70966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  70969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  70973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  70977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  70981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  70985 */     // (intrinsic_wo_chain:{ *:[i32] } 3883:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)  =>  (SMLAD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*  70985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLAD),
     /*  70988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70992 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  70994 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  70996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70999 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71005 */     GIR_RootConstrainSelectedInstOperands,
     /*  71006 */     // GIR_Coverage, 1899,
     /*  71006 */     GIR_EraseRootFromParent_Done,
     /*  71007 */   // Label 1425: @71007
     /*  71007 */   GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(71070), // Rule ID 1900 //
     /*  71012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  71015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smladx),
     /*  71020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71048 */     // (intrinsic_wo_chain:{ *:[i32] } 3884:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)  =>  (SMLADX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*  71048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLADX),
     /*  71051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  71055 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  71057 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  71059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71062 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71068 */     GIR_RootConstrainSelectedInstOperands,
     /*  71069 */     // GIR_Coverage, 1900,
     /*  71069 */     GIR_EraseRootFromParent_Done,
     /*  71070 */   // Label 1426: @71070
     /*  71070 */   GIM_Try, /*On fail goto*//*Label 1427*/ GIMT_Encode4(71133), // Rule ID 1901 //
     /*  71075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  71078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlsd),
     /*  71083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71111 */     // (intrinsic_wo_chain:{ *:[i32] } 3891:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)  =>  (SMLSD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*  71111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLSD),
     /*  71114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  71118 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  71120 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  71122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71125 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71131 */     GIR_RootConstrainSelectedInstOperands,
     /*  71132 */     // GIR_Coverage, 1901,
     /*  71132 */     GIR_EraseRootFromParent_Done,
     /*  71133 */   // Label 1427: @71133
     /*  71133 */   GIM_Try, /*On fail goto*//*Label 1428*/ GIMT_Encode4(71196), // Rule ID 1902 //
     /*  71138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  71141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlsdx),
     /*  71146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71174 */     // (intrinsic_wo_chain:{ *:[i32] } 3892:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)  =>  (SMLSDX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*  71174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLSDX),
     /*  71177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  71181 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  71183 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  71185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71188 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71194 */     GIR_RootConstrainSelectedInstOperands,
     /*  71195 */     // GIR_Coverage, 1902,
     /*  71195 */     GIR_EraseRootFromParent_Done,
     /*  71196 */   // Label 1428: @71196
     /*  71196 */   GIM_Try, /*On fail goto*//*Label 1429*/ GIMT_Encode4(71259), // Rule ID 1990 //
     /*  71201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  71204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlabb),
     /*  71209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71237 */     // (intrinsic_wo_chain:{ *:[i32] } 3881:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLABB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABB),
     /*  71240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71242 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71244 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71246 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71251 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71257 */     GIR_RootConstrainSelectedInstOperands,
     /*  71258 */     // GIR_Coverage, 1990,
     /*  71258 */     GIR_EraseRootFromParent_Done,
     /*  71259 */   // Label 1429: @71259
     /*  71259 */   GIM_Try, /*On fail goto*//*Label 1430*/ GIMT_Encode4(71322), // Rule ID 1991 //
     /*  71264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  71267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlabt),
     /*  71272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71300 */     // (intrinsic_wo_chain:{ *:[i32] } 3882:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLABT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABT),
     /*  71303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71305 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71307 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71309 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71314 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71320 */     GIR_RootConstrainSelectedInstOperands,
     /*  71321 */     // GIR_Coverage, 1991,
     /*  71321 */     GIR_EraseRootFromParent_Done,
     /*  71322 */   // Label 1430: @71322
     /*  71322 */   GIM_Try, /*On fail goto*//*Label 1431*/ GIMT_Encode4(71385), // Rule ID 1992 //
     /*  71327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  71330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlatb),
     /*  71335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71363 */     // (intrinsic_wo_chain:{ *:[i32] } 3887:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLATB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLATB),
     /*  71366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71368 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71370 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71372 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71377 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71383 */     GIR_RootConstrainSelectedInstOperands,
     /*  71384 */     // GIR_Coverage, 1992,
     /*  71384 */     GIR_EraseRootFromParent_Done,
     /*  71385 */   // Label 1431: @71385
     /*  71385 */   GIM_Try, /*On fail goto*//*Label 1432*/ GIMT_Encode4(71448), // Rule ID 1993 //
     /*  71390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  71393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlatt),
     /*  71398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71426 */     // (intrinsic_wo_chain:{ *:[i32] } 3888:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLATT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLATT),
     /*  71429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71431 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71433 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71435 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71440 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71446 */     GIR_RootConstrainSelectedInstOperands,
     /*  71447 */     // GIR_Coverage, 1993,
     /*  71447 */     GIR_EraseRootFromParent_Done,
     /*  71448 */   // Label 1432: @71448
     /*  71448 */   GIM_Try, /*On fail goto*//*Label 1433*/ GIMT_Encode4(71511), // Rule ID 1994 //
     /*  71453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  71456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlawb),
     /*  71461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71489 */     // (intrinsic_wo_chain:{ *:[i32] } 3889:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLAWB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLAWB),
     /*  71492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71494 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71496 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71498 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71503 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71509 */     GIR_RootConstrainSelectedInstOperands,
     /*  71510 */     // GIR_Coverage, 1994,
     /*  71510 */     GIR_EraseRootFromParent_Done,
     /*  71511 */   // Label 1433: @71511
     /*  71511 */   GIM_Try, /*On fail goto*//*Label 1434*/ GIMT_Encode4(71574), // Rule ID 1995 //
     /*  71516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  71519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlawt),
     /*  71524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71552 */     // (intrinsic_wo_chain:{ *:[i32] } 3890:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLAWT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLAWT),
     /*  71555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71557 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71559 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71561 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71566 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71572 */     GIR_RootConstrainSelectedInstOperands,
     /*  71573 */     // GIR_Coverage, 1995,
     /*  71573 */     GIR_EraseRootFromParent_Done,
     /*  71574 */   // Label 1434: @71574
     /*  71574 */   GIM_Try, /*On fail goto*//*Label 1435*/ GIMT_Encode4(71637), // Rule ID 2181 //
     /*  71579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlabb),
     /*  71587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71615 */     // (intrinsic_wo_chain:{ *:[i32] } 3881:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLABB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABB),
     /*  71618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71620 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71622 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71624 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71629 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71635 */     GIR_RootConstrainSelectedInstOperands,
     /*  71636 */     // GIR_Coverage, 2181,
     /*  71636 */     GIR_EraseRootFromParent_Done,
     /*  71637 */   // Label 1435: @71637
     /*  71637 */   GIM_Try, /*On fail goto*//*Label 1436*/ GIMT_Encode4(71700), // Rule ID 2182 //
     /*  71642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlabt),
     /*  71650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71678 */     // (intrinsic_wo_chain:{ *:[i32] } 3882:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLABT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABT),
     /*  71681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71683 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71685 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71687 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71692 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71698 */     GIR_RootConstrainSelectedInstOperands,
     /*  71699 */     // GIR_Coverage, 2182,
     /*  71699 */     GIR_EraseRootFromParent_Done,
     /*  71700 */   // Label 1436: @71700
     /*  71700 */   GIM_Try, /*On fail goto*//*Label 1437*/ GIMT_Encode4(71763), // Rule ID 2183 //
     /*  71705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlatb),
     /*  71713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71741 */     // (intrinsic_wo_chain:{ *:[i32] } 3887:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLATB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLATB),
     /*  71744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71746 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71748 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71750 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71755 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71761 */     GIR_RootConstrainSelectedInstOperands,
     /*  71762 */     // GIR_Coverage, 2183,
     /*  71762 */     GIR_EraseRootFromParent_Done,
     /*  71763 */   // Label 1437: @71763
     /*  71763 */   GIM_Try, /*On fail goto*//*Label 1438*/ GIMT_Encode4(71826), // Rule ID 2184 //
     /*  71768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlatt),
     /*  71776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71804 */     // (intrinsic_wo_chain:{ *:[i32] } 3888:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLATT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLATT),
     /*  71807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71809 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71811 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71813 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71818 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71824 */     GIR_RootConstrainSelectedInstOperands,
     /*  71825 */     // GIR_Coverage, 2184,
     /*  71825 */     GIR_EraseRootFromParent_Done,
     /*  71826 */   // Label 1438: @71826
     /*  71826 */   GIM_Try, /*On fail goto*//*Label 1439*/ GIMT_Encode4(71889), // Rule ID 2185 //
     /*  71831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlawb),
     /*  71839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71867 */     // (intrinsic_wo_chain:{ *:[i32] } 3889:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLAWB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLAWB),
     /*  71870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71872 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71874 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71876 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71881 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71887 */     GIR_RootConstrainSelectedInstOperands,
     /*  71888 */     // GIR_Coverage, 2185,
     /*  71888 */     GIR_EraseRootFromParent_Done,
     /*  71889 */   // Label 1439: @71889
     /*  71889 */   GIM_Try, /*On fail goto*//*Label 1440*/ GIMT_Encode4(71952), // Rule ID 2186 //
     /*  71894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlawt),
     /*  71902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71930 */     // (intrinsic_wo_chain:{ *:[i32] } 3890:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLAWT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLAWT),
     /*  71933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71935 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71937 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71939 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71944 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71950 */     GIR_RootConstrainSelectedInstOperands,
     /*  71951 */     // GIR_Coverage, 2186,
     /*  71951 */     GIR_EraseRootFromParent_Done,
     /*  71952 */   // Label 1440: @71952
     /*  71952 */   GIM_Try, /*On fail goto*//*Label 1441*/ GIMT_Encode4(72015), // Rule ID 2472 //
     /*  71957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  71960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlah),
     /*  71965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  71968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  71971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  71974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /*  71977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  71981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  71985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  71989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  71993 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3812:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQRDMLAHv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  71993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLAHv4i16),
     /*  71996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  71998 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72002 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72007 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72013 */     GIR_RootConstrainSelectedInstOperands,
     /*  72014 */     // GIR_Coverage, 2472,
     /*  72014 */     GIR_EraseRootFromParent_Done,
     /*  72015 */   // Label 1441: @72015
     /*  72015 */   GIM_Try, /*On fail goto*//*Label 1442*/ GIMT_Encode4(72078), // Rule ID 2473 //
     /*  72020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  72023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlah),
     /*  72028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  72031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  72034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  72037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /*  72040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72056 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3812:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQRDMLAHv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  72056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLAHv2i32),
     /*  72059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72061 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72063 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72065 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72070 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72076 */     GIR_RootConstrainSelectedInstOperands,
     /*  72077 */     // GIR_Coverage, 2473,
     /*  72077 */     GIR_EraseRootFromParent_Done,
     /*  72078 */   // Label 1442: @72078
     /*  72078 */   GIM_Try, /*On fail goto*//*Label 1443*/ GIMT_Encode4(72141), // Rule ID 2474 //
     /*  72083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  72086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlah),
     /*  72091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  72094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  72100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  72103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72119 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3812:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQRDMLAHv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  72119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLAHv8i16),
     /*  72122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72124 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72126 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72128 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72133 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72139 */     GIR_RootConstrainSelectedInstOperands,
     /*  72140 */     // GIR_Coverage, 2474,
     /*  72140 */     GIR_EraseRootFromParent_Done,
     /*  72141 */   // Label 1443: @72141
     /*  72141 */   GIM_Try, /*On fail goto*//*Label 1444*/ GIMT_Encode4(72204), // Rule ID 2475 //
     /*  72146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  72149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlah),
     /*  72154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  72166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72182 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3812:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQRDMLAHv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  72182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLAHv4i32),
     /*  72185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72187 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72189 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72191 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72196 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72202 */     GIR_RootConstrainSelectedInstOperands,
     /*  72203 */     // GIR_Coverage, 2475,
     /*  72203 */     GIR_EraseRootFromParent_Done,
     /*  72204 */   // Label 1444: @72204
     /*  72204 */   GIM_Try, /*On fail goto*//*Label 1445*/ GIMT_Encode4(72267), // Rule ID 2480 //
     /*  72209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  72212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlsh),
     /*  72217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  72220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  72223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  72226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /*  72229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72245 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3813:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQRDMLSHv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  72245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLSHv4i16),
     /*  72248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72250 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72252 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72254 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72259 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72265 */     GIR_RootConstrainSelectedInstOperands,
     /*  72266 */     // GIR_Coverage, 2480,
     /*  72266 */     GIR_EraseRootFromParent_Done,
     /*  72267 */   // Label 1445: @72267
     /*  72267 */   GIM_Try, /*On fail goto*//*Label 1446*/ GIMT_Encode4(72330), // Rule ID 2481 //
     /*  72272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  72275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlsh),
     /*  72280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  72283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  72286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  72289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /*  72292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72308 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3813:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQRDMLSHv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  72308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLSHv2i32),
     /*  72311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72313 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72317 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72322 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72328 */     GIR_RootConstrainSelectedInstOperands,
     /*  72329 */     // GIR_Coverage, 2481,
     /*  72329 */     GIR_EraseRootFromParent_Done,
     /*  72330 */   // Label 1446: @72330
     /*  72330 */   GIM_Try, /*On fail goto*//*Label 1447*/ GIMT_Encode4(72393), // Rule ID 2482 //
     /*  72335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  72338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlsh),
     /*  72343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  72346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  72352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  72355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72371 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3813:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQRDMLSHv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  72371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLSHv8i16),
     /*  72374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72376 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72378 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72380 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72385 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72391 */     GIR_RootConstrainSelectedInstOperands,
     /*  72392 */     // GIR_Coverage, 2482,
     /*  72392 */     GIR_EraseRootFromParent_Done,
     /*  72393 */   // Label 1447: @72393
     /*  72393 */   GIM_Try, /*On fail goto*//*Label 1448*/ GIMT_Encode4(72456), // Rule ID 2483 //
     /*  72398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  72401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlsh),
     /*  72406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  72418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72434 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3813:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQRDMLSHv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  72434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLSHv4i32),
     /*  72437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72439 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72441 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72443 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72448 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72454 */     GIR_RootConstrainSelectedInstOperands,
     /*  72455 */     // GIR_Coverage, 2483,
     /*  72455 */     GIR_EraseRootFromParent_Done,
     /*  72456 */   // Label 1448: @72456
     /*  72456 */   GIM_Try, /*On fail goto*//*Label 1449*/ GIMT_Encode4(72525), // Rule ID 4840 //
     /*  72461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlah),
     /*  72469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  72472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  72478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72497 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3664:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLAH_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLAH_qrs8),
     /*  72500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72502 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72504 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72506 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72511 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72517 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72523 */     GIR_RootConstrainSelectedInstOperands,
     /*  72524 */     // GIR_Coverage, 4840,
     /*  72524 */     GIR_EraseRootFromParent_Done,
     /*  72525 */   // Label 1449: @72525
     /*  72525 */   GIM_Try, /*On fail goto*//*Label 1450*/ GIMT_Encode4(72594), // Rule ID 4842 //
     /*  72530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlah),
     /*  72538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  72541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  72547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72566 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3664:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLAH_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLAH_qrs16),
     /*  72569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72571 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72573 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72575 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72580 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72586 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72592 */     GIR_RootConstrainSelectedInstOperands,
     /*  72593 */     // GIR_Coverage, 4842,
     /*  72593 */     GIR_EraseRootFromParent_Done,
     /*  72594 */   // Label 1450: @72594
     /*  72594 */   GIM_Try, /*On fail goto*//*Label 1451*/ GIMT_Encode4(72663), // Rule ID 4844 //
     /*  72599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlah),
     /*  72607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72635 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3664:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLAH_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLAH_qrs32),
     /*  72638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72640 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72642 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72644 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72649 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72655 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72661 */     GIR_RootConstrainSelectedInstOperands,
     /*  72662 */     // GIR_Coverage, 4844,
     /*  72662 */     GIR_EraseRootFromParent_Done,
     /*  72663 */   // Label 1451: @72663
     /*  72663 */   GIM_Try, /*On fail goto*//*Label 1452*/ GIMT_Encode4(72732), // Rule ID 4846 //
     /*  72668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlah),
     /*  72676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  72679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  72685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72704 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3673:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLAH_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLAH_qrs8),
     /*  72707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72709 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72711 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72713 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72718 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72724 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72730 */     GIR_RootConstrainSelectedInstOperands,
     /*  72731 */     // GIR_Coverage, 4846,
     /*  72731 */     GIR_EraseRootFromParent_Done,
     /*  72732 */   // Label 1452: @72732
     /*  72732 */   GIM_Try, /*On fail goto*//*Label 1453*/ GIMT_Encode4(72801), // Rule ID 4848 //
     /*  72737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlah),
     /*  72745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  72748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  72754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72773 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3673:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLAH_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLAH_qrs16),
     /*  72776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72778 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72780 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72782 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72787 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72793 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72799 */     GIR_RootConstrainSelectedInstOperands,
     /*  72800 */     // GIR_Coverage, 4848,
     /*  72800 */     GIR_EraseRootFromParent_Done,
     /*  72801 */   // Label 1453: @72801
     /*  72801 */   GIM_Try, /*On fail goto*//*Label 1454*/ GIMT_Encode4(72870), // Rule ID 4850 //
     /*  72806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlah),
     /*  72814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72842 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3673:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLAH_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLAH_qrs32),
     /*  72845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72847 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72849 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72851 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72856 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72862 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72868 */     GIR_RootConstrainSelectedInstOperands,
     /*  72869 */     // GIR_Coverage, 4850,
     /*  72869 */     GIR_EraseRootFromParent_Done,
     /*  72870 */   // Label 1454: @72870
     /*  72870 */   GIM_Try, /*On fail goto*//*Label 1455*/ GIMT_Encode4(72939), // Rule ID 4852 //
     /*  72875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlash),
     /*  72883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  72886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  72892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72911 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3666:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLASH_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLASH_qrs8),
     /*  72914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72916 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72918 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72920 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72925 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72931 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72937 */     GIR_RootConstrainSelectedInstOperands,
     /*  72938 */     // GIR_Coverage, 4852,
     /*  72938 */     GIR_EraseRootFromParent_Done,
     /*  72939 */   // Label 1455: @72939
     /*  72939 */   GIM_Try, /*On fail goto*//*Label 1456*/ GIMT_Encode4(73008), // Rule ID 4854 //
     /*  72944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlash),
     /*  72952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  72955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  72961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72980 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3666:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLASH_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLASH_qrs16),
     /*  72983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72985 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72987 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72989 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72994 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73000 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73006 */     GIR_RootConstrainSelectedInstOperands,
     /*  73007 */     // GIR_Coverage, 4854,
     /*  73007 */     GIR_EraseRootFromParent_Done,
     /*  73008 */   // Label 1456: @73008
     /*  73008 */   GIM_Try, /*On fail goto*//*Label 1457*/ GIMT_Encode4(73077), // Rule ID 4856 //
     /*  73013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  73016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlash),
     /*  73021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  73027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  73030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  73049 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3666:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLASH_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  73049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLASH_qrs32),
     /*  73052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73054 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  73056 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  73058 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  73060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73063 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73069 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73075 */     GIR_RootConstrainSelectedInstOperands,
     /*  73076 */     // GIR_Coverage, 4856,
     /*  73076 */     GIR_EraseRootFromParent_Done,
     /*  73077 */   // Label 1457: @73077
     /*  73077 */   GIM_Try, /*On fail goto*//*Label 1458*/ GIMT_Encode4(73146), // Rule ID 4858 //
     /*  73082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  73085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlash),
     /*  73090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  73093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  73118 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3675:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLASH_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  73118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLASH_qrs8),
     /*  73121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73123 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  73125 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  73127 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  73129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73132 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73138 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73144 */     GIR_RootConstrainSelectedInstOperands,
     /*  73145 */     // GIR_Coverage, 4858,
     /*  73145 */     GIR_EraseRootFromParent_Done,
     /*  73146 */   // Label 1458: @73146
     /*  73146 */   GIM_Try, /*On fail goto*//*Label 1459*/ GIMT_Encode4(73215), // Rule ID 4860 //
     /*  73151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  73154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlash),
     /*  73159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  73162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  73165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  73168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  73187 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3675:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLASH_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  73187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLASH_qrs16),
     /*  73190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73192 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  73194 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  73196 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  73198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73201 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73207 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73213 */     GIR_RootConstrainSelectedInstOperands,
     /*  73214 */     // GIR_Coverage, 4860,
     /*  73214 */     GIR_EraseRootFromParent_Done,
     /*  73215 */   // Label 1459: @73215
     /*  73215 */   GIM_Try, /*On fail goto*//*Label 1460*/ GIMT_Encode4(73284), // Rule ID 4862 //
     /*  73220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  73223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlash),
     /*  73228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  73234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  73237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  73256 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3675:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLASH_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  73256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLASH_qrs32),
     /*  73259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73261 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  73263 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  73265 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  73267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73270 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73276 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73282 */     GIR_RootConstrainSelectedInstOperands,
     /*  73283 */     // GIR_Coverage, 4862,
     /*  73283 */     GIR_EraseRootFromParent_Done,
     /*  73284 */   // Label 1460: @73284
     /*  73284 */   GIM_Try, /*On fail goto*//*Label 1461*/ GIMT_Encode4(73379), // Rule ID 2694 //
     /*  73289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1c),
     /*  73297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  73303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  73309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  73313 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3729:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$hash_abcd, i32:{ *:[i32] }:$hash_e, v4i32:{ *:[v4i32] }:$wk)  =>  (SHA1C:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$hash_abcd, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (COPY_TO_REGCLASS:{ *:[f32] } i32:{ *:[i32] }:$hash_e, SPR:{ *:[i32] }), ssub_0:{ *:[i32] }), v4i32:{ *:[v4i32] }:$wk)
     /*  73313 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  73316 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73320 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73325 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // hash_e
     /*  73329 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  73334 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  73337 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  73341 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73346 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  73349 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  73352 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/17,
     /*  73355 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPair_with_ssub_0RegClassID),
     /*  73360 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /*  73365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA1C),
     /*  73368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73370 */     GIR_RootToRootCopy, /*OpIdx*/2, // hash_abcd
     /*  73372 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73375 */     GIR_RootToRootCopy, /*OpIdx*/4, // wk
     /*  73377 */     GIR_RootConstrainSelectedInstOperands,
     /*  73378 */     // GIR_Coverage, 2694,
     /*  73378 */     GIR_EraseRootFromParent_Done,
     /*  73379 */   // Label 1461: @73379
     /*  73379 */   GIM_Try, /*On fail goto*//*Label 1462*/ GIMT_Encode4(73474), // Rule ID 2695 //
     /*  73384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1m),
     /*  73392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  73398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  73404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  73408 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3731:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$hash_abcd, i32:{ *:[i32] }:$hash_e, v4i32:{ *:[v4i32] }:$wk)  =>  (SHA1M:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$hash_abcd, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (COPY_TO_REGCLASS:{ *:[f32] } i32:{ *:[i32] }:$hash_e, SPR:{ *:[i32] }), ssub_0:{ *:[i32] }), v4i32:{ *:[v4i32] }:$wk)
     /*  73408 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  73411 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73415 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73420 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // hash_e
     /*  73424 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  73429 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  73432 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  73436 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73441 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  73444 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  73447 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/17,
     /*  73450 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPair_with_ssub_0RegClassID),
     /*  73455 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /*  73460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA1M),
     /*  73463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73465 */     GIR_RootToRootCopy, /*OpIdx*/2, // hash_abcd
     /*  73467 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73470 */     GIR_RootToRootCopy, /*OpIdx*/4, // wk
     /*  73472 */     GIR_RootConstrainSelectedInstOperands,
     /*  73473 */     // GIR_Coverage, 2695,
     /*  73473 */     GIR_EraseRootFromParent_Done,
     /*  73474 */   // Label 1462: @73474
     /*  73474 */   GIM_Try, /*On fail goto*//*Label 1463*/ GIMT_Encode4(73569), // Rule ID 2696 //
     /*  73479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1p),
     /*  73487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  73493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  73499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  73503 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3732:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$hash_abcd, i32:{ *:[i32] }:$hash_e, v4i32:{ *:[v4i32] }:$wk)  =>  (SHA1P:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$hash_abcd, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (COPY_TO_REGCLASS:{ *:[f32] } i32:{ *:[i32] }:$hash_e, SPR:{ *:[i32] }), ssub_0:{ *:[i32] }), v4i32:{ *:[v4i32] }:$wk)
     /*  73503 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  73506 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73510 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73515 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // hash_e
     /*  73519 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  73524 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  73527 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  73531 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73536 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  73539 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  73542 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/17,
     /*  73545 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPair_with_ssub_0RegClassID),
     /*  73550 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /*  73555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA1P),
     /*  73558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73560 */     GIR_RootToRootCopy, /*OpIdx*/2, // hash_abcd
     /*  73562 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73565 */     GIR_RootToRootCopy, /*OpIdx*/4, // wk
     /*  73567 */     GIR_RootConstrainSelectedInstOperands,
     /*  73568 */     // GIR_Coverage, 2696,
     /*  73568 */     GIR_EraseRootFromParent_Done,
     /*  73569 */   // Label 1463: @73569
     /*  73569 */   GIM_Reject,
     /*  73570 */ // Label 1316: @73570
     /*  73570 */ GIM_Try, /*On fail goto*//*Label 1464*/ GIMT_Encode4(76956),
     /*  73575 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /*  73578 */   GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(73662), // Rule ID 3727 //
     /*  73583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  73591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73611 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /*  73615 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  73619 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  73623 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3704:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, 8:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHLL_lws8bh:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)
     /*  73623 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73626 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73630 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lws8bh),
     /*  73638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73640 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  73642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73645 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73651 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73657 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73660 */     GIR_RootConstrainSelectedInstOperands,
     /*  73661 */     // GIR_Coverage, 3727,
     /*  73661 */     GIR_EraseRootFromParent_Done,
     /*  73662 */   // Label 1465: @73662
     /*  73662 */   GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(73746), // Rule ID 3731 //
     /*  73667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  73675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73695 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /*  73699 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  73703 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  73707 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3704:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, 8:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHLL_lws8th:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)
     /*  73707 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73710 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73714 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lws8th),
     /*  73722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73724 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  73726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73729 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73735 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73741 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73744 */     GIR_RootConstrainSelectedInstOperands,
     /*  73745 */     // GIR_Coverage, 3731,
     /*  73745 */     GIR_EraseRootFromParent_Done,
     /*  73746 */   // Label 1466: @73746
     /*  73746 */   GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(73830), // Rule ID 3735 //
     /*  73751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  73762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73779 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /*  73783 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  73787 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  73791 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3704:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, 16:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHLL_lws16bh:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)
     /*  73791 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73794 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73798 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lws16bh),
     /*  73806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73808 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  73810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73813 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73819 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73825 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73828 */     GIR_RootConstrainSelectedInstOperands,
     /*  73829 */     // GIR_Coverage, 3735,
     /*  73829 */     GIR_EraseRootFromParent_Done,
     /*  73830 */   // Label 1467: @73830
     /*  73830 */   GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(73914), // Rule ID 3739 //
     /*  73835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  73846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73863 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /*  73867 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  73871 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  73875 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3704:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, 16:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHLL_lws16th:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)
     /*  73875 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73878 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73882 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lws16th),
     /*  73890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73892 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  73894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73897 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73903 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73909 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73912 */     GIR_RootConstrainSelectedInstOperands,
     /*  73913 */     // GIR_Coverage, 3739,
     /*  73913 */     GIR_EraseRootFromParent_Done,
     /*  73914 */   // Label 1468: @73914
     /*  73914 */   GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(73998), // Rule ID 3743 //
     /*  73919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  73927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73947 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /*  73951 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  73955 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  73959 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3704:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, 8:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHLL_lwu8bh:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)
     /*  73959 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73962 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73966 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lwu8bh),
     /*  73974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73976 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  73978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73981 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73987 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73993 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73996 */     GIR_RootConstrainSelectedInstOperands,
     /*  73997 */     // GIR_Coverage, 3743,
     /*  73997 */     GIR_EraseRootFromParent_Done,
     /*  73998 */   // Label 1469: @73998
     /*  73998 */   GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(74082), // Rule ID 3747 //
     /*  74003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  74008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  74011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  74017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74031 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /*  74035 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  74039 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74043 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3704:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, 8:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHLL_lwu8th:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)
     /*  74043 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74046 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74050 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lwu8th),
     /*  74058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74060 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  74062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74065 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74071 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74077 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74080 */     GIR_RootConstrainSelectedInstOperands,
     /*  74081 */     // GIR_Coverage, 3747,
     /*  74081 */     GIR_EraseRootFromParent_Done,
     /*  74082 */   // Label 1470: @74082
     /*  74082 */   GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(74166), // Rule ID 3751 //
     /*  74087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  74092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  74098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  74101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74115 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /*  74119 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  74123 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  74127 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3704:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, 16:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHLL_lwu16bh:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)
     /*  74127 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74130 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74134 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lwu16bh),
     /*  74142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74144 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  74146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74149 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74155 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74161 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74164 */     GIR_RootConstrainSelectedInstOperands,
     /*  74165 */     // GIR_Coverage, 3751,
     /*  74165 */     GIR_EraseRootFromParent_Done,
     /*  74166 */   // Label 1471: @74166
     /*  74166 */   GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(74250), // Rule ID 3755 //
     /*  74171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  74176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  74182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  74185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74199 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /*  74203 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  74207 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74211 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3704:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, 16:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHLL_lwu16th:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)
     /*  74211 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74214 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74218 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lwu16th),
     /*  74226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74228 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  74230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74233 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74239 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74245 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74248 */     GIR_RootConstrainSelectedInstOperands,
     /*  74249 */     // GIR_Coverage, 3755,
     /*  74249 */     GIR_EraseRootFromParent_Done,
     /*  74250 */   // Label 1472: @74250
     /*  74250 */   GIM_Try, /*On fail goto*//*Label 1473*/ GIMT_Encode4(74339), // Rule ID 4387 //
     /*  74255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  74266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74290 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74294 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  74298 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3660:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBs8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  74298 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74301 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74305 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBs8),
     /*  74313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74315 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74317 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74322 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74328 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74334 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74337 */     GIR_RootConstrainSelectedInstOperands,
     /*  74338 */     // GIR_Coverage, 4387,
     /*  74338 */     GIR_EraseRootFromParent_Done,
     /*  74339 */   // Label 1473: @74339
     /*  74339 */   GIM_Try, /*On fail goto*//*Label 1474*/ GIMT_Encode4(74428), // Rule ID 4389 //
     /*  74344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  74355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74379 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74383 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74387 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3660:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTs8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  74387 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74390 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74394 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTs8),
     /*  74402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74406 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74411 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74417 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74423 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74426 */     GIR_RootConstrainSelectedInstOperands,
     /*  74427 */     // GIR_Coverage, 4389,
     /*  74427 */     GIR_EraseRootFromParent_Done,
     /*  74428 */   // Label 1474: @74428
     /*  74428 */   GIM_Try, /*On fail goto*//*Label 1475*/ GIMT_Encode4(74517), // Rule ID 4391 //
     /*  74433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  74447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  74450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74468 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74472 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  74476 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3660:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBs16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  74476 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74479 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74483 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBs16),
     /*  74491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74495 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74500 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74506 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74512 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74515 */     GIR_RootConstrainSelectedInstOperands,
     /*  74516 */     // GIR_Coverage, 4391,
     /*  74516 */     GIR_EraseRootFromParent_Done,
     /*  74517 */   // Label 1475: @74517
     /*  74517 */   GIM_Try, /*On fail goto*//*Label 1476*/ GIMT_Encode4(74606), // Rule ID 4393 //
     /*  74522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  74536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  74539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74557 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74561 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74565 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3660:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTs16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  74565 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74568 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74572 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTs16),
     /*  74580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74584 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74589 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74595 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74601 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74604 */     GIR_RootConstrainSelectedInstOperands,
     /*  74605 */     // GIR_Coverage, 4393,
     /*  74605 */     GIR_EraseRootFromParent_Done,
     /*  74606 */   // Label 1476: @74606
     /*  74606 */   GIM_Try, /*On fail goto*//*Label 1477*/ GIMT_Encode4(74695), // Rule ID 4395 //
     /*  74611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  74622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  74625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  74628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74646 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74650 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  74654 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3660:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBs32:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  74654 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74657 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74661 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBs32),
     /*  74669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74673 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74678 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74684 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74690 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74693 */     GIR_RootConstrainSelectedInstOperands,
     /*  74694 */     // GIR_Coverage, 4395,
     /*  74694 */     GIR_EraseRootFromParent_Done,
     /*  74695 */   // Label 1477: @74695
     /*  74695 */   GIM_Try, /*On fail goto*//*Label 1478*/ GIMT_Encode4(74784), // Rule ID 4397 //
     /*  74700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  74711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  74714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  74717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74735 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74739 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74743 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3660:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTs32:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  74743 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74746 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74750 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTs32),
     /*  74758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74760 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74762 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74767 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74773 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74779 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74782 */     GIR_RootConstrainSelectedInstOperands,
     /*  74783 */     // GIR_Coverage, 4397,
     /*  74783 */     GIR_EraseRootFromParent_Done,
     /*  74784 */   // Label 1478: @74784
     /*  74784 */   GIM_Try, /*On fail goto*//*Label 1479*/ GIMT_Encode4(74873), // Rule ID 4399 //
     /*  74789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  74800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74824 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  74828 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  74832 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3660:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBu8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  74832 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74835 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74839 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBu8),
     /*  74847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74851 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74856 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74862 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74868 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74871 */     GIR_RootConstrainSelectedInstOperands,
     /*  74872 */     // GIR_Coverage, 4399,
     /*  74872 */     GIR_EraseRootFromParent_Done,
     /*  74873 */   // Label 1479: @74873
     /*  74873 */   GIM_Try, /*On fail goto*//*Label 1480*/ GIMT_Encode4(74962), // Rule ID 4401 //
     /*  74878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  74889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74913 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  74917 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74921 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3660:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTu8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  74921 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74924 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74928 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTu8),
     /*  74936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74945 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74951 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74957 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74960 */     GIR_RootConstrainSelectedInstOperands,
     /*  74961 */     // GIR_Coverage, 4401,
     /*  74961 */     GIR_EraseRootFromParent_Done,
     /*  74962 */   // Label 1480: @74962
     /*  74962 */   GIM_Try, /*On fail goto*//*Label 1481*/ GIMT_Encode4(75051), // Rule ID 4403 //
     /*  74967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  74981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  74984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75002 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  75006 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  75010 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3660:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBu16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  75010 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75013 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75017 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBu16),
     /*  75025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  75029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  75031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75034 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75040 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75046 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75049 */     GIR_RootConstrainSelectedInstOperands,
     /*  75050 */     // GIR_Coverage, 4403,
     /*  75050 */     GIR_EraseRootFromParent_Done,
     /*  75051 */   // Label 1481: @75051
     /*  75051 */   GIM_Try, /*On fail goto*//*Label 1482*/ GIMT_Encode4(75140), // Rule ID 4405 //
     /*  75056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  75064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  75070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  75073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  75076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  75079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75091 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  75095 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  75099 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3660:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTu16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  75099 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75102 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75106 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTu16),
     /*  75114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  75118 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  75120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75123 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75129 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75135 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75138 */     GIR_RootConstrainSelectedInstOperands,
     /*  75139 */     // GIR_Coverage, 4405,
     /*  75139 */     GIR_EraseRootFromParent_Done,
     /*  75140 */   // Label 1482: @75140
     /*  75140 */   GIM_Try, /*On fail goto*//*Label 1483*/ GIMT_Encode4(75229), // Rule ID 4407 //
     /*  75145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  75153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  75156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  75162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  75165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  75168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75180 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  75184 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  75188 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3660:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBu32:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  75188 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75191 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75195 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBu32),
     /*  75203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  75207 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  75209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75212 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75218 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75224 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75227 */     GIR_RootConstrainSelectedInstOperands,
     /*  75228 */     // GIR_Coverage, 4407,
     /*  75228 */     GIR_EraseRootFromParent_Done,
     /*  75229 */   // Label 1483: @75229
     /*  75229 */   GIM_Try, /*On fail goto*//*Label 1484*/ GIMT_Encode4(75318), // Rule ID 4409 //
     /*  75234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  75242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  75245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  75251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  75254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  75257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75269 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  75273 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  75277 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3660:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTu32:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  75277 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75280 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75284 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTu32),
     /*  75292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  75296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  75298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75301 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75307 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75313 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75316 */     GIR_RootConstrainSelectedInstOperands,
     /*  75317 */     // GIR_Coverage, 4409,
     /*  75317 */     GIR_EraseRootFromParent_Done,
     /*  75318 */   // Label 1484: @75318
     /*  75318 */   GIM_Try, /*On fail goto*//*Label 1485*/ GIMT_Encode4(75416), // Rule ID 4032 //
     /*  75323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  75326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  75334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  75343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  75346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75350 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  75354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75362 */     // MIs[1] Operand 1
     /*  75362 */     // No operand predicates
     /*  75362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75370 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75372 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3603:{ *:[iPTR] }, 1:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm)  =>  (MVE_VCADDf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75372 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75375 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75379 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCADDf16),
     /*  75387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75389 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75391 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75393 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75399 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75405 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75411 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75414 */     GIR_RootConstrainSelectedInstOperands,
     /*  75415 */     // GIR_Coverage, 4032,
     /*  75415 */     GIR_EraseRootFromParent_Done,
     /*  75416 */   // Label 1485: @75416
     /*  75416 */   GIM_Try, /*On fail goto*//*Label 1486*/ GIMT_Encode4(75514), // Rule ID 4034 //
     /*  75421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  75424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  75441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  75444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75448 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  75452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75460 */     // MIs[1] Operand 1
     /*  75460 */     // No operand predicates
     /*  75460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75468 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75470 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3603:{ *:[iPTR] }, 1:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm)  =>  (MVE_VCADDf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75470 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75473 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75477 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCADDf32),
     /*  75485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75487 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75489 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75497 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75503 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75509 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75512 */     GIR_RootConstrainSelectedInstOperands,
     /*  75513 */     // GIR_Coverage, 4034,
     /*  75513 */     GIR_EraseRootFromParent_Done,
     /*  75514 */   // Label 1486: @75514
     /*  75514 */   GIM_Try, /*On fail goto*//*Label 1487*/ GIMT_Encode4(75612), // Rule ID 4541 //
     /*  75519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  75530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  75539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v16s8,
     /*  75542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75546 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  75550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75558 */     // MIs[1] Operand 1
     /*  75558 */     // No operand predicates
     /*  75558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75566 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75568 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3603:{ *:[iPTR] }, 1:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VCADDi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75568 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75571 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75575 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCADDi8),
     /*  75583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75585 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75587 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75589 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75595 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75601 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75607 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75610 */     GIR_RootConstrainSelectedInstOperands,
     /*  75611 */     // GIR_Coverage, 4541,
     /*  75611 */     GIR_EraseRootFromParent_Done,
     /*  75612 */   // Label 1487: @75612
     /*  75612 */   GIM_Try, /*On fail goto*//*Label 1488*/ GIMT_Encode4(75710), // Rule ID 4543 //
     /*  75617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  75628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  75637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  75640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75644 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  75648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75656 */     // MIs[1] Operand 1
     /*  75656 */     // No operand predicates
     /*  75656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75666 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3603:{ *:[iPTR] }, 1:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VCADDi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75666 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75669 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75673 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCADDi16),
     /*  75681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75683 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75685 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75687 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75693 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75699 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75705 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75708 */     GIR_RootConstrainSelectedInstOperands,
     /*  75709 */     // GIR_Coverage, 4543,
     /*  75709 */     GIR_EraseRootFromParent_Done,
     /*  75710 */   // Label 1488: @75710
     /*  75710 */   GIM_Try, /*On fail goto*//*Label 1489*/ GIMT_Encode4(75808), // Rule ID 4545 //
     /*  75715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  75735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  75738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75742 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  75746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75754 */     // MIs[1] Operand 1
     /*  75754 */     // No operand predicates
     /*  75754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75762 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75764 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3603:{ *:[iPTR] }, 1:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VCADDi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75764 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75767 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75771 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCADDi32),
     /*  75779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75781 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75783 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75791 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75797 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75803 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75806 */     GIR_RootConstrainSelectedInstOperands,
     /*  75807 */     // GIR_Coverage, 4545,
     /*  75807 */     GIR_EraseRootFromParent_Done,
     /*  75808 */   // Label 1489: @75808
     /*  75808 */   GIM_Try, /*On fail goto*//*Label 1490*/ GIMT_Encode4(75906), // Rule ID 4547 //
     /*  75813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  75824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  75833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v16s8,
     /*  75836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75840 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  75844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75852 */     // MIs[1] Operand 1
     /*  75852 */     // No operand predicates
     /*  75852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75862 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3603:{ *:[iPTR] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VHCADDs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75862 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75865 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75869 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHCADDs8),
     /*  75877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75879 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75881 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75883 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75889 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75895 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75901 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75904 */     GIR_RootConstrainSelectedInstOperands,
     /*  75905 */     // GIR_Coverage, 4547,
     /*  75905 */     GIR_EraseRootFromParent_Done,
     /*  75906 */   // Label 1490: @75906
     /*  75906 */   GIM_Try, /*On fail goto*//*Label 1491*/ GIMT_Encode4(76004), // Rule ID 4549 //
     /*  75911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  75922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  75931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  75934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75938 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  75942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75950 */     // MIs[1] Operand 1
     /*  75950 */     // No operand predicates
     /*  75950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75960 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3603:{ *:[iPTR] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VHCADDs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75960 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75963 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75967 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHCADDs16),
     /*  75975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75977 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75979 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75981 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75987 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75993 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75999 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76002 */     GIR_RootConstrainSelectedInstOperands,
     /*  76003 */     // GIR_Coverage, 4549,
     /*  76003 */     GIR_EraseRootFromParent_Done,
     /*  76004 */   // Label 1491: @76004
     /*  76004 */   GIM_Try, /*On fail goto*//*Label 1492*/ GIMT_Encode4(76102), // Rule ID 4551 //
     /*  76009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  76017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  76020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  76029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  76032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76036 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  76040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  76044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  76048 */     // MIs[1] Operand 1
     /*  76048 */     // No operand predicates
     /*  76048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76058 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3603:{ *:[iPTR] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VHCADDs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  76058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  76061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  76065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHCADDs32),
     /*  76073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  76075 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76077 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76079 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  76082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76085 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76091 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76097 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76100 */     GIR_RootConstrainSelectedInstOperands,
     /*  76101 */     // GIR_Coverage, 4551,
     /*  76101 */     GIR_EraseRootFromParent_Done,
     /*  76102 */   // Label 1492: @76102
     /*  76102 */   GIM_Try, /*On fail goto*//*Label 1493*/ GIMT_Encode4(76178), // Rule ID 3037 //
     /*  76107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  76115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  76118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  76127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v16s8,
     /*  76130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76134 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  76138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76150 */     // (intrinsic_wo_chain:{ *:[i32] } 3596:{ *:[iPTR] }, 0:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VABAVs8:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  76150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVs8),
     /*  76153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  76155 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  76157 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76159 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76164 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76170 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76176 */     GIR_RootConstrainSelectedInstOperands,
     /*  76177 */     // GIR_Coverage, 3037,
     /*  76177 */     GIR_EraseRootFromParent_Done,
     /*  76178 */   // Label 1493: @76178
     /*  76178 */   GIM_Try, /*On fail goto*//*Label 1494*/ GIMT_Encode4(76254), // Rule ID 3039 //
     /*  76183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  76191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  76194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  76203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  76206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76210 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  76214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76226 */     // (intrinsic_wo_chain:{ *:[i32] } 3596:{ *:[iPTR] }, 0:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VABAVs16:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  76226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVs16),
     /*  76229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  76231 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  76233 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76235 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76240 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76246 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76252 */     GIR_RootConstrainSelectedInstOperands,
     /*  76253 */     // GIR_Coverage, 3039,
     /*  76253 */     GIR_EraseRootFromParent_Done,
     /*  76254 */   // Label 1494: @76254
     /*  76254 */   GIM_Try, /*On fail goto*//*Label 1495*/ GIMT_Encode4(76330), // Rule ID 3041 //
     /*  76259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  76267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  76270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  76279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  76282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76286 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  76290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76302 */     // (intrinsic_wo_chain:{ *:[i32] } 3596:{ *:[iPTR] }, 0:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VABAVs32:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  76302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVs32),
     /*  76305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  76307 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  76309 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76311 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76316 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76322 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76328 */     GIR_RootConstrainSelectedInstOperands,
     /*  76329 */     // GIR_Coverage, 3041,
     /*  76329 */     GIR_EraseRootFromParent_Done,
     /*  76330 */   // Label 1495: @76330
     /*  76330 */   GIM_Try, /*On fail goto*//*Label 1496*/ GIMT_Encode4(76406), // Rule ID 3043 //
     /*  76335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  76343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  76346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  76355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v16s8,
     /*  76358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76362 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  76366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76378 */     // (intrinsic_wo_chain:{ *:[i32] } 3596:{ *:[iPTR] }, 1:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VABAVu8:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  76378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVu8),
     /*  76381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  76383 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  76385 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76387 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76392 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76398 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76404 */     GIR_RootConstrainSelectedInstOperands,
     /*  76405 */     // GIR_Coverage, 3043,
     /*  76405 */     GIR_EraseRootFromParent_Done,
     /*  76406 */   // Label 1496: @76406
     /*  76406 */   GIM_Try, /*On fail goto*//*Label 1497*/ GIMT_Encode4(76482), // Rule ID 3045 //
     /*  76411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  76419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  76422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  76431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  76434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76438 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  76442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76454 */     // (intrinsic_wo_chain:{ *:[i32] } 3596:{ *:[iPTR] }, 1:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VABAVu16:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  76454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVu16),
     /*  76457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  76459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  76461 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76463 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76468 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76474 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76480 */     GIR_RootConstrainSelectedInstOperands,
     /*  76481 */     // GIR_Coverage, 3045,
     /*  76481 */     GIR_EraseRootFromParent_Done,
     /*  76482 */   // Label 1497: @76482
     /*  76482 */   GIM_Try, /*On fail goto*//*Label 1498*/ GIMT_Encode4(76558), // Rule ID 3047 //
     /*  76487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  76495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  76498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  76507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  76510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76514 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  76518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76530 */     // (intrinsic_wo_chain:{ *:[i32] } 3596:{ *:[iPTR] }, 1:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VABAVu32:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  76530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVu32),
     /*  76533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  76535 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  76537 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76539 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76544 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76550 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76556 */     GIR_RootConstrainSelectedInstOperands,
     /*  76557 */     // GIR_Coverage, 3047,
     /*  76557 */     GIR_EraseRootFromParent_Done,
     /*  76558 */   // Label 1498: @76558
     /*  76558 */   GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(76643), // Rule ID 3996 //
     /*  76563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  76566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcmlaq),
     /*  76571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  76574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  76580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  76583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  76586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  76598 */     // MIs[1] Operand 1
     /*  76598 */     // No operand predicates
     /*  76598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76610 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76612 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3606:{ *:[iPTR] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm)  =>  (MVE_VCMLAf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  76612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMLAf16),
     /*  76615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  76617 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qd_src
     /*  76619 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76621 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76623 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  76626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76629 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76635 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76641 */     GIR_RootConstrainSelectedInstOperands,
     /*  76642 */     // GIR_Coverage, 3996,
     /*  76642 */     GIR_EraseRootFromParent_Done,
     /*  76643 */   // Label 1499: @76643
     /*  76643 */   GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(76728), // Rule ID 3999 //
     /*  76648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  76651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcmlaq),
     /*  76656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  76659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  76665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  76668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  76671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  76683 */     // MIs[1] Operand 1
     /*  76683 */     // No operand predicates
     /*  76683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76691 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76697 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3606:{ *:[iPTR] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v4f32] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm)  =>  (MVE_VCMLAf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  76697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMLAf32),
     /*  76700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  76702 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qd_src
     /*  76704 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76706 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76708 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  76711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76714 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76720 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76726 */     GIR_RootConstrainSelectedInstOperands,
     /*  76727 */     // GIR_Coverage, 3999,
     /*  76727 */     GIR_EraseRootFromParent_Done,
     /*  76728 */   // Label 1500: @76728
     /*  76728 */   GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(76824), // Rule ID 2688 //
     /*  76733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  76736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbx2),
     /*  76741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  76744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  76747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  76750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  76753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s8,
     /*  76756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  76760 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3859:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$orig, v8i8:{ *:[v8i8] }:$Vn0, v8i8:{ *:[v8i8] }:$Vn1, v8i8:{ *:[v8i8] }:$Vm)  =>  (VTBX2:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$orig, (REG_SEQUENCE:{ *:[v16i8] } DPair:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn0, dsub_0:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn1, dsub_1:{ *:[i32] }), v8i8:{ *:[v8i8] }:$Vm)
     /*  76760 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  76763 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  76767 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76772 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Vn0
     /*  76776 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  76779 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // Vn1
     /*  76783 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  76786 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPairRegClassID),
     /*  76791 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  76796 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  76801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBX2),
     /*  76804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76806 */     GIR_RootToRootCopy, /*OpIdx*/2, // orig
     /*  76808 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76811 */     GIR_RootToRootCopy, /*OpIdx*/5, // Vm
     /*  76813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  76816 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76822 */     GIR_RootConstrainSelectedInstOperands,
     /*  76823 */     // GIR_Coverage, 2688,
     /*  76823 */     GIR_EraseRootFromParent_Done,
     /*  76824 */   // Label 1501: @76824
     /*  76824 */   GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(76955), // Rule ID 2689 //
     /*  76829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  76832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbl3),
     /*  76837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  76840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  76843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  76846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  76849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s8,
     /*  76852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  76856 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3856:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Vn0, v8i8:{ *:[v8i8] }:$Vn1, v8i8:{ *:[v8i8] }:$Vn2, v8i8:{ *:[v8i8] }:$Vm)  =>  (VTBL3Pseudo:{ *:[v8i8] } (REG_SEQUENCE:{ *:[v4i64] } QQPR:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn0, dsub_0:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn1, dsub_1:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn2, dsub_2:{ *:[i32] }, (IMPLICIT_DEF:{ *:[v8i8] }), dsub_3:{ *:[i32] }), v8i8:{ *:[v8i8] }:$Vm)
     /*  76856 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s8,
     /*  76859 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  76863 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76868 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  76870 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /*  76873 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  76877 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76882 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Vn0
     /*  76886 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  76889 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Vn1
     /*  76893 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  76896 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // Vn2
     /*  76900 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /*  76903 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  76906 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /*  76909 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::QQPRRegClassID),
     /*  76914 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  76919 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  76924 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/5, GIMT_Encode2(ARM::DPRRegClassID),
     /*  76929 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/7, GIMT_Encode2(ARM::DPRRegClassID),
     /*  76934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBL3Pseudo),
     /*  76937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  76939 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76942 */     GIR_RootToRootCopy, /*OpIdx*/5, // Vm
     /*  76944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  76947 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76953 */     GIR_RootConstrainSelectedInstOperands,
     /*  76954 */     // GIR_Coverage, 2689,
     /*  76954 */     GIR_EraseRootFromParent_Done,
     /*  76955 */   // Label 1502: @76955
     /*  76955 */   GIM_Reject,
     /*  76956 */ // Label 1464: @76956
     /*  76956 */ GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(82262),
     /*  76961 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/7,
     /*  76964 */   GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(77057), // Rule ID 3838 //
     /*  76969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  76974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  76977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  76983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  76989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  76992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77004 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  77008 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77012 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77016 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3700:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_by_vecs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  77016 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77019 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77023 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecs8),
     /*  77031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77033 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77035 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77040 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77046 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77052 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77055 */     GIR_RootConstrainSelectedInstOperands,
     /*  77056 */     // GIR_Coverage, 3838,
     /*  77056 */     GIR_EraseRootFromParent_Done,
     /*  77057 */   // Label 1504: @77057
     /*  77057 */   GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(77150), // Rule ID 3840 //
     /*  77062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  77070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  77073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  77076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77097 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  77101 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77105 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77109 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3700:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_by_vecs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  77109 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77112 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77116 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecs16),
     /*  77124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77126 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77128 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77133 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77139 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77148 */     GIR_RootConstrainSelectedInstOperands,
     /*  77149 */     // GIR_Coverage, 3840,
     /*  77149 */     GIR_EraseRootFromParent_Done,
     /*  77150 */   // Label 1505: @77150
     /*  77150 */   GIM_Try, /*On fail goto*//*Label 1506*/ GIMT_Encode4(77243), // Rule ID 3842 //
     /*  77155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  77163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  77166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  77169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77190 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  77194 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77198 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77202 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3700:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_by_vecs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  77202 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77205 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77209 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecs32),
     /*  77217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77219 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77221 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77226 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77232 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77238 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77241 */     GIR_RootConstrainSelectedInstOperands,
     /*  77242 */     // GIR_Coverage, 3842,
     /*  77242 */     GIR_EraseRootFromParent_Done,
     /*  77243 */   // Label 1506: @77243
     /*  77243 */   GIM_Try, /*On fail goto*//*Label 1507*/ GIMT_Encode4(77336), // Rule ID 3844 //
     /*  77248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  77256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77283 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  77287 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77291 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  77295 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3700:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_by_vecu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  77295 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77298 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77302 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecu8),
     /*  77310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77312 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77314 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77319 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77325 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77331 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77334 */     GIR_RootConstrainSelectedInstOperands,
     /*  77335 */     // GIR_Coverage, 3844,
     /*  77335 */     GIR_EraseRootFromParent_Done,
     /*  77336 */   // Label 1507: @77336
     /*  77336 */   GIM_Try, /*On fail goto*//*Label 1508*/ GIMT_Encode4(77429), // Rule ID 3846 //
     /*  77341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  77349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  77352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  77355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77376 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  77380 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77384 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  77388 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3700:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_by_vecu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  77388 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77391 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77395 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecu16),
     /*  77403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77405 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77407 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77412 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77418 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77424 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77427 */     GIR_RootConstrainSelectedInstOperands,
     /*  77428 */     // GIR_Coverage, 3846,
     /*  77428 */     GIR_EraseRootFromParent_Done,
     /*  77429 */   // Label 1508: @77429
     /*  77429 */   GIM_Try, /*On fail goto*//*Label 1509*/ GIMT_Encode4(77522), // Rule ID 3848 //
     /*  77434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  77442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  77445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  77448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77469 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  77473 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77477 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  77481 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3700:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_by_vecu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  77481 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77484 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77488 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecu32),
     /*  77496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77498 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77500 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77505 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77511 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77517 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77520 */     GIR_RootConstrainSelectedInstOperands,
     /*  77521 */     // GIR_Coverage, 3848,
     /*  77521 */     GIR_EraseRootFromParent_Done,
     /*  77522 */   // Label 1509: @77522
     /*  77522 */   GIM_Try, /*On fail goto*//*Label 1510*/ GIMT_Encode4(77615), // Rule ID 3850 //
     /*  77527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  77535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77562 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77566 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77570 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77574 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3700:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_by_vecs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  77574 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77577 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77581 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecs8),
     /*  77589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77591 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77593 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77598 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77604 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77610 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77613 */     GIR_RootConstrainSelectedInstOperands,
     /*  77614 */     // GIR_Coverage, 3850,
     /*  77614 */     GIR_EraseRootFromParent_Done,
     /*  77615 */   // Label 1510: @77615
     /*  77615 */   GIM_Try, /*On fail goto*//*Label 1511*/ GIMT_Encode4(77708), // Rule ID 3852 //
     /*  77620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  77628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  77631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  77634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77655 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77659 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77663 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77667 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3700:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_by_vecs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  77667 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77670 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77674 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecs16),
     /*  77682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77684 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77686 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77691 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77697 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77703 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77706 */     GIR_RootConstrainSelectedInstOperands,
     /*  77707 */     // GIR_Coverage, 3852,
     /*  77707 */     GIR_EraseRootFromParent_Done,
     /*  77708 */   // Label 1511: @77708
     /*  77708 */   GIM_Try, /*On fail goto*//*Label 1512*/ GIMT_Encode4(77801), // Rule ID 3854 //
     /*  77713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  77721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  77724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  77727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77748 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77752 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77756 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77760 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3700:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_by_vecs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  77760 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77763 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77767 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecs32),
     /*  77775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77777 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77779 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77784 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77790 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77796 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77799 */     GIR_RootConstrainSelectedInstOperands,
     /*  77800 */     // GIR_Coverage, 3854,
     /*  77800 */     GIR_EraseRootFromParent_Done,
     /*  77801 */   // Label 1512: @77801
     /*  77801 */   GIM_Try, /*On fail goto*//*Label 1513*/ GIMT_Encode4(77894), // Rule ID 3856 //
     /*  77806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  77814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77841 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77845 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77849 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  77853 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3700:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_by_vecu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  77853 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77856 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77860 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecu8),
     /*  77868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77870 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77872 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77877 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77883 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77889 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77892 */     GIR_RootConstrainSelectedInstOperands,
     /*  77893 */     // GIR_Coverage, 3856,
     /*  77893 */     GIR_EraseRootFromParent_Done,
     /*  77894 */   // Label 1513: @77894
     /*  77894 */   GIM_Try, /*On fail goto*//*Label 1514*/ GIMT_Encode4(77987), // Rule ID 3858 //
     /*  77899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  77907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  77910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  77913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77934 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77938 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77942 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  77946 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3700:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_by_vecu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  77946 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77949 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77953 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecu16),
     /*  77961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77963 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77965 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77970 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77976 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77982 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77985 */     GIR_RootConstrainSelectedInstOperands,
     /*  77986 */     // GIR_Coverage, 3858,
     /*  77986 */     GIR_EraseRootFromParent_Done,
     /*  77987 */   // Label 1514: @77987
     /*  77987 */   GIM_Try, /*On fail goto*//*Label 1515*/ GIMT_Encode4(78080), // Rule ID 3860 //
     /*  77992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  78000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  78003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  78006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78027 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78031 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  78035 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  78039 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3700:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_by_vecu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  78039 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78042 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78046 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecu32),
     /*  78054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78056 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78058 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78063 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78069 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78075 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78078 */     GIR_RootConstrainSelectedInstOperands,
     /*  78079 */     // GIR_Coverage, 3860,
     /*  78079 */     GIR_EraseRootFromParent_Done,
     /*  78080 */   // Label 1515: @78080
     /*  78080 */   GIM_Try, /*On fail goto*//*Label 1516*/ GIMT_Encode4(78173), // Rule ID 3862 //
     /*  78085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  78093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  78096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78120 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78124 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78128 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  78132 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3700:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  78132 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78135 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78139 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecs8),
     /*  78147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78149 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78151 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78156 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78162 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78168 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78171 */     GIR_RootConstrainSelectedInstOperands,
     /*  78172 */     // GIR_Coverage, 3862,
     /*  78172 */     GIR_EraseRootFromParent_Done,
     /*  78173 */   // Label 1516: @78173
     /*  78173 */   GIM_Try, /*On fail goto*//*Label 1517*/ GIMT_Encode4(78266), // Rule ID 3864 //
     /*  78178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  78186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  78189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  78192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78213 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78217 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78221 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  78225 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3700:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  78225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecs16),
     /*  78240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78242 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78244 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78249 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78255 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78261 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78264 */     GIR_RootConstrainSelectedInstOperands,
     /*  78265 */     // GIR_Coverage, 3864,
     /*  78265 */     GIR_EraseRootFromParent_Done,
     /*  78266 */   // Label 1517: @78266
     /*  78266 */   GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(78359), // Rule ID 3866 //
     /*  78271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  78279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  78282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  78285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78306 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78310 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78314 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  78318 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3700:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  78318 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78321 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78325 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecs32),
     /*  78333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78335 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78337 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78342 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78348 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78354 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78357 */     GIR_RootConstrainSelectedInstOperands,
     /*  78358 */     // GIR_Coverage, 3866,
     /*  78358 */     GIR_EraseRootFromParent_Done,
     /*  78359 */   // Label 1518: @78359
     /*  78359 */   GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(78452), // Rule ID 3868 //
     /*  78364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  78372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  78375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78399 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78403 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78407 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  78411 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3700:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  78411 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78414 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78418 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecu8),
     /*  78426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78428 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78430 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78435 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78441 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78447 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78450 */     GIR_RootConstrainSelectedInstOperands,
     /*  78451 */     // GIR_Coverage, 3868,
     /*  78451 */     GIR_EraseRootFromParent_Done,
     /*  78452 */   // Label 1519: @78452
     /*  78452 */   GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(78545), // Rule ID 3870 //
     /*  78457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  78465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  78468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  78471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78492 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78496 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78500 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  78504 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3700:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  78504 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78507 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78511 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecu16),
     /*  78519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78521 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78523 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78528 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78534 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78540 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78543 */     GIR_RootConstrainSelectedInstOperands,
     /*  78544 */     // GIR_Coverage, 3870,
     /*  78544 */     GIR_EraseRootFromParent_Done,
     /*  78545 */   // Label 1520: @78545
     /*  78545 */   GIM_Try, /*On fail goto*//*Label 1521*/ GIMT_Encode4(78638), // Rule ID 3872 //
     /*  78550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  78558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  78561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  78564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78585 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78589 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78593 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  78597 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3700:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  78597 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78600 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78604 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecu32),
     /*  78612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78614 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78616 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78621 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78627 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78633 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78636 */     GIR_RootConstrainSelectedInstOperands,
     /*  78637 */     // GIR_Coverage, 3872,
     /*  78637 */     GIR_EraseRootFromParent_Done,
     /*  78638 */   // Label 1521: @78638
     /*  78638 */   GIM_Try, /*On fail goto*//*Label 1522*/ GIMT_Encode4(78731), // Rule ID 3874 //
     /*  78643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  78651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  78654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78678 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  78682 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78686 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  78690 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3700:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_by_vecs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  78690 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78693 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78697 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecs8),
     /*  78705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78707 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78709 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78714 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78720 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78729 */     GIR_RootConstrainSelectedInstOperands,
     /*  78730 */     // GIR_Coverage, 3874,
     /*  78730 */     GIR_EraseRootFromParent_Done,
     /*  78731 */   // Label 1522: @78731
     /*  78731 */   GIM_Try, /*On fail goto*//*Label 1523*/ GIMT_Encode4(78824), // Rule ID 3876 //
     /*  78736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  78744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  78747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  78750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78771 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  78775 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78779 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  78783 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3700:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_by_vecs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  78783 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78786 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78790 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecs16),
     /*  78798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78800 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78802 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78807 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78813 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78819 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78822 */     GIR_RootConstrainSelectedInstOperands,
     /*  78823 */     // GIR_Coverage, 3876,
     /*  78823 */     GIR_EraseRootFromParent_Done,
     /*  78824 */   // Label 1523: @78824
     /*  78824 */   GIM_Try, /*On fail goto*//*Label 1524*/ GIMT_Encode4(78917), // Rule ID 3878 //
     /*  78829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  78837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  78840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  78843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78864 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  78868 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78872 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  78876 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3700:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_by_vecs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  78876 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78879 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78883 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecs32),
     /*  78891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78893 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78895 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78900 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78906 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78912 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78915 */     GIR_RootConstrainSelectedInstOperands,
     /*  78916 */     // GIR_Coverage, 3878,
     /*  78916 */     GIR_EraseRootFromParent_Done,
     /*  78917 */   // Label 1524: @78917
     /*  78917 */   GIM_Try, /*On fail goto*//*Label 1525*/ GIMT_Encode4(79010), // Rule ID 3880 //
     /*  78922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  78930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  78933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78957 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  78961 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78965 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  78969 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3700:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_by_vecu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  78969 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78972 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78976 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecu8),
     /*  78984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78986 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78988 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78993 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78999 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79005 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79008 */     GIR_RootConstrainSelectedInstOperands,
     /*  79009 */     // GIR_Coverage, 3880,
     /*  79009 */     GIR_EraseRootFromParent_Done,
     /*  79010 */   // Label 1525: @79010
     /*  79010 */   GIM_Try, /*On fail goto*//*Label 1526*/ GIMT_Encode4(79103), // Rule ID 3882 //
     /*  79015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  79020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  79029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79050 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79054 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79058 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79062 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3700:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_by_vecu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  79062 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79065 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79069 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecu16),
     /*  79077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79079 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  79081 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  79083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79086 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79092 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79098 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79101 */     GIR_RootConstrainSelectedInstOperands,
     /*  79102 */     // GIR_Coverage, 3882,
     /*  79102 */     GIR_EraseRootFromParent_Done,
     /*  79103 */   // Label 1526: @79103
     /*  79103 */   GIM_Try, /*On fail goto*//*Label 1527*/ GIMT_Encode4(79196), // Rule ID 3884 //
     /*  79108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  79113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  79116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  79119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79143 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79147 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79151 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79155 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3700:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_by_vecu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  79155 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79158 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79162 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecu32),
     /*  79170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79172 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  79174 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  79176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79179 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79185 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79191 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79194 */     GIR_RootConstrainSelectedInstOperands,
     /*  79195 */     // GIR_Coverage, 3884,
     /*  79195 */     GIR_EraseRootFromParent_Done,
     /*  79196 */   // Label 1527: @79196
     /*  79196 */   GIM_Try, /*On fail goto*//*Label 1528*/ GIMT_Encode4(79274), // Rule ID 4489 //
     /*  79201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79236 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79240 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79244 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  79248 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3671:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVNs32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  79248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNs32bh),
     /*  79251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79255 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79260 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79266 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79272 */     GIR_RootConstrainSelectedInstOperands,
     /*  79273 */     // GIR_Coverage, 4489,
     /*  79273 */     GIR_EraseRootFromParent_Done,
     /*  79274 */   // Label 1528: @79274
     /*  79274 */   GIM_Try, /*On fail goto*//*Label 1529*/ GIMT_Encode4(79352), // Rule ID 4491 //
     /*  79279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79314 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79318 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79322 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79326 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3671:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVNs32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  79326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNs32th),
     /*  79329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79333 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79338 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79344 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79350 */     GIR_RootConstrainSelectedInstOperands,
     /*  79351 */     // GIR_Coverage, 4491,
     /*  79351 */     GIR_EraseRootFromParent_Done,
     /*  79352 */   // Label 1529: @79352
     /*  79352 */   GIM_Try, /*On fail goto*//*Label 1530*/ GIMT_Encode4(79430), // Rule ID 4493 //
     /*  79357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  79365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  79368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  79371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79392 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79396 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79400 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  79404 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3671:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVNs16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  79404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNs16bh),
     /*  79407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79411 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79416 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79422 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79428 */     GIR_RootConstrainSelectedInstOperands,
     /*  79429 */     // GIR_Coverage, 4493,
     /*  79429 */     GIR_EraseRootFromParent_Done,
     /*  79430 */   // Label 1530: @79430
     /*  79430 */   GIM_Try, /*On fail goto*//*Label 1531*/ GIMT_Encode4(79508), // Rule ID 4495 //
     /*  79435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  79443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  79446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  79449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79470 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79474 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79478 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79482 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3671:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVNs16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  79482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNs16th),
     /*  79485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79489 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79494 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79500 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79506 */     GIR_RootConstrainSelectedInstOperands,
     /*  79507 */     // GIR_Coverage, 4495,
     /*  79507 */     GIR_EraseRootFromParent_Done,
     /*  79508 */   // Label 1531: @79508
     /*  79508 */   GIM_Try, /*On fail goto*//*Label 1532*/ GIMT_Encode4(79586), // Rule ID 4497 //
     /*  79513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79548 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79552 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79556 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  79560 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3671:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVNu32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  79560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNu32bh),
     /*  79563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79565 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79567 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79572 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79578 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79584 */     GIR_RootConstrainSelectedInstOperands,
     /*  79585 */     // GIR_Coverage, 4497,
     /*  79585 */     GIR_EraseRootFromParent_Done,
     /*  79586 */   // Label 1532: @79586
     /*  79586 */   GIM_Try, /*On fail goto*//*Label 1533*/ GIMT_Encode4(79664), // Rule ID 4499 //
     /*  79591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79626 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79630 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79634 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79638 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3671:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVNu32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  79638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNu32th),
     /*  79641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79650 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79656 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79662 */     GIR_RootConstrainSelectedInstOperands,
     /*  79663 */     // GIR_Coverage, 4499,
     /*  79663 */     GIR_EraseRootFromParent_Done,
     /*  79664 */   // Label 1533: @79664
     /*  79664 */   GIM_Try, /*On fail goto*//*Label 1534*/ GIMT_Encode4(79742), // Rule ID 4501 //
     /*  79669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  79677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  79680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  79683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79704 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79708 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79712 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  79716 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3671:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVNu16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  79716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNu16bh),
     /*  79719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79723 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79728 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79734 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79740 */     GIR_RootConstrainSelectedInstOperands,
     /*  79741 */     // GIR_Coverage, 4501,
     /*  79741 */     GIR_EraseRootFromParent_Done,
     /*  79742 */   // Label 1534: @79742
     /*  79742 */   GIM_Try, /*On fail goto*//*Label 1535*/ GIMT_Encode4(79820), // Rule ID 4503 //
     /*  79747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  79755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  79758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  79761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79782 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79786 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79790 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79794 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3671:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVNu16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  79794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNu16th),
     /*  79797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79801 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79806 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79812 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79818 */     GIR_RootConstrainSelectedInstOperands,
     /*  79819 */     // GIR_Coverage, 4503,
     /*  79819 */     GIR_EraseRootFromParent_Done,
     /*  79820 */   // Label 1535: @79820
     /*  79820 */   GIM_Try, /*On fail goto*//*Label 1536*/ GIMT_Encode4(79898), // Rule ID 4505 //
     /*  79825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79860 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79864 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79868 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  79872 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3671:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVUNs32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  79872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVUNs32bh),
     /*  79875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79879 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79884 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79890 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79896 */     GIR_RootConstrainSelectedInstOperands,
     /*  79897 */     // GIR_Coverage, 4505,
     /*  79897 */     GIR_EraseRootFromParent_Done,
     /*  79898 */   // Label 1536: @79898
     /*  79898 */   GIM_Try, /*On fail goto*//*Label 1537*/ GIMT_Encode4(79976), // Rule ID 4507 //
     /*  79903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79938 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79942 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79946 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79950 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3671:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVUNs32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  79950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVUNs32th),
     /*  79953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79957 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79962 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79968 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79974 */     GIR_RootConstrainSelectedInstOperands,
     /*  79975 */     // GIR_Coverage, 4507,
     /*  79975 */     GIR_EraseRootFromParent_Done,
     /*  79976 */   // Label 1537: @79976
     /*  79976 */   GIM_Try, /*On fail goto*//*Label 1538*/ GIMT_Encode4(80054), // Rule ID 4509 //
     /*  79981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  79989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  79992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  79995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80016 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  80020 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80024 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80028 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3671:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVUNs16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  80028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVUNs16bh),
     /*  80031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  80035 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  80037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80040 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80046 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80052 */     GIR_RootConstrainSelectedInstOperands,
     /*  80053 */     // GIR_Coverage, 4509,
     /*  80053 */     GIR_EraseRootFromParent_Done,
     /*  80054 */   // Label 1538: @80054
     /*  80054 */   GIM_Try, /*On fail goto*//*Label 1539*/ GIMT_Encode4(80132), // Rule ID 4511 //
     /*  80059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  80064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  80067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  80070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  80073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80094 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  80098 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80102 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80106 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3671:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVUNs16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  80106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVUNs16th),
     /*  80109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  80113 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  80115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80118 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80124 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80130 */     GIR_RootConstrainSelectedInstOperands,
     /*  80131 */     // GIR_Coverage, 4511,
     /*  80131 */     GIR_EraseRootFromParent_Done,
     /*  80132 */   // Label 1539: @80132
     /*  80132 */   GIM_Try, /*On fail goto*//*Label 1540*/ GIMT_Encode4(80210), // Rule ID 4701 //
     /*  80137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  80145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  80148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80172 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80176 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80180 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80184 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3698:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qrs8),
     /*  80187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80189 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80191 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80196 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80202 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80208 */     GIR_RootConstrainSelectedInstOperands,
     /*  80209 */     // GIR_Coverage, 4701,
     /*  80209 */     GIR_EraseRootFromParent_Done,
     /*  80210 */   // Label 1540: @80210
     /*  80210 */   GIM_Try, /*On fail goto*//*Label 1541*/ GIMT_Encode4(80288), // Rule ID 4703 //
     /*  80215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  80223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  80226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80250 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80254 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80258 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80262 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3698:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qrs16),
     /*  80265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80267 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80269 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80274 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80280 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80286 */     GIR_RootConstrainSelectedInstOperands,
     /*  80287 */     // GIR_Coverage, 4703,
     /*  80287 */     GIR_EraseRootFromParent_Done,
     /*  80288 */   // Label 1541: @80288
     /*  80288 */   GIM_Try, /*On fail goto*//*Label 1542*/ GIMT_Encode4(80366), // Rule ID 4705 //
     /*  80293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  80301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  80304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80328 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80332 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80336 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80340 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3698:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qrs32),
     /*  80343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80345 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80347 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80352 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80358 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80364 */     GIR_RootConstrainSelectedInstOperands,
     /*  80365 */     // GIR_Coverage, 4705,
     /*  80365 */     GIR_EraseRootFromParent_Done,
     /*  80366 */   // Label 1542: @80366
     /*  80366 */   GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(80444), // Rule ID 4707 //
     /*  80371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  80379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  80382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80406 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80410 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80414 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80418 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3698:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_qru8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qru8),
     /*  80421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80423 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80425 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80430 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80436 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80442 */     GIR_RootConstrainSelectedInstOperands,
     /*  80443 */     // GIR_Coverage, 4707,
     /*  80443 */     GIR_EraseRootFromParent_Done,
     /*  80444 */   // Label 1543: @80444
     /*  80444 */   GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(80522), // Rule ID 4709 //
     /*  80449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  80457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  80460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80484 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80488 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80492 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80496 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3698:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_qru16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qru16),
     /*  80499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80501 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80503 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80508 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80514 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80520 */     GIR_RootConstrainSelectedInstOperands,
     /*  80521 */     // GIR_Coverage, 4709,
     /*  80521 */     GIR_EraseRootFromParent_Done,
     /*  80522 */   // Label 1544: @80522
     /*  80522 */   GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(80600), // Rule ID 4711 //
     /*  80527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  80535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  80538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80562 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80566 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80570 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80574 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3698:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_qru32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qru32),
     /*  80577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80579 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80581 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80586 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80592 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80598 */     GIR_RootConstrainSelectedInstOperands,
     /*  80599 */     // GIR_Coverage, 4711,
     /*  80599 */     GIR_EraseRootFromParent_Done,
     /*  80600 */   // Label 1545: @80600
     /*  80600 */   GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(80678), // Rule ID 4713 //
     /*  80605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  80613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  80616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80640 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80644 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  80648 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80652 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3698:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qrs8),
     /*  80655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80657 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80659 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80664 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80670 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80676 */     GIR_RootConstrainSelectedInstOperands,
     /*  80677 */     // GIR_Coverage, 4713,
     /*  80677 */     GIR_EraseRootFromParent_Done,
     /*  80678 */   // Label 1546: @80678
     /*  80678 */   GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(80756), // Rule ID 4715 //
     /*  80683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  80691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  80694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80718 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80722 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  80726 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80730 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3698:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qrs16),
     /*  80733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80735 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80737 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80742 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80748 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80754 */     GIR_RootConstrainSelectedInstOperands,
     /*  80755 */     // GIR_Coverage, 4715,
     /*  80755 */     GIR_EraseRootFromParent_Done,
     /*  80756 */   // Label 1547: @80756
     /*  80756 */   GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(80834), // Rule ID 4717 //
     /*  80761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  80769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  80772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80796 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80800 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  80804 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80808 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3698:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qrs32),
     /*  80811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80813 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80815 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80820 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80826 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80832 */     GIR_RootConstrainSelectedInstOperands,
     /*  80833 */     // GIR_Coverage, 4717,
     /*  80833 */     GIR_EraseRootFromParent_Done,
     /*  80834 */   // Label 1548: @80834
     /*  80834 */   GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(80912), // Rule ID 4719 //
     /*  80839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  80847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  80850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80874 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80878 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  80882 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80886 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3698:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_qru8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qru8),
     /*  80889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80891 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80893 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80898 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80904 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80910 */     GIR_RootConstrainSelectedInstOperands,
     /*  80911 */     // GIR_Coverage, 4719,
     /*  80911 */     GIR_EraseRootFromParent_Done,
     /*  80912 */   // Label 1549: @80912
     /*  80912 */   GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(80990), // Rule ID 4721 //
     /*  80917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  80925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  80928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80952 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80956 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  80960 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80964 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3698:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_qru16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qru16),
     /*  80967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80969 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80971 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80976 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80982 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80988 */     GIR_RootConstrainSelectedInstOperands,
     /*  80989 */     // GIR_Coverage, 4721,
     /*  80989 */     GIR_EraseRootFromParent_Done,
     /*  80990 */   // Label 1550: @80990
     /*  80990 */   GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(81068), // Rule ID 4723 //
     /*  80995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  81003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  81006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81030 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  81034 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81038 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81042 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3698:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_qru32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qru32),
     /*  81045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81047 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81049 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81054 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81060 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81066 */     GIR_RootConstrainSelectedInstOperands,
     /*  81067 */     // GIR_Coverage, 4723,
     /*  81067 */     GIR_EraseRootFromParent_Done,
     /*  81068 */   // Label 1551: @81068
     /*  81068 */   GIM_Try, /*On fail goto*//*Label 1552*/ GIMT_Encode4(81146), // Rule ID 4725 //
     /*  81073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  81081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  81084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81108 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81112 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  81116 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  81120 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3698:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qrs8),
     /*  81123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81125 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81127 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81132 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81138 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81144 */     GIR_RootConstrainSelectedInstOperands,
     /*  81145 */     // GIR_Coverage, 4725,
     /*  81145 */     GIR_EraseRootFromParent_Done,
     /*  81146 */   // Label 1552: @81146
     /*  81146 */   GIM_Try, /*On fail goto*//*Label 1553*/ GIMT_Encode4(81224), // Rule ID 4727 //
     /*  81151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  81159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  81162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81186 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81190 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  81194 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  81198 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3698:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qrs16),
     /*  81201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81203 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81205 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81210 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81216 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81222 */     GIR_RootConstrainSelectedInstOperands,
     /*  81223 */     // GIR_Coverage, 4727,
     /*  81223 */     GIR_EraseRootFromParent_Done,
     /*  81224 */   // Label 1553: @81224
     /*  81224 */   GIM_Try, /*On fail goto*//*Label 1554*/ GIMT_Encode4(81302), // Rule ID 4729 //
     /*  81229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  81237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  81240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81264 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81268 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  81272 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  81276 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3698:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qrs32),
     /*  81279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81281 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81283 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81288 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81294 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81300 */     GIR_RootConstrainSelectedInstOperands,
     /*  81301 */     // GIR_Coverage, 4729,
     /*  81301 */     GIR_EraseRootFromParent_Done,
     /*  81302 */   // Label 1554: @81302
     /*  81302 */   GIM_Try, /*On fail goto*//*Label 1555*/ GIMT_Encode4(81380), // Rule ID 4731 //
     /*  81307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  81315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  81318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81342 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81346 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  81350 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81354 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3698:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_qru8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qru8),
     /*  81357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81359 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81361 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81366 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81372 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81378 */     GIR_RootConstrainSelectedInstOperands,
     /*  81379 */     // GIR_Coverage, 4731,
     /*  81379 */     GIR_EraseRootFromParent_Done,
     /*  81380 */   // Label 1555: @81380
     /*  81380 */   GIM_Try, /*On fail goto*//*Label 1556*/ GIMT_Encode4(81458), // Rule ID 4733 //
     /*  81385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  81393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  81396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81420 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81424 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  81428 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81432 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3698:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_qru16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qru16),
     /*  81435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81437 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81439 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81444 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81450 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81456 */     GIR_RootConstrainSelectedInstOperands,
     /*  81457 */     // GIR_Coverage, 4733,
     /*  81457 */     GIR_EraseRootFromParent_Done,
     /*  81458 */   // Label 1556: @81458
     /*  81458 */   GIM_Try, /*On fail goto*//*Label 1557*/ GIMT_Encode4(81536), // Rule ID 4735 //
     /*  81463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  81471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  81474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81498 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81502 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  81506 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81510 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3698:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_qru32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qru32),
     /*  81513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81515 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81517 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81522 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81528 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81534 */     GIR_RootConstrainSelectedInstOperands,
     /*  81535 */     // GIR_Coverage, 4735,
     /*  81535 */     GIR_EraseRootFromParent_Done,
     /*  81536 */   // Label 1557: @81536
     /*  81536 */   GIM_Try, /*On fail goto*//*Label 1558*/ GIMT_Encode4(81614), // Rule ID 4737 //
     /*  81541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  81549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  81552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81576 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81580 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81584 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  81588 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3698:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qrs8),
     /*  81591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81593 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81595 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81600 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81606 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81612 */     GIR_RootConstrainSelectedInstOperands,
     /*  81613 */     // GIR_Coverage, 4737,
     /*  81613 */     GIR_EraseRootFromParent_Done,
     /*  81614 */   // Label 1558: @81614
     /*  81614 */   GIM_Try, /*On fail goto*//*Label 1559*/ GIMT_Encode4(81692), // Rule ID 4739 //
     /*  81619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  81627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  81630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81654 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81658 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81662 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  81666 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3698:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qrs16),
     /*  81669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81671 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81673 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81678 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81684 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81690 */     GIR_RootConstrainSelectedInstOperands,
     /*  81691 */     // GIR_Coverage, 4739,
     /*  81691 */     GIR_EraseRootFromParent_Done,
     /*  81692 */   // Label 1559: @81692
     /*  81692 */   GIM_Try, /*On fail goto*//*Label 1560*/ GIMT_Encode4(81770), // Rule ID 4741 //
     /*  81697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  81705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  81708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81732 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81736 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81740 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  81744 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3698:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qrs32),
     /*  81747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81749 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81751 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81756 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81762 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81768 */     GIR_RootConstrainSelectedInstOperands,
     /*  81769 */     // GIR_Coverage, 4741,
     /*  81769 */     GIR_EraseRootFromParent_Done,
     /*  81770 */   // Label 1560: @81770
     /*  81770 */   GIM_Try, /*On fail goto*//*Label 1561*/ GIMT_Encode4(81848), // Rule ID 4743 //
     /*  81775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  81783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  81786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81810 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81814 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81818 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81822 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3698:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_qru8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qru8),
     /*  81825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81827 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81829 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81834 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81840 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81846 */     GIR_RootConstrainSelectedInstOperands,
     /*  81847 */     // GIR_Coverage, 4743,
     /*  81847 */     GIR_EraseRootFromParent_Done,
     /*  81848 */   // Label 1561: @81848
     /*  81848 */   GIM_Try, /*On fail goto*//*Label 1562*/ GIMT_Encode4(81926), // Rule ID 4745 //
     /*  81853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  81861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  81864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81888 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81892 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81896 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81900 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3698:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_qru16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qru16),
     /*  81903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81905 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81907 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81912 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81918 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81924 */     GIR_RootConstrainSelectedInstOperands,
     /*  81925 */     // GIR_Coverage, 4745,
     /*  81925 */     GIR_EraseRootFromParent_Done,
     /*  81926 */   // Label 1562: @81926
     /*  81926 */   GIM_Try, /*On fail goto*//*Label 1563*/ GIMT_Encode4(82004), // Rule ID 4747 //
     /*  81931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  81939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  81942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81966 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81970 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81974 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81978 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3698:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_qru32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qru32),
     /*  81981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81983 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81985 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81990 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81996 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82002 */     GIR_RootConstrainSelectedInstOperands,
     /*  82003 */     // GIR_Coverage, 4747,
     /*  82003 */     GIR_EraseRootFromParent_Done,
     /*  82004 */   // Label 1563: @82004
     /*  82004 */   GIM_Try, /*On fail goto*//*Label 1564*/ GIMT_Encode4(82140), // Rule ID 2690 //
     /*  82009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  82012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbx3),
     /*  82017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  82020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  82023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  82026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  82029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s8,
     /*  82032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s8,
     /*  82035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  82039 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3860:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$orig, v8i8:{ *:[v8i8] }:$Vn0, v8i8:{ *:[v8i8] }:$Vn1, v8i8:{ *:[v8i8] }:$Vn2, v8i8:{ *:[v8i8] }:$Vm)  =>  (VTBX3Pseudo:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$orig, (REG_SEQUENCE:{ *:[v4i64] } QQPR:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn0, dsub_0:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn1, dsub_1:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn2, dsub_2:{ *:[i32] }, (IMPLICIT_DEF:{ *:[v8i8] }), dsub_3:{ *:[i32] }), v8i8:{ *:[v8i8] }:$Vm)
     /*  82039 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s8,
     /*  82042 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82046 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82051 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82053 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /*  82056 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  82060 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82065 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Vn0
     /*  82069 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  82072 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // Vn1
     /*  82076 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  82079 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // Vn2
     /*  82083 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /*  82086 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82089 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /*  82092 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::QQPRRegClassID),
     /*  82097 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82102 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82107 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/5, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82112 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/7, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBX3Pseudo),
     /*  82120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82122 */     GIR_RootToRootCopy, /*OpIdx*/2, // orig
     /*  82124 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82127 */     GIR_RootToRootCopy, /*OpIdx*/6, // Vm
     /*  82129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  82132 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82138 */     GIR_RootConstrainSelectedInstOperands,
     /*  82139 */     // GIR_Coverage, 2690,
     /*  82139 */     GIR_EraseRootFromParent_Done,
     /*  82140 */   // Label 1564: @82140
     /*  82140 */   GIM_Try, /*On fail goto*//*Label 1565*/ GIMT_Encode4(82261), // Rule ID 2691 //
     /*  82145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  82148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbl4),
     /*  82153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  82156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  82159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  82162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  82165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s8,
     /*  82168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s8,
     /*  82171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  82175 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3857:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Vn0, v8i8:{ *:[v8i8] }:$Vn1, v8i8:{ *:[v8i8] }:$Vn2, v8i8:{ *:[v8i8] }:$Vn3, v8i8:{ *:[v8i8] }:$Vm)  =>  (VTBL4Pseudo:{ *:[v8i8] } (REG_SEQUENCE:{ *:[v4i64] } QQPR:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn0, dsub_0:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn1, dsub_1:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn2, dsub_2:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn3, dsub_3:{ *:[i32] }), v8i8:{ *:[v8i8] }:$Vm)
     /*  82175 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /*  82178 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  82182 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82187 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Vn0
     /*  82191 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  82194 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Vn1
     /*  82198 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  82201 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // Vn2
     /*  82205 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /*  82208 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // Vn3
     /*  82212 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /*  82215 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::QQPRRegClassID),
     /*  82220 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82225 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82230 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/5, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82235 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/7, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBL4Pseudo),
     /*  82243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82245 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82248 */     GIR_RootToRootCopy, /*OpIdx*/6, // Vm
     /*  82250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  82253 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82259 */     GIR_RootConstrainSelectedInstOperands,
     /*  82260 */     // GIR_Coverage, 2691,
     /*  82260 */     GIR_EraseRootFromParent_Done,
     /*  82261 */   // Label 1565: @82261
     /*  82261 */   GIM_Reject,
     /*  82262 */ // Label 1503: @82262
     /*  82262 */ GIM_Try, /*On fail goto*//*Label 1566*/ GIMT_Encode4(87155),
     /*  82267 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/8,
     /*  82270 */   GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(82358), // Rule ID 3181 //
     /*  82275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  82301 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  82304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82308 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82312 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82316 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82320 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82324 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82328 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82332 */     // (intrinsic_wo_chain:{ *:[i32] } 3653:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVs8:{ *:[i32] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  82332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVs8),
     /*  82335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82337 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82339 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82344 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82350 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82356 */     GIR_RootConstrainSelectedInstOperands,
     /*  82357 */     // GIR_Coverage, 3181,
     /*  82357 */     GIR_EraseRootFromParent_Done,
     /*  82358 */   // Label 1567: @82358
     /*  82358 */   GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(82446), // Rule ID 3185 //
     /*  82363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  82389 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  82392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82396 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82400 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82404 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  82408 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82412 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82416 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82420 */     // (intrinsic_wo_chain:{ *:[i32] } 3653:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVxs8:{ *:[i32] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  82420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVxs8),
     /*  82423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82425 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82427 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82432 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82438 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82444 */     GIR_RootConstrainSelectedInstOperands,
     /*  82445 */     // GIR_Coverage, 3185,
     /*  82445 */     GIR_EraseRootFromParent_Done,
     /*  82446 */   // Label 1568: @82446
     /*  82446 */   GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(82534), // Rule ID 3189 //
     /*  82451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  82477 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  82480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82484 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  82488 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82492 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82496 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82500 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82504 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82508 */     // (intrinsic_wo_chain:{ *:[i32] } 3653:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVu8:{ *:[i32] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  82508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu8),
     /*  82511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82513 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82515 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82520 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82526 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82532 */     GIR_RootConstrainSelectedInstOperands,
     /*  82533 */     // GIR_Coverage, 3189,
     /*  82533 */     GIR_EraseRootFromParent_Done,
     /*  82534 */   // Label 1569: @82534
     /*  82534 */   GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(82622), // Rule ID 3193 //
     /*  82539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  82565 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  82568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82572 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82576 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82580 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82584 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82588 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82592 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82596 */     // (intrinsic_wo_chain:{ *:[i32] } 3653:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVs16:{ *:[i32] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  82596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVs16),
     /*  82599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82601 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82603 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82608 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82614 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82620 */     GIR_RootConstrainSelectedInstOperands,
     /*  82621 */     // GIR_Coverage, 3193,
     /*  82621 */     GIR_EraseRootFromParent_Done,
     /*  82622 */   // Label 1570: @82622
     /*  82622 */   GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(82710), // Rule ID 3197 //
     /*  82627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  82653 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  82656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82660 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82664 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82668 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  82672 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82676 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82680 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82684 */     // (intrinsic_wo_chain:{ *:[i32] } 3653:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVxs16:{ *:[i32] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  82684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVxs16),
     /*  82687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82689 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82691 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82696 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82702 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82708 */     GIR_RootConstrainSelectedInstOperands,
     /*  82709 */     // GIR_Coverage, 3197,
     /*  82709 */     GIR_EraseRootFromParent_Done,
     /*  82710 */   // Label 1571: @82710
     /*  82710 */   GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(82798), // Rule ID 3201 //
     /*  82715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  82741 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  82744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82748 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  82752 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82756 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82760 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82764 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82768 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82772 */     // (intrinsic_wo_chain:{ *:[i32] } 3653:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVu16:{ *:[i32] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  82772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu16),
     /*  82775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82777 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82779 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82784 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82790 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82796 */     GIR_RootConstrainSelectedInstOperands,
     /*  82797 */     // GIR_Coverage, 3201,
     /*  82797 */     GIR_EraseRootFromParent_Done,
     /*  82798 */   // Label 1572: @82798
     /*  82798 */   GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(82886), // Rule ID 3205 //
     /*  82803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  82829 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  82832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82836 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82840 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82844 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82848 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82852 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82856 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82860 */     // (intrinsic_wo_chain:{ *:[i32] } 3653:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVs32:{ *:[i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  82860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVs32),
     /*  82863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82865 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82867 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82872 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82878 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82884 */     GIR_RootConstrainSelectedInstOperands,
     /*  82885 */     // GIR_Coverage, 3205,
     /*  82885 */     GIR_EraseRootFromParent_Done,
     /*  82886 */   // Label 1573: @82886
     /*  82886 */   GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(82974), // Rule ID 3209 //
     /*  82891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  82917 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  82920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82924 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82928 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82932 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  82936 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82940 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82944 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82948 */     // (intrinsic_wo_chain:{ *:[i32] } 3653:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVxs32:{ *:[i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  82948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVxs32),
     /*  82951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82953 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82955 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82960 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82966 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82972 */     GIR_RootConstrainSelectedInstOperands,
     /*  82973 */     // GIR_Coverage, 3209,
     /*  82973 */     GIR_EraseRootFromParent_Done,
     /*  82974 */   // Label 1574: @82974
     /*  82974 */   GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(83062), // Rule ID 3213 //
     /*  82979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  83005 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  83008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83012 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  83016 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83020 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83024 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83028 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83032 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83036 */     // (intrinsic_wo_chain:{ *:[i32] } 3653:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVu32:{ *:[i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  83036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu32),
     /*  83039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83041 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83043 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83048 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83054 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83060 */     GIR_RootConstrainSelectedInstOperands,
     /*  83061 */     // GIR_Coverage, 3213,
     /*  83061 */     GIR_EraseRootFromParent_Done,
     /*  83062 */   // Label 1575: @83062
     /*  83062 */   GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(83150), // Rule ID 3217 //
     /*  83067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  83093 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  83096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83100 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83104 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  83108 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83112 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83116 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83120 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83124 */     // (intrinsic_wo_chain:{ *:[i32] } 3653:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLSDAVs8:{ *:[i32] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  83124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVs8),
     /*  83127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83129 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83131 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83136 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83142 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83148 */     GIR_RootConstrainSelectedInstOperands,
     /*  83149 */     // GIR_Coverage, 3217,
     /*  83149 */     GIR_EraseRootFromParent_Done,
     /*  83150 */   // Label 1576: @83150
     /*  83150 */   GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(83238), // Rule ID 3221 //
     /*  83155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  83181 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  83184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83188 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83192 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  83196 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  83200 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83204 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83208 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83212 */     // (intrinsic_wo_chain:{ *:[i32] } 3653:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLSDAVxs8:{ *:[i32] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  83212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVxs8),
     /*  83215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83217 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83219 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83224 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83230 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83236 */     GIR_RootConstrainSelectedInstOperands,
     /*  83237 */     // GIR_Coverage, 3221,
     /*  83237 */     GIR_EraseRootFromParent_Done,
     /*  83238 */   // Label 1577: @83238
     /*  83238 */   GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(83326), // Rule ID 3225 //
     /*  83243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  83269 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  83272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83276 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83280 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  83284 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83288 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83292 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83296 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83300 */     // (intrinsic_wo_chain:{ *:[i32] } 3653:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLSDAVs16:{ *:[i32] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  83300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVs16),
     /*  83303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83305 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83307 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83312 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83318 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83324 */     GIR_RootConstrainSelectedInstOperands,
     /*  83325 */     // GIR_Coverage, 3225,
     /*  83325 */     GIR_EraseRootFromParent_Done,
     /*  83326 */   // Label 1578: @83326
     /*  83326 */   GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(83414), // Rule ID 3229 //
     /*  83331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  83357 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  83360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83364 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83368 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  83372 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  83376 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83380 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83384 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83388 */     // (intrinsic_wo_chain:{ *:[i32] } 3653:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLSDAVxs16:{ *:[i32] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  83388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVxs16),
     /*  83391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83393 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83395 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83400 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83406 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83412 */     GIR_RootConstrainSelectedInstOperands,
     /*  83413 */     // GIR_Coverage, 3229,
     /*  83413 */     GIR_EraseRootFromParent_Done,
     /*  83414 */   // Label 1579: @83414
     /*  83414 */   GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(83502), // Rule ID 3233 //
     /*  83419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  83445 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  83448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83452 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83456 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  83460 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83464 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83468 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83472 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83476 */     // (intrinsic_wo_chain:{ *:[i32] } 3653:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLSDAVs32:{ *:[i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  83476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVs32),
     /*  83479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83481 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83483 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83488 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83494 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83500 */     GIR_RootConstrainSelectedInstOperands,
     /*  83501 */     // GIR_Coverage, 3233,
     /*  83501 */     GIR_EraseRootFromParent_Done,
     /*  83502 */   // Label 1580: @83502
     /*  83502 */   GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(83590), // Rule ID 3237 //
     /*  83507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  83533 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  83536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83540 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83544 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  83548 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  83552 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83556 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83560 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83564 */     // (intrinsic_wo_chain:{ *:[i32] } 3653:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLSDAVxs32:{ *:[i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  83564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVxs32),
     /*  83567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83569 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83571 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83576 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83582 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83588 */     GIR_RootConstrainSelectedInstOperands,
     /*  83589 */     // GIR_Coverage, 3237,
     /*  83589 */     GIR_EraseRootFromParent_Done,
     /*  83590 */   // Label 1581: @83590
     /*  83590 */   GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(83680), // Rule ID 3183 //
     /*  83595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  83621 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  83624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83628 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83632 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83636 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83644 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83648 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83652 */     // (intrinsic_wo_chain:{ *:[i32] } 3653:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVas8:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  83652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVas8),
     /*  83655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83657 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  83659 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83661 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83666 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83672 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83678 */     GIR_RootConstrainSelectedInstOperands,
     /*  83679 */     // GIR_Coverage, 3183,
     /*  83679 */     GIR_EraseRootFromParent_Done,
     /*  83680 */   // Label 1582: @83680
     /*  83680 */   GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(83770), // Rule ID 3187 //
     /*  83685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  83711 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  83714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83718 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83722 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83726 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  83730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83734 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83738 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83742 */     // (intrinsic_wo_chain:{ *:[i32] } 3653:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVaxs8:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  83742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVaxs8),
     /*  83745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83747 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  83749 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83751 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83756 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83762 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83768 */     GIR_RootConstrainSelectedInstOperands,
     /*  83769 */     // GIR_Coverage, 3187,
     /*  83769 */     GIR_EraseRootFromParent_Done,
     /*  83770 */   // Label 1583: @83770
     /*  83770 */   GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(83860), // Rule ID 3191 //
     /*  83775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  83801 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  83804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83808 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  83812 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83816 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83824 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83828 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83832 */     // (intrinsic_wo_chain:{ *:[i32] } 3653:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVau8:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  83832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau8),
     /*  83835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83837 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  83839 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83841 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83846 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83852 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83858 */     GIR_RootConstrainSelectedInstOperands,
     /*  83859 */     // GIR_Coverage, 3191,
     /*  83859 */     GIR_EraseRootFromParent_Done,
     /*  83860 */   // Label 1584: @83860
     /*  83860 */   GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(83950), // Rule ID 3195 //
     /*  83865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  83891 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  83894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83898 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83902 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83906 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83914 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83918 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83922 */     // (intrinsic_wo_chain:{ *:[i32] } 3653:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVas16:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  83922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVas16),
     /*  83925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83927 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  83929 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83931 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83936 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83942 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83948 */     GIR_RootConstrainSelectedInstOperands,
     /*  83949 */     // GIR_Coverage, 3195,
     /*  83949 */     GIR_EraseRootFromParent_Done,
     /*  83950 */   // Label 1585: @83950
     /*  83950 */   GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(84040), // Rule ID 3199 //
     /*  83955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  83981 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  83984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83988 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83992 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83996 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  84000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84004 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84008 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84012 */     // (intrinsic_wo_chain:{ *:[i32] } 3653:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVaxs16:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  84012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVaxs16),
     /*  84015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84017 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84019 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84021 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84026 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84032 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84038 */     GIR_RootConstrainSelectedInstOperands,
     /*  84039 */     // GIR_Coverage, 3199,
     /*  84039 */     GIR_EraseRootFromParent_Done,
     /*  84040 */   // Label 1586: @84040
     /*  84040 */   GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(84130), // Rule ID 3203 //
     /*  84045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84068 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  84071 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  84074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84078 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  84082 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  84086 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  84090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84094 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84098 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84102 */     // (intrinsic_wo_chain:{ *:[i32] } 3653:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVau16:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  84102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau16),
     /*  84105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84107 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84109 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84111 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84116 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84122 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84128 */     GIR_RootConstrainSelectedInstOperands,
     /*  84129 */     // GIR_Coverage, 3203,
     /*  84129 */     GIR_EraseRootFromParent_Done,
     /*  84130 */   // Label 1587: @84130
     /*  84130 */   GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(84220), // Rule ID 3207 //
     /*  84135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  84161 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  84164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84168 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84172 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  84176 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  84180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84184 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84188 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84192 */     // (intrinsic_wo_chain:{ *:[i32] } 3653:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVas32:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  84192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVas32),
     /*  84195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84197 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84199 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84201 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84206 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84212 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84218 */     GIR_RootConstrainSelectedInstOperands,
     /*  84219 */     // GIR_Coverage, 3207,
     /*  84219 */     GIR_EraseRootFromParent_Done,
     /*  84220 */   // Label 1588: @84220
     /*  84220 */   GIM_Try, /*On fail goto*//*Label 1589*/ GIMT_Encode4(84310), // Rule ID 3211 //
     /*  84225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  84251 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  84254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84258 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84262 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  84266 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  84270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84274 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84278 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84282 */     // (intrinsic_wo_chain:{ *:[i32] } 3653:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVaxs32:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  84282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVaxs32),
     /*  84285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84287 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84289 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84291 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84296 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84302 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84308 */     GIR_RootConstrainSelectedInstOperands,
     /*  84309 */     // GIR_Coverage, 3211,
     /*  84309 */     GIR_EraseRootFromParent_Done,
     /*  84310 */   // Label 1589: @84310
     /*  84310 */   GIM_Try, /*On fail goto*//*Label 1590*/ GIMT_Encode4(84400), // Rule ID 3215 //
     /*  84315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  84341 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  84344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84348 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  84352 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  84356 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  84360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84364 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84368 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84372 */     // (intrinsic_wo_chain:{ *:[i32] } 3653:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVau32:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  84372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau32),
     /*  84375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84377 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84379 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84381 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84386 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84392 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84398 */     GIR_RootConstrainSelectedInstOperands,
     /*  84399 */     // GIR_Coverage, 3215,
     /*  84399 */     GIR_EraseRootFromParent_Done,
     /*  84400 */   // Label 1590: @84400
     /*  84400 */   GIM_Try, /*On fail goto*//*Label 1591*/ GIMT_Encode4(84490), // Rule ID 3219 //
     /*  84405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  84431 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  84434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84438 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84442 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84446 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  84450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84454 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84458 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84462 */     // (intrinsic_wo_chain:{ *:[i32] } 3653:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLSDAVas8:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  84462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVas8),
     /*  84465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84467 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84469 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84471 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84476 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84482 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84488 */     GIR_RootConstrainSelectedInstOperands,
     /*  84489 */     // GIR_Coverage, 3219,
     /*  84489 */     GIR_EraseRootFromParent_Done,
     /*  84490 */   // Label 1591: @84490
     /*  84490 */   GIM_Try, /*On fail goto*//*Label 1592*/ GIMT_Encode4(84580), // Rule ID 3223 //
     /*  84495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  84521 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  84524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84528 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84532 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84536 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  84540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84544 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84548 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84552 */     // (intrinsic_wo_chain:{ *:[i32] } 3653:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLSDAVaxs8:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  84552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVaxs8),
     /*  84555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84557 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84559 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84561 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84566 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84572 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84578 */     GIR_RootConstrainSelectedInstOperands,
     /*  84579 */     // GIR_Coverage, 3223,
     /*  84579 */     GIR_EraseRootFromParent_Done,
     /*  84580 */   // Label 1592: @84580
     /*  84580 */   GIM_Try, /*On fail goto*//*Label 1593*/ GIMT_Encode4(84670), // Rule ID 3227 //
     /*  84585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  84611 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  84614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84618 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84622 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84626 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  84630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84634 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84638 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84642 */     // (intrinsic_wo_chain:{ *:[i32] } 3653:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLSDAVas16:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  84642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVas16),
     /*  84645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84647 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84649 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84651 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84656 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84662 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84668 */     GIR_RootConstrainSelectedInstOperands,
     /*  84669 */     // GIR_Coverage, 3227,
     /*  84669 */     GIR_EraseRootFromParent_Done,
     /*  84670 */   // Label 1593: @84670
     /*  84670 */   GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(84760), // Rule ID 3231 //
     /*  84675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  84701 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  84704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84708 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84712 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84716 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  84720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84724 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84728 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84732 */     // (intrinsic_wo_chain:{ *:[i32] } 3653:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLSDAVaxs16:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  84732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVaxs16),
     /*  84735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84737 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84739 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84741 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84746 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84752 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84758 */     GIR_RootConstrainSelectedInstOperands,
     /*  84759 */     // GIR_Coverage, 3231,
     /*  84759 */     GIR_EraseRootFromParent_Done,
     /*  84760 */   // Label 1594: @84760
     /*  84760 */   GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(84850), // Rule ID 3235 //
     /*  84765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  84791 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  84794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84798 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84802 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84806 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  84810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84814 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84818 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84822 */     // (intrinsic_wo_chain:{ *:[i32] } 3653:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLSDAVas32:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  84822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVas32),
     /*  84825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84827 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84829 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84831 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84836 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84842 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84848 */     GIR_RootConstrainSelectedInstOperands,
     /*  84849 */     // GIR_Coverage, 3235,
     /*  84849 */     GIR_EraseRootFromParent_Done,
     /*  84850 */   // Label 1595: @84850
     /*  84850 */   GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(84940), // Rule ID 3239 //
     /*  84855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  84881 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  84884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84888 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84892 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84896 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  84900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84904 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84908 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84912 */     // (intrinsic_wo_chain:{ *:[i32] } 3653:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLSDAVaxs32:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  84912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVaxs32),
     /*  84915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84917 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84919 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84921 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84926 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84932 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84938 */     GIR_RootConstrainSelectedInstOperands,
     /*  84939 */     // GIR_Coverage, 3239,
     /*  84939 */     GIR_EraseRootFromParent_Done,
     /*  84940 */   // Label 1596: @84940
     /*  84940 */   GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(85027), // Rule ID 4335 //
     /*  84945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  84950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  84953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  84956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  84959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  84962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  84968 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  84971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84987 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  84991 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  84995 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  84999 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3662:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  84999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHs8),
     /*  85002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85004 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85006 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85008 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85013 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85019 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85025 */     GIR_RootConstrainSelectedInstOperands,
     /*  85026 */     // GIR_Coverage, 4335,
     /*  85026 */     GIR_EraseRootFromParent_Done,
     /*  85027 */   // Label 1597: @85027
     /*  85027 */   GIM_Try, /*On fail goto*//*Label 1598*/ GIMT_Encode4(85114), // Rule ID 4337 //
     /*  85032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  85040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  85046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  85049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85055 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85074 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85078 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85082 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85086 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3662:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  85086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHs16),
     /*  85089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85091 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85093 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85095 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85100 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85106 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85112 */     GIR_RootConstrainSelectedInstOperands,
     /*  85113 */     // GIR_Coverage, 4337,
     /*  85113 */     GIR_EraseRootFromParent_Done,
     /*  85114 */   // Label 1598: @85114
     /*  85114 */   GIM_Try, /*On fail goto*//*Label 1599*/ GIMT_Encode4(85201), // Rule ID 4339 //
     /*  85119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  85127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  85130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  85133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  85136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85142 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85161 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85165 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85169 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85173 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3662:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  85173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHs32),
     /*  85176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85178 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85180 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85182 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85187 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85193 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85199 */     GIR_RootConstrainSelectedInstOperands,
     /*  85200 */     // GIR_Coverage, 4339,
     /*  85200 */     GIR_EraseRootFromParent_Done,
     /*  85201 */   // Label 1599: @85201
     /*  85201 */   GIM_Try, /*On fail goto*//*Label 1600*/ GIMT_Encode4(85288), // Rule ID 4341 //
     /*  85206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  85214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  85217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85229 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85248 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  85252 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85256 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85260 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3662:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHXs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  85260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHXs8),
     /*  85263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85265 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85267 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85269 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85274 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85280 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85286 */     GIR_RootConstrainSelectedInstOperands,
     /*  85287 */     // GIR_Coverage, 4341,
     /*  85287 */     GIR_EraseRootFromParent_Done,
     /*  85288 */   // Label 1600: @85288
     /*  85288 */   GIM_Try, /*On fail goto*//*Label 1601*/ GIMT_Encode4(85375), // Rule ID 4343 //
     /*  85293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  85301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  85307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  85310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85316 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85335 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  85339 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85343 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85347 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3662:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHXs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  85347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHXs16),
     /*  85350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85352 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85354 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85356 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85361 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85367 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85373 */     GIR_RootConstrainSelectedInstOperands,
     /*  85374 */     // GIR_Coverage, 4343,
     /*  85374 */     GIR_EraseRootFromParent_Done,
     /*  85375 */   // Label 1601: @85375
     /*  85375 */   GIM_Try, /*On fail goto*//*Label 1602*/ GIMT_Encode4(85462), // Rule ID 4345 //
     /*  85380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  85388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  85391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  85394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  85397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85403 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85422 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  85426 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85430 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85434 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3662:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHXs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  85434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHXs32),
     /*  85437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85439 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85441 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85443 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85448 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85454 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85460 */     GIR_RootConstrainSelectedInstOperands,
     /*  85461 */     // GIR_Coverage, 4345,
     /*  85461 */     GIR_EraseRootFromParent_Done,
     /*  85462 */   // Label 1602: @85462
     /*  85462 */   GIM_Try, /*On fail goto*//*Label 1603*/ GIMT_Encode4(85549), // Rule ID 4347 //
     /*  85467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  85475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  85478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85490 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85509 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85513 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85517 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85521 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3662:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  85521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHs8),
     /*  85524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85526 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85528 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85530 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85535 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85541 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85547 */     GIR_RootConstrainSelectedInstOperands,
     /*  85548 */     // GIR_Coverage, 4347,
     /*  85548 */     GIR_EraseRootFromParent_Done,
     /*  85549 */   // Label 1603: @85549
     /*  85549 */   GIM_Try, /*On fail goto*//*Label 1604*/ GIMT_Encode4(85636), // Rule ID 4349 //
     /*  85554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  85562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  85568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  85571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85577 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85596 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85600 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85604 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85608 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3662:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  85608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHs16),
     /*  85611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85613 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85615 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85617 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85622 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85628 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85634 */     GIR_RootConstrainSelectedInstOperands,
     /*  85635 */     // GIR_Coverage, 4349,
     /*  85635 */     GIR_EraseRootFromParent_Done,
     /*  85636 */   // Label 1604: @85636
     /*  85636 */   GIM_Try, /*On fail goto*//*Label 1605*/ GIMT_Encode4(85723), // Rule ID 4351 //
     /*  85641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  85649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  85652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  85655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  85658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85664 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85683 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85687 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85691 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85695 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3662:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  85695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHs32),
     /*  85698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85700 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85702 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85704 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85709 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85715 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85721 */     GIR_RootConstrainSelectedInstOperands,
     /*  85722 */     // GIR_Coverage, 4351,
     /*  85722 */     GIR_EraseRootFromParent_Done,
     /*  85723 */   // Label 1605: @85723
     /*  85723 */   GIM_Try, /*On fail goto*//*Label 1606*/ GIMT_Encode4(85810), // Rule ID 4353 //
     /*  85728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  85736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  85739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85751 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85770 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  85774 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85778 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85782 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3662:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHXs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  85782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHXs8),
     /*  85785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85787 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85789 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85791 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85796 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85802 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85808 */     GIR_RootConstrainSelectedInstOperands,
     /*  85809 */     // GIR_Coverage, 4353,
     /*  85809 */     GIR_EraseRootFromParent_Done,
     /*  85810 */   // Label 1606: @85810
     /*  85810 */   GIM_Try, /*On fail goto*//*Label 1607*/ GIMT_Encode4(85897), // Rule ID 4355 //
     /*  85815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  85823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  85829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  85832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85838 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85857 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  85861 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85865 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85869 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3662:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHXs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  85869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHXs16),
     /*  85872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85874 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85876 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85878 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85883 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85889 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85895 */     GIR_RootConstrainSelectedInstOperands,
     /*  85896 */     // GIR_Coverage, 4355,
     /*  85896 */     GIR_EraseRootFromParent_Done,
     /*  85897 */   // Label 1607: @85897
     /*  85897 */   GIM_Try, /*On fail goto*//*Label 1608*/ GIMT_Encode4(85984), // Rule ID 4357 //
     /*  85902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  85910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  85913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  85916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  85919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85925 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85944 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  85948 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85952 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85956 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3662:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHXs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  85956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHXs32),
     /*  85959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85961 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85963 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85965 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85970 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85976 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85982 */     GIR_RootConstrainSelectedInstOperands,
     /*  85983 */     // GIR_Coverage, 4357,
     /*  85983 */     GIR_EraseRootFromParent_Done,
     /*  85984 */   // Label 1608: @85984
     /*  85984 */   GIM_Try, /*On fail goto*//*Label 1609*/ GIMT_Encode4(86071), // Rule ID 4359 //
     /*  85989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  85997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  86000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  86003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86012 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86031 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86035 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  86039 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86043 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3662:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  86043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHs8),
     /*  86046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86048 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86050 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86052 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86057 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86063 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86069 */     GIR_RootConstrainSelectedInstOperands,
     /*  86070 */     // GIR_Coverage, 4359,
     /*  86070 */     GIR_EraseRootFromParent_Done,
     /*  86071 */   // Label 1609: @86071
     /*  86071 */   GIM_Try, /*On fail goto*//*Label 1610*/ GIMT_Encode4(86158), // Rule ID 4361 //
     /*  86076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  86084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  86093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86099 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86118 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86122 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  86126 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86130 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3662:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  86130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHs16),
     /*  86133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86135 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86137 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86139 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86144 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86150 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86156 */     GIR_RootConstrainSelectedInstOperands,
     /*  86157 */     // GIR_Coverage, 4361,
     /*  86157 */     GIR_EraseRootFromParent_Done,
     /*  86158 */   // Label 1610: @86158
     /*  86158 */   GIM_Try, /*On fail goto*//*Label 1611*/ GIMT_Encode4(86245), // Rule ID 4363 //
     /*  86163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  86171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  86174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  86177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  86180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86186 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86205 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86209 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  86213 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86217 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3662:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  86217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHs32),
     /*  86220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86222 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86224 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86226 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86231 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86237 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86243 */     GIR_RootConstrainSelectedInstOperands,
     /*  86244 */     // GIR_Coverage, 4363,
     /*  86244 */     GIR_EraseRootFromParent_Done,
     /*  86245 */   // Label 1611: @86245
     /*  86245 */   GIM_Try, /*On fail goto*//*Label 1612*/ GIMT_Encode4(86332), // Rule ID 4365 //
     /*  86250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  86258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  86261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  86264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86273 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86292 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  86296 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  86300 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86304 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3662:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHXs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  86304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHXs8),
     /*  86307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86309 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86311 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86313 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86318 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86324 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86330 */     GIR_RootConstrainSelectedInstOperands,
     /*  86331 */     // GIR_Coverage, 4365,
     /*  86331 */     GIR_EraseRootFromParent_Done,
     /*  86332 */   // Label 1612: @86332
     /*  86332 */   GIM_Try, /*On fail goto*//*Label 1613*/ GIMT_Encode4(86419), // Rule ID 4367 //
     /*  86337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  86345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  86354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86360 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86379 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  86383 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  86387 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86391 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3662:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHXs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  86391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHXs16),
     /*  86394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86396 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86398 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86400 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86405 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86411 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86417 */     GIR_RootConstrainSelectedInstOperands,
     /*  86418 */     // GIR_Coverage, 4367,
     /*  86418 */     GIR_EraseRootFromParent_Done,
     /*  86419 */   // Label 1613: @86419
     /*  86419 */   GIM_Try, /*On fail goto*//*Label 1614*/ GIMT_Encode4(86506), // Rule ID 4369 //
     /*  86424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  86432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  86435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  86438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  86441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86447 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86466 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  86470 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  86474 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86478 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3662:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHXs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  86478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHXs32),
     /*  86481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86483 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86485 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86487 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86492 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86498 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86504 */     GIR_RootConstrainSelectedInstOperands,
     /*  86505 */     // GIR_Coverage, 4369,
     /*  86505 */     GIR_EraseRootFromParent_Done,
     /*  86506 */   // Label 1614: @86506
     /*  86506 */   GIM_Try, /*On fail goto*//*Label 1615*/ GIMT_Encode4(86593), // Rule ID 4371 //
     /*  86511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  86519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  86522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  86525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86534 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86553 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86557 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86561 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86565 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3662:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  86565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHs8),
     /*  86568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86570 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86572 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86574 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86579 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86585 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86591 */     GIR_RootConstrainSelectedInstOperands,
     /*  86592 */     // GIR_Coverage, 4371,
     /*  86592 */     GIR_EraseRootFromParent_Done,
     /*  86593 */   // Label 1615: @86593
     /*  86593 */   GIM_Try, /*On fail goto*//*Label 1616*/ GIMT_Encode4(86680), // Rule ID 4373 //
     /*  86598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  86606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  86615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86621 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86640 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86644 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86648 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86652 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3662:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  86652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHs16),
     /*  86655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86657 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86659 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86661 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86666 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86672 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86678 */     GIR_RootConstrainSelectedInstOperands,
     /*  86679 */     // GIR_Coverage, 4373,
     /*  86679 */     GIR_EraseRootFromParent_Done,
     /*  86680 */   // Label 1616: @86680
     /*  86680 */   GIM_Try, /*On fail goto*//*Label 1617*/ GIMT_Encode4(86767), // Rule ID 4375 //
     /*  86685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  86693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  86696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  86699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  86702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86708 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86727 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86731 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86735 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86739 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3662:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  86739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHs32),
     /*  86742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86744 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86746 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86748 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86753 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86759 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86765 */     GIR_RootConstrainSelectedInstOperands,
     /*  86766 */     // GIR_Coverage, 4375,
     /*  86766 */     GIR_EraseRootFromParent_Done,
     /*  86767 */   // Label 1617: @86767
     /*  86767 */   GIM_Try, /*On fail goto*//*Label 1618*/ GIMT_Encode4(86854), // Rule ID 4377 //
     /*  86772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  86780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  86783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  86786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86795 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86814 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  86818 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86822 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86826 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3662:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHXs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  86826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHXs8),
     /*  86829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86831 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86833 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86835 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86840 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86846 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86852 */     GIR_RootConstrainSelectedInstOperands,
     /*  86853 */     // GIR_Coverage, 4377,
     /*  86853 */     GIR_EraseRootFromParent_Done,
     /*  86854 */   // Label 1618: @86854
     /*  86854 */   GIM_Try, /*On fail goto*//*Label 1619*/ GIMT_Encode4(86941), // Rule ID 4379 //
     /*  86859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  86867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  86876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86882 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86901 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  86905 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86909 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86913 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3662:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHXs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  86913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHXs16),
     /*  86916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86918 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86920 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86922 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86927 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86933 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86939 */     GIR_RootConstrainSelectedInstOperands,
     /*  86940 */     // GIR_Coverage, 4379,
     /*  86940 */     GIR_EraseRootFromParent_Done,
     /*  86941 */   // Label 1619: @86941
     /*  86941 */   GIM_Try, /*On fail goto*//*Label 1620*/ GIMT_Encode4(87028), // Rule ID 4381 //
     /*  86946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  86954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  86957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  86960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  86963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86969 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86988 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  86992 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86996 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  87000 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3662:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHXs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  87000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHXs32),
     /*  87003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87005 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  87007 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  87009 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  87011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87014 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87020 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87026 */     GIR_RootConstrainSelectedInstOperands,
     /*  87027 */     // GIR_Coverage, 4381,
     /*  87027 */     GIR_EraseRootFromParent_Done,
     /*  87028 */   // Label 1620: @87028
     /*  87028 */   GIM_Try, /*On fail goto*//*Label 1621*/ GIMT_Encode4(87154), // Rule ID 2692 //
     /*  87033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  87036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbx4),
     /*  87041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  87044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  87047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  87050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  87053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s8,
     /*  87056 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s8,
     /*  87059 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s8,
     /*  87062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  87066 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3861:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$orig, v8i8:{ *:[v8i8] }:$Vn0, v8i8:{ *:[v8i8] }:$Vn1, v8i8:{ *:[v8i8] }:$Vn2, v8i8:{ *:[v8i8] }:$Vn3, v8i8:{ *:[v8i8] }:$Vm)  =>  (VTBX4Pseudo:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$orig, (REG_SEQUENCE:{ *:[v4i64] } QQPR:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn0, dsub_0:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn1, dsub_1:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn2, dsub_2:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn3, dsub_3:{ *:[i32] }), v8i8:{ *:[v8i8] }:$Vm)
     /*  87066 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /*  87069 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  87073 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87078 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Vn0
     /*  87082 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  87085 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // Vn1
     /*  87089 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  87092 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // Vn2
     /*  87096 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /*  87099 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/6, // Vn3
     /*  87103 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /*  87106 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::QQPRRegClassID),
     /*  87111 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  87116 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  87121 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/5, GIMT_Encode2(ARM::DPRRegClassID),
     /*  87126 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/7, GIMT_Encode2(ARM::DPRRegClassID),
     /*  87131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBX4Pseudo),
     /*  87134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87136 */     GIR_RootToRootCopy, /*OpIdx*/2, // orig
     /*  87138 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87141 */     GIR_RootToRootCopy, /*OpIdx*/7, // Vm
     /*  87143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  87146 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87152 */     GIR_RootConstrainSelectedInstOperands,
     /*  87153 */     // GIR_Coverage, 2692,
     /*  87153 */     GIR_EraseRootFromParent_Done,
     /*  87154 */   // Label 1621: @87154
     /*  87154 */   GIM_Reject,
     /*  87155 */ // Label 1566: @87155
     /*  87155 */ GIM_Try, /*On fail goto*//*Label 1622*/ GIMT_Encode4(91449),
     /*  87160 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/10,
     /*  87163 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshrn),
     /*  87168 */   GIM_Try, /*On fail goto*//*Label 1623*/ GIMT_Encode4(87275), // Rule ID 3758 //
     /*  87173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  87176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  87182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87191 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87194 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87197 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87220 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  87224 */     // MIs[1] Operand 1
     /*  87224 */     // No operand predicates
     /*  87224 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87228 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87232 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  87236 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  87240 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  87244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87246 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3706:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHRNi16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi16bh),
     /*  87249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87251 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87253 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87255 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87261 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87267 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87273 */     GIR_RootConstrainSelectedInstOperands,
     /*  87274 */     // GIR_Coverage, 3758,
     /*  87274 */     GIR_EraseRootFromParent_Done,
     /*  87275 */   // Label 1623: @87275
     /*  87275 */   GIM_Try, /*On fail goto*//*Label 1624*/ GIMT_Encode4(87382), // Rule ID 3760 //
     /*  87280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  87283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  87289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87298 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87301 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87304 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87327 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  87331 */     // MIs[1] Operand 1
     /*  87331 */     // No operand predicates
     /*  87331 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87335 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87339 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  87343 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  87347 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  87351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87353 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3706:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHRNi16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi16th),
     /*  87356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87358 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87362 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87368 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87374 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87380 */     GIR_RootConstrainSelectedInstOperands,
     /*  87381 */     // GIR_Coverage, 3760,
     /*  87381 */     GIR_EraseRootFromParent_Done,
     /*  87382 */   // Label 1624: @87382
     /*  87382 */   GIM_Try, /*On fail goto*//*Label 1625*/ GIMT_Encode4(87489), // Rule ID 3762 //
     /*  87387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  87390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  87396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87405 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87408 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87411 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87434 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  87438 */     // MIs[1] Operand 1
     /*  87438 */     // No operand predicates
     /*  87438 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87442 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87446 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  87450 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  87454 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  87458 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87460 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3706:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHRNi32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi32bh),
     /*  87463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87465 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87467 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87469 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87475 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87481 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87487 */     GIR_RootConstrainSelectedInstOperands,
     /*  87488 */     // GIR_Coverage, 3762,
     /*  87488 */     GIR_EraseRootFromParent_Done,
     /*  87489 */   // Label 1625: @87489
     /*  87489 */   GIM_Try, /*On fail goto*//*Label 1626*/ GIMT_Encode4(87596), // Rule ID 3764 //
     /*  87494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  87497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  87503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87512 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87515 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87518 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87541 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  87545 */     // MIs[1] Operand 1
     /*  87545 */     // No operand predicates
     /*  87545 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87549 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87553 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  87557 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  87561 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  87565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87567 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3706:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHRNi32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi32th),
     /*  87570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87572 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87576 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87582 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87588 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87594 */     GIR_RootConstrainSelectedInstOperands,
     /*  87595 */     // GIR_Coverage, 3764,
     /*  87595 */     GIR_EraseRootFromParent_Done,
     /*  87596 */   // Label 1626: @87596
     /*  87596 */   GIM_Try, /*On fail goto*//*Label 1627*/ GIMT_Encode4(87703), // Rule ID 3766 //
     /*  87601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  87604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  87610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87619 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87622 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87625 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87648 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  87652 */     // MIs[1] Operand 1
     /*  87652 */     // No operand predicates
     /*  87652 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87656 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87660 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  87664 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  87668 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  87672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87674 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3706:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHRNi16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi16bh),
     /*  87677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87679 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87681 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87683 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87689 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87695 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87701 */     GIR_RootConstrainSelectedInstOperands,
     /*  87702 */     // GIR_Coverage, 3766,
     /*  87702 */     GIR_EraseRootFromParent_Done,
     /*  87703 */   // Label 1627: @87703
     /*  87703 */   GIM_Try, /*On fail goto*//*Label 1628*/ GIMT_Encode4(87810), // Rule ID 3768 //
     /*  87708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  87711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  87717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87726 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87729 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87732 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87755 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  87759 */     // MIs[1] Operand 1
     /*  87759 */     // No operand predicates
     /*  87759 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87763 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87767 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  87771 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  87775 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  87779 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87781 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3706:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHRNi16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi16th),
     /*  87784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87786 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87788 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87790 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87796 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87802 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87808 */     GIR_RootConstrainSelectedInstOperands,
     /*  87809 */     // GIR_Coverage, 3768,
     /*  87809 */     GIR_EraseRootFromParent_Done,
     /*  87810 */   // Label 1628: @87810
     /*  87810 */   GIM_Try, /*On fail goto*//*Label 1629*/ GIMT_Encode4(87917), // Rule ID 3770 //
     /*  87815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  87818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  87824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87833 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87836 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87839 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87862 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  87866 */     // MIs[1] Operand 1
     /*  87866 */     // No operand predicates
     /*  87866 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87870 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87874 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  87878 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  87882 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  87886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87888 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3706:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHRNi32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi32bh),
     /*  87891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87893 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87895 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87903 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87909 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87915 */     GIR_RootConstrainSelectedInstOperands,
     /*  87916 */     // GIR_Coverage, 3770,
     /*  87916 */     GIR_EraseRootFromParent_Done,
     /*  87917 */   // Label 1629: @87917
     /*  87917 */   GIM_Try, /*On fail goto*//*Label 1630*/ GIMT_Encode4(88024), // Rule ID 3772 //
     /*  87922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  87925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  87931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87940 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87943 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87946 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87969 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  87973 */     // MIs[1] Operand 1
     /*  87973 */     // No operand predicates
     /*  87973 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87977 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87981 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  87985 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  87989 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  87993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87995 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3706:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHRNi32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi32th),
     /*  87998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88000 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88002 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88004 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88010 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88016 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88022 */     GIR_RootConstrainSelectedInstOperands,
     /*  88023 */     // GIR_Coverage, 3772,
     /*  88023 */     GIR_EraseRootFromParent_Done,
     /*  88024 */   // Label 1630: @88024
     /*  88024 */   GIM_Try, /*On fail goto*//*Label 1631*/ GIMT_Encode4(88131), // Rule ID 3774 //
     /*  88029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  88032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  88038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88047 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88050 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88053 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88076 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  88080 */     // MIs[1] Operand 1
     /*  88080 */     // No operand predicates
     /*  88080 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88084 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88088 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  88092 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  88096 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  88100 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88102 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3706:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHRNi16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi16bh),
     /*  88105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88107 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88109 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88111 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88117 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88123 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88129 */     GIR_RootConstrainSelectedInstOperands,
     /*  88130 */     // GIR_Coverage, 3774,
     /*  88130 */     GIR_EraseRootFromParent_Done,
     /*  88131 */   // Label 1631: @88131
     /*  88131 */   GIM_Try, /*On fail goto*//*Label 1632*/ GIMT_Encode4(88238), // Rule ID 3776 //
     /*  88136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  88139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  88145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88154 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88157 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88160 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88183 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  88187 */     // MIs[1] Operand 1
     /*  88187 */     // No operand predicates
     /*  88187 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88191 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88195 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  88199 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  88203 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  88207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88209 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3706:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHRNi16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi16th),
     /*  88212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88214 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88216 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88218 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88224 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88230 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88236 */     GIR_RootConstrainSelectedInstOperands,
     /*  88237 */     // GIR_Coverage, 3776,
     /*  88237 */     GIR_EraseRootFromParent_Done,
     /*  88238 */   // Label 1632: @88238
     /*  88238 */   GIM_Try, /*On fail goto*//*Label 1633*/ GIMT_Encode4(88345), // Rule ID 3778 //
     /*  88243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  88252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88261 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88264 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88267 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88290 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  88294 */     // MIs[1] Operand 1
     /*  88294 */     // No operand predicates
     /*  88294 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88298 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88302 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  88306 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  88310 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  88314 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88316 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3706:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHRNi32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi32bh),
     /*  88319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88321 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88331 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88337 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88343 */     GIR_RootConstrainSelectedInstOperands,
     /*  88344 */     // GIR_Coverage, 3778,
     /*  88344 */     GIR_EraseRootFromParent_Done,
     /*  88345 */   // Label 1633: @88345
     /*  88345 */   GIM_Try, /*On fail goto*//*Label 1634*/ GIMT_Encode4(88452), // Rule ID 3780 //
     /*  88350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  88359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88368 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88371 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88374 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88397 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  88401 */     // MIs[1] Operand 1
     /*  88401 */     // No operand predicates
     /*  88401 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88405 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88409 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  88413 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  88417 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  88421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88423 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3706:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHRNi32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi32th),
     /*  88426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88428 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88432 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88438 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88444 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88450 */     GIR_RootConstrainSelectedInstOperands,
     /*  88451 */     // GIR_Coverage, 3780,
     /*  88451 */     GIR_EraseRootFromParent_Done,
     /*  88452 */   // Label 1634: @88452
     /*  88452 */   GIM_Try, /*On fail goto*//*Label 1635*/ GIMT_Encode4(88559), // Rule ID 3782 //
     /*  88457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  88460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  88466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88475 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88478 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88481 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88504 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  88508 */     // MIs[1] Operand 1
     /*  88508 */     // No operand predicates
     /*  88508 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88512 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88516 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  88520 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  88524 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  88528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88530 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3706:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHRNi16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi16bh),
     /*  88533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88535 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88545 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88551 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88557 */     GIR_RootConstrainSelectedInstOperands,
     /*  88558 */     // GIR_Coverage, 3782,
     /*  88558 */     GIR_EraseRootFromParent_Done,
     /*  88559 */   // Label 1635: @88559
     /*  88559 */   GIM_Try, /*On fail goto*//*Label 1636*/ GIMT_Encode4(88666), // Rule ID 3784 //
     /*  88564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  88567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  88573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88582 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88585 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88588 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88611 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  88615 */     // MIs[1] Operand 1
     /*  88615 */     // No operand predicates
     /*  88615 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88619 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88623 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  88627 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  88631 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  88635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88637 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3706:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHRNi16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi16th),
     /*  88640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88642 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88644 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88646 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88652 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88658 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88664 */     GIR_RootConstrainSelectedInstOperands,
     /*  88665 */     // GIR_Coverage, 3784,
     /*  88665 */     GIR_EraseRootFromParent_Done,
     /*  88666 */   // Label 1636: @88666
     /*  88666 */   GIM_Try, /*On fail goto*//*Label 1637*/ GIMT_Encode4(88773), // Rule ID 3786 //
     /*  88671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  88680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88689 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88692 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88695 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88718 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  88722 */     // MIs[1] Operand 1
     /*  88722 */     // No operand predicates
     /*  88722 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88726 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88730 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  88734 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  88738 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  88742 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88744 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3706:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHRNi32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi32bh),
     /*  88747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88749 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88751 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88753 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88759 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88765 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88771 */     GIR_RootConstrainSelectedInstOperands,
     /*  88772 */     // GIR_Coverage, 3786,
     /*  88772 */     GIR_EraseRootFromParent_Done,
     /*  88773 */   // Label 1637: @88773
     /*  88773 */   GIM_Try, /*On fail goto*//*Label 1638*/ GIMT_Encode4(88880), // Rule ID 3788 //
     /*  88778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  88787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88796 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88799 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88802 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88825 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  88829 */     // MIs[1] Operand 1
     /*  88829 */     // No operand predicates
     /*  88829 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88833 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88837 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  88841 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  88845 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  88849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88851 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3706:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHRNi32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi32th),
     /*  88854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88856 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88858 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88860 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88866 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88872 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88878 */     GIR_RootConstrainSelectedInstOperands,
     /*  88879 */     // GIR_Coverage, 3788,
     /*  88879 */     GIR_EraseRootFromParent_Done,
     /*  88880 */   // Label 1638: @88880
     /*  88880 */   GIM_Try, /*On fail goto*//*Label 1639*/ GIMT_Encode4(88987), // Rule ID 3790 //
     /*  88885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  88888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  88894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88903 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88906 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88909 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88932 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  88936 */     // MIs[1] Operand 1
     /*  88936 */     // No operand predicates
     /*  88936 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  88940 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  88944 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  88948 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  88952 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  88956 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88958 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3706:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRNbhs16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNbhs16),
     /*  88961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88963 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88965 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88967 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88973 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88979 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88985 */     GIR_RootConstrainSelectedInstOperands,
     /*  88986 */     // GIR_Coverage, 3790,
     /*  88986 */     GIR_EraseRootFromParent_Done,
     /*  88987 */   // Label 1639: @88987
     /*  88987 */   GIM_Try, /*On fail goto*//*Label 1640*/ GIMT_Encode4(89094), // Rule ID 3792 //
     /*  88992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  88995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89010 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89013 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89016 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89039 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  89043 */     // MIs[1] Operand 1
     /*  89043 */     // No operand predicates
     /*  89043 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89047 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89051 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  89055 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  89059 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  89063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89065 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3706:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRNths16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNths16),
     /*  89068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89070 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89072 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89074 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89080 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89086 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89092 */     GIR_RootConstrainSelectedInstOperands,
     /*  89093 */     // GIR_Coverage, 3792,
     /*  89093 */     GIR_EraseRootFromParent_Done,
     /*  89094 */   // Label 1640: @89094
     /*  89094 */   GIM_Try, /*On fail goto*//*Label 1641*/ GIMT_Encode4(89201), // Rule ID 3794 //
     /*  89099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89117 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89120 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89123 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89146 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  89150 */     // MIs[1] Operand 1
     /*  89150 */     // No operand predicates
     /*  89150 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89154 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89158 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  89162 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  89166 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  89170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89172 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3706:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRNbhs32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNbhs32),
     /*  89175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89177 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89179 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89187 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89193 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89199 */     GIR_RootConstrainSelectedInstOperands,
     /*  89200 */     // GIR_Coverage, 3794,
     /*  89200 */     GIR_EraseRootFromParent_Done,
     /*  89201 */   // Label 1641: @89201
     /*  89201 */   GIM_Try, /*On fail goto*//*Label 1642*/ GIMT_Encode4(89308), // Rule ID 3796 //
     /*  89206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89224 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89227 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89230 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89253 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  89257 */     // MIs[1] Operand 1
     /*  89257 */     // No operand predicates
     /*  89257 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89261 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89265 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  89269 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  89273 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  89277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89279 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3706:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRNths32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNths32),
     /*  89282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89284 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89288 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89294 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89300 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89306 */     GIR_RootConstrainSelectedInstOperands,
     /*  89307 */     // GIR_Coverage, 3796,
     /*  89307 */     GIR_EraseRootFromParent_Done,
     /*  89308 */   // Label 1642: @89308
     /*  89308 */   GIM_Try, /*On fail goto*//*Label 1643*/ GIMT_Encode4(89415), // Rule ID 3798 //
     /*  89313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  89316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  89319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89331 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89334 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89337 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89360 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  89364 */     // MIs[1] Operand 1
     /*  89364 */     // No operand predicates
     /*  89364 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89368 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89372 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  89376 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  89380 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  89384 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89386 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3706:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRNbhu16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNbhu16),
     /*  89389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89391 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89393 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89395 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89401 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89407 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89413 */     GIR_RootConstrainSelectedInstOperands,
     /*  89414 */     // GIR_Coverage, 3798,
     /*  89414 */     GIR_EraseRootFromParent_Done,
     /*  89415 */   // Label 1643: @89415
     /*  89415 */   GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(89522), // Rule ID 3800 //
     /*  89420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  89423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  89426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89438 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89441 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89444 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89467 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  89471 */     // MIs[1] Operand 1
     /*  89471 */     // No operand predicates
     /*  89471 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89475 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89479 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  89483 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  89487 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  89491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89493 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3706:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRNthu16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNthu16),
     /*  89496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89498 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89500 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89502 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89508 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89514 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89520 */     GIR_RootConstrainSelectedInstOperands,
     /*  89521 */     // GIR_Coverage, 3800,
     /*  89521 */     GIR_EraseRootFromParent_Done,
     /*  89522 */   // Label 1644: @89522
     /*  89522 */   GIM_Try, /*On fail goto*//*Label 1645*/ GIMT_Encode4(89629), // Rule ID 3802 //
     /*  89527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89545 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89548 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89551 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89574 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  89578 */     // MIs[1] Operand 1
     /*  89578 */     // No operand predicates
     /*  89578 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89582 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89586 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  89590 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  89594 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  89598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89600 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3706:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRNbhu32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNbhu32),
     /*  89603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89605 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89607 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89609 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89615 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89621 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89627 */     GIR_RootConstrainSelectedInstOperands,
     /*  89628 */     // GIR_Coverage, 3802,
     /*  89628 */     GIR_EraseRootFromParent_Done,
     /*  89629 */   // Label 1645: @89629
     /*  89629 */   GIM_Try, /*On fail goto*//*Label 1646*/ GIMT_Encode4(89736), // Rule ID 3804 //
     /*  89634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89652 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89655 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89658 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89681 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  89685 */     // MIs[1] Operand 1
     /*  89685 */     // No operand predicates
     /*  89685 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89689 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89693 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  89697 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  89701 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  89705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89707 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3706:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRNthu32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNthu32),
     /*  89710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89712 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89716 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89722 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89728 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89734 */     GIR_RootConstrainSelectedInstOperands,
     /*  89735 */     // GIR_Coverage, 3804,
     /*  89735 */     GIR_EraseRootFromParent_Done,
     /*  89736 */   // Label 1646: @89736
     /*  89736 */   GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(89843), // Rule ID 3806 //
     /*  89741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  89744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  89747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89759 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89762 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89765 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89788 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  89792 */     // MIs[1] Operand 1
     /*  89792 */     // No operand predicates
     /*  89792 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89796 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  89800 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  89804 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  89808 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  89812 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89814 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3706:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRNbhs16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNbhs16),
     /*  89817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89819 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89821 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89823 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89829 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89835 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89841 */     GIR_RootConstrainSelectedInstOperands,
     /*  89842 */     // GIR_Coverage, 3806,
     /*  89842 */     GIR_EraseRootFromParent_Done,
     /*  89843 */   // Label 1647: @89843
     /*  89843 */   GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(89950), // Rule ID 3808 //
     /*  89848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  89851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  89854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89866 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89869 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89872 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89895 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  89899 */     // MIs[1] Operand 1
     /*  89899 */     // No operand predicates
     /*  89899 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89903 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  89907 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  89911 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  89915 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  89919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89921 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3706:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRNths16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNths16),
     /*  89924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89926 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89928 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89930 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89936 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89942 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89948 */     GIR_RootConstrainSelectedInstOperands,
     /*  89949 */     // GIR_Coverage, 3808,
     /*  89949 */     GIR_EraseRootFromParent_Done,
     /*  89950 */   // Label 1648: @89950
     /*  89950 */   GIM_Try, /*On fail goto*//*Label 1649*/ GIMT_Encode4(90057), // Rule ID 3810 //
     /*  89955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89973 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89976 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89979 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90002 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  90006 */     // MIs[1] Operand 1
     /*  90006 */     // No operand predicates
     /*  90006 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90010 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90014 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  90018 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90022 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  90026 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90028 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3706:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRNbhs32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNbhs32),
     /*  90031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90033 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90035 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90043 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90049 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90055 */     GIR_RootConstrainSelectedInstOperands,
     /*  90056 */     // GIR_Coverage, 3810,
     /*  90056 */     GIR_EraseRootFromParent_Done,
     /*  90057 */   // Label 1649: @90057
     /*  90057 */   GIM_Try, /*On fail goto*//*Label 1650*/ GIMT_Encode4(90164), // Rule ID 3812 //
     /*  90062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  90065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90080 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90083 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90086 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90109 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  90113 */     // MIs[1] Operand 1
     /*  90113 */     // No operand predicates
     /*  90113 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90117 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90121 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  90125 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90129 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  90133 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90135 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3706:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRNths32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNths32),
     /*  90138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90140 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90142 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90144 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90150 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90156 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90162 */     GIR_RootConstrainSelectedInstOperands,
     /*  90163 */     // GIR_Coverage, 3812,
     /*  90163 */     GIR_EraseRootFromParent_Done,
     /*  90164 */   // Label 1650: @90164
     /*  90164 */   GIM_Try, /*On fail goto*//*Label 1651*/ GIMT_Encode4(90271), // Rule ID 3814 //
     /*  90169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  90172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  90178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90187 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90190 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90193 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90216 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  90220 */     // MIs[1] Operand 1
     /*  90220 */     // No operand predicates
     /*  90220 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90224 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90228 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90232 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  90236 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  90240 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90242 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3706:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRNbhu16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNbhu16),
     /*  90245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90247 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90251 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90257 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90263 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90269 */     GIR_RootConstrainSelectedInstOperands,
     /*  90270 */     // GIR_Coverage, 3814,
     /*  90270 */     GIR_EraseRootFromParent_Done,
     /*  90271 */   // Label 1651: @90271
     /*  90271 */   GIM_Try, /*On fail goto*//*Label 1652*/ GIMT_Encode4(90378), // Rule ID 3816 //
     /*  90276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  90279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  90285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90294 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90297 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90300 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90323 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  90327 */     // MIs[1] Operand 1
     /*  90327 */     // No operand predicates
     /*  90327 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90331 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90335 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90339 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  90343 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  90347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90349 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3706:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRNthu16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNthu16),
     /*  90352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90354 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90356 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90358 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90364 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90370 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90376 */     GIR_RootConstrainSelectedInstOperands,
     /*  90377 */     // GIR_Coverage, 3816,
     /*  90377 */     GIR_EraseRootFromParent_Done,
     /*  90378 */   // Label 1652: @90378
     /*  90378 */   GIM_Try, /*On fail goto*//*Label 1653*/ GIMT_Encode4(90485), // Rule ID 3818 //
     /*  90383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  90386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90401 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90404 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90407 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90430 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  90434 */     // MIs[1] Operand 1
     /*  90434 */     // No operand predicates
     /*  90434 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90438 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90442 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90446 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  90450 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  90454 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90456 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3706:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRNbhu32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNbhu32),
     /*  90459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90461 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90463 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90465 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90471 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90477 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90483 */     GIR_RootConstrainSelectedInstOperands,
     /*  90484 */     // GIR_Coverage, 3818,
     /*  90484 */     GIR_EraseRootFromParent_Done,
     /*  90485 */   // Label 1653: @90485
     /*  90485 */   GIM_Try, /*On fail goto*//*Label 1654*/ GIMT_Encode4(90592), // Rule ID 3820 //
     /*  90490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  90493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90508 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90511 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90514 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90537 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  90541 */     // MIs[1] Operand 1
     /*  90541 */     // No operand predicates
     /*  90541 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90545 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90549 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90553 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  90557 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  90561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90563 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3706:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRNthu32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNthu32),
     /*  90566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90568 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90572 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90578 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90584 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90590 */     GIR_RootConstrainSelectedInstOperands,
     /*  90591 */     // GIR_Coverage, 3820,
     /*  90591 */     GIR_EraseRootFromParent_Done,
     /*  90592 */   // Label 1654: @90592
     /*  90592 */   GIM_Try, /*On fail goto*//*Label 1655*/ GIMT_Encode4(90699), // Rule ID 3822 //
     /*  90597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  90600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  90606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90615 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90618 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90621 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90644 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  90648 */     // MIs[1] Operand 1
     /*  90648 */     // No operand predicates
     /*  90648 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90652 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  90656 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90660 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90664 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  90668 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90670 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3706:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRUNs16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRUNs16bh),
     /*  90673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90675 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90677 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90679 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90685 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90691 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90697 */     GIR_RootConstrainSelectedInstOperands,
     /*  90698 */     // GIR_Coverage, 3822,
     /*  90698 */     GIR_EraseRootFromParent_Done,
     /*  90699 */   // Label 1655: @90699
     /*  90699 */   GIM_Try, /*On fail goto*//*Label 1656*/ GIMT_Encode4(90806), // Rule ID 3824 //
     /*  90704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  90707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  90713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90722 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90725 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90728 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90751 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  90755 */     // MIs[1] Operand 1
     /*  90755 */     // No operand predicates
     /*  90755 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90759 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  90763 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90767 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90771 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  90775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90777 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3706:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRUNs16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRUNs16th),
     /*  90780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90782 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90786 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90792 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90798 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90804 */     GIR_RootConstrainSelectedInstOperands,
     /*  90805 */     // GIR_Coverage, 3824,
     /*  90805 */     GIR_EraseRootFromParent_Done,
     /*  90806 */   // Label 1656: @90806
     /*  90806 */   GIM_Try, /*On fail goto*//*Label 1657*/ GIMT_Encode4(90913), // Rule ID 3826 //
     /*  90811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  90814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90829 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90832 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90835 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90858 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  90862 */     // MIs[1] Operand 1
     /*  90862 */     // No operand predicates
     /*  90862 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90866 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  90870 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90874 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90878 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  90882 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90884 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3706:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRUNs32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRUNs32bh),
     /*  90887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90889 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90891 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90893 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90899 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90905 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90911 */     GIR_RootConstrainSelectedInstOperands,
     /*  90912 */     // GIR_Coverage, 3826,
     /*  90912 */     GIR_EraseRootFromParent_Done,
     /*  90913 */   // Label 1657: @90913
     /*  90913 */   GIM_Try, /*On fail goto*//*Label 1658*/ GIMT_Encode4(91020), // Rule ID 3828 //
     /*  90918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  90921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90936 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90939 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90942 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90965 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  90969 */     // MIs[1] Operand 1
     /*  90969 */     // No operand predicates
     /*  90969 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90973 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  90977 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90981 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90985 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  90989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90991 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3706:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRUNs32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRUNs32th),
     /*  90994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90996 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90998 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  91000 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91006 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91012 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91018 */     GIR_RootConstrainSelectedInstOperands,
     /*  91019 */     // GIR_Coverage, 3828,
     /*  91019 */     GIR_EraseRootFromParent_Done,
     /*  91020 */   // Label 1658: @91020
     /*  91020 */   GIM_Try, /*On fail goto*//*Label 1659*/ GIMT_Encode4(91127), // Rule ID 3830 //
     /*  91025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  91028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  91031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  91034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  91037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  91040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  91043 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  91046 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  91049 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  91052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  91068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91072 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  91076 */     // MIs[1] Operand 1
     /*  91076 */     // No operand predicates
     /*  91076 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  91080 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  91084 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  91088 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  91092 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  91096 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91098 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3706:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRUNs16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  91098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRUNs16bh),
     /*  91101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  91103 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  91105 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  91107 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91113 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91119 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91125 */     GIR_RootConstrainSelectedInstOperands,
     /*  91126 */     // GIR_Coverage, 3830,
     /*  91126 */     GIR_EraseRootFromParent_Done,
     /*  91127 */   // Label 1659: @91127
     /*  91127 */   GIM_Try, /*On fail goto*//*Label 1660*/ GIMT_Encode4(91234), // Rule ID 3832 //
     /*  91132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  91135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  91138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  91141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  91144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  91147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  91150 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  91153 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  91156 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  91159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  91175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91179 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  91183 */     // MIs[1] Operand 1
     /*  91183 */     // No operand predicates
     /*  91183 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  91187 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  91191 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  91195 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  91199 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  91203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91205 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3706:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRUNs16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  91205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRUNs16th),
     /*  91208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  91210 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  91212 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  91214 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91220 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91226 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91232 */     GIR_RootConstrainSelectedInstOperands,
     /*  91233 */     // GIR_Coverage, 3832,
     /*  91233 */     GIR_EraseRootFromParent_Done,
     /*  91234 */   // Label 1660: @91234
     /*  91234 */   GIM_Try, /*On fail goto*//*Label 1661*/ GIMT_Encode4(91341), // Rule ID 3834 //
     /*  91239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  91242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  91248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  91251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  91254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  91257 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  91260 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  91263 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  91266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  91282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91286 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  91290 */     // MIs[1] Operand 1
     /*  91290 */     // No operand predicates
     /*  91290 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  91294 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  91298 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  91302 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  91306 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  91310 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91312 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3706:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRUNs32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  91312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRUNs32bh),
     /*  91315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  91317 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  91319 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  91321 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91327 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91333 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91339 */     GIR_RootConstrainSelectedInstOperands,
     /*  91340 */     // GIR_Coverage, 3834,
     /*  91340 */     GIR_EraseRootFromParent_Done,
     /*  91341 */   // Label 1661: @91341
     /*  91341 */   GIM_Try, /*On fail goto*//*Label 1662*/ GIMT_Encode4(91448), // Rule ID 3836 //
     /*  91346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  91349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  91355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  91358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  91361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  91364 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  91367 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  91370 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  91373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  91389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91393 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  91397 */     // MIs[1] Operand 1
     /*  91397 */     // No operand predicates
     /*  91397 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  91401 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  91405 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  91409 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  91413 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  91417 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91419 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3706:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRUNs32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  91419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRUNs32th),
     /*  91422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  91424 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  91426 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  91428 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91434 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91440 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91446 */     GIR_RootConstrainSelectedInstOperands,
     /*  91447 */     // GIR_Coverage, 3836,
     /*  91447 */     GIR_EraseRootFromParent_Done,
     /*  91448 */   // Label 1662: @91448
     /*  91448 */   GIM_Reject,
     /*  91449 */ // Label 1622: @91449
     /*  91449 */ GIM_Reject,
     /*  91450 */ // Label 16: @91450
     /*  91450 */ GIM_Try, /*On fail goto*//*Label 1663*/ GIMT_Encode4(91507),
     /*  91455 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/1,
     /*  91458 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_clrex),
     /*  91463 */   GIM_Try, /*On fail goto*//*Label 1664*/ GIMT_Encode4(91480), // Rule ID 245 //
     /*  91468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6K_IsARM),
     /*  91471 */     // (intrinsic_void 3492:{ *:[iPTR] })  =>  (CLREX)
     /*  91471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CLREX),
     /*  91474 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91478 */     GIR_RootConstrainSelectedInstOperands,
     /*  91479 */     // GIR_Coverage, 245,
     /*  91479 */     GIR_EraseRootFromParent_Done,
     /*  91480 */   // Label 1664: @91480
     /*  91480 */   GIM_Try, /*On fail goto*//*Label 1665*/ GIMT_Encode4(91506), // Rule ID 574 //
     /*  91485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV7Clrex_IsThumb),
     /*  91488 */     // (intrinsic_void 3492:{ *:[iPTR] })  =>  (t2CLREX)
     /*  91488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CLREX),
     /*  91491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91494 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91500 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91504 */     GIR_RootConstrainSelectedInstOperands,
     /*  91505 */     // GIR_Coverage, 574,
     /*  91505 */     GIR_EraseRootFromParent_Done,
     /*  91506 */   // Label 1665: @91506
     /*  91506 */   GIM_Reject,
     /*  91507 */ // Label 1663: @91507
     /*  91507 */ GIM_Try, /*On fail goto*//*Label 1666*/ GIMT_Encode4(92309),
     /*  91512 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /*  91515 */   GIM_Try, /*On fail goto*//*Label 1667*/ GIMT_Encode4(91551), // Rule ID 344 //
     /*  91520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsWindows),
     /*  91523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_undefined),
     /*  91528 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91531 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/1, GIMT_Encode8(249),
     /*  91542 */     // (intrinsic_void 3930:{ *:[iPTR] }, 249:{ *:[i32] })  =>  (t__brkdiv0)
     /*  91542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t__brkdiv0),
     /*  91545 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91549 */     GIR_RootConstrainSelectedInstOperands,
     /*  91550 */     // GIR_Coverage, 344,
     /*  91550 */     GIR_EraseRootFromParent_Done,
     /*  91551 */   // Label 1667: @91551
     /*  91551 */   GIM_Try, /*On fail goto*//*Label 1668*/ GIMT_Encode4(91603), // Rule ID 2 //
     /*  91556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  91559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_hint),
     /*  91564 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91575 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_239),
     /*  91579 */     // MIs[1] Operand 1
     /*  91579 */     // No operand predicates
     /*  91579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91581 */     // (intrinsic_void 3510:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_239>>:$imm)  =>  (HINT (imm:{ *:[i32] }):$imm)
     /*  91581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::HINT),
     /*  91584 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91590 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91596 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91601 */     GIR_RootConstrainSelectedInstOperands,
     /*  91602 */     // GIR_Coverage, 2,
     /*  91602 */     GIR_EraseRootFromParent_Done,
     /*  91603 */   // Label 1668: @91603
     /*  91603 */   GIM_Try, /*On fail goto*//*Label 1669*/ GIMT_Encode4(91655), // Rule ID 10 //
     /*  91608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV7_IsARM),
     /*  91611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dbg),
     /*  91616 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91627 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91631 */     // MIs[1] Operand 1
     /*  91631 */     // No operand predicates
     /*  91631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91633 */     // (intrinsic_void 3505:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (DBG (imm:{ *:[i32] }):$opt)
     /*  91633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::DBG),
     /*  91636 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  91639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91642 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91648 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91653 */     GIR_RootConstrainSelectedInstOperands,
     /*  91654 */     // GIR_Coverage, 10,
     /*  91654 */     GIR_EraseRootFromParent_Done,
     /*  91655 */   // Label 1669: @91655
     /*  91655 */   GIM_Try, /*On fail goto*//*Label 1670*/ GIMT_Encode4(91698), // Rule ID 11 //
     /*  91660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  91663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_undefined),
     /*  91668 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91679 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_65535),
     /*  91683 */     // MIs[1] Operand 1
     /*  91683 */     // No operand predicates
     /*  91683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91685 */     // (intrinsic_void 3930:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_65535>>:$imm16)  =>  (UDF (imm:{ *:[i32] }):$imm16)
     /*  91685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UDF),
     /*  91688 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm16
     /*  91691 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91696 */     GIR_RootConstrainSelectedInstOperands,
     /*  91697 */     // GIR_Coverage, 11,
     /*  91697 */     GIR_EraseRootFromParent_Done,
     /*  91698 */   // Label 1670: @91698
     /*  91698 */   GIM_Try, /*On fail goto*//*Label 1671*/ GIMT_Encode4(91741), // Rule ID 228 //
     /*  91703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsARM),
     /*  91706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dmb),
     /*  91711 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91722 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91726 */     // MIs[1] Operand 1
     /*  91726 */     // No operand predicates
     /*  91726 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91728 */     // (intrinsic_void 3506:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (DMB (imm:{ *:[i32] }):$opt)
     /*  91728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::DMB),
     /*  91731 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  91734 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91739 */     GIR_RootConstrainSelectedInstOperands,
     /*  91740 */     // GIR_Coverage, 228,
     /*  91740 */     GIR_EraseRootFromParent_Done,
     /*  91741 */   // Label 1671: @91741
     /*  91741 */   GIM_Try, /*On fail goto*//*Label 1672*/ GIMT_Encode4(91784), // Rule ID 229 //
     /*  91746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsARM),
     /*  91749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dsb),
     /*  91754 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91765 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91769 */     // MIs[1] Operand 1
     /*  91769 */     // No operand predicates
     /*  91769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91771 */     // (intrinsic_void 3507:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (DSB (imm:{ *:[i32] }):$opt)
     /*  91771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::DSB),
     /*  91774 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  91777 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91782 */     GIR_RootConstrainSelectedInstOperands,
     /*  91783 */     // GIR_Coverage, 229,
     /*  91783 */     GIR_EraseRootFromParent_Done,
     /*  91784 */   // Label 1672: @91784
     /*  91784 */   GIM_Try, /*On fail goto*//*Label 1673*/ GIMT_Encode4(91827), // Rule ID 230 //
     /*  91789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsARM),
     /*  91792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_isb),
     /*  91797 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91808 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91812 */     // MIs[1] Operand 1
     /*  91812 */     // No operand predicates
     /*  91812 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91814 */     // (intrinsic_void 3511:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (ISB (imm:{ *:[i32] }):$opt)
     /*  91814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ISB),
     /*  91817 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  91820 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91825 */     GIR_RootConstrainSelectedInstOperands,
     /*  91826 */     // GIR_Coverage, 230,
     /*  91826 */     GIR_EraseRootFromParent_Done,
     /*  91827 */   // Label 1673: @91827
     /*  91827 */   GIM_Try, /*On fail goto*//*Label 1674*/ GIMT_Encode4(91879), // Rule ID 276 //
     /*  91832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6M_IsThumb),
     /*  91835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_hint),
     /*  91840 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91851 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91855 */     // MIs[1] Operand 1
     /*  91855 */     // No operand predicates
     /*  91855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91857 */     // (intrinsic_void 3510:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)  =>  (tHINT (imm:{ *:[i32] }):$imm)
     /*  91857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tHINT),
     /*  91860 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91866 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91872 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91877 */     GIR_RootConstrainSelectedInstOperands,
     /*  91878 */     // GIR_Coverage, 276,
     /*  91878 */     GIR_EraseRootFromParent_Done,
     /*  91879 */   // Label 1674: @91879
     /*  91879 */   GIM_Try, /*On fail goto*//*Label 1675*/ GIMT_Encode4(91922), // Rule ID 343 //
     /*  91884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb),
     /*  91887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_undefined),
     /*  91892 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91903 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_255),
     /*  91907 */     // MIs[1] Operand 1
     /*  91907 */     // No operand predicates
     /*  91907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91909 */     // (intrinsic_void 3930:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_255>>:$imm8)  =>  (tUDF (imm:{ *:[i32] }):$imm8)
     /*  91909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tUDF),
     /*  91912 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm8
     /*  91915 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91920 */     GIR_RootConstrainSelectedInstOperands,
     /*  91921 */     // GIR_Coverage, 343,
     /*  91921 */     GIR_EraseRootFromParent_Done,
     /*  91922 */   // Label 1675: @91922
     /*  91922 */   GIM_Try, /*On fail goto*//*Label 1676*/ GIMT_Encode4(91965), // Rule ID 494 //
     /*  91927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  91930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_undefined),
     /*  91935 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91946 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_65535),
     /*  91950 */     // MIs[1] Operand 1
     /*  91950 */     // No operand predicates
     /*  91950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91952 */     // (intrinsic_void 3930:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_65535>>:$imm16)  =>  (t2UDF (imm:{ *:[i32] }):$imm16)
     /*  91952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UDF),
     /*  91955 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm16
     /*  91958 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91963 */     GIR_RootConstrainSelectedInstOperands,
     /*  91964 */     // GIR_Coverage, 494,
     /*  91964 */     GIR_EraseRootFromParent_Done,
     /*  91965 */   // Label 1676: @91965
     /*  91965 */   GIM_Try, /*On fail goto*//*Label 1677*/ GIMT_Encode4(92017), // Rule ID 559 //
     /*  91970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsThumb),
     /*  91973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dmb),
     /*  91978 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91989 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91993 */     // MIs[1] Operand 1
     /*  91993 */     // No operand predicates
     /*  91993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91995 */     // (intrinsic_void 3506:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (t2DMB (imm:{ *:[i32] }):$opt)
     /*  91995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2DMB),
     /*  91998 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  92001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92004 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92010 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92015 */     GIR_RootConstrainSelectedInstOperands,
     /*  92016 */     // GIR_Coverage, 559,
     /*  92016 */     GIR_EraseRootFromParent_Done,
     /*  92017 */   // Label 1677: @92017
     /*  92017 */   GIM_Try, /*On fail goto*//*Label 1678*/ GIMT_Encode4(92069), // Rule ID 560 //
     /*  92022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsThumb),
     /*  92025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dsb),
     /*  92030 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  92033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92041 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  92045 */     // MIs[1] Operand 1
     /*  92045 */     // No operand predicates
     /*  92045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92047 */     // (intrinsic_void 3507:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (t2DSB (imm:{ *:[i32] }):$opt)
     /*  92047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2DSB),
     /*  92050 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  92053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92056 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92062 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92067 */     GIR_RootConstrainSelectedInstOperands,
     /*  92068 */     // GIR_Coverage, 560,
     /*  92068 */     GIR_EraseRootFromParent_Done,
     /*  92069 */   // Label 1678: @92069
     /*  92069 */   GIM_Try, /*On fail goto*//*Label 1679*/ GIMT_Encode4(92121), // Rule ID 561 //
     /*  92074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsThumb),
     /*  92077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_isb),
     /*  92082 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  92085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92093 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  92097 */     // MIs[1] Operand 1
     /*  92097 */     // No operand predicates
     /*  92097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92099 */     // (intrinsic_void 3511:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (t2ISB (imm:{ *:[i32] }):$opt)
     /*  92099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ISB),
     /*  92102 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  92105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92108 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92114 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92119 */     GIR_RootConstrainSelectedInstOperands,
     /*  92120 */     // GIR_Coverage, 561,
     /*  92120 */     GIR_EraseRootFromParent_Done,
     /*  92121 */   // Label 1679: @92121
     /*  92121 */   GIM_Try, /*On fail goto*//*Label 1680*/ GIMT_Encode4(92173), // Rule ID 579 //
     /*  92126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  92129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_hint),
     /*  92134 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  92137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92145 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_239),
     /*  92149 */     // MIs[1] Operand 1
     /*  92149 */     // No operand predicates
     /*  92149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92151 */     // (intrinsic_void 3510:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_239>>:$imm)  =>  (t2HINT (imm:{ *:[i32] }):$imm)
     /*  92151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2HINT),
     /*  92154 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  92157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92160 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92166 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92171 */     GIR_RootConstrainSelectedInstOperands,
     /*  92172 */     // GIR_Coverage, 579,
     /*  92172 */     GIR_EraseRootFromParent_Done,
     /*  92173 */   // Label 1680: @92173
     /*  92173 */   GIM_Try, /*On fail goto*//*Label 1681*/ GIMT_Encode4(92225), // Rule ID 580 //
     /*  92178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  92181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dbg),
     /*  92186 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  92189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92197 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  92201 */     // MIs[1] Operand 1
     /*  92201 */     // No operand predicates
     /*  92201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92203 */     // (intrinsic_void 3505:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (t2DBG (imm:{ *:[i32] }):$opt)
     /*  92203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2DBG),
     /*  92206 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  92209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92212 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92218 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92223 */     GIR_RootConstrainSelectedInstOperands,
     /*  92224 */     // GIR_Coverage, 580,
     /*  92224 */     GIR_EraseRootFromParent_Done,
     /*  92225 */   // Label 1681: @92225
     /*  92225 */   GIM_Try, /*On fail goto*//*Label 1682*/ GIMT_Encode4(92265), // Rule ID 725 //
     /*  92230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRegs),
     /*  92233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_get_fpscr),
     /*  92238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92245 */     // (intrinsic_w_chain:{ *:[i32] } 3508:{ *:[iPTR] })  =>  (VMRS:{ *:[i32] })
     /*  92245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMRS),
     /*  92248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  92250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92253 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92259 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92263 */     GIR_RootConstrainSelectedInstOperands,
     /*  92264 */     // GIR_Coverage, 725,
     /*  92264 */     GIR_EraseRootFromParent_Done,
     /*  92265 */   // Label 1682: @92265
     /*  92265 */   GIM_Try, /*On fail goto*//*Label 1683*/ GIMT_Encode4(92308), // Rule ID 726 //
     /*  92270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRegs),
     /*  92273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_set_fpscr),
     /*  92278 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  92281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92285 */     // (intrinsic_void 3874:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rt)  =>  (VMSR:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rt)
     /*  92285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMSR),
     /*  92288 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rt
     /*  92290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92293 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92299 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for ARM::FPSCR*/0,
     /*  92302 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92306 */     GIR_RootConstrainSelectedInstOperands,
     /*  92307 */     // GIR_Coverage, 726,
     /*  92307 */     GIR_EraseRootFromParent_Done,
     /*  92308 */   // Label 1683: @92308
     /*  92308 */   GIM_Reject,
     /*  92309 */ // Label 1666: @92309
     /*  92309 */ GIM_Try, /*On fail goto*//*Label 1684*/ GIMT_Encode4(92352), // Rule ID 604 //
     /*  92314 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLOB_HasV8_1MMainline_IsThumb2),
     /*  92317 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  92320 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::start_loop_iterations),
     /*  92325 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92328 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRlrRegClassID),
     /*  92335 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  92339 */   // (intrinsic_w_chain:{ *:[i32] } 348:{ *:[iPTR] }, rGPR:{ *:[i32] }:$tc)  =>  (t2DoLoopStart:{ *:[i32] } rGPR:{ *:[i32] }:$tc)
     /*  92339 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2DoLoopStart),
     /*  92342 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[X]
     /*  92344 */   GIR_RootToRootCopy, /*OpIdx*/2, // tc
     /*  92346 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92350 */   GIR_RootConstrainSelectedInstOperands,
     /*  92351 */   // GIR_Coverage, 604,
     /*  92351 */   GIR_EraseRootFromParent_Done,
     /*  92352 */ // Label 1684: @92352
     /*  92352 */ GIM_Try, /*On fail goto*//*Label 1685*/ GIMT_Encode4(94343),
     /*  92357 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /*  92360 */   GIM_Try, /*On fail goto*//*Label 1686*/ GIMT_Encode4(92414), // Rule ID 5051 //
     /*  92365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_base),
     /*  92370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  92373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  92376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92395 */     // MIs[1] Operand 1
     /*  92395 */     // No operand predicates
     /*  92395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92397 */     // (intrinsic_w_chain:{ *:[v4i32] } 3641:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)  =>  (MVE_VLDRWU32_qi:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_qi),
     /*  92400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  92402 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  92404 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92407 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92412 */     GIR_RootConstrainSelectedInstOperands,
     /*  92413 */     // GIR_Coverage, 5051,
     /*  92413 */     GIR_EraseRootFromParent_Done,
     /*  92414 */   // Label 1686: @92414
     /*  92414 */   GIM_Try, /*On fail goto*//*Label 1687*/ GIMT_Encode4(92468), // Rule ID 5057 //
     /*  92419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_base),
     /*  92424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  92427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  92430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92449 */     // MIs[1] Operand 1
     /*  92449 */     // No operand predicates
     /*  92449 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92451 */     // (intrinsic_w_chain:{ *:[v4f32] } 3641:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)  =>  (MVE_VLDRWU32_qi:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_qi),
     /*  92454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  92456 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  92458 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92461 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92466 */     GIR_RootConstrainSelectedInstOperands,
     /*  92467 */     // GIR_Coverage, 5057,
     /*  92467 */     GIR_EraseRootFromParent_Done,
     /*  92468 */   // Label 1687: @92468
     /*  92468 */   GIM_Try, /*On fail goto*//*Label 1688*/ GIMT_Encode4(92522), // Rule ID 5059 //
     /*  92473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_base),
     /*  92478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  92481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  92484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92503 */     // MIs[1] Operand 1
     /*  92503 */     // No operand predicates
     /*  92503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92505 */     // (intrinsic_w_chain:{ *:[v2i64] } 3641:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)  =>  (MVE_VLDRDU64_qi:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_qi),
     /*  92508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  92510 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  92512 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92515 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92520 */     GIR_RootConstrainSelectedInstOperands,
     /*  92521 */     // GIR_Coverage, 5059,
     /*  92521 */     GIR_EraseRootFromParent_Done,
     /*  92522 */   // Label 1688: @92522
     /*  92522 */   GIM_Try, /*On fail goto*//*Label 1689*/ GIMT_Encode4(92576), // Rule ID 5061 //
     /*  92527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_base),
     /*  92532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  92535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  92538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92557 */     // MIs[1] Operand 1
     /*  92557 */     // No operand predicates
     /*  92557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92559 */     // (intrinsic_w_chain:{ *:[v2f64] } 3641:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)  =>  (MVE_VLDRDU64_qi:{ *:[v2f64] } MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_qi),
     /*  92562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  92564 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  92566 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92569 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92574 */     GIR_RootConstrainSelectedInstOperands,
     /*  92575 */     // GIR_Coverage, 5061,
     /*  92575 */     GIR_EraseRootFromParent_Done,
     /*  92576 */   // Label 1689: @92576
     /*  92576 */   GIM_Try, /*On fail goto*//*Label 1690*/ GIMT_Encode4(92618), // Rule ID 1741 //
     /*  92581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_space),
     /*  92586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  92596 */     // MIs[0] size
     /*  92596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  92599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  92603 */     // (intrinsic_w_chain:{ *:[i32] } 3905:{ *:[iPTR] }, (timm:{ *:[i32] }):$size, GPR:{ *:[i32] }:$Rn)  =>  (SPACE:{ *:[i32] } (timm:{ *:[i32] }):$size, GPR:{ *:[i32] }:$Rn)
     /*  92603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SPACE),
     /*  92606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92608 */     GIR_RootToRootCopy, /*OpIdx*/2, // size
     /*  92610 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /*  92612 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92616 */     GIR_RootConstrainSelectedInstOperands,
     /*  92617 */     // GIR_Coverage, 1741,
     /*  92617 */     GIR_EraseRootFromParent_Done,
     /*  92618 */   // Label 1690: @92618
     /*  92618 */   GIM_Try, /*On fail goto*//*Label 1691*/ GIMT_Encode4(92672), // Rule ID 5053 //
     /*  92623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_base),
     /*  92628 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  92631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  92637 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92649 */     // MIs[1] Operand 1
     /*  92649 */     // No operand predicates
     /*  92649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92655 */     // (intrinsic_void 3714:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v4i32] }:$data)  =>  (MVE_VSTRW32_qi MQPR:{ *:[v4i32] }:$data, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_qi),
     /*  92658 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  92660 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  92662 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92665 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92670 */     GIR_RootConstrainSelectedInstOperands,
     /*  92671 */     // GIR_Coverage, 5053,
     /*  92671 */     GIR_EraseRootFromParent_Done,
     /*  92672 */   // Label 1691: @92672
     /*  92672 */   GIM_Try, /*On fail goto*//*Label 1692*/ GIMT_Encode4(92726), // Rule ID 5063 //
     /*  92677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_base),
     /*  92682 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  92685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  92691 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92703 */     // MIs[1] Operand 1
     /*  92703 */     // No operand predicates
     /*  92703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92709 */     // (intrinsic_void 3714:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v4f32] }:$data)  =>  (MVE_VSTRW32_qi MQPR:{ *:[v4f32] }:$data, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_qi),
     /*  92712 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  92714 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  92716 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92719 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92724 */     GIR_RootConstrainSelectedInstOperands,
     /*  92725 */     // GIR_Coverage, 5063,
     /*  92725 */     GIR_EraseRootFromParent_Done,
     /*  92726 */   // Label 1692: @92726
     /*  92726 */   GIM_Try, /*On fail goto*//*Label 1693*/ GIMT_Encode4(92780), // Rule ID 5067 //
     /*  92731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_base),
     /*  92736 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  92739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  92745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92757 */     // MIs[1] Operand 1
     /*  92757 */     // No operand predicates
     /*  92757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92763 */     // (intrinsic_void 3714:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v2i64] }:$data)  =>  (MVE_VSTRD64_qi MQPR:{ *:[v2i64] }:$data, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_qi),
     /*  92766 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  92768 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  92770 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92773 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92778 */     GIR_RootConstrainSelectedInstOperands,
     /*  92779 */     // GIR_Coverage, 5067,
     /*  92779 */     GIR_EraseRootFromParent_Done,
     /*  92780 */   // Label 1693: @92780
     /*  92780 */   GIM_Try, /*On fail goto*//*Label 1694*/ GIMT_Encode4(92834), // Rule ID 5071 //
     /*  92785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_base),
     /*  92790 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  92793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  92799 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92811 */     // MIs[1] Operand 1
     /*  92811 */     // No operand predicates
     /*  92811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92817 */     // (intrinsic_void 3714:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v2f64] }:$data)  =>  (MVE_VSTRD64_qi MQPR:{ *:[v2f64] }:$data, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_qi),
     /*  92820 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  92822 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  92824 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92827 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92832 */     GIR_RootConstrainSelectedInstOperands,
     /*  92833 */     // GIR_Coverage, 5071,
     /*  92833 */     GIR_EraseRootFromParent_Done,
     /*  92834 */   // Label 1694: @92834
     /*  92834 */   GIM_Try, /*On fail goto*//*Label 1695*/ GIMT_Encode4(92892), // Rule ID 3 //
     /*  92839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  92842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sel),
     /*  92847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  92860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  92864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  92868 */     // (intrinsic_w_chain:{ *:[i32] } 3873:{ *:[iPTR] }, GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (SEL:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  92868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SEL),
     /*  92871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  92875 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  92877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92880 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92886 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92890 */     GIR_RootConstrainSelectedInstOperands,
     /*  92891 */     // GIR_Coverage, 3,
     /*  92891 */     GIR_EraseRootFromParent_Done,
     /*  92892 */   // Label 1695: @92892
     /*  92892 */   GIM_Try, /*On fail goto*//*Label 1696*/ GIMT_Encode4(92950), // Rule ID 121 //
     /*  92897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  92900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sasx),
     /*  92905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92926 */     // (intrinsic_w_chain:{ *:[i32] } 3872:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  92926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SASX),
     /*  92929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92931 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  92933 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  92935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92938 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92944 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92948 */     GIR_RootConstrainSelectedInstOperands,
     /*  92949 */     // GIR_Coverage, 121,
     /*  92949 */     GIR_EraseRootFromParent_Done,
     /*  92950 */   // Label 1696: @92950
     /*  92950 */   GIM_Try, /*On fail goto*//*Label 1697*/ GIMT_Encode4(93008), // Rule ID 122 //
     /*  92955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  92958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sadd16),
     /*  92963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92984 */     // (intrinsic_w_chain:{ *:[i32] } 3870:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  92984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SADD16),
     /*  92987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  92991 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  92993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92996 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93002 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93006 */     GIR_RootConstrainSelectedInstOperands,
     /*  93007 */     // GIR_Coverage, 122,
     /*  93007 */     GIR_EraseRootFromParent_Done,
     /*  93008 */   // Label 1697: @93008
     /*  93008 */   GIM_Try, /*On fail goto*//*Label 1698*/ GIMT_Encode4(93066), // Rule ID 123 //
     /*  93013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sadd8),
     /*  93021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93042 */     // (intrinsic_w_chain:{ *:[i32] } 3871:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SADD8),
     /*  93045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93049 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93054 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93060 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93064 */     GIR_RootConstrainSelectedInstOperands,
     /*  93065 */     // GIR_Coverage, 123,
     /*  93065 */     GIR_EraseRootFromParent_Done,
     /*  93066 */   // Label 1698: @93066
     /*  93066 */   GIM_Try, /*On fail goto*//*Label 1699*/ GIMT_Encode4(93124), // Rule ID 124 //
     /*  93071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssax),
     /*  93079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93100 */     // (intrinsic_w_chain:{ *:[i32] } 3908:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SSAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SSAX),
     /*  93103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93107 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93112 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93118 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93122 */     GIR_RootConstrainSelectedInstOperands,
     /*  93123 */     // GIR_Coverage, 124,
     /*  93123 */     GIR_EraseRootFromParent_Done,
     /*  93124 */   // Label 1699: @93124
     /*  93124 */   GIM_Try, /*On fail goto*//*Label 1700*/ GIMT_Encode4(93182), // Rule ID 125 //
     /*  93129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssub16),
     /*  93137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93158 */     // (intrinsic_w_chain:{ *:[i32] } 3909:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SSUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SSUB16),
     /*  93161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93163 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93165 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93170 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93176 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93180 */     GIR_RootConstrainSelectedInstOperands,
     /*  93181 */     // GIR_Coverage, 125,
     /*  93181 */     GIR_EraseRootFromParent_Done,
     /*  93182 */   // Label 1700: @93182
     /*  93182 */   GIM_Try, /*On fail goto*//*Label 1701*/ GIMT_Encode4(93240), // Rule ID 126 //
     /*  93187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssub8),
     /*  93195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93216 */     // (intrinsic_w_chain:{ *:[i32] } 3910:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SSUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SSUB8),
     /*  93219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93223 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93228 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93234 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93238 */     GIR_RootConstrainSelectedInstOperands,
     /*  93239 */     // GIR_Coverage, 126,
     /*  93239 */     GIR_EraseRootFromParent_Done,
     /*  93240 */   // Label 1701: @93240
     /*  93240 */   GIM_Try, /*On fail goto*//*Label 1702*/ GIMT_Encode4(93298), // Rule ID 127 //
     /*  93245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uasx),
     /*  93253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93274 */     // (intrinsic_w_chain:{ *:[i32] } 3923:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UASX),
     /*  93277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93281 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93286 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93292 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93296 */     GIR_RootConstrainSelectedInstOperands,
     /*  93297 */     // GIR_Coverage, 127,
     /*  93297 */     GIR_EraseRootFromParent_Done,
     /*  93298 */   // Label 1702: @93298
     /*  93298 */   GIM_Try, /*On fail goto*//*Label 1703*/ GIMT_Encode4(93356), // Rule ID 128 //
     /*  93303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uadd16),
     /*  93311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93332 */     // (intrinsic_w_chain:{ *:[i32] } 3921:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UADD16),
     /*  93335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93339 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93344 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93350 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93354 */     GIR_RootConstrainSelectedInstOperands,
     /*  93355 */     // GIR_Coverage, 128,
     /*  93355 */     GIR_EraseRootFromParent_Done,
     /*  93356 */   // Label 1703: @93356
     /*  93356 */   GIM_Try, /*On fail goto*//*Label 1704*/ GIMT_Encode4(93414), // Rule ID 129 //
     /*  93361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uadd8),
     /*  93369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93390 */     // (intrinsic_w_chain:{ *:[i32] } 3922:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UADD8),
     /*  93393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93397 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93402 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93408 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93412 */     GIR_RootConstrainSelectedInstOperands,
     /*  93413 */     // GIR_Coverage, 129,
     /*  93413 */     GIR_EraseRootFromParent_Done,
     /*  93414 */   // Label 1704: @93414
     /*  93414 */   GIM_Try, /*On fail goto*//*Label 1705*/ GIMT_Encode4(93472), // Rule ID 130 //
     /*  93419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usax),
     /*  93427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93448 */     // (intrinsic_w_chain:{ *:[i32] } 3941:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (USAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USAX),
     /*  93451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93455 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93460 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93466 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93470 */     GIR_RootConstrainSelectedInstOperands,
     /*  93471 */     // GIR_Coverage, 130,
     /*  93471 */     GIR_EraseRootFromParent_Done,
     /*  93472 */   // Label 1705: @93472
     /*  93472 */   GIM_Try, /*On fail goto*//*Label 1706*/ GIMT_Encode4(93530), // Rule ID 131 //
     /*  93477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usub16),
     /*  93485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93506 */     // (intrinsic_w_chain:{ *:[i32] } 3942:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (USUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USUB16),
     /*  93509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93511 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93513 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93518 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93524 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93528 */     GIR_RootConstrainSelectedInstOperands,
     /*  93529 */     // GIR_Coverage, 131,
     /*  93529 */     GIR_EraseRootFromParent_Done,
     /*  93530 */   // Label 1706: @93530
     /*  93530 */   GIM_Try, /*On fail goto*//*Label 1707*/ GIMT_Encode4(93588), // Rule ID 132 //
     /*  93535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usub8),
     /*  93543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93564 */     // (intrinsic_w_chain:{ *:[i32] } 3943:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (USUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USUB8),
     /*  93567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93569 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93571 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93576 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93582 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93586 */     GIR_RootConstrainSelectedInstOperands,
     /*  93587 */     // GIR_Coverage, 132,
     /*  93587 */     GIR_EraseRootFromParent_Done,
     /*  93588 */   // Label 1707: @93588
     /*  93588 */   GIM_Try, /*On fail goto*//*Label 1708*/ GIMT_Encode4(93646), // Rule ID 431 //
     /*  93593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sel),
     /*  93601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  93614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  93618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  93622 */     // (intrinsic_w_chain:{ *:[i32] } 3873:{ *:[iPTR] }, GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (t2SEL:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  93622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SEL),
     /*  93625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93629 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93634 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93640 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93644 */     GIR_RootConstrainSelectedInstOperands,
     /*  93645 */     // GIR_Coverage, 431,
     /*  93645 */     GIR_EraseRootFromParent_Done,
     /*  93646 */   // Label 1708: @93646
     /*  93646 */   GIM_Try, /*On fail goto*//*Label 1709*/ GIMT_Encode4(93704), // Rule ID 444 //
     /*  93651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sasx),
     /*  93659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93680 */     // (intrinsic_w_chain:{ *:[i32] } 3872:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SASX),
     /*  93683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93687 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93692 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93698 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93702 */     GIR_RootConstrainSelectedInstOperands,
     /*  93703 */     // GIR_Coverage, 444,
     /*  93703 */     GIR_EraseRootFromParent_Done,
     /*  93704 */   // Label 1709: @93704
     /*  93704 */   GIM_Try, /*On fail goto*//*Label 1710*/ GIMT_Encode4(93762), // Rule ID 445 //
     /*  93709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sadd16),
     /*  93717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93738 */     // (intrinsic_w_chain:{ *:[i32] } 3870:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SADD16),
     /*  93741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93745 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93750 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93756 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93760 */     GIR_RootConstrainSelectedInstOperands,
     /*  93761 */     // GIR_Coverage, 445,
     /*  93761 */     GIR_EraseRootFromParent_Done,
     /*  93762 */   // Label 1710: @93762
     /*  93762 */   GIM_Try, /*On fail goto*//*Label 1711*/ GIMT_Encode4(93820), // Rule ID 446 //
     /*  93767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sadd8),
     /*  93775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93796 */     // (intrinsic_w_chain:{ *:[i32] } 3871:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SADD8),
     /*  93799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93803 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93808 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93814 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93818 */     GIR_RootConstrainSelectedInstOperands,
     /*  93819 */     // GIR_Coverage, 446,
     /*  93819 */     GIR_EraseRootFromParent_Done,
     /*  93820 */   // Label 1711: @93820
     /*  93820 */   GIM_Try, /*On fail goto*//*Label 1712*/ GIMT_Encode4(93878), // Rule ID 447 //
     /*  93825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssax),
     /*  93833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93854 */     // (intrinsic_w_chain:{ *:[i32] } 3908:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SSAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SSAX),
     /*  93857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93861 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93866 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93872 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93876 */     GIR_RootConstrainSelectedInstOperands,
     /*  93877 */     // GIR_Coverage, 447,
     /*  93877 */     GIR_EraseRootFromParent_Done,
     /*  93878 */   // Label 1712: @93878
     /*  93878 */   GIM_Try, /*On fail goto*//*Label 1713*/ GIMT_Encode4(93936), // Rule ID 448 //
     /*  93883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssub16),
     /*  93891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93912 */     // (intrinsic_w_chain:{ *:[i32] } 3909:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SSUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SSUB16),
     /*  93915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93919 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93924 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93930 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93934 */     GIR_RootConstrainSelectedInstOperands,
     /*  93935 */     // GIR_Coverage, 448,
     /*  93935 */     GIR_EraseRootFromParent_Done,
     /*  93936 */   // Label 1713: @93936
     /*  93936 */   GIM_Try, /*On fail goto*//*Label 1714*/ GIMT_Encode4(93994), // Rule ID 449 //
     /*  93941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssub8),
     /*  93949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93970 */     // (intrinsic_w_chain:{ *:[i32] } 3910:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SSUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SSUB8),
     /*  93973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93975 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93977 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93982 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93988 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93992 */     GIR_RootConstrainSelectedInstOperands,
     /*  93993 */     // GIR_Coverage, 449,
     /*  93993 */     GIR_EraseRootFromParent_Done,
     /*  93994 */   // Label 1714: @93994
     /*  93994 */   GIM_Try, /*On fail goto*//*Label 1715*/ GIMT_Encode4(94052), // Rule ID 450 //
     /*  93999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  94002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uasx),
     /*  94007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  94010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  94013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94028 */     // (intrinsic_w_chain:{ *:[i32] } 3923:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  94028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UASX),
     /*  94031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  94035 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  94037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  94040 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  94046 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94050 */     GIR_RootConstrainSelectedInstOperands,
     /*  94051 */     // GIR_Coverage, 450,
     /*  94051 */     GIR_EraseRootFromParent_Done,
     /*  94052 */   // Label 1715: @94052
     /*  94052 */   GIM_Try, /*On fail goto*//*Label 1716*/ GIMT_Encode4(94110), // Rule ID 451 //
     /*  94057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  94060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uadd16),
     /*  94065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  94068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  94071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94086 */     // (intrinsic_w_chain:{ *:[i32] } 3921:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  94086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UADD16),
     /*  94089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  94093 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  94095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  94098 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  94104 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94108 */     GIR_RootConstrainSelectedInstOperands,
     /*  94109 */     // GIR_Coverage, 451,
     /*  94109 */     GIR_EraseRootFromParent_Done,
     /*  94110 */   // Label 1716: @94110
     /*  94110 */   GIM_Try, /*On fail goto*//*Label 1717*/ GIMT_Encode4(94168), // Rule ID 452 //
     /*  94115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  94118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uadd8),
     /*  94123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  94126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  94129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94144 */     // (intrinsic_w_chain:{ *:[i32] } 3922:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  94144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UADD8),
     /*  94147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  94151 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  94153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  94156 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  94162 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94166 */     GIR_RootConstrainSelectedInstOperands,
     /*  94167 */     // GIR_Coverage, 452,
     /*  94167 */     GIR_EraseRootFromParent_Done,
     /*  94168 */   // Label 1717: @94168
     /*  94168 */   GIM_Try, /*On fail goto*//*Label 1718*/ GIMT_Encode4(94226), // Rule ID 453 //
     /*  94173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  94176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usax),
     /*  94181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  94184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  94187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94202 */     // (intrinsic_w_chain:{ *:[i32] } 3941:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2USAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  94202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USAX),
     /*  94205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  94209 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  94211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  94214 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  94220 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94224 */     GIR_RootConstrainSelectedInstOperands,
     /*  94225 */     // GIR_Coverage, 453,
     /*  94225 */     GIR_EraseRootFromParent_Done,
     /*  94226 */   // Label 1718: @94226
     /*  94226 */   GIM_Try, /*On fail goto*//*Label 1719*/ GIMT_Encode4(94284), // Rule ID 454 //
     /*  94231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  94234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usub16),
     /*  94239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  94242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  94245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94260 */     // (intrinsic_w_chain:{ *:[i32] } 3942:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2USUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  94260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USUB16),
     /*  94263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  94267 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  94269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  94272 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  94278 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94282 */     GIR_RootConstrainSelectedInstOperands,
     /*  94283 */     // GIR_Coverage, 454,
     /*  94283 */     GIR_EraseRootFromParent_Done,
     /*  94284 */   // Label 1719: @94284
     /*  94284 */   GIM_Try, /*On fail goto*//*Label 1720*/ GIMT_Encode4(94342), // Rule ID 455 //
     /*  94289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  94292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usub8),
     /*  94297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  94300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  94303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94318 */     // (intrinsic_w_chain:{ *:[i32] } 3943:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2USUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  94318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USUB8),
     /*  94321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94323 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  94325 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  94327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  94330 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  94336 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94340 */     GIR_RootConstrainSelectedInstOperands,
     /*  94341 */     // GIR_Coverage, 455,
     /*  94341 */     GIR_EraseRootFromParent_Done,
     /*  94342 */   // Label 1720: @94342
     /*  94342 */   GIM_Reject,
     /*  94343 */ // Label 1685: @94343
     /*  94343 */ GIM_Try, /*On fail goto*//*Label 1721*/ GIMT_Encode4(94589),
     /*  94348 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /*  94351 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_base_wb),
     /*  94356 */   GIM_Try, /*On fail goto*//*Label 1722*/ GIMT_Encode4(94414), // Rule ID 5055 //
     /*  94361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  94364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  94373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  94385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  94389 */     // MIs[1] Operand 1
     /*  94389 */     // No operand predicates
     /*  94389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94393 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94395 */     // (intrinsic_w_chain:{ *:[v4i32] } 3716:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v4i32] }:$data)  =>  (MVE_VSTRW32_qi_pre:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$data, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  94395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_qi_pre),
     /*  94398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wb]
     /*  94400 */     GIR_RootToRootCopy, /*OpIdx*/4, // data
     /*  94402 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  94404 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  94407 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  94412 */     GIR_RootConstrainSelectedInstOperands,
     /*  94413 */     // GIR_Coverage, 5055,
     /*  94413 */     GIR_EraseRootFromParent_Done,
     /*  94414 */   // Label 1722: @94414
     /*  94414 */   GIM_Try, /*On fail goto*//*Label 1723*/ GIMT_Encode4(94472), // Rule ID 5065 //
     /*  94419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  94422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  94431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  94443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  94447 */     // MIs[1] Operand 1
     /*  94447 */     // No operand predicates
     /*  94447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94453 */     // (intrinsic_w_chain:{ *:[v4i32] } 3716:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v4f32] }:$data)  =>  (MVE_VSTRW32_qi_pre:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$data, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  94453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_qi_pre),
     /*  94456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wb]
     /*  94458 */     GIR_RootToRootCopy, /*OpIdx*/4, // data
     /*  94460 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  94462 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  94465 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  94470 */     GIR_RootConstrainSelectedInstOperands,
     /*  94471 */     // GIR_Coverage, 5065,
     /*  94471 */     GIR_EraseRootFromParent_Done,
     /*  94472 */   // Label 1723: @94472
     /*  94472 */   GIM_Try, /*On fail goto*//*Label 1724*/ GIMT_Encode4(94530), // Rule ID 5069 //
     /*  94477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  94489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  94501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  94505 */     // MIs[1] Operand 1
     /*  94505 */     // No operand predicates
     /*  94505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94511 */     // (intrinsic_w_chain:{ *:[v2i64] } 3716:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v2i64] }:$data)  =>  (MVE_VSTRD64_qi_pre:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$data, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  94511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_qi_pre),
     /*  94514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wb]
     /*  94516 */     GIR_RootToRootCopy, /*OpIdx*/4, // data
     /*  94518 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  94520 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  94523 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  94528 */     GIR_RootConstrainSelectedInstOperands,
     /*  94529 */     // GIR_Coverage, 5069,
     /*  94529 */     GIR_EraseRootFromParent_Done,
     /*  94530 */   // Label 1724: @94530
     /*  94530 */   GIM_Try, /*On fail goto*//*Label 1725*/ GIMT_Encode4(94588), // Rule ID 5073 //
     /*  94535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  94547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  94559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  94563 */     // MIs[1] Operand 1
     /*  94563 */     // No operand predicates
     /*  94563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94569 */     // (intrinsic_w_chain:{ *:[v2i64] } 3716:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v2f64] }:$data)  =>  (MVE_VSTRD64_qi_pre:{ *:[v2i64] } MQPR:{ *:[v2f64] }:$data, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  94569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_qi_pre),
     /*  94572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wb]
     /*  94574 */     GIR_RootToRootCopy, /*OpIdx*/4, // data
     /*  94576 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  94578 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  94581 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  94586 */     GIR_RootConstrainSelectedInstOperands,
     /*  94587 */     // GIR_Coverage, 5073,
     /*  94587 */     GIR_EraseRootFromParent_Done,
     /*  94588 */   // Label 1725: @94588
     /*  94588 */   GIM_Reject,
     /*  94589 */ // Label 1721: @94589
     /*  94589 */ GIM_Try, /*On fail goto*//*Label 1726*/ GIMT_Encode4(95760),
     /*  94594 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /*  94597 */   GIM_Try, /*On fail goto*//*Label 1727*/ GIMT_Encode4(94658), // Rule ID 4943 //
     /*  94602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  94610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  94613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94619 */     // MIs[0] base
     /*  94619 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94623 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94635 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  94639 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  94643 */     // (intrinsic_void 3718:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, MQPR:{ *:[v8i16] }:$data, 16:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRH16_rq_u MQPR:{ *:[v8i16] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  94643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH16_rq_u),
     /*  94646 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94648 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94650 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94652 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94656 */     GIR_RootConstrainSelectedInstOperands,
     /*  94657 */     // GIR_Coverage, 4943,
     /*  94657 */     GIR_EraseRootFromParent_Done,
     /*  94658 */   // Label 1727: @94658
     /*  94658 */   GIM_Try, /*On fail goto*//*Label 1728*/ GIMT_Encode4(94719), // Rule ID 4944 //
     /*  94663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  94671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  94674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94680 */     // MIs[0] base
     /*  94680 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94696 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  94700 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  94704 */     // (intrinsic_void 3718:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, MQPR:{ *:[v8i16] }:$data, 16:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSTRH16_rq MQPR:{ *:[v8i16] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  94704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH16_rq),
     /*  94707 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94709 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94711 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94713 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94717 */     GIR_RootConstrainSelectedInstOperands,
     /*  94718 */     // GIR_Coverage, 4944,
     /*  94718 */     GIR_EraseRootFromParent_Done,
     /*  94719 */   // Label 1728: @94719
     /*  94719 */   GIM_Try, /*On fail goto*//*Label 1729*/ GIMT_Encode4(94780), // Rule ID 4947 //
     /*  94724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  94732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  94735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94741 */     // MIs[0] base
     /*  94741 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94757 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  94761 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  94765 */     // (intrinsic_void 3718:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets, MQPR:{ *:[v16i8] }:$data, 8:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRB8_rq MQPR:{ *:[v16i8] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets)
     /*  94765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRB8_rq),
     /*  94768 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94770 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94772 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94774 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94778 */     GIR_RootConstrainSelectedInstOperands,
     /*  94779 */     // GIR_Coverage, 4947,
     /*  94779 */     GIR_EraseRootFromParent_Done,
     /*  94780 */   // Label 1729: @94780
     /*  94780 */   GIM_Try, /*On fail goto*//*Label 1730*/ GIMT_Encode4(94841), // Rule ID 5027 //
     /*  94785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  94793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  94796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94802 */     // MIs[0] base
     /*  94802 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94818 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  94822 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  94826 */     // (intrinsic_void 3718:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, MQPR:{ *:[v8i16] }:$data, 8:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRB16_rq MQPR:{ *:[v8i16] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  94826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRB16_rq),
     /*  94829 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94831 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94833 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94835 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94839 */     GIR_RootConstrainSelectedInstOperands,
     /*  94840 */     // GIR_Coverage, 5027,
     /*  94840 */     GIR_EraseRootFromParent_Done,
     /*  94841 */   // Label 1730: @94841
     /*  94841 */   GIM_Try, /*On fail goto*//*Label 1731*/ GIMT_Encode4(94902), // Rule ID 5029 //
     /*  94846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  94857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94863 */     // MIs[0] base
     /*  94863 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94867 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94879 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  94883 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  94887 */     // (intrinsic_void 3718:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4i32] }:$data, 8:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRB32_rq MQPR:{ *:[v4i32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  94887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRB32_rq),
     /*  94890 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94892 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94894 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94900 */     GIR_RootConstrainSelectedInstOperands,
     /*  94901 */     // GIR_Coverage, 5029,
     /*  94901 */     GIR_EraseRootFromParent_Done,
     /*  94902 */   // Label 1731: @94902
     /*  94902 */   GIM_Try, /*On fail goto*//*Label 1732*/ GIMT_Encode4(94963), // Rule ID 5031 //
     /*  94907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  94915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  94918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94924 */     // MIs[0] base
     /*  94924 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94940 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  94944 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  94948 */     // (intrinsic_void 3718:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, MQPR:{ *:[v8f16] }:$data, 16:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRH16_rq_u MQPR:{ *:[v8f16] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  94948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH16_rq_u),
     /*  94951 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94953 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94955 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94957 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94961 */     GIR_RootConstrainSelectedInstOperands,
     /*  94962 */     // GIR_Coverage, 5031,
     /*  94962 */     GIR_EraseRootFromParent_Done,
     /*  94963 */   // Label 1732: @94963
     /*  94963 */   GIM_Try, /*On fail goto*//*Label 1733*/ GIMT_Encode4(95024), // Rule ID 5032 //
     /*  94968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  94976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  94979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94985 */     // MIs[0] base
     /*  94985 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94989 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95001 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  95005 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  95009 */     // (intrinsic_void 3718:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, MQPR:{ *:[v8f16] }:$data, 16:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSTRH16_rq MQPR:{ *:[v8f16] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  95009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH16_rq),
     /*  95012 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95014 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95016 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95018 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95022 */     GIR_RootConstrainSelectedInstOperands,
     /*  95023 */     // GIR_Coverage, 5032,
     /*  95023 */     GIR_EraseRootFromParent_Done,
     /*  95024 */   // Label 1733: @95024
     /*  95024 */   GIM_Try, /*On fail goto*//*Label 1734*/ GIMT_Encode4(95085), // Rule ID 5035 //
     /*  95029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95046 */     // MIs[0] base
     /*  95046 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95062 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  95066 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  95070 */     // (intrinsic_void 3718:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4i32] }:$data, 16:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRH32_rq_u MQPR:{ *:[v4i32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  95070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH32_rq_u),
     /*  95073 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95075 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95077 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95079 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95083 */     GIR_RootConstrainSelectedInstOperands,
     /*  95084 */     // GIR_Coverage, 5035,
     /*  95084 */     GIR_EraseRootFromParent_Done,
     /*  95085 */   // Label 1734: @95085
     /*  95085 */   GIM_Try, /*On fail goto*//*Label 1735*/ GIMT_Encode4(95146), // Rule ID 5036 //
     /*  95090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95107 */     // MIs[0] base
     /*  95107 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95123 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  95127 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  95131 */     // (intrinsic_void 3718:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4i32] }:$data, 16:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSTRH32_rq MQPR:{ *:[v4i32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  95131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH32_rq),
     /*  95134 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95136 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95138 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95140 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95144 */     GIR_RootConstrainSelectedInstOperands,
     /*  95145 */     // GIR_Coverage, 5036,
     /*  95145 */     GIR_EraseRootFromParent_Done,
     /*  95146 */   // Label 1735: @95146
     /*  95146 */   GIM_Try, /*On fail goto*//*Label 1736*/ GIMT_Encode4(95207), // Rule ID 5039 //
     /*  95151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95168 */     // MIs[0] base
     /*  95168 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95172 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95184 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  95188 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  95192 */     // (intrinsic_void 3718:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4i32] }:$data, 32:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRW32_rq_u MQPR:{ *:[v4i32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  95192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_rq_u),
     /*  95195 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95197 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95199 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95201 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95205 */     GIR_RootConstrainSelectedInstOperands,
     /*  95206 */     // GIR_Coverage, 5039,
     /*  95206 */     GIR_EraseRootFromParent_Done,
     /*  95207 */   // Label 1736: @95207
     /*  95207 */   GIM_Try, /*On fail goto*//*Label 1737*/ GIMT_Encode4(95268), // Rule ID 5040 //
     /*  95212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95229 */     // MIs[0] base
     /*  95229 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95245 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  95249 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  95253 */     // (intrinsic_void 3718:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4i32] }:$data, 32:{ *:[i32] }, 2:{ *:[i32] })  =>  (MVE_VSTRW32_rq MQPR:{ *:[v4i32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  95253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_rq),
     /*  95256 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95258 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95260 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95262 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95266 */     GIR_RootConstrainSelectedInstOperands,
     /*  95267 */     // GIR_Coverage, 5040,
     /*  95267 */     GIR_EraseRootFromParent_Done,
     /*  95268 */   // Label 1737: @95268
     /*  95268 */   GIM_Try, /*On fail goto*//*Label 1738*/ GIMT_Encode4(95329), // Rule ID 5043 //
     /*  95273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95290 */     // MIs[0] base
     /*  95290 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95294 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95306 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  95310 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  95314 */     // (intrinsic_void 3718:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4f32] }:$data, 32:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRW32_rq_u MQPR:{ *:[v4f32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  95314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_rq_u),
     /*  95317 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95319 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95321 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95323 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95327 */     GIR_RootConstrainSelectedInstOperands,
     /*  95328 */     // GIR_Coverage, 5043,
     /*  95328 */     GIR_EraseRootFromParent_Done,
     /*  95329 */   // Label 1738: @95329
     /*  95329 */   GIM_Try, /*On fail goto*//*Label 1739*/ GIMT_Encode4(95390), // Rule ID 5044 //
     /*  95334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95351 */     // MIs[0] base
     /*  95351 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95367 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  95371 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  95375 */     // (intrinsic_void 3718:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4f32] }:$data, 32:{ *:[i32] }, 2:{ *:[i32] })  =>  (MVE_VSTRW32_rq MQPR:{ *:[v4f32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  95375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_rq),
     /*  95378 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95380 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95382 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95384 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95388 */     GIR_RootConstrainSelectedInstOperands,
     /*  95389 */     // GIR_Coverage, 5044,
     /*  95389 */     GIR_EraseRootFromParent_Done,
     /*  95390 */   // Label 1739: @95390
     /*  95390 */   GIM_Try, /*On fail goto*//*Label 1740*/ GIMT_Encode4(95451), // Rule ID 5047 //
     /*  95395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  95403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  95406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95412 */     // MIs[0] base
     /*  95412 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95416 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95428 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  95432 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  95436 */     // (intrinsic_void 3718:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, MQPR:{ *:[v2i64] }:$data, 64:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRD64_rq_u MQPR:{ *:[v2i64] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  95436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_rq_u),
     /*  95439 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95441 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95443 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95445 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95449 */     GIR_RootConstrainSelectedInstOperands,
     /*  95450 */     // GIR_Coverage, 5047,
     /*  95450 */     GIR_EraseRootFromParent_Done,
     /*  95451 */   // Label 1740: @95451
     /*  95451 */   GIM_Try, /*On fail goto*//*Label 1741*/ GIMT_Encode4(95512), // Rule ID 5048 //
     /*  95456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  95464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  95467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95473 */     // MIs[0] base
     /*  95473 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95477 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95489 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  95493 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 3,
     /*  95497 */     // (intrinsic_void 3718:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, MQPR:{ *:[v2i64] }:$data, 64:{ *:[i32] }, 3:{ *:[i32] })  =>  (MVE_VSTRD64_rq MQPR:{ *:[v2i64] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  95497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_rq),
     /*  95500 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95502 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95504 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95506 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95510 */     GIR_RootConstrainSelectedInstOperands,
     /*  95511 */     // GIR_Coverage, 5048,
     /*  95511 */     GIR_EraseRootFromParent_Done,
     /*  95512 */   // Label 1741: @95512
     /*  95512 */   GIM_Try, /*On fail goto*//*Label 1742*/ GIMT_Encode4(95576), // Rule ID 258 //
     /*  95517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  95520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcrr),
     /*  95525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  95528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95531 */     // MIs[0] cop
     /*  95531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95534 */     // MIs[0] opc1
     /*  95534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  95541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  95545 */     // MIs[0] CRm
     /*  95545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95548 */     // (intrinsic_void 3522:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPRnopc:{ *:[i32] }:$Rt, GPRnopc:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)  =>  (MCRR (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPRnopc:{ *:[i32] }:$Rt, GPRnopc:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)
     /*  95548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MCRR),
     /*  95551 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95553 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95555 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  95557 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rt2
     /*  95559 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  95564 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  95570 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95574 */     GIR_RootConstrainSelectedInstOperands,
     /*  95575 */     // GIR_Coverage, 258,
     /*  95575 */     GIR_EraseRootFromParent_Done,
     /*  95576 */   // Label 1742: @95576
     /*  95576 */   GIM_Try, /*On fail goto*//*Label 1743*/ GIMT_Encode4(95631), // Rule ID 259 //
     /*  95581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_PreV8),
     /*  95584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcrr2),
     /*  95589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  95592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95595 */     // MIs[0] cop
     /*  95595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95598 */     // MIs[0] opc1
     /*  95598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  95605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  95609 */     // MIs[0] CRm
     /*  95609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95612 */     // (intrinsic_void 3523:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPRnopc:{ *:[i32] }:$Rt, GPRnopc:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)  =>  (MCRR2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPRnopc:{ *:[i32] }:$Rt, GPRnopc:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)
     /*  95612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MCRR2),
     /*  95615 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95617 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95619 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  95621 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rt2
     /*  95623 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95625 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95629 */     GIR_RootConstrainSelectedInstOperands,
     /*  95630 */     // GIR_Coverage, 259,
     /*  95630 */     GIR_EraseRootFromParent_Done,
     /*  95631 */   // Label 1743: @95631
     /*  95631 */   GIM_Try, /*On fail goto*//*Label 1744*/ GIMT_Encode4(95695), // Rule ID 596 //
     /*  95636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  95639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcrr),
     /*  95644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  95647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95650 */     // MIs[0] cop
     /*  95650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95653 */     // MIs[0] opc1
     /*  95653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95664 */     // MIs[0] CRm
     /*  95664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95667 */     // (intrinsic_void 3522:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, GPR:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)  =>  (t2MCRR (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, GPR:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)
     /*  95667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MCRR),
     /*  95670 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95672 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  95676 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rt2
     /*  95678 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  95683 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  95689 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95693 */     GIR_RootConstrainSelectedInstOperands,
     /*  95694 */     // GIR_Coverage, 596,
     /*  95694 */     GIR_EraseRootFromParent_Done,
     /*  95695 */   // Label 1744: @95695
     /*  95695 */   GIM_Try, /*On fail goto*//*Label 1745*/ GIMT_Encode4(95759), // Rule ID 597 //
     /*  95700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_PreV8),
     /*  95703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcrr2),
     /*  95708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  95711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95714 */     // MIs[0] cop
     /*  95714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95717 */     // MIs[0] opc1
     /*  95717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95728 */     // MIs[0] CRm
     /*  95728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95731 */     // (intrinsic_void 3523:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, GPR:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)  =>  (t2MCRR2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, GPR:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)
     /*  95731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MCRR2),
     /*  95734 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95736 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  95740 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rt2
     /*  95742 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  95747 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  95753 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95757 */     GIR_RootConstrainSelectedInstOperands,
     /*  95758 */     // GIR_Coverage, 597,
     /*  95758 */     GIR_EraseRootFromParent_Done,
     /*  95759 */   // Label 1745: @95759
     /*  95759 */   GIM_Reject,
     /*  95760 */ // Label 1726: @95760
     /*  95760 */ GIM_Try, /*On fail goto*//*Label 1746*/ GIMT_Encode4(99111),
     /*  95765 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/7,
     /*  95768 */   GIM_Try, /*On fail goto*//*Label 1747*/ GIMT_Encode4(95829), // Rule ID 246 //
     /*  95773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_PreV8),
     /*  95776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_cdp),
     /*  95781 */     // MIs[0] cop
     /*  95781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95784 */     // MIs[0] opc1
     /*  95784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95787 */     // MIs[0] CRd
     /*  95787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  95790 */     // MIs[0] CRn
     /*  95790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  95793 */     // MIs[0] CRm
     /*  95793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95796 */     // MIs[0] opc2
     /*  95796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  95799 */     // (intrinsic_void 3490:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (CDP (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  95799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CDP),
     /*  95802 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95804 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95806 */     GIR_RootToRootCopy, /*OpIdx*/3, // CRd
     /*  95808 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  95810 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95812 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  95814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  95817 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  95823 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95827 */     GIR_RootConstrainSelectedInstOperands,
     /*  95828 */     // GIR_Coverage, 246,
     /*  95828 */     GIR_EraseRootFromParent_Done,
     /*  95829 */   // Label 1747: @95829
     /*  95829 */   GIM_Try, /*On fail goto*//*Label 1748*/ GIMT_Encode4(95881), // Rule ID 247 //
     /*  95834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_PreV8),
     /*  95837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_cdp2),
     /*  95842 */     // MIs[0] cop
     /*  95842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95845 */     // MIs[0] opc1
     /*  95845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95848 */     // MIs[0] CRd
     /*  95848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  95851 */     // MIs[0] CRn
     /*  95851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  95854 */     // MIs[0] CRm
     /*  95854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95857 */     // MIs[0] opc2
     /*  95857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  95860 */     // (intrinsic_void 3491:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (CDP2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  95860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CDP2),
     /*  95863 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95865 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95867 */     GIR_RootToRootCopy, /*OpIdx*/3, // CRd
     /*  95869 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  95871 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95873 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  95875 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95879 */     GIR_RootConstrainSelectedInstOperands,
     /*  95880 */     // GIR_Coverage, 247,
     /*  95880 */     GIR_EraseRootFromParent_Done,
     /*  95881 */   // Label 1748: @95881
     /*  95881 */   GIM_Try, /*On fail goto*//*Label 1749*/ GIMT_Encode4(95942), // Rule ID 598 //
     /*  95886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_PreV8),
     /*  95889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_cdp),
     /*  95894 */     // MIs[0] cop
     /*  95894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95897 */     // MIs[0] opc1
     /*  95897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95900 */     // MIs[0] CRd
     /*  95900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  95903 */     // MIs[0] CRn
     /*  95903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  95906 */     // MIs[0] CRm
     /*  95906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95909 */     // MIs[0] opc2
     /*  95909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  95912 */     // (intrinsic_void 3490:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (t2CDP (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  95912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CDP),
     /*  95915 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95917 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95919 */     GIR_RootToRootCopy, /*OpIdx*/3, // CRd
     /*  95921 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  95923 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95925 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  95927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  95930 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  95936 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95940 */     GIR_RootConstrainSelectedInstOperands,
     /*  95941 */     // GIR_Coverage, 598,
     /*  95941 */     GIR_EraseRootFromParent_Done,
     /*  95942 */   // Label 1749: @95942
     /*  95942 */   GIM_Try, /*On fail goto*//*Label 1750*/ GIMT_Encode4(96003), // Rule ID 599 //
     /*  95947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_PreV8),
     /*  95950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_cdp2),
     /*  95955 */     // MIs[0] cop
     /*  95955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95958 */     // MIs[0] opc1
     /*  95958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95961 */     // MIs[0] CRd
     /*  95961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  95964 */     // MIs[0] CRn
     /*  95964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  95967 */     // MIs[0] CRm
     /*  95967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95970 */     // MIs[0] opc2
     /*  95970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  95973 */     // (intrinsic_void 3491:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (t2CDP2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  95973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CDP2),
     /*  95976 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95978 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95980 */     GIR_RootToRootCopy, /*OpIdx*/3, // CRd
     /*  95982 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  95984 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95986 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  95988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  95991 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  95997 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96001 */     GIR_RootConstrainSelectedInstOperands,
     /*  96002 */     // GIR_Coverage, 599,
     /*  96002 */     GIR_EraseRootFromParent_Done,
     /*  96003 */   // Label 1750: @96003
     /*  96003 */   GIM_Try, /*On fail goto*//*Label 1751*/ GIMT_Encode4(96071), // Rule ID 4937 //
     /*  96008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96032 */     // MIs[0] base
     /*  96032 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96044 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96048 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96052 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96056 */     // (intrinsic_w_chain:{ *:[v8i16] } 3645:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  96059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96061 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96063 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96065 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96069 */     GIR_RootConstrainSelectedInstOperands,
     /*  96070 */     // GIR_Coverage, 4937,
     /*  96070 */     GIR_EraseRootFromParent_Done,
     /*  96071 */   // Label 1751: @96071
     /*  96071 */   GIM_Try, /*On fail goto*//*Label 1752*/ GIMT_Encode4(96139), // Rule ID 4938 //
     /*  96076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96100 */     // MIs[0] base
     /*  96100 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96112 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96116 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  96120 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96124 */     // (intrinsic_w_chain:{ *:[v8i16] } 3645:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  96127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96129 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96131 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96133 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96137 */     GIR_RootConstrainSelectedInstOperands,
     /*  96138 */     // GIR_Coverage, 4938,
     /*  96138 */     GIR_EraseRootFromParent_Done,
     /*  96139 */   // Label 1752: @96139
     /*  96139 */   GIM_Try, /*On fail goto*//*Label 1753*/ GIMT_Encode4(96207), // Rule ID 4941 //
     /*  96144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  96152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  96155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96168 */     // MIs[0] base
     /*  96168 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96180 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  96184 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96188 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96192 */     // (intrinsic_w_chain:{ *:[v16i8] } 3645:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRBU8_rq:{ *:[v16i8] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets)
     /*  96192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBU8_rq),
     /*  96195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96197 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96199 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96201 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96205 */     GIR_RootConstrainSelectedInstOperands,
     /*  96206 */     // GIR_Coverage, 4941,
     /*  96206 */     GIR_EraseRootFromParent_Done,
     /*  96207 */   // Label 1753: @96207
     /*  96207 */   GIM_Try, /*On fail goto*//*Label 1754*/ GIMT_Encode4(96275), // Rule ID 4949 //
     /*  96212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  96220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  96223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96236 */     // MIs[0] base
     /*  96236 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96248 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  96252 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96256 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96260 */     // (intrinsic_w_chain:{ *:[v16i8] } 3645:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRBU8_rq:{ *:[v16i8] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets)
     /*  96260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBU8_rq),
     /*  96263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96265 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96267 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96269 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96273 */     GIR_RootConstrainSelectedInstOperands,
     /*  96274 */     // GIR_Coverage, 4949,
     /*  96274 */     GIR_EraseRootFromParent_Done,
     /*  96275 */   // Label 1754: @96275
     /*  96275 */   GIM_Try, /*On fail goto*//*Label 1755*/ GIMT_Encode4(96343), // Rule ID 4951 //
     /*  96280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96304 */     // MIs[0] base
     /*  96304 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96316 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  96320 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96324 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96328 */     // (intrinsic_w_chain:{ *:[v8i16] } 3645:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRBU16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBU16_rq),
     /*  96331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96333 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96335 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96337 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96341 */     GIR_RootConstrainSelectedInstOperands,
     /*  96342 */     // GIR_Coverage, 4951,
     /*  96342 */     GIR_EraseRootFromParent_Done,
     /*  96343 */   // Label 1755: @96343
     /*  96343 */   GIM_Try, /*On fail goto*//*Label 1756*/ GIMT_Encode4(96411), // Rule ID 4953 //
     /*  96348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96372 */     // MIs[0] base
     /*  96372 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96384 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  96388 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96392 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96396 */     // (intrinsic_w_chain:{ *:[v8i16] } 3645:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRBS16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBS16_rq),
     /*  96399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96401 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96403 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96405 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96409 */     GIR_RootConstrainSelectedInstOperands,
     /*  96410 */     // GIR_Coverage, 4953,
     /*  96410 */     GIR_EraseRootFromParent_Done,
     /*  96411 */   // Label 1756: @96411
     /*  96411 */   GIM_Try, /*On fail goto*//*Label 1757*/ GIMT_Encode4(96479), // Rule ID 4955 //
     /*  96416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  96424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  96427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96440 */     // MIs[0] base
     /*  96440 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96452 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  96456 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96460 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96464 */     // (intrinsic_w_chain:{ *:[v4i32] } 3645:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRBU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  96464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBU32_rq),
     /*  96467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96469 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96471 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96473 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96477 */     GIR_RootConstrainSelectedInstOperands,
     /*  96478 */     // GIR_Coverage, 4955,
     /*  96478 */     GIR_EraseRootFromParent_Done,
     /*  96479 */   // Label 1757: @96479
     /*  96479 */   GIM_Try, /*On fail goto*//*Label 1758*/ GIMT_Encode4(96547), // Rule ID 4957 //
     /*  96484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  96492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  96495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96508 */     // MIs[0] base
     /*  96508 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96520 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  96524 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96528 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96532 */     // (intrinsic_w_chain:{ *:[v4i32] } 3645:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRBS32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  96532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBS32_rq),
     /*  96535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96537 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96539 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96541 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96545 */     GIR_RootConstrainSelectedInstOperands,
     /*  96546 */     // GIR_Coverage, 4957,
     /*  96546 */     GIR_EraseRootFromParent_Done,
     /*  96547 */   // Label 1758: @96547
     /*  96547 */   GIM_Try, /*On fail goto*//*Label 1759*/ GIMT_Encode4(96615), // Rule ID 4959 //
     /*  96552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96576 */     // MIs[0] base
     /*  96576 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96588 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96592 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96596 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96600 */     // (intrinsic_w_chain:{ *:[v8i16] } 3645:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  96603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96605 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96607 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96609 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96613 */     GIR_RootConstrainSelectedInstOperands,
     /*  96614 */     // GIR_Coverage, 4959,
     /*  96614 */     GIR_EraseRootFromParent_Done,
     /*  96615 */   // Label 1759: @96615
     /*  96615 */   GIM_Try, /*On fail goto*//*Label 1760*/ GIMT_Encode4(96683), // Rule ID 4960 //
     /*  96620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96644 */     // MIs[0] base
     /*  96644 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96656 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96660 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  96664 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96668 */     // (intrinsic_w_chain:{ *:[v8i16] } 3645:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  96671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96673 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96675 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96677 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96681 */     GIR_RootConstrainSelectedInstOperands,
     /*  96682 */     // GIR_Coverage, 4960,
     /*  96682 */     GIR_EraseRootFromParent_Done,
     /*  96683 */   // Label 1760: @96683
     /*  96683 */   GIM_Try, /*On fail goto*//*Label 1761*/ GIMT_Encode4(96751), // Rule ID 4963 //
     /*  96688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96712 */     // MIs[0] base
     /*  96712 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96724 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96728 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96732 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96736 */     // (intrinsic_w_chain:{ *:[v8i16] } 3645:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  96739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96741 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96743 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96745 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96749 */     GIR_RootConstrainSelectedInstOperands,
     /*  96750 */     // GIR_Coverage, 4963,
     /*  96750 */     GIR_EraseRootFromParent_Done,
     /*  96751 */   // Label 1761: @96751
     /*  96751 */   GIM_Try, /*On fail goto*//*Label 1762*/ GIMT_Encode4(96819), // Rule ID 4964 //
     /*  96756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96780 */     // MIs[0] base
     /*  96780 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96792 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96796 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  96800 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96804 */     // (intrinsic_w_chain:{ *:[v8i16] } 3645:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  96807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96809 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96811 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96813 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96817 */     GIR_RootConstrainSelectedInstOperands,
     /*  96818 */     // GIR_Coverage, 4964,
     /*  96818 */     GIR_EraseRootFromParent_Done,
     /*  96819 */   // Label 1762: @96819
     /*  96819 */   GIM_Try, /*On fail goto*//*Label 1763*/ GIMT_Encode4(96887), // Rule ID 4967 //
     /*  96824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96848 */     // MIs[0] base
     /*  96848 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96860 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96864 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96868 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96872 */     // (intrinsic_w_chain:{ *:[v8i16] } 3645:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  96875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96877 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96879 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96881 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96885 */     GIR_RootConstrainSelectedInstOperands,
     /*  96886 */     // GIR_Coverage, 4967,
     /*  96886 */     GIR_EraseRootFromParent_Done,
     /*  96887 */   // Label 1763: @96887
     /*  96887 */   GIM_Try, /*On fail goto*//*Label 1764*/ GIMT_Encode4(96955), // Rule ID 4968 //
     /*  96892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96916 */     // MIs[0] base
     /*  96916 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96928 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96932 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  96936 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96940 */     // (intrinsic_w_chain:{ *:[v8i16] } 3645:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  96943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96945 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96947 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96949 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96953 */     GIR_RootConstrainSelectedInstOperands,
     /*  96954 */     // GIR_Coverage, 4968,
     /*  96954 */     GIR_EraseRootFromParent_Done,
     /*  96955 */   // Label 1764: @96955
     /*  96955 */   GIM_Try, /*On fail goto*//*Label 1765*/ GIMT_Encode4(97023), // Rule ID 4971 //
     /*  96960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96984 */     // MIs[0] base
     /*  96984 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96996 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97000 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97004 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97008 */     // (intrinsic_w_chain:{ *:[v8f16] } 3645:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8f16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  97008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  97011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97013 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97015 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97017 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97021 */     GIR_RootConstrainSelectedInstOperands,
     /*  97022 */     // GIR_Coverage, 4971,
     /*  97022 */     GIR_EraseRootFromParent_Done,
     /*  97023 */   // Label 1765: @97023
     /*  97023 */   GIM_Try, /*On fail goto*//*Label 1766*/ GIMT_Encode4(97091), // Rule ID 4972 //
     /*  97028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  97036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97052 */     // MIs[0] base
     /*  97052 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97064 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97068 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  97072 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97076 */     // (intrinsic_w_chain:{ *:[v8f16] } 3645:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8f16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  97076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  97079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97081 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97083 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97085 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97089 */     GIR_RootConstrainSelectedInstOperands,
     /*  97090 */     // GIR_Coverage, 4972,
     /*  97090 */     GIR_EraseRootFromParent_Done,
     /*  97091 */   // Label 1766: @97091
     /*  97091 */   GIM_Try, /*On fail goto*//*Label 1767*/ GIMT_Encode4(97159), // Rule ID 4975 //
     /*  97096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  97104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97120 */     // MIs[0] base
     /*  97120 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97132 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97136 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97140 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97144 */     // (intrinsic_w_chain:{ *:[v8f16] } 3645:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8f16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  97144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  97147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97149 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97151 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97153 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97157 */     GIR_RootConstrainSelectedInstOperands,
     /*  97158 */     // GIR_Coverage, 4975,
     /*  97158 */     GIR_EraseRootFromParent_Done,
     /*  97159 */   // Label 1767: @97159
     /*  97159 */   GIM_Try, /*On fail goto*//*Label 1768*/ GIMT_Encode4(97227), // Rule ID 4976 //
     /*  97164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  97172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97188 */     // MIs[0] base
     /*  97188 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97200 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97204 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  97208 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97212 */     // (intrinsic_w_chain:{ *:[v8f16] } 3645:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8f16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  97212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  97215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97217 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97219 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97221 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97225 */     GIR_RootConstrainSelectedInstOperands,
     /*  97226 */     // GIR_Coverage, 4976,
     /*  97226 */     GIR_EraseRootFromParent_Done,
     /*  97227 */   // Label 1768: @97227
     /*  97227 */   GIM_Try, /*On fail goto*//*Label 1769*/ GIMT_Encode4(97295), // Rule ID 4979 //
     /*  97232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97256 */     // MIs[0] base
     /*  97256 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97268 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97272 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97276 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97280 */     // (intrinsic_w_chain:{ *:[v4i32] } 3645:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU32_rq_u),
     /*  97283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97285 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97287 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97289 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97293 */     GIR_RootConstrainSelectedInstOperands,
     /*  97294 */     // GIR_Coverage, 4979,
     /*  97294 */     GIR_EraseRootFromParent_Done,
     /*  97295 */   // Label 1769: @97295
     /*  97295 */   GIM_Try, /*On fail goto*//*Label 1770*/ GIMT_Encode4(97363), // Rule ID 4980 //
     /*  97300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97324 */     // MIs[0] base
     /*  97324 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97336 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97340 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  97344 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97348 */     // (intrinsic_w_chain:{ *:[v4i32] } 3645:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU32_rq),
     /*  97351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97353 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97355 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97357 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97361 */     GIR_RootConstrainSelectedInstOperands,
     /*  97362 */     // GIR_Coverage, 4980,
     /*  97362 */     GIR_EraseRootFromParent_Done,
     /*  97363 */   // Label 1770: @97363
     /*  97363 */   GIM_Try, /*On fail goto*//*Label 1771*/ GIMT_Encode4(97431), // Rule ID 4983 //
     /*  97368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97392 */     // MIs[0] base
     /*  97392 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97404 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97408 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97412 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97416 */     // (intrinsic_w_chain:{ *:[v4i32] } 3645:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHS32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHS32_rq_u),
     /*  97419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97421 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97423 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97425 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97429 */     GIR_RootConstrainSelectedInstOperands,
     /*  97430 */     // GIR_Coverage, 4983,
     /*  97430 */     GIR_EraseRootFromParent_Done,
     /*  97431 */   // Label 1771: @97431
     /*  97431 */   GIM_Try, /*On fail goto*//*Label 1772*/ GIMT_Encode4(97499), // Rule ID 4984 //
     /*  97436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97460 */     // MIs[0] base
     /*  97460 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97472 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97476 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  97480 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97484 */     // (intrinsic_w_chain:{ *:[v4i32] } 3645:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHS32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHS32_rq),
     /*  97487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97489 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97491 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97493 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97497 */     GIR_RootConstrainSelectedInstOperands,
     /*  97498 */     // GIR_Coverage, 4984,
     /*  97498 */     GIR_EraseRootFromParent_Done,
     /*  97499 */   // Label 1772: @97499
     /*  97499 */   GIM_Try, /*On fail goto*//*Label 1773*/ GIMT_Encode4(97567), // Rule ID 4987 //
     /*  97504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97528 */     // MIs[0] base
     /*  97528 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97540 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97544 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97548 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97552 */     // (intrinsic_w_chain:{ *:[v4i32] } 3645:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  97555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97557 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97559 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97561 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97565 */     GIR_RootConstrainSelectedInstOperands,
     /*  97566 */     // GIR_Coverage, 4987,
     /*  97566 */     GIR_EraseRootFromParent_Done,
     /*  97567 */   // Label 1773: @97567
     /*  97567 */   GIM_Try, /*On fail goto*//*Label 1774*/ GIMT_Encode4(97635), // Rule ID 4988 //
     /*  97572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97596 */     // MIs[0] base
     /*  97596 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97608 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97612 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  97616 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97620 */     // (intrinsic_w_chain:{ *:[v4i32] } 3645:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  97623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97625 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97627 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97629 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97633 */     GIR_RootConstrainSelectedInstOperands,
     /*  97634 */     // GIR_Coverage, 4988,
     /*  97634 */     GIR_EraseRootFromParent_Done,
     /*  97635 */   // Label 1774: @97635
     /*  97635 */   GIM_Try, /*On fail goto*//*Label 1775*/ GIMT_Encode4(97703), // Rule ID 4991 //
     /*  97640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97664 */     // MIs[0] base
     /*  97664 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97676 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97680 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97684 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97688 */     // (intrinsic_w_chain:{ *:[v4i32] } 3645:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  97691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97693 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97695 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97697 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97701 */     GIR_RootConstrainSelectedInstOperands,
     /*  97702 */     // GIR_Coverage, 4991,
     /*  97702 */     GIR_EraseRootFromParent_Done,
     /*  97703 */   // Label 1775: @97703
     /*  97703 */   GIM_Try, /*On fail goto*//*Label 1776*/ GIMT_Encode4(97771), // Rule ID 4992 //
     /*  97708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97732 */     // MIs[0] base
     /*  97732 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97744 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97748 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  97752 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97756 */     // (intrinsic_w_chain:{ *:[v4i32] } 3645:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  97759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97761 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97763 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97765 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97769 */     GIR_RootConstrainSelectedInstOperands,
     /*  97770 */     // GIR_Coverage, 4992,
     /*  97770 */     GIR_EraseRootFromParent_Done,
     /*  97771 */   // Label 1776: @97771
     /*  97771 */   GIM_Try, /*On fail goto*//*Label 1777*/ GIMT_Encode4(97839), // Rule ID 4995 //
     /*  97776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97800 */     // MIs[0] base
     /*  97800 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97812 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97816 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97820 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97824 */     // (intrinsic_w_chain:{ *:[v4i32] } 3645:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  97827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97829 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97831 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97833 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97837 */     GIR_RootConstrainSelectedInstOperands,
     /*  97838 */     // GIR_Coverage, 4995,
     /*  97838 */     GIR_EraseRootFromParent_Done,
     /*  97839 */   // Label 1777: @97839
     /*  97839 */   GIM_Try, /*On fail goto*//*Label 1778*/ GIMT_Encode4(97907), // Rule ID 4996 //
     /*  97844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97868 */     // MIs[0] base
     /*  97868 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97880 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97884 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  97888 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97892 */     // (intrinsic_w_chain:{ *:[v4i32] } 3645:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  97895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97897 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97899 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97901 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97905 */     GIR_RootConstrainSelectedInstOperands,
     /*  97906 */     // GIR_Coverage, 4996,
     /*  97906 */     GIR_EraseRootFromParent_Done,
     /*  97907 */   // Label 1778: @97907
     /*  97907 */   GIM_Try, /*On fail goto*//*Label 1779*/ GIMT_Encode4(97975), // Rule ID 4999 //
     /*  97912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97936 */     // MIs[0] base
     /*  97936 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97948 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97952 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97956 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97960 */     // (intrinsic_w_chain:{ *:[v4i32] } 3645:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  97963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97965 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97967 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97969 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97973 */     GIR_RootConstrainSelectedInstOperands,
     /*  97974 */     // GIR_Coverage, 4999,
     /*  97974 */     GIR_EraseRootFromParent_Done,
     /*  97975 */   // Label 1779: @97975
     /*  97975 */   GIM_Try, /*On fail goto*//*Label 1780*/ GIMT_Encode4(98043), // Rule ID 5000 //
     /*  97980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98004 */     // MIs[0] base
     /*  98004 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98016 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  98020 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  98024 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98028 */     // (intrinsic_w_chain:{ *:[v4i32] } 3645:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  98028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  98031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98033 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98035 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98037 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98041 */     GIR_RootConstrainSelectedInstOperands,
     /*  98042 */     // GIR_Coverage, 5000,
     /*  98042 */     GIR_EraseRootFromParent_Done,
     /*  98043 */   // Label 1780: @98043
     /*  98043 */   GIM_Try, /*On fail goto*//*Label 1781*/ GIMT_Encode4(98111), // Rule ID 5003 //
     /*  98048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98072 */     // MIs[0] base
     /*  98072 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98084 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  98088 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  98092 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  98096 */     // (intrinsic_w_chain:{ *:[v4f32] } 3645:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4f32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  98096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  98099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98101 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98103 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98105 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98109 */     GIR_RootConstrainSelectedInstOperands,
     /*  98110 */     // GIR_Coverage, 5003,
     /*  98110 */     GIR_EraseRootFromParent_Done,
     /*  98111 */   // Label 1781: @98111
     /*  98111 */   GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(98179), // Rule ID 5004 //
     /*  98116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98140 */     // MIs[0] base
     /*  98140 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98152 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  98156 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  98160 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  98164 */     // (intrinsic_w_chain:{ *:[v4f32] } 3645:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4f32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  98164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  98167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98169 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98171 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98173 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98177 */     GIR_RootConstrainSelectedInstOperands,
     /*  98178 */     // GIR_Coverage, 5004,
     /*  98178 */     GIR_EraseRootFromParent_Done,
     /*  98179 */   // Label 1782: @98179
     /*  98179 */   GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(98247), // Rule ID 5007 //
     /*  98184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98208 */     // MIs[0] base
     /*  98208 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98220 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  98224 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  98228 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98232 */     // (intrinsic_w_chain:{ *:[v4f32] } 3645:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4f32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  98232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  98235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98237 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98239 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98241 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98245 */     GIR_RootConstrainSelectedInstOperands,
     /*  98246 */     // GIR_Coverage, 5007,
     /*  98246 */     GIR_EraseRootFromParent_Done,
     /*  98247 */   // Label 1783: @98247
     /*  98247 */   GIM_Try, /*On fail goto*//*Label 1784*/ GIMT_Encode4(98315), // Rule ID 5008 //
     /*  98252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98276 */     // MIs[0] base
     /*  98276 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98288 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  98292 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  98296 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98300 */     // (intrinsic_w_chain:{ *:[v4f32] } 3645:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4f32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  98300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  98303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98305 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98307 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98309 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98313 */     GIR_RootConstrainSelectedInstOperands,
     /*  98314 */     // GIR_Coverage, 5008,
     /*  98314 */     GIR_EraseRootFromParent_Done,
     /*  98315 */   // Label 1784: @98315
     /*  98315 */   GIM_Try, /*On fail goto*//*Label 1785*/ GIMT_Encode4(98383), // Rule ID 5011 //
     /*  98320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98344 */     // MIs[0] base
     /*  98344 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98356 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98360 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  98364 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  98368 */     // (intrinsic_w_chain:{ *:[v2i64] } 3645:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRDU64_rq_u:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq_u),
     /*  98371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98373 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98375 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98377 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98381 */     GIR_RootConstrainSelectedInstOperands,
     /*  98382 */     // GIR_Coverage, 5011,
     /*  98382 */     GIR_EraseRootFromParent_Done,
     /*  98383 */   // Label 1785: @98383
     /*  98383 */   GIM_Try, /*On fail goto*//*Label 1786*/ GIMT_Encode4(98451), // Rule ID 5012 //
     /*  98388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98412 */     // MIs[0] base
     /*  98412 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98424 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98428 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 3,
     /*  98432 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  98436 */     // (intrinsic_w_chain:{ *:[v2i64] } 3645:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 3:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRDU64_rq:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq),
     /*  98439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98441 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98443 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98445 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98449 */     GIR_RootConstrainSelectedInstOperands,
     /*  98450 */     // GIR_Coverage, 5012,
     /*  98450 */     GIR_EraseRootFromParent_Done,
     /*  98451 */   // Label 1786: @98451
     /*  98451 */   GIM_Try, /*On fail goto*//*Label 1787*/ GIMT_Encode4(98519), // Rule ID 5015 //
     /*  98456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98480 */     // MIs[0] base
     /*  98480 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98492 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98496 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  98500 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98504 */     // (intrinsic_w_chain:{ *:[v2i64] } 3645:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRDU64_rq_u:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq_u),
     /*  98507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98509 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98511 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98513 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98517 */     GIR_RootConstrainSelectedInstOperands,
     /*  98518 */     // GIR_Coverage, 5015,
     /*  98518 */     GIR_EraseRootFromParent_Done,
     /*  98519 */   // Label 1787: @98519
     /*  98519 */   GIM_Try, /*On fail goto*//*Label 1788*/ GIMT_Encode4(98587), // Rule ID 5016 //
     /*  98524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98548 */     // MIs[0] base
     /*  98548 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98560 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98564 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 3,
     /*  98568 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98572 */     // (intrinsic_w_chain:{ *:[v2i64] } 3645:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRDU64_rq:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq),
     /*  98575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98577 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98579 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98581 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98585 */     GIR_RootConstrainSelectedInstOperands,
     /*  98586 */     // GIR_Coverage, 5016,
     /*  98586 */     GIR_EraseRootFromParent_Done,
     /*  98587 */   // Label 1788: @98587
     /*  98587 */   GIM_Try, /*On fail goto*//*Label 1789*/ GIMT_Encode4(98655), // Rule ID 5019 //
     /*  98592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98616 */     // MIs[0] base
     /*  98616 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98628 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98632 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  98636 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  98640 */     // (intrinsic_w_chain:{ *:[v2i64] } 3645:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRDU64_rq_u:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq_u),
     /*  98643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98645 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98647 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98649 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98653 */     GIR_RootConstrainSelectedInstOperands,
     /*  98654 */     // GIR_Coverage, 5019,
     /*  98654 */     GIR_EraseRootFromParent_Done,
     /*  98655 */   // Label 1789: @98655
     /*  98655 */   GIM_Try, /*On fail goto*//*Label 1790*/ GIMT_Encode4(98723), // Rule ID 5020 //
     /*  98660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98684 */     // MIs[0] base
     /*  98684 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98696 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98700 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 3,
     /*  98704 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  98708 */     // (intrinsic_w_chain:{ *:[v2i64] } 3645:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 3:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRDU64_rq:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq),
     /*  98711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98713 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98715 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98717 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98721 */     GIR_RootConstrainSelectedInstOperands,
     /*  98722 */     // GIR_Coverage, 5020,
     /*  98722 */     GIR_EraseRootFromParent_Done,
     /*  98723 */   // Label 1790: @98723
     /*  98723 */   GIM_Try, /*On fail goto*//*Label 1791*/ GIMT_Encode4(98791), // Rule ID 5023 //
     /*  98728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98752 */     // MIs[0] base
     /*  98752 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98764 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98768 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  98772 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98776 */     // (intrinsic_w_chain:{ *:[v2i64] } 3645:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRDU64_rq_u:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq_u),
     /*  98779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98781 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98783 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98785 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98789 */     GIR_RootConstrainSelectedInstOperands,
     /*  98790 */     // GIR_Coverage, 5023,
     /*  98790 */     GIR_EraseRootFromParent_Done,
     /*  98791 */   // Label 1791: @98791
     /*  98791 */   GIM_Try, /*On fail goto*//*Label 1792*/ GIMT_Encode4(98859), // Rule ID 5024 //
     /*  98796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98820 */     // MIs[0] base
     /*  98820 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98832 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98836 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 3,
     /*  98840 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98844 */     // (intrinsic_w_chain:{ *:[v2i64] } 3645:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRDU64_rq:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq),
     /*  98847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98849 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98851 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98853 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98857 */     GIR_RootConstrainSelectedInstOperands,
     /*  98858 */     // GIR_Coverage, 5024,
     /*  98858 */     GIR_EraseRootFromParent_Done,
     /*  98859 */   // Label 1792: @98859
     /*  98859 */   GIM_Try, /*On fail goto*//*Label 1793*/ GIMT_Encode4(98924), // Rule ID 256 //
     /*  98864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  98867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcr),
     /*  98872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  98875 */     // MIs[0] cop
     /*  98875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  98878 */     // MIs[0] opc1
     /*  98878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  98881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98885 */     // MIs[0] CRn
     /*  98885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  98888 */     // MIs[0] CRm
     /*  98888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  98891 */     // MIs[0] opc2
     /*  98891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  98894 */     // (intrinsic_void 3520:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (MCR (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  98894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MCR),
     /*  98897 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  98899 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  98901 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  98903 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  98905 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  98907 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  98909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  98912 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  98918 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98922 */     GIR_RootConstrainSelectedInstOperands,
     /*  98923 */     // GIR_Coverage, 256,
     /*  98923 */     GIR_EraseRootFromParent_Done,
     /*  98924 */   // Label 1793: @98924
     /*  98924 */   GIM_Try, /*On fail goto*//*Label 1794*/ GIMT_Encode4(98980), // Rule ID 257 //
     /*  98929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_PreV8),
     /*  98932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcr2),
     /*  98937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  98940 */     // MIs[0] cop
     /*  98940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  98943 */     // MIs[0] opc1
     /*  98943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  98946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98950 */     // MIs[0] CRn
     /*  98950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  98953 */     // MIs[0] CRm
     /*  98953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  98956 */     // MIs[0] opc2
     /*  98956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  98959 */     // (intrinsic_void 3521:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (MCR2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  98959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MCR2),
     /*  98962 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  98964 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  98966 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  98968 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  98970 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  98972 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  98974 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98978 */     GIR_RootConstrainSelectedInstOperands,
     /*  98979 */     // GIR_Coverage, 257,
     /*  98979 */     GIR_EraseRootFromParent_Done,
     /*  98980 */   // Label 1794: @98980
     /*  98980 */   GIM_Try, /*On fail goto*//*Label 1795*/ GIMT_Encode4(99045), // Rule ID 594 //
     /*  98985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  98988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcr),
     /*  98993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  98996 */     // MIs[0] cop
     /*  98996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  98999 */     // MIs[0] opc1
     /*  98999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  99002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99006 */     // MIs[0] CRn
     /*  99006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99009 */     // MIs[0] CRm
     /*  99009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  99012 */     // MIs[0] opc2
     /*  99012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  99015 */     // (intrinsic_void 3520:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (t2MCR (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  99015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MCR),
     /*  99018 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  99020 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  99022 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  99024 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  99026 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  99028 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  99030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99033 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99039 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99043 */     GIR_RootConstrainSelectedInstOperands,
     /*  99044 */     // GIR_Coverage, 594,
     /*  99044 */     GIR_EraseRootFromParent_Done,
     /*  99045 */   // Label 1795: @99045
     /*  99045 */   GIM_Try, /*On fail goto*//*Label 1796*/ GIMT_Encode4(99110), // Rule ID 595 //
     /*  99050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_PreV8),
     /*  99053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcr2),
     /*  99058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  99061 */     // MIs[0] cop
     /*  99061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  99064 */     // MIs[0] opc1
     /*  99064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  99067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99071 */     // MIs[0] CRn
     /*  99071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99074 */     // MIs[0] CRm
     /*  99074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  99077 */     // MIs[0] opc2
     /*  99077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  99080 */     // (intrinsic_void 3521:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (t2MCR2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  99080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MCR2),
     /*  99083 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  99085 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  99087 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  99089 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  99091 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  99093 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  99095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99098 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99104 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99108 */     GIR_RootConstrainSelectedInstOperands,
     /*  99109 */     // GIR_Coverage, 595,
     /*  99109 */     GIR_EraseRootFromParent_Done,
     /*  99110 */   // Label 1796: @99110
     /*  99110 */   GIM_Reject,
     /*  99111 */ // Label 1746: @99111
     /*  99111 */ GIM_Reject,
     /*  99112 */ // Label 17: @99112
     /*  99112 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(13), /*)*//*default:*//*Label 1800*/ GIMT_Encode4(99269),
     /*  99123 */ /*GILLT_v2s64*//*Label 1797*/ GIMT_Encode4(99155), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99135 */ /*GILLT_v4s32*//*Label 1798*/ GIMT_Encode4(99193), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99151 */ /*GILLT_v8s16*//*Label 1799*/ GIMT_Encode4(99231),
     /*  99155 */ // Label 1797: @99155
     /*  99155 */ GIM_Try, /*On fail goto*//*Label 1801*/ GIMT_Encode4(99192), // Rule ID 2668 //
     /*  99160 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  99166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99170 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99174 */   // (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)  =>  (VMOVLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)
     /*  99174 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv2i64),
     /*  99177 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99179 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99181 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99184 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99190 */   GIR_RootConstrainSelectedInstOperands,
     /*  99191 */   // GIR_Coverage, 2668,
     /*  99191 */   GIR_EraseRootFromParent_Done,
     /*  99192 */ // Label 1801: @99192
     /*  99192 */ GIM_Reject,
     /*  99193 */ // Label 1798: @99193
     /*  99193 */ GIM_Try, /*On fail goto*//*Label 1802*/ GIMT_Encode4(99230), // Rule ID 2667 //
     /*  99198 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99201 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  99204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99208 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99212 */   // (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)  =>  (VMOVLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)
     /*  99212 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv4i32),
     /*  99215 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99217 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99219 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99222 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99228 */   GIR_RootConstrainSelectedInstOperands,
     /*  99229 */   // GIR_Coverage, 2667,
     /*  99229 */   GIR_EraseRootFromParent_Done,
     /*  99230 */ // Label 1802: @99230
     /*  99230 */ GIM_Reject,
     /*  99231 */ // Label 1799: @99231
     /*  99231 */ GIM_Try, /*On fail goto*//*Label 1803*/ GIMT_Encode4(99268), // Rule ID 2666 //
     /*  99236 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99239 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  99242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99246 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99250 */   // (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)  =>  (VMOVLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)
     /*  99250 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv8i16),
     /*  99253 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99255 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99257 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99260 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99266 */   GIR_RootConstrainSelectedInstOperands,
     /*  99267 */   // GIR_Coverage, 2666,
     /*  99267 */   GIR_EraseRootFromParent_Done,
     /*  99268 */ // Label 1803: @99268
     /*  99268 */ GIM_Reject,
     /*  99269 */ // Label 1800: @99269
     /*  99269 */ GIM_Reject,
     /*  99270 */ // Label 18: @99270
     /*  99270 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(12), /*)*//*default:*//*Label 1807*/ GIMT_Encode4(99427),
     /*  99281 */ /*GILLT_v2s32*//*Label 1804*/ GIMT_Encode4(99313), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99293 */ /*GILLT_v4s16*//*Label 1805*/ GIMT_Encode4(99351), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99309 */ /*GILLT_v8s8*//*Label 1806*/ GIMT_Encode4(99389),
     /*  99313 */ // Label 1804: @99313
     /*  99313 */ GIM_Try, /*On fail goto*//*Label 1808*/ GIMT_Encode4(99350), // Rule ID 1588 //
     /*  99318 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99321 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99328 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99332 */   // (trunc:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vm)  =>  (VMOVNv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vm)
     /*  99332 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVNv2i32),
     /*  99335 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99337 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99339 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99342 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99348 */   GIR_RootConstrainSelectedInstOperands,
     /*  99349 */   // GIR_Coverage, 1588,
     /*  99349 */   GIR_EraseRootFromParent_Done,
     /*  99350 */ // Label 1808: @99350
     /*  99350 */ GIM_Reject,
     /*  99351 */ // Label 1805: @99351
     /*  99351 */ GIM_Try, /*On fail goto*//*Label 1809*/ GIMT_Encode4(99388), // Rule ID 1587 //
     /*  99356 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99359 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  99362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99366 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99370 */   // (trunc:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vm)  =>  (VMOVNv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vm)
     /*  99370 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVNv4i16),
     /*  99373 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99375 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99377 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99380 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99386 */   GIR_RootConstrainSelectedInstOperands,
     /*  99387 */   // GIR_Coverage, 1587,
     /*  99387 */   GIR_EraseRootFromParent_Done,
     /*  99388 */ // Label 1809: @99388
     /*  99388 */ GIM_Reject,
     /*  99389 */ // Label 1806: @99389
     /*  99389 */ GIM_Try, /*On fail goto*//*Label 1810*/ GIMT_Encode4(99426), // Rule ID 1586 //
     /*  99394 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99397 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  99400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99404 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99408 */   // (trunc:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vm)  =>  (VMOVNv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vm)
     /*  99408 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVNv8i8),
     /*  99411 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99413 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99415 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99418 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99424 */   GIR_RootConstrainSelectedInstOperands,
     /*  99425 */   // GIR_Coverage, 1586,
     /*  99425 */   GIR_EraseRootFromParent_Done,
     /*  99426 */ // Label 1810: @99426
     /*  99426 */ GIM_Reject,
     /*  99427 */ // Label 1807: @99427
     /*  99427 */ GIM_Reject,
     /*  99428 */ // Label 19: @99428
     /*  99428 */ GIM_Try, /*On fail goto*//*Label 1811*/ GIMT_Encode4(99748),
     /*  99433 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  99436 */   GIM_Try, /*On fail goto*//*Label 1812*/ GIMT_Encode4(99477), // Rule ID 404 //
     /*  99441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  99444 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  99448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  99452 */     // MIs[0] Operand 1
     /*  99452 */     // No operand predicates
     /*  99452 */     // (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm  =>  (t2MOVi:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  99452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /*  99455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99457 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /*  99460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99463 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99469 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99475 */     GIR_RootConstrainSelectedInstOperands,
     /*  99476 */     // GIR_Coverage, 404,
     /*  99476 */     GIR_EraseRootFromParent_Done,
     /*  99477 */   // Label 1812: @99477
     /*  99477 */   GIM_Try, /*On fail goto*//*Label 1813*/ GIMT_Encode4(99518), // Rule ID 57 //
     /*  99482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  99485 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  99489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99493 */     // MIs[0] Operand 1
     /*  99493 */     // No operand predicates
     /*  99493 */     // (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm  =>  (MOVi:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  99493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MOVi),
     /*  99496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99498 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /*  99501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99504 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99510 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99516 */     GIR_RootConstrainSelectedInstOperands,
     /*  99517 */     // GIR_Coverage, 57,
     /*  99517 */     GIR_EraseRootFromParent_Done,
     /*  99518 */   // Label 1813: @99518
     /*  99518 */   GIM_Try, /*On fail goto*//*Label 1814*/ GIMT_Encode4(99553), // Rule ID 58 //
     /*  99523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6T2_IsARM),
     /*  99526 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_65535),
     /*  99530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99534 */     // MIs[0] Operand 1
     /*  99534 */     // No operand predicates
     /*  99534 */     // (imm:{ *:[i32] })<<P:Predicate_imm0_65535>>:$imm  =>  (MOVi16:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  99534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MOVi16),
     /*  99537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /*  99542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99545 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99551 */     GIR_RootConstrainSelectedInstOperands,
     /*  99552 */     // GIR_Coverage, 58,
     /*  99552 */     GIR_EraseRootFromParent_Done,
     /*  99553 */   // Label 1814: @99553
     /*  99553 */   GIM_Try, /*On fail goto*//*Label 1815*/ GIMT_Encode4(99596), // Rule ID 168 //
     /*  99558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  99561 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm_not),
     /*  99565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99569 */     // MIs[0] Operand 1
     /*  99569 */     // No operand predicates
     /*  99569 */     // (imm:{ *:[i32] })<<P:Predicate_mod_imm_not>><<X:imm_not_XFORM>>:$imm  =>  (MVNi:{ *:[i32] } (imm_not_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  99569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVNi),
     /*  99572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99574 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderInvertedImm), // imm
     /*  99579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99582 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99588 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99594 */     GIR_RootConstrainSelectedInstOperands,
     /*  99595 */     // GIR_Coverage, 168,
     /*  99595 */     GIR_EraseRootFromParent_Done,
     /*  99596 */   // Label 1815: @99596
     /*  99596 */   GIM_Try, /*On fail goto*//*Label 1816*/ GIMT_Encode4(99622), // Rule ID 268 //
     /*  99601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  99604 */     GIM_CheckAPIntImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_arm_i32imm),
     /*  99608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99612 */     // MIs[0] Operand 1
     /*  99612 */     // No operand predicates
     /*  99612 */     // (imm:{ *:[i32] })<<P:Predicate_arm_i32imm>>:$src  =>  (MOVi32imm:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /*  99612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MOVi32imm),
     /*  99615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99617 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /*  99620 */     GIR_RootConstrainSelectedInstOperands,
     /*  99621 */     // GIR_Coverage, 268,
     /*  99621 */     GIR_EraseRootFromParent_Done,
     /*  99622 */   // Label 1816: @99622
     /*  99622 */   GIM_Try, /*On fail goto*//*Label 1817*/ GIMT_Encode4(99663), // Rule ID 322 //
     /*  99627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  99630 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_255_expr),
     /*  99634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  99638 */     // MIs[0] Operand 1
     /*  99638 */     // No operand predicates
     /*  99638 */     // (imm:{ *:[i32] })<<P:Predicate_imm0_255_expr>>:$imm8  =>  (tMOVi8:{ *:[i32] } (imm:{ *:[i32] }):$imm8)
     /*  99638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tMOVi8),
     /*  99641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99643 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  99649 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm8
     /*  99652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99655 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99661 */     GIR_RootConstrainSelectedInstOperands,
     /*  99662 */     // GIR_Coverage, 322,
     /*  99662 */     GIR_EraseRootFromParent_Done,
     /*  99663 */   // Label 1817: @99663
     /*  99663 */   GIM_Try, /*On fail goto*//*Label 1818*/ GIMT_Encode4(99698), // Rule ID 405 //
     /*  99668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV8MBaseline_IsThumb),
     /*  99671 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_65535),
     /*  99675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  99679 */     // MIs[0] Operand 1
     /*  99679 */     // No operand predicates
     /*  99679 */     // (imm:{ *:[i32] })<<P:Predicate_imm0_65535>>:$imm  =>  (t2MOVi16:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  99679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MOVi16),
     /*  99682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99684 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /*  99687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99690 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99696 */     GIR_RootConstrainSelectedInstOperands,
     /*  99697 */     // GIR_Coverage, 405,
     /*  99697 */     GIR_EraseRootFromParent_Done,
     /*  99698 */   // Label 1818: @99698
     /*  99698 */   GIM_Try, /*On fail goto*//*Label 1819*/ GIMT_Encode4(99747),
     /*  99703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  99707 */     GIM_Try, /*On fail goto*//*Label 1820*/ GIMT_Encode4(99728), // Rule ID 353 //
     /*  99712 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseMovt_GenExecuteOnly_IsThumb1Only),
     /*  99715 */       // MIs[0] Operand 1
     /*  99715 */       // No operand predicates
     /*  99715 */       // (imm:{ *:[i32] }):$src  =>  (tMOVi32imm:{ *:[i32] }:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /*  99715 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tMOVi32imm),
     /*  99718 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99720 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /*  99723 */       GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for ARM::CPSR*/0,
     /*  99726 */       GIR_RootConstrainSelectedInstOperands,
     /*  99727 */       // GIR_Coverage, 353,
     /*  99727 */       GIR_EraseRootFromParent_Done,
     /*  99728 */     // Label 1820: @99728
     /*  99728 */     GIM_Try, /*On fail goto*//*Label 1821*/ GIMT_Encode4(99746), // Rule ID 582 //
     /*  99733 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_UseMovt),
     /*  99736 */       // MIs[0] Operand 1
     /*  99736 */       // No operand predicates
     /*  99736 */       // (imm:{ *:[i32] }):$src  =>  (t2MOVi32imm:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /*  99736 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MOVi32imm),
     /*  99739 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99741 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /*  99744 */       GIR_RootConstrainSelectedInstOperands,
     /*  99745 */       // GIR_Coverage, 582,
     /*  99745 */       GIR_EraseRootFromParent_Done,
     /*  99746 */     // Label 1821: @99746
     /*  99746 */     GIM_Reject,
     /*  99747 */   // Label 1819: @99747
     /*  99747 */   GIM_Reject,
     /*  99748 */ // Label 1811: @99748
     /*  99748 */ GIM_Reject,
     /*  99749 */ // Label 20: @99749
     /*  99749 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1824*/ GIMT_Encode4(99844),
     /*  99760 */ /*GILLT_s32*//*Label 1822*/ GIMT_Encode4(99768),
     /*  99764 */ /*GILLT_s64*//*Label 1823*/ GIMT_Encode4(99806),
     /*  99768 */ // Label 1822: @99768
     /*  99768 */ GIM_Try, /*On fail goto*//*Label 1825*/ GIMT_Encode4(99805), // Rule ID 728 //
     /*  99773 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP3),
     /*  99776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  99780 */   // MIs[0] Operand 1
     /*  99780 */   // No operand predicates
     /*  99780 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_vfp_f32imm),
     /*  99784 */   // (fpimm:{ *:[f32] })<<P:Predicate_vfp_f32imm>><<X:vfp_f32imm_xform>>:$imm  =>  (FCONSTS:{ *:[f32] } (vfp_f32imm_xform:{ *:[f32] } (fpimm:{ *:[f32] }):$imm))
     /*  99784 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::FCONSTS),
     /*  99787 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  99789 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderVFPF32Imm), // imm
     /*  99794 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99797 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99803 */   GIR_RootConstrainSelectedInstOperands,
     /*  99804 */   // GIR_Coverage, 728,
     /*  99804 */   GIR_EraseRootFromParent_Done,
     /*  99805 */ // Label 1825: @99805
     /*  99805 */ GIM_Reject,
     /*  99806 */ // Label 1823: @99806
     /*  99806 */ GIM_Try, /*On fail goto*//*Label 1826*/ GIMT_Encode4(99843), // Rule ID 727 //
     /*  99811 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP3),
     /*  99814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99818 */   // MIs[0] Operand 1
     /*  99818 */   // No operand predicates
     /*  99818 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_vfp_f64imm),
     /*  99822 */   // (fpimm:{ *:[f64] })<<P:Predicate_vfp_f64imm>><<X:vfp_f64imm_xform>>:$imm  =>  (FCONSTD:{ *:[f64] } (vfp_f64imm_xform:{ *:[f64] } (fpimm:{ *:[f64] }):$imm))
     /*  99822 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::FCONSTD),
     /*  99825 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /*  99827 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderVFPF64Imm), // imm
     /*  99832 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99835 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99841 */   GIR_RootConstrainSelectedInstOperands,
     /*  99842 */   // GIR_Coverage, 727,
     /*  99842 */   GIR_EraseRootFromParent_Done,
     /*  99843 */ // Label 1826: @99843
     /*  99843 */ GIM_Reject,
     /*  99844 */ // Label 1824: @99844
     /*  99844 */ GIM_Reject,
     /*  99845 */ // Label 21: @99845
     /*  99845 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(13), /*)*//*default:*//*Label 1830*/ GIMT_Encode4(100002),
     /*  99856 */ /*GILLT_v2s64*//*Label 1827*/ GIMT_Encode4(99888), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99868 */ /*GILLT_v4s32*//*Label 1828*/ GIMT_Encode4(99926), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99884 */ /*GILLT_v8s16*//*Label 1829*/ GIMT_Encode4(99964),
     /*  99888 */ // Label 1827: @99888
     /*  99888 */ GIM_Try, /*On fail goto*//*Label 1831*/ GIMT_Encode4(99925), // Rule ID 1600 //
     /*  99893 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99896 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  99899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99903 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99907 */   // (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)  =>  (VMOVLsv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)
     /*  99907 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLsv2i64),
     /*  99910 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99912 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99914 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99917 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99923 */   GIR_RootConstrainSelectedInstOperands,
     /*  99924 */   // GIR_Coverage, 1600,
     /*  99924 */   GIR_EraseRootFromParent_Done,
     /*  99925 */ // Label 1831: @99925
     /*  99925 */ GIM_Reject,
     /*  99926 */ // Label 1828: @99926
     /*  99926 */ GIM_Try, /*On fail goto*//*Label 1832*/ GIMT_Encode4(99963), // Rule ID 1599 //
     /*  99931 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  99937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99941 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99945 */   // (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)  =>  (VMOVLsv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)
     /*  99945 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLsv4i32),
     /*  99948 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99950 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99952 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99955 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99961 */   GIR_RootConstrainSelectedInstOperands,
     /*  99962 */   // GIR_Coverage, 1599,
     /*  99962 */   GIR_EraseRootFromParent_Done,
     /*  99963 */ // Label 1832: @99963
     /*  99963 */ GIM_Reject,
     /*  99964 */ // Label 1829: @99964
     /*  99964 */ GIM_Try, /*On fail goto*//*Label 1833*/ GIMT_Encode4(100001), // Rule ID 1598 //
     /*  99969 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  99975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99979 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99983 */   // (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)  =>  (VMOVLsv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)
     /*  99983 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLsv8i16),
     /*  99986 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99988 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99990 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99993 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99999 */   GIR_RootConstrainSelectedInstOperands,
     /* 100000 */   // GIR_Coverage, 1598,
     /* 100000 */   GIR_EraseRootFromParent_Done,
     /* 100001 */ // Label 1833: @100001
     /* 100001 */ GIM_Reject,
     /* 100002 */ // Label 1830: @100002
     /* 100002 */ GIM_Reject,
     /* 100003 */ // Label 22: @100003
     /* 100003 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(13), /*)*//*default:*//*Label 1837*/ GIMT_Encode4(100607),
     /* 100014 */ /*GILLT_s32*//*Label 1834*/ GIMT_Encode4(100062), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 100042 */ /*GILLT_v4s32*//*Label 1835*/ GIMT_Encode4(100354), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 100058 */ /*GILLT_v8s16*//*Label 1836*/ GIMT_Encode4(100537),
     /* 100062 */ // Label 1834: @100062
     /* 100062 */ GIM_Try, /*On fail goto*//*Label 1838*/ GIMT_Encode4(100353),
     /* 100067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 100070 */   GIM_Try, /*On fail goto*//*Label 1839*/ GIMT_Encode4(100115), // Rule ID 340 //
     /* 100075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /* 100078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100086 */     // MIs[0] Operand 2
     /* 100086 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 100097 */     // (sext_inreg:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, i8:{ *:[Other] })  =>  (tSXTB:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /* 100097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tSXTB),
     /* 100100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100102 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 100104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100107 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100113 */     GIR_RootConstrainSelectedInstOperands,
     /* 100114 */     // GIR_Coverage, 340,
     /* 100114 */     GIR_EraseRootFromParent_Done,
     /* 100115 */   // Label 1839: @100115
     /* 100115 */   GIM_Try, /*On fail goto*//*Label 1840*/ GIMT_Encode4(100160), // Rule ID 341 //
     /* 100120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /* 100123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100127 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100131 */     // MIs[0] Operand 2
     /* 100131 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 100142 */     // (sext_inreg:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] })  =>  (tSXTH:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /* 100142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tSXTH),
     /* 100145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100147 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 100149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100152 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100158 */     GIR_RootConstrainSelectedInstOperands,
     /* 100159 */     // GIR_Coverage, 341,
     /* 100159 */     GIR_EraseRootFromParent_Done,
     /* 100160 */   // Label 1840: @100160
     /* 100160 */   GIM_Try, /*On fail goto*//*Label 1841*/ GIMT_Encode4(100208), // Rule ID 2002 //
     /* 100165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /* 100168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 100172 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 100176 */     // MIs[0] Operand 2
     /* 100176 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 100187 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Src, i8:{ *:[Other] })  =>  (SXTB:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /* 100187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTB),
     /* 100190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100192 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /* 100194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100200 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100206 */     GIR_RootConstrainSelectedInstOperands,
     /* 100207 */     // GIR_Coverage, 2002,
     /* 100207 */     GIR_EraseRootFromParent_Done,
     /* 100208 */   // Label 1841: @100208
     /* 100208 */   GIM_Try, /*On fail goto*//*Label 1842*/ GIMT_Encode4(100256), // Rule ID 2003 //
     /* 100213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /* 100216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 100220 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 100224 */     // MIs[0] Operand 2
     /* 100224 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 100235 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Src, i16:{ *:[Other] })  =>  (SXTH:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /* 100235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTH),
     /* 100238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100240 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /* 100242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100248 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100254 */     GIR_RootConstrainSelectedInstOperands,
     /* 100255 */     // GIR_Coverage, 2003,
     /* 100255 */     GIR_EraseRootFromParent_Done,
     /* 100256 */   // Label 1842: @100256
     /* 100256 */   GIM_Try, /*On fail goto*//*Label 1843*/ GIMT_Encode4(100304), // Rule ID 2241 //
     /* 100261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 100264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100268 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100272 */     // MIs[0] Operand 2
     /* 100272 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 100283 */     // (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Src, i8:{ *:[Other] })  =>  (t2SXTB:{ *:[i32] } rGPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /* 100283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTB),
     /* 100286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100288 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /* 100290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100296 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100302 */     GIR_RootConstrainSelectedInstOperands,
     /* 100303 */     // GIR_Coverage, 2241,
     /* 100303 */     GIR_EraseRootFromParent_Done,
     /* 100304 */   // Label 1843: @100304
     /* 100304 */   GIM_Try, /*On fail goto*//*Label 1844*/ GIMT_Encode4(100352), // Rule ID 2242 //
     /* 100309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 100312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100316 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100320 */     // MIs[0] Operand 2
     /* 100320 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 100331 */     // (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Src, i16:{ *:[Other] })  =>  (t2SXTH:{ *:[i32] } rGPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /* 100331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTH),
     /* 100334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100336 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /* 100338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100344 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100350 */     GIR_RootConstrainSelectedInstOperands,
     /* 100351 */     // GIR_Coverage, 2242,
     /* 100351 */     GIR_EraseRootFromParent_Done,
     /* 100352 */   // Label 1844: @100352
     /* 100352 */   GIM_Reject,
     /* 100353 */ // Label 1838: @100353
     /* 100353 */ GIM_Reject,
     /* 100354 */ // Label 1835: @100354
     /* 100354 */ GIM_Try, /*On fail goto*//*Label 1845*/ GIMT_Encode4(100536),
     /* 100359 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 100362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 100366 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 100370 */   GIM_Try, /*On fail goto*//*Label 1846*/ GIMT_Encode4(100428), // Rule ID 3713 //
     /* 100375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 100378 */     // MIs[0] Operand 2
     /* 100378 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 100389 */     // (sext_inreg:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, v4i16:{ *:[Other] })  =>  (MVE_VMOVLs16bh:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src)
     /* 100389 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 100392 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100396 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOVLs16bh),
     /* 100404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 100406 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 100408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100411 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100417 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100423 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100426 */     GIR_RootConstrainSelectedInstOperands,
     /* 100427 */     // GIR_Coverage, 3713,
     /* 100427 */     GIR_EraseRootFromParent_Done,
     /* 100428 */   // Label 1846: @100428
     /* 100428 */   GIM_Try, /*On fail goto*//*Label 1847*/ GIMT_Encode4(100535), // Rule ID 3715 //
     /* 100433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 100436 */     // MIs[0] Operand 2
     /* 100436 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 100447 */     // (sext_inreg:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, v4i8:{ *:[Other] })  =>  (MVE_VMOVLs16bh:{ *:[v4i32] } (MVE_VMOVLs8bh:{ *:[v16i8] } MQPR:{ *:[v4i32] }:$src))
     /* 100447 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 100450 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100454 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100459 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 100462 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100466 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 100474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOVLs8bh),
     /* 100478 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100483 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 100487 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 100490 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100496 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100502 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 100505 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 100507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOVLs16bh),
     /* 100510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 100512 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100518 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100524 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100530 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 100533 */     GIR_RootConstrainSelectedInstOperands,
     /* 100534 */     // GIR_Coverage, 3715,
     /* 100534 */     GIR_EraseRootFromParent_Done,
     /* 100535 */   // Label 1847: @100535
     /* 100535 */   GIM_Reject,
     /* 100536 */ // Label 1845: @100536
     /* 100536 */ GIM_Reject,
     /* 100537 */ // Label 1836: @100537
     /* 100537 */ GIM_Try, /*On fail goto*//*Label 1848*/ GIMT_Encode4(100606), // Rule ID 3714 //
     /* 100542 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 100545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 100548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 100552 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 100556 */   // MIs[0] Operand 2
     /* 100556 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 100567 */   // (sext_inreg:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, v8i8:{ *:[Other] })  =>  (MVE_VMOVLs8bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src)
     /* 100567 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 100570 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100574 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100579 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOVLs8bh),
     /* 100582 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 100584 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 100586 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100589 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100595 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100601 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100604 */   GIR_RootConstrainSelectedInstOperands,
     /* 100605 */   // GIR_Coverage, 3714,
     /* 100605 */   GIR_EraseRootFromParent_Done,
     /* 100606 */ // Label 1848: @100606
     /* 100606 */ GIM_Reject,
     /* 100607 */ // Label 1837: @100607
     /* 100607 */ GIM_Reject,
     /* 100608 */ // Label 23: @100608
     /* 100608 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(13), /*)*//*default:*//*Label 1852*/ GIMT_Encode4(100765),
     /* 100619 */ /*GILLT_v2s64*//*Label 1849*/ GIMT_Encode4(100651), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 100631 */ /*GILLT_v4s32*//*Label 1850*/ GIMT_Encode4(100689), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 100647 */ /*GILLT_v8s16*//*Label 1851*/ GIMT_Encode4(100727),
     /* 100651 */ // Label 1849: @100651
     /* 100651 */ GIM_Try, /*On fail goto*//*Label 1853*/ GIMT_Encode4(100688), // Rule ID 1603 //
     /* 100656 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 100662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 100666 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 100670 */   // (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)  =>  (VMOVLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)
     /* 100670 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv2i64),
     /* 100673 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 100675 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 100677 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100680 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100686 */   GIR_RootConstrainSelectedInstOperands,
     /* 100687 */   // GIR_Coverage, 1603,
     /* 100687 */   GIR_EraseRootFromParent_Done,
     /* 100688 */ // Label 1853: @100688
     /* 100688 */ GIM_Reject,
     /* 100689 */ // Label 1850: @100689
     /* 100689 */ GIM_Try, /*On fail goto*//*Label 1854*/ GIMT_Encode4(100726), // Rule ID 1602 //
     /* 100694 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 100700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 100704 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 100708 */   // (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)  =>  (VMOVLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)
     /* 100708 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv4i32),
     /* 100711 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 100713 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 100715 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100718 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100724 */   GIR_RootConstrainSelectedInstOperands,
     /* 100725 */   // GIR_Coverage, 1602,
     /* 100725 */   GIR_EraseRootFromParent_Done,
     /* 100726 */ // Label 1854: @100726
     /* 100726 */ GIM_Reject,
     /* 100727 */ // Label 1851: @100727
     /* 100727 */ GIM_Try, /*On fail goto*//*Label 1855*/ GIMT_Encode4(100764), // Rule ID 1601 //
     /* 100732 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 100738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 100742 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 100746 */   // (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)  =>  (VMOVLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)
     /* 100746 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv8i16),
     /* 100749 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 100751 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 100753 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100756 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100762 */   GIR_RootConstrainSelectedInstOperands,
     /* 100763 */   // GIR_Coverage, 1601,
     /* 100763 */   GIR_EraseRootFromParent_Done,
     /* 100764 */ // Label 1855: @100764
     /* 100764 */ GIM_Reject,
     /* 100765 */ // Label 1852: @100765
     /* 100765 */ GIM_Reject,
     /* 100766 */ // Label 24: @100766
     /* 100766 */ GIM_Try, /*On fail goto*//*Label 1856*/ GIMT_Encode4(100981),
     /* 100771 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 100774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 100777 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 100780 */   GIM_Try, /*On fail goto*//*Label 1857*/ GIMT_Encode4(100837), // Rule ID 470 //
     /* 100785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 100788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 100804 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_31),
     /* 100808 */     // MIs[1] Operand 1
     /* 100808 */     // No operand predicates
     /* 100808 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100810 */     // (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm1_31>>:$imm)  =>  (t2LSLri:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 100810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2LSLri),
     /* 100813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100815 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 100817 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 100820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100823 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100829 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100835 */     GIR_RootConstrainSelectedInstOperands,
     /* 100836 */     // GIR_Coverage, 470,
     /* 100836 */     GIR_EraseRootFromParent_Done,
     /* 100837 */   // Label 1857: @100837
     /* 100837 */   GIM_Try, /*On fail goto*//*Label 1858*/ GIMT_Encode4(100934),
     /* 100842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100850 */     GIM_Try, /*On fail goto*//*Label 1859*/ GIMT_Encode4(100895), // Rule ID 318 //
     /* 100855 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 100858 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100862 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 100866 */       // MIs[1] Operand 1
     /* 100866 */       // No operand predicates
     /* 100866 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100868 */       // (shl:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$imm5)  =>  (tLSLri:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$imm5)
     /* 100868 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tLSLri),
     /* 100871 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100873 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 100879 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 100881 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm5
     /* 100884 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100887 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100893 */       GIR_RootConstrainSelectedInstOperands,
     /* 100894 */       // GIR_Coverage, 318,
     /* 100894 */       GIR_EraseRootFromParent_Done,
     /* 100895 */     // Label 1859: @100895
     /* 100895 */     GIM_Try, /*On fail goto*//*Label 1860*/ GIMT_Encode4(100933), // Rule ID 319 //
     /* 100900 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 100903 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100907 */       // (shl:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tLSLrr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /* 100907 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tLSLrr),
     /* 100910 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 100912 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 100918 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 100920 */       GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 100922 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100925 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100931 */       GIR_RootConstrainSelectedInstOperands,
     /* 100932 */       // GIR_Coverage, 319,
     /* 100932 */       GIR_EraseRootFromParent_Done,
     /* 100933 */     // Label 1860: @100933
     /* 100933 */     GIM_Reject,
     /* 100934 */   // Label 1858: @100934
     /* 100934 */   GIM_Try, /*On fail goto*//*Label 1861*/ GIMT_Encode4(100980), // Rule ID 471 //
     /* 100939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 100942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100954 */     // (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2LSLrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /* 100954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2LSLrr),
     /* 100957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100959 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 100961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 100963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100966 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100972 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100978 */     GIR_RootConstrainSelectedInstOperands,
     /* 100979 */     // GIR_Coverage, 471,
     /* 100979 */     GIR_EraseRootFromParent_Done,
     /* 100980 */   // Label 1861: @100980
     /* 100980 */   GIM_Reject,
     /* 100981 */ // Label 1856: @100981
     /* 100981 */ GIM_Reject,
     /* 100982 */ // Label 25: @100982
     /* 100982 */ GIM_Try, /*On fail goto*//*Label 1862*/ GIMT_Encode4(101089),
     /* 100987 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 100990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 100993 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 100996 */   GIM_Try, /*On fail goto*//*Label 1863*/ GIMT_Encode4(101042), // Rule ID 321 //
     /* 101001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 101004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101008 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101016 */     // (srl:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tLSRrr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /* 101016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tLSRrr),
     /* 101019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 101021 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 101027 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101034 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101040 */     GIR_RootConstrainSelectedInstOperands,
     /* 101041 */     // GIR_Coverage, 321,
     /* 101041 */     GIR_EraseRootFromParent_Done,
     /* 101042 */   // Label 1863: @101042
     /* 101042 */   GIM_Try, /*On fail goto*//*Label 1864*/ GIMT_Encode4(101088), // Rule ID 473 //
     /* 101047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 101050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101054 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101062 */     // (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2LSRrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /* 101062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2LSRrr),
     /* 101065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101067 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101074 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101080 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101086 */     GIR_RootConstrainSelectedInstOperands,
     /* 101087 */     // GIR_Coverage, 473,
     /* 101087 */     GIR_EraseRootFromParent_Done,
     /* 101088 */   // Label 1864: @101088
     /* 101088 */   GIM_Reject,
     /* 101089 */ // Label 1862: @101089
     /* 101089 */ GIM_Reject,
     /* 101090 */ // Label 26: @101090
     /* 101090 */ GIM_Try, /*On fail goto*//*Label 1865*/ GIMT_Encode4(101362),
     /* 101095 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 101098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 101101 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 101104 */   GIM_Try, /*On fail goto*//*Label 1866*/ GIMT_Encode4(101159), // Rule ID 201 //
     /* 101109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /* 101112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 101116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 101124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 101128 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 101133 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 101137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101139 */     // (sra:{ *:[i32] } (bswap:{ *:[i32] } GPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (REVSH:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /* 101139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::REVSH),
     /* 101142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 101148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101151 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101157 */     GIR_RootConstrainSelectedInstOperands,
     /* 101158 */     // GIR_Coverage, 201,
     /* 101158 */     GIR_EraseRootFromParent_Done,
     /* 101159 */   // Label 1866: @101159
     /* 101159 */   GIM_Try, /*On fail goto*//*Label 1867*/ GIMT_Encode4(101214), // Rule ID 328 //
     /* 101164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /* 101167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 101179 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 101183 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101188 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 101192 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101194 */     // (sra:{ *:[i32] } (bswap:{ *:[i32] } tGPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (tREVSH:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /* 101194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tREVSH),
     /* 101197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 101203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101206 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101212 */     GIR_RootConstrainSelectedInstOperands,
     /* 101213 */     // GIR_Coverage, 328,
     /* 101213 */     GIR_EraseRootFromParent_Done,
     /* 101214 */   // Label 1867: @101214
     /* 101214 */   GIM_Try, /*On fail goto*//*Label 1868*/ GIMT_Encode4(101269), // Rule ID 538 //
     /* 101219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 101222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 101234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 101238 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101243 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 101247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101249 */     // (sra:{ *:[i32] } (bswap:{ *:[i32] } rGPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (t2REVSH:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /* 101249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2REVSH),
     /* 101252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 101258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101261 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101267 */     GIR_RootConstrainSelectedInstOperands,
     /* 101268 */     // GIR_Coverage, 538,
     /* 101268 */     GIR_EraseRootFromParent_Done,
     /* 101269 */   // Label 1868: @101269
     /* 101269 */   GIM_Try, /*On fail goto*//*Label 1869*/ GIMT_Encode4(101315), // Rule ID 312 //
     /* 101274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 101277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101289 */     // (sra:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tASRrr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /* 101289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tASRrr),
     /* 101292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 101294 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 101300 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101307 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101313 */     GIR_RootConstrainSelectedInstOperands,
     /* 101314 */     // GIR_Coverage, 312,
     /* 101314 */     GIR_EraseRootFromParent_Done,
     /* 101315 */   // Label 1869: @101315
     /* 101315 */   GIM_Try, /*On fail goto*//*Label 1870*/ GIMT_Encode4(101361), // Rule ID 475 //
     /* 101320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 101323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101327 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101335 */     // (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2ASRrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /* 101335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ASRrr),
     /* 101338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101340 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101347 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101353 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101359 */     GIR_RootConstrainSelectedInstOperands,
     /* 101360 */     // GIR_Coverage, 475,
     /* 101360 */     GIR_EraseRootFromParent_Done,
     /* 101361 */   // Label 1870: @101361
     /* 101361 */   GIM_Reject,
     /* 101362 */ // Label 1865: @101362
     /* 101362 */ GIM_Reject,
     /* 101363 */ // Label 27: @101363
     /* 101363 */ GIM_Try, /*On fail goto*//*Label 1871*/ GIMT_Encode4(101694),
     /* 101368 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 101371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 101374 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 101377 */   GIM_Try, /*On fail goto*//*Label 1872*/ GIMT_Encode4(101432), // Rule ID 200 //
     /* 101382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /* 101385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 101389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 101397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 101401 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 101406 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 101410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101412 */     // (rotr:{ *:[i32] } (bswap:{ *:[i32] } GPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (REV16:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /* 101412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::REV16),
     /* 101415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 101421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101424 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101430 */     GIR_RootConstrainSelectedInstOperands,
     /* 101431 */     // GIR_Coverage, 200,
     /* 101431 */     GIR_EraseRootFromParent_Done,
     /* 101432 */   // Label 1872: @101432
     /* 101432 */   GIM_Try, /*On fail goto*//*Label 1873*/ GIMT_Encode4(101487), // Rule ID 327 //
     /* 101437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /* 101440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 101452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 101456 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101461 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 101465 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101467 */     // (rotr:{ *:[i32] } (bswap:{ *:[i32] } tGPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (tREV16:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /* 101467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tREV16),
     /* 101470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 101476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101479 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101485 */     GIR_RootConstrainSelectedInstOperands,
     /* 101486 */     // GIR_Coverage, 327,
     /* 101486 */     GIR_EraseRootFromParent_Done,
     /* 101487 */   // Label 1873: @101487
     /* 101487 */   GIM_Try, /*On fail goto*//*Label 1874*/ GIMT_Encode4(101601),
     /* 101492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101496 */     GIM_Try, /*On fail goto*//*Label 1875*/ GIMT_Encode4(101547), // Rule ID 537 //
     /* 101501 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 101504 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101508 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 101512 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 101516 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101521 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 101525 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101527 */       // (rotr:{ *:[i32] } (bswap:{ *:[i32] } rGPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (t2REV16:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /* 101527 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2REV16),
     /* 101530 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101532 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 101536 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101539 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101545 */       GIR_RootConstrainSelectedInstOperands,
     /* 101546 */       // GIR_Coverage, 537,
     /* 101546 */       GIR_EraseRootFromParent_Done,
     /* 101547 */     // Label 1875: @101547
     /* 101547 */     GIM_Try, /*On fail goto*//*Label 1876*/ GIMT_Encode4(101600), // Rule ID 476 //
     /* 101552 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 101555 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101559 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101563 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 101567 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_31),
     /* 101571 */       // MIs[1] Operand 1
     /* 101571 */       // No operand predicates
     /* 101571 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101573 */       // (rotr:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm1_31>>:$imm)  =>  (t2RORri:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 101573 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2RORri),
     /* 101576 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101578 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 101580 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 101583 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101586 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101592 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101598 */       GIR_RootConstrainSelectedInstOperands,
     /* 101599 */       // GIR_Coverage, 476,
     /* 101599 */       GIR_EraseRootFromParent_Done,
     /* 101600 */     // Label 1876: @101600
     /* 101600 */     GIM_Reject,
     /* 101601 */   // Label 1874: @101601
     /* 101601 */   GIM_Try, /*On fail goto*//*Label 1877*/ GIMT_Encode4(101647), // Rule ID 329 //
     /* 101606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 101609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101613 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101621 */     // (rotr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tROR:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /* 101621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tROR),
     /* 101624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 101626 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 101632 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101639 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101645 */     GIR_RootConstrainSelectedInstOperands,
     /* 101646 */     // GIR_Coverage, 329,
     /* 101646 */     GIR_EraseRootFromParent_Done,
     /* 101647 */   // Label 1877: @101647
     /* 101647 */   GIM_Try, /*On fail goto*//*Label 1878*/ GIMT_Encode4(101693), // Rule ID 477 //
     /* 101652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 101655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101667 */     // (rotr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2RORrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /* 101667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2RORrr),
     /* 101670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101672 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101679 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101685 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101691 */     GIR_RootConstrainSelectedInstOperands,
     /* 101692 */     // GIR_Coverage, 477,
     /* 101692 */     GIR_EraseRootFromParent_Done,
     /* 101693 */   // Label 1878: @101693
     /* 101693 */   GIM_Reject,
     /* 101694 */ // Label 1871: @101694
     /* 101694 */ GIM_Reject,
     /* 101695 */ // Label 28: @101695
     /* 101695 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 1882*/ GIMT_Encode4(101942),
     /* 101706 */ /*GILLT_v4s32*//*Label 1879*/ GIMT_Encode4(101738), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 101722 */ /*GILLT_v8s16*//*Label 1880*/ GIMT_Encode4(101806), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 101734 */ /*GILLT_v16s8*//*Label 1881*/ GIMT_Encode4(101874),
     /* 101738 */ // Label 1879: @101738
     /* 101738 */ GIM_Try, /*On fail goto*//*Label 1883*/ GIMT_Encode4(101805), // Rule ID 4464 //
     /* 101743 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 101746 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101749 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 101752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101756 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101760 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101764 */   // (mulhu:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMULHu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 101764 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 101767 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101771 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101776 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu32),
     /* 101779 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 101781 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 101783 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 101785 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101788 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101794 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101800 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101803 */   GIR_RootConstrainSelectedInstOperands,
     /* 101804 */   // GIR_Coverage, 4464,
     /* 101804 */   GIR_EraseRootFromParent_Done,
     /* 101805 */ // Label 1883: @101805
     /* 101805 */ GIM_Reject,
     /* 101806 */ // Label 1880: @101806
     /* 101806 */ GIM_Try, /*On fail goto*//*Label 1884*/ GIMT_Encode4(101873), // Rule ID 4460 //
     /* 101811 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 101814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 101817 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 101820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101824 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101828 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101832 */   // (mulhu:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMULHu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 101832 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 101835 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101839 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101844 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu16),
     /* 101847 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 101849 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 101851 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 101853 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101856 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101862 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101868 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101871 */   GIR_RootConstrainSelectedInstOperands,
     /* 101872 */   // GIR_Coverage, 4460,
     /* 101872 */   GIR_EraseRootFromParent_Done,
     /* 101873 */ // Label 1884: @101873
     /* 101873 */ GIM_Reject,
     /* 101874 */ // Label 1881: @101874
     /* 101874 */ GIM_Try, /*On fail goto*//*Label 1885*/ GIMT_Encode4(101941), // Rule ID 4456 //
     /* 101879 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 101882 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 101885 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 101888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101892 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101896 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101900 */   // (mulhu:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMULHu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 101900 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 101903 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101907 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101912 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu8),
     /* 101915 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 101917 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 101919 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 101921 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101924 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101930 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101936 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101939 */   GIR_RootConstrainSelectedInstOperands,
     /* 101940 */   // GIR_Coverage, 4456,
     /* 101940 */   GIR_EraseRootFromParent_Done,
     /* 101941 */ // Label 1885: @101941
     /* 101941 */ GIM_Reject,
     /* 101942 */ // Label 1882: @101942
     /* 101942 */ GIM_Reject,
     /* 101943 */ // Label 29: @101943
     /* 101943 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 1890*/ GIMT_Encode4(102311),
     /* 101954 */ /*GILLT_s32*//*Label 1886*/ GIMT_Encode4(102014), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 101982 */ /*GILLT_v4s32*//*Label 1887*/ GIMT_Encode4(102107), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 101998 */ /*GILLT_v8s16*//*Label 1888*/ GIMT_Encode4(102175), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 102010 */ /*GILLT_v16s8*//*Label 1889*/ GIMT_Encode4(102243),
     /* 102014 */ // Label 1886: @102014
     /* 102014 */ GIM_Try, /*On fail goto*//*Label 1891*/ GIMT_Encode4(102106),
     /* 102019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 102022 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 102025 */   GIM_Try, /*On fail goto*//*Label 1892*/ GIMT_Encode4(102065), // Rule ID 178 //
     /* 102030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /* 102033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 102037 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 102041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 102045 */     // (mulhs:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (SMMUL:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /* 102045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMMUL),
     /* 102048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 102050 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 102052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 102054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102057 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102063 */     GIR_RootConstrainSelectedInstOperands,
     /* 102064 */     // GIR_Coverage, 178,
     /* 102064 */     GIR_EraseRootFromParent_Done,
     /* 102065 */   // Label 1892: @102065
     /* 102065 */   GIM_Try, /*On fail goto*//*Label 1893*/ GIMT_Encode4(102105), // Rule ID 507 //
     /* 102070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 102073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 102077 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 102081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 102085 */     // (mulhs:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMMUL:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /* 102085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMMUL),
     /* 102088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 102090 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 102092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 102094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102097 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102103 */     GIR_RootConstrainSelectedInstOperands,
     /* 102104 */     // GIR_Coverage, 507,
     /* 102104 */     GIR_EraseRootFromParent_Done,
     /* 102105 */   // Label 1893: @102105
     /* 102105 */   GIM_Reject,
     /* 102106 */ // Label 1891: @102106
     /* 102106 */ GIM_Reject,
     /* 102107 */ // Label 1887: @102107
     /* 102107 */ GIM_Try, /*On fail goto*//*Label 1894*/ GIMT_Encode4(102174), // Rule ID 4452 //
     /* 102112 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 102115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102118 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 102121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102125 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102129 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102133 */   // (mulhs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMULHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 102133 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 102136 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102140 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102145 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs32),
     /* 102148 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 102150 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 102152 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 102154 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102157 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102163 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102169 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102172 */   GIR_RootConstrainSelectedInstOperands,
     /* 102173 */   // GIR_Coverage, 4452,
     /* 102173 */   GIR_EraseRootFromParent_Done,
     /* 102174 */ // Label 1894: @102174
     /* 102174 */ GIM_Reject,
     /* 102175 */ // Label 1888: @102175
     /* 102175 */ GIM_Try, /*On fail goto*//*Label 1895*/ GIMT_Encode4(102242), // Rule ID 4448 //
     /* 102180 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 102183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102186 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 102189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102193 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102197 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102201 */   // (mulhs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMULHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 102201 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 102204 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102208 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102213 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs16),
     /* 102216 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 102218 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 102220 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 102222 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102225 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102231 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102237 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102240 */   GIR_RootConstrainSelectedInstOperands,
     /* 102241 */   // GIR_Coverage, 4448,
     /* 102241 */   GIR_EraseRootFromParent_Done,
     /* 102242 */ // Label 1895: @102242
     /* 102242 */ GIM_Reject,
     /* 102243 */ // Label 1889: @102243
     /* 102243 */ GIM_Try, /*On fail goto*//*Label 1896*/ GIMT_Encode4(102310), // Rule ID 4445 //
     /* 102248 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 102251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 102254 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 102257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102261 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102265 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102269 */   // (mulhs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMULHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 102269 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 102272 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102276 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102281 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs8),
     /* 102284 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 102286 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 102288 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 102290 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102293 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102299 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102305 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102308 */   GIR_RootConstrainSelectedInstOperands,
     /* 102309 */   // GIR_Coverage, 4445,
     /* 102309 */   GIR_EraseRootFromParent_Done,
     /* 102310 */ // Label 1896: @102310
     /* 102310 */ GIM_Reject,
     /* 102311 */ // Label 1890: @102311
     /* 102311 */ GIM_Reject,
     /* 102312 */ // Label 30: @102312
     /* 102312 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(16), /*)*//*default:*//*Label 1905*/ GIMT_Encode4(102956),
     /* 102323 */ /*GILLT_s64*//*Label 1897*/ GIMT_Encode4(102379), GIMT_Encode4(0),
     /* 102331 */ /*GILLT_v2s32*//*Label 1898*/ GIMT_Encode4(102426),
     /* 102335 */ /*GILLT_v2s64*//*Label 1899*/ GIMT_Encode4(102473), GIMT_Encode4(0),
     /* 102343 */ /*GILLT_v4s16*//*Label 1900*/ GIMT_Encode4(102520),
     /* 102347 */ /*GILLT_v4s32*//*Label 1901*/ GIMT_Encode4(102567), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 102359 */ /*GILLT_v8s8*//*Label 1902*/ GIMT_Encode4(102681),
     /* 102363 */ /*GILLT_v8s16*//*Label 1903*/ GIMT_Encode4(102728), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 102375 */ /*GILLT_v16s8*//*Label 1904*/ GIMT_Encode4(102842),
     /* 102379 */ // Label 1897: @102379
     /* 102379 */ GIM_Try, /*On fail goto*//*Label 1906*/ GIMT_Encode4(102425), // Rule ID 830 //
     /* 102384 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102387 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 102390 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 102393 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102397 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102401 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102405 */   // (uaddsat:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VQADDuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /* 102405 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv1i64),
     /* 102408 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102410 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102412 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102414 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102417 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102423 */   GIR_RootConstrainSelectedInstOperands,
     /* 102424 */   // GIR_Coverage, 830,
     /* 102424 */   GIR_EraseRootFromParent_Done,
     /* 102425 */ // Label 1906: @102425
     /* 102425 */ GIM_Reject,
     /* 102426 */ // Label 1898: @102426
     /* 102426 */ GIM_Try, /*On fail goto*//*Label 1907*/ GIMT_Encode4(102472), // Rule ID 825 //
     /* 102431 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 102437 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 102440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102444 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102448 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102452 */   // (uaddsat:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQADDuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 102452 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv2i32),
     /* 102455 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102457 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102459 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102461 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102464 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102470 */   GIR_RootConstrainSelectedInstOperands,
     /* 102471 */   // GIR_Coverage, 825,
     /* 102471 */   GIR_EraseRootFromParent_Done,
     /* 102472 */ // Label 1907: @102472
     /* 102472 */ GIM_Reject,
     /* 102473 */ // Label 1899: @102473
     /* 102473 */ GIM_Try, /*On fail goto*//*Label 1908*/ GIMT_Encode4(102519), // Rule ID 831 //
     /* 102478 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 102484 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 102487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102491 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102495 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102499 */   // (uaddsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VQADDuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /* 102499 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv2i64),
     /* 102502 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102504 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102506 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102508 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102511 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102517 */   GIR_RootConstrainSelectedInstOperands,
     /* 102518 */   // GIR_Coverage, 831,
     /* 102518 */   GIR_EraseRootFromParent_Done,
     /* 102519 */ // Label 1908: @102519
     /* 102519 */ GIM_Reject,
     /* 102520 */ // Label 1900: @102520
     /* 102520 */ GIM_Try, /*On fail goto*//*Label 1909*/ GIMT_Encode4(102566), // Rule ID 824 //
     /* 102525 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102528 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 102531 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 102534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102538 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102542 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102546 */   // (uaddsat:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQADDuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 102546 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv4i16),
     /* 102549 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102551 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102553 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102555 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102558 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102564 */   GIR_RootConstrainSelectedInstOperands,
     /* 102565 */   // GIR_Coverage, 824,
     /* 102565 */   GIR_EraseRootFromParent_Done,
     /* 102566 */ // Label 1909: @102566
     /* 102566 */ GIM_Reject,
     /* 102567 */ // Label 1901: @102567
     /* 102567 */ GIM_Try, /*On fail goto*//*Label 1910*/ GIMT_Encode4(102680),
     /* 102572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102575 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 102578 */   GIM_Try, /*On fail goto*//*Label 1911*/ GIMT_Encode4(102618), // Rule ID 827 //
     /* 102583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102590 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102598 */     // (uaddsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQADDuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 102598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv4i32),
     /* 102601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102603 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102610 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102616 */     GIR_RootConstrainSelectedInstOperands,
     /* 102617 */     // GIR_Coverage, 827,
     /* 102617 */     GIR_EraseRootFromParent_Done,
     /* 102618 */   // Label 1911: @102618
     /* 102618 */   GIM_Try, /*On fail goto*//*Label 1912*/ GIMT_Encode4(102679), // Rule ID 3527 //
     /* 102623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 102626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102630 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102638 */     // (uaddsat:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQADDu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 102638 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 102641 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102645 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDu32),
     /* 102653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 102655 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 102657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 102659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102662 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102668 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102674 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102677 */     GIR_RootConstrainSelectedInstOperands,
     /* 102678 */     // GIR_Coverage, 3527,
     /* 102678 */     GIR_EraseRootFromParent_Done,
     /* 102679 */   // Label 1912: @102679
     /* 102679 */   GIM_Reject,
     /* 102680 */ // Label 1910: @102680
     /* 102680 */ GIM_Reject,
     /* 102681 */ // Label 1902: @102681
     /* 102681 */ GIM_Try, /*On fail goto*//*Label 1913*/ GIMT_Encode4(102727), // Rule ID 828 //
     /* 102686 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 102692 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 102695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102699 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102703 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102707 */   // (uaddsat:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VQADDuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 102707 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv8i8),
     /* 102710 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102712 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102714 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102716 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102719 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102725 */   GIR_RootConstrainSelectedInstOperands,
     /* 102726 */   // GIR_Coverage, 828,
     /* 102726 */   GIR_EraseRootFromParent_Done,
     /* 102727 */ // Label 1913: @102727
     /* 102727 */ GIM_Reject,
     /* 102728 */ // Label 1903: @102728
     /* 102728 */ GIM_Try, /*On fail goto*//*Label 1914*/ GIMT_Encode4(102841),
     /* 102733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102736 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 102739 */   GIM_Try, /*On fail goto*//*Label 1915*/ GIMT_Encode4(102779), // Rule ID 826 //
     /* 102744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102751 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102759 */     // (uaddsat:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQADDuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 102759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv8i16),
     /* 102762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102764 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102771 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102777 */     GIR_RootConstrainSelectedInstOperands,
     /* 102778 */     // GIR_Coverage, 826,
     /* 102778 */     GIR_EraseRootFromParent_Done,
     /* 102779 */   // Label 1915: @102779
     /* 102779 */   GIM_Try, /*On fail goto*//*Label 1916*/ GIMT_Encode4(102840), // Rule ID 3524 //
     /* 102784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 102787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102799 */     // (uaddsat:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQADDu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 102799 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 102802 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102806 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDu16),
     /* 102814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 102816 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 102818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 102820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102823 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102829 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102835 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102838 */     GIR_RootConstrainSelectedInstOperands,
     /* 102839 */     // GIR_Coverage, 3524,
     /* 102839 */     GIR_EraseRootFromParent_Done,
     /* 102840 */   // Label 1916: @102840
     /* 102840 */   GIM_Reject,
     /* 102841 */ // Label 1914: @102841
     /* 102841 */ GIM_Reject,
     /* 102842 */ // Label 1904: @102842
     /* 102842 */ GIM_Try, /*On fail goto*//*Label 1917*/ GIMT_Encode4(102955),
     /* 102847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 102850 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 102853 */   GIM_Try, /*On fail goto*//*Label 1918*/ GIMT_Encode4(102893), // Rule ID 829 //
     /* 102858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102873 */     // (uaddsat:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VQADDuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 102873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv16i8),
     /* 102876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102878 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102885 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102891 */     GIR_RootConstrainSelectedInstOperands,
     /* 102892 */     // GIR_Coverage, 829,
     /* 102892 */     GIR_EraseRootFromParent_Done,
     /* 102893 */   // Label 1918: @102893
     /* 102893 */   GIM_Try, /*On fail goto*//*Label 1919*/ GIMT_Encode4(102954), // Rule ID 3521 //
     /* 102898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 102901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102905 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102913 */     // (uaddsat:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQADDu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 102913 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 102916 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102920 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDu8),
     /* 102928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 102930 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 102932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 102934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102937 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102943 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102949 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102952 */     GIR_RootConstrainSelectedInstOperands,
     /* 102953 */     // GIR_Coverage, 3521,
     /* 102953 */     GIR_EraseRootFromParent_Done,
     /* 102954 */   // Label 1919: @102954
     /* 102954 */   GIM_Reject,
     /* 102955 */ // Label 1917: @102955
     /* 102955 */ GIM_Reject,
     /* 102956 */ // Label 1905: @102956
     /* 102956 */ GIM_Reject,
     /* 102957 */ // Label 31: @102957
     /* 102957 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 1929*/ GIMT_Encode4(104256),
     /* 102968 */ /*GILLT_s32*//*Label 1920*/ GIMT_Encode4(103028),
     /* 102972 */ /*GILLT_s64*//*Label 1921*/ GIMT_Encode4(103369), GIMT_Encode4(0),
     /* 102980 */ /*GILLT_v2s32*//*Label 1922*/ GIMT_Encode4(103416),
     /* 102984 */ /*GILLT_v2s64*//*Label 1923*/ GIMT_Encode4(103463), GIMT_Encode4(0),
     /* 102992 */ /*GILLT_v4s16*//*Label 1924*/ GIMT_Encode4(103664),
     /* 102996 */ /*GILLT_v4s32*//*Label 1925*/ GIMT_Encode4(103711), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 103008 */ /*GILLT_v8s8*//*Label 1926*/ GIMT_Encode4(103981),
     /* 103012 */ /*GILLT_v8s16*//*Label 1927*/ GIMT_Encode4(104028), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 103024 */ /*GILLT_v16s8*//*Label 1928*/ GIMT_Encode4(104142),
     /* 103028 */ // Label 1920: @103028
     /* 103028 */ GIM_Try, /*On fail goto*//*Label 1930*/ GIMT_Encode4(103368),
     /* 103033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 103036 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 103039 */   GIM_Try, /*On fail goto*//*Label 1931*/ GIMT_Encode4(103101), // Rule ID 5654 //
     /* 103044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /* 103047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 103051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 103059 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 103063 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103068 */     // MIs[1] Rn
     /* 103068 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 103073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103077 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103079 */     // (saddsat:{ *:[i32] } (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn), rGPR:{ *:[i32] }:$Rm)  =>  (QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 103079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDADD),
     /* 103082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 103084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 103086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 103090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103093 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103099 */     GIR_RootConstrainSelectedInstOperands,
     /* 103100 */     // GIR_Coverage, 5654,
     /* 103100 */     GIR_EraseRootFromParent_Done,
     /* 103101 */   // Label 1931: @103101
     /* 103101 */   GIM_Try, /*On fail goto*//*Label 1932*/ GIMT_Encode4(103163), // Rule ID 5688 //
     /* 103106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 103109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 103121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 103125 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103130 */     // MIs[1] Rn
     /* 103130 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 103135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103141 */     // (saddsat:{ *:[i32] } (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn), rGPR:{ *:[i32] }:$Rm)  =>  (t2QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 103141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDADD),
     /* 103144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 103146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 103148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 103152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103155 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103161 */     GIR_RootConstrainSelectedInstOperands,
     /* 103162 */     // GIR_Coverage, 5688,
     /* 103162 */     GIR_EraseRootFromParent_Done,
     /* 103163 */   // Label 1932: @103163
     /* 103163 */   GIM_Try, /*On fail goto*//*Label 1933*/ GIMT_Encode4(103225), // Rule ID 1870 //
     /* 103168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /* 103171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 103175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 103187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 103191 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103196 */     // MIs[1] Rn
     /* 103196 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 103201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103203 */     // (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 103203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDADD),
     /* 103206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 103208 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 103210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 103214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103217 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103223 */     GIR_RootConstrainSelectedInstOperands,
     /* 103224 */     // GIR_Coverage, 1870,
     /* 103224 */     GIR_EraseRootFromParent_Done,
     /* 103225 */   // Label 1933: @103225
     /* 103225 */   GIM_Try, /*On fail goto*//*Label 1934*/ GIMT_Encode4(103287), // Rule ID 2136 //
     /* 103230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 103233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 103249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 103253 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103258 */     // MIs[1] Rn
     /* 103258 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 103263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103265 */     // (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (t2QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 103265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDADD),
     /* 103268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 103270 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 103272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 103276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103279 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103285 */     GIR_RootConstrainSelectedInstOperands,
     /* 103286 */     // GIR_Coverage, 2136,
     /* 103286 */     GIR_EraseRootFromParent_Done,
     /* 103287 */   // Label 1934: @103287
     /* 103287 */   GIM_Try, /*On fail goto*//*Label 1935*/ GIMT_Encode4(103327), // Rule ID 1868 //
     /* 103292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /* 103295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 103299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 103303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 103307 */     // (saddsat:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (QADD:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /* 103307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QADD),
     /* 103310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 103312 */     GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 103314 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 103316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103319 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103325 */     GIR_RootConstrainSelectedInstOperands,
     /* 103326 */     // GIR_Coverage, 1868,
     /* 103326 */     GIR_EraseRootFromParent_Done,
     /* 103327 */   // Label 1935: @103327
     /* 103327 */   GIM_Try, /*On fail goto*//*Label 1936*/ GIMT_Encode4(103367), // Rule ID 2134 //
     /* 103332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 103335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103347 */     // (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)  =>  (t2QADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 103347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QADD),
     /* 103350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 103352 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 103354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 103356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103359 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103365 */     GIR_RootConstrainSelectedInstOperands,
     /* 103366 */     // GIR_Coverage, 2134,
     /* 103366 */     GIR_EraseRootFromParent_Done,
     /* 103367 */   // Label 1936: @103367
     /* 103367 */   GIM_Reject,
     /* 103368 */ // Label 1930: @103368
     /* 103368 */ GIM_Reject,
     /* 103369 */ // Label 1921: @103369
     /* 103369 */ GIM_Try, /*On fail goto*//*Label 1937*/ GIMT_Encode4(103415), // Rule ID 822 //
     /* 103374 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 103380 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 103383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103387 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103391 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103395 */   // (saddsat:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VQADDsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /* 103395 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv1i64),
     /* 103398 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103400 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103402 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103404 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103407 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103413 */   GIR_RootConstrainSelectedInstOperands,
     /* 103414 */   // GIR_Coverage, 822,
     /* 103414 */   GIR_EraseRootFromParent_Done,
     /* 103415 */ // Label 1937: @103415
     /* 103415 */ GIM_Reject,
     /* 103416 */ // Label 1922: @103416
     /* 103416 */ GIM_Try, /*On fail goto*//*Label 1938*/ GIMT_Encode4(103462), // Rule ID 817 //
     /* 103421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 103427 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 103430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103434 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103438 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103442 */   // (saddsat:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQADDsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 103442 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv2i32),
     /* 103445 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103447 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103449 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103451 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103454 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103460 */   GIR_RootConstrainSelectedInstOperands,
     /* 103461 */   // GIR_Coverage, 817,
     /* 103461 */   GIR_EraseRootFromParent_Done,
     /* 103462 */ // Label 1938: @103462
     /* 103462 */ GIM_Reject,
     /* 103463 */ // Label 1923: @103463
     /* 103463 */ GIM_Try, /*On fail goto*//*Label 1939*/ GIMT_Encode4(103663),
     /* 103468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 103471 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 103474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103478 */   GIM_Try, /*On fail goto*//*Label 1940*/ GIMT_Encode4(103552), // Rule ID 5745 //
     /* 103483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103494 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103497 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 103502 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 103506 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 103510 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103515 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103524 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103526 */     // (saddsat:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 3807:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm), QPR:{ *:[v2i64] }:$src1)  =>  (VQDMLALv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 103526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLALv2i64),
     /* 103529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103531 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 103533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 103537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 103541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103544 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103550 */     GIR_RootConstrainSelectedInstOperands,
     /* 103551 */     // GIR_Coverage, 5745,
     /* 103551 */     GIR_EraseRootFromParent_Done,
     /* 103552 */   // Label 1940: @103552
     /* 103552 */   GIM_Try, /*On fail goto*//*Label 1941*/ GIMT_Encode4(103626), // Rule ID 2489 //
     /* 103557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103572 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103575 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 103580 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 103584 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 103588 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103593 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103600 */     // (saddsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, (intrinsic_wo_chain:{ *:[v2i64] } 3807:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm))  =>  (VQDMLALv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 103600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLALv2i64),
     /* 103603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103605 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 103607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 103611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 103615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103618 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103624 */     GIR_RootConstrainSelectedInstOperands,
     /* 103625 */     // GIR_Coverage, 2489,
     /* 103625 */     GIR_EraseRootFromParent_Done,
     /* 103626 */   // Label 1941: @103626
     /* 103626 */   GIM_Try, /*On fail goto*//*Label 1942*/ GIMT_Encode4(103662), // Rule ID 823 //
     /* 103631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103642 */     // (saddsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VQADDsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /* 103642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv2i64),
     /* 103645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103647 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103654 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103660 */     GIR_RootConstrainSelectedInstOperands,
     /* 103661 */     // GIR_Coverage, 823,
     /* 103661 */     GIR_EraseRootFromParent_Done,
     /* 103662 */   // Label 1942: @103662
     /* 103662 */   GIM_Reject,
     /* 103663 */ // Label 1939: @103663
     /* 103663 */ GIM_Reject,
     /* 103664 */ // Label 1924: @103664
     /* 103664 */ GIM_Try, /*On fail goto*//*Label 1943*/ GIMT_Encode4(103710), // Rule ID 816 //
     /* 103669 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103672 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 103675 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 103678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103682 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103686 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103690 */   // (saddsat:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQADDsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 103690 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv4i16),
     /* 103693 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103695 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103697 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103699 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103702 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103708 */   GIR_RootConstrainSelectedInstOperands,
     /* 103709 */   // GIR_Coverage, 816,
     /* 103709 */   GIR_EraseRootFromParent_Done,
     /* 103710 */ // Label 1943: @103710
     /* 103710 */ GIM_Reject,
     /* 103711 */ // Label 1925: @103711
     /* 103711 */ GIM_Try, /*On fail goto*//*Label 1944*/ GIMT_Encode4(103980),
     /* 103716 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 103719 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 103722 */   GIM_Try, /*On fail goto*//*Label 1945*/ GIMT_Encode4(103800), // Rule ID 5744 //
     /* 103727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103742 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103745 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 103750 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 103754 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 103758 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103763 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103772 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103774 */     // (saddsat:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 3807:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm), QPR:{ *:[v4i32] }:$src1)  =>  (VQDMLALv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 103774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLALv4i32),
     /* 103777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103779 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 103781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 103785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 103789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103792 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103798 */     GIR_RootConstrainSelectedInstOperands,
     /* 103799 */     // GIR_Coverage, 5744,
     /* 103799 */     GIR_EraseRootFromParent_Done,
     /* 103800 */   // Label 1945: @103800
     /* 103800 */   GIM_Try, /*On fail goto*//*Label 1946*/ GIMT_Encode4(103878), // Rule ID 2488 //
     /* 103805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103812 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103824 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103827 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 103832 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 103836 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 103840 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103845 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103850 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103852 */     // (saddsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, (intrinsic_wo_chain:{ *:[v4i32] } 3807:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm))  =>  (VQDMLALv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 103852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLALv4i32),
     /* 103855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103857 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 103859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 103863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 103867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103870 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103876 */     GIR_RootConstrainSelectedInstOperands,
     /* 103877 */     // GIR_Coverage, 2488,
     /* 103877 */     GIR_EraseRootFromParent_Done,
     /* 103878 */   // Label 1946: @103878
     /* 103878 */   GIM_Try, /*On fail goto*//*Label 1947*/ GIMT_Encode4(103918), // Rule ID 819 //
     /* 103883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103890 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103898 */     // (saddsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQADDsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 103898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv4i32),
     /* 103901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103903 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103910 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103916 */     GIR_RootConstrainSelectedInstOperands,
     /* 103917 */     // GIR_Coverage, 819,
     /* 103917 */     GIR_EraseRootFromParent_Done,
     /* 103918 */   // Label 1947: @103918
     /* 103918 */   GIM_Try, /*On fail goto*//*Label 1948*/ GIMT_Encode4(103979), // Rule ID 3518 //
     /* 103923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 103926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 103930 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 103934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 103938 */     // (saddsat:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQADDs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 103938 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 103941 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103945 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDs32),
     /* 103953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 103955 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 103957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 103959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103962 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103968 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103974 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103977 */     GIR_RootConstrainSelectedInstOperands,
     /* 103978 */     // GIR_Coverage, 3518,
     /* 103978 */     GIR_EraseRootFromParent_Done,
     /* 103979 */   // Label 1948: @103979
     /* 103979 */   GIM_Reject,
     /* 103980 */ // Label 1944: @103980
     /* 103980 */ GIM_Reject,
     /* 103981 */ // Label 1926: @103981
     /* 103981 */ GIM_Try, /*On fail goto*//*Label 1949*/ GIMT_Encode4(104027), // Rule ID 820 //
     /* 103986 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103989 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 103992 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 103995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103999 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104003 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104007 */   // (saddsat:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VQADDsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 104007 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv8i8),
     /* 104010 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104012 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104014 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104016 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104019 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104025 */   GIR_RootConstrainSelectedInstOperands,
     /* 104026 */   // GIR_Coverage, 820,
     /* 104026 */   GIR_EraseRootFromParent_Done,
     /* 104027 */ // Label 1949: @104027
     /* 104027 */ GIM_Reject,
     /* 104028 */ // Label 1927: @104028
     /* 104028 */ GIM_Try, /*On fail goto*//*Label 1950*/ GIMT_Encode4(104141),
     /* 104033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104036 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 104039 */   GIM_Try, /*On fail goto*//*Label 1951*/ GIMT_Encode4(104079), // Rule ID 818 //
     /* 104044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104059 */     // (saddsat:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQADDsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 104059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv8i16),
     /* 104062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104064 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104071 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104077 */     GIR_RootConstrainSelectedInstOperands,
     /* 104078 */     // GIR_Coverage, 818,
     /* 104078 */     GIR_EraseRootFromParent_Done,
     /* 104079 */   // Label 1951: @104079
     /* 104079 */   GIM_Try, /*On fail goto*//*Label 1952*/ GIMT_Encode4(104140), // Rule ID 3515 //
     /* 104084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 104087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104099 */     // (saddsat:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQADDs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 104099 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 104102 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104106 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDs16),
     /* 104114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 104116 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 104118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 104120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104123 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104129 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104135 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104138 */     GIR_RootConstrainSelectedInstOperands,
     /* 104139 */     // GIR_Coverage, 3515,
     /* 104139 */     GIR_EraseRootFromParent_Done,
     /* 104140 */   // Label 1952: @104140
     /* 104140 */   GIM_Reject,
     /* 104141 */ // Label 1950: @104141
     /* 104141 */ GIM_Reject,
     /* 104142 */ // Label 1928: @104142
     /* 104142 */ GIM_Try, /*On fail goto*//*Label 1953*/ GIMT_Encode4(104255),
     /* 104147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 104150 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 104153 */   GIM_Try, /*On fail goto*//*Label 1954*/ GIMT_Encode4(104193), // Rule ID 821 //
     /* 104158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104173 */     // (saddsat:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VQADDsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 104173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv16i8),
     /* 104176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104178 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104185 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104191 */     GIR_RootConstrainSelectedInstOperands,
     /* 104192 */     // GIR_Coverage, 821,
     /* 104192 */     GIR_EraseRootFromParent_Done,
     /* 104193 */   // Label 1954: @104193
     /* 104193 */   GIM_Try, /*On fail goto*//*Label 1955*/ GIMT_Encode4(104254), // Rule ID 3512 //
     /* 104198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 104201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104213 */     // (saddsat:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQADDs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 104213 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 104216 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104220 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDs8),
     /* 104228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 104230 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 104232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 104234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104237 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104243 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104249 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104252 */     GIR_RootConstrainSelectedInstOperands,
     /* 104253 */     // GIR_Coverage, 3512,
     /* 104253 */     GIR_EraseRootFromParent_Done,
     /* 104254 */   // Label 1955: @104254
     /* 104254 */   GIM_Reject,
     /* 104255 */ // Label 1953: @104255
     /* 104255 */ GIM_Reject,
     /* 104256 */ // Label 1929: @104256
     /* 104256 */ GIM_Reject,
     /* 104257 */ // Label 32: @104257
     /* 104257 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(16), /*)*//*default:*//*Label 1964*/ GIMT_Encode4(104901),
     /* 104268 */ /*GILLT_s64*//*Label 1956*/ GIMT_Encode4(104324), GIMT_Encode4(0),
     /* 104276 */ /*GILLT_v2s32*//*Label 1957*/ GIMT_Encode4(104371),
     /* 104280 */ /*GILLT_v2s64*//*Label 1958*/ GIMT_Encode4(104418), GIMT_Encode4(0),
     /* 104288 */ /*GILLT_v4s16*//*Label 1959*/ GIMT_Encode4(104465),
     /* 104292 */ /*GILLT_v4s32*//*Label 1960*/ GIMT_Encode4(104512), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 104304 */ /*GILLT_v8s8*//*Label 1961*/ GIMT_Encode4(104626),
     /* 104308 */ /*GILLT_v8s16*//*Label 1962*/ GIMT_Encode4(104673), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 104320 */ /*GILLT_v16s8*//*Label 1963*/ GIMT_Encode4(104787),
     /* 104324 */ // Label 1956: @104324
     /* 104324 */ GIM_Try, /*On fail goto*//*Label 1965*/ GIMT_Encode4(104370), // Rule ID 1022 //
     /* 104329 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104332 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 104335 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 104338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104342 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104346 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104350 */   // (usubsat:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VQSUBuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /* 104350 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv1i64),
     /* 104353 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104355 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104357 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104359 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104362 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104368 */   GIR_RootConstrainSelectedInstOperands,
     /* 104369 */   // GIR_Coverage, 1022,
     /* 104369 */   GIR_EraseRootFromParent_Done,
     /* 104370 */ // Label 1965: @104370
     /* 104370 */ GIM_Reject,
     /* 104371 */ // Label 1957: @104371
     /* 104371 */ GIM_Try, /*On fail goto*//*Label 1966*/ GIMT_Encode4(104417), // Rule ID 1017 //
     /* 104376 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 104382 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 104385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104389 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104393 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104397 */   // (usubsat:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQSUBuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 104397 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv2i32),
     /* 104400 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104402 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104404 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104406 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104409 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104415 */   GIR_RootConstrainSelectedInstOperands,
     /* 104416 */   // GIR_Coverage, 1017,
     /* 104416 */   GIR_EraseRootFromParent_Done,
     /* 104417 */ // Label 1966: @104417
     /* 104417 */ GIM_Reject,
     /* 104418 */ // Label 1958: @104418
     /* 104418 */ GIM_Try, /*On fail goto*//*Label 1967*/ GIMT_Encode4(104464), // Rule ID 1023 //
     /* 104423 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 104429 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 104432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104436 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104440 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104444 */   // (usubsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VQSUBuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /* 104444 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv2i64),
     /* 104447 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104449 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104451 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104453 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104456 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104462 */   GIR_RootConstrainSelectedInstOperands,
     /* 104463 */   // GIR_Coverage, 1023,
     /* 104463 */   GIR_EraseRootFromParent_Done,
     /* 104464 */ // Label 1967: @104464
     /* 104464 */ GIM_Reject,
     /* 104465 */ // Label 1959: @104465
     /* 104465 */ GIM_Try, /*On fail goto*//*Label 1968*/ GIMT_Encode4(104511), // Rule ID 1016 //
     /* 104470 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 104476 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 104479 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104483 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104487 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104491 */   // (usubsat:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQSUBuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 104491 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv4i16),
     /* 104494 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104496 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104498 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104500 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104503 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104509 */   GIR_RootConstrainSelectedInstOperands,
     /* 104510 */   // GIR_Coverage, 1016,
     /* 104510 */   GIR_EraseRootFromParent_Done,
     /* 104511 */ // Label 1968: @104511
     /* 104511 */ GIM_Reject,
     /* 104512 */ // Label 1960: @104512
     /* 104512 */ GIM_Try, /*On fail goto*//*Label 1969*/ GIMT_Encode4(104625),
     /* 104517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 104520 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 104523 */   GIM_Try, /*On fail goto*//*Label 1970*/ GIMT_Encode4(104563), // Rule ID 1019 //
     /* 104528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104535 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104543 */     // (usubsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQSUBuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 104543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv4i32),
     /* 104546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104548 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104550 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104555 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104561 */     GIR_RootConstrainSelectedInstOperands,
     /* 104562 */     // GIR_Coverage, 1019,
     /* 104562 */     GIR_EraseRootFromParent_Done,
     /* 104563 */   // Label 1970: @104563
     /* 104563 */   GIM_Try, /*On fail goto*//*Label 1971*/ GIMT_Encode4(104624), // Rule ID 3545 //
     /* 104568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 104571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104583 */     // (usubsat:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQSUBu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 104583 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 104586 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104590 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBu32),
     /* 104598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 104600 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 104602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 104604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104607 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104613 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104619 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104622 */     GIR_RootConstrainSelectedInstOperands,
     /* 104623 */     // GIR_Coverage, 3545,
     /* 104623 */     GIR_EraseRootFromParent_Done,
     /* 104624 */   // Label 1971: @104624
     /* 104624 */   GIM_Reject,
     /* 104625 */ // Label 1969: @104625
     /* 104625 */ GIM_Reject,
     /* 104626 */ // Label 1961: @104626
     /* 104626 */ GIM_Try, /*On fail goto*//*Label 1972*/ GIMT_Encode4(104672), // Rule ID 1020 //
     /* 104631 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104634 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 104637 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 104640 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104644 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104648 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104652 */   // (usubsat:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VQSUBuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 104652 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv8i8),
     /* 104655 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104657 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104659 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104661 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104664 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104670 */   GIR_RootConstrainSelectedInstOperands,
     /* 104671 */   // GIR_Coverage, 1020,
     /* 104671 */   GIR_EraseRootFromParent_Done,
     /* 104672 */ // Label 1972: @104672
     /* 104672 */ GIM_Reject,
     /* 104673 */ // Label 1962: @104673
     /* 104673 */ GIM_Try, /*On fail goto*//*Label 1973*/ GIMT_Encode4(104786),
     /* 104678 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104681 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 104684 */   GIM_Try, /*On fail goto*//*Label 1974*/ GIMT_Encode4(104724), // Rule ID 1018 //
     /* 104689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104696 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104704 */     // (usubsat:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQSUBuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 104704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv8i16),
     /* 104707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104709 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104716 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104722 */     GIR_RootConstrainSelectedInstOperands,
     /* 104723 */     // GIR_Coverage, 1018,
     /* 104723 */     GIR_EraseRootFromParent_Done,
     /* 104724 */   // Label 1974: @104724
     /* 104724 */   GIM_Try, /*On fail goto*//*Label 1975*/ GIMT_Encode4(104785), // Rule ID 3542 //
     /* 104729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 104732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104744 */     // (usubsat:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQSUBu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 104744 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 104747 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104751 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBu16),
     /* 104759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 104761 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 104763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 104765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104768 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104774 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104780 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104783 */     GIR_RootConstrainSelectedInstOperands,
     /* 104784 */     // GIR_Coverage, 3542,
     /* 104784 */     GIR_EraseRootFromParent_Done,
     /* 104785 */   // Label 1975: @104785
     /* 104785 */   GIM_Reject,
     /* 104786 */ // Label 1973: @104786
     /* 104786 */ GIM_Reject,
     /* 104787 */ // Label 1963: @104787
     /* 104787 */ GIM_Try, /*On fail goto*//*Label 1976*/ GIMT_Encode4(104900),
     /* 104792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 104795 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 104798 */   GIM_Try, /*On fail goto*//*Label 1977*/ GIMT_Encode4(104838), // Rule ID 1021 //
     /* 104803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104810 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104818 */     // (usubsat:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VQSUBuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 104818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv16i8),
     /* 104821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104823 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104830 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104836 */     GIR_RootConstrainSelectedInstOperands,
     /* 104837 */     // GIR_Coverage, 1021,
     /* 104837 */     GIR_EraseRootFromParent_Done,
     /* 104838 */   // Label 1977: @104838
     /* 104838 */   GIM_Try, /*On fail goto*//*Label 1978*/ GIMT_Encode4(104899), // Rule ID 3539 //
     /* 104843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 104846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104850 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104858 */     // (usubsat:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQSUBu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 104858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 104861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBu8),
     /* 104873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 104875 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 104877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 104879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104882 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104888 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104894 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104897 */     GIR_RootConstrainSelectedInstOperands,
     /* 104898 */     // GIR_Coverage, 3539,
     /* 104898 */     GIR_EraseRootFromParent_Done,
     /* 104899 */   // Label 1978: @104899
     /* 104899 */   GIM_Reject,
     /* 104900 */ // Label 1976: @104900
     /* 104900 */ GIM_Reject,
     /* 104901 */ // Label 1964: @104901
     /* 104901 */ GIM_Reject,
     /* 104902 */ // Label 33: @104902
     /* 104902 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 1988*/ GIMT_Encode4(105921),
     /* 104913 */ /*GILLT_s32*//*Label 1979*/ GIMT_Encode4(104973),
     /* 104917 */ /*GILLT_s64*//*Label 1980*/ GIMT_Encode4(105190), GIMT_Encode4(0),
     /* 104925 */ /*GILLT_v2s32*//*Label 1981*/ GIMT_Encode4(105237),
     /* 104929 */ /*GILLT_v2s64*//*Label 1982*/ GIMT_Encode4(105284), GIMT_Encode4(0),
     /* 104937 */ /*GILLT_v4s16*//*Label 1983*/ GIMT_Encode4(105407),
     /* 104941 */ /*GILLT_v4s32*//*Label 1984*/ GIMT_Encode4(105454), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 104953 */ /*GILLT_v8s8*//*Label 1985*/ GIMT_Encode4(105646),
     /* 104957 */ /*GILLT_v8s16*//*Label 1986*/ GIMT_Encode4(105693), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 104969 */ /*GILLT_v16s8*//*Label 1987*/ GIMT_Encode4(105807),
     /* 104973 */ // Label 1979: @104973
     /* 104973 */ GIM_Try, /*On fail goto*//*Label 1989*/ GIMT_Encode4(105189),
     /* 104978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 104981 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 104984 */   GIM_Try, /*On fail goto*//*Label 1990*/ GIMT_Encode4(105046), // Rule ID 1871 //
     /* 104989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /* 104992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 104996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 105000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 105008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 105012 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 105017 */     // MIs[1] Rn
     /* 105017 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 105022 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105024 */     // (ssubsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (QDSUB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 105024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDSUB),
     /* 105027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 105029 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 105031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 105035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105038 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105044 */     GIR_RootConstrainSelectedInstOperands,
     /* 105045 */     // GIR_Coverage, 1871,
     /* 105045 */     GIR_EraseRootFromParent_Done,
     /* 105046 */   // Label 1990: @105046
     /* 105046 */   GIM_Try, /*On fail goto*//*Label 1991*/ GIMT_Encode4(105108), // Rule ID 2137 //
     /* 105051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 105054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 105058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 105062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 105070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 105074 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 105079 */     // MIs[1] Rn
     /* 105079 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 105084 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105086 */     // (ssubsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (t2QDSUB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 105086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDSUB),
     /* 105089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 105091 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 105093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 105097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105100 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105106 */     GIR_RootConstrainSelectedInstOperands,
     /* 105107 */     // GIR_Coverage, 2137,
     /* 105107 */     GIR_EraseRootFromParent_Done,
     /* 105108 */   // Label 1991: @105108
     /* 105108 */   GIM_Try, /*On fail goto*//*Label 1992*/ GIMT_Encode4(105148), // Rule ID 1869 //
     /* 105113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /* 105116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 105120 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 105124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 105128 */     // (ssubsat:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (QSUB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /* 105128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QSUB),
     /* 105131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 105133 */     GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 105135 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 105137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105140 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105146 */     GIR_RootConstrainSelectedInstOperands,
     /* 105147 */     // GIR_Coverage, 1869,
     /* 105147 */     GIR_EraseRootFromParent_Done,
     /* 105148 */   // Label 1992: @105148
     /* 105148 */   GIM_Try, /*On fail goto*//*Label 1993*/ GIMT_Encode4(105188), // Rule ID 2135 //
     /* 105153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 105156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 105160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 105164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 105168 */     // (ssubsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)  =>  (t2QSUB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 105168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QSUB),
     /* 105171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 105173 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 105175 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 105177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105180 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105186 */     GIR_RootConstrainSelectedInstOperands,
     /* 105187 */     // GIR_Coverage, 2135,
     /* 105187 */     GIR_EraseRootFromParent_Done,
     /* 105188 */   // Label 1993: @105188
     /* 105188 */   GIM_Reject,
     /* 105189 */ // Label 1989: @105189
     /* 105189 */ GIM_Reject,
     /* 105190 */ // Label 1980: @105190
     /* 105190 */ GIM_Try, /*On fail goto*//*Label 1994*/ GIMT_Encode4(105236), // Rule ID 1014 //
     /* 105195 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 105201 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 105204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105208 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105212 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105216 */   // (ssubsat:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VQSUBsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /* 105216 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv1i64),
     /* 105219 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105221 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105223 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105225 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105228 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105234 */   GIR_RootConstrainSelectedInstOperands,
     /* 105235 */   // GIR_Coverage, 1014,
     /* 105235 */   GIR_EraseRootFromParent_Done,
     /* 105236 */ // Label 1994: @105236
     /* 105236 */ GIM_Reject,
     /* 105237 */ // Label 1981: @105237
     /* 105237 */ GIM_Try, /*On fail goto*//*Label 1995*/ GIMT_Encode4(105283), // Rule ID 1009 //
     /* 105242 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 105248 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 105251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105255 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105259 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105263 */   // (ssubsat:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQSUBsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 105263 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv2i32),
     /* 105266 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105268 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105270 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105272 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105275 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105281 */   GIR_RootConstrainSelectedInstOperands,
     /* 105282 */   // GIR_Coverage, 1009,
     /* 105282 */   GIR_EraseRootFromParent_Done,
     /* 105283 */ // Label 1995: @105283
     /* 105283 */ GIM_Reject,
     /* 105284 */ // Label 1982: @105284
     /* 105284 */ GIM_Try, /*On fail goto*//*Label 1996*/ GIMT_Encode4(105406),
     /* 105289 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 105292 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 105295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105299 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105303 */   GIM_Try, /*On fail goto*//*Label 1997*/ GIMT_Encode4(105373), // Rule ID 2496 //
     /* 105308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 105319 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 105322 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 105327 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 105331 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 105335 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105340 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105347 */     // (ssubsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, (intrinsic_wo_chain:{ *:[v2i64] } 3807:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm))  =>  (VQDMLSLv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 105347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLSLv2i64),
     /* 105350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105352 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 105354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 105358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 105362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105365 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105371 */     GIR_RootConstrainSelectedInstOperands,
     /* 105372 */     // GIR_Coverage, 2496,
     /* 105372 */     GIR_EraseRootFromParent_Done,
     /* 105373 */   // Label 1997: @105373
     /* 105373 */   GIM_Try, /*On fail goto*//*Label 1998*/ GIMT_Encode4(105405), // Rule ID 1015 //
     /* 105378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105385 */     // (ssubsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VQSUBsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /* 105385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv2i64),
     /* 105388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105390 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105397 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105403 */     GIR_RootConstrainSelectedInstOperands,
     /* 105404 */     // GIR_Coverage, 1015,
     /* 105404 */     GIR_EraseRootFromParent_Done,
     /* 105405 */   // Label 1998: @105405
     /* 105405 */   GIM_Reject,
     /* 105406 */ // Label 1996: @105406
     /* 105406 */ GIM_Reject,
     /* 105407 */ // Label 1983: @105407
     /* 105407 */ GIM_Try, /*On fail goto*//*Label 1999*/ GIMT_Encode4(105453), // Rule ID 1008 //
     /* 105412 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 105418 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 105421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105425 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105429 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105433 */   // (ssubsat:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQSUBsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 105433 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv4i16),
     /* 105436 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105438 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105440 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105442 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105445 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105451 */   GIR_RootConstrainSelectedInstOperands,
     /* 105452 */   // GIR_Coverage, 1008,
     /* 105452 */   GIR_EraseRootFromParent_Done,
     /* 105453 */ // Label 1999: @105453
     /* 105453 */ GIM_Reject,
     /* 105454 */ // Label 1984: @105454
     /* 105454 */ GIM_Try, /*On fail goto*//*Label 2000*/ GIMT_Encode4(105645),
     /* 105459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 105462 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 105465 */   GIM_Try, /*On fail goto*//*Label 2001*/ GIMT_Encode4(105543), // Rule ID 2495 //
     /* 105470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105477 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 105489 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 105492 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 105497 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 105501 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 105505 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105510 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105517 */     // (ssubsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, (intrinsic_wo_chain:{ *:[v4i32] } 3807:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm))  =>  (VQDMLSLv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 105517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLSLv4i32),
     /* 105520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105522 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 105524 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 105528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 105532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105535 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105541 */     GIR_RootConstrainSelectedInstOperands,
     /* 105542 */     // GIR_Coverage, 2495,
     /* 105542 */     GIR_EraseRootFromParent_Done,
     /* 105543 */   // Label 2001: @105543
     /* 105543 */   GIM_Try, /*On fail goto*//*Label 2002*/ GIMT_Encode4(105583), // Rule ID 1011 //
     /* 105548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105555 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105563 */     // (ssubsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQSUBsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 105563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv4i32),
     /* 105566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105568 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105570 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105575 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105581 */     GIR_RootConstrainSelectedInstOperands,
     /* 105582 */     // GIR_Coverage, 1011,
     /* 105582 */     GIR_EraseRootFromParent_Done,
     /* 105583 */   // Label 2002: @105583
     /* 105583 */   GIM_Try, /*On fail goto*//*Label 2003*/ GIMT_Encode4(105644), // Rule ID 3536 //
     /* 105588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 105591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105595 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105603 */     // (ssubsat:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQSUBs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 105603 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 105606 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105610 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBs32),
     /* 105618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 105620 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 105622 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 105624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105627 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105633 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105639 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105642 */     GIR_RootConstrainSelectedInstOperands,
     /* 105643 */     // GIR_Coverage, 3536,
     /* 105643 */     GIR_EraseRootFromParent_Done,
     /* 105644 */   // Label 2003: @105644
     /* 105644 */   GIM_Reject,
     /* 105645 */ // Label 2000: @105645
     /* 105645 */ GIM_Reject,
     /* 105646 */ // Label 1985: @105646
     /* 105646 */ GIM_Try, /*On fail goto*//*Label 2004*/ GIMT_Encode4(105692), // Rule ID 1012 //
     /* 105651 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105654 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 105657 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 105660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105664 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105668 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105672 */   // (ssubsat:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VQSUBsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 105672 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv8i8),
     /* 105675 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105677 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105679 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105681 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105684 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105690 */   GIR_RootConstrainSelectedInstOperands,
     /* 105691 */   // GIR_Coverage, 1012,
     /* 105691 */   GIR_EraseRootFromParent_Done,
     /* 105692 */ // Label 2004: @105692
     /* 105692 */ GIM_Reject,
     /* 105693 */ // Label 1986: @105693
     /* 105693 */ GIM_Try, /*On fail goto*//*Label 2005*/ GIMT_Encode4(105806),
     /* 105698 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 105701 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 105704 */   GIM_Try, /*On fail goto*//*Label 2006*/ GIMT_Encode4(105744), // Rule ID 1010 //
     /* 105709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105716 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105724 */     // (ssubsat:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQSUBsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 105724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv8i16),
     /* 105727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105729 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105736 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105742 */     GIR_RootConstrainSelectedInstOperands,
     /* 105743 */     // GIR_Coverage, 1010,
     /* 105743 */     GIR_EraseRootFromParent_Done,
     /* 105744 */   // Label 2006: @105744
     /* 105744 */   GIM_Try, /*On fail goto*//*Label 2007*/ GIMT_Encode4(105805), // Rule ID 3533 //
     /* 105749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 105752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105764 */     // (ssubsat:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQSUBs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 105764 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 105767 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105771 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBs16),
     /* 105779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 105781 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 105783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 105785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105788 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105794 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105800 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105803 */     GIR_RootConstrainSelectedInstOperands,
     /* 105804 */     // GIR_Coverage, 3533,
     /* 105804 */     GIR_EraseRootFromParent_Done,
     /* 105805 */   // Label 2007: @105805
     /* 105805 */   GIM_Reject,
     /* 105806 */ // Label 2005: @105806
     /* 105806 */ GIM_Reject,
     /* 105807 */ // Label 1987: @105807
     /* 105807 */ GIM_Try, /*On fail goto*//*Label 2008*/ GIMT_Encode4(105920),
     /* 105812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 105815 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 105818 */   GIM_Try, /*On fail goto*//*Label 2009*/ GIMT_Encode4(105858), // Rule ID 1013 //
     /* 105823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105830 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105838 */     // (ssubsat:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VQSUBsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 105838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv16i8),
     /* 105841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105843 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105850 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105856 */     GIR_RootConstrainSelectedInstOperands,
     /* 105857 */     // GIR_Coverage, 1013,
     /* 105857 */     GIR_EraseRootFromParent_Done,
     /* 105858 */   // Label 2009: @105858
     /* 105858 */   GIM_Try, /*On fail goto*//*Label 2010*/ GIMT_Encode4(105919), // Rule ID 3530 //
     /* 105863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 105866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105870 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105878 */     // (ssubsat:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQSUBs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 105878 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 105881 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105885 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBs8),
     /* 105893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 105895 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 105897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 105899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105902 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105908 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105914 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105917 */     GIR_RootConstrainSelectedInstOperands,
     /* 105918 */     // GIR_Coverage, 3530,
     /* 105918 */     GIR_EraseRootFromParent_Done,
     /* 105919 */   // Label 2010: @105919
     /* 105919 */   GIM_Reject,
     /* 105920 */ // Label 2008: @105920
     /* 105920 */ GIM_Reject,
     /* 105921 */ // Label 1988: @105921
     /* 105921 */ GIM_Reject,
     /* 105922 */ // Label 34: @105922
     /* 105922 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2018*/ GIMT_Encode4(108274),
     /* 105933 */ /*GILLT_s16*//*Label 2011*/ GIMT_Encode4(105985),
     /* 105937 */ /*GILLT_s32*//*Label 2012*/ GIMT_Encode4(106032),
     /* 105941 */ /*GILLT_s64*//*Label 2013*/ GIMT_Encode4(107627), GIMT_Encode4(0),
     /* 105949 */ /*GILLT_v2s32*//*Label 2014*/ GIMT_Encode4(107674), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 105961 */ /*GILLT_v4s16*//*Label 2015*/ GIMT_Encode4(107721),
     /* 105965 */ /*GILLT_v4s32*//*Label 2016*/ GIMT_Encode4(107906), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 105981 */ /*GILLT_v8s16*//*Label 2017*/ GIMT_Encode4(108020),
     /* 105985 */ // Label 2011: @105985
     /* 105985 */ GIM_Try, /*On fail goto*//*Label 2019*/ GIMT_Encode4(106031), // Rule ID 614 //
     /* 105990 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 105993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 105996 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 105999 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 106003 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 106007 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 106011 */   // (fadd:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VADDH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 106011 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDH),
     /* 106014 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 106016 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 106018 */   GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 106020 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 106023 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 106029 */   GIR_RootConstrainSelectedInstOperands,
     /* 106030 */   // GIR_Coverage, 614,
     /* 106030 */   GIR_EraseRootFromParent_Done,
     /* 106031 */ // Label 2019: @106031
     /* 106031 */ GIM_Reject,
     /* 106032 */ // Label 2012: @106032
     /* 106032 */ GIM_Try, /*On fail goto*//*Label 2020*/ GIMT_Encode4(107626),
     /* 106037 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 106040 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 106043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106047 */   GIM_Try, /*On fail goto*//*Label 2021*/ GIMT_Encode4(106375), // Rule ID 5921 //
     /* 106052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseFPVMLx_UseNEONForFP),
     /* 106055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 106063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 106067 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 106071 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106076 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106087 */     // (fadd:{ *:[f32] } (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b), SPR:{ *:[f32] }:$acc)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMLAfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 106087 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 106090 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106094 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106099 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 106101 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 106104 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106108 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106113 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 106116 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106121 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 106124 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106128 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106133 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 106136 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 106140 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 106143 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106148 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106153 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106158 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 106161 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106165 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106170 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 106172 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 106175 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106179 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106184 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 106187 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106192 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 106195 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106199 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106204 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 106207 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 106211 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 106214 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106219 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106224 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106229 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 106232 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106236 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106241 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 106243 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 106246 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106250 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106255 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 106258 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106263 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 106266 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106270 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106275 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 106278 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // acc
     /* 106282 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 106285 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106290 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106295 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106300 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 106303 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMLAfd),
     /* 106307 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106312 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 106315 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 106318 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 106321 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 106324 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 106330 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106332 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 106335 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106339 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106344 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 106347 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106357 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 106364 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106369 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106374 */     // GIR_Coverage, 5921,
     /* 106374 */     GIR_EraseRootFromParent_Done,
     /* 106375 */   // Label 2021: @106375
     /* 106375 */   GIM_Try, /*On fail goto*//*Label 2022*/ GIMT_Encode4(106703), // Rule ID 5922 //
     /* 106380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4_UseFusedMAC_UseNEONForFP),
     /* 106383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 106391 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 106395 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 106399 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106404 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106415 */     // (fadd:{ *:[f32] } (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b), SPR:{ *:[f32] }:$acc)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VFMAfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 106415 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 106418 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106422 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106427 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 106429 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 106432 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106436 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106441 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 106444 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106449 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 106452 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106456 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106461 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 106464 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 106468 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 106471 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106476 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106481 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106486 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 106489 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106493 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106498 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 106500 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 106503 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106507 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106512 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 106515 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106520 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 106523 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106527 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106532 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 106535 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 106539 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 106542 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106547 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106552 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106557 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 106560 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106564 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106569 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 106571 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 106574 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106578 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106583 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 106586 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106591 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 106594 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106598 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106603 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 106606 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // acc
     /* 106610 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 106613 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106618 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106623 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106628 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 106631 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VFMAfd),
     /* 106635 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106640 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 106643 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 106646 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 106649 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 106652 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 106658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106660 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 106663 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106667 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106672 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 106675 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106685 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 106692 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106697 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106702 */     // GIR_Coverage, 5922,
     /* 106702 */     GIR_EraseRootFromParent_Done,
     /* 106703 */   // Label 2022: @106703
     /* 106703 */   GIM_Try, /*On fail goto*//*Label 2023*/ GIMT_Encode4(107031), // Rule ID 2700 //
     /* 106708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseFPVMLx_UseNEONForFP),
     /* 106711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 106719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 106723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 106727 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 106731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106736 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106743 */     // (fadd:{ *:[f32] } SPR:{ *:[f32] }:$acc, (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b))  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMLAfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 106743 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 106746 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106750 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106755 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 106757 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 106760 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106764 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106769 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 106772 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106777 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 106780 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106784 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106789 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 106792 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 106796 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 106799 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106804 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106809 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106814 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 106817 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106821 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106826 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 106828 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 106831 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106835 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106840 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 106843 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106848 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 106851 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106855 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106860 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 106863 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 106867 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 106870 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106875 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106880 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106885 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 106888 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106892 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106897 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 106899 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 106902 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106906 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106911 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 106914 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106919 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 106922 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106926 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106931 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 106934 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // acc
     /* 106938 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 106941 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106946 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106951 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106956 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 106959 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMLAfd),
     /* 106963 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106968 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 106971 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 106974 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 106977 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 106980 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 106986 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106988 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 106991 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106995 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107000 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 107003 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107013 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 107020 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107025 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107030 */     // GIR_Coverage, 2700,
     /* 107030 */     GIR_EraseRootFromParent_Done,
     /* 107031 */   // Label 2023: @107031
     /* 107031 */   GIM_Try, /*On fail goto*//*Label 2024*/ GIMT_Encode4(107359), // Rule ID 2702 //
     /* 107036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4_UseFusedMAC_UseNEONForFP),
     /* 107039 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 107047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 107051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 107055 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 107059 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107064 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107071 */     // (fadd:{ *:[f32] } SPR:{ *:[f32] }:$acc, (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b))  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VFMAfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 107071 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 107074 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107078 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107083 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 107085 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 107088 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107092 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107097 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 107100 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107105 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 107108 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 107112 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107117 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 107120 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 107124 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 107127 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107132 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107137 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107142 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 107145 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107149 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107154 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 107156 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 107159 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107163 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107168 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 107171 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107176 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 107179 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 107183 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107188 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 107191 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 107195 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 107198 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107203 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107208 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107213 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 107216 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107220 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107225 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 107227 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 107230 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107234 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107239 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 107242 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107247 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 107250 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 107254 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107259 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 107262 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // acc
     /* 107266 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 107269 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107274 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107279 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107284 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 107287 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VFMAfd),
     /* 107291 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107296 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 107299 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 107302 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 107305 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 107308 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107314 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107316 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 107319 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107323 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107328 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 107331 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107341 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 107348 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107353 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107358 */     // GIR_Coverage, 2702,
     /* 107358 */     GIR_EraseRootFromParent_Done,
     /* 107359 */   // Label 2024: @107359
     /* 107359 */   GIM_Try, /*On fail goto*//*Label 2025*/ GIMT_Encode4(107395), // Rule ID 613 //
     /* 107364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 107367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107375 */     // (fadd:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VADDS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 107375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDS),
     /* 107378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 107380 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 107382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 107384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107387 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107393 */     GIR_RootConstrainSelectedInstOperands,
     /* 107394 */     // GIR_Coverage, 613,
     /* 107394 */     GIR_EraseRootFromParent_Done,
     /* 107395 */   // Label 2025: @107395
     /* 107395 */   GIM_Try, /*On fail goto*//*Label 2026*/ GIMT_Encode4(107625), // Rule ID 2697 //
     /* 107400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 107403 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107411 */     // (fadd:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VADDfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 107411 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 107414 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107418 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107423 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 107425 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 107428 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107432 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107437 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 107440 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107445 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 107448 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 107452 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107457 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 107460 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 107464 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 107467 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107472 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107477 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107482 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 107485 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107489 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107494 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 107496 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 107499 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107503 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107508 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 107511 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107516 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 107519 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 107523 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107528 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 107531 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 107535 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 107538 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107543 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107548 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107553 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 107556 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VADDfd),
     /* 107560 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107565 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 107568 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 107571 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 107574 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107580 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107582 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 107585 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107589 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107594 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 107597 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107607 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 107614 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107619 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107624 */     // GIR_Coverage, 2697,
     /* 107624 */     GIR_EraseRootFromParent_Done,
     /* 107625 */   // Label 2026: @107625
     /* 107625 */   GIM_Reject,
     /* 107626 */ // Label 2020: @107626
     /* 107626 */ GIM_Reject,
     /* 107627 */ // Label 2013: @107627
     /* 107627 */ GIM_Try, /*On fail goto*//*Label 2027*/ GIMT_Encode4(107673), // Rule ID 612 //
     /* 107632 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 107635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107638 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 107641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107645 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107649 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107653 */   // (fadd:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VADDD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 107653 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDD),
     /* 107656 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 107658 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 107660 */   GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 107662 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107665 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107671 */   GIR_RootConstrainSelectedInstOperands,
     /* 107672 */   // GIR_Coverage, 612,
     /* 107672 */   GIR_EraseRootFromParent_Done,
     /* 107673 */ // Label 2027: @107673
     /* 107673 */ GIM_Reject,
     /* 107674 */ // Label 2014: @107674
     /* 107674 */ GIM_Try, /*On fail goto*//*Label 2028*/ GIMT_Encode4(107720), // Rule ID 764 //
     /* 107679 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 107682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 107685 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 107688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107692 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107696 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107700 */   // (fadd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VADDfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 107700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDfd),
     /* 107703 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 107705 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 107707 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 107709 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107712 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107718 */   GIR_RootConstrainSelectedInstOperands,
     /* 107719 */   // GIR_Coverage, 764,
     /* 107719 */   GIR_EraseRootFromParent_Done,
     /* 107720 */ // Label 2028: @107720
     /* 107720 */ GIM_Reject,
     /* 107721 */ // Label 2015: @107721
     /* 107721 */ GIM_Try, /*On fail goto*//*Label 2029*/ GIMT_Encode4(107905),
     /* 107726 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107729 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 107732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107736 */   GIM_Try, /*On fail goto*//*Label 2030*/ GIMT_Encode4(107802), // Rule ID 5584 //
     /* 107741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 107744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 107752 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107756 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 107760 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107765 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107774 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107776 */     // (fadd:{ *:[v4f16] } (fmul:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm), DPR:{ *:[v4f16] }:$src1)  =>  (VFMAhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 107776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhd),
     /* 107779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 107781 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 107783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 107787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 107791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107794 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107800 */     GIR_RootConstrainSelectedInstOperands,
     /* 107801 */     // GIR_Coverage, 5584,
     /* 107801 */     GIR_EraseRootFromParent_Done,
     /* 107802 */   // Label 2030: @107802
     /* 107802 */   GIM_Try, /*On fail goto*//*Label 2031*/ GIMT_Encode4(107868), // Rule ID 945 //
     /* 107807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 107810 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 107818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 107822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107826 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 107830 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107835 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107842 */     // (fadd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, (fmul:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm))  =>  (VFMAhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 107842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhd),
     /* 107845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 107847 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 107849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 107853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 107857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107860 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107866 */     GIR_RootConstrainSelectedInstOperands,
     /* 107867 */     // GIR_Coverage, 945,
     /* 107867 */     GIR_EraseRootFromParent_Done,
     /* 107868 */   // Label 2031: @107868
     /* 107868 */   GIM_Try, /*On fail goto*//*Label 2032*/ GIMT_Encode4(107904), // Rule ID 766 //
     /* 107873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 107876 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107884 */     // (fadd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VADDhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 107884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDhd),
     /* 107887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 107889 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 107891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 107893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107896 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107902 */     GIR_RootConstrainSelectedInstOperands,
     /* 107903 */     // GIR_Coverage, 766,
     /* 107903 */     GIR_EraseRootFromParent_Done,
     /* 107904 */   // Label 2032: @107904
     /* 107904 */   GIM_Reject,
     /* 107905 */ // Label 2029: @107905
     /* 107905 */ GIM_Reject,
     /* 107906 */ // Label 2016: @107906
     /* 107906 */ GIM_Try, /*On fail goto*//*Label 2033*/ GIMT_Encode4(108019),
     /* 107911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 107914 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 107917 */   GIM_Try, /*On fail goto*//*Label 2034*/ GIMT_Encode4(107957), // Rule ID 765 //
     /* 107922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 107925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107937 */     // (fadd:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VADDfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 107937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDfq),
     /* 107940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 107942 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 107944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 107946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107949 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107955 */     GIR_RootConstrainSelectedInstOperands,
     /* 107956 */     // GIR_Coverage, 765,
     /* 107956 */     GIR_EraseRootFromParent_Done,
     /* 107957 */   // Label 2034: @107957
     /* 107957 */   GIM_Try, /*On fail goto*//*Label 2035*/ GIMT_Encode4(108018), // Rule ID 4016 //
     /* 107962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 107965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 107969 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 107973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 107977 */     // (fadd:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)  =>  (MVE_VADDf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 107977 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 107980 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107984 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDf32),
     /* 107992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 107994 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 107996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 107998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108001 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108007 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108016 */     GIR_RootConstrainSelectedInstOperands,
     /* 108017 */     // GIR_Coverage, 4016,
     /* 108017 */     GIR_EraseRootFromParent_Done,
     /* 108018 */   // Label 2035: @108018
     /* 108018 */   GIM_Reject,
     /* 108019 */ // Label 2033: @108019
     /* 108019 */ GIM_Reject,
     /* 108020 */ // Label 2017: @108020
     /* 108020 */ GIM_Try, /*On fail goto*//*Label 2036*/ GIMT_Encode4(108273),
     /* 108025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 108028 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 108031 */   GIM_Try, /*On fail goto*//*Label 2037*/ GIMT_Encode4(108101), // Rule ID 5585 //
     /* 108036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 108039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 108047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 108051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 108055 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 108059 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108064 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108075 */     // (fadd:{ *:[v8f16] } (fmul:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm), QPR:{ *:[v8f16] }:$src1)  =>  (VFMAhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 108075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhq),
     /* 108078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 108080 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 108082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 108086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 108090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 108093 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108099 */     GIR_RootConstrainSelectedInstOperands,
     /* 108100 */     // GIR_Coverage, 5585,
     /* 108100 */     GIR_EraseRootFromParent_Done,
     /* 108101 */   // Label 2037: @108101
     /* 108101 */   GIM_Try, /*On fail goto*//*Label 2038*/ GIMT_Encode4(108171), // Rule ID 946 //
     /* 108106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 108109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 108121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 108125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 108129 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 108133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108138 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108145 */     // (fadd:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, (fmul:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm))  =>  (VFMAhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 108145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhq),
     /* 108148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 108150 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 108156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 108160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 108163 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108169 */     GIR_RootConstrainSelectedInstOperands,
     /* 108170 */     // GIR_Coverage, 946,
     /* 108170 */     GIR_EraseRootFromParent_Done,
     /* 108171 */   // Label 2038: @108171
     /* 108171 */   GIM_Try, /*On fail goto*//*Label 2039*/ GIMT_Encode4(108211), // Rule ID 767 //
     /* 108176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 108179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108191 */     // (fadd:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VADDhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 108191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDhq),
     /* 108194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 108196 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 108198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 108200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 108203 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108209 */     GIR_RootConstrainSelectedInstOperands,
     /* 108210 */     // GIR_Coverage, 767,
     /* 108210 */     GIR_EraseRootFromParent_Done,
     /* 108211 */   // Label 2039: @108211
     /* 108211 */   GIM_Try, /*On fail goto*//*Label 2040*/ GIMT_Encode4(108272), // Rule ID 4020 //
     /* 108216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 108219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 108223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 108227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 108231 */     // (fadd:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)  =>  (MVE_VADDf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 108231 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 108234 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108238 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDf16),
     /* 108246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 108248 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 108250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 108252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108255 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108261 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108267 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108270 */     GIR_RootConstrainSelectedInstOperands,
     /* 108271 */     // GIR_Coverage, 4020,
     /* 108271 */     GIR_EraseRootFromParent_Done,
     /* 108272 */   // Label 2040: @108272
     /* 108272 */   GIM_Reject,
     /* 108273 */ // Label 2036: @108273
     /* 108273 */ GIM_Reject,
     /* 108274 */ // Label 2018: @108274
     /* 108274 */ GIM_Reject,
     /* 108275 */ // Label 35: @108275
     /* 108275 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2048*/ GIMT_Encode4(109951),
     /* 108286 */ /*GILLT_s16*//*Label 2041*/ GIMT_Encode4(108338),
     /* 108290 */ /*GILLT_s32*//*Label 2042*/ GIMT_Encode4(108385),
     /* 108294 */ /*GILLT_s64*//*Label 2043*/ GIMT_Encode4(109312), GIMT_Encode4(0),
     /* 108302 */ /*GILLT_v2s32*//*Label 2044*/ GIMT_Encode4(109359), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 108314 */ /*GILLT_v4s16*//*Label 2045*/ GIMT_Encode4(109406),
     /* 108318 */ /*GILLT_v4s32*//*Label 2046*/ GIMT_Encode4(109583), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 108334 */ /*GILLT_v8s16*//*Label 2047*/ GIMT_Encode4(109697),
     /* 108338 */ // Label 2041: @108338
     /* 108338 */ GIM_Try, /*On fail goto*//*Label 2049*/ GIMT_Encode4(108384), // Rule ID 617 //
     /* 108343 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 108346 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 108349 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 108352 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 108356 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 108360 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 108364 */   // (fsub:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VSUBH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 108364 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBH),
     /* 108367 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 108369 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 108371 */   GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 108373 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 108376 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108382 */   GIR_RootConstrainSelectedInstOperands,
     /* 108383 */   // GIR_Coverage, 617,
     /* 108383 */   GIR_EraseRootFromParent_Done,
     /* 108384 */ // Label 2049: @108384
     /* 108384 */ GIM_Reject,
     /* 108385 */ // Label 2042: @108385
     /* 108385 */ GIM_Try, /*On fail goto*//*Label 2050*/ GIMT_Encode4(109311),
     /* 108390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 108393 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 108396 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108400 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108404 */   GIM_Try, /*On fail goto*//*Label 2051*/ GIMT_Encode4(108728), // Rule ID 2701 //
     /* 108409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseFPVMLx_UseNEONForFP),
     /* 108412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 108416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 108420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 108424 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 108428 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108433 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108440 */     // (fsub:{ *:[f32] } SPR:{ *:[f32] }:$acc, (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b))  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMLSfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 108440 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 108443 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108447 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108452 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 108454 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 108457 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108461 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108466 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 108469 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108474 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 108477 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108481 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108486 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 108489 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 108493 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 108496 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108501 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108506 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108511 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 108514 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108518 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108523 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 108525 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 108528 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108532 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108537 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 108540 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108545 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 108548 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108552 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108557 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 108560 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 108564 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 108567 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108572 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108577 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108582 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 108585 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108589 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 108596 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 108599 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108603 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108608 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 108611 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108616 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 108619 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108623 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108628 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 108631 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // acc
     /* 108635 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 108638 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108643 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108648 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108653 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 108656 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMLSfd),
     /* 108660 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108665 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 108668 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 108671 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 108674 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 108677 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108683 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 108685 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 108688 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108692 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108697 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 108700 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108710 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 108717 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108722 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108727 */     // GIR_Coverage, 2701,
     /* 108727 */     GIR_EraseRootFromParent_Done,
     /* 108728 */   // Label 2051: @108728
     /* 108728 */   GIM_Try, /*On fail goto*//*Label 2052*/ GIMT_Encode4(109052), // Rule ID 2703 //
     /* 108733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4_UseFusedMAC_UseNEONForFP),
     /* 108736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 108740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 108744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 108748 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 108752 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108757 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108762 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108764 */     // (fsub:{ *:[f32] } SPR:{ *:[f32] }:$acc, (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b))  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VFMSfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 108764 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 108767 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108771 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108776 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 108778 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 108781 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108785 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108790 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 108793 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108798 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 108801 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108805 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108810 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 108813 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 108817 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 108820 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108825 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108830 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108835 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 108838 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108842 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108847 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 108849 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 108852 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108856 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108861 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 108864 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108869 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 108872 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108876 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108881 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 108884 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 108888 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 108891 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108896 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108901 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108906 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 108909 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108913 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108918 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 108920 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 108923 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108927 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108932 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 108935 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108940 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 108943 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108947 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108952 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 108955 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // acc
     /* 108959 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 108962 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108967 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108972 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108977 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 108980 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VFMSfd),
     /* 108984 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108989 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 108992 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 108995 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 108998 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 109001 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109007 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109009 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 109012 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109016 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109021 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 109024 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109034 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 109041 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 109046 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109051 */     // GIR_Coverage, 2703,
     /* 109051 */     GIR_EraseRootFromParent_Done,
     /* 109052 */   // Label 2052: @109052
     /* 109052 */   GIM_Try, /*On fail goto*//*Label 2053*/ GIMT_Encode4(109084), // Rule ID 616 //
     /* 109057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 109060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 109064 */     // (fsub:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VSUBS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 109064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBS),
     /* 109067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 109069 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 109071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 109073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109076 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109082 */     GIR_RootConstrainSelectedInstOperands,
     /* 109083 */     // GIR_Coverage, 616,
     /* 109083 */     GIR_EraseRootFromParent_Done,
     /* 109084 */   // Label 2053: @109084
     /* 109084 */   GIM_Try, /*On fail goto*//*Label 2054*/ GIMT_Encode4(109310), // Rule ID 2698 //
     /* 109089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 109092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 109096 */     // (fsub:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VSUBfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 109096 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 109099 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 109103 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109108 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 109110 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 109113 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109117 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109122 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 109125 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109130 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 109133 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 109137 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109142 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 109145 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 109149 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 109152 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109157 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109162 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 109167 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 109170 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 109174 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109179 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 109181 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 109184 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109188 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109193 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 109196 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109201 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 109204 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 109208 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109213 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 109216 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 109220 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 109223 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109228 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109233 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 109238 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 109241 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VSUBfd),
     /* 109245 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109250 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 109253 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 109256 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 109259 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109267 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 109270 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109274 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109279 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 109282 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109292 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 109299 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 109304 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109309 */     // GIR_Coverage, 2698,
     /* 109309 */     GIR_EraseRootFromParent_Done,
     /* 109310 */   // Label 2054: @109310
     /* 109310 */   GIM_Reject,
     /* 109311 */ // Label 2050: @109311
     /* 109311 */ GIM_Reject,
     /* 109312 */ // Label 2043: @109312
     /* 109312 */ GIM_Try, /*On fail goto*//*Label 2055*/ GIMT_Encode4(109358), // Rule ID 615 //
     /* 109317 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 109320 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109323 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 109326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109330 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109334 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109338 */   // (fsub:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VSUBD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 109338 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBD),
     /* 109341 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 109343 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 109345 */   GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 109347 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109350 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109356 */   GIR_RootConstrainSelectedInstOperands,
     /* 109357 */   // GIR_Coverage, 615,
     /* 109357 */   GIR_EraseRootFromParent_Done,
     /* 109358 */ // Label 2055: @109358
     /* 109358 */ GIM_Reject,
     /* 109359 */ // Label 2044: @109359
     /* 109359 */ GIM_Try, /*On fail goto*//*Label 2056*/ GIMT_Encode4(109405), // Rule ID 968 //
     /* 109364 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 109367 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 109370 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 109373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109377 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109381 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109385 */   // (fsub:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VSUBfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 109385 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBfd),
     /* 109388 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109390 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 109392 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 109394 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109397 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109403 */   GIR_RootConstrainSelectedInstOperands,
     /* 109404 */   // GIR_Coverage, 968,
     /* 109404 */   GIR_EraseRootFromParent_Done,
     /* 109405 */ // Label 2056: @109405
     /* 109405 */ GIM_Reject,
     /* 109406 */ // Label 2045: @109406
     /* 109406 */ GIM_Try, /*On fail goto*//*Label 2057*/ GIMT_Encode4(109582),
     /* 109411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 109414 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 109417 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109421 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109425 */   GIM_Try, /*On fail goto*//*Label 2058*/ GIMT_Encode4(109487), // Rule ID 923 //
     /* 109430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFPVMLx),
     /* 109433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 109437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 109441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 109445 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 109449 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109454 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109461 */     // (fsub:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, (fmul:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm))  =>  (VMLShd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 109461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLShd),
     /* 109464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109466 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 109468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 109472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 109476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109479 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109485 */     GIR_RootConstrainSelectedInstOperands,
     /* 109486 */     // GIR_Coverage, 923,
     /* 109486 */     GIR_EraseRootFromParent_Done,
     /* 109487 */   // Label 2058: @109487
     /* 109487 */   GIM_Try, /*On fail goto*//*Label 2059*/ GIMT_Encode4(109549), // Rule ID 949 //
     /* 109492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 109495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 109499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 109503 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 109507 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 109511 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109516 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109523 */     // (fsub:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, (fmul:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm))  =>  (VFMShd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 109523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMShd),
     /* 109526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109528 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 109530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 109534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 109538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109541 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109547 */     GIR_RootConstrainSelectedInstOperands,
     /* 109548 */     // GIR_Coverage, 949,
     /* 109548 */     GIR_EraseRootFromParent_Done,
     /* 109549 */   // Label 2059: @109549
     /* 109549 */   GIM_Try, /*On fail goto*//*Label 2060*/ GIMT_Encode4(109581), // Rule ID 970 //
     /* 109554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 109557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109561 */     // (fsub:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VSUBhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 109561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBhd),
     /* 109564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109566 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 109568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 109570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109573 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109579 */     GIR_RootConstrainSelectedInstOperands,
     /* 109580 */     // GIR_Coverage, 970,
     /* 109580 */     GIR_EraseRootFromParent_Done,
     /* 109581 */   // Label 2060: @109581
     /* 109581 */   GIM_Reject,
     /* 109582 */ // Label 2057: @109582
     /* 109582 */ GIM_Reject,
     /* 109583 */ // Label 2046: @109583
     /* 109583 */ GIM_Try, /*On fail goto*//*Label 2061*/ GIMT_Encode4(109696),
     /* 109588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 109591 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 109594 */   GIM_Try, /*On fail goto*//*Label 2062*/ GIMT_Encode4(109634), // Rule ID 969 //
     /* 109599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 109602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109614 */     // (fsub:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VSUBfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 109614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBfq),
     /* 109617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109619 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 109621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 109623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109626 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109632 */     GIR_RootConstrainSelectedInstOperands,
     /* 109633 */     // GIR_Coverage, 969,
     /* 109633 */     GIR_EraseRootFromParent_Done,
     /* 109634 */   // Label 2062: @109634
     /* 109634 */   GIM_Try, /*On fail goto*//*Label 2063*/ GIMT_Encode4(109695), // Rule ID 4024 //
     /* 109639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 109642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 109646 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 109650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 109654 */     // (fsub:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)  =>  (MVE_VSUBf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 109654 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 109657 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 109661 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSUBf32),
     /* 109669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 109671 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 109673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 109675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109678 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109684 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109690 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109693 */     GIR_RootConstrainSelectedInstOperands,
     /* 109694 */     // GIR_Coverage, 4024,
     /* 109694 */     GIR_EraseRootFromParent_Done,
     /* 109695 */   // Label 2063: @109695
     /* 109695 */   GIM_Reject,
     /* 109696 */ // Label 2061: @109696
     /* 109696 */ GIM_Reject,
     /* 109697 */ // Label 2047: @109697
     /* 109697 */ GIM_Try, /*On fail goto*//*Label 2064*/ GIMT_Encode4(109950),
     /* 109702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109705 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 109708 */   GIM_Try, /*On fail goto*//*Label 2065*/ GIMT_Encode4(109778), // Rule ID 924 //
     /* 109713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFPVMLx),
     /* 109716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109720 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 109728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 109732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109736 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 109740 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109745 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109750 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109752 */     // (fsub:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, (fmul:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm))  =>  (VMLShq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 109752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLShq),
     /* 109755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109757 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 109759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 109763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 109767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109770 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109776 */     GIR_RootConstrainSelectedInstOperands,
     /* 109777 */     // GIR_Coverage, 924,
     /* 109777 */     GIR_EraseRootFromParent_Done,
     /* 109778 */   // Label 2065: @109778
     /* 109778 */   GIM_Try, /*On fail goto*//*Label 2066*/ GIMT_Encode4(109848), // Rule ID 950 //
     /* 109783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 109786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 109798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 109802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109806 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 109810 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109815 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109820 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109822 */     // (fsub:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, (fmul:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm))  =>  (VFMShq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 109822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMShq),
     /* 109825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109827 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 109829 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 109833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 109837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109840 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109846 */     GIR_RootConstrainSelectedInstOperands,
     /* 109847 */     // GIR_Coverage, 950,
     /* 109847 */     GIR_EraseRootFromParent_Done,
     /* 109848 */   // Label 2066: @109848
     /* 109848 */   GIM_Try, /*On fail goto*//*Label 2067*/ GIMT_Encode4(109888), // Rule ID 971 //
     /* 109853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 109856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109868 */     // (fsub:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VSUBhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 109868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBhq),
     /* 109871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109873 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 109875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 109877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109880 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109886 */     GIR_RootConstrainSelectedInstOperands,
     /* 109887 */     // GIR_Coverage, 971,
     /* 109887 */     GIR_EraseRootFromParent_Done,
     /* 109888 */   // Label 2067: @109888
     /* 109888 */   GIM_Try, /*On fail goto*//*Label 2068*/ GIMT_Encode4(109949), // Rule ID 4028 //
     /* 109893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 109896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 109900 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 109904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 109908 */     // (fsub:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)  =>  (MVE_VSUBf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 109908 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 109911 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 109915 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSUBf16),
     /* 109923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 109925 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 109927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 109929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109932 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109938 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109944 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109947 */     GIR_RootConstrainSelectedInstOperands,
     /* 109948 */     // GIR_Coverage, 4028,
     /* 109948 */     GIR_EraseRootFromParent_Done,
     /* 109949 */   // Label 2068: @109949
     /* 109949 */   GIM_Reject,
     /* 109950 */ // Label 2064: @109950
     /* 109950 */ GIM_Reject,
     /* 109951 */ // Label 2048: @109951
     /* 109951 */ GIM_Reject,
     /* 109952 */ // Label 36: @109952
     /* 109952 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2076*/ GIMT_Encode4(110932),
     /* 109963 */ /*GILLT_s16*//*Label 2069*/ GIMT_Encode4(110015),
     /* 109967 */ /*GILLT_s32*//*Label 2070*/ GIMT_Encode4(110062),
     /* 109971 */ /*GILLT_s64*//*Label 2071*/ GIMT_Encode4(110451), GIMT_Encode4(0),
     /* 109979 */ /*GILLT_v2s32*//*Label 2072*/ GIMT_Encode4(110610), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 109991 */ /*GILLT_v4s16*//*Label 2073*/ GIMT_Encode4(110657),
     /* 109995 */ /*GILLT_v4s32*//*Label 2074*/ GIMT_Encode4(110704), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 110011 */ /*GILLT_v8s16*//*Label 2075*/ GIMT_Encode4(110818),
     /* 110015 */ // Label 2069: @110015
     /* 110015 */ GIM_Try, /*On fail goto*//*Label 2077*/ GIMT_Encode4(110061), // Rule ID 623 //
     /* 110020 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 110023 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 110026 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 110029 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110033 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110037 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110041 */   // (fmul:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VMULH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 110041 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULH),
     /* 110044 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 110046 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 110048 */   GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 110050 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110053 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110059 */   GIR_RootConstrainSelectedInstOperands,
     /* 110060 */   // GIR_Coverage, 623,
     /* 110060 */   GIR_EraseRootFromParent_Done,
     /* 110061 */ // Label 2077: @110061
     /* 110061 */ GIM_Reject,
     /* 110062 */ // Label 2070: @110062
     /* 110062 */ GIM_Try, /*On fail goto*//*Label 2078*/ GIMT_Encode4(110450),
     /* 110067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 110070 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 110073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110077 */   GIM_Try, /*On fail goto*//*Label 2079*/ GIMT_Encode4(110130), // Rule ID 2302 //
     /* 110082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoHonorSignDependentRounding),
     /* 110085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 110097 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110106 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110108 */     // (fmul:{ *:[f32] } (fneg:{ *:[f32] } SPR:{ *:[f32] }:$a), SPR:{ *:[f32] }:$b)  =>  (VNMULS:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)
     /* 110108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULS),
     /* 110111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 110113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 110117 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 110119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110122 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110128 */     GIR_RootConstrainSelectedInstOperands,
     /* 110129 */     // GIR_Coverage, 2302,
     /* 110129 */     GIR_EraseRootFromParent_Done,
     /* 110130 */   // Label 2079: @110130
     /* 110130 */   GIM_Try, /*On fail goto*//*Label 2080*/ GIMT_Encode4(110183), // Rule ID 5711 //
     /* 110135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoHonorSignDependentRounding),
     /* 110138 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 110146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110150 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 110154 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110161 */     // (fmul:{ *:[f32] } SPR:{ *:[f32] }:$b, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (VNMULS:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)
     /* 110161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULS),
     /* 110164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 110166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 110170 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 110172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110175 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110181 */     GIR_RootConstrainSelectedInstOperands,
     /* 110182 */     // GIR_Coverage, 5711,
     /* 110182 */     GIR_EraseRootFromParent_Done,
     /* 110183 */   // Label 2080: @110183
     /* 110183 */   GIM_Try, /*On fail goto*//*Label 2081*/ GIMT_Encode4(110219), // Rule ID 622 //
     /* 110188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 110191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110199 */     // (fmul:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VMULS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 110199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULS),
     /* 110202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 110204 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 110206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 110208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110211 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110217 */     GIR_RootConstrainSelectedInstOperands,
     /* 110218 */     // GIR_Coverage, 622,
     /* 110218 */     GIR_EraseRootFromParent_Done,
     /* 110219 */   // Label 2081: @110219
     /* 110219 */   GIM_Try, /*On fail goto*//*Label 2082*/ GIMT_Encode4(110449), // Rule ID 2699 //
     /* 110224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 110227 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110235 */     // (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMULfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 110235 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 110238 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 110242 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110247 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 110249 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 110252 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110256 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110261 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 110264 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110269 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 110272 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 110276 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110281 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 110284 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 110288 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 110291 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110296 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110301 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 110306 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 110309 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 110313 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110318 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 110320 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 110323 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110327 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110332 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 110335 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110340 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 110343 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 110347 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110352 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 110355 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 110359 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 110362 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110367 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110372 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 110377 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 110380 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMULfd),
     /* 110384 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110389 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 110392 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 110395 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 110398 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110404 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 110406 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 110409 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110413 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110418 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 110421 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110431 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 110438 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 110443 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110448 */     // GIR_Coverage, 2699,
     /* 110448 */     GIR_EraseRootFromParent_Done,
     /* 110449 */   // Label 2082: @110449
     /* 110449 */   GIM_Reject,
     /* 110450 */ // Label 2078: @110450
     /* 110450 */ GIM_Reject,
     /* 110451 */ // Label 2071: @110451
     /* 110451 */ GIM_Try, /*On fail goto*//*Label 2083*/ GIMT_Encode4(110609),
     /* 110456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110459 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 110462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110466 */   GIM_Try, /*On fail goto*//*Label 2084*/ GIMT_Encode4(110519), // Rule ID 2301 //
     /* 110471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_NoHonorSignDependentRounding),
     /* 110474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 110486 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110497 */     // (fmul:{ *:[f64] } (fneg:{ *:[f64] } DPR:{ *:[f64] }:$a), DPR:{ *:[f64] }:$b)  =>  (VNMULD:{ *:[f64] } DPR:{ *:[f64] }:$a, DPR:{ *:[f64] }:$b)
     /* 110497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULD),
     /* 110500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 110502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 110506 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 110508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110511 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110517 */     GIR_RootConstrainSelectedInstOperands,
     /* 110518 */     // GIR_Coverage, 2301,
     /* 110518 */     GIR_EraseRootFromParent_Done,
     /* 110519 */   // Label 2084: @110519
     /* 110519 */   GIM_Try, /*On fail goto*//*Label 2085*/ GIMT_Encode4(110572), // Rule ID 5710 //
     /* 110524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_NoHonorSignDependentRounding),
     /* 110527 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 110535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 110543 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110550 */     // (fmul:{ *:[f64] } DPR:{ *:[f64] }:$b, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (VNMULD:{ *:[f64] } DPR:{ *:[f64] }:$a, DPR:{ *:[f64] }:$b)
     /* 110550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULD),
     /* 110553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 110555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 110559 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 110561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110564 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110570 */     GIR_RootConstrainSelectedInstOperands,
     /* 110571 */     // GIR_Coverage, 5710,
     /* 110571 */     GIR_EraseRootFromParent_Done,
     /* 110572 */   // Label 2085: @110572
     /* 110572 */   GIM_Try, /*On fail goto*//*Label 2086*/ GIMT_Encode4(110608), // Rule ID 621 //
     /* 110577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 110580 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110588 */     // (fmul:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VMULD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 110588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULD),
     /* 110591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 110593 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 110595 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 110597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110600 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110606 */     GIR_RootConstrainSelectedInstOperands,
     /* 110607 */     // GIR_Coverage, 621,
     /* 110607 */     GIR_EraseRootFromParent_Done,
     /* 110608 */   // Label 2086: @110608
     /* 110608 */   GIM_Reject,
     /* 110609 */ // Label 2083: @110609
     /* 110609 */ GIM_Reject,
     /* 110610 */ // Label 2072: @110610
     /* 110610 */ GIM_Try, /*On fail goto*//*Label 2087*/ GIMT_Encode4(110656), // Rule ID 843 //
     /* 110615 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 110618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 110621 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 110624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110628 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110632 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110636 */   // (fmul:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VMULfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 110636 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULfd),
     /* 110639 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 110641 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 110643 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 110645 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110648 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110654 */   GIR_RootConstrainSelectedInstOperands,
     /* 110655 */   // GIR_Coverage, 843,
     /* 110655 */   GIR_EraseRootFromParent_Done,
     /* 110656 */ // Label 2087: @110656
     /* 110656 */ GIM_Reject,
     /* 110657 */ // Label 2073: @110657
     /* 110657 */ GIM_Try, /*On fail goto*//*Label 2088*/ GIMT_Encode4(110703), // Rule ID 845 //
     /* 110662 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 110665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 110668 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 110671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110675 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110679 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110683 */   // (fmul:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VMULhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 110683 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULhd),
     /* 110686 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 110688 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 110690 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 110692 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110695 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110701 */   GIR_RootConstrainSelectedInstOperands,
     /* 110702 */   // GIR_Coverage, 845,
     /* 110702 */   GIR_EraseRootFromParent_Done,
     /* 110703 */ // Label 2088: @110703
     /* 110703 */ GIM_Reject,
     /* 110704 */ // Label 2074: @110704
     /* 110704 */ GIM_Try, /*On fail goto*//*Label 2089*/ GIMT_Encode4(110817),
     /* 110709 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 110712 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 110715 */   GIM_Try, /*On fail goto*//*Label 2090*/ GIMT_Encode4(110755), // Rule ID 844 //
     /* 110720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 110723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110727 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110735 */     // (fmul:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VMULfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 110735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULfq),
     /* 110738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 110740 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 110742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 110744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110747 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110753 */     GIR_RootConstrainSelectedInstOperands,
     /* 110754 */     // GIR_Coverage, 844,
     /* 110754 */     GIR_EraseRootFromParent_Done,
     /* 110755 */   // Label 2090: @110755
     /* 110755 */   GIM_Try, /*On fail goto*//*Label 2091*/ GIMT_Encode4(110816), // Rule ID 3988 //
     /* 110760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 110763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110767 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110775 */     // (fmul:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)  =>  (MVE_VMULf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 110775 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 110778 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 110782 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULf32),
     /* 110790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 110792 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 110794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 110796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110799 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110805 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110811 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110814 */     GIR_RootConstrainSelectedInstOperands,
     /* 110815 */     // GIR_Coverage, 3988,
     /* 110815 */     GIR_EraseRootFromParent_Done,
     /* 110816 */   // Label 2091: @110816
     /* 110816 */   GIM_Reject,
     /* 110817 */ // Label 2089: @110817
     /* 110817 */ GIM_Reject,
     /* 110818 */ // Label 2075: @110818
     /* 110818 */ GIM_Try, /*On fail goto*//*Label 2092*/ GIMT_Encode4(110931),
     /* 110823 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 110826 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 110829 */   GIM_Try, /*On fail goto*//*Label 2093*/ GIMT_Encode4(110869), // Rule ID 846 //
     /* 110834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 110837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110849 */     // (fmul:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VMULhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 110849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULhq),
     /* 110852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 110854 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 110856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 110858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110861 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110867 */     GIR_RootConstrainSelectedInstOperands,
     /* 110868 */     // GIR_Coverage, 846,
     /* 110868 */     GIR_EraseRootFromParent_Done,
     /* 110869 */   // Label 2093: @110869
     /* 110869 */   GIM_Try, /*On fail goto*//*Label 2094*/ GIMT_Encode4(110930), // Rule ID 3992 //
     /* 110874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 110877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110889 */     // (fmul:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)  =>  (MVE_VMULf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 110889 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 110892 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 110896 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULf16),
     /* 110904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 110906 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 110908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 110910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110913 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110919 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110925 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110928 */     GIR_RootConstrainSelectedInstOperands,
     /* 110929 */     // GIR_Coverage, 3992,
     /* 110929 */     GIR_EraseRootFromParent_Done,
     /* 110930 */   // Label 2094: @110930
     /* 110930 */   GIM_Reject,
     /* 110931 */ // Label 2092: @110931
     /* 110931 */ GIM_Reject,
     /* 110932 */ // Label 2076: @110932
     /* 110932 */ GIM_Reject,
     /* 110933 */ // Label 37: @110933
     /* 110933 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2102*/ GIMT_Encode4(113023),
     /* 110944 */ /*GILLT_s16*//*Label 2095*/ GIMT_Encode4(110996),
     /* 110948 */ /*GILLT_s32*//*Label 2096*/ GIMT_Encode4(111383),
     /* 110952 */ /*GILLT_s64*//*Label 2097*/ GIMT_Encode4(111770), GIMT_Encode4(0),
     /* 110960 */ /*GILLT_v2s32*//*Label 2098*/ GIMT_Encode4(112157), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 110972 */ /*GILLT_v4s16*//*Label 2099*/ GIMT_Encode4(112337),
     /* 110976 */ /*GILLT_v4s32*//*Label 2100*/ GIMT_Encode4(112393), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 110992 */ /*GILLT_v8s16*//*Label 2101*/ GIMT_Encode4(112771),
     /* 110996 */ // Label 2095: @110996
     /* 110996 */ GIM_Try, /*On fail goto*//*Label 2103*/ GIMT_Encode4(111382),
     /* 111001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 111004 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 111007 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 111010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111014 */   GIM_Try, /*On fail goto*//*Label 2104*/ GIMT_Encode4(111088), // Rule ID 2406 //
     /* 111019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 111022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111030 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 111034 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111043 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 111047 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111051 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 111055 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111060 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111062 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), HPR:{ *:[f16] }:$Sm, (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sdin))  =>  (VFNMAH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 111062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAH),
     /* 111065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sdin
     /* 111071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111080 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111086 */     GIR_RootConstrainSelectedInstOperands,
     /* 111087 */     // GIR_Coverage, 2406,
     /* 111087 */     GIR_EraseRootFromParent_Done,
     /* 111088 */   // Label 2104: @111088
     /* 111088 */   GIM_Try, /*On fail goto*//*Label 2105*/ GIMT_Encode4(111162), // Rule ID 5719 //
     /* 111093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 111096 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 111104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 111112 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 111121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111125 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 111129 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111134 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111136 */     // (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sm, (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sdin))  =>  (VFNMAH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 111136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAH),
     /* 111139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sdin
     /* 111145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111149 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 111151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111154 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111160 */     GIR_RootConstrainSelectedInstOperands,
     /* 111161 */     // GIR_Coverage, 5719,
     /* 111161 */     GIR_EraseRootFromParent_Done,
     /* 111162 */   // Label 2105: @111162
     /* 111162 */   GIM_Try, /*On fail goto*//*Label 2106*/ GIMT_Encode4(111221), // Rule ID 2398 //
     /* 111167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 111170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111178 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 111182 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111197 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), HPR:{ *:[f16] }:$Sm, HPR:{ *:[f16] }:$Sdin)  =>  (VFMSH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 111197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSH),
     /* 111200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111202 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 111204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111208 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111213 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111219 */     GIR_RootConstrainSelectedInstOperands,
     /* 111220 */     // GIR_Coverage, 2398,
     /* 111220 */     GIR_EraseRootFromParent_Done,
     /* 111221 */   // Label 2106: @111221
     /* 111221 */   GIM_Try, /*On fail goto*//*Label 2107*/ GIMT_Encode4(111280), // Rule ID 5716 //
     /* 111226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 111229 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 111237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111241 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 111245 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111256 */     // (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sm, (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), HPR:{ *:[f16] }:$Sdin)  =>  (VFMSH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 111256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSH),
     /* 111259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111261 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 111263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111267 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 111269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111272 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111278 */     GIR_RootConstrainSelectedInstOperands,
     /* 111279 */     // GIR_Coverage, 5716,
     /* 111279 */     GIR_EraseRootFromParent_Done,
     /* 111280 */   // Label 2107: @111280
     /* 111280 */   GIM_Try, /*On fail goto*//*Label 2108*/ GIMT_Encode4(111339), // Rule ID 2411 //
     /* 111285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 111288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 111300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 111308 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111315 */     // (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm, (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sdin))  =>  (VFNMSH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 111315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSH),
     /* 111318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sdin
     /* 111324 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 111326 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111331 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111337 */     GIR_RootConstrainSelectedInstOperands,
     /* 111338 */     // GIR_Coverage, 2411,
     /* 111338 */     GIR_EraseRootFromParent_Done,
     /* 111339 */   // Label 2108: @111339
     /* 111339 */   GIM_Try, /*On fail goto*//*Label 2109*/ GIMT_Encode4(111381), // Rule ID 2392 //
     /* 111344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 111347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111359 */     // (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm, HPR:{ *:[f16] }:$Sdin)  =>  (VFMAH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 111359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAH),
     /* 111362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 111366 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 111368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111373 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111379 */     GIR_RootConstrainSelectedInstOperands,
     /* 111380 */     // GIR_Coverage, 2392,
     /* 111380 */     GIR_EraseRootFromParent_Done,
     /* 111381 */   // Label 2109: @111381
     /* 111381 */   GIM_Reject,
     /* 111382 */ // Label 2103: @111382
     /* 111382 */ GIM_Reject,
     /* 111383 */ // Label 2096: @111383
     /* 111383 */ GIM_Try, /*On fail goto*//*Label 2110*/ GIMT_Encode4(111769),
     /* 111388 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 111391 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 111394 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 111397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111401 */   GIM_Try, /*On fail goto*//*Label 2111*/ GIMT_Encode4(111475), // Rule ID 2405 //
     /* 111406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 111421 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 111434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111438 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 111442 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111447 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111449 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), SPR:{ *:[f32] }:$Sm, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sdin))  =>  (VFNMAS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAS),
     /* 111452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sdin
     /* 111458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111462 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111467 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111473 */     GIR_RootConstrainSelectedInstOperands,
     /* 111474 */     // GIR_Coverage, 2405,
     /* 111474 */     GIR_EraseRootFromParent_Done,
     /* 111475 */   // Label 2111: @111475
     /* 111475 */   GIM_Try, /*On fail goto*//*Label 2112*/ GIMT_Encode4(111549), // Rule ID 5718 //
     /* 111480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 111491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 111499 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111504 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 111508 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111512 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 111516 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111521 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111523 */     // (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sm, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sdin))  =>  (VFNMAS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAS),
     /* 111526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sdin
     /* 111532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111536 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 111538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111541 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111547 */     GIR_RootConstrainSelectedInstOperands,
     /* 111548 */     // GIR_Coverage, 5718,
     /* 111548 */     GIR_EraseRootFromParent_Done,
     /* 111549 */   // Label 2112: @111549
     /* 111549 */   GIM_Try, /*On fail goto*//*Label 2113*/ GIMT_Encode4(111608), // Rule ID 2397 //
     /* 111554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 111569 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111582 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111584 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), SPR:{ *:[f32] }:$Sm, SPR:{ *:[f32] }:$Sdin)  =>  (VFMSS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSS),
     /* 111587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111589 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 111591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111595 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111600 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111606 */     GIR_RootConstrainSelectedInstOperands,
     /* 111607 */     // GIR_Coverage, 2397,
     /* 111607 */     GIR_EraseRootFromParent_Done,
     /* 111608 */   // Label 2113: @111608
     /* 111608 */   GIM_Try, /*On fail goto*//*Label 2114*/ GIMT_Encode4(111667), // Rule ID 5715 //
     /* 111613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111616 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 111624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 111632 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111643 */     // (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sm, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), SPR:{ *:[f32] }:$Sdin)  =>  (VFMSS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSS),
     /* 111646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111648 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 111650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111654 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 111656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111659 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111665 */     GIR_RootConstrainSelectedInstOperands,
     /* 111666 */     // GIR_Coverage, 5715,
     /* 111666 */     GIR_EraseRootFromParent_Done,
     /* 111667 */   // Label 2114: @111667
     /* 111667 */   GIM_Try, /*On fail goto*//*Label 2115*/ GIMT_Encode4(111726), // Rule ID 2410 //
     /* 111672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 111687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111691 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 111695 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111700 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111702 */     // (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sdin))  =>  (VFNMSS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSS),
     /* 111705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sdin
     /* 111711 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 111713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111718 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111724 */     GIR_RootConstrainSelectedInstOperands,
     /* 111725 */     // GIR_Coverage, 2410,
     /* 111725 */     GIR_EraseRootFromParent_Done,
     /* 111726 */   // Label 2115: @111726
     /* 111726 */   GIM_Try, /*On fail goto*//*Label 2116*/ GIMT_Encode4(111768), // Rule ID 2391 //
     /* 111731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111734 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111746 */     // (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm, SPR:{ *:[f32] }:$Sdin)  =>  (VFMAS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAS),
     /* 111749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111751 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 111753 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 111755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111760 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111766 */     GIR_RootConstrainSelectedInstOperands,
     /* 111767 */     // GIR_Coverage, 2391,
     /* 111767 */     GIR_EraseRootFromParent_Done,
     /* 111768 */   // Label 2116: @111768
     /* 111768 */   GIM_Reject,
     /* 111769 */ // Label 2110: @111769
     /* 111769 */ GIM_Reject,
     /* 111770 */ // Label 2097: @111770
     /* 111770 */ GIM_Try, /*On fail goto*//*Label 2117*/ GIMT_Encode4(112156),
     /* 111775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111778 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 111781 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 111784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111788 */   GIM_Try, /*On fail goto*//*Label 2118*/ GIMT_Encode4(111862), // Rule ID 2404 //
     /* 111793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 111796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 111808 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111817 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 111821 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111825 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 111829 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111834 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111836 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), DPR:{ *:[f64] }:$Dm, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Ddin))  =>  (VFNMAD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 111836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAD),
     /* 111839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 111841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ddin
     /* 111845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 111849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 111851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111854 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111860 */     GIR_RootConstrainSelectedInstOperands,
     /* 111861 */     // GIR_Coverage, 2404,
     /* 111861 */     GIR_EraseRootFromParent_Done,
     /* 111862 */   // Label 2118: @111862
     /* 111862 */   GIM_Try, /*On fail goto*//*Label 2119*/ GIMT_Encode4(111936), // Rule ID 5717 //
     /* 111867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 111870 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 111878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111882 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 111886 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111891 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 111895 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111899 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 111903 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111908 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111910 */     // (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dm, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Ddin))  =>  (VFNMAD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 111910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAD),
     /* 111913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 111915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ddin
     /* 111919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 111923 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 111925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111928 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111934 */     GIR_RootConstrainSelectedInstOperands,
     /* 111935 */     // GIR_Coverage, 5717,
     /* 111935 */     GIR_EraseRootFromParent_Done,
     /* 111936 */   // Label 2119: @111936
     /* 111936 */   GIM_Try, /*On fail goto*//*Label 2120*/ GIMT_Encode4(111995), // Rule ID 2396 //
     /* 111941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 111944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 111956 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111971 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), DPR:{ *:[f64] }:$Dm, DPR:{ *:[f64] }:$Ddin)  =>  (VFMSD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 111971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSD),
     /* 111974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 111976 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ddin
     /* 111978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 111982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 111984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111987 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111993 */     GIR_RootConstrainSelectedInstOperands,
     /* 111994 */     // GIR_Coverage, 2396,
     /* 111994 */     GIR_EraseRootFromParent_Done,
     /* 111995 */   // Label 2120: @111995
     /* 111995 */   GIM_Try, /*On fail goto*//*Label 2121*/ GIMT_Encode4(112054), // Rule ID 5714 //
     /* 112000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 112003 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 112011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 112019 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112028 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112030 */     // (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dm, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), DPR:{ *:[f64] }:$Ddin)  =>  (VFMSD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 112030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSD),
     /* 112033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 112035 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ddin
     /* 112037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 112041 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 112043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112046 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112052 */     GIR_RootConstrainSelectedInstOperands,
     /* 112053 */     // GIR_Coverage, 5714,
     /* 112053 */     GIR_EraseRootFromParent_Done,
     /* 112054 */   // Label 2121: @112054
     /* 112054 */   GIM_Try, /*On fail goto*//*Label 2122*/ GIMT_Encode4(112113), // Rule ID 2409 //
     /* 112059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 112062 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 112074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 112082 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112089 */     // (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Ddin))  =>  (VFNMSD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 112089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSD),
     /* 112092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 112094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ddin
     /* 112098 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 112100 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 112102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112105 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112111 */     GIR_RootConstrainSelectedInstOperands,
     /* 112112 */     // GIR_Coverage, 2409,
     /* 112112 */     GIR_EraseRootFromParent_Done,
     /* 112113 */   // Label 2122: @112113
     /* 112113 */   GIM_Try, /*On fail goto*//*Label 2123*/ GIMT_Encode4(112155), // Rule ID 2390 //
     /* 112118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 112121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112133 */     // (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm, DPR:{ *:[f64] }:$Ddin)  =>  (VFMAD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 112133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAD),
     /* 112136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 112138 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ddin
     /* 112140 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 112142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 112144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112147 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112153 */     GIR_RootConstrainSelectedInstOperands,
     /* 112154 */     // GIR_Coverage, 2390,
     /* 112154 */     GIR_EraseRootFromParent_Done,
     /* 112155 */   // Label 2123: @112155
     /* 112155 */   GIM_Reject,
     /* 112156 */ // Label 2117: @112156
     /* 112156 */ GIM_Reject,
     /* 112157 */ // Label 2098: @112157
     /* 112157 */ GIM_Try, /*On fail goto*//*Label 2124*/ GIMT_Encode4(112336),
     /* 112162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 112165 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 112168 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 112171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112175 */   GIM_Try, /*On fail goto*//*Label 2125*/ GIMT_Encode4(112234), // Rule ID 2503 //
     /* 112180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 112183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 112195 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112208 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112210 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn), DPR:{ *:[v2f32] }:$Vm, DPR:{ *:[v2f32] }:$src1)  =>  (VFMSfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$src1, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 112210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSfd),
     /* 112213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112215 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 112221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 112223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112226 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112232 */     GIR_RootConstrainSelectedInstOperands,
     /* 112233 */     // GIR_Coverage, 2503,
     /* 112233 */     GIR_EraseRootFromParent_Done,
     /* 112234 */   // Label 2125: @112234
     /* 112234 */   GIM_Try, /*On fail goto*//*Label 2126*/ GIMT_Encode4(112293), // Rule ID 5757 //
     /* 112239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 112242 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 112250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 112258 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112269 */     // (fma:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm, (fneg:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn), DPR:{ *:[v2f32] }:$src1)  =>  (VFMSfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$src1, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 112269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSfd),
     /* 112272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112274 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 112280 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 112282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112285 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112291 */     GIR_RootConstrainSelectedInstOperands,
     /* 112292 */     // GIR_Coverage, 5757,
     /* 112292 */     GIR_EraseRootFromParent_Done,
     /* 112293 */   // Label 2126: @112293
     /* 112293 */   GIM_Try, /*On fail goto*//*Label 2127*/ GIMT_Encode4(112335), // Rule ID 2501 //
     /* 112298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 112301 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112313 */     // (fma:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm, DPR:{ *:[v2f32] }:$src1)  =>  (VFMAfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$src1, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 112313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAfd),
     /* 112316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112318 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112320 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 112322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 112324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112327 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112333 */     GIR_RootConstrainSelectedInstOperands,
     /* 112334 */     // GIR_Coverage, 2501,
     /* 112334 */     GIR_EraseRootFromParent_Done,
     /* 112335 */   // Label 2127: @112335
     /* 112335 */   GIM_Reject,
     /* 112336 */ // Label 2124: @112336
     /* 112336 */ GIM_Reject,
     /* 112337 */ // Label 2099: @112337
     /* 112337 */ GIM_Try, /*On fail goto*//*Label 2128*/ GIMT_Encode4(112392), // Rule ID 2499 //
     /* 112342 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 112345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 112348 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 112351 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 112354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112358 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112362 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112366 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112370 */   // (fma:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm, DPR:{ *:[v4f16] }:$src1)  =>  (VFMAhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 112370 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhd),
     /* 112373 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112375 */   GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112377 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 112379 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 112381 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112384 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112390 */   GIR_RootConstrainSelectedInstOperands,
     /* 112391 */   // GIR_Coverage, 2499,
     /* 112391 */   GIR_EraseRootFromParent_Done,
     /* 112392 */ // Label 2128: @112392
     /* 112392 */ GIM_Reject,
     /* 112393 */ // Label 2100: @112393
     /* 112393 */ GIM_Try, /*On fail goto*//*Label 2129*/ GIMT_Encode4(112770),
     /* 112398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112401 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 112404 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 112407 */   GIM_Try, /*On fail goto*//*Label 2130*/ GIMT_Encode4(112470), // Rule ID 2504 //
     /* 112412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 112415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112427 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112431 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112446 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn), QPR:{ *:[v4f32] }:$Vm, QPR:{ *:[v4f32] }:$src1)  =>  (VFMSfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$src1, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 112446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSfq),
     /* 112449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112451 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 112457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 112459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112462 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112468 */     GIR_RootConstrainSelectedInstOperands,
     /* 112469 */     // GIR_Coverage, 2504,
     /* 112469 */     GIR_EraseRootFromParent_Done,
     /* 112470 */   // Label 2130: @112470
     /* 112470 */   GIM_Try, /*On fail goto*//*Label 2131*/ GIMT_Encode4(112539), // Rule ID 4002 //
     /* 112475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 112478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112490 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112494 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112509 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$m1), MQPR:{ *:[v4f32] }:$m2, MQPR:{ *:[v4f32] }:$add)  =>  (MVE_VFMSf32:{ *:[v4f32] } ?:{ *:[v4f32] }:$add, ?:{ *:[v4f32] }:$m1, ?:{ *:[v4f32] }:$m2)
     /* 112509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMSf32),
     /* 112512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 112514 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 112516 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // m1
     /* 112520 */     GIR_RootToRootCopy, /*OpIdx*/2, // m2
     /* 112522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112525 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112531 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112537 */     GIR_RootConstrainSelectedInstOperands,
     /* 112538 */     // GIR_Coverage, 4002,
     /* 112538 */     GIR_EraseRootFromParent_Done,
     /* 112539 */   // Label 2131: @112539
     /* 112539 */   GIM_Try, /*On fail goto*//*Label 2132*/ GIMT_Encode4(112602), // Rule ID 5758 //
     /* 112544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 112547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 112559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112567 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112576 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112578 */     // (fma:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm, (fneg:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn), QPR:{ *:[v4f32] }:$src1)  =>  (VFMSfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$src1, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 112578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSfq),
     /* 112581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112583 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 112589 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 112591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112594 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112600 */     GIR_RootConstrainSelectedInstOperands,
     /* 112601 */     // GIR_Coverage, 5758,
     /* 112601 */     GIR_EraseRootFromParent_Done,
     /* 112602 */   // Label 2132: @112602
     /* 112602 */   GIM_Try, /*On fail goto*//*Label 2133*/ GIMT_Encode4(112671), // Rule ID 6038 //
     /* 112607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 112610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112614 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 112622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112630 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112641 */     // (fma:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$m2, (fneg:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$m1), MQPR:{ *:[v4f32] }:$add)  =>  (MVE_VFMSf32:{ *:[v4f32] } ?:{ *:[v4f32] }:$add, ?:{ *:[v4f32] }:$m1, ?:{ *:[v4f32] }:$m2)
     /* 112641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMSf32),
     /* 112644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 112646 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 112648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // m1
     /* 112652 */     GIR_RootToRootCopy, /*OpIdx*/1, // m2
     /* 112654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112657 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112663 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112669 */     GIR_RootConstrainSelectedInstOperands,
     /* 112670 */     // GIR_Coverage, 6038,
     /* 112670 */     GIR_EraseRootFromParent_Done,
     /* 112671 */   // Label 2133: @112671
     /* 112671 */   GIM_Try, /*On fail goto*//*Label 2134*/ GIMT_Encode4(112717), // Rule ID 2502 //
     /* 112676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 112679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112695 */     // (fma:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm, QPR:{ *:[v4f32] }:$src1)  =>  (VFMAfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$src1, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 112695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAfq),
     /* 112698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112700 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112702 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 112704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 112706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112709 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112715 */     GIR_RootConstrainSelectedInstOperands,
     /* 112716 */     // GIR_Coverage, 2502,
     /* 112716 */     GIR_EraseRootFromParent_Done,
     /* 112717 */   // Label 2134: @112717
     /* 112717 */   GIM_Try, /*On fail goto*//*Label 2135*/ GIMT_Encode4(112769), // Rule ID 4006 //
     /* 112722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 112725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112741 */     // (fma:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$m1, MQPR:{ *:[v4f32] }:$m2, MQPR:{ *:[v4f32] }:$add)  =>  (MVE_VFMAf32:{ *:[v4f32] } ?:{ *:[v4f32] }:$add, ?:{ *:[v4f32] }:$m1, ?:{ *:[v4f32] }:$m2)
     /* 112741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMAf32),
     /* 112744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 112746 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 112748 */     GIR_RootToRootCopy, /*OpIdx*/1, // m1
     /* 112750 */     GIR_RootToRootCopy, /*OpIdx*/2, // m2
     /* 112752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112755 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112761 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112767 */     GIR_RootConstrainSelectedInstOperands,
     /* 112768 */     // GIR_Coverage, 4006,
     /* 112768 */     GIR_EraseRootFromParent_Done,
     /* 112769 */   // Label 2135: @112769
     /* 112769 */   GIM_Reject,
     /* 112770 */ // Label 2129: @112770
     /* 112770 */ GIM_Reject,
     /* 112771 */ // Label 2101: @112771
     /* 112771 */ GIM_Try, /*On fail goto*//*Label 2136*/ GIMT_Encode4(113022),
     /* 112776 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112779 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 112782 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 112785 */   GIM_Try, /*On fail goto*//*Label 2137*/ GIMT_Encode4(112854), // Rule ID 4012 //
     /* 112790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 112793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112809 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112822 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112824 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$m1), MQPR:{ *:[v8f16] }:$m2, MQPR:{ *:[v8f16] }:$add)  =>  (MVE_VFMSf16:{ *:[v8f16] } ?:{ *:[v8f16] }:$add, ?:{ *:[v8f16] }:$m1, ?:{ *:[v8f16] }:$m2)
     /* 112824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMSf16),
     /* 112827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 112829 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 112831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // m1
     /* 112835 */     GIR_RootToRootCopy, /*OpIdx*/2, // m2
     /* 112837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112840 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112846 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112852 */     GIR_RootConstrainSelectedInstOperands,
     /* 112853 */     // GIR_Coverage, 4012,
     /* 112853 */     GIR_EraseRootFromParent_Done,
     /* 112854 */   // Label 2137: @112854
     /* 112854 */   GIM_Try, /*On fail goto*//*Label 2138*/ GIMT_Encode4(112923), // Rule ID 6040 //
     /* 112859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 112862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112866 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 112874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112882 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112893 */     // (fma:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$m2, (fneg:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$m1), MQPR:{ *:[v8f16] }:$add)  =>  (MVE_VFMSf16:{ *:[v8f16] } ?:{ *:[v8f16] }:$add, ?:{ *:[v8f16] }:$m1, ?:{ *:[v8f16] }:$m2)
     /* 112893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMSf16),
     /* 112896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 112898 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 112900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // m1
     /* 112904 */     GIR_RootToRootCopy, /*OpIdx*/1, // m2
     /* 112906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112909 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112915 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112921 */     GIR_RootConstrainSelectedInstOperands,
     /* 112922 */     // GIR_Coverage, 6040,
     /* 112922 */     GIR_EraseRootFromParent_Done,
     /* 112923 */   // Label 2138: @112923
     /* 112923 */   GIM_Try, /*On fail goto*//*Label 2139*/ GIMT_Encode4(112969), // Rule ID 2500 //
     /* 112928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 112931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112935 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112947 */     // (fma:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm, QPR:{ *:[v8f16] }:$src1)  =>  (VFMAhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 112947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhq),
     /* 112950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112952 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112954 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 112956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 112958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112961 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112967 */     GIR_RootConstrainSelectedInstOperands,
     /* 112968 */     // GIR_Coverage, 2500,
     /* 112968 */     GIR_EraseRootFromParent_Done,
     /* 112969 */   // Label 2139: @112969
     /* 112969 */   GIM_Try, /*On fail goto*//*Label 2140*/ GIMT_Encode4(113021), // Rule ID 4009 //
     /* 112974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 112977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112981 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112993 */     // (fma:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$m1, MQPR:{ *:[v8f16] }:$m2, MQPR:{ *:[v8f16] }:$add)  =>  (MVE_VFMAf16:{ *:[v8f16] } ?:{ *:[v8f16] }:$add, ?:{ *:[v8f16] }:$m1, ?:{ *:[v8f16] }:$m2)
     /* 112993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMAf16),
     /* 112996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 112998 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 113000 */     GIR_RootToRootCopy, /*OpIdx*/1, // m1
     /* 113002 */     GIR_RootToRootCopy, /*OpIdx*/2, // m2
     /* 113004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113007 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113013 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113019 */     GIR_RootConstrainSelectedInstOperands,
     /* 113020 */     // GIR_Coverage, 4009,
     /* 113020 */     GIR_EraseRootFromParent_Done,
     /* 113021 */   // Label 2140: @113021
     /* 113021 */   GIM_Reject,
     /* 113022 */ // Label 2136: @113022
     /* 113022 */ GIM_Reject,
     /* 113023 */ // Label 2102: @113023
     /* 113023 */ GIM_Reject,
     /* 113024 */ // Label 38: @113024
     /* 113024 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 2144*/ GIMT_Encode4(113188),
     /* 113035 */ /*GILLT_s16*//*Label 2141*/ GIMT_Encode4(113047),
     /* 113039 */ /*GILLT_s32*//*Label 2142*/ GIMT_Encode4(113094),
     /* 113043 */ /*GILLT_s64*//*Label 2143*/ GIMT_Encode4(113141),
     /* 113047 */ // Label 2141: @113047
     /* 113047 */ GIM_Try, /*On fail goto*//*Label 2145*/ GIMT_Encode4(113093), // Rule ID 620 //
     /* 113052 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 113055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 113058 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 113061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113065 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113069 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113073 */   // (fdiv:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VDIVH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 113073 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VDIVH),
     /* 113076 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113078 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 113080 */   GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 113082 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113085 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113091 */   GIR_RootConstrainSelectedInstOperands,
     /* 113092 */   // GIR_Coverage, 620,
     /* 113092 */   GIR_EraseRootFromParent_Done,
     /* 113093 */ // Label 2145: @113093
     /* 113093 */ GIM_Reject,
     /* 113094 */ // Label 2142: @113094
     /* 113094 */ GIM_Try, /*On fail goto*//*Label 2146*/ GIMT_Encode4(113140), // Rule ID 619 //
     /* 113099 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP2),
     /* 113102 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 113105 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 113108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113112 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113116 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113120 */   // (fdiv:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VDIVS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 113120 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VDIVS),
     /* 113123 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113125 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 113127 */   GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 113129 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113132 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113138 */   GIR_RootConstrainSelectedInstOperands,
     /* 113139 */   // GIR_Coverage, 619,
     /* 113139 */   GIR_EraseRootFromParent_Done,
     /* 113140 */ // Label 2146: @113140
     /* 113140 */ GIM_Reject,
     /* 113141 */ // Label 2143: @113141
     /* 113141 */ GIM_Try, /*On fail goto*//*Label 2147*/ GIMT_Encode4(113187), // Rule ID 618 //
     /* 113146 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 113149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 113152 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 113155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 113159 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 113163 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 113167 */   // (fdiv:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VDIVD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 113167 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VDIVD),
     /* 113170 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 113172 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 113174 */   GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 113176 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113179 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113185 */   GIR_RootConstrainSelectedInstOperands,
     /* 113186 */   // GIR_Coverage, 618,
     /* 113186 */   GIR_EraseRootFromParent_Done,
     /* 113187 */ // Label 2147: @113187
     /* 113187 */ GIM_Reject,
     /* 113188 */ // Label 2144: @113188
     /* 113188 */ GIM_Reject,
     /* 113189 */ // Label 39: @113189
     /* 113189 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2155*/ GIMT_Encode4(114719),
     /* 113200 */ /*GILLT_s16*//*Label 2148*/ GIMT_Encode4(113252),
     /* 113204 */ /*GILLT_s32*//*Label 2149*/ GIMT_Encode4(113599),
     /* 113208 */ /*GILLT_s64*//*Label 2150*/ GIMT_Encode4(114098), GIMT_Encode4(0),
     /* 113216 */ /*GILLT_v2s32*//*Label 2151*/ GIMT_Encode4(114445), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 113228 */ /*GILLT_v4s16*//*Label 2152*/ GIMT_Encode4(114483),
     /* 113232 */ /*GILLT_v4s32*//*Label 2153*/ GIMT_Encode4(114521), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 113248 */ /*GILLT_v8s16*//*Label 2154*/ GIMT_Encode4(114620),
     /* 113252 */ // Label 2148: @113252
     /* 113252 */ GIM_Try, /*On fail goto*//*Label 2156*/ GIMT_Encode4(113598),
     /* 113257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 113260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113264 */   GIM_Try, /*On fail goto*//*Label 2157*/ GIMT_Encode4(113349), // Rule ID 2414 //
     /* 113269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 113272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 113284 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 113288 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 113292 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 113296 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 113300 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 113304 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113309 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113314 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113319 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 113321 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), HPR:{ *:[f16] }:$Sm, HPR:{ *:[f16] }:$Sdin))  =>  (VFNMSH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 113321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSH),
     /* 113324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 113330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sn
     /* 113334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 113338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113341 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113347 */     GIR_RootConstrainSelectedInstOperands,
     /* 113348 */     // GIR_Coverage, 2414,
     /* 113348 */     GIR_EraseRootFromParent_Done,
     /* 113349 */   // Label 2157: @113349
     /* 113349 */   GIM_Try, /*On fail goto*//*Label 2158*/ GIMT_Encode4(113434), // Rule ID 5722 //
     /* 113354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 113357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113365 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 113369 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 113373 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 113377 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113382 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 113386 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 113390 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 113394 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113399 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113404 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 113406 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sm, (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), HPR:{ *:[f16] }:$Sdin))  =>  (VFNMSH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 113406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSH),
     /* 113409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 113415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sn
     /* 113419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sm
     /* 113423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113426 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113432 */     GIR_RootConstrainSelectedInstOperands,
     /* 113433 */     // GIR_Coverage, 5722,
     /* 113433 */     GIR_EraseRootFromParent_Done,
     /* 113434 */   // Label 2158: @113434
     /* 113434 */   GIM_Try, /*On fail goto*//*Label 2159*/ GIMT_Encode4(113507), // Rule ID 2403 //
     /* 113439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 113442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 113454 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 113458 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 113462 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113467 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113472 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113479 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm, HPR:{ *:[f16] }:$Sdin))  =>  (VFNMAH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 113479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAH),
     /* 113482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 113488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 113492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 113496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113499 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113505 */     GIR_RootConstrainSelectedInstOperands,
     /* 113506 */     // GIR_Coverage, 2403,
     /* 113506 */     GIR_EraseRootFromParent_Done,
     /* 113507 */   // Label 2159: @113507
     /* 113507 */   GIM_Try, /*On fail goto*//*Label 2160*/ GIMT_Encode4(113567), // Rule ID 626 //
     /* 113512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 113515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 113523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 113527 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 113531 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113536 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113543 */     // (fneg:{ *:[f16] } (fmul:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm))  =>  (VNMULH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 113543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULH),
     /* 113546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 113552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 113556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113559 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113565 */     GIR_RootConstrainSelectedInstOperands,
     /* 113566 */     // GIR_Coverage, 626,
     /* 113566 */     GIR_EraseRootFromParent_Done,
     /* 113567 */   // Label 2160: @113567
     /* 113567 */   GIM_Try, /*On fail goto*//*Label 2161*/ GIMT_Encode4(113597), // Rule ID 664 //
     /* 113572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 113575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113579 */     // (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VNEGH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 113579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGH),
     /* 113582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113584 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 113586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113589 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113595 */     GIR_RootConstrainSelectedInstOperands,
     /* 113596 */     // GIR_Coverage, 664,
     /* 113596 */     GIR_EraseRootFromParent_Done,
     /* 113597 */   // Label 2161: @113597
     /* 113597 */   GIM_Reject,
     /* 113598 */ // Label 2156: @113598
     /* 113598 */ GIM_Reject,
     /* 113599 */ // Label 2149: @113599
     /* 113599 */ GIM_Try, /*On fail goto*//*Label 2162*/ GIMT_Encode4(114097),
     /* 113604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 113607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113611 */   GIM_Try, /*On fail goto*//*Label 2163*/ GIMT_Encode4(113696), // Rule ID 2413 //
     /* 113616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 113619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 113631 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113635 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 113639 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 113643 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 113647 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 113651 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113656 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113661 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113666 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 113668 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), SPR:{ *:[f32] }:$Sm, SPR:{ *:[f32] }:$Sdin))  =>  (VFNMSS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 113668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSS),
     /* 113671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 113677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sn
     /* 113681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 113685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113688 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113694 */     GIR_RootConstrainSelectedInstOperands,
     /* 113695 */     // GIR_Coverage, 2413,
     /* 113695 */     GIR_EraseRootFromParent_Done,
     /* 113696 */   // Label 2163: @113696
     /* 113696 */   GIM_Try, /*On fail goto*//*Label 2164*/ GIMT_Encode4(113781), // Rule ID 5721 //
     /* 113701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 113704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 113716 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113720 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 113724 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 113733 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 113737 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 113741 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113746 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113751 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 113753 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sm, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), SPR:{ *:[f32] }:$Sdin))  =>  (VFNMSS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 113753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSS),
     /* 113756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 113762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sn
     /* 113766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sm
     /* 113770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113773 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113779 */     GIR_RootConstrainSelectedInstOperands,
     /* 113780 */     // GIR_Coverage, 5721,
     /* 113780 */     GIR_EraseRootFromParent_Done,
     /* 113781 */   // Label 2164: @113781
     /* 113781 */   GIM_Try, /*On fail goto*//*Label 2165*/ GIMT_Encode4(113854), // Rule ID 2402 //
     /* 113786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 113789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 113801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113805 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 113809 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113814 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113819 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113824 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113826 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm, SPR:{ *:[f32] }:$Sdin))  =>  (VFNMAS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 113826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAS),
     /* 113829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 113835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 113839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 113843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113846 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113852 */     GIR_RootConstrainSelectedInstOperands,
     /* 113853 */     // GIR_Coverage, 2402,
     /* 113853 */     GIR_EraseRootFromParent_Done,
     /* 113854 */   // Label 2165: @113854
     /* 113854 */   GIM_Try, /*On fail goto*//*Label 2166*/ GIMT_Encode4(113914), // Rule ID 625 //
     /* 113859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP2),
     /* 113862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 113870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 113874 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113878 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113883 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113890 */     // (fneg:{ *:[f32] } (fmul:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm))  =>  (VNMULS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 113890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULS),
     /* 113893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 113899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 113903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113906 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113912 */     GIR_RootConstrainSelectedInstOperands,
     /* 113913 */     // GIR_Coverage, 625,
     /* 113913 */     GIR_EraseRootFromParent_Done,
     /* 113914 */   // Label 2166: @113914
     /* 113914 */   GIM_Try, /*On fail goto*//*Label 2167*/ GIMT_Encode4(113944), // Rule ID 663 //
     /* 113919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 113922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113926 */     // (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VNEGS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 113926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGS),
     /* 113929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113931 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 113933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113936 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113942 */     GIR_RootConstrainSelectedInstOperands,
     /* 113943 */     // GIR_Coverage, 663,
     /* 113943 */     GIR_EraseRootFromParent_Done,
     /* 113944 */   // Label 2167: @113944
     /* 113944 */   GIM_Try, /*On fail goto*//*Label 2168*/ GIMT_Encode4(114096), // Rule ID 2705 //
     /* 113949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 113952 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113956 */     // (fneg:{ *:[f32] } SPR:{ *:[f32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VNEGfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 113956 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 113959 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 113963 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113968 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 113970 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 113973 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113977 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113982 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 113985 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 113990 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 113993 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 113997 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114002 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 114005 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 114009 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 114012 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 114017 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 114022 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 114027 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 114030 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VNEGfd),
     /* 114034 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114039 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 114042 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 114045 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114051 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 114053 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 114056 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114060 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114065 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 114068 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 114073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114078 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 114085 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 114090 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 114095 */     // GIR_Coverage, 2705,
     /* 114095 */     GIR_EraseRootFromParent_Done,
     /* 114096 */   // Label 2168: @114096
     /* 114096 */   GIM_Reject,
     /* 114097 */ // Label 2162: @114097
     /* 114097 */ GIM_Reject,
     /* 114098 */ // Label 2150: @114098
     /* 114098 */ GIM_Try, /*On fail goto*//*Label 2169*/ GIMT_Encode4(114444),
     /* 114103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 114106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114110 */   GIM_Try, /*On fail goto*//*Label 2170*/ GIMT_Encode4(114195), // Rule ID 2412 //
     /* 114115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 114118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 114126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 114130 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114134 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 114138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 114142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 114146 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 114150 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114155 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114160 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114165 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 114167 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), DPR:{ *:[f64] }:$Dm, DPR:{ *:[f64] }:$Ddin))  =>  (VFNMSD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 114167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSD),
     /* 114170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ddin
     /* 114176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Dn
     /* 114180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Dm
     /* 114184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114187 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114193 */     GIR_RootConstrainSelectedInstOperands,
     /* 114194 */     // GIR_Coverage, 2412,
     /* 114194 */     GIR_EraseRootFromParent_Done,
     /* 114195 */   // Label 2170: @114195
     /* 114195 */   GIM_Try, /*On fail goto*//*Label 2171*/ GIMT_Encode4(114280), // Rule ID 5720 //
     /* 114200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 114203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 114211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 114215 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114219 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 114223 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114228 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 114232 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 114236 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 114240 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114245 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114250 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 114252 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dm, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), DPR:{ *:[f64] }:$Ddin))  =>  (VFNMSD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 114252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSD),
     /* 114255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ddin
     /* 114261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Dn
     /* 114265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dm
     /* 114269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114272 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114278 */     GIR_RootConstrainSelectedInstOperands,
     /* 114279 */     // GIR_Coverage, 5720,
     /* 114279 */     GIR_EraseRootFromParent_Done,
     /* 114280 */   // Label 2171: @114280
     /* 114280 */   GIM_Try, /*On fail goto*//*Label 2172*/ GIMT_Encode4(114353), // Rule ID 2401 //
     /* 114285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 114288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 114296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 114300 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114304 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 114308 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114313 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114318 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114325 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm, DPR:{ *:[f64] }:$Ddin))  =>  (VFNMAD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 114325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAD),
     /* 114328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ddin
     /* 114334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 114338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Dm
     /* 114342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114345 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114351 */     GIR_RootConstrainSelectedInstOperands,
     /* 114352 */     // GIR_Coverage, 2401,
     /* 114352 */     GIR_EraseRootFromParent_Done,
     /* 114353 */   // Label 2172: @114353
     /* 114353 */   GIM_Try, /*On fail goto*//*Label 2173*/ GIMT_Encode4(114413), // Rule ID 624 //
     /* 114358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 114361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 114369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 114373 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114377 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114382 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114389 */     // (fneg:{ *:[f64] } (fmul:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm))  =>  (VNMULD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 114389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULD),
     /* 114392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 114398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Dm
     /* 114402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114405 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114411 */     GIR_RootConstrainSelectedInstOperands,
     /* 114412 */     // GIR_Coverage, 624,
     /* 114412 */     GIR_EraseRootFromParent_Done,
     /* 114413 */   // Label 2173: @114413
     /* 114413 */   GIM_Try, /*On fail goto*//*Label 2174*/ GIMT_Encode4(114443), // Rule ID 662 //
     /* 114418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 114421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114425 */     // (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VNEGD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 114425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGD),
     /* 114428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114430 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 114432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114435 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114441 */     GIR_RootConstrainSelectedInstOperands,
     /* 114442 */     // GIR_Coverage, 662,
     /* 114442 */     GIR_EraseRootFromParent_Done,
     /* 114443 */   // Label 2174: @114443
     /* 114443 */   GIM_Reject,
     /* 114444 */ // Label 2169: @114444
     /* 114444 */ GIM_Reject,
     /* 114445 */ // Label 2151: @114445
     /* 114445 */ GIM_Try, /*On fail goto*//*Label 2175*/ GIMT_Encode4(114482), // Rule ID 1530 //
     /* 114450 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 114453 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 114456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114460 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114464 */   // (fneg:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VNEGfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /* 114464 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGfd),
     /* 114467 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 114469 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 114471 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114474 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114480 */   GIR_RootConstrainSelectedInstOperands,
     /* 114481 */   // GIR_Coverage, 1530,
     /* 114481 */   GIR_EraseRootFromParent_Done,
     /* 114482 */ // Label 2175: @114482
     /* 114482 */ GIM_Reject,
     /* 114483 */ // Label 2152: @114483
     /* 114483 */ GIM_Try, /*On fail goto*//*Label 2176*/ GIMT_Encode4(114520), // Rule ID 1532 //
     /* 114488 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 114491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 114494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114498 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114502 */   // (fneg:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VNEGhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /* 114502 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGhd),
     /* 114505 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 114507 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 114509 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114512 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114518 */   GIR_RootConstrainSelectedInstOperands,
     /* 114519 */   // GIR_Coverage, 1532,
     /* 114519 */   GIR_EraseRootFromParent_Done,
     /* 114520 */ // Label 2176: @114520
     /* 114520 */ GIM_Reject,
     /* 114521 */ // Label 2153: @114521
     /* 114521 */ GIM_Try, /*On fail goto*//*Label 2177*/ GIMT_Encode4(114619),
     /* 114526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114529 */   GIM_Try, /*On fail goto*//*Label 2178*/ GIMT_Encode4(114563), // Rule ID 1531 //
     /* 114534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 114537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 114541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 114545 */     // (fneg:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VNEGf32q:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /* 114545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGf32q),
     /* 114548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 114550 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 114552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114555 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114561 */     GIR_RootConstrainSelectedInstOperands,
     /* 114562 */     // GIR_Coverage, 1531,
     /* 114562 */     GIR_EraseRootFromParent_Done,
     /* 114563 */   // Label 2178: @114563
     /* 114563 */   GIM_Try, /*On fail goto*//*Label 2179*/ GIMT_Encode4(114618), // Rule ID 4116 //
     /* 114568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 114571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 114575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 114579 */     // (fneg:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$v)  =>  (MVE_VNEGf32:{ *:[v4f32] } ?:{ *:[v4f32] }:$v)
     /* 114579 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 114582 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 114586 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VNEGf32),
     /* 114594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 114596 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 114598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114601 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114607 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114613 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114616 */     GIR_RootConstrainSelectedInstOperands,
     /* 114617 */     // GIR_Coverage, 4116,
     /* 114617 */     GIR_EraseRootFromParent_Done,
     /* 114618 */   // Label 2179: @114618
     /* 114618 */   GIM_Reject,
     /* 114619 */ // Label 2177: @114619
     /* 114619 */ GIM_Reject,
     /* 114620 */ // Label 2154: @114620
     /* 114620 */ GIM_Try, /*On fail goto*//*Label 2180*/ GIMT_Encode4(114718),
     /* 114625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 114628 */   GIM_Try, /*On fail goto*//*Label 2181*/ GIMT_Encode4(114662), // Rule ID 1533 //
     /* 114633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 114636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 114640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 114644 */     // (fneg:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VNEGhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /* 114644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGhq),
     /* 114647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 114649 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 114651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114654 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114660 */     GIR_RootConstrainSelectedInstOperands,
     /* 114661 */     // GIR_Coverage, 1533,
     /* 114661 */     GIR_EraseRootFromParent_Done,
     /* 114662 */   // Label 2181: @114662
     /* 114662 */   GIM_Try, /*On fail goto*//*Label 2182*/ GIMT_Encode4(114717), // Rule ID 4114 //
     /* 114667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 114670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 114674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 114678 */     // (fneg:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$v)  =>  (MVE_VNEGf16:{ *:[v8f16] } ?:{ *:[v8f16] }:$v)
     /* 114678 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 114681 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 114685 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VNEGf16),
     /* 114693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 114695 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 114697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114700 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114706 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114712 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114715 */     GIR_RootConstrainSelectedInstOperands,
     /* 114716 */     // GIR_Coverage, 4114,
     /* 114716 */     GIR_EraseRootFromParent_Done,
     /* 114717 */   // Label 2182: @114717
     /* 114717 */   GIM_Reject,
     /* 114718 */ // Label 2180: @114718
     /* 114718 */ GIM_Reject,
     /* 114719 */ // Label 2155: @114719
     /* 114719 */ GIM_Reject,
     /* 114720 */ // Label 40: @114720
     /* 114720 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 2186*/ GIMT_Encode4(114955),
     /* 114731 */ /*GILLT_s32*//*Label 2183*/ GIMT_Encode4(114763),
     /* 114735 */ /*GILLT_s64*//*Label 2184*/ GIMT_Encode4(114823), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 114759 */ /*GILLT_v4s32*//*Label 2185*/ GIMT_Encode4(114920),
     /* 114763 */ // Label 2183: @114763
     /* 114763 */ GIM_Try, /*On fail goto*//*Label 2187*/ GIMT_Encode4(114822), // Rule ID 2303 //
     /* 114768 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 114771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 114778 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 114782 */   // (fpextend:{ *:[f32] } HPR:{ *:[f16] }:$Sm)  =>  (VCVTBHS:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[f32] } HPR:{ *:[f16] }:$Sm, SPR:{ *:[i32] }))
     /* 114782 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114785 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114789 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114794 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Sm
     /* 114798 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 114803 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTBHS),
     /* 114806 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 114808 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114811 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114814 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114820 */   GIR_RootConstrainSelectedInstOperands,
     /* 114821 */   // GIR_Coverage, 2303,
     /* 114821 */   GIR_EraseRootFromParent_Done,
     /* 114822 */ // Label 2187: @114822
     /* 114822 */ GIM_Reject,
     /* 114823 */ // Label 2184: @114823
     /* 114823 */ GIM_Try, /*On fail goto*//*Label 2188*/ GIMT_Encode4(114860), // Rule ID 660 //
     /* 114828 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 114831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 114834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114838 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 114842 */   // (fpextend:{ *:[f64] } SPR:{ *:[f32] }:$Sm)  =>  (VCVTDS:{ *:[f64] } SPR:{ *:[f32] }:$Sm)
     /* 114842 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTDS),
     /* 114845 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114847 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 114849 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114852 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114858 */   GIR_RootConstrainSelectedInstOperands,
     /* 114859 */   // GIR_Coverage, 660,
     /* 114859 */   GIR_EraseRootFromParent_Done,
     /* 114860 */ // Label 2188: @114860
     /* 114860 */ GIM_Try, /*On fail goto*//*Label 2189*/ GIMT_Encode4(114919), // Rule ID 2313 //
     /* 114865 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 114868 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114875 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 114879 */   // (fpextend:{ *:[f64] } HPR:{ *:[f16] }:$Sm)  =>  (VCVTBHD:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f32] } HPR:{ *:[f16] }:$Sm, SPR:{ *:[i32] }))
     /* 114879 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114882 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114886 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114891 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Sm
     /* 114895 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 114900 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTBHD),
     /* 114903 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114905 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114908 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114911 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114917 */   GIR_RootConstrainSelectedInstOperands,
     /* 114918 */   // GIR_Coverage, 2313,
     /* 114918 */   GIR_EraseRootFromParent_Done,
     /* 114919 */ // Label 2189: @114919
     /* 114919 */ GIM_Reject,
     /* 114920 */ // Label 2185: @114920
     /* 114920 */ GIM_Try, /*On fail goto*//*Label 2190*/ GIMT_Encode4(114954), // Rule ID 2670 //
     /* 114925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 114928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 114932 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114936 */   // (fpextend:{ *:[v4f32] } DPR:{ *:[v4f16] }:$src)  =>  (VCVTh2f:{ *:[v4f32] } DPR:{ *:[v4f16] }:$src)
     /* 114936 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2f),
     /* 114939 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 114941 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114943 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114946 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114952 */   GIR_RootConstrainSelectedInstOperands,
     /* 114953 */   // GIR_Coverage, 2670,
     /* 114953 */   GIR_EraseRootFromParent_Done,
     /* 114954 */ // Label 2190: @114954
     /* 114954 */ GIM_Reject,
     /* 114955 */ // Label 2186: @114955
     /* 114955 */ GIM_Reject,
     /* 114956 */ // Label 41: @114956
     /* 114956 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(8), /*)*//*default:*//*Label 2194*/ GIMT_Encode4(115227),
     /* 114967 */ /*GILLT_s16*//*Label 2191*/ GIMT_Encode4(114999),
     /* 114971 */ /*GILLT_s32*//*Label 2192*/ GIMT_Encode4(115154), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 114995 */ /*GILLT_v4s16*//*Label 2193*/ GIMT_Encode4(115192),
     /* 114999 */ // Label 2191: @114999
     /* 114999 */ GIM_Try, /*On fail goto*//*Label 2195*/ GIMT_Encode4(115076), // Rule ID 2305 //
     /* 115004 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 115007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 115014 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115018 */   // (fpround:{ *:[f16] } SPR:{ *:[f32] }:$Sm)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (VCVTBSH:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), SPR:{ *:[f32] }:$Sm), HPR:{ *:[i32] })
     /* 115018 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 115021 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 115025 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115030 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 115032 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115035 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTBSH),
     /* 115039 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115044 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 115047 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Sm
     /* 115051 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 115054 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115060 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115062 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115065 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115067 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115070 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /* 115075 */   // GIR_Coverage, 2305,
     /* 115075 */   GIR_EraseRootFromParent_Done,
     /* 115076 */ // Label 2195: @115076
     /* 115076 */ GIM_Try, /*On fail goto*//*Label 2196*/ GIMT_Encode4(115153), // Rule ID 2315 //
     /* 115081 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 115084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 115091 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115095 */   // (fpround:{ *:[f16] } DPR:{ *:[f64] }:$Dm)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (VCVTBDH:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), DPR:{ *:[f64] }:$Dm), HPR:{ *:[i32] })
     /* 115095 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 115098 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 115102 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115107 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 115109 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115112 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTBDH),
     /* 115116 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115121 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 115124 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Dm
     /* 115128 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 115131 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115137 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115139 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115142 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115144 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115147 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /* 115152 */   // GIR_Coverage, 2315,
     /* 115152 */   GIR_EraseRootFromParent_Done,
     /* 115153 */ // Label 2196: @115153
     /* 115153 */ GIM_Reject,
     /* 115154 */ // Label 2192: @115154
     /* 115154 */ GIM_Try, /*On fail goto*//*Label 2197*/ GIMT_Encode4(115191), // Rule ID 661 //
     /* 115159 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 115162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115169 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115173 */   // (fpround:{ *:[f32] } DPR:{ *:[f64] }:$Dm)  =>  (VCVTSD:{ *:[f32] } DPR:{ *:[f64] }:$Dm)
     /* 115173 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTSD),
     /* 115176 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 115178 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 115180 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 115183 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115189 */   GIR_RootConstrainSelectedInstOperands,
     /* 115190 */   // GIR_Coverage, 661,
     /* 115190 */   GIR_EraseRootFromParent_Done,
     /* 115191 */ // Label 2197: @115191
     /* 115191 */ GIM_Reject,
     /* 115192 */ // Label 2193: @115192
     /* 115192 */ GIM_Try, /*On fail goto*//*Label 2198*/ GIMT_Encode4(115226), // Rule ID 2669 //
     /* 115197 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 115200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115204 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 115208 */   // (fpround:{ *:[v4f16] } QPR:{ *:[v4f32] }:$src)  =>  (VCVTf2h:{ *:[v4f16] } QPR:{ *:[v4f32] }:$src)
     /* 115208 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2h),
     /* 115211 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 115213 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115215 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 115218 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115224 */   GIR_RootConstrainSelectedInstOperands,
     /* 115225 */   // GIR_Coverage, 2669,
     /* 115225 */   GIR_EraseRootFromParent_Done,
     /* 115226 */ // Label 2198: @115226
     /* 115226 */ GIM_Reject,
     /* 115227 */ // Label 2194: @115227
     /* 115227 */ GIM_Reject,
     /* 115228 */ // Label 42: @115228
     /* 115228 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(13), /*)*//*default:*//*Label 2206*/ GIMT_Encode4(116561),
     /* 115239 */ /*GILLT_s32*//*Label 2199*/ GIMT_Encode4(115287), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 115251 */ /*GILLT_v2s32*//*Label 2200*/ GIMT_Encode4(116181), GIMT_Encode4(0),
     /* 115259 */ /*GILLT_v4s1*//*Label 2201*/ GIMT_Encode4(116219),
     /* 115263 */ /*GILLT_v4s16*//*Label 2202*/ GIMT_Encode4(116272),
     /* 115267 */ /*GILLT_v4s32*//*Label 2203*/ GIMT_Encode4(116310), GIMT_Encode4(0),
     /* 115275 */ /*GILLT_v8s1*//*Label 2204*/ GIMT_Encode4(116409), GIMT_Encode4(0),
     /* 115283 */ /*GILLT_v8s16*//*Label 2205*/ GIMT_Encode4(116462),
     /* 115287 */ // Label 2199: @115287
     /* 115287 */ GIM_Try, /*On fail goto*//*Label 2207*/ GIMT_Encode4(115353), // Rule ID 2323 //
     /* 115292 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 115295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 115298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115302 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115306 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 115310 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 115314 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 115319 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115321 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPSH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 115321 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115324 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPSH),
     /* 115328 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115333 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115337 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115339 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115342 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115344 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115347 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115352 */   // GIR_Coverage, 2323,
     /* 115352 */   GIR_EraseRootFromParent_Done,
     /* 115353 */ // Label 2207: @115353
     /* 115353 */ GIM_Try, /*On fail goto*//*Label 2208*/ GIMT_Encode4(115419), // Rule ID 2325 //
     /* 115358 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 115361 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115368 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115372 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 115376 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 115380 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115385 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115387 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPSS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 115387 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115390 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPSS),
     /* 115394 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115399 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115403 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115405 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115408 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115410 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115413 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115418 */   // GIR_Coverage, 2325,
     /* 115418 */   GIR_EraseRootFromParent_Done,
     /* 115419 */ // Label 2208: @115419
     /* 115419 */ GIM_Try, /*On fail goto*//*Label 2209*/ GIMT_Encode4(115485), // Rule ID 2327 //
     /* 115424 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 115427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115434 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115438 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 115442 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 115446 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115451 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115453 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPSD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 115453 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115456 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPSD),
     /* 115460 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115465 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115469 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115471 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115474 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115476 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115479 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115484 */   // GIR_Coverage, 2327,
     /* 115484 */   GIR_EraseRootFromParent_Done,
     /* 115485 */ // Label 2209: @115485
     /* 115485 */ GIM_Try, /*On fail goto*//*Label 2210*/ GIMT_Encode4(115551), // Rule ID 2329 //
     /* 115490 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 115493 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 115496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115500 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115504 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 115508 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 115512 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 115517 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115519 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMSH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 115519 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115522 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMSH),
     /* 115526 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115531 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115535 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115537 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115540 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115542 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115545 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115550 */   // GIR_Coverage, 2329,
     /* 115550 */   GIR_EraseRootFromParent_Done,
     /* 115551 */ // Label 2210: @115551
     /* 115551 */ GIM_Try, /*On fail goto*//*Label 2211*/ GIMT_Encode4(115617), // Rule ID 2331 //
     /* 115556 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 115559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115566 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115570 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 115574 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 115578 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115583 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115585 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMSS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 115585 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115588 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMSS),
     /* 115592 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115597 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115601 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115603 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115606 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115608 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115611 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115616 */   // GIR_Coverage, 2331,
     /* 115616 */   GIR_EraseRootFromParent_Done,
     /* 115617 */ // Label 2211: @115617
     /* 115617 */ GIM_Try, /*On fail goto*//*Label 2212*/ GIMT_Encode4(115683), // Rule ID 2333 //
     /* 115622 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 115625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115632 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115636 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 115640 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 115644 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115649 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115651 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMSD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 115651 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115654 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMSD),
     /* 115658 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115663 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115667 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115669 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115672 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115674 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115677 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115682 */   // GIR_Coverage, 2333,
     /* 115682 */   GIR_EraseRootFromParent_Done,
     /* 115683 */ // Label 2212: @115683
     /* 115683 */ GIM_Try, /*On fail goto*//*Label 2213*/ GIMT_Encode4(115749), // Rule ID 2317 //
     /* 115688 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 115691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 115694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115698 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115702 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 115706 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 115710 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 115715 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115717 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTASH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 115717 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115720 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTASH),
     /* 115724 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115729 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115733 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115735 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115738 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115740 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115743 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115748 */   // GIR_Coverage, 2317,
     /* 115748 */   GIR_EraseRootFromParent_Done,
     /* 115749 */ // Label 2213: @115749
     /* 115749 */ GIM_Try, /*On fail goto*//*Label 2214*/ GIMT_Encode4(115815), // Rule ID 2319 //
     /* 115754 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 115757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115764 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115768 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 115772 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 115776 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115781 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115783 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTASS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 115783 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115786 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTASS),
     /* 115790 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115795 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115799 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115801 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115804 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115806 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115809 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115814 */   // GIR_Coverage, 2319,
     /* 115814 */   GIR_EraseRootFromParent_Done,
     /* 115815 */ // Label 2214: @115815
     /* 115815 */ GIM_Try, /*On fail goto*//*Label 2215*/ GIMT_Encode4(115881), // Rule ID 2321 //
     /* 115820 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 115823 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115830 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115834 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 115838 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 115842 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115847 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115849 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTASD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 115849 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115852 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTASD),
     /* 115856 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115861 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115865 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115867 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115870 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115872 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115875 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115880 */   // GIR_Coverage, 2321,
     /* 115880 */   GIR_EraseRootFromParent_Done,
     /* 115881 */ // Label 2215: @115881
     /* 115881 */ GIM_Try, /*On fail goto*//*Label 2216*/ GIMT_Encode4(115941), // Rule ID 2352 //
     /* 115886 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 115889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115900 */   // (fp_to_sint:{ *:[i32] } DPR:{ *:[f64] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOSIZD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 115900 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115903 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOSIZD),
     /* 115907 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115912 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 115916 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 115919 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115925 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115927 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115930 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115932 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115935 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115940 */   // GIR_Coverage, 2352,
     /* 115940 */   GIR_EraseRootFromParent_Done,
     /* 115941 */ // Label 2216: @115941
     /* 115941 */ GIM_Try, /*On fail goto*//*Label 2217*/ GIMT_Encode4(116001), // Rule ID 2356 //
     /* 115946 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 115949 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115956 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115960 */   // (fp_to_sint:{ *:[i32] } SPR:{ *:[f32] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOSIZS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 115960 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115963 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOSIZS),
     /* 115967 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115972 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 115976 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 115979 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115985 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115987 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115990 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115992 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115995 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116000 */   // GIR_Coverage, 2356,
     /* 116000 */   GIR_EraseRootFromParent_Done,
     /* 116001 */ // Label 2217: @116001
     /* 116001 */ GIM_Try, /*On fail goto*//*Label 2218*/ GIMT_Encode4(116061), // Rule ID 2360 //
     /* 116006 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 116009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 116012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116016 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 116020 */   // (fp_to_sint:{ *:[i32] } HPR:{ *:[f16] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOSIZH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 116020 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116023 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOSIZH),
     /* 116027 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116032 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 116036 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 116039 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116045 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116047 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116050 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116052 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116055 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116060 */   // GIR_Coverage, 2360,
     /* 116060 */   GIR_EraseRootFromParent_Done,
     /* 116061 */ // Label 2218: @116061
     /* 116061 */ GIM_Try, /*On fail goto*//*Label 2219*/ GIMT_Encode4(116180), // Rule ID 2710 //
     /* 116066 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 116069 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 116072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 116076 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 116080 */   // (fp_to_sint:{ *:[i32] } SPR:{ *:[f32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[i32] } (VCVTf2sd:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] })), ssub_0:{ *:[i32] })
     /* 116080 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 116083 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 116087 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116092 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 116094 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s32,
     /* 116097 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 116101 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116106 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 116109 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 116113 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/17,
     /* 116116 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 116121 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 116126 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 116131 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 116134 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTf2sd),
     /* 116138 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116143 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 116146 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 116149 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116155 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116157 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116160 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116162 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 116169 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 116174 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 116179 */   // GIR_Coverage, 2710,
     /* 116179 */   GIR_EraseRootFromParent_Done,
     /* 116180 */ // Label 2219: @116180
     /* 116180 */ GIM_Reject,
     /* 116181 */ // Label 2200: @116181
     /* 116181 */ GIM_Try, /*On fail goto*//*Label 2220*/ GIMT_Encode4(116218), // Rule ID 1604 //
     /* 116186 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 116189 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 116192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 116196 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 116200 */   // (fp_to_sint:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTf2sd:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /* 116200 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2sd),
     /* 116203 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 116205 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 116207 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 116210 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116216 */   GIR_RootConstrainSelectedInstOperands,
     /* 116217 */   // GIR_Coverage, 1604,
     /* 116217 */   GIR_EraseRootFromParent_Done,
     /* 116218 */ // Label 2220: @116218
     /* 116218 */ GIM_Reject,
     /* 116219 */ // Label 2201: @116219
     /* 116219 */ GIM_Try, /*On fail goto*//*Label 2221*/ GIMT_Encode4(116271), // Rule ID 5105 //
     /* 116224 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 116227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 116230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /* 116234 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 116238 */   // (fp_to_sint:{ *:[v4i1] } MQPR:{ *:[v4f32] }:$v1)  =>  (MVE_VCMPf32r:{ *:[v4i1] } MQPR:{ *:[v4f32] }:$v1, ZR:{ *:[i32] }, 1:{ *:[i32] })
     /* 116238 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMPf32r),
     /* 116241 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /* 116243 */   GIR_RootToRootCopy, /*OpIdx*/1, // v1
     /* 116245 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::ZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116251 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 116254 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116257 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116263 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116269 */   GIR_RootConstrainSelectedInstOperands,
     /* 116270 */   // GIR_Coverage, 5105,
     /* 116270 */   GIR_EraseRootFromParent_Done,
     /* 116271 */ // Label 2221: @116271
     /* 116271 */ GIM_Reject,
     /* 116272 */ // Label 2202: @116272
     /* 116272 */ GIM_Try, /*On fail goto*//*Label 2222*/ GIMT_Encode4(116309), // Rule ID 1612 //
     /* 116277 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 116280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 116283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 116287 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 116291 */   // (fp_to_sint:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTh2sd:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /* 116291 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2sd),
     /* 116294 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 116296 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 116298 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 116301 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116307 */   GIR_RootConstrainSelectedInstOperands,
     /* 116308 */   // GIR_Coverage, 1612,
     /* 116308 */   GIR_EraseRootFromParent_Done,
     /* 116309 */ // Label 2222: @116309
     /* 116309 */ GIM_Reject,
     /* 116310 */ // Label 2203: @116310
     /* 116310 */ GIM_Try, /*On fail goto*//*Label 2223*/ GIMT_Encode4(116408),
     /* 116315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 116318 */   GIM_Try, /*On fail goto*//*Label 2224*/ GIMT_Encode4(116352), // Rule ID 1608 //
     /* 116323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 116326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 116330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 116334 */     // (fp_to_sint:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTf2sq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /* 116334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2sq),
     /* 116337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 116339 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 116341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 116344 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116350 */     GIR_RootConstrainSelectedInstOperands,
     /* 116351 */     // GIR_Coverage, 1608,
     /* 116351 */     GIR_EraseRootFromParent_Done,
     /* 116352 */   // Label 2224: @116352
     /* 116352 */   GIM_Try, /*On fail goto*//*Label 2225*/ GIMT_Encode4(116407), // Rule ID 4094 //
     /* 116357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 116360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 116364 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 116368 */     // (fp_to_sint:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VCVTs32f32z:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$src)
     /* 116368 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 116371 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 116375 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32z),
     /* 116383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 116385 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116390 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116396 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116402 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116405 */     GIR_RootConstrainSelectedInstOperands,
     /* 116406 */     // GIR_Coverage, 4094,
     /* 116406 */     GIR_EraseRootFromParent_Done,
     /* 116407 */   // Label 2225: @116407
     /* 116407 */   GIM_Reject,
     /* 116408 */ // Label 2223: @116408
     /* 116408 */ GIM_Reject,
     /* 116409 */ // Label 2204: @116409
     /* 116409 */ GIM_Try, /*On fail goto*//*Label 2226*/ GIMT_Encode4(116461), // Rule ID 5106 //
     /* 116414 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 116417 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 116420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /* 116424 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 116428 */   // (fp_to_sint:{ *:[v8i1] } MQPR:{ *:[v8f16] }:$v1)  =>  (MVE_VCMPf16r:{ *:[v8i1] } MQPR:{ *:[v8f16] }:$v1, ZR:{ *:[i32] }, 1:{ *:[i32] })
     /* 116428 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMPf16r),
     /* 116431 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /* 116433 */   GIR_RootToRootCopy, /*OpIdx*/1, // v1
     /* 116435 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::ZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116441 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 116444 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116447 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116453 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116459 */   GIR_RootConstrainSelectedInstOperands,
     /* 116460 */   // GIR_Coverage, 5106,
     /* 116460 */   GIR_EraseRootFromParent_Done,
     /* 116461 */ // Label 2226: @116461
     /* 116461 */ GIM_Reject,
     /* 116462 */ // Label 2205: @116462
     /* 116462 */ GIM_Try, /*On fail goto*//*Label 2227*/ GIMT_Encode4(116560),
     /* 116467 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 116470 */   GIM_Try, /*On fail goto*//*Label 2228*/ GIMT_Encode4(116504), // Rule ID 1616 //
     /* 116475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 116478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 116482 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 116486 */     // (fp_to_sint:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTh2sq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /* 116486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2sq),
     /* 116489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 116491 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 116493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 116496 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116502 */     GIR_RootConstrainSelectedInstOperands,
     /* 116503 */     // GIR_Coverage, 1616,
     /* 116503 */     GIR_EraseRootFromParent_Done,
     /* 116504 */   // Label 2228: @116504
     /* 116504 */   GIM_Try, /*On fail goto*//*Label 2229*/ GIMT_Encode4(116559), // Rule ID 4090 //
     /* 116509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 116512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 116516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 116520 */     // (fp_to_sint:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VCVTs16f16z:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$src)
     /* 116520 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 116523 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 116527 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16z),
     /* 116535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 116537 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116542 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116548 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116554 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116557 */     GIR_RootConstrainSelectedInstOperands,
     /* 116558 */     // GIR_Coverage, 4090,
     /* 116558 */     GIR_EraseRootFromParent_Done,
     /* 116559 */   // Label 2229: @116559
     /* 116559 */   GIM_Reject,
     /* 116560 */ // Label 2227: @116560
     /* 116560 */ GIM_Reject,
     /* 116561 */ // Label 2206: @116561
     /* 116561 */ GIM_Reject,
     /* 116562 */ // Label 43: @116562
     /* 116562 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(13), /*)*//*default:*//*Label 2237*/ GIMT_Encode4(117895),
     /* 116573 */ /*GILLT_s32*//*Label 2230*/ GIMT_Encode4(116621), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 116585 */ /*GILLT_v2s32*//*Label 2231*/ GIMT_Encode4(117515), GIMT_Encode4(0),
     /* 116593 */ /*GILLT_v4s1*//*Label 2232*/ GIMT_Encode4(117553),
     /* 116597 */ /*GILLT_v4s16*//*Label 2233*/ GIMT_Encode4(117606),
     /* 116601 */ /*GILLT_v4s32*//*Label 2234*/ GIMT_Encode4(117644), GIMT_Encode4(0),
     /* 116609 */ /*GILLT_v8s1*//*Label 2235*/ GIMT_Encode4(117743), GIMT_Encode4(0),
     /* 116617 */ /*GILLT_v8s16*//*Label 2236*/ GIMT_Encode4(117796),
     /* 116621 */ // Label 2230: @116621
     /* 116621 */ GIM_Try, /*On fail goto*//*Label 2238*/ GIMT_Encode4(116687), // Rule ID 2324 //
     /* 116626 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 116629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 116632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116636 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116640 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 116644 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 116648 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 116653 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116655 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPUH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 116655 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116658 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPUH),
     /* 116662 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116667 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116671 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116673 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116676 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116678 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116681 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116686 */   // GIR_Coverage, 2324,
     /* 116686 */   GIR_EraseRootFromParent_Done,
     /* 116687 */ // Label 2238: @116687
     /* 116687 */ GIM_Try, /*On fail goto*//*Label 2239*/ GIMT_Encode4(116753), // Rule ID 2326 //
     /* 116692 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116695 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 116698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116702 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116706 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 116710 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 116714 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 116719 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116721 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPUS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 116721 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116724 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPUS),
     /* 116728 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116733 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116737 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116739 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116742 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116744 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116747 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116752 */   // GIR_Coverage, 2326,
     /* 116752 */   GIR_EraseRootFromParent_Done,
     /* 116753 */ // Label 2239: @116753
     /* 116753 */ GIM_Try, /*On fail goto*//*Label 2240*/ GIMT_Encode4(116819), // Rule ID 2328 //
     /* 116758 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 116761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 116764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116768 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116772 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 116776 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 116780 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 116785 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116787 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPUD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 116787 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116790 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPUD),
     /* 116794 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116799 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116803 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116805 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116808 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116810 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116813 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116818 */   // GIR_Coverage, 2328,
     /* 116818 */   GIR_EraseRootFromParent_Done,
     /* 116819 */ // Label 2240: @116819
     /* 116819 */ GIM_Try, /*On fail goto*//*Label 2241*/ GIMT_Encode4(116885), // Rule ID 2330 //
     /* 116824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 116827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 116830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116834 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116838 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 116842 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 116846 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 116851 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116853 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMUH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 116853 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116856 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMUH),
     /* 116860 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116865 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116869 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116871 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116874 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116876 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116879 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116884 */   // GIR_Coverage, 2330,
     /* 116884 */   GIR_EraseRootFromParent_Done,
     /* 116885 */ // Label 2241: @116885
     /* 116885 */ GIM_Try, /*On fail goto*//*Label 2242*/ GIMT_Encode4(116951), // Rule ID 2332 //
     /* 116890 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 116896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116900 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116904 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 116908 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 116912 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 116917 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116919 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMUS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 116919 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116922 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMUS),
     /* 116926 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116931 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116935 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116937 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116940 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116942 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116945 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116950 */   // GIR_Coverage, 2332,
     /* 116950 */   GIR_EraseRootFromParent_Done,
     /* 116951 */ // Label 2242: @116951
     /* 116951 */ GIM_Try, /*On fail goto*//*Label 2243*/ GIMT_Encode4(117017), // Rule ID 2334 //
     /* 116956 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 116959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 116962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116966 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116970 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 116974 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 116978 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 116983 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116985 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMUD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 116985 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116988 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMUD),
     /* 116992 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116997 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 117001 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117003 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117006 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117008 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117011 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117016 */   // GIR_Coverage, 2334,
     /* 117016 */   GIR_EraseRootFromParent_Done,
     /* 117017 */ // Label 2243: @117017
     /* 117017 */ GIM_Try, /*On fail goto*//*Label 2244*/ GIMT_Encode4(117083), // Rule ID 2318 //
     /* 117022 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 117025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 117028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117032 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117036 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 117040 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 117044 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 117049 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117051 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTAUH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 117051 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117054 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTAUH),
     /* 117058 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117063 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 117067 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117069 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117072 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117074 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117077 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117082 */   // GIR_Coverage, 2318,
     /* 117082 */   GIR_EraseRootFromParent_Done,
     /* 117083 */ // Label 2244: @117083
     /* 117083 */ GIM_Try, /*On fail goto*//*Label 2245*/ GIMT_Encode4(117149), // Rule ID 2320 //
     /* 117088 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 117091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 117094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117098 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117102 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 117106 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 117110 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 117115 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117117 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTAUS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 117117 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117120 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTAUS),
     /* 117124 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117129 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 117133 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117135 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117138 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117140 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117143 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117148 */   // GIR_Coverage, 2320,
     /* 117148 */   GIR_EraseRootFromParent_Done,
     /* 117149 */ // Label 2245: @117149
     /* 117149 */ GIM_Try, /*On fail goto*//*Label 2246*/ GIMT_Encode4(117215), // Rule ID 2322 //
     /* 117154 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 117157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 117160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117164 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117168 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 117172 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 117176 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117181 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117183 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTAUD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 117183 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117186 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTAUD),
     /* 117190 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117195 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 117199 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117201 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117204 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117206 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117209 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117214 */   // GIR_Coverage, 2322,
     /* 117214 */   GIR_EraseRootFromParent_Done,
     /* 117215 */ // Label 2246: @117215
     /* 117215 */ GIM_Try, /*On fail goto*//*Label 2247*/ GIMT_Encode4(117275), // Rule ID 2362 //
     /* 117220 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 117223 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 117226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117230 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117234 */   // (fp_to_uint:{ *:[i32] } DPR:{ *:[f64] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOUIZD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 117234 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117237 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOUIZD),
     /* 117241 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117246 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 117250 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 117253 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117259 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117261 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117264 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117266 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117269 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117274 */   // GIR_Coverage, 2362,
     /* 117274 */   GIR_EraseRootFromParent_Done,
     /* 117275 */ // Label 2247: @117275
     /* 117275 */ GIM_Try, /*On fail goto*//*Label 2248*/ GIMT_Encode4(117335), // Rule ID 2366 //
     /* 117280 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 117283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 117286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117290 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 117294 */   // (fp_to_uint:{ *:[i32] } SPR:{ *:[f32] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOUIZS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 117294 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117297 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOUIZS),
     /* 117301 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117306 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 117310 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 117313 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117319 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117321 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117324 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117326 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117329 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117334 */   // GIR_Coverage, 2366,
     /* 117334 */   GIR_EraseRootFromParent_Done,
     /* 117335 */ // Label 2248: @117335
     /* 117335 */ GIM_Try, /*On fail goto*//*Label 2249*/ GIMT_Encode4(117395), // Rule ID 2370 //
     /* 117340 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 117343 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 117346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117350 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 117354 */   // (fp_to_uint:{ *:[i32] } HPR:{ *:[f16] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOUIZH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 117354 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117357 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOUIZH),
     /* 117361 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117366 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 117370 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 117373 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117379 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117381 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117384 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117386 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117389 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117394 */   // GIR_Coverage, 2370,
     /* 117394 */   GIR_EraseRootFromParent_Done,
     /* 117395 */ // Label 2249: @117395
     /* 117395 */ GIM_Try, /*On fail goto*//*Label 2250*/ GIMT_Encode4(117514), // Rule ID 2711 //
     /* 117400 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 117403 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 117406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 117410 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 117414 */   // (fp_to_uint:{ *:[i32] } SPR:{ *:[f32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[i32] } (VCVTf2ud:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] })), ssub_0:{ *:[i32] })
     /* 117414 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 117417 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117421 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117426 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 117428 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s32,
     /* 117431 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 117435 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117440 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 117443 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 117447 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/17,
     /* 117450 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 117455 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 117460 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 117465 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 117468 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTf2ud),
     /* 117472 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117477 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 117480 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 117483 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117489 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117491 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117494 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117496 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 117503 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 117508 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 117513 */   // GIR_Coverage, 2711,
     /* 117513 */   GIR_EraseRootFromParent_Done,
     /* 117514 */ // Label 2250: @117514
     /* 117514 */ GIM_Reject,
     /* 117515 */ // Label 2231: @117515
     /* 117515 */ GIM_Try, /*On fail goto*//*Label 2251*/ GIMT_Encode4(117552), // Rule ID 1605 //
     /* 117520 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 117523 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 117526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117530 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117534 */   // (fp_to_uint:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTf2ud:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /* 117534 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2ud),
     /* 117537 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 117539 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 117541 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 117544 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117550 */   GIR_RootConstrainSelectedInstOperands,
     /* 117551 */   // GIR_Coverage, 1605,
     /* 117551 */   GIR_EraseRootFromParent_Done,
     /* 117552 */ // Label 2251: @117552
     /* 117552 */ GIM_Reject,
     /* 117553 */ // Label 2232: @117553
     /* 117553 */ GIM_Try, /*On fail goto*//*Label 2252*/ GIMT_Encode4(117605), // Rule ID 5103 //
     /* 117558 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 117561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 117564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /* 117568 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117572 */   // (fp_to_uint:{ *:[v4i1] } MQPR:{ *:[v4f32] }:$v1)  =>  (MVE_VCMPf32r:{ *:[v4i1] } MQPR:{ *:[v4f32] }:$v1, ZR:{ *:[i32] }, 1:{ *:[i32] })
     /* 117572 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMPf32r),
     /* 117575 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /* 117577 */   GIR_RootToRootCopy, /*OpIdx*/1, // v1
     /* 117579 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::ZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117585 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 117588 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117591 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117597 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117603 */   GIR_RootConstrainSelectedInstOperands,
     /* 117604 */   // GIR_Coverage, 5103,
     /* 117604 */   GIR_EraseRootFromParent_Done,
     /* 117605 */ // Label 2252: @117605
     /* 117605 */ GIM_Reject,
     /* 117606 */ // Label 2233: @117606
     /* 117606 */ GIM_Try, /*On fail goto*//*Label 2253*/ GIMT_Encode4(117643), // Rule ID 1613 //
     /* 117611 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 117614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 117617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117621 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117625 */   // (fp_to_uint:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTh2ud:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /* 117625 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2ud),
     /* 117628 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 117630 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 117632 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 117635 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117641 */   GIR_RootConstrainSelectedInstOperands,
     /* 117642 */   // GIR_Coverage, 1613,
     /* 117642 */   GIR_EraseRootFromParent_Done,
     /* 117643 */ // Label 2253: @117643
     /* 117643 */ GIM_Reject,
     /* 117644 */ // Label 2234: @117644
     /* 117644 */ GIM_Try, /*On fail goto*//*Label 2254*/ GIMT_Encode4(117742),
     /* 117649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 117652 */   GIM_Try, /*On fail goto*//*Label 2255*/ GIMT_Encode4(117686), // Rule ID 1609 //
     /* 117657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 117660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 117664 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 117668 */     // (fp_to_uint:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTf2uq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /* 117668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2uq),
     /* 117671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 117673 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 117675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 117678 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117684 */     GIR_RootConstrainSelectedInstOperands,
     /* 117685 */     // GIR_Coverage, 1609,
     /* 117685 */     GIR_EraseRootFromParent_Done,
     /* 117686 */   // Label 2255: @117686
     /* 117686 */   GIM_Try, /*On fail goto*//*Label 2256*/ GIMT_Encode4(117741), // Rule ID 4096 //
     /* 117691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 117694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117698 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117702 */     // (fp_to_uint:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VCVTu32f32z:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$src)
     /* 117702 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 117705 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117709 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32z),
     /* 117717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 117719 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 117721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117724 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117730 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117736 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117739 */     GIR_RootConstrainSelectedInstOperands,
     /* 117740 */     // GIR_Coverage, 4096,
     /* 117740 */     GIR_EraseRootFromParent_Done,
     /* 117741 */   // Label 2256: @117741
     /* 117741 */   GIM_Reject,
     /* 117742 */ // Label 2254: @117742
     /* 117742 */ GIM_Reject,
     /* 117743 */ // Label 2235: @117743
     /* 117743 */ GIM_Try, /*On fail goto*//*Label 2257*/ GIMT_Encode4(117795), // Rule ID 5104 //
     /* 117748 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 117751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 117754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /* 117758 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117762 */   // (fp_to_uint:{ *:[v8i1] } MQPR:{ *:[v8f16] }:$v1)  =>  (MVE_VCMPf16r:{ *:[v8i1] } MQPR:{ *:[v8f16] }:$v1, ZR:{ *:[i32] }, 1:{ *:[i32] })
     /* 117762 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMPf16r),
     /* 117765 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /* 117767 */   GIR_RootToRootCopy, /*OpIdx*/1, // v1
     /* 117769 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::ZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117775 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 117778 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117781 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117787 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117793 */   GIR_RootConstrainSelectedInstOperands,
     /* 117794 */   // GIR_Coverage, 5104,
     /* 117794 */   GIR_EraseRootFromParent_Done,
     /* 117795 */ // Label 2257: @117795
     /* 117795 */ GIM_Reject,
     /* 117796 */ // Label 2236: @117796
     /* 117796 */ GIM_Try, /*On fail goto*//*Label 2258*/ GIMT_Encode4(117894),
     /* 117801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 117804 */   GIM_Try, /*On fail goto*//*Label 2259*/ GIMT_Encode4(117838), // Rule ID 1617 //
     /* 117809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 117812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 117816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 117820 */     // (fp_to_uint:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTh2uq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /* 117820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2uq),
     /* 117823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 117825 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 117827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 117830 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117836 */     GIR_RootConstrainSelectedInstOperands,
     /* 117837 */     // GIR_Coverage, 1617,
     /* 117837 */     GIR_EraseRootFromParent_Done,
     /* 117838 */   // Label 2259: @117838
     /* 117838 */   GIM_Try, /*On fail goto*//*Label 2260*/ GIMT_Encode4(117893), // Rule ID 4092 //
     /* 117843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 117846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117850 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117854 */     // (fp_to_uint:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VCVTu16f16z:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$src)
     /* 117854 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 117857 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117861 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16z),
     /* 117869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 117871 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 117873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117876 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117882 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117888 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117891 */     GIR_RootConstrainSelectedInstOperands,
     /* 117892 */     // GIR_Coverage, 4092,
     /* 117892 */     GIR_EraseRootFromParent_Done,
     /* 117893 */   // Label 2260: @117893
     /* 117893 */   GIM_Reject,
     /* 117894 */ // Label 2258: @117894
     /* 117894 */ GIM_Reject,
     /* 117895 */ // Label 2237: @117895
     /* 117895 */ GIM_Reject,
     /* 117896 */ // Label 44: @117896
     /* 117896 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2268*/ GIMT_Encode4(118547),
     /* 117907 */ /*GILLT_s16*//*Label 2261*/ GIMT_Encode4(117959),
     /* 117911 */ /*GILLT_s32*//*Label 2262*/ GIMT_Encode4(118019),
     /* 117915 */ /*GILLT_s64*//*Label 2263*/ GIMT_Encode4(118213), GIMT_Encode4(0),
     /* 117923 */ /*GILLT_v2s32*//*Label 2264*/ GIMT_Encode4(118273), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 117935 */ /*GILLT_v4s16*//*Label 2265*/ GIMT_Encode4(118311),
     /* 117939 */ /*GILLT_v4s32*//*Label 2266*/ GIMT_Encode4(118349), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 117955 */ /*GILLT_v8s16*//*Label 2267*/ GIMT_Encode4(118448),
     /* 117959 */ // Label 2261: @117959
     /* 117959 */ GIM_Try, /*On fail goto*//*Label 2269*/ GIMT_Encode4(118018), // Rule ID 2346 //
     /* 117964 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 117967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 117970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 117974 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117978 */   // (sint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$a)  =>  (VSITOH:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 117978 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117981 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117985 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117990 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 117994 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 117999 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSITOH),
     /* 118002 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 118004 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118007 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118010 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118016 */   GIR_RootConstrainSelectedInstOperands,
     /* 118017 */   // GIR_Coverage, 2346,
     /* 118017 */   GIR_EraseRootFromParent_Done,
     /* 118018 */ // Label 2269: @118018
     /* 118018 */ GIM_Reject,
     /* 118019 */ // Label 2262: @118019
     /* 118019 */ GIM_Try, /*On fail goto*//*Label 2270*/ GIMT_Encode4(118212),
     /* 118024 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 118027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 118031 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 118035 */   GIM_Try, /*On fail goto*//*Label 2271*/ GIMT_Encode4(118083), // Rule ID 2344 //
     /* 118040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 118043 */     // (sint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$a)  =>  (VSITOS:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 118043 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118046 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118050 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118055 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118059 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSITOS),
     /* 118067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 118069 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118075 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118081 */     GIR_RootConstrainSelectedInstOperands,
     /* 118082 */     // GIR_Coverage, 2344,
     /* 118082 */     GIR_EraseRootFromParent_Done,
     /* 118083 */   // Label 2271: @118083
     /* 118083 */   GIM_Try, /*On fail goto*//*Label 2272*/ GIMT_Encode4(118211), // Rule ID 2712 //
     /* 118088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 118091 */     // (sint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[f32] } (VCVTs2fd:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), (COPY_TO_REGCLASS:{ *:[i32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }), ssub_0:{ *:[i32] })), ssub_0:{ *:[i32] })
     /* 118091 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 118094 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118098 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118103 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118107 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118112 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 118115 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118119 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118124 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 118126 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s32,
     /* 118129 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 118133 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118138 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 118141 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 118144 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/17,
     /* 118147 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118152 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118157 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 118165 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTs2fd),
     /* 118169 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118174 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 118177 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 118180 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118186 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 118188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118193 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 118200 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118205 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118210 */     // GIR_Coverage, 2712,
     /* 118210 */     GIR_EraseRootFromParent_Done,
     /* 118211 */   // Label 2272: @118211
     /* 118211 */   GIM_Reject,
     /* 118212 */ // Label 2270: @118212
     /* 118212 */ GIM_Reject,
     /* 118213 */ // Label 2263: @118213
     /* 118213 */ GIM_Try, /*On fail goto*//*Label 2273*/ GIMT_Encode4(118272), // Rule ID 2342 //
     /* 118218 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 118221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 118224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118228 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 118232 */   // (sint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$a)  =>  (VSITOD:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 118232 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118235 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118239 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118244 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118248 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118253 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSITOD),
     /* 118256 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 118258 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118261 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118264 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118270 */   GIR_RootConstrainSelectedInstOperands,
     /* 118271 */   // GIR_Coverage, 2342,
     /* 118271 */   GIR_EraseRootFromParent_Done,
     /* 118272 */ // Label 2273: @118272
     /* 118272 */ GIM_Reject,
     /* 118273 */ // Label 2264: @118273
     /* 118273 */ GIM_Try, /*On fail goto*//*Label 2274*/ GIMT_Encode4(118310), // Rule ID 1606 //
     /* 118278 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 118281 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 118284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118288 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118292 */   // (sint_to_fp:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm)  =>  (VCVTs2fd:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm)
     /* 118292 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTs2fd),
     /* 118295 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 118297 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 118299 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118302 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118308 */   GIR_RootConstrainSelectedInstOperands,
     /* 118309 */   // GIR_Coverage, 1606,
     /* 118309 */   GIR_EraseRootFromParent_Done,
     /* 118310 */ // Label 2274: @118310
     /* 118310 */ GIM_Reject,
     /* 118311 */ // Label 2265: @118311
     /* 118311 */ GIM_Try, /*On fail goto*//*Label 2275*/ GIMT_Encode4(118348), // Rule ID 1614 //
     /* 118316 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 118319 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 118322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118326 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118330 */   // (sint_to_fp:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm)  =>  (VCVTs2hd:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm)
     /* 118330 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTs2hd),
     /* 118333 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 118335 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 118337 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118340 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118346 */   GIR_RootConstrainSelectedInstOperands,
     /* 118347 */   // GIR_Coverage, 1614,
     /* 118347 */   GIR_EraseRootFromParent_Done,
     /* 118348 */ // Label 2275: @118348
     /* 118348 */ GIM_Reject,
     /* 118349 */ // Label 2266: @118349
     /* 118349 */ GIM_Try, /*On fail goto*//*Label 2276*/ GIMT_Encode4(118447),
     /* 118354 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 118357 */   GIM_Try, /*On fail goto*//*Label 2277*/ GIMT_Encode4(118391), // Rule ID 1610 //
     /* 118362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 118365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 118369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 118373 */     // (sint_to_fp:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm)  =>  (VCVTs2fq:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm)
     /* 118373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTs2fq),
     /* 118376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 118378 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 118380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118383 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118389 */     GIR_RootConstrainSelectedInstOperands,
     /* 118390 */     // GIR_Coverage, 1610,
     /* 118390 */     GIR_EraseRootFromParent_Done,
     /* 118391 */   // Label 2277: @118391
     /* 118391 */   GIM_Try, /*On fail goto*//*Label 2278*/ GIMT_Encode4(118446), // Rule ID 4102 //
     /* 118396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 118399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 118403 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 118407 */     // (sint_to_fp:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VCVTf32s32n:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$src)
     /* 118407 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 118410 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118414 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32s32n),
     /* 118422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 118424 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 118426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118429 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118435 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118441 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118444 */     GIR_RootConstrainSelectedInstOperands,
     /* 118445 */     // GIR_Coverage, 4102,
     /* 118445 */     GIR_EraseRootFromParent_Done,
     /* 118446 */   // Label 2278: @118446
     /* 118446 */   GIM_Reject,
     /* 118447 */ // Label 2276: @118447
     /* 118447 */ GIM_Reject,
     /* 118448 */ // Label 2267: @118448
     /* 118448 */ GIM_Try, /*On fail goto*//*Label 2279*/ GIMT_Encode4(118546),
     /* 118453 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 118456 */   GIM_Try, /*On fail goto*//*Label 2280*/ GIMT_Encode4(118490), // Rule ID 1618 //
     /* 118461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 118464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 118468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 118472 */     // (sint_to_fp:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm)  =>  (VCVTs2hq:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm)
     /* 118472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTs2hq),
     /* 118475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 118477 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 118479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118482 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118488 */     GIR_RootConstrainSelectedInstOperands,
     /* 118489 */     // GIR_Coverage, 1618,
     /* 118489 */     GIR_EraseRootFromParent_Done,
     /* 118490 */   // Label 2280: @118490
     /* 118490 */   GIM_Try, /*On fail goto*//*Label 2281*/ GIMT_Encode4(118545), // Rule ID 4098 //
     /* 118495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 118498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 118502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 118506 */     // (sint_to_fp:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VCVTf16s16n:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$src)
     /* 118506 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 118509 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118513 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16s16n),
     /* 118521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 118523 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 118525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118528 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118534 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118540 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118543 */     GIR_RootConstrainSelectedInstOperands,
     /* 118544 */     // GIR_Coverage, 4098,
     /* 118544 */     GIR_EraseRootFromParent_Done,
     /* 118545 */   // Label 2281: @118545
     /* 118545 */   GIM_Reject,
     /* 118546 */ // Label 2279: @118546
     /* 118546 */ GIM_Reject,
     /* 118547 */ // Label 2268: @118547
     /* 118547 */ GIM_Reject,
     /* 118548 */ // Label 45: @118548
     /* 118548 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2289*/ GIMT_Encode4(119199),
     /* 118559 */ /*GILLT_s16*//*Label 2282*/ GIMT_Encode4(118611),
     /* 118563 */ /*GILLT_s32*//*Label 2283*/ GIMT_Encode4(118671),
     /* 118567 */ /*GILLT_s64*//*Label 2284*/ GIMT_Encode4(118865), GIMT_Encode4(0),
     /* 118575 */ /*GILLT_v2s32*//*Label 2285*/ GIMT_Encode4(118925), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 118587 */ /*GILLT_v4s16*//*Label 2286*/ GIMT_Encode4(118963),
     /* 118591 */ /*GILLT_v4s32*//*Label 2287*/ GIMT_Encode4(119001), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 118607 */ /*GILLT_v8s16*//*Label 2288*/ GIMT_Encode4(119100),
     /* 118611 */ // Label 2282: @118611
     /* 118611 */ GIM_Try, /*On fail goto*//*Label 2290*/ GIMT_Encode4(118670), // Rule ID 2351 //
     /* 118616 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 118619 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 118622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 118626 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 118630 */   // (uint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$a)  =>  (VUITOH:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 118630 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118633 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118637 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118642 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118646 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118651 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUITOH),
     /* 118654 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 118656 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118659 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118662 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118668 */   GIR_RootConstrainSelectedInstOperands,
     /* 118669 */   // GIR_Coverage, 2351,
     /* 118669 */   GIR_EraseRootFromParent_Done,
     /* 118670 */ // Label 2290: @118670
     /* 118670 */ GIM_Reject,
     /* 118671 */ // Label 2283: @118671
     /* 118671 */ GIM_Try, /*On fail goto*//*Label 2291*/ GIMT_Encode4(118864),
     /* 118676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 118679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 118683 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 118687 */   GIM_Try, /*On fail goto*//*Label 2292*/ GIMT_Encode4(118735), // Rule ID 2349 //
     /* 118692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 118695 */     // (uint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$a)  =>  (VUITOS:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 118695 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118698 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118702 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118707 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118711 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUITOS),
     /* 118719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 118721 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118727 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118733 */     GIR_RootConstrainSelectedInstOperands,
     /* 118734 */     // GIR_Coverage, 2349,
     /* 118734 */     GIR_EraseRootFromParent_Done,
     /* 118735 */   // Label 2292: @118735
     /* 118735 */   GIM_Try, /*On fail goto*//*Label 2293*/ GIMT_Encode4(118863), // Rule ID 2713 //
     /* 118740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 118743 */     // (uint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[f32] } (VCVTu2fd:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), (COPY_TO_REGCLASS:{ *:[i32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }), ssub_0:{ *:[i32] })), ssub_0:{ *:[i32] })
     /* 118743 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 118746 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118750 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118755 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118759 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118764 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 118767 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118771 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118776 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 118778 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s32,
     /* 118781 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 118785 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118790 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 118793 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 118796 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/17,
     /* 118799 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118804 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118809 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118814 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 118817 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTu2fd),
     /* 118821 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118826 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 118829 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 118832 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 118840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118845 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 118852 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118857 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118862 */     // GIR_Coverage, 2713,
     /* 118862 */     GIR_EraseRootFromParent_Done,
     /* 118863 */   // Label 2293: @118863
     /* 118863 */   GIM_Reject,
     /* 118864 */ // Label 2291: @118864
     /* 118864 */ GIM_Reject,
     /* 118865 */ // Label 2284: @118865
     /* 118865 */ GIM_Try, /*On fail goto*//*Label 2294*/ GIMT_Encode4(118924), // Rule ID 2347 //
     /* 118870 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 118873 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 118876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118880 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 118884 */   // (uint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$a)  =>  (VUITOD:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 118884 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118887 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118891 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118896 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118900 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118905 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUITOD),
     /* 118908 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 118910 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118913 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118916 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118922 */   GIR_RootConstrainSelectedInstOperands,
     /* 118923 */   // GIR_Coverage, 2347,
     /* 118923 */   GIR_EraseRootFromParent_Done,
     /* 118924 */ // Label 2294: @118924
     /* 118924 */ GIM_Reject,
     /* 118925 */ // Label 2285: @118925
     /* 118925 */ GIM_Try, /*On fail goto*//*Label 2295*/ GIMT_Encode4(118962), // Rule ID 1607 //
     /* 118930 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 118933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 118936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118940 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118944 */   // (uint_to_fp:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm)  =>  (VCVTu2fd:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm)
     /* 118944 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTu2fd),
     /* 118947 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 118949 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 118951 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118954 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118960 */   GIR_RootConstrainSelectedInstOperands,
     /* 118961 */   // GIR_Coverage, 1607,
     /* 118961 */   GIR_EraseRootFromParent_Done,
     /* 118962 */ // Label 2295: @118962
     /* 118962 */ GIM_Reject,
     /* 118963 */ // Label 2286: @118963
     /* 118963 */ GIM_Try, /*On fail goto*//*Label 2296*/ GIMT_Encode4(119000), // Rule ID 1615 //
     /* 118968 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 118971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 118974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118982 */   // (uint_to_fp:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm)  =>  (VCVTu2hd:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm)
     /* 118982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTu2hd),
     /* 118985 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 118987 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 118989 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118992 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118998 */   GIR_RootConstrainSelectedInstOperands,
     /* 118999 */   // GIR_Coverage, 1615,
     /* 118999 */   GIR_EraseRootFromParent_Done,
     /* 119000 */ // Label 2296: @119000
     /* 119000 */ GIM_Reject,
     /* 119001 */ // Label 2287: @119001
     /* 119001 */ GIM_Try, /*On fail goto*//*Label 2297*/ GIMT_Encode4(119099),
     /* 119006 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 119009 */   GIM_Try, /*On fail goto*//*Label 2298*/ GIMT_Encode4(119043), // Rule ID 1611 //
     /* 119014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 119017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119025 */     // (uint_to_fp:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm)  =>  (VCVTu2fq:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm)
     /* 119025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTu2fq),
     /* 119028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119030 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119035 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119041 */     GIR_RootConstrainSelectedInstOperands,
     /* 119042 */     // GIR_Coverage, 1611,
     /* 119042 */     GIR_EraseRootFromParent_Done,
     /* 119043 */   // Label 2298: @119043
     /* 119043 */   GIM_Try, /*On fail goto*//*Label 2299*/ GIMT_Encode4(119098), // Rule ID 4104 //
     /* 119048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 119051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119059 */     // (uint_to_fp:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VCVTf32u32n:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$src)
     /* 119059 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 119062 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119066 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32u32n),
     /* 119074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 119076 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 119078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119081 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119087 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119093 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119096 */     GIR_RootConstrainSelectedInstOperands,
     /* 119097 */     // GIR_Coverage, 4104,
     /* 119097 */     GIR_EraseRootFromParent_Done,
     /* 119098 */   // Label 2299: @119098
     /* 119098 */   GIM_Reject,
     /* 119099 */ // Label 2297: @119099
     /* 119099 */ GIM_Reject,
     /* 119100 */ // Label 2288: @119100
     /* 119100 */ GIM_Try, /*On fail goto*//*Label 2300*/ GIMT_Encode4(119198),
     /* 119105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 119108 */   GIM_Try, /*On fail goto*//*Label 2301*/ GIMT_Encode4(119142), // Rule ID 1619 //
     /* 119113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 119116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119120 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119124 */     // (uint_to_fp:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm)  =>  (VCVTu2hq:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm)
     /* 119124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTu2hq),
     /* 119127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119129 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119134 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119140 */     GIR_RootConstrainSelectedInstOperands,
     /* 119141 */     // GIR_Coverage, 1619,
     /* 119141 */     GIR_EraseRootFromParent_Done,
     /* 119142 */   // Label 2301: @119142
     /* 119142 */   GIM_Try, /*On fail goto*//*Label 2302*/ GIMT_Encode4(119197), // Rule ID 4100 //
     /* 119147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 119150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119158 */     // (uint_to_fp:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VCVTf16u16n:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$src)
     /* 119158 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 119161 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119165 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16u16n),
     /* 119173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 119175 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 119177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119180 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119186 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119192 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119195 */     GIR_RootConstrainSelectedInstOperands,
     /* 119196 */     // GIR_Coverage, 4100,
     /* 119196 */     GIR_EraseRootFromParent_Done,
     /* 119197 */   // Label 2302: @119197
     /* 119197 */   GIM_Reject,
     /* 119198 */ // Label 2300: @119198
     /* 119198 */ GIM_Reject,
     /* 119199 */ // Label 2289: @119199
     /* 119199 */ GIM_Reject,
     /* 119200 */ // Label 46: @119200
     /* 119200 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2310*/ GIMT_Encode4(119975),
     /* 119211 */ /*GILLT_s16*//*Label 2303*/ GIMT_Encode4(119263),
     /* 119215 */ /*GILLT_s32*//*Label 2304*/ GIMT_Encode4(119301),
     /* 119219 */ /*GILLT_s64*//*Label 2305*/ GIMT_Encode4(119493), GIMT_Encode4(0),
     /* 119227 */ /*GILLT_v2s32*//*Label 2306*/ GIMT_Encode4(119531), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 119239 */ /*GILLT_v4s16*//*Label 2307*/ GIMT_Encode4(119569),
     /* 119243 */ /*GILLT_v4s32*//*Label 2308*/ GIMT_Encode4(119607), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 119259 */ /*GILLT_v8s16*//*Label 2309*/ GIMT_Encode4(119791),
     /* 119263 */ // Label 2303: @119263
     /* 119263 */ GIM_Try, /*On fail goto*//*Label 2311*/ GIMT_Encode4(119300), // Rule ID 653 //
     /* 119268 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 119271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 119274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 119278 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 119282 */   // (fabs:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VABSH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 119282 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSH),
     /* 119285 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 119287 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 119289 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119292 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119298 */   GIR_RootConstrainSelectedInstOperands,
     /* 119299 */   // GIR_Coverage, 653,
     /* 119299 */   GIR_EraseRootFromParent_Done,
     /* 119300 */ // Label 2311: @119300
     /* 119300 */ GIM_Reject,
     /* 119301 */ // Label 2304: @119301
     /* 119301 */ GIM_Try, /*On fail goto*//*Label 2312*/ GIMT_Encode4(119492),
     /* 119306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 119309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 119313 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 119317 */   GIM_Try, /*On fail goto*//*Label 2313*/ GIMT_Encode4(119343), // Rule ID 652 //
     /* 119322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 119325 */     // (fabs:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VABSS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 119325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSS),
     /* 119328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 119330 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 119332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119335 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119341 */     GIR_RootConstrainSelectedInstOperands,
     /* 119342 */     // GIR_Coverage, 652,
     /* 119342 */     GIR_EraseRootFromParent_Done,
     /* 119343 */   // Label 2313: @119343
     /* 119343 */   GIM_Try, /*On fail goto*//*Label 2314*/ GIMT_Encode4(119491), // Rule ID 2704 //
     /* 119348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 119351 */     // (fabs:{ *:[f32] } SPR:{ *:[f32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VABSfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 119351 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 119354 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119358 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119363 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 119365 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 119368 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119372 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119377 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 119380 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 119385 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 119388 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 119392 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119397 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 119400 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 119404 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 119407 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 119412 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 119417 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 119422 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 119425 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VABSfd),
     /* 119429 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119434 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 119437 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 119440 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119446 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119448 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 119451 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119455 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119460 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 119463 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 119468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119473 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 119480 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 119485 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 119490 */     // GIR_Coverage, 2704,
     /* 119490 */     GIR_EraseRootFromParent_Done,
     /* 119491 */   // Label 2314: @119491
     /* 119491 */   GIM_Reject,
     /* 119492 */ // Label 2312: @119492
     /* 119492 */ GIM_Reject,
     /* 119493 */ // Label 2305: @119493
     /* 119493 */ GIM_Try, /*On fail goto*//*Label 2315*/ GIMT_Encode4(119530), // Rule ID 651 //
     /* 119498 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 119501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 119504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119508 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119512 */   // (fabs:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VABSD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 119512 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSD),
     /* 119515 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 119517 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 119519 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119522 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119528 */   GIR_RootConstrainSelectedInstOperands,
     /* 119529 */   // GIR_Coverage, 651,
     /* 119529 */   GIR_EraseRootFromParent_Done,
     /* 119530 */ // Label 2315: @119530
     /* 119530 */ GIM_Reject,
     /* 119531 */ // Label 2306: @119531
     /* 119531 */ GIM_Try, /*On fail goto*//*Label 2316*/ GIMT_Encode4(119568), // Rule ID 1514 //
     /* 119536 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 119539 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 119542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119546 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119550 */   // (fabs:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VABSfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /* 119550 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSfd),
     /* 119553 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119555 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119557 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119560 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119566 */   GIR_RootConstrainSelectedInstOperands,
     /* 119567 */   // GIR_Coverage, 1514,
     /* 119567 */   GIR_EraseRootFromParent_Done,
     /* 119568 */ // Label 2316: @119568
     /* 119568 */ GIM_Reject,
     /* 119569 */ // Label 2307: @119569
     /* 119569 */ GIM_Try, /*On fail goto*//*Label 2317*/ GIMT_Encode4(119606), // Rule ID 1516 //
     /* 119574 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 119577 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 119580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119584 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119588 */   // (fabs:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VABShd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /* 119588 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABShd),
     /* 119591 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119593 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119595 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119598 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119604 */   GIR_RootConstrainSelectedInstOperands,
     /* 119605 */   // GIR_Coverage, 1516,
     /* 119605 */   GIR_EraseRootFromParent_Done,
     /* 119606 */ // Label 2317: @119606
     /* 119606 */ GIM_Reject,
     /* 119607 */ // Label 2308: @119607
     /* 119607 */ GIM_Try, /*On fail goto*//*Label 2318*/ GIMT_Encode4(119790),
     /* 119612 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 119615 */   GIM_Try, /*On fail goto*//*Label 2319*/ GIMT_Encode4(119700), // Rule ID 4041 //
     /* 119620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 119623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 119635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 119639 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 119643 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119648 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119655 */     // (fabs:{ *:[v4f32] } (fsub:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn))  =>  (MVE_VABDf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 119655 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 119658 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119662 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDf32),
     /* 119670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 119672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 119676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Qn
     /* 119680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119683 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119689 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119695 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119698 */     GIR_RootConstrainSelectedInstOperands,
     /* 119699 */     // GIR_Coverage, 4041,
     /* 119699 */     GIR_EraseRootFromParent_Done,
     /* 119700 */   // Label 2319: @119700
     /* 119700 */   GIM_Try, /*On fail goto*//*Label 2320*/ GIMT_Encode4(119734), // Rule ID 1515 //
     /* 119705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 119708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119716 */     // (fabs:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VABSfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /* 119716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSfq),
     /* 119719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119721 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119726 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119732 */     GIR_RootConstrainSelectedInstOperands,
     /* 119733 */     // GIR_Coverage, 1515,
     /* 119733 */     GIR_EraseRootFromParent_Done,
     /* 119734 */   // Label 2320: @119734
     /* 119734 */   GIM_Try, /*On fail goto*//*Label 2321*/ GIMT_Encode4(119789), // Rule ID 4112 //
     /* 119739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 119742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119746 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119750 */     // (fabs:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$v)  =>  (MVE_VABSf32:{ *:[v4f32] } ?:{ *:[v4f32] }:$v)
     /* 119750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 119753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABSf32),
     /* 119765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 119767 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 119769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119772 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119778 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119784 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119787 */     GIR_RootConstrainSelectedInstOperands,
     /* 119788 */     // GIR_Coverage, 4112,
     /* 119788 */     GIR_EraseRootFromParent_Done,
     /* 119789 */   // Label 2321: @119789
     /* 119789 */   GIM_Reject,
     /* 119790 */ // Label 2318: @119790
     /* 119790 */ GIM_Reject,
     /* 119791 */ // Label 2309: @119791
     /* 119791 */ GIM_Try, /*On fail goto*//*Label 2322*/ GIMT_Encode4(119974),
     /* 119796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 119799 */   GIM_Try, /*On fail goto*//*Label 2323*/ GIMT_Encode4(119884), // Rule ID 4040 //
     /* 119804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 119807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 119819 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 119823 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 119827 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119832 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119839 */     // (fabs:{ *:[v8f16] } (fsub:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn))  =>  (MVE_VABDf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 119839 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 119842 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119846 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDf16),
     /* 119854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 119856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 119860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Qn
     /* 119864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119867 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119873 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119882 */     GIR_RootConstrainSelectedInstOperands,
     /* 119883 */     // GIR_Coverage, 4040,
     /* 119883 */     GIR_EraseRootFromParent_Done,
     /* 119884 */   // Label 2323: @119884
     /* 119884 */   GIM_Try, /*On fail goto*//*Label 2324*/ GIMT_Encode4(119918), // Rule ID 1517 //
     /* 119889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 119892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119900 */     // (fabs:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VABShq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /* 119900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABShq),
     /* 119903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119905 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119910 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119916 */     GIR_RootConstrainSelectedInstOperands,
     /* 119917 */     // GIR_Coverage, 1517,
     /* 119917 */     GIR_EraseRootFromParent_Done,
     /* 119918 */   // Label 2324: @119918
     /* 119918 */   GIM_Try, /*On fail goto*//*Label 2325*/ GIMT_Encode4(119973), // Rule ID 4110 //
     /* 119923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 119926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119930 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119934 */     // (fabs:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$v)  =>  (MVE_VABSf16:{ *:[v8f16] } ?:{ *:[v8f16] }:$v)
     /* 119934 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 119937 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119941 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABSf16),
     /* 119949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 119951 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 119953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119956 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119962 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119968 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119971 */     GIR_RootConstrainSelectedInstOperands,
     /* 119972 */     // GIR_Coverage, 4110,
     /* 119972 */     GIR_EraseRootFromParent_Done,
     /* 119973 */   // Label 2325: @119973
     /* 119973 */   GIM_Reject,
     /* 119974 */ // Label 2322: @119974
     /* 119974 */ GIM_Reject,
     /* 119975 */ // Label 2310: @119975
     /* 119975 */ GIM_Reject,
     /* 119976 */ // Label 47: @119976
     /* 119976 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2333*/ GIMT_Encode4(120567),
     /* 119987 */ /*GILLT_s16*//*Label 2326*/ GIMT_Encode4(120039),
     /* 119991 */ /*GILLT_s32*//*Label 2327*/ GIMT_Encode4(120073),
     /* 119995 */ /*GILLT_s64*//*Label 2328*/ GIMT_Encode4(120107), GIMT_Encode4(0),
     /* 120003 */ /*GILLT_v2s32*//*Label 2329*/ GIMT_Encode4(120141), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 120015 */ /*GILLT_v4s16*//*Label 2330*/ GIMT_Encode4(120175),
     /* 120019 */ /*GILLT_v4s32*//*Label 2331*/ GIMT_Encode4(120209), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 120035 */ /*GILLT_v8s16*//*Label 2332*/ GIMT_Encode4(120388),
     /* 120039 */ // Label 2326: @120039
     /* 120039 */ GIM_Try, /*On fail goto*//*Label 2334*/ GIMT_Encode4(120072), // Rule ID 642 //
     /* 120044 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 120047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 120050 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 120053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 120057 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 120061 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 120065 */   // (fminnum:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VFP_VMINNMH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 120065 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMINNMH),
     /* 120070 */   GIR_RootConstrainSelectedInstOperands,
     /* 120071 */   // GIR_Coverage, 642,
     /* 120071 */   GIR_Done,
     /* 120072 */ // Label 2334: @120072
     /* 120072 */ GIM_Reject,
     /* 120073 */ // Label 2327: @120073
     /* 120073 */ GIM_Try, /*On fail goto*//*Label 2335*/ GIMT_Encode4(120106), // Rule ID 643 //
     /* 120078 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 120081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 120084 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 120087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 120091 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 120095 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 120099 */   // (fminnum:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VFP_VMINNMS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 120099 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMINNMS),
     /* 120104 */   GIR_RootConstrainSelectedInstOperands,
     /* 120105 */   // GIR_Coverage, 643,
     /* 120105 */   GIR_Done,
     /* 120106 */ // Label 2335: @120106
     /* 120106 */ GIM_Reject,
     /* 120107 */ // Label 2328: @120107
     /* 120107 */ GIM_Try, /*On fail goto*//*Label 2336*/ GIMT_Encode4(120140), // Rule ID 644 //
     /* 120112 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 120115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 120118 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 120121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120125 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120129 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120133 */   // (fminnum:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VFP_VMINNMD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 120133 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMINNMD),
     /* 120138 */   GIR_RootConstrainSelectedInstOperands,
     /* 120139 */   // GIR_Coverage, 644,
     /* 120139 */   GIR_Done,
     /* 120140 */ // Label 2336: @120140
     /* 120140 */ GIM_Reject,
     /* 120141 */ // Label 2329: @120141
     /* 120141 */ GIM_Try, /*On fail goto*//*Label 2337*/ GIMT_Encode4(120174), // Rule ID 1233 //
     /* 120146 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasNEON),
     /* 120149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 120152 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 120155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120159 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120163 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120167 */   // (fminnum:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (NEON_VMINNMNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 120167 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMINNMNDf),
     /* 120172 */   GIR_RootConstrainSelectedInstOperands,
     /* 120173 */   // GIR_Coverage, 1233,
     /* 120173 */   GIR_Done,
     /* 120174 */ // Label 2337: @120174
     /* 120174 */ GIM_Reject,
     /* 120175 */ // Label 2330: @120175
     /* 120175 */ GIM_Try, /*On fail goto*//*Label 2338*/ GIMT_Encode4(120208), // Rule ID 1235 //
     /* 120180 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasFullFP16_HasNEON),
     /* 120183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 120186 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 120189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120193 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120197 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120201 */   // (fminnum:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (NEON_VMINNMNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 120201 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMINNMNDh),
     /* 120206 */   GIR_RootConstrainSelectedInstOperands,
     /* 120207 */   // GIR_Coverage, 1235,
     /* 120207 */   GIR_Done,
     /* 120208 */ // Label 2338: @120208
     /* 120208 */ GIM_Reject,
     /* 120209 */ // Label 2331: @120209
     /* 120209 */ GIM_Try, /*On fail goto*//*Label 2339*/ GIMT_Encode4(120387),
     /* 120214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 120217 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 120220 */   GIM_Try, /*On fail goto*//*Label 2340*/ GIMT_Encode4(120298), // Rule ID 4122 //
     /* 120225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 120228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120240 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 120244 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120249 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 120253 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120257 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 120261 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120266 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 120268 */     // (fminnum:{ *:[v4f32] } (fabs:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qd), (fabs:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm))  =>  (MVE_VMINNMAf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qd, MQPR:{ *:[v4f32] }:$Qm)
     /* 120268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMAf32),
     /* 120271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qd
     /* 120277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Qm
     /* 120281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120284 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120290 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120296 */     GIR_RootConstrainSelectedInstOperands,
     /* 120297 */     // GIR_Coverage, 4122,
     /* 120297 */     GIR_EraseRootFromParent_Done,
     /* 120298 */   // Label 2340: @120298
     /* 120298 */   GIM_Try, /*On fail goto*//*Label 2341*/ GIMT_Encode4(120325), // Rule ID 1234 //
     /* 120303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasNEON),
     /* 120306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120318 */     // (fminnum:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (NEON_VMINNMNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 120318 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMINNMNQf),
     /* 120323 */     GIR_RootConstrainSelectedInstOperands,
     /* 120324 */     // GIR_Coverage, 1234,
     /* 120324 */     GIR_Done,
     /* 120325 */   // Label 2341: @120325
     /* 120325 */   GIM_Try, /*On fail goto*//*Label 2342*/ GIMT_Encode4(120386), // Rule ID 3288 //
     /* 120330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 120333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120337 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120345 */     // (fminnum:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)  =>  (MVE_VMINNMf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 120345 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 120348 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 120352 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMf32),
     /* 120360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120362 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 120364 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 120366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120369 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120375 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120381 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120384 */     GIR_RootConstrainSelectedInstOperands,
     /* 120385 */     // GIR_Coverage, 3288,
     /* 120385 */     GIR_EraseRootFromParent_Done,
     /* 120386 */   // Label 2342: @120386
     /* 120386 */   GIM_Reject,
     /* 120387 */ // Label 2339: @120387
     /* 120387 */ GIM_Reject,
     /* 120388 */ // Label 2332: @120388
     /* 120388 */ GIM_Try, /*On fail goto*//*Label 2343*/ GIMT_Encode4(120566),
     /* 120393 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 120396 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 120399 */   GIM_Try, /*On fail goto*//*Label 2344*/ GIMT_Encode4(120477), // Rule ID 4124 //
     /* 120404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 120407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 120423 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 120432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 120440 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120445 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 120447 */     // (fminnum:{ *:[v8f16] } (fabs:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd), (fabs:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm))  =>  (MVE_VMINNMAf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd, MQPR:{ *:[v8f16] }:$Qm)
     /* 120447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMAf16),
     /* 120450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qd
     /* 120456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Qm
     /* 120460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120463 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120469 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120475 */     GIR_RootConstrainSelectedInstOperands,
     /* 120476 */     // GIR_Coverage, 4124,
     /* 120476 */     GIR_EraseRootFromParent_Done,
     /* 120477 */   // Label 2344: @120477
     /* 120477 */   GIM_Try, /*On fail goto*//*Label 2345*/ GIMT_Encode4(120504), // Rule ID 1236 //
     /* 120482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasFullFP16_HasNEON),
     /* 120485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120489 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120497 */     // (fminnum:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (NEON_VMINNMNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 120497 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMINNMNQh),
     /* 120502 */     GIR_RootConstrainSelectedInstOperands,
     /* 120503 */     // GIR_Coverage, 1236,
     /* 120503 */     GIR_Done,
     /* 120504 */   // Label 2345: @120504
     /* 120504 */   GIM_Try, /*On fail goto*//*Label 2346*/ GIMT_Encode4(120565), // Rule ID 3291 //
     /* 120509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 120512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120524 */     // (fminnum:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)  =>  (MVE_VMINNMf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 120524 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 120527 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 120531 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMf16),
     /* 120539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120541 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 120543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 120545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120548 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120554 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120560 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120563 */     GIR_RootConstrainSelectedInstOperands,
     /* 120564 */     // GIR_Coverage, 3291,
     /* 120564 */     GIR_EraseRootFromParent_Done,
     /* 120565 */   // Label 2346: @120565
     /* 120565 */   GIM_Reject,
     /* 120566 */ // Label 2343: @120566
     /* 120566 */ GIM_Reject,
     /* 120567 */ // Label 2333: @120567
     /* 120567 */ GIM_Reject,
     /* 120568 */ // Label 48: @120568
     /* 120568 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2354*/ GIMT_Encode4(121159),
     /* 120579 */ /*GILLT_s16*//*Label 2347*/ GIMT_Encode4(120631),
     /* 120583 */ /*GILLT_s32*//*Label 2348*/ GIMT_Encode4(120665),
     /* 120587 */ /*GILLT_s64*//*Label 2349*/ GIMT_Encode4(120699), GIMT_Encode4(0),
     /* 120595 */ /*GILLT_v2s32*//*Label 2350*/ GIMT_Encode4(120733), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 120607 */ /*GILLT_v4s16*//*Label 2351*/ GIMT_Encode4(120767),
     /* 120611 */ /*GILLT_v4s32*//*Label 2352*/ GIMT_Encode4(120801), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 120627 */ /*GILLT_v8s16*//*Label 2353*/ GIMT_Encode4(120980),
     /* 120631 */ // Label 2347: @120631
     /* 120631 */ GIM_Try, /*On fail goto*//*Label 2355*/ GIMT_Encode4(120664), // Rule ID 639 //
     /* 120636 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 120639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 120642 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 120645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 120649 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 120653 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 120657 */   // (fmaxnum:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VFP_VMAXNMH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 120657 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMAXNMH),
     /* 120662 */   GIR_RootConstrainSelectedInstOperands,
     /* 120663 */   // GIR_Coverage, 639,
     /* 120663 */   GIR_Done,
     /* 120664 */ // Label 2355: @120664
     /* 120664 */ GIM_Reject,
     /* 120665 */ // Label 2348: @120665
     /* 120665 */ GIM_Try, /*On fail goto*//*Label 2356*/ GIMT_Encode4(120698), // Rule ID 640 //
     /* 120670 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 120673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 120676 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 120679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 120683 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 120687 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 120691 */   // (fmaxnum:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VFP_VMAXNMS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 120691 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMAXNMS),
     /* 120696 */   GIR_RootConstrainSelectedInstOperands,
     /* 120697 */   // GIR_Coverage, 640,
     /* 120697 */   GIR_Done,
     /* 120698 */ // Label 2356: @120698
     /* 120698 */ GIM_Reject,
     /* 120699 */ // Label 2349: @120699
     /* 120699 */ GIM_Try, /*On fail goto*//*Label 2357*/ GIMT_Encode4(120732), // Rule ID 641 //
     /* 120704 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 120707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 120710 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 120713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120717 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120721 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120725 */   // (fmaxnum:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VFP_VMAXNMD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 120725 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMAXNMD),
     /* 120730 */   GIR_RootConstrainSelectedInstOperands,
     /* 120731 */   // GIR_Coverage, 641,
     /* 120731 */   GIR_Done,
     /* 120732 */ // Label 2357: @120732
     /* 120732 */ GIM_Reject,
     /* 120733 */ // Label 2350: @120733
     /* 120733 */ GIM_Try, /*On fail goto*//*Label 2358*/ GIMT_Encode4(120766), // Rule ID 1213 //
     /* 120738 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasNEON),
     /* 120741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 120744 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 120747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120751 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120755 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120759 */   // (fmaxnum:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (NEON_VMAXNMNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 120759 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMAXNMNDf),
     /* 120764 */   GIR_RootConstrainSelectedInstOperands,
     /* 120765 */   // GIR_Coverage, 1213,
     /* 120765 */   GIR_Done,
     /* 120766 */ // Label 2358: @120766
     /* 120766 */ GIM_Reject,
     /* 120767 */ // Label 2351: @120767
     /* 120767 */ GIM_Try, /*On fail goto*//*Label 2359*/ GIMT_Encode4(120800), // Rule ID 1215 //
     /* 120772 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasFullFP16_HasNEON),
     /* 120775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 120778 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 120781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120785 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120789 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120793 */   // (fmaxnum:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (NEON_VMAXNMNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 120793 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMAXNMNDh),
     /* 120798 */   GIR_RootConstrainSelectedInstOperands,
     /* 120799 */   // GIR_Coverage, 1215,
     /* 120799 */   GIR_Done,
     /* 120800 */ // Label 2359: @120800
     /* 120800 */ GIM_Reject,
     /* 120801 */ // Label 2352: @120801
     /* 120801 */ GIM_Try, /*On fail goto*//*Label 2360*/ GIMT_Encode4(120979),
     /* 120806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 120809 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 120812 */   GIM_Try, /*On fail goto*//*Label 2361*/ GIMT_Encode4(120890), // Rule ID 4118 //
     /* 120817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 120820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 120836 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120841 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 120845 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120849 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 120853 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120858 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 120860 */     // (fmaxnum:{ *:[v4f32] } (fabs:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qd), (fabs:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm))  =>  (MVE_VMAXNMAf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qd, MQPR:{ *:[v4f32] }:$Qm)
     /* 120860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMAf32),
     /* 120863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qd
     /* 120869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Qm
     /* 120873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120876 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120882 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120888 */     GIR_RootConstrainSelectedInstOperands,
     /* 120889 */     // GIR_Coverage, 4118,
     /* 120889 */     GIR_EraseRootFromParent_Done,
     /* 120890 */   // Label 2361: @120890
     /* 120890 */   GIM_Try, /*On fail goto*//*Label 2362*/ GIMT_Encode4(120917), // Rule ID 1214 //
     /* 120895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasNEON),
     /* 120898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120910 */     // (fmaxnum:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (NEON_VMAXNMNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 120910 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMAXNMNQf),
     /* 120915 */     GIR_RootConstrainSelectedInstOperands,
     /* 120916 */     // GIR_Coverage, 1214,
     /* 120916 */     GIR_Done,
     /* 120917 */   // Label 2362: @120917
     /* 120917 */   GIM_Try, /*On fail goto*//*Label 2363*/ GIMT_Encode4(120978), // Rule ID 3030 //
     /* 120922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 120925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120937 */     // (fmaxnum:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)  =>  (MVE_VMAXNMf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 120937 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 120940 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 120944 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMf32),
     /* 120952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120954 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 120956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 120958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120961 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120967 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120973 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120976 */     GIR_RootConstrainSelectedInstOperands,
     /* 120977 */     // GIR_Coverage, 3030,
     /* 120977 */     GIR_EraseRootFromParent_Done,
     /* 120978 */   // Label 2363: @120978
     /* 120978 */   GIM_Reject,
     /* 120979 */ // Label 2360: @120979
     /* 120979 */ GIM_Reject,
     /* 120980 */ // Label 2353: @120980
     /* 120980 */ GIM_Try, /*On fail goto*//*Label 2364*/ GIMT_Encode4(121158),
     /* 120985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 120988 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 120991 */   GIM_Try, /*On fail goto*//*Label 2365*/ GIMT_Encode4(121069), // Rule ID 4120 //
     /* 120996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 120999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 121003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 121011 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 121015 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 121020 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 121024 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 121028 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 121032 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 121037 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 121039 */     // (fmaxnum:{ *:[v8f16] } (fabs:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd), (fabs:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm))  =>  (MVE_VMAXNMAf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd, MQPR:{ *:[v8f16] }:$Qm)
     /* 121039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMAf16),
     /* 121042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 121044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qd
     /* 121048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Qm
     /* 121052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121055 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121061 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121067 */     GIR_RootConstrainSelectedInstOperands,
     /* 121068 */     // GIR_Coverage, 4120,
     /* 121068 */     GIR_EraseRootFromParent_Done,
     /* 121069 */   // Label 2365: @121069
     /* 121069 */   GIM_Try, /*On fail goto*//*Label 2366*/ GIMT_Encode4(121096), // Rule ID 1216 //
     /* 121074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasFullFP16_HasNEON),
     /* 121077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121089 */     // (fmaxnum:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (NEON_VMAXNMNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 121089 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMAXNMNQh),
     /* 121094 */     GIR_RootConstrainSelectedInstOperands,
     /* 121095 */     // GIR_Coverage, 1216,
     /* 121095 */     GIR_Done,
     /* 121096 */   // Label 2366: @121096
     /* 121096 */   GIM_Try, /*On fail goto*//*Label 2367*/ GIMT_Encode4(121157), // Rule ID 3285 //
     /* 121101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 121104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 121108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 121112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 121116 */     // (fmaxnum:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)  =>  (MVE_VMAXNMf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 121116 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 121119 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121123 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMf16),
     /* 121131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 121133 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 121135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 121137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121140 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121146 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121152 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121155 */     GIR_RootConstrainSelectedInstOperands,
     /* 121156 */     // GIR_Coverage, 3285,
     /* 121156 */     GIR_EraseRootFromParent_Done,
     /* 121157 */   // Label 2367: @121157
     /* 121157 */   GIM_Reject,
     /* 121158 */ // Label 2364: @121158
     /* 121158 */ GIM_Reject,
     /* 121159 */ // Label 2354: @121159
     /* 121159 */ GIM_Reject,
     /* 121160 */ // Label 49: @121160
     /* 121160 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2374*/ GIMT_Encode4(121893),
     /* 121171 */ /*GILLT_s16*//*Label 2368*/ GIMT_Encode4(121223),
     /* 121175 */ /*GILLT_s32*//*Label 2369*/ GIMT_Encode4(121464), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 121187 */ /*GILLT_v2s32*//*Label 2370*/ GIMT_Encode4(121705), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 121199 */ /*GILLT_v4s16*//*Label 2371*/ GIMT_Encode4(121752),
     /* 121203 */ /*GILLT_v4s32*//*Label 2372*/ GIMT_Encode4(121799), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 121219 */ /*GILLT_v8s16*//*Label 2373*/ GIMT_Encode4(121846),
     /* 121223 */ // Label 2368: @121223
     /* 121223 */ GIM_Try, /*On fail goto*//*Label 2375*/ GIMT_Encode4(121463), // Rule ID 2707 //
     /* 121228 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 121231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 121234 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 121237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 121241 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 121245 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 121249 */   // (fminimum:{ *:[f16] } HPR:{ *:[f16] }:$a, HPR:{ *:[f16] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (VMINhd:{ *:[f64] } (INSERT_SUBREG:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), DPR_VFP2:{ *:[i32] }), HPR:{ *:[f16] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), DPR_VFP2:{ *:[i32] }), HPR:{ *:[f16] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 121249 */   GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 121252 */   GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121256 */   GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121261 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 121263 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s16,
     /* 121266 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121270 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121275 */   GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 121278 */   GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121283 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 121286 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121290 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121295 */   GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 121298 */   GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 121302 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 121305 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121310 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121315 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::HPRRegClassID),
     /* 121320 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s16,
     /* 121323 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121327 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121332 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 121334 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s16,
     /* 121337 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121341 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121346 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 121349 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121354 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 121357 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121361 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121366 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 121369 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 121373 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 121376 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121381 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121386 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::HPRRegClassID),
     /* 121391 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 121394 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMINhd),
     /* 121398 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121403 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 121406 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 121409 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 121412 */   GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121418 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121420 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 121423 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121427 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121432 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 121435 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121440 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121443 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121445 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 121452 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 121457 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121462 */   // GIR_Coverage, 2707,
     /* 121462 */   GIR_EraseRootFromParent_Done,
     /* 121463 */ // Label 2375: @121463
     /* 121463 */ GIM_Reject,
     /* 121464 */ // Label 2369: @121464
     /* 121464 */ GIM_Try, /*On fail goto*//*Label 2376*/ GIMT_Encode4(121704), // Rule ID 2709 //
     /* 121469 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 121472 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 121475 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 121478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 121482 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 121486 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 121490 */   // (fminimum:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMINfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 121490 */   GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 121493 */   GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121497 */   GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121502 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 121504 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 121507 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121511 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121516 */   GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 121519 */   GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121524 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 121527 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121531 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121536 */   GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 121539 */   GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 121543 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 121546 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121551 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121556 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 121561 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 121564 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121568 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121573 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 121575 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 121578 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121582 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121587 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 121590 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121595 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 121598 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121602 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121607 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 121610 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 121614 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 121617 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121622 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121627 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 121632 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 121635 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMINfd),
     /* 121639 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121644 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 121647 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 121650 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 121653 */   GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121659 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121661 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 121664 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121668 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121673 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 121676 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121681 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121684 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121686 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 121693 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 121698 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121703 */   // GIR_Coverage, 2709,
     /* 121703 */   GIR_EraseRootFromParent_Done,
     /* 121704 */ // Label 2376: @121704
     /* 121704 */ GIM_Reject,
     /* 121705 */ // Label 2370: @121705
     /* 121705 */ GIM_Try, /*On fail goto*//*Label 2377*/ GIMT_Encode4(121751), // Rule ID 1229 //
     /* 121710 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 121713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 121716 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 121719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121723 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121727 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121731 */   // (fminimum:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VMINfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 121731 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINfd),
     /* 121734 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 121736 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 121738 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 121740 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 121743 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121749 */   GIR_RootConstrainSelectedInstOperands,
     /* 121750 */   // GIR_Coverage, 1229,
     /* 121750 */   GIR_EraseRootFromParent_Done,
     /* 121751 */ // Label 2377: @121751
     /* 121751 */ GIM_Reject,
     /* 121752 */ // Label 2371: @121752
     /* 121752 */ GIM_Try, /*On fail goto*//*Label 2378*/ GIMT_Encode4(121798), // Rule ID 1231 //
     /* 121757 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 121760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 121763 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 121766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121770 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121774 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121778 */   // (fminimum:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VMINhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 121778 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINhd),
     /* 121781 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 121783 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 121785 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 121787 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 121790 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121796 */   GIR_RootConstrainSelectedInstOperands,
     /* 121797 */   // GIR_Coverage, 1231,
     /* 121797 */   GIR_EraseRootFromParent_Done,
     /* 121798 */ // Label 2378: @121798
     /* 121798 */ GIM_Reject,
     /* 121799 */ // Label 2372: @121799
     /* 121799 */ GIM_Try, /*On fail goto*//*Label 2379*/ GIMT_Encode4(121845), // Rule ID 1230 //
     /* 121804 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 121807 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 121810 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 121813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121817 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121821 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121825 */   // (fminimum:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VMINfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 121825 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINfq),
     /* 121828 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 121830 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 121832 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 121834 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 121837 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121843 */   GIR_RootConstrainSelectedInstOperands,
     /* 121844 */   // GIR_Coverage, 1230,
     /* 121844 */   GIR_EraseRootFromParent_Done,
     /* 121845 */ // Label 2379: @121845
     /* 121845 */ GIM_Reject,
     /* 121846 */ // Label 2373: @121846
     /* 121846 */ GIM_Try, /*On fail goto*//*Label 2380*/ GIMT_Encode4(121892), // Rule ID 1232 //
     /* 121851 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 121854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 121857 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 121860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121864 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121868 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121872 */   // (fminimum:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VMINhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 121872 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINhq),
     /* 121875 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 121877 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 121879 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 121881 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 121884 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121890 */   GIR_RootConstrainSelectedInstOperands,
     /* 121891 */   // GIR_Coverage, 1232,
     /* 121891 */   GIR_EraseRootFromParent_Done,
     /* 121892 */ // Label 2380: @121892
     /* 121892 */ GIM_Reject,
     /* 121893 */ // Label 2374: @121893
     /* 121893 */ GIM_Reject,
     /* 121894 */ // Label 50: @121894
     /* 121894 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2387*/ GIMT_Encode4(122627),
     /* 121905 */ /*GILLT_s16*//*Label 2381*/ GIMT_Encode4(121957),
     /* 121909 */ /*GILLT_s32*//*Label 2382*/ GIMT_Encode4(122198), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 121921 */ /*GILLT_v2s32*//*Label 2383*/ GIMT_Encode4(122439), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 121933 */ /*GILLT_v4s16*//*Label 2384*/ GIMT_Encode4(122486),
     /* 121937 */ /*GILLT_v4s32*//*Label 2385*/ GIMT_Encode4(122533), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 121953 */ /*GILLT_v8s16*//*Label 2386*/ GIMT_Encode4(122580),
     /* 121957 */ // Label 2381: @121957
     /* 121957 */ GIM_Try, /*On fail goto*//*Label 2388*/ GIMT_Encode4(122197), // Rule ID 2706 //
     /* 121962 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 121965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 121968 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 121971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 121975 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 121979 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 121983 */   // (fmaximum:{ *:[f16] } HPR:{ *:[f16] }:$a, HPR:{ *:[f16] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (VMAXhd:{ *:[f64] } (INSERT_SUBREG:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), DPR_VFP2:{ *:[i32] }), HPR:{ *:[f16] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), DPR_VFP2:{ *:[i32] }), HPR:{ *:[f16] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 121983 */   GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 121986 */   GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121990 */   GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121995 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 121997 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s16,
     /* 122000 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122004 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122009 */   GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 122012 */   GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122017 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 122020 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 122024 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122029 */   GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 122032 */   GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 122036 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 122039 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122044 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122049 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::HPRRegClassID),
     /* 122054 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s16,
     /* 122057 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 122061 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122066 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 122068 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s16,
     /* 122071 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122075 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122080 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 122083 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122088 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 122091 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 122095 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122100 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 122103 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 122107 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 122110 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122115 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122120 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::HPRRegClassID),
     /* 122125 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 122128 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMAXhd),
     /* 122132 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122137 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 122140 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 122143 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 122146 */   GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122152 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122154 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 122157 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122161 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122166 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 122169 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122174 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122177 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122179 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 122186 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 122191 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122196 */   // GIR_Coverage, 2706,
     /* 122196 */   GIR_EraseRootFromParent_Done,
     /* 122197 */ // Label 2388: @122197
     /* 122197 */ GIM_Reject,
     /* 122198 */ // Label 2382: @122198
     /* 122198 */ GIM_Try, /*On fail goto*//*Label 2389*/ GIMT_Encode4(122438), // Rule ID 2708 //
     /* 122203 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 122206 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 122209 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 122212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 122216 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 122220 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 122224 */   // (fmaximum:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMAXfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 122224 */   GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 122227 */   GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 122231 */   GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122236 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 122238 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 122241 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122245 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122250 */   GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 122253 */   GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122258 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 122261 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 122265 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122270 */   GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 122273 */   GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 122277 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 122280 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122285 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122290 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 122295 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 122298 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 122302 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122307 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 122309 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 122312 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122316 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122321 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 122324 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122329 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 122332 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 122336 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122341 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 122344 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 122348 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 122351 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122356 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122361 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 122366 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 122369 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMAXfd),
     /* 122373 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122378 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 122381 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 122384 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 122387 */   GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122393 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122395 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 122398 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122402 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122407 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 122410 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122415 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122418 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122420 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 122427 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 122432 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122437 */   // GIR_Coverage, 2708,
     /* 122437 */   GIR_EraseRootFromParent_Done,
     /* 122438 */ // Label 2389: @122438
     /* 122438 */ GIM_Reject,
     /* 122439 */ // Label 2383: @122439
     /* 122439 */ GIM_Try, /*On fail goto*//*Label 2390*/ GIMT_Encode4(122485), // Rule ID 1209 //
     /* 122444 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 122447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 122450 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 122453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122457 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122461 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122465 */   // (fmaximum:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VMAXfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 122465 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXfd),
     /* 122468 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122470 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122472 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122474 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122477 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122483 */   GIR_RootConstrainSelectedInstOperands,
     /* 122484 */   // GIR_Coverage, 1209,
     /* 122484 */   GIR_EraseRootFromParent_Done,
     /* 122485 */ // Label 2390: @122485
     /* 122485 */ GIM_Reject,
     /* 122486 */ // Label 2384: @122486
     /* 122486 */ GIM_Try, /*On fail goto*//*Label 2391*/ GIMT_Encode4(122532), // Rule ID 1211 //
     /* 122491 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 122494 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 122497 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 122500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122504 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122508 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122512 */   // (fmaximum:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VMAXhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 122512 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXhd),
     /* 122515 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122517 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122519 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122521 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122524 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122530 */   GIR_RootConstrainSelectedInstOperands,
     /* 122531 */   // GIR_Coverage, 1211,
     /* 122531 */   GIR_EraseRootFromParent_Done,
     /* 122532 */ // Label 2391: @122532
     /* 122532 */ GIM_Reject,
     /* 122533 */ // Label 2385: @122533
     /* 122533 */ GIM_Try, /*On fail goto*//*Label 2392*/ GIMT_Encode4(122579), // Rule ID 1210 //
     /* 122538 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 122541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 122544 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 122547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122551 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122555 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122559 */   // (fmaximum:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VMAXfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 122559 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXfq),
     /* 122562 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122564 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122566 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122568 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122571 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122577 */   GIR_RootConstrainSelectedInstOperands,
     /* 122578 */   // GIR_Coverage, 1210,
     /* 122578 */   GIR_EraseRootFromParent_Done,
     /* 122579 */ // Label 2392: @122579
     /* 122579 */ GIM_Reject,
     /* 122580 */ // Label 2386: @122580
     /* 122580 */ GIM_Try, /*On fail goto*//*Label 2393*/ GIMT_Encode4(122626), // Rule ID 1212 //
     /* 122585 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 122588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 122591 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 122594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122598 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122602 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122606 */   // (fmaximum:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VMAXhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 122606 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXhq),
     /* 122609 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122611 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122613 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122615 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122618 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122624 */   GIR_RootConstrainSelectedInstOperands,
     /* 122625 */   // GIR_Coverage, 1212,
     /* 122625 */   GIR_EraseRootFromParent_Done,
     /* 122626 */ // Label 2393: @122626
     /* 122626 */ GIM_Reject,
     /* 122627 */ // Label 2387: @122627
     /* 122627 */ GIM_Reject,
     /* 122628 */ // Label 51: @122628
     /* 122628 */ GIM_Try, /*On fail goto*//*Label 2394*/ GIMT_Encode4(122660), // Rule ID 2419 //
     /* 122633 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 122636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 122640 */   // (get_fpenv:{ *:[i32] })  =>  (VMRS:{ *:[i32] })
     /* 122640 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMRS),
     /* 122643 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122645 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122648 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122654 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122658 */   GIR_RootConstrainSelectedInstOperands,
     /* 122659 */   // GIR_Coverage, 2419,
     /* 122659 */   GIR_EraseRootFromParent_Done,
     /* 122660 */ // Label 2394: @122660
     /* 122660 */ GIM_Reject,
     /* 122661 */ // Label 52: @122661
     /* 122661 */ GIM_Try, /*On fail goto*//*Label 2395*/ GIMT_Encode4(122696), // Rule ID 2420 //
     /* 122666 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 122669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 122673 */   // (set_fpenv GPRnopc:{ *:[i32] }:$Rt)  =>  (VMSR:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rt)
     /* 122673 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMSR),
     /* 122676 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122678 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122681 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122687 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for ARM::FPSCR*/0,
     /* 122690 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122694 */   GIR_RootConstrainSelectedInstOperands,
     /* 122695 */   // GIR_Coverage, 2420,
     /* 122695 */   GIR_EraseRootFromParent_Done,
     /* 122696 */ // Label 2395: @122696
     /* 122696 */ GIM_Reject,
     /* 122697 */ // Label 53: @122697
     /* 122697 */ GIM_Try, /*On fail goto*//*Label 2396*/ GIMT_Encode4(122761), // Rule ID 2421 //
     /* 122702 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /* 122705 */   // (reset_fpenv)  =>  (VMSR:{ *:[i32] } (MOVi:{ *:[i32] } 0:{ *:[i32] }))
     /* 122705 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122708 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MOVi),
     /* 122712 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122717 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 122720 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 122723 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122729 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122735 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 122737 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMSR),
     /* 122740 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122743 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122746 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122752 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for ARM::FPSCR*/0,
     /* 122755 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122759 */   GIR_RootConstrainSelectedInstOperands,
     /* 122760 */   // GIR_Coverage, 2421,
     /* 122760 */   GIR_EraseRootFromParent_Done,
     /* 122761 */ // Label 2396: @122761
     /* 122761 */ GIM_Try, /*On fail goto*//*Label 2397*/ GIMT_Encode4(122825), // Rule ID 2422 //
     /* 122766 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb),
     /* 122769 */   // (reset_fpenv)  =>  (VMSR:{ *:[i32] } (tMOVi8:{ *:[i32] } 0:{ *:[i32] }))
     /* 122769 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122772 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::tMOVi8),
     /* 122776 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122781 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 122787 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 122790 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 122793 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122799 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 122801 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMSR),
     /* 122804 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122807 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122810 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122816 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for ARM::FPSCR*/0,
     /* 122819 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122823 */   GIR_RootConstrainSelectedInstOperands,
     /* 122824 */   // GIR_Coverage, 2422,
     /* 122824 */   GIR_EraseRootFromParent_Done,
     /* 122825 */ // Label 2397: @122825
     /* 122825 */ GIM_Reject,
     /* 122826 */ // Label 54: @122826
     /* 122826 */ GIM_Try, /*On fail goto*//*Label 2398*/ GIMT_Encode4(122858), // Rule ID 2423 //
     /* 122831 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 122834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 122838 */   // (get_fpmode:{ *:[i32] })  =>  (VMRS:{ *:[i32] })
     /* 122838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMRS),
     /* 122841 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122843 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122846 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122852 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122856 */   GIR_RootConstrainSelectedInstOperands,
     /* 122857 */   // GIR_Coverage, 2423,
     /* 122857 */   GIR_EraseRootFromParent_Done,
     /* 122858 */ // Label 2398: @122858
     /* 122858 */ GIM_Reject,
     /* 122859 */ // Label 55: @122859
     /* 122859 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 2405*/ GIMT_Encode4(123401),
     /* 122870 */ /*GILLT_v2s32*//*Label 2399*/ GIMT_Encode4(122918), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 122882 */ /*GILLT_v4s16*//*Label 2400*/ GIMT_Encode4(122965),
     /* 122886 */ /*GILLT_v4s32*//*Label 2401*/ GIMT_Encode4(123012), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 122898 */ /*GILLT_v8s8*//*Label 2402*/ GIMT_Encode4(123126),
     /* 122902 */ /*GILLT_v8s16*//*Label 2403*/ GIMT_Encode4(123173), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 122914 */ /*GILLT_v16s8*//*Label 2404*/ GIMT_Encode4(123287),
     /* 122918 */ // Label 2399: @122918
     /* 122918 */ GIM_Try, /*On fail goto*//*Label 2406*/ GIMT_Encode4(122964), // Rule ID 1218 //
     /* 122923 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 122926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 122929 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 122932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122936 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122940 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122944 */   // (smin:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VMINsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 122944 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv2i32),
     /* 122947 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122949 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122951 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122953 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122956 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122962 */   GIR_RootConstrainSelectedInstOperands,
     /* 122963 */   // GIR_Coverage, 1218,
     /* 122963 */   GIR_EraseRootFromParent_Done,
     /* 122964 */ // Label 2406: @122964
     /* 122964 */ GIM_Reject,
     /* 122965 */ // Label 2400: @122965
     /* 122965 */ GIM_Try, /*On fail goto*//*Label 2407*/ GIMT_Encode4(123011), // Rule ID 1217 //
     /* 122970 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 122973 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 122976 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 122979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122983 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122987 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122991 */   // (smin:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VMINsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 122991 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv4i16),
     /* 122994 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122996 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122998 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123000 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123003 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123009 */   GIR_RootConstrainSelectedInstOperands,
     /* 123010 */   // GIR_Coverage, 1217,
     /* 123010 */   GIR_EraseRootFromParent_Done,
     /* 123011 */ // Label 2407: @123011
     /* 123011 */ GIM_Reject,
     /* 123012 */ // Label 2401: @123012
     /* 123012 */ GIM_Try, /*On fail goto*//*Label 2408*/ GIMT_Encode4(123125),
     /* 123017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 123020 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 123023 */   GIM_Try, /*On fail goto*//*Label 2409*/ GIMT_Encode4(123063), // Rule ID 1220 //
     /* 123028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123035 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123043 */     // (smin:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VMINsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 123043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv4i32),
     /* 123046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123048 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123055 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123061 */     GIR_RootConstrainSelectedInstOperands,
     /* 123062 */     // GIR_Coverage, 1220,
     /* 123062 */     GIR_EraseRootFromParent_Done,
     /* 123063 */   // Label 2409: @123063
     /* 123063 */   GIM_Try, /*On fail goto*//*Label 2410*/ GIMT_Encode4(123124), // Rule ID 3300 //
     /* 123068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123075 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123083 */     // (smin:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMINs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 123083 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 123086 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 123090 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINs32),
     /* 123098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123100 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 123102 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 123104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123107 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123113 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123119 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123122 */     GIR_RootConstrainSelectedInstOperands,
     /* 123123 */     // GIR_Coverage, 3300,
     /* 123123 */     GIR_EraseRootFromParent_Done,
     /* 123124 */   // Label 2410: @123124
     /* 123124 */   GIM_Reject,
     /* 123125 */ // Label 2408: @123125
     /* 123125 */ GIM_Reject,
     /* 123126 */ // Label 2402: @123126
     /* 123126 */ GIM_Try, /*On fail goto*//*Label 2411*/ GIMT_Encode4(123172), // Rule ID 1221 //
     /* 123131 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123134 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 123137 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 123140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123144 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123148 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123152 */   // (smin:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMINsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 123152 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv8i8),
     /* 123155 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123157 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123159 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123161 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123164 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123170 */   GIR_RootConstrainSelectedInstOperands,
     /* 123171 */   // GIR_Coverage, 1221,
     /* 123171 */   GIR_EraseRootFromParent_Done,
     /* 123172 */ // Label 2411: @123172
     /* 123172 */ GIM_Reject,
     /* 123173 */ // Label 2403: @123173
     /* 123173 */ GIM_Try, /*On fail goto*//*Label 2412*/ GIMT_Encode4(123286),
     /* 123178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 123181 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 123184 */   GIM_Try, /*On fail goto*//*Label 2413*/ GIMT_Encode4(123224), // Rule ID 1219 //
     /* 123189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123196 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123204 */     // (smin:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VMINsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 123204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv8i16),
     /* 123207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123209 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123216 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123222 */     GIR_RootConstrainSelectedInstOperands,
     /* 123223 */     // GIR_Coverage, 1219,
     /* 123223 */     GIR_EraseRootFromParent_Done,
     /* 123224 */   // Label 2413: @123224
     /* 123224 */   GIM_Try, /*On fail goto*//*Label 2414*/ GIMT_Encode4(123285), // Rule ID 3297 //
     /* 123229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123236 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123244 */     // (smin:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMINs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 123244 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 123247 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 123251 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINs16),
     /* 123259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123261 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 123263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 123265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123268 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123274 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123283 */     GIR_RootConstrainSelectedInstOperands,
     /* 123284 */     // GIR_Coverage, 3297,
     /* 123284 */     GIR_EraseRootFromParent_Done,
     /* 123285 */   // Label 2414: @123285
     /* 123285 */   GIM_Reject,
     /* 123286 */ // Label 2412: @123286
     /* 123286 */ GIM_Reject,
     /* 123287 */ // Label 2404: @123287
     /* 123287 */ GIM_Try, /*On fail goto*//*Label 2415*/ GIMT_Encode4(123400),
     /* 123292 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 123295 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 123298 */   GIM_Try, /*On fail goto*//*Label 2416*/ GIMT_Encode4(123338), // Rule ID 1222 //
     /* 123303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123318 */     // (smin:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMINsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 123318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv16i8),
     /* 123321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123323 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123330 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123336 */     GIR_RootConstrainSelectedInstOperands,
     /* 123337 */     // GIR_Coverage, 1222,
     /* 123337 */     GIR_EraseRootFromParent_Done,
     /* 123338 */   // Label 2416: @123338
     /* 123338 */   GIM_Try, /*On fail goto*//*Label 2417*/ GIMT_Encode4(123399), // Rule ID 3294 //
     /* 123343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123350 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123358 */     // (smin:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMINs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 123358 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 123361 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 123365 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINs8),
     /* 123373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123375 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 123377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 123379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123382 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123388 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123394 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123397 */     GIR_RootConstrainSelectedInstOperands,
     /* 123398 */     // GIR_Coverage, 3294,
     /* 123398 */     GIR_EraseRootFromParent_Done,
     /* 123399 */   // Label 2417: @123399
     /* 123399 */   GIM_Reject,
     /* 123400 */ // Label 2415: @123400
     /* 123400 */ GIM_Reject,
     /* 123401 */ // Label 2405: @123401
     /* 123401 */ GIM_Reject,
     /* 123402 */ // Label 56: @123402
     /* 123402 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 2424*/ GIMT_Encode4(123944),
     /* 123413 */ /*GILLT_v2s32*//*Label 2418*/ GIMT_Encode4(123461), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123425 */ /*GILLT_v4s16*//*Label 2419*/ GIMT_Encode4(123508),
     /* 123429 */ /*GILLT_v4s32*//*Label 2420*/ GIMT_Encode4(123555), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123441 */ /*GILLT_v8s8*//*Label 2421*/ GIMT_Encode4(123669),
     /* 123445 */ /*GILLT_v8s16*//*Label 2422*/ GIMT_Encode4(123716), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123457 */ /*GILLT_v16s8*//*Label 2423*/ GIMT_Encode4(123830),
     /* 123461 */ // Label 2418: @123461
     /* 123461 */ GIM_Try, /*On fail goto*//*Label 2425*/ GIMT_Encode4(123507), // Rule ID 1198 //
     /* 123466 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123469 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 123472 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 123475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123479 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123483 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123487 */   // (smax:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VMAXsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 123487 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv2i32),
     /* 123490 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123492 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123494 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123496 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123499 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123505 */   GIR_RootConstrainSelectedInstOperands,
     /* 123506 */   // GIR_Coverage, 1198,
     /* 123506 */   GIR_EraseRootFromParent_Done,
     /* 123507 */ // Label 2425: @123507
     /* 123507 */ GIM_Reject,
     /* 123508 */ // Label 2419: @123508
     /* 123508 */ GIM_Try, /*On fail goto*//*Label 2426*/ GIMT_Encode4(123554), // Rule ID 1197 //
     /* 123513 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 123519 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 123522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123530 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123534 */   // (smax:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VMAXsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 123534 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv4i16),
     /* 123537 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123539 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123541 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123543 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123546 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123552 */   GIR_RootConstrainSelectedInstOperands,
     /* 123553 */   // GIR_Coverage, 1197,
     /* 123553 */   GIR_EraseRootFromParent_Done,
     /* 123554 */ // Label 2426: @123554
     /* 123554 */ GIM_Reject,
     /* 123555 */ // Label 2420: @123555
     /* 123555 */ GIM_Try, /*On fail goto*//*Label 2427*/ GIMT_Encode4(123668),
     /* 123560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 123563 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 123566 */   GIM_Try, /*On fail goto*//*Label 2428*/ GIMT_Encode4(123606), // Rule ID 1200 //
     /* 123571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123586 */     // (smax:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VMAXsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 123586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv4i32),
     /* 123589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123591 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123598 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123604 */     GIR_RootConstrainSelectedInstOperands,
     /* 123605 */     // GIR_Coverage, 1200,
     /* 123605 */     GIR_EraseRootFromParent_Done,
     /* 123606 */   // Label 2428: @123606
     /* 123606 */   GIM_Try, /*On fail goto*//*Label 2429*/ GIMT_Encode4(123667), // Rule ID 3318 //
     /* 123611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123626 */     // (smax:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMAXs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 123626 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 123629 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 123633 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXs32),
     /* 123641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123643 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 123645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 123647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123650 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123656 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123662 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123665 */     GIR_RootConstrainSelectedInstOperands,
     /* 123666 */     // GIR_Coverage, 3318,
     /* 123666 */     GIR_EraseRootFromParent_Done,
     /* 123667 */   // Label 2429: @123667
     /* 123667 */   GIM_Reject,
     /* 123668 */ // Label 2427: @123668
     /* 123668 */ GIM_Reject,
     /* 123669 */ // Label 2421: @123669
     /* 123669 */ GIM_Try, /*On fail goto*//*Label 2430*/ GIMT_Encode4(123715), // Rule ID 1201 //
     /* 123674 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 123680 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 123683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123687 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123691 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123695 */   // (smax:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMAXsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 123695 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv8i8),
     /* 123698 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123700 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123702 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123704 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123707 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123713 */   GIR_RootConstrainSelectedInstOperands,
     /* 123714 */   // GIR_Coverage, 1201,
     /* 123714 */   GIR_EraseRootFromParent_Done,
     /* 123715 */ // Label 2430: @123715
     /* 123715 */ GIM_Reject,
     /* 123716 */ // Label 2422: @123716
     /* 123716 */ GIM_Try, /*On fail goto*//*Label 2431*/ GIMT_Encode4(123829),
     /* 123721 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 123724 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 123727 */   GIM_Try, /*On fail goto*//*Label 2432*/ GIMT_Encode4(123767), // Rule ID 1199 //
     /* 123732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123739 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123747 */     // (smax:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VMAXsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 123747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv8i16),
     /* 123750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123752 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123759 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123765 */     GIR_RootConstrainSelectedInstOperands,
     /* 123766 */     // GIR_Coverage, 1199,
     /* 123766 */     GIR_EraseRootFromParent_Done,
     /* 123767 */   // Label 2432: @123767
     /* 123767 */   GIM_Try, /*On fail goto*//*Label 2433*/ GIMT_Encode4(123828), // Rule ID 3315 //
     /* 123772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123787 */     // (smax:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMAXs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 123787 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 123790 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 123794 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXs16),
     /* 123802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123804 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 123806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 123808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123811 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123817 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123826 */     GIR_RootConstrainSelectedInstOperands,
     /* 123827 */     // GIR_Coverage, 3315,
     /* 123827 */     GIR_EraseRootFromParent_Done,
     /* 123828 */   // Label 2433: @123828
     /* 123828 */   GIM_Reject,
     /* 123829 */ // Label 2431: @123829
     /* 123829 */ GIM_Reject,
     /* 123830 */ // Label 2423: @123830
     /* 123830 */ GIM_Try, /*On fail goto*//*Label 2434*/ GIMT_Encode4(123943),
     /* 123835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 123838 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 123841 */   GIM_Try, /*On fail goto*//*Label 2435*/ GIMT_Encode4(123881), // Rule ID 1202 //
     /* 123846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123861 */     // (smax:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMAXsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 123861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv16i8),
     /* 123864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123866 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123868 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123873 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123879 */     GIR_RootConstrainSelectedInstOperands,
     /* 123880 */     // GIR_Coverage, 1202,
     /* 123880 */     GIR_EraseRootFromParent_Done,
     /* 123881 */   // Label 2435: @123881
     /* 123881 */   GIM_Try, /*On fail goto*//*Label 2436*/ GIMT_Encode4(123942), // Rule ID 3312 //
     /* 123886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123893 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123901 */     // (smax:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMAXs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 123901 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 123904 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 123908 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXs8),
     /* 123916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123918 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 123920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 123922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123925 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123931 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123937 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123940 */     GIR_RootConstrainSelectedInstOperands,
     /* 123941 */     // GIR_Coverage, 3312,
     /* 123941 */     GIR_EraseRootFromParent_Done,
     /* 123942 */   // Label 2436: @123942
     /* 123942 */   GIM_Reject,
     /* 123943 */ // Label 2434: @123943
     /* 123943 */ GIM_Reject,
     /* 123944 */ // Label 2424: @123944
     /* 123944 */ GIM_Reject,
     /* 123945 */ // Label 57: @123945
     /* 123945 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 2443*/ GIMT_Encode4(124865),
     /* 123956 */ /*GILLT_v2s32*//*Label 2437*/ GIMT_Encode4(124004), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123968 */ /*GILLT_v4s16*//*Label 2438*/ GIMT_Encode4(124051),
     /* 123972 */ /*GILLT_v4s32*//*Label 2439*/ GIMT_Encode4(124098), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123984 */ /*GILLT_v8s8*//*Label 2440*/ GIMT_Encode4(124338),
     /* 123988 */ /*GILLT_v8s16*//*Label 2441*/ GIMT_Encode4(124385), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 124000 */ /*GILLT_v16s8*//*Label 2442*/ GIMT_Encode4(124625),
     /* 124004 */ // Label 2437: @124004
     /* 124004 */ GIM_Try, /*On fail goto*//*Label 2444*/ GIMT_Encode4(124050), // Rule ID 1224 //
     /* 124009 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 124015 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 124018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124022 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124026 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124030 */   // (umin:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VMINuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 124030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv2i32),
     /* 124033 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124035 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124037 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124039 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124042 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124048 */   GIR_RootConstrainSelectedInstOperands,
     /* 124049 */   // GIR_Coverage, 1224,
     /* 124049 */   GIR_EraseRootFromParent_Done,
     /* 124050 */ // Label 2444: @124050
     /* 124050 */ GIM_Reject,
     /* 124051 */ // Label 2438: @124051
     /* 124051 */ GIM_Try, /*On fail goto*//*Label 2445*/ GIMT_Encode4(124097), // Rule ID 1223 //
     /* 124056 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 124062 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 124065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124069 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124073 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124077 */   // (umin:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VMINuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 124077 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv4i16),
     /* 124080 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124082 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124084 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124086 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124089 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124095 */   GIR_RootConstrainSelectedInstOperands,
     /* 124096 */   // GIR_Coverage, 1223,
     /* 124096 */   GIR_EraseRootFromParent_Done,
     /* 124097 */ // Label 2445: @124097
     /* 124097 */ GIM_Reject,
     /* 124098 */ // Label 2439: @124098
     /* 124098 */ GIM_Try, /*On fail goto*//*Label 2446*/ GIMT_Encode4(124337),
     /* 124103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 124106 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 124109 */   GIM_Try, /*On fail goto*//*Label 2447*/ GIMT_Encode4(124172), // Rule ID 6027 //
     /* 124114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 124133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124144 */     // (umin:{ *:[v4i32] } (abs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm), MQPR:{ *:[v4i32] }:$Qd)  =>  (MVE_VMINAs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, MQPR:{ *:[v4i32] }:$Qm)
     /* 124144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs32),
     /* 124147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 124151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124158 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124164 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124170 */     GIR_RootConstrainSelectedInstOperands,
     /* 124171 */     // GIR_Coverage, 6027,
     /* 124171 */     GIR_EraseRootFromParent_Done,
     /* 124172 */   // Label 2447: @124172
     /* 124172 */   GIM_Try, /*On fail goto*//*Label 2448*/ GIMT_Encode4(124235), // Rule ID 3697 //
     /* 124177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124196 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 124200 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124207 */     // (umin:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, (abs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm))  =>  (MVE_VMINAs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, MQPR:{ *:[v4i32] }:$Qm)
     /* 124207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs32),
     /* 124210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124212 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 124214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124221 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124227 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124233 */     GIR_RootConstrainSelectedInstOperands,
     /* 124234 */     // GIR_Coverage, 3697,
     /* 124234 */     GIR_EraseRootFromParent_Done,
     /* 124235 */   // Label 2448: @124235
     /* 124235 */   GIM_Try, /*On fail goto*//*Label 2449*/ GIMT_Encode4(124275), // Rule ID 1226 //
     /* 124240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124255 */     // (umin:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VMINuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 124255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv4i32),
     /* 124258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124260 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124267 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124273 */     GIR_RootConstrainSelectedInstOperands,
     /* 124274 */     // GIR_Coverage, 1226,
     /* 124274 */     GIR_EraseRootFromParent_Done,
     /* 124275 */   // Label 2449: @124275
     /* 124275 */   GIM_Try, /*On fail goto*//*Label 2450*/ GIMT_Encode4(124336), // Rule ID 3309 //
     /* 124280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124295 */     // (umin:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMINu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 124295 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 124298 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 124302 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINu32),
     /* 124310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124312 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 124314 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 124316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124319 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124325 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124331 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124334 */     GIR_RootConstrainSelectedInstOperands,
     /* 124335 */     // GIR_Coverage, 3309,
     /* 124335 */     GIR_EraseRootFromParent_Done,
     /* 124336 */   // Label 2450: @124336
     /* 124336 */   GIM_Reject,
     /* 124337 */ // Label 2446: @124337
     /* 124337 */ GIM_Reject,
     /* 124338 */ // Label 2440: @124338
     /* 124338 */ GIM_Try, /*On fail goto*//*Label 2451*/ GIMT_Encode4(124384), // Rule ID 1227 //
     /* 124343 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124346 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 124349 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 124352 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124356 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124360 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124364 */   // (umin:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMINuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 124364 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv8i8),
     /* 124367 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124369 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124371 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124373 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124376 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124382 */   GIR_RootConstrainSelectedInstOperands,
     /* 124383 */   // GIR_Coverage, 1227,
     /* 124383 */   GIR_EraseRootFromParent_Done,
     /* 124384 */ // Label 2451: @124384
     /* 124384 */ GIM_Reject,
     /* 124385 */ // Label 2441: @124385
     /* 124385 */ GIM_Try, /*On fail goto*//*Label 2452*/ GIMT_Encode4(124624),
     /* 124390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 124393 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 124396 */   GIM_Try, /*On fail goto*//*Label 2453*/ GIMT_Encode4(124459), // Rule ID 6026 //
     /* 124401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 124420 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124431 */     // (umin:{ *:[v8i16] } (abs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm), MQPR:{ *:[v8i16] }:$Qd)  =>  (MVE_VMINAs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, MQPR:{ *:[v8i16] }:$Qm)
     /* 124431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs16),
     /* 124434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 124438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124445 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124451 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124457 */     GIR_RootConstrainSelectedInstOperands,
     /* 124458 */     // GIR_Coverage, 6026,
     /* 124458 */     GIR_EraseRootFromParent_Done,
     /* 124459 */   // Label 2453: @124459
     /* 124459 */   GIM_Try, /*On fail goto*//*Label 2454*/ GIMT_Encode4(124522), // Rule ID 3695 //
     /* 124464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124471 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 124487 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124492 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124494 */     // (umin:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, (abs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm))  =>  (MVE_VMINAs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, MQPR:{ *:[v8i16] }:$Qm)
     /* 124494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs16),
     /* 124497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124499 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 124501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124508 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124514 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124520 */     GIR_RootConstrainSelectedInstOperands,
     /* 124521 */     // GIR_Coverage, 3695,
     /* 124521 */     GIR_EraseRootFromParent_Done,
     /* 124522 */   // Label 2454: @124522
     /* 124522 */   GIM_Try, /*On fail goto*//*Label 2455*/ GIMT_Encode4(124562), // Rule ID 1225 //
     /* 124527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124534 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124542 */     // (umin:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VMINuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 124542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv8i16),
     /* 124545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124547 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124554 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124560 */     GIR_RootConstrainSelectedInstOperands,
     /* 124561 */     // GIR_Coverage, 1225,
     /* 124561 */     GIR_EraseRootFromParent_Done,
     /* 124562 */   // Label 2455: @124562
     /* 124562 */   GIM_Try, /*On fail goto*//*Label 2456*/ GIMT_Encode4(124623), // Rule ID 3306 //
     /* 124567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124582 */     // (umin:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMINu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 124582 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 124585 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 124589 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINu16),
     /* 124597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124599 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 124601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 124603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124606 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124612 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124618 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124621 */     GIR_RootConstrainSelectedInstOperands,
     /* 124622 */     // GIR_Coverage, 3306,
     /* 124622 */     GIR_EraseRootFromParent_Done,
     /* 124623 */   // Label 2456: @124623
     /* 124623 */   GIM_Reject,
     /* 124624 */ // Label 2452: @124624
     /* 124624 */ GIM_Reject,
     /* 124625 */ // Label 2442: @124625
     /* 124625 */ GIM_Try, /*On fail goto*//*Label 2457*/ GIMT_Encode4(124864),
     /* 124630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 124633 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 124636 */   GIM_Try, /*On fail goto*//*Label 2458*/ GIMT_Encode4(124699), // Rule ID 6025 //
     /* 124641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 124660 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124669 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124671 */     // (umin:{ *:[v16i8] } (abs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm), MQPR:{ *:[v16i8] }:$Qd)  =>  (MVE_VMINAs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, MQPR:{ *:[v16i8] }:$Qm)
     /* 124671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs8),
     /* 124674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 124678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124685 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124691 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124697 */     GIR_RootConstrainSelectedInstOperands,
     /* 124698 */     // GIR_Coverage, 6025,
     /* 124698 */     GIR_EraseRootFromParent_Done,
     /* 124699 */   // Label 2458: @124699
     /* 124699 */   GIM_Try, /*On fail goto*//*Label 2459*/ GIMT_Encode4(124762), // Rule ID 3693 //
     /* 124704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 124727 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124732 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124734 */     // (umin:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, (abs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm))  =>  (MVE_VMINAs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, MQPR:{ *:[v16i8] }:$Qm)
     /* 124734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs8),
     /* 124737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124739 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 124741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124748 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124754 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124760 */     GIR_RootConstrainSelectedInstOperands,
     /* 124761 */     // GIR_Coverage, 3693,
     /* 124761 */     GIR_EraseRootFromParent_Done,
     /* 124762 */   // Label 2459: @124762
     /* 124762 */   GIM_Try, /*On fail goto*//*Label 2460*/ GIMT_Encode4(124802), // Rule ID 1228 //
     /* 124767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124782 */     // (umin:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMINuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 124782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv16i8),
     /* 124785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124787 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124794 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124800 */     GIR_RootConstrainSelectedInstOperands,
     /* 124801 */     // GIR_Coverage, 1228,
     /* 124801 */     GIR_EraseRootFromParent_Done,
     /* 124802 */   // Label 2460: @124802
     /* 124802 */   GIM_Try, /*On fail goto*//*Label 2461*/ GIMT_Encode4(124863), // Rule ID 3303 //
     /* 124807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124822 */     // (umin:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMINu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 124822 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 124825 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 124829 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINu8),
     /* 124837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124839 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 124841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 124843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124846 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124852 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124858 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124861 */     GIR_RootConstrainSelectedInstOperands,
     /* 124862 */     // GIR_Coverage, 3303,
     /* 124862 */     GIR_EraseRootFromParent_Done,
     /* 124863 */   // Label 2461: @124863
     /* 124863 */   GIM_Reject,
     /* 124864 */ // Label 2457: @124864
     /* 124864 */ GIM_Reject,
     /* 124865 */ // Label 2443: @124865
     /* 124865 */ GIM_Reject,
     /* 124866 */ // Label 58: @124866
     /* 124866 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 2468*/ GIMT_Encode4(125786),
     /* 124877 */ /*GILLT_v2s32*//*Label 2462*/ GIMT_Encode4(124925), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 124889 */ /*GILLT_v4s16*//*Label 2463*/ GIMT_Encode4(124972),
     /* 124893 */ /*GILLT_v4s32*//*Label 2464*/ GIMT_Encode4(125019), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 124905 */ /*GILLT_v8s8*//*Label 2465*/ GIMT_Encode4(125259),
     /* 124909 */ /*GILLT_v8s16*//*Label 2466*/ GIMT_Encode4(125306), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 124921 */ /*GILLT_v16s8*//*Label 2467*/ GIMT_Encode4(125546),
     /* 124925 */ // Label 2462: @124925
     /* 124925 */ GIM_Try, /*On fail goto*//*Label 2469*/ GIMT_Encode4(124971), // Rule ID 1204 //
     /* 124930 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 124936 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 124939 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124943 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124947 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124951 */   // (umax:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VMAXuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 124951 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv2i32),
     /* 124954 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124956 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124958 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124960 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124963 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124969 */   GIR_RootConstrainSelectedInstOperands,
     /* 124970 */   // GIR_Coverage, 1204,
     /* 124970 */   GIR_EraseRootFromParent_Done,
     /* 124971 */ // Label 2469: @124971
     /* 124971 */ GIM_Reject,
     /* 124972 */ // Label 2463: @124972
     /* 124972 */ GIM_Try, /*On fail goto*//*Label 2470*/ GIMT_Encode4(125018), // Rule ID 1203 //
     /* 124977 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124980 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 124983 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 124986 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124990 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124994 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124998 */   // (umax:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VMAXuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 124998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv4i16),
     /* 125001 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125003 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 125005 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 125007 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125010 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125016 */   GIR_RootConstrainSelectedInstOperands,
     /* 125017 */   // GIR_Coverage, 1203,
     /* 125017 */   GIR_EraseRootFromParent_Done,
     /* 125018 */ // Label 2470: @125018
     /* 125018 */ GIM_Reject,
     /* 125019 */ // Label 2464: @125019
     /* 125019 */ GIM_Try, /*On fail goto*//*Label 2471*/ GIMT_Encode4(125258),
     /* 125024 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 125027 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 125030 */   GIM_Try, /*On fail goto*//*Label 2472*/ GIMT_Encode4(125093), // Rule ID 6030 //
     /* 125035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 125050 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 125054 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125065 */     // (umax:{ *:[v4i32] } (abs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm), MQPR:{ *:[v4i32] }:$Qd)  =>  (MVE_VMAXAs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, MQPR:{ *:[v4i32] }:$Qm)
     /* 125065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs32),
     /* 125068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125070 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 125072 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 125076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125079 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125085 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125091 */     GIR_RootConstrainSelectedInstOperands,
     /* 125092 */     // GIR_Coverage, 6030,
     /* 125092 */     GIR_EraseRootFromParent_Done,
     /* 125093 */   // Label 2472: @125093
     /* 125093 */   GIM_Try, /*On fail goto*//*Label 2473*/ GIMT_Encode4(125156), // Rule ID 3703 //
     /* 125098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 125117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 125121 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125128 */     // (umax:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, (abs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm))  =>  (MVE_VMAXAs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, MQPR:{ *:[v4i32] }:$Qm)
     /* 125128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs32),
     /* 125131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125133 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 125135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 125139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125142 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125148 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125154 */     GIR_RootConstrainSelectedInstOperands,
     /* 125155 */     // GIR_Coverage, 3703,
     /* 125155 */     GIR_EraseRootFromParent_Done,
     /* 125156 */   // Label 2473: @125156
     /* 125156 */   GIM_Try, /*On fail goto*//*Label 2474*/ GIMT_Encode4(125196), // Rule ID 1206 //
     /* 125161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125168 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125176 */     // (umax:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VMAXuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 125176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv4i32),
     /* 125179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125181 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 125183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 125185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125188 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125194 */     GIR_RootConstrainSelectedInstOperands,
     /* 125195 */     // GIR_Coverage, 1206,
     /* 125195 */     GIR_EraseRootFromParent_Done,
     /* 125196 */   // Label 2474: @125196
     /* 125196 */   GIM_Try, /*On fail goto*//*Label 2475*/ GIMT_Encode4(125257), // Rule ID 3327 //
     /* 125201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125216 */     // (umax:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMAXu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 125216 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 125219 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 125223 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXu32),
     /* 125231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125233 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 125235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 125237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125240 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125246 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125252 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125255 */     GIR_RootConstrainSelectedInstOperands,
     /* 125256 */     // GIR_Coverage, 3327,
     /* 125256 */     GIR_EraseRootFromParent_Done,
     /* 125257 */   // Label 2475: @125257
     /* 125257 */   GIM_Reject,
     /* 125258 */ // Label 2471: @125258
     /* 125258 */ GIM_Reject,
     /* 125259 */ // Label 2465: @125259
     /* 125259 */ GIM_Try, /*On fail goto*//*Label 2476*/ GIMT_Encode4(125305), // Rule ID 1207 //
     /* 125264 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 125270 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 125273 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125277 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125281 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125285 */   // (umax:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMAXuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 125285 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv8i8),
     /* 125288 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125290 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 125292 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 125294 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125297 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125303 */   GIR_RootConstrainSelectedInstOperands,
     /* 125304 */   // GIR_Coverage, 1207,
     /* 125304 */   GIR_EraseRootFromParent_Done,
     /* 125305 */ // Label 2476: @125305
     /* 125305 */ GIM_Reject,
     /* 125306 */ // Label 2466: @125306
     /* 125306 */ GIM_Try, /*On fail goto*//*Label 2477*/ GIMT_Encode4(125545),
     /* 125311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 125314 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 125317 */   GIM_Try, /*On fail goto*//*Label 2478*/ GIMT_Encode4(125380), // Rule ID 6029 //
     /* 125322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 125337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 125341 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125350 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125352 */     // (umax:{ *:[v8i16] } (abs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm), MQPR:{ *:[v8i16] }:$Qd)  =>  (MVE_VMAXAs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, MQPR:{ *:[v8i16] }:$Qm)
     /* 125352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs16),
     /* 125355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 125359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 125363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125366 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125372 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125378 */     GIR_RootConstrainSelectedInstOperands,
     /* 125379 */     // GIR_Coverage, 6029,
     /* 125379 */     GIR_EraseRootFromParent_Done,
     /* 125380 */   // Label 2478: @125380
     /* 125380 */   GIM_Try, /*On fail goto*//*Label 2479*/ GIMT_Encode4(125443), // Rule ID 3701 //
     /* 125385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 125404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 125408 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125415 */     // (umax:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, (abs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm))  =>  (MVE_VMAXAs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, MQPR:{ *:[v8i16] }:$Qm)
     /* 125415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs16),
     /* 125418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125420 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 125422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 125426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125429 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125435 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125441 */     GIR_RootConstrainSelectedInstOperands,
     /* 125442 */     // GIR_Coverage, 3701,
     /* 125442 */     GIR_EraseRootFromParent_Done,
     /* 125443 */   // Label 2479: @125443
     /* 125443 */   GIM_Try, /*On fail goto*//*Label 2480*/ GIMT_Encode4(125483), // Rule ID 1205 //
     /* 125448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125455 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125463 */     // (umax:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VMAXuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 125463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv8i16),
     /* 125466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125468 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 125470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 125472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125475 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125481 */     GIR_RootConstrainSelectedInstOperands,
     /* 125482 */     // GIR_Coverage, 1205,
     /* 125482 */     GIR_EraseRootFromParent_Done,
     /* 125483 */   // Label 2480: @125483
     /* 125483 */   GIM_Try, /*On fail goto*//*Label 2481*/ GIMT_Encode4(125544), // Rule ID 3324 //
     /* 125488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125503 */     // (umax:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMAXu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 125503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 125506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 125510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXu16),
     /* 125518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125520 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 125522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 125524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125527 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125533 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125539 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125542 */     GIR_RootConstrainSelectedInstOperands,
     /* 125543 */     // GIR_Coverage, 3324,
     /* 125543 */     GIR_EraseRootFromParent_Done,
     /* 125544 */   // Label 2481: @125544
     /* 125544 */   GIM_Reject,
     /* 125545 */ // Label 2477: @125545
     /* 125545 */ GIM_Reject,
     /* 125546 */ // Label 2467: @125546
     /* 125546 */ GIM_Try, /*On fail goto*//*Label 2482*/ GIMT_Encode4(125785),
     /* 125551 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 125554 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 125557 */   GIM_Try, /*On fail goto*//*Label 2483*/ GIMT_Encode4(125620), // Rule ID 6028 //
     /* 125562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 125577 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 125581 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125590 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125592 */     // (umax:{ *:[v16i8] } (abs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm), MQPR:{ *:[v16i8] }:$Qd)  =>  (MVE_VMAXAs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, MQPR:{ *:[v16i8] }:$Qm)
     /* 125592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs8),
     /* 125595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 125599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 125603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125606 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125612 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125618 */     GIR_RootConstrainSelectedInstOperands,
     /* 125619 */     // GIR_Coverage, 6028,
     /* 125619 */     GIR_EraseRootFromParent_Done,
     /* 125620 */   // Label 2483: @125620
     /* 125620 */   GIM_Try, /*On fail goto*//*Label 2484*/ GIMT_Encode4(125683), // Rule ID 3699 //
     /* 125625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 125644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 125648 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125655 */     // (umax:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, (abs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm))  =>  (MVE_VMAXAs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, MQPR:{ *:[v16i8] }:$Qm)
     /* 125655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs8),
     /* 125658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125660 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 125662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 125666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125669 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125675 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125681 */     GIR_RootConstrainSelectedInstOperands,
     /* 125682 */     // GIR_Coverage, 3699,
     /* 125682 */     GIR_EraseRootFromParent_Done,
     /* 125683 */   // Label 2484: @125683
     /* 125683 */   GIM_Try, /*On fail goto*//*Label 2485*/ GIMT_Encode4(125723), // Rule ID 1208 //
     /* 125688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125695 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125703 */     // (umax:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMAXuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 125703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv16i8),
     /* 125706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125708 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 125710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 125712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125715 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125721 */     GIR_RootConstrainSelectedInstOperands,
     /* 125722 */     // GIR_Coverage, 1208,
     /* 125722 */     GIR_EraseRootFromParent_Done,
     /* 125723 */   // Label 2485: @125723
     /* 125723 */   GIM_Try, /*On fail goto*//*Label 2486*/ GIMT_Encode4(125784), // Rule ID 3321 //
     /* 125728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125735 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125743 */     // (umax:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMAXu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 125743 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 125746 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 125750 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXu8),
     /* 125758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125760 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 125762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 125764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125767 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125773 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125779 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125782 */     GIR_RootConstrainSelectedInstOperands,
     /* 125783 */     // GIR_Coverage, 3321,
     /* 125783 */     GIR_EraseRootFromParent_Done,
     /* 125784 */   // Label 2486: @125784
     /* 125784 */   GIM_Reject,
     /* 125785 */ // Label 2482: @125785
     /* 125785 */ GIM_Reject,
     /* 125786 */ // Label 2468: @125786
     /* 125786 */ GIM_Reject,
     /* 125787 */ // Label 59: @125787
     /* 125787 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 2493*/ GIMT_Encode4(126257),
     /* 125798 */ /*GILLT_v2s32*//*Label 2487*/ GIMT_Encode4(125846), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 125810 */ /*GILLT_v4s16*//*Label 2488*/ GIMT_Encode4(125884),
     /* 125814 */ /*GILLT_v4s32*//*Label 2489*/ GIMT_Encode4(125922), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 125826 */ /*GILLT_v8s8*//*Label 2490*/ GIMT_Encode4(126021),
     /* 125830 */ /*GILLT_v8s16*//*Label 2491*/ GIMT_Encode4(126059), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 125842 */ /*GILLT_v16s8*//*Label 2492*/ GIMT_Encode4(126158),
     /* 125846 */ // Label 2487: @125846
     /* 125846 */ GIM_Try, /*On fail goto*//*Label 2494*/ GIMT_Encode4(125883), // Rule ID 1510 //
     /* 125851 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 125857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125861 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125865 */   // (abs:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)  =>  (VABSv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /* 125865 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv2i32),
     /* 125868 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125870 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 125872 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125875 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125881 */   GIR_RootConstrainSelectedInstOperands,
     /* 125882 */   // GIR_Coverage, 1510,
     /* 125882 */   GIR_EraseRootFromParent_Done,
     /* 125883 */ // Label 2494: @125883
     /* 125883 */ GIM_Reject,
     /* 125884 */ // Label 2488: @125884
     /* 125884 */ GIM_Try, /*On fail goto*//*Label 2495*/ GIMT_Encode4(125921), // Rule ID 1509 //
     /* 125889 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 125895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125899 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125903 */   // (abs:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)  =>  (VABSv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)
     /* 125903 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv4i16),
     /* 125906 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125908 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 125910 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125913 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125919 */   GIR_RootConstrainSelectedInstOperands,
     /* 125920 */   // GIR_Coverage, 1509,
     /* 125920 */   GIR_EraseRootFromParent_Done,
     /* 125921 */ // Label 2495: @125921
     /* 125921 */ GIM_Reject,
     /* 125922 */ // Label 2489: @125922
     /* 125922 */ GIM_Try, /*On fail goto*//*Label 2496*/ GIMT_Encode4(126020),
     /* 125927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 125930 */   GIM_Try, /*On fail goto*//*Label 2497*/ GIMT_Encode4(125964), // Rule ID 1513 //
     /* 125935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125942 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125946 */     // (abs:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)  =>  (VABSv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /* 125946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv4i32),
     /* 125949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125951 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 125953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125956 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125962 */     GIR_RootConstrainSelectedInstOperands,
     /* 125963 */     // GIR_Coverage, 1513,
     /* 125963 */     GIR_EraseRootFromParent_Done,
     /* 125964 */   // Label 2497: @125964
     /* 125964 */   GIM_Try, /*On fail goto*//*Label 2498*/ GIMT_Encode4(126019), // Rule ID 3672 //
     /* 125969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125976 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125980 */     // (abs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$v)  =>  (MVE_VABSs32:{ *:[v4i32] } ?:{ *:[v4i32] }:$v)
     /* 125980 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 125983 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 125987 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABSs32),
     /* 125995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125997 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 125999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126002 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126008 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126014 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126017 */     GIR_RootConstrainSelectedInstOperands,
     /* 126018 */     // GIR_Coverage, 3672,
     /* 126018 */     GIR_EraseRootFromParent_Done,
     /* 126019 */   // Label 2498: @126019
     /* 126019 */   GIM_Reject,
     /* 126020 */ // Label 2496: @126020
     /* 126020 */ GIM_Reject,
     /* 126021 */ // Label 2490: @126021
     /* 126021 */ GIM_Try, /*On fail goto*//*Label 2499*/ GIMT_Encode4(126058), // Rule ID 1508 //
     /* 126026 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126029 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 126032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126036 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126040 */   // (abs:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)  =>  (VABSv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /* 126040 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv8i8),
     /* 126043 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126045 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126047 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126050 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126056 */   GIR_RootConstrainSelectedInstOperands,
     /* 126057 */   // GIR_Coverage, 1508,
     /* 126057 */   GIR_EraseRootFromParent_Done,
     /* 126058 */ // Label 2499: @126058
     /* 126058 */ GIM_Reject,
     /* 126059 */ // Label 2491: @126059
     /* 126059 */ GIM_Try, /*On fail goto*//*Label 2500*/ GIMT_Encode4(126157),
     /* 126064 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 126067 */   GIM_Try, /*On fail goto*//*Label 2501*/ GIMT_Encode4(126101), // Rule ID 1512 //
     /* 126072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126083 */     // (abs:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)  =>  (VABSv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)
     /* 126083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv8i16),
     /* 126086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126088 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126093 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126099 */     GIR_RootConstrainSelectedInstOperands,
     /* 126100 */     // GIR_Coverage, 1512,
     /* 126100 */     GIR_EraseRootFromParent_Done,
     /* 126101 */   // Label 2501: @126101
     /* 126101 */   GIM_Try, /*On fail goto*//*Label 2502*/ GIMT_Encode4(126156), // Rule ID 3666 //
     /* 126106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 126109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126117 */     // (abs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$v)  =>  (MVE_VABSs16:{ *:[v8i16] } ?:{ *:[v8i16] }:$v)
     /* 126117 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 126120 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126124 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABSs16),
     /* 126132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 126134 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 126136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126139 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126145 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126151 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126154 */     GIR_RootConstrainSelectedInstOperands,
     /* 126155 */     // GIR_Coverage, 3666,
     /* 126155 */     GIR_EraseRootFromParent_Done,
     /* 126156 */   // Label 2502: @126156
     /* 126156 */   GIM_Reject,
     /* 126157 */ // Label 2500: @126157
     /* 126157 */ GIM_Reject,
     /* 126158 */ // Label 2492: @126158
     /* 126158 */ GIM_Try, /*On fail goto*//*Label 2503*/ GIMT_Encode4(126256),
     /* 126163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 126166 */   GIM_Try, /*On fail goto*//*Label 2504*/ GIMT_Encode4(126200), // Rule ID 1511 //
     /* 126171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126182 */     // (abs:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)  =>  (VABSv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /* 126182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv16i8),
     /* 126185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126187 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126192 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126198 */     GIR_RootConstrainSelectedInstOperands,
     /* 126199 */     // GIR_Coverage, 1511,
     /* 126199 */     GIR_EraseRootFromParent_Done,
     /* 126200 */   // Label 2504: @126200
     /* 126200 */   GIM_Try, /*On fail goto*//*Label 2505*/ GIMT_Encode4(126255), // Rule ID 3660 //
     /* 126205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 126208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126212 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126216 */     // (abs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$v)  =>  (MVE_VABSs8:{ *:[v16i8] } ?:{ *:[v16i8] }:$v)
     /* 126216 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 126219 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126223 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABSs8),
     /* 126231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 126233 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 126235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126238 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126244 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126250 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126253 */     GIR_RootConstrainSelectedInstOperands,
     /* 126254 */     // GIR_Coverage, 3660,
     /* 126254 */     GIR_EraseRootFromParent_Done,
     /* 126255 */   // Label 2505: @126255
     /* 126255 */   GIM_Reject,
     /* 126256 */ // Label 2503: @126256
     /* 126256 */ GIM_Reject,
     /* 126257 */ // Label 2493: @126257
     /* 126257 */ GIM_Reject,
     /* 126258 */ // Label 60: @126258
     /* 126258 */ GIM_Try, /*On fail goto*//*Label 2506*/ GIMT_Encode4(126330),
     /* 126263 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 126266 */   GIM_Try, /*On fail goto*//*Label 2507*/ GIMT_Encode4(126281), // Rule ID 32 //
     /* 126271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /* 126274 */     // (br (bb:{ *:[Other] }):$target)  =>  (B (bb:{ *:[Other] }):$target)
     /* 126274 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::B),
     /* 126279 */     GIR_RootConstrainSelectedInstOperands,
     /* 126280 */     // GIR_Coverage, 32,
     /* 126280 */     GIR_Done,
     /* 126281 */   // Label 2507: @126281
     /* 126281 */   GIM_Try, /*On fail goto*//*Label 2508*/ GIMT_Encode4(126305), // Rule ID 283 //
     /* 126286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 126289 */     // (br (bb:{ *:[Other] }):$target)  =>  (tB (bb:{ *:[Other] }):$target)
     /* 126289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tB),
     /* 126292 */     GIR_RootToRootCopy, /*OpIdx*/0, // target
     /* 126294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126297 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126303 */     GIR_RootConstrainSelectedInstOperands,
     /* 126304 */     // GIR_Coverage, 283,
     /* 126304 */     GIR_EraseRootFromParent_Done,
     /* 126305 */   // Label 2508: @126305
     /* 126305 */   GIM_Try, /*On fail goto*//*Label 2509*/ GIMT_Encode4(126329), // Rule ID 577 //
     /* 126310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV8MBaseline_IsThumb),
     /* 126313 */     // (br (bb:{ *:[Other] }):$target)  =>  (t2B (bb:{ *:[Other] }):$target)
     /* 126313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2B),
     /* 126316 */     GIR_RootToRootCopy, /*OpIdx*/0, // target
     /* 126318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126321 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126327 */     GIR_RootConstrainSelectedInstOperands,
     /* 126328 */     // GIR_Coverage, 577,
     /* 126328 */     GIR_EraseRootFromParent_Done,
     /* 126329 */   // Label 2509: @126329
     /* 126329 */   GIM_Reject,
     /* 126330 */ // Label 2506: @126330
     /* 126330 */ GIM_Reject,
     /* 126331 */ // Label 61: @126331
     /* 126331 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(16), /*)*//*default:*//*Label 2514*/ GIMT_Encode4(126630),
     /* 126342 */ /*GILLT_v4s16*//*Label 2510*/ GIMT_Encode4(126378), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126358 */ /*GILLT_v8s8*//*Label 2511*/ GIMT_Encode4(126441),
     /* 126362 */ /*GILLT_v8s16*//*Label 2512*/ GIMT_Encode4(126504), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126374 */ /*GILLT_v16s8*//*Label 2513*/ GIMT_Encode4(126567),
     /* 126378 */ // Label 2510: @126378
     /* 126378 */ GIM_Try, /*On fail goto*//*Label 2515*/ GIMT_Encode4(126440), // Rule ID 1572 //
     /* 126383 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126386 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 126389 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 126392 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 126395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126399 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126403 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 126407 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 126411 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 126415 */   // MIs[1] Operand 1
     /* 126415 */   // No operand predicates
     /* 126415 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126417 */   // (vector_insert:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, GPR:{ *:[i32] }:$R, (imm:{ *:[i32] }):$lane)  =>  (VSETLNi16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, GPR:{ *:[i32] }:$R, (imm:{ *:[i32] }):$lane)
     /* 126417 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSETLNi16),
     /* 126420 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[V]
     /* 126422 */   GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126424 */   GIR_RootToRootCopy, /*OpIdx*/2, // R
     /* 126426 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // lane
     /* 126429 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126432 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126438 */   GIR_RootConstrainSelectedInstOperands,
     /* 126439 */   // GIR_Coverage, 1572,
     /* 126439 */   GIR_EraseRootFromParent_Done,
     /* 126440 */ // Label 2515: @126440
     /* 126440 */ GIM_Reject,
     /* 126441 */ // Label 2511: @126441
     /* 126441 */ GIM_Try, /*On fail goto*//*Label 2516*/ GIMT_Encode4(126503), // Rule ID 1571 //
     /* 126446 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 126452 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 126455 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 126458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126462 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126466 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 126470 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 126474 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 126478 */   // MIs[1] Operand 1
     /* 126478 */   // No operand predicates
     /* 126478 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126480 */   // (vector_insert:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, GPR:{ *:[i32] }:$R, (imm:{ *:[i32] }):$lane)  =>  (VSETLNi8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, GPR:{ *:[i32] }:$R, (imm:{ *:[i32] }):$lane)
     /* 126480 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSETLNi8),
     /* 126483 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[V]
     /* 126485 */   GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126487 */   GIR_RootToRootCopy, /*OpIdx*/2, // R
     /* 126489 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // lane
     /* 126492 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126495 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126501 */   GIR_RootConstrainSelectedInstOperands,
     /* 126502 */   // GIR_Coverage, 1571,
     /* 126502 */   GIR_EraseRootFromParent_Done,
     /* 126503 */ // Label 2516: @126503
     /* 126503 */ GIM_Reject,
     /* 126504 */ // Label 2512: @126504
     /* 126504 */ GIM_Try, /*On fail goto*//*Label 2517*/ GIMT_Encode4(126566), // Rule ID 3436 //
     /* 126509 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 126512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 126515 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 126518 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 126521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126525 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126529 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 126533 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 126537 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 126541 */   // MIs[1] Operand 1
     /* 126541 */   // No operand predicates
     /* 126541 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126543 */   // (vector_insert:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] }):$lane)  =>  (MVE_VMOV_to_lane_16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] }):$lane)
     /* 126543 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOV_to_lane_16),
     /* 126546 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 126548 */   GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126550 */   GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 126552 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // lane
     /* 126555 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126558 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126564 */   GIR_RootConstrainSelectedInstOperands,
     /* 126565 */   // GIR_Coverage, 3436,
     /* 126565 */   GIR_EraseRootFromParent_Done,
     /* 126566 */ // Label 2517: @126566
     /* 126566 */ GIM_Reject,
     /* 126567 */ // Label 2513: @126567
     /* 126567 */ GIM_Try, /*On fail goto*//*Label 2518*/ GIMT_Encode4(126629), // Rule ID 3435 //
     /* 126572 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 126575 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 126578 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 126581 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 126584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126588 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126592 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 126596 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 126600 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 126604 */   // MIs[1] Operand 1
     /* 126604 */   // No operand predicates
     /* 126604 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126606 */   // (vector_insert:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] }):$lane)  =>  (MVE_VMOV_to_lane_8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] }):$lane)
     /* 126606 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOV_to_lane_8),
     /* 126609 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 126611 */   GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126613 */   GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 126615 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // lane
     /* 126618 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126621 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126627 */   GIR_RootConstrainSelectedInstOperands,
     /* 126628 */   // GIR_Coverage, 3435,
     /* 126628 */   GIR_EraseRootFromParent_Done,
     /* 126629 */ // Label 2518: @126629
     /* 126629 */ GIM_Reject,
     /* 126630 */ // Label 2514: @126630
     /* 126630 */ GIM_Reject,
     /* 126631 */ // Label 62: @126631
     /* 126631 */ GIM_Try, /*On fail goto*//*Label 2519*/ GIMT_Encode4(126687), // Rule ID 1570 //
     /* 126636 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRegs_HasFastVGETLNi32),
     /* 126639 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 126642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 126645 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 126648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 126652 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126656 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 126660 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 126664 */   // MIs[1] Operand 1
     /* 126664 */   // No operand predicates
     /* 126664 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126666 */   // (extractelt:{ *:[i32] } DPR:{ *:[v2i32] }:$V, (imm:{ *:[i32] }):$lane)  =>  (VGETLNi32:{ *:[i32] } DPR:{ *:[v2i32] }:$V, (imm:{ *:[i32] }):$lane)
     /* 126666 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VGETLNi32),
     /* 126669 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[R]
     /* 126671 */   GIR_RootToRootCopy, /*OpIdx*/1, // V
     /* 126673 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // lane
     /* 126676 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126679 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126685 */   GIR_RootConstrainSelectedInstOperands,
     /* 126686 */   // GIR_Coverage, 1570,
     /* 126686 */   GIR_EraseRootFromParent_Done,
     /* 126687 */ // Label 2519: @126687
     /* 126687 */ GIM_Reject,
     /* 126688 */ // Label 63: @126688
     /* 126688 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 2527*/ GIMT_Encode4(127248),
     /* 126699 */ /*GILLT_s32*//*Label 2520*/ GIMT_Encode4(126759), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126711 */ /*GILLT_v2s32*//*Label 2521*/ GIMT_Encode4(126837), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126723 */ /*GILLT_v4s16*//*Label 2522*/ GIMT_Encode4(126875),
     /* 126727 */ /*GILLT_v4s32*//*Label 2523*/ GIMT_Encode4(126913), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126739 */ /*GILLT_v8s8*//*Label 2524*/ GIMT_Encode4(127012),
     /* 126743 */ /*GILLT_v8s16*//*Label 2525*/ GIMT_Encode4(127050), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126755 */ /*GILLT_v16s8*//*Label 2526*/ GIMT_Encode4(127149),
     /* 126759 */ // Label 2520: @126759
     /* 126759 */ GIM_Try, /*On fail goto*//*Label 2528*/ GIMT_Encode4(126836),
     /* 126764 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 126767 */   GIM_Try, /*On fail goto*//*Label 2529*/ GIMT_Encode4(126801), // Rule ID 197 //
     /* 126772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5T_IsARM),
     /* 126775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 126779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 126783 */     // (ctlz:{ *:[i32] } GPR:{ *:[i32] }:$Rm)  =>  (CLZ:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /* 126783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CLZ),
     /* 126786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 126788 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 126790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126793 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126799 */     GIR_RootConstrainSelectedInstOperands,
     /* 126800 */     // GIR_Coverage, 197,
     /* 126800 */     GIR_EraseRootFromParent_Done,
     /* 126801 */   // Label 2529: @126801
     /* 126801 */   GIM_Try, /*On fail goto*//*Label 2530*/ GIMT_Encode4(126835), // Rule ID 534 //
     /* 126806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 126809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 126813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 126817 */     // (ctlz:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)  =>  (t2CLZ:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /* 126817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CLZ),
     /* 126820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 126822 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 126824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126827 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126833 */     GIR_RootConstrainSelectedInstOperands,
     /* 126834 */     // GIR_Coverage, 534,
     /* 126834 */     GIR_EraseRootFromParent_Done,
     /* 126835 */   // Label 2530: @126835
     /* 126835 */   GIM_Reject,
     /* 126836 */ // Label 2528: @126836
     /* 126836 */ GIM_Reject,
     /* 126837 */ // Label 2521: @126837
     /* 126837 */ GIM_Try, /*On fail goto*//*Label 2531*/ GIMT_Encode4(126874), // Rule ID 1548 //
     /* 126842 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 126848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126852 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126856 */   // (ctlz:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)  =>  (VCLZv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /* 126856 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv2i32),
     /* 126859 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126861 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126863 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126866 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126872 */   GIR_RootConstrainSelectedInstOperands,
     /* 126873 */   // GIR_Coverage, 1548,
     /* 126873 */   GIR_EraseRootFromParent_Done,
     /* 126874 */ // Label 2531: @126874
     /* 126874 */ GIM_Reject,
     /* 126875 */ // Label 2522: @126875
     /* 126875 */ GIM_Try, /*On fail goto*//*Label 2532*/ GIMT_Encode4(126912), // Rule ID 1547 //
     /* 126880 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 126886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126890 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126894 */   // (ctlz:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)  =>  (VCLZv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)
     /* 126894 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv4i16),
     /* 126897 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126899 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126901 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126904 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126910 */   GIR_RootConstrainSelectedInstOperands,
     /* 126911 */   // GIR_Coverage, 1547,
     /* 126911 */   GIR_EraseRootFromParent_Done,
     /* 126912 */ // Label 2532: @126912
     /* 126912 */ GIM_Reject,
     /* 126913 */ // Label 2523: @126913
     /* 126913 */ GIM_Try, /*On fail goto*//*Label 2533*/ GIMT_Encode4(127011),
     /* 126918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 126921 */   GIM_Try, /*On fail goto*//*Label 2534*/ GIMT_Encode4(126955), // Rule ID 1551 //
     /* 126926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126937 */     // (ctlz:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)  =>  (VCLZv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /* 126937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv4i32),
     /* 126940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126942 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126947 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126953 */     GIR_RootConstrainSelectedInstOperands,
     /* 126954 */     // GIR_Coverage, 1551,
     /* 126954 */     GIR_EraseRootFromParent_Done,
     /* 126955 */   // Label 2534: @126955
     /* 126955 */   GIM_Try, /*On fail goto*//*Label 2535*/ GIMT_Encode4(127010), // Rule ID 3658 //
     /* 126960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 126963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126967 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126971 */     // (ctlz:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$val)  =>  (MVE_VCLZs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$val)
     /* 126971 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 126974 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126978 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLZs32),
     /* 126986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 126988 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 126990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126993 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126999 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127005 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127008 */     GIR_RootConstrainSelectedInstOperands,
     /* 127009 */     // GIR_Coverage, 3658,
     /* 127009 */     GIR_EraseRootFromParent_Done,
     /* 127010 */   // Label 2535: @127010
     /* 127010 */   GIM_Reject,
     /* 127011 */ // Label 2533: @127011
     /* 127011 */ GIM_Reject,
     /* 127012 */ // Label 2524: @127012
     /* 127012 */ GIM_Try, /*On fail goto*//*Label 2536*/ GIMT_Encode4(127049), // Rule ID 1546 //
     /* 127017 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 127020 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 127023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 127027 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 127031 */   // (ctlz:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)  =>  (VCLZv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /* 127031 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv8i8),
     /* 127034 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 127036 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 127038 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127041 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127047 */   GIR_RootConstrainSelectedInstOperands,
     /* 127048 */   // GIR_Coverage, 1546,
     /* 127048 */   GIR_EraseRootFromParent_Done,
     /* 127049 */ // Label 2536: @127049
     /* 127049 */ GIM_Reject,
     /* 127050 */ // Label 2525: @127050
     /* 127050 */ GIM_Try, /*On fail goto*//*Label 2537*/ GIMT_Encode4(127148),
     /* 127055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 127058 */   GIM_Try, /*On fail goto*//*Label 2538*/ GIMT_Encode4(127092), // Rule ID 1550 //
     /* 127063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 127066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 127070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 127074 */     // (ctlz:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)  =>  (VCLZv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)
     /* 127074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv8i16),
     /* 127077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 127079 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 127081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127084 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127090 */     GIR_RootConstrainSelectedInstOperands,
     /* 127091 */     // GIR_Coverage, 1550,
     /* 127091 */     GIR_EraseRootFromParent_Done,
     /* 127092 */   // Label 2538: @127092
     /* 127092 */   GIM_Try, /*On fail goto*//*Label 2539*/ GIMT_Encode4(127147), // Rule ID 3656 //
     /* 127097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127104 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127108 */     // (ctlz:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$val)  =>  (MVE_VCLZs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$val)
     /* 127108 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 127111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127115 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLZs16),
     /* 127123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127125 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 127127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127130 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127136 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127142 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127145 */     GIR_RootConstrainSelectedInstOperands,
     /* 127146 */     // GIR_Coverage, 3656,
     /* 127146 */     GIR_EraseRootFromParent_Done,
     /* 127147 */   // Label 2539: @127147
     /* 127147 */   GIM_Reject,
     /* 127148 */ // Label 2537: @127148
     /* 127148 */ GIM_Reject,
     /* 127149 */ // Label 2526: @127149
     /* 127149 */ GIM_Try, /*On fail goto*//*Label 2540*/ GIMT_Encode4(127247),
     /* 127154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 127157 */   GIM_Try, /*On fail goto*//*Label 2541*/ GIMT_Encode4(127191), // Rule ID 1549 //
     /* 127162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 127165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 127169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 127173 */     // (ctlz:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)  =>  (VCLZv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /* 127173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv16i8),
     /* 127176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 127178 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 127180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127183 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127189 */     GIR_RootConstrainSelectedInstOperands,
     /* 127190 */     // GIR_Coverage, 1549,
     /* 127190 */     GIR_EraseRootFromParent_Done,
     /* 127191 */   // Label 2541: @127191
     /* 127191 */   GIM_Try, /*On fail goto*//*Label 2542*/ GIMT_Encode4(127246), // Rule ID 3654 //
     /* 127196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127203 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127207 */     // (ctlz:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$val)  =>  (MVE_VCLZs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$val)
     /* 127207 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 127210 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127214 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLZs8),
     /* 127222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127224 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 127226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127229 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127235 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127241 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127244 */     GIR_RootConstrainSelectedInstOperands,
     /* 127245 */     // GIR_Coverage, 3654,
     /* 127245 */     GIR_EraseRootFromParent_Done,
     /* 127246 */   // Label 2542: @127246
     /* 127246 */   GIM_Reject,
     /* 127247 */ // Label 2540: @127247
     /* 127247 */ GIM_Reject,
     /* 127248 */ // Label 2527: @127248
     /* 127248 */ GIM_Reject,
     /* 127249 */ // Label 64: @127249
     /* 127249 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(11), GIMT_Encode2(16), /*)*//*default:*//*Label 2545*/ GIMT_Encode4(127356),
     /* 127260 */ /*GILLT_v8s8*//*Label 2543*/ GIMT_Encode4(127280), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127276 */ /*GILLT_v16s8*//*Label 2544*/ GIMT_Encode4(127318),
     /* 127280 */ // Label 2543: @127280
     /* 127280 */ GIM_Try, /*On fail goto*//*Label 2546*/ GIMT_Encode4(127317), // Rule ID 1552 //
     /* 127285 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 127288 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 127291 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 127295 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 127299 */   // (ctpop:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)  =>  (VCNTd:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /* 127299 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCNTd),
     /* 127302 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 127304 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 127306 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127309 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127315 */   GIR_RootConstrainSelectedInstOperands,
     /* 127316 */   // GIR_Coverage, 1552,
     /* 127316 */   GIR_EraseRootFromParent_Done,
     /* 127317 */ // Label 2546: @127317
     /* 127317 */ GIM_Reject,
     /* 127318 */ // Label 2544: @127318
     /* 127318 */ GIM_Try, /*On fail goto*//*Label 2547*/ GIMT_Encode4(127355), // Rule ID 1553 //
     /* 127323 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 127326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 127329 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 127333 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 127337 */   // (ctpop:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)  =>  (VCNTq:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /* 127337 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCNTq),
     /* 127340 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 127342 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 127344 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127347 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127353 */   GIR_RootConstrainSelectedInstOperands,
     /* 127354 */   // GIR_Coverage, 1553,
     /* 127354 */   GIR_EraseRootFromParent_Done,
     /* 127355 */ // Label 2547: @127355
     /* 127355 */ GIM_Reject,
     /* 127356 */ // Label 2545: @127356
     /* 127356 */ GIM_Reject,
     /* 127357 */ // Label 65: @127357
     /* 127357 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(13), /*)*//*default:*//*Label 2551*/ GIMT_Encode4(127646),
     /* 127368 */ /*GILLT_s32*//*Label 2548*/ GIMT_Encode4(127416), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127396 */ /*GILLT_v4s32*//*Label 2549*/ GIMT_Encode4(127528), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127412 */ /*GILLT_v8s16*//*Label 2550*/ GIMT_Encode4(127587),
     /* 127416 */ // Label 2548: @127416
     /* 127416 */ GIM_Try, /*On fail goto*//*Label 2552*/ GIMT_Encode4(127527),
     /* 127421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 127424 */   GIM_Try, /*On fail goto*//*Label 2553*/ GIMT_Encode4(127458), // Rule ID 199 //
     /* 127429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /* 127432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 127436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 127440 */     // (bswap:{ *:[i32] } GPR:{ *:[i32] }:$Rm)  =>  (REV:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /* 127440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::REV),
     /* 127443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 127445 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 127447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127450 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127456 */     GIR_RootConstrainSelectedInstOperands,
     /* 127457 */     // GIR_Coverage, 199,
     /* 127457 */     GIR_EraseRootFromParent_Done,
     /* 127458 */   // Label 2553: @127458
     /* 127458 */   GIM_Try, /*On fail goto*//*Label 2554*/ GIMT_Encode4(127492), // Rule ID 326 //
     /* 127463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /* 127466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 127470 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 127474 */     // (bswap:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)  =>  (tREV:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /* 127474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tREV),
     /* 127477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 127479 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 127481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127484 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127490 */     GIR_RootConstrainSelectedInstOperands,
     /* 127491 */     // GIR_Coverage, 326,
     /* 127491 */     GIR_EraseRootFromParent_Done,
     /* 127492 */   // Label 2554: @127492
     /* 127492 */   GIM_Try, /*On fail goto*//*Label 2555*/ GIMT_Encode4(127526), // Rule ID 536 //
     /* 127497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 127500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 127504 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 127508 */     // (bswap:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)  =>  (t2REV:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /* 127508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2REV),
     /* 127511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 127513 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 127515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127518 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127524 */     GIR_RootConstrainSelectedInstOperands,
     /* 127525 */     // GIR_Coverage, 536,
     /* 127525 */     GIR_EraseRootFromParent_Done,
     /* 127526 */   // Label 2555: @127526
     /* 127526 */   GIM_Reject,
     /* 127527 */ // Label 2552: @127527
     /* 127527 */ GIM_Reject,
     /* 127528 */ // Label 2549: @127528
     /* 127528 */ GIM_Try, /*On fail goto*//*Label 2556*/ GIMT_Encode4(127586), // Rule ID 3331 //
     /* 127533 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 127539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127543 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127547 */   // (bswap:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV32_8:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src)
     /* 127547 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 127550 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127554 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127559 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_8),
     /* 127562 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127564 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 127566 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127569 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127575 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127581 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127584 */   GIR_RootConstrainSelectedInstOperands,
     /* 127585 */   // GIR_Coverage, 3331,
     /* 127585 */   GIR_EraseRootFromParent_Done,
     /* 127586 */ // Label 2556: @127586
     /* 127586 */ GIM_Reject,
     /* 127587 */ // Label 2550: @127587
     /* 127587 */ GIM_Try, /*On fail goto*//*Label 2557*/ GIMT_Encode4(127645), // Rule ID 3330 //
     /* 127592 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 127598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127602 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127606 */   // (bswap:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV16_8:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src)
     /* 127606 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 127609 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127613 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127618 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV16_8),
     /* 127621 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127623 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 127625 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127628 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127634 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127640 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127643 */   GIR_RootConstrainSelectedInstOperands,
     /* 127644 */   // GIR_Coverage, 3330,
     /* 127644 */   GIR_EraseRootFromParent_Done,
     /* 127645 */ // Label 2557: @127645
     /* 127645 */ GIM_Reject,
     /* 127646 */ // Label 2551: @127646
     /* 127646 */ GIM_Reject,
     /* 127647 */ // Label 66: @127647
     /* 127647 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 2562*/ GIMT_Encode4(128078),
     /* 127658 */ /*GILLT_s32*//*Label 2558*/ GIMT_Encode4(127718), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127686 */ /*GILLT_v4s32*//*Label 2559*/ GIMT_Encode4(127796), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127702 */ /*GILLT_v8s16*//*Label 2560*/ GIMT_Encode4(127890), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127714 */ /*GILLT_v16s8*//*Label 2561*/ GIMT_Encode4(127984),
     /* 127718 */ // Label 2558: @127718
     /* 127718 */ GIM_Try, /*On fail goto*//*Label 2563*/ GIMT_Encode4(127795),
     /* 127723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 127726 */   GIM_Try, /*On fail goto*//*Label 2564*/ GIMT_Encode4(127760), // Rule ID 198 //
     /* 127731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6T2_IsARM),
     /* 127734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 127738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 127742 */     // (bitreverse:{ *:[i32] } GPR:{ *:[i32] }:$Rm)  =>  (RBIT:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /* 127742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::RBIT),
     /* 127745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 127747 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 127749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127752 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127758 */     GIR_RootConstrainSelectedInstOperands,
     /* 127759 */     // GIR_Coverage, 198,
     /* 127759 */     GIR_EraseRootFromParent_Done,
     /* 127760 */   // Label 2564: @127760
     /* 127760 */   GIM_Try, /*On fail goto*//*Label 2565*/ GIMT_Encode4(127794), // Rule ID 535 //
     /* 127765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 127768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 127772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 127776 */     // (bitreverse:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)  =>  (t2RBIT:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /* 127776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2RBIT),
     /* 127779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 127781 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 127783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127786 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127792 */     GIR_RootConstrainSelectedInstOperands,
     /* 127793 */     // GIR_Coverage, 535,
     /* 127793 */     GIR_EraseRootFromParent_Done,
     /* 127794 */   // Label 2565: @127794
     /* 127794 */   GIM_Reject,
     /* 127795 */ // Label 2563: @127795
     /* 127795 */ GIM_Reject,
     /* 127796 */ // Label 2559: @127796
     /* 127796 */ GIM_Try, /*On fail goto*//*Label 2566*/ GIMT_Encode4(127889), // Rule ID 4758 //
     /* 127801 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 127807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127811 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127815 */   // (bitreverse:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$val1)  =>  (MVE_VBRSR32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$val1, (t2MOVi:{ *:[i32] } 32:{ *:[i32] }))
     /* 127815 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 127818 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127822 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127827 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 127830 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 127834 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127839 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /* 127842 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 127845 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127851 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127857 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127859 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR32),
     /* 127862 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127864 */   GIR_RootToRootCopy, /*OpIdx*/1, // val1
     /* 127866 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127869 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127872 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127878 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127884 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 127887 */   GIR_RootConstrainSelectedInstOperands,
     /* 127888 */   // GIR_Coverage, 4758,
     /* 127888 */   GIR_EraseRootFromParent_Done,
     /* 127889 */ // Label 2566: @127889
     /* 127889 */ GIM_Reject,
     /* 127890 */ // Label 2560: @127890
     /* 127890 */ GIM_Try, /*On fail goto*//*Label 2567*/ GIMT_Encode4(127983), // Rule ID 4759 //
     /* 127895 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127898 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 127901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127905 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127909 */   // (bitreverse:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$val1)  =>  (MVE_VBRSR16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$val1, (t2MOVi:{ *:[i32] } 16:{ *:[i32] }))
     /* 127909 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 127912 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127916 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127921 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 127924 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 127928 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127933 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/16,
     /* 127936 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 127939 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127945 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127951 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127953 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR16),
     /* 127956 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127958 */   GIR_RootToRootCopy, /*OpIdx*/1, // val1
     /* 127960 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127963 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127966 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127972 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127978 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 127981 */   GIR_RootConstrainSelectedInstOperands,
     /* 127982 */   // GIR_Coverage, 4759,
     /* 127982 */   GIR_EraseRootFromParent_Done,
     /* 127983 */ // Label 2567: @127983
     /* 127983 */ GIM_Reject,
     /* 127984 */ // Label 2561: @127984
     /* 127984 */ GIM_Try, /*On fail goto*//*Label 2568*/ GIMT_Encode4(128077), // Rule ID 4757 //
     /* 127989 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127992 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 127995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127999 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128003 */   // (bitreverse:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$val1)  =>  (MVE_VBRSR8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$val1, (t2MOVi:{ *:[i32] } 8:{ *:[i32] }))
     /* 128003 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 128006 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 128010 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128015 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128018 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 128022 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128027 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 128030 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 128033 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128039 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128045 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128047 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR8),
     /* 128050 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 128052 */   GIR_RootToRootCopy, /*OpIdx*/1, // val1
     /* 128054 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128057 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128060 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128066 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128072 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 128075 */   GIR_RootConstrainSelectedInstOperands,
     /* 128076 */   // GIR_Coverage, 4757,
     /* 128076 */   GIR_EraseRootFromParent_Done,
     /* 128077 */ // Label 2568: @128077
     /* 128077 */ GIM_Reject,
     /* 128078 */ // Label 2562: @128078
     /* 128078 */ GIM_Reject,
     /* 128079 */ // Label 67: @128079
     /* 128079 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2574*/ GIMT_Encode4(128341),
     /* 128090 */ /*GILLT_s16*//*Label 2569*/ GIMT_Encode4(128142),
     /* 128094 */ /*GILLT_s32*//*Label 2570*/ GIMT_Encode4(128169),
     /* 128098 */ /*GILLT_s64*//*Label 2571*/ GIMT_Encode4(128196), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 128122 */ /*GILLT_v4s32*//*Label 2572*/ GIMT_Encode4(128223), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 128138 */ /*GILLT_v8s16*//*Label 2573*/ GIMT_Encode4(128282),
     /* 128142 */ // Label 2569: @128142
     /* 128142 */ GIM_Try, /*On fail goto*//*Label 2575*/ GIMT_Encode4(128168), // Rule ID 683 //
     /* 128147 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 128150 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 128153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128157 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128161 */   // (fceil:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTPH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 128161 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTPH),
     /* 128166 */   GIR_RootConstrainSelectedInstOperands,
     /* 128167 */   // GIR_Coverage, 683,
     /* 128167 */   GIR_Done,
     /* 128168 */ // Label 2575: @128168
     /* 128168 */ GIM_Reject,
     /* 128169 */ // Label 2570: @128169
     /* 128169 */ GIM_Try, /*On fail goto*//*Label 2576*/ GIMT_Encode4(128195), // Rule ID 684 //
     /* 128174 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 128177 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 128180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128184 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128188 */   // (fceil:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTPS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 128188 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTPS),
     /* 128193 */   GIR_RootConstrainSelectedInstOperands,
     /* 128194 */   // GIR_Coverage, 684,
     /* 128194 */   GIR_Done,
     /* 128195 */ // Label 2576: @128195
     /* 128195 */ GIM_Reject,
     /* 128196 */ // Label 2571: @128196
     /* 128196 */ GIM_Try, /*On fail goto*//*Label 2577*/ GIMT_Encode4(128222), // Rule ID 685 //
     /* 128201 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 128204 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 128207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128211 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128215 */   // (fceil:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTPD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 128215 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTPD),
     /* 128220 */   GIR_RootConstrainSelectedInstOperands,
     /* 128221 */   // GIR_Coverage, 685,
     /* 128221 */   GIR_Done,
     /* 128222 */ // Label 2577: @128222
     /* 128222 */ GIM_Reject,
     /* 128223 */ // Label 2572: @128223
     /* 128223 */ GIM_Try, /*On fail goto*//*Label 2578*/ GIMT_Encode4(128281), // Rule ID 3986 //
     /* 128228 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 128231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 128234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128238 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128242 */   // (fceil:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32P:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /* 128242 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 128245 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 128249 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128254 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32P),
     /* 128257 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 128259 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 128261 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128264 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128270 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128276 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128279 */   GIR_RootConstrainSelectedInstOperands,
     /* 128280 */   // GIR_Coverage, 3986,
     /* 128280 */   GIR_EraseRootFromParent_Done,
     /* 128281 */ // Label 2578: @128281
     /* 128281 */ GIM_Reject,
     /* 128282 */ // Label 2573: @128282
     /* 128282 */ GIM_Try, /*On fail goto*//*Label 2579*/ GIMT_Encode4(128340), // Rule ID 3974 //
     /* 128287 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 128290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 128293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128297 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128301 */   // (fceil:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16P:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /* 128301 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 128304 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 128308 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128313 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16P),
     /* 128316 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 128318 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 128320 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128323 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128329 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128335 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128338 */   GIR_RootConstrainSelectedInstOperands,
     /* 128339 */   // GIR_Coverage, 3974,
     /* 128339 */   GIR_EraseRootFromParent_Done,
     /* 128340 */ // Label 2579: @128340
     /* 128340 */ GIM_Reject,
     /* 128341 */ // Label 2574: @128341
     /* 128341 */ GIM_Reject,
     /* 128342 */ // Label 68: @128342
     /* 128342 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 2583*/ GIMT_Encode4(128479),
     /* 128353 */ /*GILLT_s16*//*Label 2580*/ GIMT_Encode4(128365),
     /* 128357 */ /*GILLT_s32*//*Label 2581*/ GIMT_Encode4(128403),
     /* 128361 */ /*GILLT_s64*//*Label 2582*/ GIMT_Encode4(128441),
     /* 128365 */ // Label 2580: @128365
     /* 128365 */ GIM_Try, /*On fail goto*//*Label 2584*/ GIMT_Encode4(128402), // Rule ID 691 //
     /* 128370 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 128373 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 128376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128380 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128384 */   // (fsqrt:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VSQRTH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 128384 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSQRTH),
     /* 128387 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 128389 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 128391 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 128394 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128400 */   GIR_RootConstrainSelectedInstOperands,
     /* 128401 */   // GIR_Coverage, 691,
     /* 128401 */   GIR_EraseRootFromParent_Done,
     /* 128402 */ // Label 2584: @128402
     /* 128402 */ GIM_Reject,
     /* 128403 */ // Label 2581: @128403
     /* 128403 */ GIM_Try, /*On fail goto*//*Label 2585*/ GIMT_Encode4(128440), // Rule ID 690 //
     /* 128408 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP2),
     /* 128411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 128414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128418 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128422 */   // (fsqrt:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VSQRTS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 128422 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSQRTS),
     /* 128425 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 128427 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 128429 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 128432 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128438 */   GIR_RootConstrainSelectedInstOperands,
     /* 128439 */   // GIR_Coverage, 690,
     /* 128439 */   GIR_EraseRootFromParent_Done,
     /* 128440 */ // Label 2585: @128440
     /* 128440 */ GIM_Reject,
     /* 128441 */ // Label 2582: @128441
     /* 128441 */ GIM_Try, /*On fail goto*//*Label 2586*/ GIMT_Encode4(128478), // Rule ID 689 //
     /* 128446 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 128449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 128452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128456 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128460 */   // (fsqrt:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VSQRTD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 128460 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSQRTD),
     /* 128463 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 128465 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 128467 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 128470 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128476 */   GIR_RootConstrainSelectedInstOperands,
     /* 128477 */   // GIR_Coverage, 689,
     /* 128477 */   GIR_EraseRootFromParent_Done,
     /* 128478 */ // Label 2586: @128478
     /* 128478 */ GIM_Reject,
     /* 128479 */ // Label 2583: @128479
     /* 128479 */ GIM_Reject,
     /* 128480 */ // Label 69: @128480
     /* 128480 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2594*/ GIMT_Encode4(128854),
     /* 128491 */ /*GILLT_s16*//*Label 2587*/ GIMT_Encode4(128543),
     /* 128495 */ /*GILLT_s32*//*Label 2588*/ GIMT_Encode4(128570),
     /* 128499 */ /*GILLT_s64*//*Label 2589*/ GIMT_Encode4(128597), GIMT_Encode4(0),
     /* 128507 */ /*GILLT_v2s32*//*Label 2590*/ GIMT_Encode4(128624), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 128519 */ /*GILLT_v4s16*//*Label 2591*/ GIMT_Encode4(128651),
     /* 128523 */ /*GILLT_v4s32*//*Label 2592*/ GIMT_Encode4(128678), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 128539 */ /*GILLT_v8s16*//*Label 2593*/ GIMT_Encode4(128766),
     /* 128543 */ // Label 2587: @128543
     /* 128543 */ GIM_Try, /*On fail goto*//*Label 2595*/ GIMT_Encode4(128569), // Rule ID 686 //
     /* 128548 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 128551 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 128554 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128558 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128562 */   // (ffloor:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTMH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 128562 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTMH),
     /* 128567 */   GIR_RootConstrainSelectedInstOperands,
     /* 128568 */   // GIR_Coverage, 686,
     /* 128568 */   GIR_Done,
     /* 128569 */ // Label 2595: @128569
     /* 128569 */ GIM_Reject,
     /* 128570 */ // Label 2588: @128570
     /* 128570 */ GIM_Try, /*On fail goto*//*Label 2596*/ GIMT_Encode4(128596), // Rule ID 687 //
     /* 128575 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 128578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 128581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128585 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128589 */   // (ffloor:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTMS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 128589 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTMS),
     /* 128594 */   GIR_RootConstrainSelectedInstOperands,
     /* 128595 */   // GIR_Coverage, 687,
     /* 128595 */   GIR_Done,
     /* 128596 */ // Label 2596: @128596
     /* 128596 */ GIM_Reject,
     /* 128597 */ // Label 2589: @128597
     /* 128597 */ GIM_Try, /*On fail goto*//*Label 2597*/ GIMT_Encode4(128623), // Rule ID 688 //
     /* 128602 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 128605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 128608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128612 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128616 */   // (ffloor:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTMD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 128616 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTMD),
     /* 128621 */   GIR_RootConstrainSelectedInstOperands,
     /* 128622 */   // GIR_Coverage, 688,
     /* 128622 */   GIR_Done,
     /* 128623 */ // Label 2597: @128623
     /* 128623 */ GIM_Reject,
     /* 128624 */ // Label 2590: @128624
     /* 128624 */ GIM_Try, /*On fail goto*//*Label 2598*/ GIMT_Encode4(128650), // Rule ID 1707 //
     /* 128629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /* 128632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 128635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128639 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128643 */   // (ffloor:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTMNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /* 128643 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTMNDf),
     /* 128648 */   GIR_RootConstrainSelectedInstOperands,
     /* 128649 */   // GIR_Coverage, 1707,
     /* 128649 */   GIR_Done,
     /* 128650 */ // Label 2598: @128650
     /* 128650 */ GIM_Reject,
     /* 128651 */ // Label 2591: @128651
     /* 128651 */ GIM_Try, /*On fail goto*//*Label 2599*/ GIMT_Encode4(128677), // Rule ID 1709 //
     /* 128656 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /* 128659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 128662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128666 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128670 */   // (ffloor:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTMNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /* 128670 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTMNDh),
     /* 128675 */   GIR_RootConstrainSelectedInstOperands,
     /* 128676 */   // GIR_Coverage, 1709,
     /* 128676 */   GIR_Done,
     /* 128677 */ // Label 2599: @128677
     /* 128677 */ GIM_Reject,
     /* 128678 */ // Label 2592: @128678
     /* 128678 */ GIM_Try, /*On fail goto*//*Label 2600*/ GIMT_Encode4(128765),
     /* 128683 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 128686 */   GIM_Try, /*On fail goto*//*Label 2601*/ GIMT_Encode4(128709), // Rule ID 1708 //
     /* 128691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /* 128694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 128698 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 128702 */     // (ffloor:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTMNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /* 128702 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTMNQf),
     /* 128707 */     GIR_RootConstrainSelectedInstOperands,
     /* 128708 */     // GIR_Coverage, 1708,
     /* 128708 */     GIR_Done,
     /* 128709 */   // Label 2601: @128709
     /* 128709 */   GIM_Try, /*On fail goto*//*Label 2602*/ GIMT_Encode4(128764), // Rule ID 3984 //
     /* 128714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 128717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128725 */     // (ffloor:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32M:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /* 128725 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 128728 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 128732 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32M),
     /* 128740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 128742 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 128744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128747 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128753 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128759 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128762 */     GIR_RootConstrainSelectedInstOperands,
     /* 128763 */     // GIR_Coverage, 3984,
     /* 128763 */     GIR_EraseRootFromParent_Done,
     /* 128764 */   // Label 2602: @128764
     /* 128764 */   GIM_Reject,
     /* 128765 */ // Label 2600: @128765
     /* 128765 */ GIM_Reject,
     /* 128766 */ // Label 2593: @128766
     /* 128766 */ GIM_Try, /*On fail goto*//*Label 2603*/ GIMT_Encode4(128853),
     /* 128771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 128774 */   GIM_Try, /*On fail goto*//*Label 2604*/ GIMT_Encode4(128797), // Rule ID 1710 //
     /* 128779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /* 128782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 128786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 128790 */     // (ffloor:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTMNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /* 128790 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTMNQh),
     /* 128795 */     GIR_RootConstrainSelectedInstOperands,
     /* 128796 */     // GIR_Coverage, 1710,
     /* 128796 */     GIR_Done,
     /* 128797 */   // Label 2604: @128797
     /* 128797 */   GIM_Try, /*On fail goto*//*Label 2605*/ GIMT_Encode4(128852), // Rule ID 3972 //
     /* 128802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 128805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128813 */     // (ffloor:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16M:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /* 128813 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 128816 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 128820 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16M),
     /* 128828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 128830 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 128832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128835 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128841 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128847 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128850 */     GIR_RootConstrainSelectedInstOperands,
     /* 128851 */     // GIR_Coverage, 3972,
     /* 128851 */     GIR_EraseRootFromParent_Done,
     /* 128852 */   // Label 2605: @128852
     /* 128852 */   GIM_Reject,
     /* 128853 */ // Label 2603: @128853
     /* 128853 */ GIM_Reject,
     /* 128854 */ // Label 2594: @128854
     /* 128854 */ GIM_Reject,
     /* 128855 */ // Label 70: @128855
     /* 128855 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2611*/ GIMT_Encode4(129150),
     /* 128866 */ /*GILLT_s16*//*Label 2606*/ GIMT_Encode4(128918),
     /* 128870 */ /*GILLT_s32*//*Label 2607*/ GIMT_Encode4(128956),
     /* 128874 */ /*GILLT_s64*//*Label 2608*/ GIMT_Encode4(128994), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 128898 */ /*GILLT_v4s32*//*Label 2609*/ GIMT_Encode4(129032), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 128914 */ /*GILLT_v8s16*//*Label 2610*/ GIMT_Encode4(129091),
     /* 128918 */ // Label 2606: @128918
     /* 128918 */ GIM_Try, /*On fail goto*//*Label 2612*/ GIMT_Encode4(128955), // Rule ID 671 //
     /* 128923 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 128926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 128929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128933 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128937 */   // (frint:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTXH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 128937 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXH),
     /* 128940 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 128942 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 128944 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 128947 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128953 */   GIR_RootConstrainSelectedInstOperands,
     /* 128954 */   // GIR_Coverage, 671,
     /* 128954 */   GIR_EraseRootFromParent_Done,
     /* 128955 */ // Label 2612: @128955
     /* 128955 */ GIM_Reject,
     /* 128956 */ // Label 2607: @128956
     /* 128956 */ GIM_Try, /*On fail goto*//*Label 2613*/ GIMT_Encode4(128993), // Rule ID 672 //
     /* 128961 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 128964 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 128967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128971 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128975 */   // (frint:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTXS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 128975 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXS),
     /* 128978 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 128980 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 128982 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 128985 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128991 */   GIR_RootConstrainSelectedInstOperands,
     /* 128992 */   // GIR_Coverage, 672,
     /* 128992 */   GIR_EraseRootFromParent_Done,
     /* 128993 */ // Label 2613: @128993
     /* 128993 */ GIM_Reject,
     /* 128994 */ // Label 2608: @128994
     /* 128994 */ GIM_Try, /*On fail goto*//*Label 2614*/ GIMT_Encode4(129031), // Rule ID 673 //
     /* 128999 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 129002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 129005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 129009 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 129013 */   // (frint:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTXD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 129013 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXD),
     /* 129016 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 129018 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 129020 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 129023 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129029 */   GIR_RootConstrainSelectedInstOperands,
     /* 129030 */   // GIR_Coverage, 673,
     /* 129030 */   GIR_EraseRootFromParent_Done,
     /* 129031 */ // Label 2614: @129031
     /* 129031 */ GIM_Reject,
     /* 129032 */ // Label 2609: @129032
     /* 129032 */ GIM_Try, /*On fail goto*//*Label 2615*/ GIMT_Encode4(129090), // Rule ID 3978 //
     /* 129037 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 129040 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 129043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129047 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129051 */   // (frint:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32X:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /* 129051 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 129054 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 129058 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129063 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32X),
     /* 129066 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 129068 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 129070 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129073 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129079 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129085 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129088 */   GIR_RootConstrainSelectedInstOperands,
     /* 129089 */   // GIR_Coverage, 3978,
     /* 129089 */   GIR_EraseRootFromParent_Done,
     /* 129090 */ // Label 2615: @129090
     /* 129090 */ GIM_Reject,
     /* 129091 */ // Label 2610: @129091
     /* 129091 */ GIM_Try, /*On fail goto*//*Label 2616*/ GIMT_Encode4(129149), // Rule ID 3966 //
     /* 129096 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 129099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 129102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129106 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129110 */   // (frint:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16X:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /* 129110 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 129113 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 129117 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129122 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16X),
     /* 129125 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 129127 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 129129 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129132 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129138 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129144 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129147 */   GIR_RootConstrainSelectedInstOperands,
     /* 129148 */   // GIR_Coverage, 3966,
     /* 129148 */   GIR_EraseRootFromParent_Done,
     /* 129149 */ // Label 2616: @129149
     /* 129149 */ GIM_Reject,
     /* 129150 */ // Label 2611: @129150
     /* 129150 */ GIM_Reject,
     /* 129151 */ // Label 71: @129151
     /* 129151 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 2620*/ GIMT_Encode4(129288),
     /* 129162 */ /*GILLT_s16*//*Label 2617*/ GIMT_Encode4(129174),
     /* 129166 */ /*GILLT_s32*//*Label 2618*/ GIMT_Encode4(129212),
     /* 129170 */ /*GILLT_s64*//*Label 2619*/ GIMT_Encode4(129250),
     /* 129174 */ // Label 2617: @129174
     /* 129174 */ GIM_Try, /*On fail goto*//*Label 2621*/ GIMT_Encode4(129211), // Rule ID 668 //
     /* 129179 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 129182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 129185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 129189 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 129193 */   // (fnearbyint:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTRH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 129193 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTRH),
     /* 129196 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 129198 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 129200 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 129203 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129209 */   GIR_RootConstrainSelectedInstOperands,
     /* 129210 */   // GIR_Coverage, 668,
     /* 129210 */   GIR_EraseRootFromParent_Done,
     /* 129211 */ // Label 2621: @129211
     /* 129211 */ GIM_Reject,
     /* 129212 */ // Label 2618: @129212
     /* 129212 */ GIM_Try, /*On fail goto*//*Label 2622*/ GIMT_Encode4(129249), // Rule ID 669 //
     /* 129217 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 129220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 129223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 129227 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 129231 */   // (fnearbyint:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTRS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 129231 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTRS),
     /* 129234 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 129236 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 129238 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 129241 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129247 */   GIR_RootConstrainSelectedInstOperands,
     /* 129248 */   // GIR_Coverage, 669,
     /* 129248 */   GIR_EraseRootFromParent_Done,
     /* 129249 */ // Label 2622: @129249
     /* 129249 */ GIM_Reject,
     /* 129250 */ // Label 2619: @129250
     /* 129250 */ GIM_Try, /*On fail goto*//*Label 2623*/ GIMT_Encode4(129287), // Rule ID 670 //
     /* 129255 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 129258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 129261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 129265 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 129269 */   // (fnearbyint:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTRD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 129269 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTRD),
     /* 129272 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 129274 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 129276 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 129279 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129285 */   GIR_RootConstrainSelectedInstOperands,
     /* 129286 */   // GIR_Coverage, 670,
     /* 129286 */   GIR_EraseRootFromParent_Done,
     /* 129287 */ // Label 2623: @129287
     /* 129287 */ GIM_Reject,
     /* 129288 */ // Label 2620: @129288
     /* 129288 */ GIM_Reject,
     /* 129289 */ // Label 72: @129289
     /* 129289 */ GIM_Try, /*On fail goto*//*Label 2624*/ GIMT_Encode4(129304), // Rule ID 12 //
     /* 129294 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_UseNaClTrap),
     /* 129297 */   // (trap)  =>  (TRAPNaCl)
     /* 129297 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::TRAPNaCl),
     /* 129302 */   GIR_RootConstrainSelectedInstOperands,
     /* 129303 */   // GIR_Coverage, 12,
     /* 129303 */   GIR_Done,
     /* 129304 */ // Label 2624: @129304
     /* 129304 */ GIM_Try, /*On fail goto*//*Label 2625*/ GIMT_Encode4(129319), // Rule ID 13 //
     /* 129309 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNaClTrap_IsARM),
     /* 129312 */   // (trap)  =>  (TRAP)
     /* 129312 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::TRAP),
     /* 129317 */   GIR_RootConstrainSelectedInstOperands,
     /* 129318 */   // GIR_Coverage, 13,
     /* 129318 */   GIR_Done,
     /* 129319 */ // Label 2625: @129319
     /* 129319 */ GIM_Try, /*On fail goto*//*Label 2626*/ GIMT_Encode4(129334), // Rule ID 285 //
     /* 129324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb),
     /* 129327 */   // (trap)  =>  (tTRAP)
     /* 129327 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::tTRAP),
     /* 129332 */   GIR_RootConstrainSelectedInstOperands,
     /* 129333 */   // GIR_Coverage, 285,
     /* 129333 */   GIR_Done,
     /* 129334 */ // Label 2626: @129334
     /* 129334 */ GIM_Reject,
     /* 129335 */ // Label 73: @129335
     /* 129335 */ GIM_Try, /*On fail goto*//*Label 2627*/ GIMT_Encode4(129351), // Rule ID 1838 //
     /* 129340 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5T_IsARM),
     /* 129343 */   // (debugtrap)  =>  (BKPT 0:{ *:[i32] })
     /* 129343 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BKPT),
     /* 129346 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129349 */   GIR_RootConstrainSelectedInstOperands,
     /* 129350 */   // GIR_Coverage, 1838,
     /* 129350 */   GIR_EraseRootFromParent_Done,
     /* 129351 */ // Label 2627: @129351
     /* 129351 */ GIM_Try, /*On fail goto*//*Label 2628*/ GIMT_Encode4(129378), // Rule ID 1839 //
     /* 129356 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_NoV5T),
     /* 129359 */   // (debugtrap)  =>  (UDF 254:{ *:[i32] })
     /* 129359 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UDF),
     /* 129362 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(254),
     /* 129372 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129376 */   GIR_RootConstrainSelectedInstOperands,
     /* 129377 */   // GIR_Coverage, 1839,
     /* 129377 */   GIR_EraseRootFromParent_Done,
     /* 129378 */ // Label 2628: @129378
     /* 129378 */ GIM_Try, /*On fail goto*//*Label 2629*/ GIMT_Encode4(129394), // Rule ID 2024 //
     /* 129383 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5T_IsThumb),
     /* 129386 */   // (debugtrap)  =>  (tBKPT 0:{ *:[i32] })
     /* 129386 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tBKPT),
     /* 129389 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129392 */   GIR_RootConstrainSelectedInstOperands,
     /* 129393 */   // GIR_Coverage, 2024,
     /* 129393 */   GIR_EraseRootFromParent_Done,
     /* 129394 */ // Label 2629: @129394
     /* 129394 */ GIM_Try, /*On fail goto*//*Label 2630*/ GIMT_Encode4(129421), // Rule ID 2025 //
     /* 129399 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_NoV5T),
     /* 129402 */   // (debugtrap)  =>  (tUDF 254:{ *:[i32] })
     /* 129402 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tUDF),
     /* 129405 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(254),
     /* 129415 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129419 */   GIR_RootConstrainSelectedInstOperands,
     /* 129420 */   // GIR_Coverage, 2025,
     /* 129420 */   GIR_EraseRootFromParent_Done,
     /* 129421 */ // Label 2630: @129421
     /* 129421 */ GIM_Reject,
     /* 129422 */ // Label 74: @129422
     /* 129422 */ GIM_Try, /*On fail goto*//*Label 2631*/ GIMT_Encode4(129842),
     /* 129427 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 129430 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 2635*/ GIMT_Encode4(129728),
     /* 129441 */   /*GILLT_v4s32*//*Label 2632*/ GIMT_Encode4(129473), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129457 */   /*GILLT_v8s16*//*Label 2633*/ GIMT_Encode4(129544), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129469 */   /*GILLT_v16s8*//*Label 2634*/ GIMT_Encode4(129615),
     /* 129473 */   // Label 2632: @129473
     /* 129473 */   GIM_Try, /*On fail goto*//*Label 2636*/ GIMT_Encode4(129543), // Rule ID 3241 //
     /* 129478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /* 129485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 129493 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 129497 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 129501 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129506 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129513 */     // (vecreduce_add:{ *:[i32] } (mul:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src1, MQPR:{ *:[v4i32] }:$src2))  =>  (MVE_VMLADAVu32:{ *:[i32] } ?:{ *:[v4i32] }:$src1, ?:{ *:[v4i32] }:$src2)
     /* 129513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu32),
     /* 129516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 129518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 129522 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 129526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129529 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129535 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129541 */     GIR_RootConstrainSelectedInstOperands,
     /* 129542 */     // GIR_Coverage, 3241,
     /* 129542 */     GIR_EraseRootFromParent_Done,
     /* 129543 */   // Label 2636: @129543
     /* 129543 */   GIM_Reject,
     /* 129544 */   // Label 2633: @129544
     /* 129544 */   GIM_Try, /*On fail goto*//*Label 2637*/ GIMT_Encode4(129614), // Rule ID 3242 //
     /* 129549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /* 129556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 129564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 129568 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 129572 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129577 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129582 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129584 */     // (vecreduce_add:{ *:[i32] } (mul:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, MQPR:{ *:[v8i16] }:$src2))  =>  (MVE_VMLADAVu16:{ *:[i32] } ?:{ *:[v8i16] }:$src1, ?:{ *:[v8i16] }:$src2)
     /* 129584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu16),
     /* 129587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 129589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 129593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 129597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129600 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129606 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129612 */     GIR_RootConstrainSelectedInstOperands,
     /* 129613 */     // GIR_Coverage, 3242,
     /* 129613 */     GIR_EraseRootFromParent_Done,
     /* 129614 */   // Label 2637: @129614
     /* 129614 */   GIM_Reject,
     /* 129615 */   // Label 2634: @129615
     /* 129615 */   GIM_Try, /*On fail goto*//*Label 2638*/ GIMT_Encode4(129727),
     /* 129620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /* 129624 */     GIM_Try, /*On fail goto*//*Label 2639*/ GIMT_Encode4(129690), // Rule ID 3245 //
     /* 129629 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129632 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129636 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 129640 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 129644 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 129648 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129653 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129658 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129660 */       // (vecreduce_add:{ *:[i32] } (mul:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src1, MQPR:{ *:[v16i8] }:$src2))  =>  (MVE_VMLADAVu8:{ *:[i32] } ?:{ *:[v16i8] }:$src1, ?:{ *:[v16i8] }:$src2)
     /* 129660 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu8),
     /* 129663 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 129665 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 129669 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 129673 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129676 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129682 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129688 */       GIR_RootConstrainSelectedInstOperands,
     /* 129689 */       // GIR_Coverage, 3245,
     /* 129689 */       GIR_EraseRootFromParent_Done,
     /* 129690 */     // Label 2639: @129690
     /* 129690 */     GIM_Try, /*On fail goto*//*Label 2640*/ GIMT_Encode4(129726), // Rule ID 3049 //
     /* 129695 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129698 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129702 */       // (vecreduce_add:{ *:[i32] } MQPR:{ *:[v16i8] }:$vec)  =>  (MVE_VADDVu8no_acc:{ *:[i32] } ?:{ *:[v16i8] }:$vec)
     /* 129702 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu8no_acc),
     /* 129705 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /* 129707 */       GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 129709 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129712 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129718 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129724 */       GIR_RootConstrainSelectedInstOperands,
     /* 129725 */       // GIR_Coverage, 3049,
     /* 129725 */       GIR_EraseRootFromParent_Done,
     /* 129726 */     // Label 2640: @129726
     /* 129726 */     GIM_Reject,
     /* 129727 */   // Label 2638: @129727
     /* 129727 */   GIM_Reject,
     /* 129728 */   // Label 2635: @129728
     /* 129728 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(13), /*)*//*default:*//*Label 2643*/ GIMT_Encode4(129841),
     /* 129739 */   /*GILLT_v4s32*//*Label 2641*/ GIMT_Encode4(129759), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129755 */   /*GILLT_v8s16*//*Label 2642*/ GIMT_Encode4(129800),
     /* 129759 */   // Label 2641: @129759
     /* 129759 */   GIM_Try, /*On fail goto*//*Label 2644*/ GIMT_Encode4(129799), // Rule ID 3087 //
     /* 129764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /* 129771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129775 */     // (vecreduce_add:{ *:[i32] } MQPR:{ *:[v4i32] }:$vec)  =>  (MVE_VADDVu32no_acc:{ *:[i32] } ?:{ *:[v4i32] }:$vec)
     /* 129775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu32no_acc),
     /* 129778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /* 129780 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 129782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129785 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129791 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129797 */     GIR_RootConstrainSelectedInstOperands,
     /* 129798 */     // GIR_Coverage, 3087,
     /* 129798 */     GIR_EraseRootFromParent_Done,
     /* 129799 */   // Label 2644: @129799
     /* 129799 */   GIM_Reject,
     /* 129800 */   // Label 2642: @129800
     /* 129800 */   GIM_Try, /*On fail goto*//*Label 2645*/ GIMT_Encode4(129840), // Rule ID 3077 //
     /* 129805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /* 129812 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129816 */     // (vecreduce_add:{ *:[i32] } MQPR:{ *:[v8i16] }:$vec)  =>  (MVE_VADDVu16no_acc:{ *:[i32] } ?:{ *:[v8i16] }:$vec)
     /* 129816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu16no_acc),
     /* 129819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /* 129821 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 129823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129826 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129832 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129838 */     GIR_RootConstrainSelectedInstOperands,
     /* 129839 */     // GIR_Coverage, 3077,
     /* 129839 */     GIR_EraseRootFromParent_Done,
     /* 129840 */   // Label 2645: @129840
     /* 129840 */   GIM_Reject,
     /* 129841 */   // Label 2643: @129841
     /* 129841 */   GIM_Reject,
     /* 129842 */ // Label 2631: @129842
     /* 129842 */ GIM_Reject,
     /* 129843 */ // Label 75: @129843
     /* 129843 */ GIM_Try, /*On fail goto*//*Label 2646*/ GIMT_Encode4(130122),
     /* 129848 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 129851 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 2650*/ GIMT_Encode4(130121),
     /* 129862 */   /*GILLT_v4s32*//*Label 2647*/ GIMT_Encode4(129894), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129878 */   /*GILLT_v8s16*//*Label 2648*/ GIMT_Encode4(129977), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129890 */   /*GILLT_v16s8*//*Label 2649*/ GIMT_Encode4(130045),
     /* 129894 */   // Label 2647: @129894
     /* 129894 */   GIM_Try, /*On fail goto*//*Label 2651*/ GIMT_Encode4(129976), // Rule ID 3147 //
     /* 129899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 129906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129910 */     // (vecreduce_smax:{ *:[i32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VMAXVs32:{ *:[i32] } (t2MOVi:{ *:[i32] } -2147483648:{ *:[i32] }), ?:{ *:[v4i32] }:$src)
     /* 129910 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129913 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 129917 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129922 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(-2147483648),
     /* 129932 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 129935 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129941 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129947 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs32),
     /* 129952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 129954 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129957 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 129959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129962 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129968 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129974 */     GIR_RootConstrainSelectedInstOperands,
     /* 129975 */     // GIR_Coverage, 3147,
     /* 129975 */     GIR_EraseRootFromParent_Done,
     /* 129976 */   // Label 2651: @129976
     /* 129976 */   GIM_Reject,
     /* 129977 */   // Label 2648: @129977
     /* 129977 */   GIM_Try, /*On fail goto*//*Label 2652*/ GIMT_Encode4(130044), // Rule ID 3146 //
     /* 129982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 129989 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129993 */     // (vecreduce_smax:{ *:[i32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VMAXVs16:{ *:[i32] } (t2MOVi32imm:{ *:[i32] } -32768:{ *:[i32] }), ?:{ *:[v8i16] }:$src)
     /* 129993 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129996 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi32imm),
     /* 130000 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130005 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(-32768),
     /* 130015 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs16),
     /* 130020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130022 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130025 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130030 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130036 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130042 */     GIR_RootConstrainSelectedInstOperands,
     /* 130043 */     // GIR_Coverage, 3146,
     /* 130043 */     GIR_EraseRootFromParent_Done,
     /* 130044 */   // Label 2652: @130044
     /* 130044 */   GIM_Reject,
     /* 130045 */   // Label 2649: @130045
     /* 130045 */   GIM_Try, /*On fail goto*//*Label 2653*/ GIMT_Encode4(130120), // Rule ID 3145 //
     /* 130050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130057 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130061 */     // (vecreduce_smax:{ *:[i32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VMAXVs8:{ *:[i32] } (t2MVNi:{ *:[i32] } 127:{ *:[i32] }), ?:{ *:[v16i8] }:$src)
     /* 130061 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130064 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MVNi),
     /* 130068 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130073 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/127,
     /* 130076 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130079 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130085 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130091 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs8),
     /* 130096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130098 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130101 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130106 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130112 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130118 */     GIR_RootConstrainSelectedInstOperands,
     /* 130119 */     // GIR_Coverage, 3145,
     /* 130119 */     GIR_EraseRootFromParent_Done,
     /* 130120 */   // Label 2653: @130120
     /* 130120 */   GIM_Reject,
     /* 130121 */   // Label 2650: @130121
     /* 130121 */   GIM_Reject,
     /* 130122 */ // Label 2646: @130122
     /* 130122 */ GIM_Reject,
     /* 130123 */ // Label 76: @130123
     /* 130123 */ GIM_Try, /*On fail goto*//*Label 2654*/ GIMT_Encode4(130411),
     /* 130128 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 130131 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 2658*/ GIMT_Encode4(130410),
     /* 130142 */   /*GILLT_v4s32*//*Label 2655*/ GIMT_Encode4(130174), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130158 */   /*GILLT_v8s16*//*Label 2656*/ GIMT_Encode4(130257), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130170 */   /*GILLT_v16s8*//*Label 2657*/ GIMT_Encode4(130334),
     /* 130174 */   // Label 2655: @130174
     /* 130174 */   GIM_Try, /*On fail goto*//*Label 2659*/ GIMT_Encode4(130256), // Rule ID 3153 //
     /* 130179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130186 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130190 */     // (vecreduce_smin:{ *:[i32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VMINVs32:{ *:[i32] } (t2MVNi:{ *:[i32] } -2147483648:{ *:[i32] }), ?:{ *:[v4i32] }:$src)
     /* 130190 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130193 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MVNi),
     /* 130197 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130202 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(-2147483648),
     /* 130212 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130215 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130221 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs32),
     /* 130232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130237 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130242 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130248 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130254 */     GIR_RootConstrainSelectedInstOperands,
     /* 130255 */     // GIR_Coverage, 3153,
     /* 130255 */     GIR_EraseRootFromParent_Done,
     /* 130256 */   // Label 2659: @130256
     /* 130256 */   GIM_Reject,
     /* 130257 */   // Label 2656: @130257
     /* 130257 */   GIM_Try, /*On fail goto*//*Label 2660*/ GIMT_Encode4(130333), // Rule ID 3152 //
     /* 130262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130269 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130273 */     // (vecreduce_smin:{ *:[i32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VMINVs16:{ *:[i32] } (t2MOVi16:{ *:[i32] } 32767:{ *:[i32] }), ?:{ *:[v8i16] }:$src)
     /* 130273 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130276 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi16),
     /* 130280 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130285 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32767),
     /* 130295 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130298 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130304 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs16),
     /* 130309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130311 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130314 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130319 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130325 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130331 */     GIR_RootConstrainSelectedInstOperands,
     /* 130332 */     // GIR_Coverage, 3152,
     /* 130332 */     GIR_EraseRootFromParent_Done,
     /* 130333 */   // Label 2660: @130333
     /* 130333 */   GIM_Reject,
     /* 130334 */   // Label 2657: @130334
     /* 130334 */   GIM_Try, /*On fail goto*//*Label 2661*/ GIMT_Encode4(130409), // Rule ID 3151 //
     /* 130339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130346 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130350 */     // (vecreduce_smin:{ *:[i32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VMINVs8:{ *:[i32] } (t2MOVi:{ *:[i32] } 127:{ *:[i32] }), ?:{ *:[v16i8] }:$src)
     /* 130350 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130353 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130357 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130362 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/127,
     /* 130365 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130368 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130374 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs8),
     /* 130385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130387 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130390 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130395 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130401 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130407 */     GIR_RootConstrainSelectedInstOperands,
     /* 130408 */     // GIR_Coverage, 3151,
     /* 130408 */     GIR_EraseRootFromParent_Done,
     /* 130409 */   // Label 2661: @130409
     /* 130409 */   GIM_Reject,
     /* 130410 */   // Label 2658: @130410
     /* 130410 */   GIM_Reject,
     /* 130411 */ // Label 2654: @130411
     /* 130411 */ GIM_Reject,
     /* 130412 */ // Label 77: @130412
     /* 130412 */ GIM_Try, /*On fail goto*//*Label 2662*/ GIMT_Encode4(130692),
     /* 130417 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 130420 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 2666*/ GIMT_Encode4(130691),
     /* 130431 */   /*GILLT_v4s32*//*Label 2663*/ GIMT_Encode4(130463), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130447 */   /*GILLT_v8s16*//*Label 2664*/ GIMT_Encode4(130539), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130459 */   /*GILLT_v16s8*//*Label 2665*/ GIMT_Encode4(130615),
     /* 130463 */   // Label 2663: @130463
     /* 130463 */   GIM_Try, /*On fail goto*//*Label 2667*/ GIMT_Encode4(130538), // Rule ID 3150 //
     /* 130468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130479 */     // (vecreduce_umax:{ *:[i32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VMAXVu32:{ *:[i32] } (t2MOVi:{ *:[i32] } 0:{ *:[i32] }), ?:{ *:[v4i32] }:$src)
     /* 130479 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130482 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130486 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130491 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 130494 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130497 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130503 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130509 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu32),
     /* 130514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130516 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130519 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130524 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130530 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130536 */     GIR_RootConstrainSelectedInstOperands,
     /* 130537 */     // GIR_Coverage, 3150,
     /* 130537 */     GIR_EraseRootFromParent_Done,
     /* 130538 */   // Label 2667: @130538
     /* 130538 */   GIM_Reject,
     /* 130539 */   // Label 2664: @130539
     /* 130539 */   GIM_Try, /*On fail goto*//*Label 2668*/ GIMT_Encode4(130614), // Rule ID 3149 //
     /* 130544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130555 */     // (vecreduce_umax:{ *:[i32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VMAXVu16:{ *:[i32] } (t2MOVi:{ *:[i32] } 0:{ *:[i32] }), ?:{ *:[v8i16] }:$src)
     /* 130555 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130558 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130562 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130567 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 130570 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130573 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130579 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130585 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu16),
     /* 130590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130592 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130595 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130600 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130606 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130612 */     GIR_RootConstrainSelectedInstOperands,
     /* 130613 */     // GIR_Coverage, 3149,
     /* 130613 */     GIR_EraseRootFromParent_Done,
     /* 130614 */   // Label 2668: @130614
     /* 130614 */   GIM_Reject,
     /* 130615 */   // Label 2665: @130615
     /* 130615 */   GIM_Try, /*On fail goto*//*Label 2669*/ GIMT_Encode4(130690), // Rule ID 3148 //
     /* 130620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130631 */     // (vecreduce_umax:{ *:[i32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VMAXVu8:{ *:[i32] } (t2MOVi:{ *:[i32] } 0:{ *:[i32] }), ?:{ *:[v16i8] }:$src)
     /* 130631 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130634 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130638 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130643 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 130646 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130649 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130655 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130661 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu8),
     /* 130666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130668 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130671 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130676 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130682 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130688 */     GIR_RootConstrainSelectedInstOperands,
     /* 130689 */     // GIR_Coverage, 3148,
     /* 130689 */     GIR_EraseRootFromParent_Done,
     /* 130690 */   // Label 2669: @130690
     /* 130690 */   GIM_Reject,
     /* 130691 */   // Label 2666: @130691
     /* 130691 */   GIM_Reject,
     /* 130692 */ // Label 2662: @130692
     /* 130692 */ GIM_Reject,
     /* 130693 */ // Label 78: @130693
     /* 130693 */ GIM_Try, /*On fail goto*//*Label 2670*/ GIMT_Encode4(130988),
     /* 130698 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 130701 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 2674*/ GIMT_Encode4(130987),
     /* 130712 */   /*GILLT_v4s32*//*Label 2671*/ GIMT_Encode4(130744), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130728 */   /*GILLT_v8s16*//*Label 2672*/ GIMT_Encode4(130827), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130740 */   /*GILLT_v16s8*//*Label 2673*/ GIMT_Encode4(130904),
     /* 130744 */   // Label 2671: @130744
     /* 130744 */   GIM_Try, /*On fail goto*//*Label 2675*/ GIMT_Encode4(130826), // Rule ID 3156 //
     /* 130749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130760 */     // (vecreduce_umin:{ *:[i32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VMINVu32:{ *:[i32] } (t2MOVi:{ *:[i32] } 4294967295:{ *:[i32] }), ?:{ *:[v4i32] }:$src)
     /* 130760 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130763 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130767 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130772 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(4294967295),
     /* 130782 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130785 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130791 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130797 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu32),
     /* 130802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130804 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130807 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130812 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130818 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130824 */     GIR_RootConstrainSelectedInstOperands,
     /* 130825 */     // GIR_Coverage, 3156,
     /* 130825 */     GIR_EraseRootFromParent_Done,
     /* 130826 */   // Label 2675: @130826
     /* 130826 */   GIM_Reject,
     /* 130827 */   // Label 2672: @130827
     /* 130827 */   GIM_Try, /*On fail goto*//*Label 2676*/ GIMT_Encode4(130903), // Rule ID 3155 //
     /* 130832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130843 */     // (vecreduce_umin:{ *:[i32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VMINVu16:{ *:[i32] } (t2MOVi16:{ *:[i32] } 65535:{ *:[i32] }), ?:{ *:[v8i16] }:$src)
     /* 130843 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130846 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi16),
     /* 130850 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130855 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(65535),
     /* 130865 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130868 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130874 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu16),
     /* 130879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130881 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130884 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130889 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130895 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130901 */     GIR_RootConstrainSelectedInstOperands,
     /* 130902 */     // GIR_Coverage, 3155,
     /* 130902 */     GIR_EraseRootFromParent_Done,
     /* 130903 */   // Label 2676: @130903
     /* 130903 */   GIM_Reject,
     /* 130904 */   // Label 2673: @130904
     /* 130904 */   GIM_Try, /*On fail goto*//*Label 2677*/ GIMT_Encode4(130986), // Rule ID 3154 //
     /* 130909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130916 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130920 */     // (vecreduce_umin:{ *:[i32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VMINVu8:{ *:[i32] } (t2MOVi:{ *:[i32] } 255:{ *:[i32] }), ?:{ *:[v16i8] }:$src)
     /* 130920 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130923 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130927 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130932 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(255),
     /* 130942 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130945 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130951 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130957 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu8),
     /* 130962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130964 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130967 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130972 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130978 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130984 */     GIR_RootConstrainSelectedInstOperands,
     /* 130985 */     // GIR_Coverage, 3154,
     /* 130985 */     GIR_EraseRootFromParent_Done,
     /* 130986 */   // Label 2677: @130986
     /* 130986 */   GIM_Reject,
     /* 130987 */   // Label 2674: @130987
     /* 130987 */   GIM_Reject,
     /* 130988 */ // Label 2670: @130988
     /* 130988 */ GIM_Reject,
     /* 130989 */ // Label 79: @130989
     /* 130989 */ GIM_Reject,
     /* 130990 */ }; // Size: 130990 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const ARMSubtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const ARMSubtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
